# areas-monthly

    Post /api/areas-monthly

## Description
return per month product sales depending on parameters/filters passed

## Request Headers
- **X-Auth-Token** — Authorization Token

## Return format
Status whether records are created successfully

## Example
**Request**

    /api/areas-monthly
    
**Json Body With product_id, user_id, region, date**
```javascript
   {
   "user_id":1
   }
```

**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Areas Per Month",
    "data": [
        {
            "start_date": "2018-01-01",
            "areas": [
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-02",
            "areas": [
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-03",
            "areas": [
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-04",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-05",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-06",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-07",
            "areas": [],
            "job_id": ""
        },
        {
            "start_date": "2018-01-08",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-09",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-10",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-11",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-12",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-13",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-14",
            "areas": [
                1,
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-15",
            "areas": [
                1,
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-16",
            "areas": [
                1,
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-17",
            "areas": [
                1,
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-18",
            "areas": [
                1,
                2
            ],
            "job_id": 3
        },
        {
            "start_date": "2018-01-19",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-20",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-21",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-22",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-23",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-24",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-25",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-26",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-27",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-28",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-29",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-30",
            "areas": [],
            "job_id": 0
        },
        {
            "start_date": "2018-01-31",
            "areas": [],
            "job_id": 0
        }
    ]
}```
 
