# Book or Update Order

    PUT /api/book-update-return-order/{orderId?}

## Description
Returns order object eager loading with products and quantities after storing/updating given order information 

## Request Headers
- **X-Auth-Token** — Authorization Token

## Parameter
- **OrderId** — Order Id is only required when a particular order needs to be updated

## Return format
A collection JSON object containing keys **Order** , **Products**

- **Order**  — Order object
- **Products**   —  Products and their corresponding quantities in order.


## Example
**Request**

    /api/book-update-return-order
**Json Body With Customer Object**
```javascript


```

**Json Body**
```javascript
{
	"date_to_deliver": "2018-03-02",
	"delivery_time": "00:00",
	"discount": 2.0,
	"id": 0,
	"is_discounted": false,
	"is_discounted2": false,
	"job_id": 0,
	"latitude": 31.5144558,
	"longitude": 74.3375359,
	"payment": 7585.2,
	"price": 7740.0,
	"products": [{
			"product_actual_price": 2340.0,
			"product_discounted_price": 0.0,
			"scheme_free_quantity": 2,
			"product_id": 2,
			"quantity": 12,
			"product_category": []
		}, {
			"product_actual_price": 5400.0,
			"product_discounted_price": 0.0,
			"scheme_free_quantity": 0,
			"product_id": 12,
			"quantity": 12,
			"product_category": [{
					"agency_id": 0,
					"category": "",
					"created_at": "2018-03-01 11:09:35",
					"created_by": 0,
					"deleted_by": 0,
					"discount_id": 0,
					"distributor_price": 0.0,
					"id": 83,
					"is_scheme": 0,
					"minimum_order_unit": 0,
					"minimum_rs_quantity": 0,
					"minimum_ws_quantity": 0,
					"name": "Whitening Massage Cream Booster",
					"pivot": {
						"product_actual_price": 0.0,
						"product_discounted_price": 0.0,
						"scheme_free_quantity": 0,
						"order_id": 0,
						"product_id": 0,
						"quantity": 12
					},
					"product_id": 0,
					"quantity": 12,
					"retail_price": 0.0,
					"scheme_free_quantity": 0,
					"scheme_quantity": 0,
					"stock_available": 0,
					"product_category_id": 1,
					"type": "",
					"updated_at": "2018-03-01 11:09:35",
					"updated_by": 0,
					"wholesale_price": 0.0
				}
			]
		}
	],
	"remarks": "",
	"remove_images": [],
	"shop_id": 4,
	"shop_uuid": "58be9875-7ab7-45e7-a773-ef4188be6a2f",
	"status": "Returned",
	"type": "Query",
	"uuid": "c4ea4222-3bb7-4bcc-a98d-07641b449170",
	"visit_date": "2018-03-01"
}


```

**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Return Order Created",
    "data": {
        "id": 122,
        "uuid": "c4ea4222-3bb7-4bcc-a98d-07641b449170",
        "invoice_no": null,
        "agency_id": 1,
        "shop_id": 4,
        "booked_by": 13,
        "country_id": 2,
        "price": 7740,
        "discount": 2,
        "payment": 7585.2,
        "balance": 7585.2,
        "type": "Return",
        "status": "Booked",
        "date_to_deliver": "2018-03-02",
        "delivery_time": "00:00",
        "remarks": "",
        "is_discounted": 0,
        "latitude": 31.5144558,
        "longitude": 74.3375359,
        "created_by": 13,
        "updated_by": null,
        "created_at": "2018-05-03 06:42:20",
        "updated_at": "2018-05-03 06:42:20",
        "deleted_at": null,
        "products": [
            {
                "id": 2,
                "category_id": 1,
                "agency_id": 1,
                "name": "Biocos Beauti Cream Small",
                "type": "Cream",
                "product_code": "1014",
                "retail_price": 0,
                "wholesale_price": 0,
                "distributor_price": 0,
                "stock_available": 0,
                "started_on": null,
                "discontinued_on": null,
                "description": null,
                "minimum_order_unit": 0,
                "minimum_ws_quantity": 0,
                "minimum_rs_quantity": 0,
                "is_scheme": 1,
                "scheme_quantity": "6",
                "scheme_free_quantity": 1,
                "created_by": 0,
                "updated_by": 0,
                "deleted_by": 0,
                "created_at": null,
                "updated_at": null,
                "deleted_at": null,
                "product_category": [],
                "pivot": {
                    "order_id": 122,
                    "product_id": 2,
                    "id": 245,
                    "quantity": 12,
                    "product_actual_price": 2340,
                    "product_discounted_price": 0,
                    "scheme_free_quantity": 0
                },
                "images": [
                    {
                        "id": 13,
                        "product_id": 2,
                        "image_url": "http://adminpanel.biocospk.com/uploads/products/image-1522153598111.JPG",
                        "created_at": "2018-03-27 16:26:38",
                        "updated_at": "2018-03-27 16:26:38"
                    }
                ]
            },
            {
                "id": 12,
                "category_id": 1,
                "agency_id": 1,
                "name": "Facial Booster",
                "type": "Cream",
                "product_code": "000",
                "retail_price": 0,
                "wholesale_price": 0,
                "distributor_price": 0,
                "stock_available": 0,
                "started_on": null,
                "discontinued_on": null,
                "description": null,
                "minimum_order_unit": 0,
                "minimum_ws_quantity": 0,
                "minimum_rs_quantity": 0,
                "is_scheme": 0,
                "scheme_quantity": null,
                "scheme_free_quantity": null,
                "created_by": 0,
                "updated_by": 0,
                "deleted_by": 0,
                "created_at": null,
                "updated_at": "2018-04-17 13:49:54",
                "deleted_at": null,
                "product_category": [
                    {
                        "id": 26,
                        "order_product_id": 246,
                        "product_category_id": 1,
                        "quantity": 12,
                        "created_at": "2018-05-03 06:42:20",
                        "updated_at": "2018-05-03 06:42:20"
                    }
                ],
                "pivot": {
                    "order_id": 122,
                    "product_id": 12,
                    "id": 246,
                    "quantity": 12,
                    "product_actual_price": 5400,
                    "product_discounted_price": 0,
                    "scheme_free_quantity": 0
                },
                "images": [
                    {
                        "id": 12,
                        "product_id": 12,
                        "image_url": "http://adminpanel.biocospk.com/uploads/products/image-1519220708174.jpg",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            }
        ],
        "job_id": 0,
        "is_discounted_2": false,
        "images": [],
        "customer": null
    }
}
```
 
