# Log no order

    POST /api/customer-tenure-ledger

## Description
Returns data of customer Tenure Ledger

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — Customer Tenure Ledger


## Example
**Request**

    /api/customer-tenure-ledger

**Json Body**
```javascript
{"shop_id":19,"date_to_deliver_start":"2018-03-10","date_to_deliver_end":"2018-04-22"}
```


**Return** __shortened for example purpose__
``` json
[
    {
        "date": "2018-03-10",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-11",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-12",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-13",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-14",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-15",
        "sale": 0,
        "recovery": 13200,
        "balance": -13200
    },
    {
        "date": "2018-03-16",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-17",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-18",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-19",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-20",
        "sale": 3500,
        "recovery": 0,
        "balance": -11740.33
    },
    {
        "date": "2018-03-21",
        "sale": 7920,
        "recovery": 0,
        "balance": -3820
    },
    {
        "date": "2018-03-22",
        "sale": 2750,
        "recovery": 0,
        "balance": -1070
    },
    {
        "date": "2018-03-23",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-24",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-25",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-26",
        "sale": 6964,
        "recovery": 0,
        "balance": 5894
    },
    {
        "date": "2018-03-27",
        "sale": 73927,
        "recovery": 0,
        "balance": 77421
    },
    {
        "date": "2018-03-28",
        "sale": 8904,
        "recovery": 0,
        "balance": 88725
    },
    {
        "date": "2018-03-29",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-30",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-03-31",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-01",
        "sale": 2640,
        "recovery": 0,
        "balance": 94005
    },
    {
        "date": "2018-04-02",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-03",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-04",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-05",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-06",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-07",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-08",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-09",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-10",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-11",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-12",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-13",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-14",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-15",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-16",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-17",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-18",
        "sale": 0,
        "recovery": 11000,
        "balance": 72005
    },
    {
        "date": "2018-04-19",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-20",
        "sale": 0,
        "recovery": 11000,
        "balance": 83005
    },
    {
        "date": "2018-04-21",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    },
    {
        "date": "2018-04-22",
        "sale": 0,
        "recovery": 0,
        "balance": 0
    }
]