# Log no order

    POST /api/customer-outstanding-balance

## Description
Returns data of customer Outstanding Balance

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — Customer Outstanding Balance


## Example
**Request**

    /api/customer-outstanding-balance

**Json Body**
```javascript
{"so_id":13}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Customer Balances",
    "data": [
        {
            "id": 13,
            "firstname": "Malik",
            "lastname": "Shamas",
            "image": "http://adminpanel.biocospk.com/uploads/users/image-1523264378124.jpg",
            "so_customers": [
                {
                    "id": 3,
                    "balance": -6719,
                    "sale_officer_id": 13,
                    "name": "Zohra Gen. Trading "
                },
                {
                    "id": 8,
                    "balance": -4326,
                    "sale_officer_id": 13,
                    "name": "Usloob Furnishers"
                },
                {
                    "id": 18,
                    "balance": -18503,
                    "sale_officer_id": 13,
                    "name": "Rawaa Aljamal Cosmetics "
                },
                {
                    "id": 19,
                    "balance": -104581,
                    "sale_officer_id": 13,
                    "name": "Al Mushtarie Exim Trading "
                },
                {
                    "id": 27,
                    "balance": -2142,
                    "sale_officer_id": 13,
                    "name": "Pure Land"
                },
                {
                    "id": 28,
                    "balance": -1230,
                    "sale_officer_id": 13,
                    "name": "Taj Allail"
                },
                {
                    "id": 29,
                    "balance": -2344,
                    "sale_officer_id": 13,
                    "name": "African Beauty Palace"
                },
                {
                    "id": 30,
                    "balance": -678,
                    "sale_officer_id": 13,
                    "name": "Green Tower"
                },
                {
                    "id": 31,
                    "balance": -2280,
                    "sale_officer_id": 13,
                    "name": "Muhammad Tayyub Trading"
                },
                {
                    "id": 69,
                    "balance": -1670,
                    "sale_officer_id": 13,
                    "name": "Mr Qasir Reaturant Wala"
                },
                {
                    "id": 68,
                    "balance": -3246,
                    "sale_officer_id": 13,
                    "name": "Mr Len Online Seller"
                },
                {
                    "id": 67,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Singapur House Trading L.L.C"
                },
                {
                    "id": 66,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Bilal Hussain General Trading L.L.C"
                },
                {
                    "id": 65,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "King Natural Beauty International Trade"
                },
                {
                    "id": 64,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Beautymax LLC"
                },
                {
                    "id": 63,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "El Brus General Trading"
                },
                {
                    "id": 52,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Masat AL BAHAR"
                },
                {
                    "id": 53,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Zahrat Deira"
                },
                {
                    "id": 54,
                    "balance": -660,
                    "sale_officer_id": 13,
                    "name": "Lamsat Hanyan "
                },
                {
                    "id": 62,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Najafi Trading LLC"
                },
                {
                    "id": 61,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Saloon Link Sri Lanka "
                },
                {
                    "id": 57,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Miradil Cosmetics LLC"
                },
                {
                    "id": 58,
                    "balance": -860,
                    "sale_officer_id": 13,
                    "name": "Jenny ONLINE "
                },
                {
                    "id": 59,
                    "balance": 0,
                    "sale_officer_id": 13,
                    "name": "Megan Online "
                },
                {
                    "id": 60,
                    "balance": -6358,
                    "sale_officer_id": 13,
                    "name": "Al Ajwad "
                }
            ]
        }
    ]
}