# Log no order

    POST /api/customer-tenure-recovery

## Description
Returns data of customer Tenure Recovery

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — Customer Tenure Recovery


## Example
**Request**

    /api/customer-tenure-recovery

**Json Body**
```javascript
{"shop_id":19,"date_to_deliver_start":"2018-03-10","date_to_deliver_end":"2018-03-22"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Customer Tenure Recovery",
    "data": [
        {
            "date": "2018-03-10",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-11",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-12",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-13",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-14",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-15",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-16",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-17",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-18",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": [
                    {
                        "id": 71,
                        "uuid": "cb7208d9-fcd5-4bc9-9383-3f5c7c34d761",
                        "order_id": 56,
                        "agency_id": 1,
                        "bank_id": 0,
                        "shop_id": 19,
                        "user_id": 13,
                        "payment_type": "Cash",
                        "amount": 11000,
                        "balance": -72005,
                        "remarks": null,
                        "promise_cheque_date": "2018-03-18",
                        "cheque_type": "Bearer Cheque",
                        "cheque_no": "12345",
                        "latitude": null,
                        "longitude": null,
                        "created_by": null,
                        "updated_by": null,
                        "deleted_by": null,
                        "created_at": "2018-04-02 00:00:00",
                        "updated_at": "2018-04-02 21:47:45",
                        "deleted_at": null
                    }
                ]
            }
        },
        {
            "date": "2018-03-19",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-20",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-21",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        },
        {
            "date": "2018-03-22",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "payments": []
            }
        }
    ]
}