# filter order

    Post /api/filter-order

## Description
return per month product sales depending on parameters/filters passed

## Request Headers
- **X-Auth-Token** — Authorization Token

## Return format
Filter all order using parram region_id or customer_id,start_date,end_date

## Example
**Request**

    /api/filter-order
    
**Json Body With customer_id or region_id, start_date, end_date**

**if customer_id in parram**
```javascript
  {
      "shop_id":2,
      "area_id":1,
      "start_date":"2017-08-29",
      "end_date":"2018-03-24"
    }
```
**if region_id in parram**
```javascript
  {
  	"customer_id":0,
  	"region_id":2,
  	"start_date":"2017-08-29",
  	"end_date":"2018-03-24"
  }
```

**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Order found",
    "data": [
        {
            "id": 12,
            "uuid": "b944d3e4-a2de-4eab-9c4a-faa2cb74c932",
            "agency_id": null,
            "customer_id": 12,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-01 00:00:00",
            "booked_by": 1,
            "price": 7000000,
            "discount": 0,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "xgh",
            "latitude": 31.5143625,
            "longitude": 74.3375427,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-08-31 08:31:31",
            "updated_at": "2017-08-31 08:31:31",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 12,
                        "product_id": 1,
                        "quantity": 50000
                    },
                    "images": []
                }
            ],
            "customer_name": "usama tuk",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503925337dK2i.jpeg"
        },
        {
            "id": 13,
            "uuid": "f1e29caa-88c1-4550-a719-febb3b8847be",
            "agency_id": null,
            "customer_id": 12,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-01 00:00:00",
            "booked_by": 1,
            "price": 7000,
            "discount": 0,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "Abc",
            "latitude": 31.5143718,
            "longitude": 74.3375239,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-08-31 09:12:01",
            "updated_at": "2017-08-31 09:12:01",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 13,
                        "product_id": 1,
                        "quantity": 50
                    },
                    "images": []
                }
            ],
            "customer_name": "usama tuk",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503925337dK2i.jpeg"
        },
        {
            "id": 14,
            "uuid": "f1b348cc-39b8-4a13-9453-63eabc334707",
            "agency_id": null,
            "customer_id": 12,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-01 00:00:00",
            "booked_by": 1,
            "price": 3500,
            "discount": 0,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "Abc",
            "latitude": 31.5143743,
            "longitude": 74.3375201,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-08-31 09:14:54",
            "updated_at": "2017-08-31 09:14:54",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 14,
                        "product_id": 1,
                        "quantity": 25
                    },
                    "images": []
                }
            ],
            "customer_name": "usama tuk",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503925337dK2i.jpeg"
        },
        {
            "id": 15,
            "uuid": "30e4d60f-da31-4766-9c6e-f6ec29d87d32",
            "agency_id": null,
            "customer_id": 6,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-01 00:00:00",
            "booked_by": 1,
            "price": 6860,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 31.5143743,
            "longitude": 74.3375201,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-08-31 10:33:42",
            "updated_at": "2017-08-31 10:33:42",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 15,
                        "product_id": 1,
                        "quantity": 50
                    },
                    "images": []
                }
            ],
            "customer_name": "Akram",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503918983sGQ2.jpeg"
        },
        {
            "id": 16,
            "uuid": "eb05b74c-2663-49fb-8402-f5a279fe299a",
            "agency_id": null,
            "customer_id": 12,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-01 00:00:00",
            "booked_by": 1,
            "price": 3430,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "17:00:00",
            "remarks": "Abc",
            "latitude": 31.4936125,
            "longitude": 74.3502859,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-08-31 14:40:26",
            "updated_at": "2017-08-31 14:40:26",
            "deleted_at": null,
            "images": [
                {
                    "id": 11,
                    "image": "http://api.biocospk.com/uploads/order/orderimage-1504190426xopE.jpeg",
                    "order_id": 16
                }
            ],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 16,
                        "product_id": 1,
                        "quantity": 25
                    },
                    "images": []
                }
            ],
            "customer_name": "usama tuk",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503925337dK2i.jpeg"
        },
        {
            "id": 17,
            "uuid": "4004a140-f680-4cd5-aae6-0e4bf4834476",
            "agency_id": null,
            "customer_id": 4,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-05 00:00:00",
            "booked_by": 1,
            "price": 3430,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "18:20:00",
            "remarks": "",
            "latitude": 31.4943977,
            "longitude": 74.3529512,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-04 12:18:01",
            "updated_at": "2017-09-04 12:18:01",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 17,
                        "product_id": 1,
                        "quantity": 25
                    },
                    "images": []
                }
            ],
            "customer_name": "Rehan",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503918983rPQ4.jpeg"
        },
        {
            "id": 20,
            "uuid": "246d84ae-5254-41fb-b0ef-6d4261928545",
            "agency_id": null,
            "customer_id": 12,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-07 00:00:00",
            "booked_by": 1,
            "price": 3430,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 31.5143743,
            "longitude": 74.3375202,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-06 15:25:36",
            "updated_at": "2017-09-06 15:25:36",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 20,
                        "product_id": 1,
                        "quantity": 25
                    },
                    "images": []
                }
            ],
            "customer_name": "usama tuk",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503925337dK2i.jpeg"
        },
        {
            "id": 21,
            "uuid": "570cf106-6b26-4286-b6e8-e1390a7f96c6",
            "agency_id": null,
            "customer_id": 4,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-08 00:00:00",
            "booked_by": 1,
            "price": 6860,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 31.5143743,
            "longitude": 74.3375202,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-07 09:49:20",
            "updated_at": "2017-09-07 09:49:20",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 21,
                        "product_id": 1,
                        "quantity": 50
                    },
                    "images": []
                }
            ],
            "customer_name": "Rehan",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503918983rPQ4.jpeg"
        },
        {
            "id": 24,
            "uuid": "d719f5d6-273f-4e04-adc9-fb407dbccaa6",
            "agency_id": null,
            "customer_id": 17,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-10 00:00:00",
            "booked_by": 1,
            "price": 686,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "18:00:00",
            "remarks": "",
            "latitude": 31.5277466,
            "longitude": 74.3192115,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-09 12:56:38",
            "updated_at": "2017-09-09 12:56:38",
            "deleted_at": null,
            "images": [
                {
                    "id": 12,
                    "image": "http://api.biocospk.com/uploads/order/orderimage-1504961798UfGI.jpeg",
                    "order_id": 24
                }
            ],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 24,
                        "product_id": 1,
                        "quantity": 5
                    },
                    "images": []
                }
            ],
            "customer_name": "friendz karyana store",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1503993069mamb.jpeg"
        },
        {
            "id": 25,
            "uuid": "644293a0-b1e6-48a4-85c6-7b12fb253042",
            "agency_id": null,
            "customer_id": 27,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-11 00:00:00",
            "booked_by": 1,
            "price": 3267630080,
            "discount": 8,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 31.4934531,
            "longitude": 74.3501673,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-10 11:24:26",
            "updated_at": "2017-09-10 11:24:26",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 25,
                        "product_id": 1,
                        "quantity": 25369800
                    },
                    "images": []
                }
            ],
            "customer_name": "Hamza",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1504093674Jn89.jpeg"
        },
        {
            "id": 27,
            "uuid": "4bd663d8-ade2-4641-a7ee-495c41f22043",
            "agency_id": null,
            "customer_id": 37,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-14 00:00:00",
            "booked_by": 1,
            "price": 3395,
            "discount": 3,
            "payment": null,
            "type": "Order",
            "delivery_time": "16:30:00",
            "remarks": "Abc",
            "latitude": 32.1558862,
            "longitude": 74.2012402,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-13 17:46:50",
            "updated_at": "2017-09-13 17:46:50",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 27,
                        "product_id": 1,
                        "quantity": 25
                    },
                    "images": []
                }
            ],
            "customer_name": "Asad G S",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1504183600Q38C.jpeg"
        },
        {
            "id": 29,
            "uuid": "ceb21ec8-1d35-447b-9d84-51ed5cf403e9",
            "agency_id": null,
            "customer_id": 48,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-16 00:00:00",
            "booked_by": 1,
            "price": 4939.2,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 31.5143743,
            "longitude": 74.3375202,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-15 11:35:26",
            "updated_at": "2017-09-15 11:35:26",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 29,
                        "product_id": 1,
                        "quantity": 36
                    },
                    "images": []
                }
            ],
            "customer_name": "Kamran",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1504884407abaY.jpeg"
        },
        {
            "id": 30,
            "uuid": "9c065f4f-ee20-467b-b704-946d45c8a3db",
            "agency_id": null,
            "customer_id": 51,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-08-15 00:00:00",
            "booked_by": 1,
            "price": 25.2,
            "discount": 0,
            "payment": null,
            "type": "Query",
            "delivery_time": null,
            "remarks": "Remarks goes here",
            "latitude": null,
            "longitude": null,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-18 09:43:11",
            "updated_at": "2017-09-18 09:43:11",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 30,
                        "product_id": 1,
                        "quantity": 3
                    },
                    "images": []
                }
            ],
            "customer_name": "Wood works",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1504961687SiZ1.jpeg"
        },
        {
            "id": 33,
            "uuid": "35ddf4ba-1ffe-45a7-a107-af1e2ee83c55",
            "agency_id": null,
            "customer_id": 60,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-09-23 00:00:00",
            "booked_by": 1,
            "price": 3292.8,
            "discount": 2,
            "payment": null,
            "type": "Order",
            "delivery_time": "14:04:00",
            "remarks": "Abc",
            "latitude": 31.5143943,
            "longitude": 74.3374912,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-09-22 09:04:59",
            "updated_at": "2017-09-22 09:04:59",
            "deleted_at": null,
            "images": [
                {
                    "id": 15,
                    "image": "http://api.biocospk.com/uploads/order/orderimage-1506071099OjHV.jpeg",
                    "order_id": 33
                }
            ],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 33,
                        "product_id": 1,
                        "quantity": 24
                    },
                    "images": []
                }
            ],
            "customer_name": "Akeel",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1504970205M1BJ.jpeg"
        },
        {
            "id": 38,
            "uuid": "3c4d8834-16ed-4df2-92d8-0c9ff3841813",
            "agency_id": null,
            "customer_id": 77,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-10-20 00:00:00",
            "booked_by": 1,
            "price": 9777.6,
            "discount": 3,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "Abc",
            "latitude": 74.3375123,
            "longitude": 74.3375123,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-10-19 09:49:20",
            "updated_at": "2017-10-19 09:49:20",
            "deleted_at": null,
            "images": [
                {
                    "id": 17,
                    "image": "http://api.biocospk.com/uploads/order/orderimage-1508406560TGRP.jpeg",
                    "order_id": 38
                }
            ],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 38,
                        "product_id": 1,
                        "quantity": 72
                    },
                    "images": []
                }
            ],
            "customer_name": "Jameel",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-15049769197RxT.jpeg"
        },
        {
            "id": 39,
            "uuid": "c3030461-d79e-4fec-8101-ed0e6cc99350",
            "agency_id": null,
            "customer_id": 88,
            "status": "Booked",
            "visit_id": 0,
            "date_to_deliver": "2017-11-02 00:00:00",
            "booked_by": 1,
            "price": 6518.4,
            "discount": 3,
            "payment": null,
            "type": "Order",
            "delivery_time": "00:00:00",
            "remarks": "",
            "latitude": 74.337545,
            "longitude": 74.337545,
            "created_by": 1,
            "updated_by": 0,
            "deleted_by": 0,
            "created_at": "2017-11-01 10:22:54",
            "updated_at": "2017-11-01 10:22:54",
            "deleted_at": null,
            "images": [],
            "products": [
                {
                    "id": 1,
                    "name": "Cream",
                    "product_code": "DE-22",
                    "retail_price": 150,
                    "wholesale_price": 140,
                    "distributor_price": 180,
                    "pivot": {
                        "order_id": 39,
                        "product_id": 1,
                        "quantity": 48
                    },
                    "images": []
                }
            ],
            "customer_name": "Sohaib",
            "customer_image": "http://api.biocospk.com/uploads/customer/customerimage-1505106155Z1Oa.jpeg"
        }
    ]
}
```
 
