# Log no order

    POST /api/product-sales-detail-customer

## Description
Returns object of newly created job

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — Job object


## Example
**Request**

    /api/product-sales-detail-customer

**Return** __shortened for example purpose__
``` json
{"so_id":13,"start_date":"2018-07-01","end_date":"2018-07-20","product_id":3}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Orders Product Details found",
    "data": [
        {
            "id": 234,
            "shop_id": 27,
            "is_discounted_2": false,
            "customer": {
                "id": 27,
                "name": "Pure Land",
                "images": [
                    {
                        "id": 69,
                        "shop_id": 27,
                        "image_url": "http://adminpanel.biocospk.com/uploads/shops/image-1521048659127.jpg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 70,
                        "shop_id": 27,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1521045667Iqhv.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 87,
                        "shop_id": 27,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1521045667Iqhv.jpeg",
                        "type": "Other",
                        "created_at": "2018-03-14 21:30:59",
                        "updated_at": "2018-03-14 21:30:59"
                    }
                ]
            },
            "order_products": [
                {
                    "id": 449,
                    "order_id": 234,
                    "product_id": 3,
                    "quantity": 1200,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 2.5,
                    "product_discounted_price": 2.9166666666666665,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        },
        {
            "id": 235,
            "shop_id": 8,
            "is_discounted_2": false,
            "customer": {
                "id": 8,
                "name": "Usloob Furnishers",
                "images": [
                    {
                        "id": 23,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038HeOO.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 25,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038dgvL.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 24,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038EL5y.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": [
                {
                    "id": 452,
                    "order_id": 235,
                    "product_id": 3,
                    "quantity": 300,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 2.5,
                    "product_discounted_price": 3,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        },
        {
            "id": 236,
            "shop_id": 64,
            "is_discounted_2": false,
            "customer": {
                "id": 64,
                "name": "Beautymax LLC",
                "images": [
                    {
                        "id": 213,
                        "shop_id": 64,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1522787703FucQ.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 212,
                        "shop_id": 64,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1522787703J17O.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 211,
                        "shop_id": 64,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1522787696J48b.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": []
        },
        {
            "id": 243,
            "shop_id": 100,
            "is_discounted_2": false,
            "customer": {
                "id": 100,
                "name": "TM Beauty Saloon & Clinic ",
                "images": []
            },
            "order_products": [
                {
                    "id": 463,
                    "order_id": 243,
                    "product_id": 3,
                    "quantity": 12,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 2.5,
                    "product_discounted_price": 0,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        },
        {
            "id": 242,
            "shop_id": 100,
            "is_discounted_2": false,
            "customer": {
                "id": 100,
                "name": "TM Beauty Saloon & Clinic ",
                "images": []
            },
            "order_products": []
        },
        {
            "id": 241,
            "shop_id": 85,
            "is_discounted_2": false,
            "customer": {
                "id": 85,
                "name": "Madeena Al Hadaya ",
                "images": [
                    {
                        "id": 371,
                        "shop_id": 85,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1527426786RQyQ.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": [
                {
                    "id": 460,
                    "order_id": 241,
                    "product_id": 3,
                    "quantity": 36,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 2.5,
                    "product_discounted_price": 3.3333333333333335,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        },
        {
            "id": 240,
            "shop_id": 28,
            "is_discounted_2": false,
            "customer": {
                "id": 28,
                "name": "Taj Allail",
                "images": [
                    {
                        "id": 71,
                        "shop_id": 28,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1521046417euLX.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 72,
                        "shop_id": 28,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15210463736tw5.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 73,
                        "shop_id": 28,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1521046375g6Dh.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 74,
                        "shop_id": 28,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1521046417euLX.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": []
        },
        {
            "id": 239,
            "shop_id": 18,
            "is_discounted_2": false,
            "customer": {
                "id": 18,
                "name": "Rawaa Aljamal Cosmetics ",
                "images": [
                    {
                        "id": 41,
                        "shop_id": 18,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520439638Je4V.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 39,
                        "shop_id": 18,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15204396381IVT.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 40,
                        "shop_id": 18,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15204396389aGb.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": []
        },
        {
            "id": 238,
            "shop_id": 8,
            "is_discounted_2": false,
            "customer": {
                "id": 8,
                "name": "Usloob Furnishers",
                "images": [
                    {
                        "id": 23,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038HeOO.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 25,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038dgvL.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 24,
                        "shop_id": 8,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038EL5y.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": [
                {
                    "id": 454,
                    "order_id": 238,
                    "product_id": 3,
                    "quantity": 288,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 2.5,
                    "product_discounted_price": 3,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        },
        {
            "id": 245,
            "shop_id": 3,
            "is_discounted_2": false,
            "customer": {
                "id": 3,
                "name": "Zohra Gen. Trading ",
                "images": [
                    {
                        "id": 5,
                        "shop_id": 3,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 6,
                        "shop_id": 3,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 7,
                        "shop_id": 3,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                        "type": "Other",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            "order_products": [
                {
                    "id": 470,
                    "order_id": 245,
                    "product_id": 3,
                    "quantity": 15,
                    "scheme_free_quantity": 0,
                    "product_actual_price": 55,
                    "product_discounted_price": null,
                    "product_name": "Biocos Whitening Serum"
                }
            ]
        }
    ]
}
```