# Log customers newly added

    POST /api/so-customers-added

## Description
Returns data of Customers Added this month

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So Customers Added this month


## Example
**Request**

    /api/so-customers-added

**Json Body**
```javascript
{"so_id":13,"date":"2018-06"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "So Customers Newly Added",
    "data": {
        "id": 13,
        "firstname": "Malik",
        "lastname": "Shamas",
        "image": "http://adminpanel.biocospk.com/uploads/users/image-1523264378124.jpg",
        "date": "2018-06",
        "so_customers": [
            {
                "id": 87,
                "parent_id": null,
                "agency_id": 1,
                "sale_officer_id": 13,
                "area_id": 4,
                "target_visit_id": 4,
                "currency_id": 2,
                "uuid": "e290d82c-b8da-4e34-b5d2-0f65f5cd508e",
                "proprietor_id": 14,
                "contact_person_id": 14,
                "name": "Mrs Joy Philipina ",
                "email": "",
                "opening_balance": 0,
                "balance": 0,
                "location": "Al Rigga Deira but Business in Philippines",
                "latitude": 25.2747907,
                "longitude": 55.3060836,
                "phone_1": "+971506904575",
                "phone_2": "",
                "display_remarks": null,
                "discount_percentage": "0",
                "biocos_ratting": 3,
                "status": "Rejected",
                "customer_type": "Wholesaler",
                "shop_type": "",
                "Category": "C",
                "created_by": 13,
                "updated_by": null,
                "deleted_by": null,
                "created_at": "2018-06-01 15:35:18",
                "updated_at": "2018-06-01 19:49:49",
                "deleted_at": null
            },
            {
                "id": 88,
                "parent_id": null,
                "agency_id": 1,
                "sale_officer_id": 13,
                "area_id": 4,
                "target_visit_id": 4,
                "currency_id": 2,
                "uuid": "32f31181-0ef1-400a-8720-2cbbda31238e",
                "proprietor_id": 14,
                "contact_person_id": 14,
                "name": "Mr Ghulam Abbas ",
                "email": "",
                "opening_balance": 0,
                "balance": 0,
                "location": "Al Sabkha Bus Station Dubai ",
                "latitude": 25.2767159,
                "longitude": 55.3069495,
                "phone_1": "00971564703470",
                "phone_2": "",
                "display_remarks": null,
                "discount_percentage": "0",
                "biocos_ratting": 5,
                "status": "Rejected",
                "customer_type": "Wholesaler",
                "shop_type": "",
                "Category": "A+",
                "created_by": 13,
                "updated_by": null,
                "deleted_by": null,
                "created_at": "2018-06-02 19:31:59",
                "updated_at": "2018-06-02 19:37:59",
                "deleted_at": null
            }
        ]
    }
}