# Log no order

    POST /api/so-ordered-customers

## Description
Returns data of customers which ordered

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So customers which ordered


## Example
**Request**

    /api/so-ordered-customers

**Json Body**
```javascript
{"so_id":13,"date":"2018-06"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "So Ordered Customers",
    "data": [
        {
            "id": 3,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Zohra Gen. Trading ",
            "email": "",
            "opening_balance": -5279,
            "balance": -9914,
            "location": "Al dagaya ",
            "latitude": 25.2728956,
            "longitude": 55.2995986,
            "phone_1": "+971566944977",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 4,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "B",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-01 17:44:43",
            "updated_at": "2018-06-06 20:04:20",
            "deleted_at": null,
            "images": [
                {
                    "id": 5,
                    "shop_id": 3,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 6,
                    "shop_id": 3,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 7,
                    "shop_id": 3,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 8,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "89425bfa-4bd6-4472-ada2-f679e5b9b545",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Usloob Furnishers",
            "email": "",
            "opening_balance": -2274,
            "balance": -3485,
            "location": "Gold Souq ",
            "latitude": 25.2718733,
            "longitude": 55.2993414,
            "phone_1": "00971551723889",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-05 18:37:18",
            "updated_at": "2018-06-02 09:41:37",
            "deleted_at": null,
            "images": [
                {
                    "id": 23,
                    "shop_id": 8,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038HeOO.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 25,
                    "shop_id": 8,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038dgvL.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 24,
                    "shop_id": 8,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520275038EL5y.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 18,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "29d52e62-d618-4348-97f7-f37d2abb7a85",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Rawaa Aljamal Cosmetics ",
            "email": "",
            "opening_balance": 0,
            "balance": -22536,
            "location": "Al dagaya area ",
            "latitude": 25.2720906,
            "longitude": 55.2998617,
            "phone_1": "00971501534623",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-07 16:20:38",
            "updated_at": "2018-06-02 09:42:23",
            "deleted_at": null,
            "images": [
                {
                    "id": 41,
                    "shop_id": 18,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520439638Je4V.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 39,
                    "shop_id": 18,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15204396381IVT.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 40,
                    "shop_id": 18,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15204396389aGb.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 19,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "bb37d2bf-98eb-43b9-80a7-eb305e31f970",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Al Mushtarie Exim Trading ",
            "email": "",
            "opening_balance": 0,
            "balance": -117830,
            "location": "Gold Souq",
            "latitude": 25.2717632,
            "longitude": 55.2993602,
            "phone_1": "00971505544056",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-13 15:24:38",
            "updated_at": "2018-06-05 18:38:51",
            "deleted_at": null,
            "images": [
                {
                    "id": 42,
                    "shop_id": 19,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 43,
                    "shop_id": 19,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 44,
                    "shop_id": 19,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 27,
            "parent_id": 1,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "afe7a10a-ae34-40bb-acec-7f0b748ed75b",
            "proprietor_id": 16,
            "contact_person_id": 16,
            "name": "Pure Land",
            "email": "sales@pureland.ae",
            "opening_balance": -2142,
            "balance": -42592,
            "location": "alsouq street, next to country hotel, shop no.4",
            "latitude": 31.4917163,
            "longitude": 74.3631985,
            "phone_1": "971555050160",
            "phone_2": "9714-2265900",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": null,
            "Category": "A+",
            "created_by": 13,
            "updated_by": 1,
            "deleted_by": null,
            "created_at": "2018-03-14 16:40:12",
            "updated_at": "2018-06-03 17:45:02",
            "deleted_at": null,
            "images": [
                {
                    "id": 69,
                    "shop_id": 27,
                    "image_url": "http://adminpanel.biocospk.com/uploads/shops/image-1521048659127.jpg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 70,
                    "shop_id": 27,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521045667Iqhv.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 87,
                    "shop_id": 27,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521045667Iqhv.jpeg",
                    "type": "Other",
                    "created_at": "2018-03-14 21:30:59",
                    "updated_at": "2018-03-14 21:30:59"
                }
            ]
        },
        {
            "id": 28,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "598290e6-00fe-4026-9846-168673988521",
            "proprietor_id": 17,
            "contact_person_id": 17,
            "name": "Taj Allail",
            "email": "tajallail2017@gmail.com",
            "opening_balance": -1230,
            "balance": -660,
            "location": "Deira, Dubai, UAE",
            "latitude": 31.4916558,
            "longitude": 74.3632944,
            "phone_1": "971503298508",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-14 16:52:27",
            "updated_at": "2018-06-07 22:01:14",
            "deleted_at": null,
            "images": [
                {
                    "id": 71,
                    "shop_id": 28,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521046417euLX.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 72,
                    "shop_id": 28,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15210463736tw5.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 73,
                    "shop_id": 28,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521046375g6Dh.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 74,
                    "shop_id": 28,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521046417euLX.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 80,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "8c37f9f6-621f-4755-b514-ee011345ba7c",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Mrs PU China ",
            "email": "",
            "opening_balance": 0,
            "balance": 0,
            "location": "China & Taiwan ",
            "latitude": 25.2766976,
            "longitude": 55.3069755,
            "phone_1": "0086 13587414219",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 4,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "B",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-05-17 19:38:42",
            "updated_at": "2018-06-04 14:09:07",
            "deleted_at": null,
            "images": [
                {
                    "id": 280,
                    "shop_id": 80,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1526585933ycyC.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 281,
                    "shop_id": 80,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15265859341rzK.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 282,
                    "shop_id": 80,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15265859362ltJ.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 81,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "2a562705-2234-4d28-80d8-ad40af492bb1",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Akad Cosmetics ",
            "email": "",
            "opening_balance": 0,
            "balance": -2510,
            "location": "Gold Souq Area ",
            "latitude": 25.2718006,
            "longitude": 55.2993109,
            "phone_1": "00971509543214",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 4,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "B",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-05-23 18:47:36",
            "updated_at": "2018-06-02 09:43:35",
            "deleted_at": null,
            "images": [
                {
                    "id": 283,
                    "shop_id": 81,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15271012619iH9.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 284,
                    "shop_id": 81,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1527101261Z2YF.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 285,
                    "shop_id": 81,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1527101263J94B.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 87,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "e290d82c-b8da-4e34-b5d2-0f65f5cd508e",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Mrs Joy Philipina ",
            "email": "",
            "opening_balance": 0,
            "balance": 0,
            "location": "Al Rigga Deira but Business in Philippines",
            "latitude": 25.2747907,
            "longitude": 55.3060836,
            "phone_1": "+971506904575",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 3,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "C",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-06-01 15:35:18",
            "updated_at": "2018-06-01 19:49:49",
            "deleted_at": null,
            "images": [
                {
                    "id": 373,
                    "shop_id": 87,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1527867328OSuU.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        },
        {
            "id": 88,
            "parent_id": null,
            "agency_id": 1,
            "sale_officer_id": 13,
            "area_id": 4,
            "target_visit_id": 4,
            "currency_id": 2,
            "uuid": "32f31181-0ef1-400a-8720-2cbbda31238e",
            "proprietor_id": 14,
            "contact_person_id": 14,
            "name": "Mr Ghulam Abbas ",
            "email": "",
            "opening_balance": 0,
            "balance": 0,
            "location": "Al Sabkha Bus Station Dubai ",
            "latitude": 25.2767159,
            "longitude": 55.3069495,
            "phone_1": "00971564703470",
            "phone_2": "",
            "landline": null,
            "display_remarks": null,
            "discount_percentage": "0",
            "biocos_ratting": 5,
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": 13,
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-06-02 19:31:59",
            "updated_at": "2018-06-02 19:37:59",
            "deleted_at": null,
            "images": [
                {
                    "id": 374,
                    "shop_id": 88,
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1527967928Nrnj.jpeg",
                    "type": "Other",
                    "created_at": null,
                    "updated_at": null
                }
            ]
        }
    ]
}