# Log no order

    POST /api/so-orders-products

## Description
Returns data of so, total products

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So orders products


## Example
**Request**

    /api/so-orders-products

**Json Body**
```javascript
{"so_id":13,"date_to_deliver_start":"2018-04-11","date_to_deliver_end":"2018-04-15"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "SO Products Total",
    "data": [
        {
            "id": 1,
            "name": "Biocos Beauty Cream",
            "stock": 7813,
            "quantity": 720,
            "pre_quantity": 0
        },
        {
            "id": 2,
            "name": "Biocos Beauti Cream Small",
            "stock": 23854,
            "quantity": 6624,
            "pre_quantity": 0
        },
        {
            "id": 3,
            "name": "Biocos Whitening Serum",
            "stock": 26745,
            "quantity": 576,
            "pre_quantity": 1200
        },
        {
            "id": 4,
            "name": "Biocos Formula Pack",
            "stock": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 5,
            "name": "Biocos Hair Regrowth Magic Serum",
            "stock": 1507,
            "quantity": 48,
            "pre_quantity": 0
        },
        {
            "id": 6,
            "name": "Biocos Pimple Clear Magic Serum",
            "stock": 1166,
            "quantity": 48,
            "pre_quantity": 0
        },
        {
            "id": 7,
            "name": "Biocos Age Reversal Magic Serum",
            "stock": 1373,
            "quantity": 48,
            "pre_quantity": 0
        },
        {
            "id": 8,
            "name": "Biocos Whitening Serum Parlor Pack",
            "stock": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 9,
            "name": "Biocos Large Beauty Soap",
            "stock": 2145,
            "quantity": 432,
            "pre_quantity": 0
        },
        {
            "id": 10,
            "name": "Biocos Small Beauti Soap 90 grm",
            "stock": 1657,
            "quantity": 420,
            "pre_quantity": 0
        },
        {
            "id": 11,
            "name": "Biocos Neem Soap 90 grm",
            "stock": 18,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 12,
            "name": "Facial Booster",
            "stock": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 13,
            "name": "Men Whitening Serum",
            "stock": 24,
            "quantity": 0,
            "pre_quantity": 0
        }
    ]
}