# Get SO Orders

    GET /api/so_orders/{ID}

## Description
Returns object of order depending upon the ID of order passed as parameters

## Headers
- **X-Auth-Token** — Authorization token of user


## Parameters
- **SO Id** — ID of order for which details are required


## Return format
A JSON object containing key **data**

- **Data** — Order object


## Example
**Request**

    /api/so_orders/14

**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Order found",
    "data": [
        {
            "id": 5,
            "uuid": "a96d6083-52fd-4eb5-824e-00ff4f84fb72",
            "agency_id": 1,
            "shop_id": 11,
            "booked_by": 14,
            "price": 956980,
            "discount": 0,
            "payment": 956980,
            "type": "Order",
            "status": "Processed",
            "date_to_deliver": "2018-02-07",
            "delivery_time": "00:00",
            "remarks": "",
            "is_discounted": 0,
            "latitude": 31.51436,
            "longitude": 74.3375152,
            "created_by": 14,
            "updated_by": null,
            "created_at": "2018-02-06 15:24:19",
            "updated_at": "2018-02-06 20:25:08",
            "deleted_at": null,
            "is_discounted_2": false
        },
        {
            "id": 6,
            "uuid": "a96d6083-52fd-4eb5-824e-00ff4f84fb72",
            "agency_id": 1,
            "shop_id": 11,
            "booked_by": 14,
            "price": 956980,
            "discount": 0,
            "payment": 956980,
            "type": "Order",
            "status": "Processed",
            "date_to_deliver": "2018-02-07",
            "delivery_time": "00:00",
            "remarks": "",
            "is_discounted": 0,
            "latitude": 31.51436,
            "longitude": 74.3375152,
            "created_by": 14,
            "updated_by": null,
            "created_at": "2018-02-06 15:24:19",
            "updated_at": "2018-02-06 20:25:08",
            "deleted_at": null,
            "is_discounted_2": false
        }
    ]
}
```
