# Log no order

    POST /api/so-payments

## Description
Returns data of payments of tenure

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So Customers payments of tenure


## Example
**Request**

    /api/so-payments

**Json Body**
```javascript
{"supplier_id":15,"date_to_deliver_start":"2018-03-17","date_to_deliver_end":"2018-03-31"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Payments found",
    "data": [
        {
            "date": "2018-03-17",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": [
                                {
                                    "id": 68,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 3,
                                    "user_id": 15,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-17 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": [
                                {
                                    "id": 73,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 61,
                                    "user_id": 15,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-17 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-18",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": [
                                {
                                    "id": 69,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 3,
                                    "user_id": 7,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-18 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-19",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-20",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-21",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-22",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": [
                                {
                                    "id": 70,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 3,
                                    "user_id": 7,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-22 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-23",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-24",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-25",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-26",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-27",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": [
                                {
                                    "id": 71,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 3,
                                    "user_id": 7,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-27 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-28",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-29",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-30",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": []
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-31",
            "so_payment": [
                {
                    "id": 15,
                    "firstname": "Biocos",
                    "lastname": "Dubai",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1521037921116.jpg",
                    "so_customers": [
                        {
                            "id": 3,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 5,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262835kQM.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 6,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-1519926283UtAU.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 7,
                                    "shop_id": 3,
                                    "image_url": "http://api.biocospk.com/uploads/shops/image-15199262838gnw.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "payments": [
                                {
                                    "id": 72,
                                    "uuid": "a0d4d467-ebc9-4c25-84b6-d33f5f5be1c4",
                                    "order_id": 0,
                                    "agency_id": 1,
                                    "bank_id": 0,
                                    "shop_id": 3,
                                    "user_id": 7,
                                    "payment_type": "Cash",
                                    "amount": 1368,
                                    "balance": 1368,
                                    "remarks": "Against inv # 600",
                                    "promise_cheque_date": "2018-03-17",
                                    "cheque_type": null,
                                    "cheque_no": null,
                                    "latitude": null,
                                    "longitude": null,
                                    "created_by": null,
                                    "updated_by": null,
                                    "deleted_by": null,
                                    "created_at": "2018-03-31 04:00:00",
                                    "updated_at": null,
                                    "deleted_at": null
                                }
                            ]
                        },
                        {
                            "id": 61,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 15,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "82d1dc8f-9d24-4882-8cbb-de4c07f6270a",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zohra Gen. Trading ",
                            "email": "",
                            "opening_balance": -5279,
                            "balance": -6719,
                            "location": "Al dagaya ",
                            "latitude": 25.2728956,
                            "longitude": 55.2995986,
                            "phone_1": "+971566944977",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 4,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "B",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-01 17:44:43",
                            "updated_at": "2018-03-27 17:35:53",
                            "deleted_at": null,
                            "images": [],
                            "payments": []
                        }
                    ]
                }
            ]
        }
    ]
}