# Log So Targets Products

    POST /api/so-targets-products

## Description
Returns data of targets of products of month

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So Targets of Products of Month


## Example
**Request**

    /api/so-targets-products

**Json Body**
```javascript
{"so_id":13,"date_start":"2018-06-01","date_end":"2018-06-12"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "So Targets Product Wise",
    "data": [
        {
            "id": 1,
            "name": "Biocos Beauty Cream",
            "target": 245,
            "pre_target": 24,
            "quantity": 384,
            "pre_quantity": 192
        },
        {
            "id": 2,
            "name": "Biocos Beauti Cream Small",
            "target": 234,
            "pre_target": 0,
            "quantity": 2568,
            "pre_quantity": 13116
        },
        {
            "id": 3,
            "name": "Biocos Whitening Serum",
            "target": 456,
            "pre_target": 0,
            "quantity": 3312,
            "pre_quantity": 6360
        },
        {
            "id": 4,
            "name": "Biocos Formula Pack",
            "target": 543,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 5,
            "name": "Biocos Hair Regrowth Magic Serum",
            "target": 123,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 120
        },
        {
            "id": 6,
            "name": "Biocos Pimple Clear Magic Serum",
            "target": 322,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 7,
            "name": "Biocos Age Reversal Magic Serum",
            "target": 654,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 8,
            "name": "Biocos Whitening Serum Parlor Pack",
            "target": 344,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 9,
            "name": "Biocos Large Beauty Soap",
            "target": 0,
            "pre_target": 0,
            "quantity": 264,
            "pre_quantity": 72
        },
        {
            "id": 10,
            "name": "Biocos Small Beauti Soap 90 grm",
            "target": 0,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 168
        },
        {
            "id": 11,
            "name": "Biocos Neem Soap 90 grm",
            "target": 0,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 12,
            "name": "Facial Booster",
            "target": 0,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        },
        {
            "id": 13,
            "name": "Men Whitening Serum",
            "target": 0,
            "pre_target": 0,
            "quantity": 0,
            "pre_quantity": 0
        }
    ]
}