# Log no order

    POST /api/so-tenure-expense-detail

## Description
Returns data of so expenses

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — SO Customer Tenure Return expenses


## Example
**Request**

    /api/so-tenure-expense-detail

**Json Body**
```javascript
{"so_id":13,"date_start":"2018-05-10","date_end":"2018-05-22",'id':2}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Expenses found",
    "data": [
        {
            "date": "2018-05-10",
            "user_expenses": []
        },
        {
            "date": "2018-05-11",
            "user_expenses": []
        },
        {
            "date": "2018-05-12",
            "user_expenses": []
        },
        {
            "date": "2018-05-13",
            "user_expenses": []
        },
        {
            "date": "2018-05-14",
            "user_expenses": []
        },
        {
            "date": "2018-05-15",
            "user_expenses": []
        },
        {
            "date": "2018-05-16",
            "user_expenses": []
        },
        {
            "date": "2018-05-17",
            "user_expenses": [
                {
                    "id": 2,
                    "uuid": "df4e3c53-e9f9-4d87-b3ac-6ebd20f6af0f",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 200,
                    "date": "2018-05-17",
                    "created_at": "2018-05-21 08:49:51",
                    "updated_at": "2018-05-21 08:49:51",
                    "name": "Food",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-18",
            "user_expenses": [
                {
                    "id": 3,
                    "uuid": "df4e3c53-e9f9-4d87-b3ac-6ebd20f6af0f",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 200,
                    "date": "2018-05-18",
                    "created_at": "2018-05-21 08:49:51",
                    "updated_at": "2018-05-21 08:49:51",
                    "name": "Food",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-19",
            "user_expenses": []
        },
        {
            "date": "2018-05-20",
            "user_expenses": []
        },
        {
            "date": "2018-05-21",
            "user_expenses": []
        },
        {
            "date": "2018-05-22",
            "user_expenses": []
        }
    ]
}