# Log no order

    POST /api/so-tenure-expenses

## Description
Returns data of customer Tenure Orders

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — SO Customer Tenure Return expenses


## Example
**Request**

    /api/so-tenure-expenses

**Json Body**
```javascript
{"so_id":13,"date_start":"2018-05-10","date_end":"2018-05-22"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Expenses found",
    "data": [
        {
            "date": "2018-05-10",
            "user_expenses": [
                {
                    "id": 1,
                    "uuid": "2340",
                    "user_id": 13,
                    "expense_id": 3,
                    "amount": 234,
                    "date": "2018-05-10",
                    "created_at": "2018-05-15 12:37:06",
                    "updated_at": "2018-05-15 12:37:06",
                    "name": "Rent",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-11",
            "user_expenses": [
                {
                    "id": 4,
                    "uuid": "7ddb9ad7-b8fc-47eb-9100-9ef1e0eeab8a",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 230,
                    "date": "2018-05-11",
                    "created_at": "2018-05-15 12:39:31",
                    "updated_at": "2018-05-15 12:41:09",
                    "name": "Food",
                    "images": []
                },
                {
                    "id": 5,
                    "uuid": "8a6b359a-e808-4be0-a908-d74328c56b0b",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 230,
                    "date": "2018-05-11",
                    "created_at": "2018-05-15 12:41:28",
                    "updated_at": "2018-05-15 12:41:28",
                    "name": "Food",
                    "images": [
                        {
                            "id": 1,
                            "user_expense_id": 5,
                            "image": "http:///uploads/userExpense/userExpenseImage-1526545520Lkhf.jpeg",
                            "created_at": "2018-05-17 08:25:20",
                            "updated_at": "2018-05-17 08:25:20"
                        },
                        {
                            "id": 2,
                            "user_expense_id": 5,
                            "image": "http:///uploads/userExpense/userExpenseImage-1526545539SHYO.jpeg",
                            "created_at": "2018-05-17 08:25:39",
                            "updated_at": "2018-05-17 08:25:39"
                        },
                        {
                            "id": 3,
                            "user_expense_id": 5,
                            "image": "http:///uploads/userExpense/userExpenseImage-1526545558bVkw.jpeg",
                            "created_at": "2018-05-17 08:25:58",
                            "updated_at": "2018-05-17 08:25:58"
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-05-12",
            "user_expenses": []
        },
        {
            "date": "2018-05-13",
            "user_expenses": [
                {
                    "id": 2,
                    "uuid": "240",
                    "user_id": 13,
                    "expense_id": 4,
                    "amount": 432,
                    "date": "2018-05-13",
                    "created_at": "2018-05-15 12:37:06",
                    "updated_at": "2018-05-15 12:37:06",
                    "name": "Tool Tex",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-14",
            "user_expenses": []
        },
        {
            "date": "2018-05-15",
            "user_expenses": [
                {
                    "id": 3,
                    "uuid": "7ddb9ad7-b8fc-47eb-9100-9ef1e0eeab8a",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 2340,
                    "date": "2018-05-15",
                    "created_at": "2018-05-15 12:39:31",
                    "updated_at": "2018-05-15 12:39:31",
                    "name": "Food",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-16",
            "user_expenses": []
        },
        {
            "date": "2018-05-17",
            "user_expenses": [
                {
                    "id": 6,
                    "uuid": "da2ee376-1f44-4a09-a1c6-3a6c072a94b7",
                    "user_id": 13,
                    "expense_id": 1,
                    "amount": 300,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "Travel Expenses",
                    "images": []
                },
                {
                    "id": 7,
                    "uuid": "df4e3c53-e9f9-4d87-b3ac-6ebd20f6af0f",
                    "user_id": 13,
                    "expense_id": 2,
                    "amount": 200,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "Food",
                    "images": []
                },
                {
                    "id": 8,
                    "uuid": "b73958d6-8c0b-4a58-a96d-3f81c1de3eb0",
                    "user_id": 13,
                    "expense_id": 3,
                    "amount": 0,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "Rent",
                    "images": []
                },
                {
                    "id": 9,
                    "uuid": "0fb4b3f5-f14b-48ce-9555-504b76a5c220",
                    "user_id": 13,
                    "expense_id": 4,
                    "amount": 0,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "Tool Tex",
                    "images": []
                },
                {
                    "id": 10,
                    "uuid": "e737a75c-1662-4e5d-9a6b-2ca51afeb11d",
                    "user_id": 13,
                    "expense_id": 5,
                    "amount": 0,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "Maintenance",
                    "images": []
                },
                {
                    "id": 11,
                    "uuid": "2383c627-4edb-42f8-a302-11b4249ee05b",
                    "user_id": 13,
                    "expense_id": 6,
                    "amount": 0,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "health",
                    "images": []
                },
                {
                    "id": 12,
                    "uuid": "321c4fb6-cbcc-491d-91a1-10d0f4dba10e",
                    "user_id": 13,
                    "expense_id": 7,
                    "amount": 0,
                    "date": "2018-05-17",
                    "created_at": "2018-05-17 09:09:13",
                    "updated_at": "2018-05-17 09:09:13",
                    "name": "entertainment",
                    "images": []
                }
            ]
        },
        {
            "date": "2018-05-18",
            "user_expenses": []
        },
        {
            "date": "2018-05-19",
            "user_expenses": []
        },
        {
            "date": "2018-05-20",
            "user_expenses": []
        },
        {
            "date": "2018-05-21",
            "user_expenses": []
        },
        {
            "date": "2018-05-22",
            "user_expenses": []
        }
    ]
}
