# Log no order

    POST /api/so-tenure-return-orders

## Description
Returns data of customer Tenure Orders

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — SO Customer Tenure Return Orders


## Example
**Request**

    /api/so-tenure-return-orders

**Json Body**
```javascript
{"shop_id":19,"so_id":13,"date_to_deliver_start":"2018-03-10","date_to_deliver_end":"2018-03-22"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "SO Customer Tenure Return Sale",
    "data": [
        {
            "date": "2018-03-10",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-11",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-12",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-13",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-14",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-15",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-16",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-17",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-18",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-19",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": []
            }
        },
        {
            "date": "2018-03-20",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": [
                    {
                        "id": 38,
                        "uuid": "aa40b590-61d9-4ea4-8658-9a0165e6325d",
                        "agency_id": 1,
                        "shop_id": 19,
                        "booked_by": 13,
                        "country_id": 2,
                        "price": 3500,
                        "discount": 0,
                        "payment": 3500,
                        "balance": 11740.33,
                        "type": "Order",
                        "status": "Delivered",
                        "date_to_deliver": "2018-03-20",
                        "delivery_time": "00:00",
                        "remarks": "Just now got order and also delivery  mow. ",
                        "is_discounted": 0,
                        "latitude": 25.2720779,
                        "longitude": 55.2998533,
                        "created_by": 13,
                        "updated_by": null,
                        "created_at": "2018-03-20 16:29:19",
                        "updated_at": "2018-03-20 17:45:35",
                        "deleted_at": null,
                        "is_discounted_2": false
                    }
                ]
            }
        },
        {
            "date": "2018-03-21",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": [
                    {
                        "id": 41,
                        "uuid": "a1f99309-8432-404e-95ec-bfb6ef47a729",
                        "agency_id": 1,
                        "shop_id": 19,
                        "booked_by": 13,
                        "country_id": 2,
                        "price": 7920,
                        "discount": 0,
                        "payment": 7920,
                        "balance": 3820,
                        "type": "Order",
                        "status": "Delivered",
                        "date_to_deliver": "2018-03-21",
                        "delivery_time": "00:00",
                        "remarks": "",
                        "is_discounted": 0,
                        "latitude": 25.2676612,
                        "longitude": 55.3056092,
                        "created_by": 13,
                        "updated_by": null,
                        "created_at": "2018-03-21 10:11:47",
                        "updated_at": "2018-03-21 17:43:58",
                        "deleted_at": null,
                        "is_discounted_2": false
                    }
                ]
            }
        },
        {
            "date": "2018-03-22",
            "customer": {
                "id": 19,
                "sale_officer_id": 13,
                "name": "Al Mushtarie Exim Trading ",
                "images": [
                    {
                        "id": 42,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-15209546784NA3.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 43,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678iQnu.jpeg",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 44,
                        "shop_id": 19,
                        "image_url": "http://api.biocospk.com/uploads/shops/image-1520954678lztc.jpeg",
                        "created_at": null,
                        "updated_at": null
                    }
                ],
                "orders": [
                    {
                        "id": 46,
                        "uuid": "a0117538-8653-49c4-b2ec-38271fa2685b",
                        "agency_id": 1,
                        "shop_id": 19,
                        "booked_by": 13,
                        "country_id": 2,
                        "price": 2750,
                        "discount": 0,
                        "payment": 2750,
                        "balance": 1070,
                        "type": "Order",
                        "status": "Delivered",
                        "date_to_deliver": "2018-03-22",
                        "delivery_time": "00:00",
                        "remarks": "Now viait the shop and got order ans will deliver today evening. ",
                        "is_discounted": 0,
                        "latitude": 25.2767059,
                        "longitude": 55.3069758,
                        "created_by": 13,
                        "updated_by": null,
                        "created_at": "2018-03-22 10:18:34",
                        "updated_at": "2018-03-22 17:14:15",
                        "deleted_at": null,
                        "is_discounted_2": false
                    }
                ]
            }
        }
    ]
}