# Log no order

    POST /api/status-order

## Description
Update data of order, sale, stock 

## Headers
- **X-Auth-Token** — Authorization token of user

## Example
**Request**

    /api/status-order

**Json Body**
```javascript
{"order_id":70,"status":"Delivered","invoice_no":"346456"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Order Status Changed",
    "data": {
        "id": 70,
        "uuid": "5988c0e7-c669-4e54-8369-d42baba4ba41",
        "invoice_no": "346456",
        "agency_id": "1",
        "shop_id": "29",
        "booked_by": "13",
        "country_id": "2",
        "price": "2044",
        "discount": "0",
        "payment": "2044",
        "balance": "-45400",
        "type": "Order",
        "status": "Delivered",
        "date_to_deliver": "2018-05-03",
        "delivery_time": "18:22:00",
        "remarks": "now received call for order and will deliver at 6pm. ",
        "is_discounted": "1",
        "latitude": "25.2766749",
        "longitude": "55.3068402",
        "created_by": "13",
        "updated_by": "13",
        "created_at": "2018-04-02 11:23:21",
        "updated_at": "2018-05-03 05:45:13",
        "deleted_at": null,
        "products": [
            {
                "id": 1,
                "category_id": "1",
                "agency_id": "1",
                "name": "Biocos Beauty Cream",
                "type": "Cream",
                "product_code": "1008",
                "retail_price": "0",
                "wholesale_price": "0",
                "distributor_price": "0",
                "stock_available": "0",
                "started_on": null,
                "discontinued_on": null,
                "description": null,
                "minimum_order_unit": "0",
                "minimum_ws_quantity": "0",
                "minimum_rs_quantity": "0",
                "is_scheme": "0",
                "scheme_quantity": null,
                "scheme_free_quantity": null,
                "created_by": "0",
                "updated_by": "0",
                "deleted_by": "0",
                "created_at": null,
                "updated_at": null,
                "deleted_at": null,
                "product_category": [],
                "pivot": {
                    "order_id": "70",
                    "product_id": "1",
                    "id": 115,
                    "quantity": "192",
                    "product_actual_price": "7.083333333333333",
                    "product_discounted_price": "0",
                    "scheme_free_quantity": "0"
                },
                "images": [
                    {
                        "id": 1,
                        "product_id": "1",
                        "image_url": "http://adminpanel.biocospk.com/uploads/products/image-1519220155154.JPG",
                        "created_at": null,
                        "updated_at": null
                    },
                    {
                        "id": 2,
                        "product_id": "1",
                        "image_url": "http://adminpanel.biocospk.com/uploads/products/image-1519220290183.JPG",
                        "created_at": null,
                        "updated_at": null
                    }
                ]
            },
            {
                "id": 2,
                "category_id": "1",
                "agency_id": "1",
                "name": "Biocos Beauti Cream Small",
                "type": "Cream",
                "product_code": "1014",
                "retail_price": "0",
                "wholesale_price": "0",
                "distributor_price": "0",
                "stock_available": "0",
                "started_on": null,
                "discontinued_on": null,
                "description": null,
                "minimum_order_unit": "0",
                "minimum_ws_quantity": "0",
                "minimum_rs_quantity": "0",
                "is_scheme": "1",
                "scheme_quantity": "6",
                "scheme_free_quantity": "1",
                "created_by": "0",
                "updated_by": "0",
                "deleted_by": "0",
                "created_at": null,
                "updated_at": null,
                "deleted_at": null,
                "product_category": [],
                "pivot": {
                    "order_id": "70",
                    "product_id": "2",
                    "id": 116,
                    "quantity": "144",
                    "product_actual_price": "4.583333333333333",
                    "product_discounted_price": "4.75",
                    "scheme_free_quantity": "0"
                },
                "images": [
                    {
                        "id": 13,
                        "product_id": "2",
                        "image_url": "http://adminpanel.biocospk.com/uploads/products/image-1522153598111.JPG",
                        "created_at": "2018-03-27 16:26:38",
                        "updated_at": "2018-03-27 16:26:38"
                    }
                ]
            }
        ],
        "job_id": 0,
        "is_discounted_2": true,
        "images": [],
        "customer": {
            "id": 29,
            "parent_id": null,
            "agency_id": "1",
            "sale_officer_id": "13",
            "area_id": "4",
            "target_visit_id": "4",
            "currency_id": "2",
            "uuid": "a911a4d2-aab3-43ff-bea4-bb2da010636e",
            "proprietor_id": "14",
            "contact_person_id": "14",
            "name": "African Beauty Palace",
            "email": "",
            "opening_balance": "-2064",
            "balance": "-45400",
            "location": "Shamal street, Gold Souq, Deira, Dubai",
            "latitude": "25.2766749",
            "longitude": "55.3068402",
            "phone_1": "971553363154",
            "phone_2": "",
            "discount_percentage": "0",
            "biocos_ratting": "5",
            "status": "Rejected",
            "customer_type": "Wholesaler",
            "shop_type": "",
            "Category": "A+",
            "created_by": "13",
            "updated_by": null,
            "deleted_by": null,
            "created_at": "2018-03-14 16:56:46",
            "updated_at": "2018-05-03 05:45:13",
            "deleted_at": null,
            "images": [
                {
                    "id": 75,
                    "shop_id": "29",
                    "image_url": "http://api.biocospk.com/uploads/shops/image-15210466267Rap.jpeg",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 76,
                    "shop_id": "29",
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521046623MZzg.jpeg",
                    "created_at": null,
                    "updated_at": null
                },
                {
                    "id": 77,
                    "shop_id": "29",
                    "image_url": "http://api.biocospk.com/uploads/shops/image-1521046630Eysq.jpeg",
                    "created_at": null,
                    "updated_at": null
                }
            ],
            "contact_person": {
                "id": 14,
                "parent_id": null,
                "parent_id_2": null,
                "agency_id": null,
                "country_id": "0",
                "region_id": null,
                "city_id": null,
                "firstname": "Huzaifa",
                "lastname": "",
                "email": "",
                "username": null,
                "reset_token": null,
                "image": null,
                "father_name": null,
                "address": "Main Blvd Gulberg, Commercial Area Gulberg III, Lahore, Punjab, Pakistan",
                "status": "0",
                "is_zsm": "0",
                "parent_type": null,
                "religion": null,
                "gender": null,
                "cnic": null,
                "phone_1": "032152365852",
                "phone_2": "",
                "landline": "",
                "dob": null,
                "joining_date": null,
                "remember_token": null
            },
            "proprietor": {
                "id": 14,
                "parent_id": null,
                "parent_id_2": null,
                "agency_id": null,
                "country_id": "0",
                "region_id": null,
                "city_id": null,
                "firstname": "Huzaifa",
                "lastname": "",
                "email": "",
                "username": null,
                "reset_token": null,
                "image": null,
                "father_name": null,
                "address": "Main Blvd Gulberg, Commercial Area Gulberg III, Lahore, Punjab, Pakistan",
                "status": "0",
                "is_zsm": "0",
                "parent_type": null,
                "religion": null,
                "gender": null,
                "cnic": null,
                "phone_1": "032152365852",
                "phone_2": "",
                "landline": "",
                "dob": null,
                "joining_date": null,
                "remember_token": null
            },
            "product_discount": []
        }
    }
}