# Update order status

    POST /api/update-bilty/{biltyId}

## Description
Update status of bilty by passing bilty id in body 

## Request Headers
- **X-Auth-Token** Authorization Token
- **Content-Type** application/json

## Example
**Request**

    /api/update-bilty/{biltyId}

**Json Body**
```javascript
{
	{
    	"agency_id": "1",
    	"bilti_date": "2018-04-23",
    	"bilti_no": "6557",
    	"delivered_to_id": "13",
    	"id": 1,
    	"products": [{
    			"product_actual_price": 0.0,
    			"agency_id": 0,
    			"category": "",
    			"created_by": 0,
    			"deleted_by": 0,
    			"discount_id": 0,
    			"product_discounted_price": 0.0,
    			"distributor_price": 0.0,
    			"id": 1,
    			"is_scheme": 0,
    			"minimum_order_unit": 0,
    			"minimum_rs_quantity": 0,
    			"minimum_ws_quantity": 0,
    			"name": "Biocos Beauty Cream",
    			"product_id": 0,
    			"quantity": 3,
    			"retail_price": 0.0,
    			"scheme_free_quantity": 0,
    			"scheme_quantity": 0,
    			"stock_available": 0,
    			"product_category_id": 0,
    			"product_category": [],
    			"type": "",
    			"updated_by": 0,
    			"wholesale_price": 0.0
    		}, {
    			"product_actual_price": 0.0,
    			"agency_id": 0,
    			"category": "",
    			"created_by": 0,
    			"deleted_by": 0,
    			"discount_id": 0,
    			"product_discounted_price": 0.0,
    			"distributor_price": 0.0,
    			"id": 2,
    			"is_scheme": 0,
    			"minimum_order_unit": 0,
    			"minimum_rs_quantity": 0,
    			"minimum_ws_quantity": 0,
    			"name": "Biocos Beauti Cream Small",
    			"product_id": 0,
    			"quantity": 3,
    			"retail_price": 0.0,
    			"scheme_free_quantity": 0,
    			"scheme_quantity": 0,
    			"stock_available": 0,
    			"product_category_id": 0,
    			"product_category": [],
    			"type": "",
    			"updated_by": 0,
    			"wholesale_price": 0.0
    		}, {
    			"product_actual_price": 0.0,
    			"agency_id": 0,
    			"category": "",
    			"created_by": 0,
    			"deleted_by": 0,
    			"discount_id": 0,
    			"product_discounted_price": 0.0,
    			"distributor_price": 0.0,
    			"id": 3,
    			"is_scheme": 0,
    			"minimum_order_unit": 0,
    			"minimum_rs_quantity": 0,
    			"minimum_ws_quantity": 0,
    			"name": "Biocos Whitening Serum",
    			"product_id": 0,
    			"quantity": 6,
    			"retail_price": 0.0,
    			"scheme_free_quantity": 0,
    			"scheme_quantity": 0,
    			"stock_available": 0,
    			"product_category_id": 0,
    			"product_category": [],
    			"type": "",
    			"updated_by": 0,
    			"wholesale_price": 0.0
    		}, {
    			"product_actual_price": 0.0,
    			"agency_id": 0,
    			"category": "",
    			"created_by": 0,
    			"deleted_by": 0,
    			"discount_id": 0,
    			"product_discounted_price": 0.0,
    			"distributor_price": 0.0,
    			"id": 12,
    			"is_scheme": 0,
    			"minimum_order_unit": 0,
    			"minimum_rs_quantity": 0,
    			"minimum_ws_quantity": 0,
    			"name": "Facial Booster",
    			"product_id": 0,
    			"quantity": 6,
    			"retail_price": 0.0,
    			"scheme_free_quantity": 0,
    			"scheme_quantity": 0,
    			"stock_available": 0,
    			"product_category_id": 0,
    			"product_category": [{
    					"product_actual_price": 0.0,
    					"agency_id": 0,
    					"category": "",
    					"created_by": 0,
    					"deleted_by": 0,
    					"discount_id": 0,
    					"product_discounted_price": 0.0,
    					"distributor_price": 0.0,
    					"id": 6,
    					"is_scheme": 0,
    					"minimum_order_unit": 0,
    					"minimum_rs_quantity": 0,
    					"minimum_ws_quantity": 0,
    					"name": "Whitening Urgent Facial Booster",
    					"product_id": 12,
    					"quantity": 2,
    					"retail_price": 0.0,
    					"scheme_free_quantity": 0,
    					"scheme_quantity": 0,
    					"stock_available": 0,
    					"product_category_id": 0,
    					"type": "",
    					"updated_by": 0,
    					"wholesale_price": 0.0
    				}, {
    					"product_actual_price": 0.0,
    					"agency_id": 0,
    					"category": "",
    					"created_by": 0,
    					"deleted_by": 0,
    					"discount_id": 0,
    					"product_discounted_price": 0.0,
    					"distributor_price": 0.0,
    					"id": 3,
    					"is_scheme": 0,
    					"minimum_order_unit": 0,
    					"minimum_rs_quantity": 0,
    					"minimum_ws_quantity": 0,
    					"name": "Whitening Moisturizing Cream Booster",
    					"product_id": 12,
    					"quantity": 4,
    					"retail_price": 0.0,
    					"scheme_free_quantity": 0,
    					"scheme_quantity": 0,
    					"stock_available": 0,
    					"product_category_id": 0,
    					"type": "",
    					"updated_by": 0,
    					"wholesale_price": 0.0
    				}
    			],
    			"type": "",
    			"updated_by": 0,
    			"wholesale_price": 0.0
    		}
    	],
    	"status": "On The Way",
    	"supplier_id": "45"
    }

}
```

**Return** __shortened for example purpose__
``` json
"success": true,
"message": "Bilty Updated",
