<?php
/**
 *
 * PHP version >= 7.0
 *
 * @category Console_Command
 * @package  App\Console\Commands
 */

namespace App\Console\Commands;


use App\Models\PartyName;
use App\Models\User;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use DateTime;
use DatePeriod;
use DateInterval;
use Exception;
use Illuminate\Console\Command;



/**
 * Class deletePostsCommand
 *
 * @category Console_Command
 * @package  App\Console\Commands
 */
class saleandrecoveryrating extends Command
{
    /**
     * The console command name.
     *
     * @var string
     */
    protected $signature = "updaterating";

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = "update rating at user table";


    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
         try {

         $start    = (new DateTime('2021-02-01'))->modify('first day of this month');
        $end      = (new DateTime('today'))->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
        $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'rsm');
        })->where('id','<>',46) ->get();
        $obj=null;
        $max_value = 0;  //max sale value;
        $max_value_recovery = 0; //max recovery value;
        $i = 1; //loop increment for rsm;
        $e = 0;
        $totalsale = 0;
        $totalrecovery = 0;
        $winneramount = 0;
        $party_winner_id = 0;
        $party_winner_id_rec = 0;
        $sale_flag= [];
        $recovery_flag=[];
        $datecheck = count($period);
        foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
            if($start_date[$key] != date("Y-m-00")){
            
            $obj[$key]['date']=$start_date[$key];

            $check =  count($user);
            foreach ($user as $key2=>$use){
                $obj[$key]['data'][$key2]['id']=$use['id'];
              
                if(!empty($use) && !empty($use['region_id'])){
                    $party= PartyName::where('region_id',$use['region_id'])
                    ->where('id','<>',14)
                    ->get();

                   
                    foreach ($party as $key3=>$pa){

                       
                        $obj[$key]['data'][$key2]['parties'][$key3]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');

                        $obj[$key]['data'][$key2]['parties'][$key3]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');

                        if($obj[$key]['data'][$key2]['parties'][$key3]['sale']){
                        $totalsale = $totalsale + $obj[$key]['data'][$key2]['parties'][$key3]['sale'];
                    }

                      if($obj[$key]['data'][$key2]['parties'][$key3]['recovery']){
                        $totalrecovery = $totalrecovery + $obj[$key]['data'][$key2]['parties'][$key3]['recovery'];
                    }

                        
                    }
                   //sale module

                     if($totalsale > $max_value){
                           
                             $max_value = $totalsale;
                            $party_winner_id=  $obj[$key]['data'][$key2]['id']=$use['id'];

                            $totalsale = 0;

                            
                        }else{
                            $totalsale = 0;
                        }

                                //recovery module
                        if($totalrecovery > $max_value_recovery){
                           
                             $max_value_recovery = $totalrecovery;
                            $party_winner_id_rec =  $obj[$key]['data'][$key2]['id']=$use['id'];

                            $totalrecovery = 0;

                            
                        }else{
                            $totalrecovery = 0;
                        }
                       
                    if($check == $i){
                          

                        if (!in_array($party_winner_id, $sale_flag)) 
                         { 
                            User::where('id',$party_winner_id)->update(['sale_rating' => '0']);
                         $sale_flag[] = $party_winner_id;
                    
                          } 
                         if (!in_array($party_winner_id_rec, $recovery_flag)) 
                         { 
                            User::where('id',$party_winner_id_rec)->update(['recovery_rating' => '0']);
                         $recovery_flag[] = $party_winner_id_rec;
                    
                          } 

                           User::where('id',$party_winner_id)->increment('sale_rating' , 1);
                   
                           User::where('id',$party_winner_id_rec)->increment('recovery_rating' , 1);
                        
                        
                        $max_value = 0;
                        $max_value_recovery = 0;
                        $totalsale = 0;
                        $totalrecovery = 0;
                         $i = 0;
                               
                                }

                }
                
                $i++;
            }

        }
        else{
             return $this->info("rating has been updated");

        }
        
        $e++;
    }
        return $this->info("rating has been updated");
    } catch(Exception $e) {
       $this->error("An error occurred");
    }
}
}
