<?php
/**
 *
 * PHP version >= 7.0
 *
 * @category Console_Command
 * @package  App\Console\Commands
 */

namespace App\Console\Commands;


use App\Models\Subdistributor;
use App\Models\Bilti;
use App\Models\User;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\RecoverySalePointRecord; 
use DateTime;
use DatePeriod;
use DateInterval;
use Exception;
use Illuminate\Console\Command;



/**
 * Class deletePostsCommand
 *
 * @category Console_Command
 * @package  App\Console\Commands
 */
class salerecoveryandpoints extends Command
{
    /**
     * The console command name.
     *
     * @var string
     */
    protected $signature = "updatesalerecoverypoints";

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = "update record at recorverysalepointrecord table";


    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
          try {

        $start    = (new DateTime('2020-04-01'))->modify('first day of this month');
        $end      = (new DateTime('today'))->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
        $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->get();

        $obj=null;
        $max_value = 0;  //max sale value;
        $max_value_recovery = 0; //max recovery value;
        $max_value_check = 0;
        $max_value_rec_check = 0;
        $i = 0; //loop increment for rsm;
        $totalsale = 0;
        $totalsubsale = 0;
        $totalrecovery = 0;
        $totalpoints = 0;
        $pointcheck = 0;
        $max_value_point = 0;
        $data = null;
        $saled = "";
        $recoveryd = "";
        $pointd = "";

        $datecheck = count($period);
        foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
            if($start_date[$key] != date("Y-m-00")){
            
            $obj[$key]['date']=$start_date[$key];

            $check =  count($user);
            foreach ($user as $key2=>$use){
                $obj[$key]['data'][$key2]['id']=$use['id'];
              
                if(!empty($use)){
                   
                    $party= Subdistributor::where('asm_id',$use['id'])->get();
                    foreach ($party as $key3=>$pa){

                      $obj[$key]['data'][$key2]['parties'][$key3]['points'] =  Bilti::where('po_no_rsm','!=',0)->where('party_id',$pa['id'])->whereBetween('delivered_date', [$start_date[$key],  $end_date[$key]])->sum('total_points');
                       if($obj[$key]['data'][$key2]['parties'][$key3]['points']){
                        
                         $totalpoints = $totalpoints + $obj[$key]['data'][$key2]['parties'][$key3]['points']; 
                        

                  }
                        $obj[$key]['data'][$key2]['parties'][$key3]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sub_sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');

                        $obj[$key]['data'][$key2]['parties'][$key3]['sale_return']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','sub_sale_return')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');

                        $obj[$key]['data'][$key2]['parties'][$key3]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sub_recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');

                        if($obj[$key]['data'][$key2]['parties'][$key3]['sale']){
                        $totalsale = $totalsale + $obj[$key]['data'][$key2]['parties'][$key3]['sale'];

                       
                    }
                     if($obj[$key]['data'][$key2]['parties'][$key3]['sale_return']){
                         $totalsubsale = $totalsubsale + $obj[$key]['data'][$key2]['parties'][$key3]['sale_return'];
                        

                     }
                      if($obj[$key]['data'][$key2]['parties'][$key3]['recovery']){
                        $totalrecovery = $totalrecovery + $obj[$key]['data'][$key2]['parties'][$key3]['recovery'];
                    }

                        
                    }

                   //sale module
                    if($totalsubsale != 0){      
                        $totalsale   = $totalsale - $totalsubsale;

                       }else{
                        $totalsale   = $totalsale;

                       } 
                   

                }


                 if($totalsale > $max_value){
                           
                             $max_value = $totalsale;
                             $party_sale=  $obj[$key]['data'][$key2]['id']=$use;
                             
                             $date_sale = $start_date[$key];

                             $totalsale = 0;
                             $totalsubsale = 0;


                        }else{
                            $totalsale = 0;
                            $totalsubsale = 0;
                        }
                
                              //recovery module
                        if($totalrecovery > $max_value_recovery){
                           
                             $max_value_recovery = $totalrecovery;
                             $party_recovery=  $obj[$key]['data'][$key2]['id']=$use;
                            
                            $date_recovery = $start_date[$key];

                            $totalrecovery = 0;
                            
                        }else{
                            $totalrecovery = 0;
                        }

                        //points module
                        if($totalpoints > $pointcheck){
                             $pointcheck = $totalpoints;
                             $party_pointcheck=  $obj[$key]['data'][$key2]['id']=$use;

                             $date_point = $start_date[$key];
                             


                        $totalpoints = 0;
                    }else{

                        $totalpoints = 0;
                    }
            
            }

            if($max_value > $max_value_check){


                    $max_value_check = $max_value;
                     $saled = $date_sale;
                    $party_sale['max_sale']=  $max_value_check;
                     
                     
                     $party_sale_record = $party_sale;
       
                    
            }

            if($max_value_recovery > $max_value_rec_check){


                    $max_value_rec_check = $max_value_recovery;
                     $recoveryd =  $date_recovery;
                    $party_recovery['max_recovery'] = $max_value_rec_check;
                    

                    $party_recovery_record = $party_recovery;
                   
                    
            }

             if($pointcheck > $max_value_point){


                    $max_value_point = $pointcheck;
                     $pointd = $date_point;
                    $party_pointcheck['max_point'] = $max_value_point;
                    
                    $party_point_record = $party_pointcheck;
                   
                    
            }

            $max_value = 0;
            $max_value_recovery = 0;
            $pointcheck = 0;
        }

        
        
    }  ///date braket
   $data['party_sale_record'] = $party_sale_record;
    $data['party_sale_record']['date'] = $saled;
    
    $data['party_recovery_record'] = $party_recovery_record;

    $data['party_recovery_record']['date1'] = $recoveryd;

    $data['part_point_record'] = $party_point_record;

    $data['part_point_record']['date2'] = $pointd;
    
     $recovery  = RecoverySalePointRecord::where('type','recovery')->first();

     $recovery->asm_id =  $data['party_recovery_record']['id'];
     $recovery->date =  $data['party_recovery_record']['date1'];
     $recovery->recovery =  $data['party_recovery_record']['max_recovery'];
     
     $recovery->save();

     $sale  = RecoverySalePointRecord::where('type','sale')->first();
     $sale->asm_id =  $data['party_sale_record']['id'];
     $sale->date =  $data['party_sale_record']['date'];
     $sale->sale =  $data['party_sale_record']['max_sale'];
     $sale->save();

     $point  = RecoverySalePointRecord::where('type','point')->first();
     $point->asm_id =  $data['part_point_record']['id'];
     $point->date =  $data['part_point_record']['date2'];
     $point->points =  $data['part_point_record']['max_point'];
     $point->save();

       return $this->info("recovery sale and point record  has been updated");
    } 
     catch(Exception $e) {
       $this->error("An error occurred");
    }
}
}
