<?php

namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Laravel\Lumen\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        
        Commands\updateuserexpense::class,
        Commands\saleandrecoveryrating::class,
        Commands\saleandrecoveryratingasm::class,
        Commands\salerecoveryandpoints::class,
        Commands\sendattendancenotification::class,
        Commands\sendattendancenotification::class,
          Commands\voucherstatusupdate::class,
        
        'BasicIT\LumenVendorPublish\VendorPublishCommand',
        'Mlntn\Console\Commands\Serve'
    ];


    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        $schedule->command('updateuser')->monthly();
        $schedule->command('updaterating')->monthly();
        $schedule->command('updateratingasm')->monthly();
        $schedule->command('updatesalerecoverypoints')->hourly();
        $schedule->command('updatevoucherstatus')->daily();
    }
}
