<?php
namespace App\Http\Controllers;
use App\Models\Account;
use App\Models\Bilti;
use App\Models\BiltiDetail;
use App\Models\InventoryReport;
use App\Models\BiltyImage;
use App\Models\BiltiDetialType;
use App\Models\Region;
use App\Models\AsmSchedule;
use App\Models\Customer;
use App\Models\Expense;
use App\Models\ExpenseTag;
use App\Models\StockBooking;
use App\Models\StockImage;
use App\Models\StockbookingImage;
use App\Models\StockBookingDetail;
use App\Models\SubdistributorRates;
use App\Models\StockBookingDetailCategory;
use App\Models\Product;
use App\Models\ProductPrice;
use App\Models\PartyRates;
use App\Models\Order;
use App\Models\PartyName;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\RsmPayment;
use App\Models\RsmPaymentImage;
use App\Models\SupplierSo;
use App\Models\Target;
use App\Models\RsmTarget;
use App\Models\CoupanScheme;
use App\Models\TargetDetail;
use App\Models\User;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\UserExpenseDetailsledger;
use App\Models\UserPoint;
use App\Models\PaymentRemark;
use App\Models\PointSystem;
use App\Models\Visit;
use App\Models\VisitDetail;
use App\Models\Subdistributor;
use App\Models\CashAdjustmentLog;
use App\Models\BalanceAdjustmentImage;
use App\Models\SoStock;
use App\Models\StockSubdistributer;
use App\Models\StockDetailSubdistributer;
use App\Models\StockProductAdjustment; 
use App\Models\Sdvisitopeningstock; //
use App\Models\Sdopeningstockdetails; //
use App\Models\Sdopeningstockdetailcategory; //
use App\Models\UserPointTrail; //
use App\Models\Transferpayment;
use App\Models\DsfArea;
use App\Models\DsfBookingNumber;
use App\Models\DsfShop;
use App\Models\DsfPayment;
use App\Models\DsfShopImage;
use App\Models\Vouchers;
use App\Models\ProductDiscountDsfShops;
use Carbon\Carbon;
use Carbon\CarbonPeriod;
use DateTime;
use DatePeriod;
use DateInterval;
use Dingo\Api\Facade\API;
use League\Flysystem\Exception;
use Illuminate\Http\Request;
use Edujugon\PushNotification\PushNotification;
use App\Models\PushNotificationToken;
use DB;
use PhpParser\Node\Expr\AssignOp\Concat;
use Illuminate\Support\Str;
class AseController extends BaseController
{



  private $_dsfModel;

    /***
     * Constructor
     *
     * @param $request
     * @param User $userModel
     */
    public function __construct(Request $request, DsfArea $dsfModel)
    {
    	set_time_limit(8000000);
      parent::__construct($request);
      $this->_dsfModel = $dsfModel;
    }

    public function getsubdistributerbyase(Request $request){


    	try{
    		$ase_id = $request->ase_id;
  
        $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'ase');
        })->where('id','=',$ase_id)->with(['sub_distributer_users'])->first();
        return API::response()->array(['success' => true, 'message' => 'All subdistributer list in Ase',
          'data' => $users], 200);

      }catch (Exception $e) {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }


    }

//// add or get areas ////

public function addorupdateaseareas(Request $request){

 try{ 
  if($request->id == 0){
    $area          = new DsfArea();
    $area->user_id =$request->user_id;
    $area->name    =$request->name;
    $area->sub_id    =$request->sub_id;
    $area->save();

    return API::response()->array(['success' => true, 'message' => 'Area  successfully added','data' => $area], 200);
  }
  if($request->id != 0)

    $area    = DsfArea::where('id',$request->id)->first();
  if($area){
    $area->name =$request->name;
    $area->save();

    return API::response()->array(['success' => true, 'message' => 'Area  successfully updated','data' => $area], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }

}
catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}
///

public function getaseareas(Request $request){

 try{ 

      $data = [];
      $ase_id = $request->user_id;
      $sub_id = $request->sub_id;


      $dsfuser=[];

    if($sub_id = 0 ){

       

  $area    = DsfArea::where('user_id','=',$ase_id)->get();
}
else{


   $sub   = Subdistributor::where('id',$request->sub_id)->first();

   if($sub->has_dsf == 1){

            
         
              $asm   = Subdistributor::select('asm_id')->where('id',$sub->id)->first();

             
              $dsfs=User::select('id')->whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('asm_id',$asm->asm_id)->get();

            foreach ($dsfs as $key2 => $val) {
              $dsfuser[] = $val->id;
            }

          
                 $area1   = DsfArea::whereIn('user_id',$dsfuser)->where('sub_id',$request->sub_id)->get()->toArray();
                
                 $area2   = DsfArea::where('user_id',$sub->ase_id)->where('sub_id',$request->sub_id)->get()->toArray();
                 
               
               $area = array_merge($area1, $area2); 

}else{


   $area    = DsfArea::where('user_id',$sub->ase_id)->where('sub_id',$request->sub_id)->get();

 }


      
    
}
  if($area){


    return API::response()->array(['success' => true,
      'message' => 'Dsf area lists',
      'data'    => $area], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}
/////dsf shops and shops images ////

public function CreateUpdateShopAse(Request $request){

  try {


   $userId = $this->getUserIdFromToken($request);
   $role  =  $this->getUserRole($userId);

   if($role == 'ase' || $role == 'asm'){

    if($request->id == 0){
      $user = User::where('id',$request->user_id)->first();

      if($role == 'ase'){
      $asm_id  = $user->asm_id;
    }
     if($role == 'asm'){
      $asm_id  = $user->id;
    }

      $dsfshop  =   new  DsfShop();
      $dsfshop->shop_name = $request->shop_name;

      if(!empty($request->area_id)){
      $dsfshop->area_id = $request->area_id;
    }
    else{
      return API::response()->array(['success' => false,
  'message' => 'please select area '], 404);

    }

      $getshopphoneno  =  Dsfshop::select('whatsapp_ph','shop_name')->get()->toArray();

      foreach ($getshopphoneno as $key => $value) {

     
        if(in_array($request->phone, $value))
{
  return API::response()->array(['success' => false,
  'message' => 'This number already attached with'. " " .$value['shop_name']], 404);


}
      }


 

      $dsfshop->address = $request->address;

      $dsfshop->phone = $request->phone;
      $dsfshop->whatsapp_ph = $request->whatsapp_ph;
      $dsfshop->shopkeeper_name = $request->shopkeeper_name;
      $dsfshop->discount = $request->discount;
      $dsfshop->asm_id = $asm_id;
      $dsfshop->sub_id = $request->sub_id;
      $dsfshop->dsf_id = $request->user_id;
      $dsfshop->rsm_id = $user->rsm_id;

      $dsfshop->save();


      if (!empty($request->uploadimages)) {
        $images = [];
        foreach ($request->uploadimages as $image) {
         $image = upload_base64_image($image, 'uploads/shop/',
          'image-');
         $dsfshopimage  =   new  DsfShopImage();
         $dsfshopimage->dsf_shop_id = $dsfshop->id;
         $dsfshopimage->image_url = 'http://' . $image;
         $dsfshopimage->save();


       }

     }
     
   }
   if($request->id != 0){
   

    $dsfshop  =  DsfShop::where('id',$request->id)->first();
    $dsfshop->shop_name = $request->shop_name;
    $dsfshop->address = $request->address;
    $dsfshop->area_id = $request->area_id;
    $dsfshop->phone = $request->phone;
    $dsfshop->whatsapp_ph = $request->whatsapp_ph;
    $dsfshop->shopkeeper_name = $request->shopkeeper_name;
    $dsfshop->discount = $request->discount;
    $dsfshop->save();

    
    if (!empty($request->uploadimages)) {
      $images = [];
      foreach ($request->uploadimages as $image) {
       $image = upload_base64_image($image, 'uploads/shop/',
        'image-');
       $dsfshopimage  =   new  DsfShopImage();
       $dsfshopimage->dsf_shop_id = $dsfshop->id;
       $dsfshopimage->image_url = 'http://' . $image;
       $dsfshopimage->save();


     }

   }

 }
}
else{
 return API::response()->array(['success' => false,
  'message' => 'please login to ase user'], 404);

}


return API::response()->array(['success' => true,
  'message' => 'Shop added Sucessfully'], 200);
} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}



public function ListShopbyase(Request $request){

  try{ 

      
      $data = [];
      $ase_id = $request->ase_id;
      $sub_id = $request->sub_id;

    if($sub_id == 0 ){

       $sub =  Subdistributor::select('id')->where('ase_id',$ase_id)->get()->toArray();
      

     $dsfshops    = DsfShop::whereIn('sub_id',$sub)->with('subdistributer_info','shop_images','area')->get();
     foreach ($dsfshops as $key => $dsfshop) {
            $data[$key] = $dsfshop;
          
   
    }
    
    }
   
  
    else{

    $dsfshops    = DsfShop::where('sub_id',$sub_id)->with('subdistributer_info','shop_images','area')->get();
      foreach ($dsfshops as $key => $dsfshop) {
            $data[$key] = $dsfshop;
          

    }

    }
    if($data){


      return API::response()->array(['success' => true,
        'message' => 'ase shop lists',
        'data'    => $data], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}


public function allsubdistributersareaswithshopsbyase(Request $request){

  try{ 

      
     
      $ase_id = $request->user_id;

        $role= $this->getUserRole($ase_id);

      $obj =[];
      $user = User::where('id',$ase_id)->first();
      $obj['user'] = $user;

      if($role == 'ase'){
       $subs   = Subdistributor::where('ase_id',$ase_id)->get();

       
     }

     if($role == 'asm'){

        $subs   = Subdistributor::where('asm_id',$ase_id)->get();



        foreach ($subs as $key => $sub) {
           
            $obj['user']['sub_distributer_users'][$key] = $sub;

            if($sub->has_dsf == 1){
             $asm   = Subdistributor::select('id')->where('id',$sub->id)->first();

          
                $dsfs=User::select('id')->whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('subdistributer_id',$asm->id)->get();

            


       $area1=DsfArea::where('sub_id',$sub->id)->with('shops')->get()->toArray();

     

       $obj['user']['sub_distributer_users'][$key]['areas']=$area1;
      
             

            }

            else{

            
      $area1=DsfArea::where('sub_id',$sub->id)->with('shops')->get()->toArray();

      $obj['user']['sub_distributer_users'][$key]['areas']=$area1;


            }

             
          }
          if($obj){


      return API::response()->array(['success' => true,
        'message' => 'ase shop lists',
        'data'    => $obj], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }

        
     }

   ////// for ase  ///////
   
          foreach ($subs as $key => $sub) {
           
            $obj['user']['sub_distributer_users'][$key] = $sub;

           

       $area1=DsfArea::where('sub_id',$sub->id)->with('shops')->get()->toArray();

     

       $obj['user']['sub_distributer_users'][$key]['areas']=$area1; 
       


             
          }
        

      
    if($obj){


      return API::response()->array(['success' => true,
        'message' => 'ase shop lists',
        'data'    => $obj], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}



/////// add visit by ase to subdistributer and added opening stock per visit and its status ///



public function addvisitopeningstockstatus(Request $request){

  try{ 
    
    $sub_id =$request->sub_id;
    $date    =$request->date;
    $ase_id    =$request->user_id;

    $Sdvisitopeningstocks =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$ase_id)->where('date',$date)->get();
 
 
    
    if(count($Sdvisitopeningstocks) > 0){

      return API::response()->array(['success' => true,
        'message' => 'record already created'], 200);
    }

    $Sdvisitopeningstock          = new Sdvisitopeningstock();
    $Sdvisitopeningstock->sub_id =$request->sub_id;
    $Sdvisitopeningstock->date    =$request->date;
    $Sdvisitopeningstock->ase_id    =$request->user_id;
    $Sdvisitopeningstock->save();     
    
    if($Sdvisitopeningstock){


      return API::response()->array(['success' => true,
        'message' => 'visit record submitted successfully',
        'data'    => $Sdvisitopeningstock], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}

public function getvisitopeningstockstatus(Request $request){

  try{ 

    if($request->sub_id == 0){

      $now_date= date("Y-m-d");
    

    $pendingorders = Sdvisitopeningstock::where('ase_id',$request->user_id)->where('status','pending')->whereDate('date','<', $now_date)->get();

    if($pendingorders){
        foreach ($pendingorders as $key => $pendingorder) {
          
            $pendingorder->status = "cancel";
            $pendingorder->save();
        }


    }
    

    $Sdvisitopeningstock = Sdvisitopeningstock::where('ase_id',$request->user_id)->where('status',$request->status)->with('subdistributer_info')->get();

  }else{


    $pendingorders = Sdvisitopeningstock::where('sub_id',$request->sub_id)->where('ase_id',$request->user_id)->where('status','pending')->whereDate('date','<', $now_date)->get();

    if($pendingorders){
        foreach ($pendingorders as $key => $pendingorder) {
          
            $pendingorder->status = "cancel";
            $pendingorder->save();
        }


    }

    $Sdvisitopeningstock = Sdvisitopeningstock::where('sub_id',$request->sub_id)->where('ase_id',$request->user_id)->where('status',$request->status)->with('subdistributer_info')->get();

  }
     if($Sdvisitopeningstock){


      return API::response()->array(['success' => true,
        'message' => 'visit record submitted successfully',
        'data'    => $Sdvisitopeningstock], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}




public function addopeningstocksubdistributer(Request $request){

  try{ 

      $flag = 0;
      $flag1 = 0;
      $date = date("Y-m-d");


    $Sdvisitopeningstock = Sdvisitopeningstock::where('id',$request->id)->first();

    
    if($Sdvisitopeningstock){
        if($Sdvisitopeningstock->status == 'pending'){
      
         $ase=User::where('id',$Sdvisitopeningstock->ase_id)->first();
       $Dsfshops = Dsfshop::select('id')->where('sub_id',$Sdvisitopeningstock->sub_id)->get()->toArray();
    
    
     
      $role = $this->getUserRole($request->user_id);

      if($role == 'ase'){

      $stock_bookings = StockBooking::where('booked_by',$Sdvisitopeningstock->ase_id)->wherein('party_id',$Dsfshops)->where('party_check','ase')->where('date',$date)->get();
     }

     if ($role == 'asm') {
       $stock_bookings = StockBooking::where('booked_by',$Sdvisitopeningstock->ase_id)->wherein('party_id',$Dsfshops)->where('party_check','asm_shop')->where('date',$date)->get();
     }

     
     foreach ($stock_bookings as $key1 => $stockbooking) {
        $total_points = 0;
        if ($stockbooking->stock_details_without_product){
          foreach ($stockbooking->stock_details_without_product as $key2 => $stock) {

     if($role == 'ase'){
     $check_points = PointSystem::where('user_id',$ase->asm_id)->where('product_id',$stock->product_id)->first();
    }
     if ($role == 'asm') {

       $check_points = PointSystem::where('user_id',$ase->id)->where('product_id',$stock->product_id)->first();
     }



        if($check_points){
          $quantityforpoints = $stock->quantity/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $total_points = $total_points + $product_points;
         $update = StockBookingDetail::where('id',$stock->id)->first();
         $update->points = $product_points;
         $update->save();
        
        }
          } /// stockbookingdetail loop


      
     }

     $update_stock = StockBooking::where('id',$stockbooking->id)->first();
     $update_stock->total_points = $total_points;
     $update_stock->save();



if($role == 'ase'){

  $remarks  = getremarks($Sdvisitopeningstock->ase_id,$update_stock->party_id);


  $user = User::where('id',$Sdvisitopeningstock->ase_id)->first();
  $user->total_points = $user->total_points + $total_points;
  $user->save();

  $UserPointTrail = new UserPointTrail();

$UserPointTrail->user_id = $Sdvisitopeningstock->ase_id;

$UserPointTrail->points =   $update_stock->total_points;

$UserPointTrail->type = "ase_shop_order";

$UserPointTrail->detail_id = $update_stock->id;

$UserPointTrail->total_points = $user->total_points;

$UserPointTrail->remarks = $remarks;
$UserPointTrail->save();


/////
 $asm_remarks  = getremarks($user->asm_id,$update_stock->party_id);
$asm_user  = User::where('id',$user->asm_id)->first();
$asm_user->total_points = $asm_user->total_points + $total_points;
  $asm_user->save();

  $UserPointTrail = new UserPointTrail();

$UserPointTrail->user_id = $asm_user->id;

$UserPointTrail->points =   $update_stock->total_points;

$UserPointTrail->type = "asm_shop_order";

$UserPointTrail->detail_id = $update_stock->id;

$UserPointTrail->remarks = $remarks;

$UserPointTrail->total_points = $asm_user->total_points;

$UserPointTrail->save();


}

if($role == 'asm'){
  /////
  $asm_user = User::where('id',$Sdvisitopeningstock->ase_id)->first();

   $asm_remarks  = getremarks($asm_user->id,$update_stock->party_id);

$asm_user->total_points = $asm_user->total_points + $total_points;
  $asm_user->save();

  $UserPointTrail = new UserPointTrail();

$UserPointTrail->user_id = $asm_user->id;

$UserPointTrail->points =   $update_stock->total_points;

$UserPointTrail->type = "asm_shop_order";

$UserPointTrail->detail_id = $update_stock->id;
$UserPointTrail->remarks = $asm_remarks;
$UserPointTrail->total_points = $asm_user->total_points;

$UserPointTrail->save();


}

}

       $total_points = 0;
   }  /// stockboookingtable list
      

      $Sdvisitopeningstock->status = 'completed';
      $Sdvisitopeningstock->save();
      $flag= 1;
    }
    
    else{

       $Sdvisitopeningstocks          = new Sdvisitopeningstock();
    $Sdvisitopeningstocks->sub_id =$request->sub_id;
    $Sdvisitopeningstocks->date    =$request->date;
    $Sdvisitopeningstocks->status = 'completed';
    $Sdvisitopeningstocks->ase_id    =$request->user_id;
   $Sdvisitopeningstocks->save(); 
    $flag1 = 1;   
    }


    if(count($request->products)>0){

    foreach ($request->products as $stock){
            $detail=new Sdopeningstockdetails();
            if($flag == 1){
            $detail->sd_id=$request->id;
          }
          if($flag1 == 1){
               $detail->sd_id=$Sdvisitopeningstocks->id;

          }
            $detail->product_id=$stock['product_id'];
            $detail->qty=$stock['quantity'];
            $detail->date = date("Y-m-d");
            $detail->save();

                    ///
                    // add stock product category

         if(count($stock['product_category'])>0){
          foreach($stock['product_category'] as $product_category){
            if(!empty($product_category['quantity'])){
              $product_cat=new Sdopeningstockdetailcategory();

              $product_cat->stock_id=$detail->id;

              $product_cat->subproduct_id=$product_category['product_category_id'];

              $product_cat->qty=$product_category['quantity'];
//                                
             $product_cat->save();
            }
          }
        }
                   

      

    }
  

    


      return API::response()->array(['success' => true,
        'message' => 'opening stock record submitted successfully',
        'data'    => $detail], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}

public function checkvisitopeningstockstatus(Request $request){

  try{ 



       $sub_id =$request->sub_id;
    $date    =$request->date;
     $getdate     = explode('-', $date);

     $dt     = Carbon::create($getdate[0],$getdate[1],$getdate[2]);

     $olddate  = $dt->subDays(7);    ////7weeks days///

      $week_date       = $olddate->toDateString();
     
    $ase_id    =$request->user_id;

  
   $Sdvisitopeningstock =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$ase_id)->whereBetween('date',[$week_date,$date])->where('status','completed')->get();

    if(count($Sdvisitopeningstock) > 0){

      return API::response()->array(['success' => true,
        'message' => 'record exist  successfully'], 200);
    }
    else{

     $Sdvisitopeningstock  =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$ase_id)->whereDate('date','<', $week_date)->latest()->first();

    if($Sdvisitopeningstock){
     return API::response()->array(['success' => false,
        'message' => 'previous 1 week old record found',
      'data'    => $Sdvisitopeningstock], 200);
   }
   else{
     return API::response()->array(['success' => false,
        'message' => 'record not found',
      'data'    => $Sdvisitopeningstock], 200);

   }

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}
public function stockBookingCottonase(Request $request){
  try {


    $validator = \Validator::make($request->all(),['ase_id'=>'required|not_in:0']);
    if ($validator->fails()) {
      return API::response()->array(['success' => false,
        'error'   => 'Required parameters are missing or incorrect!',
        'error_message' => $validator->errors()], 400);
    }else{

        $role = "";
  
      $ase=User::where('id',$request->ase_id)->first();

       $dsfshop =Dsfshop::where('id',$request->shop_id)->first();

       if($dsfshop){

       $dsfarea = DsfArea::where('id',$dsfshop->area_id)->first();


       if($dsfarea){

              $role = $this->getUserRole($dsfarea->user_id);

              $sub_distributer = Subdistributor::where('id',$dsfarea->sub_id)->first();

       }
       else{
          return API::response()->array(['success' => false,
      'message' => 'Area not found from database'],404);
       }
      }

     if($sub_distributer->has_dsf == 1){

        $dsf =User::where('id',$dsfarea->user_id)->first();
      
      $voucher = 0;

      $dsf_accountant = $dsf->Subdistributor_info->sd_accountant_id;

      $subdistributer = $dsf->Subdistributor_info;

      if($dsf_accountant > 0){

      $sub = Subdistributor::where('id',$subdistributer->id)->first();
 
      $sub->has_voucher = 1;
      $sub->save();
   
      $now_date= date("Y-m-d");
 

      $vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->where('date',$now_date)->first();
       
      if(empty($vourchers)){
          $get_vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->first();

        if($get_vourchers){
         $serial_no=$get_vourchers->serial_no + 1;
        }else{
            $serial_no = 1;
        }
         $vourcher  = new Vouchers();
         $vourcher->soul_user_id = $dsf_accountant; 
         $vourcher->serial_no = $serial_no;
         $vourcher->dsf_id = $dsf->id;
         $vourcher->date = date("Y-m-d");
          
         $vourcher->save();


    }else{

        $vourcher = $vourchers;
    }
    }
    }

      $dis_stoc=new StockBooking();
      $dis_stoc->booked_by=$request->ase_id;
      $dis_stoc->booked_to = $request->asm_id;
     
       if(!empty($request->shop_id)){
      $dis_stoc->party_id = $request->shop_id;
    }else{
      return API::response()->array(['success' => false,
  'message' => 'please select party '], 404);

    }
      $dis_stoc->party_check = "ase";
      $dis_stoc->date=date("Y-m-d");

      $dis_stoc->remarks=$request->remarks;

      $dis_stoc->status='Booked';

      $dis_stoc->vendor_flag = 0;  
      

    $dis_stoc->save();

                // stock booking adda
      if(!empty($request->get('adda'))){
        foreach ($request->get('adda') as $adda){
          $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
          if(empty($ad)){
            $ad=new StockBookingAdda();
          }
          $ad->vendor_id=$adda['vendor_id'];
          $ad->adda_id=$adda['adda_id'];
            $ad->save();
        }
      }
      $price=0;
      $total_price=0;
      $get_total_points = 0;

      if(count($request->products)>0){

        foreach ($request->products as $stock){

          $d_stock=new StockBookingDetail();
          $d_stock->stock_booking_id=$dis_stoc->id;
          $d_stock->product_id=$stock['product_id'];

          $cot=Product::where('id',$stock['product_id'])->first();


          if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];

            if($stock['discount_type'] == "percentage" && $stock['unit_price'] == 0){



             $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             $dsfshop  =  DsfShop::where('id',$request->shop_id)->first();
             $tp_rate  = $p->distributor_price;

             $cost = $tp_rate*$stock['quantity'];
             $price=$price+$cost;

             $d_stock->price=$cost;
             $d_stock->discount=$dsfshop->discount;
             $d_stock->payment=$cost-(($cost*$dsfshop->discount)/100);

             $total_price=$total_price+($cost-(($cost*$dsfshop->discount)/100));
          
           }

           if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
            $tp_rate  = $p->distributor_price;
            
             $cost = $tp_rate*$stock['quantity'];
            
              $price=$price+$cost;

             $d_stock->price=$cost;
            
             $d_stock->discount=$stock['discount'];

             $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

             $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));

             

           }


           if($stock['discount_type'] == "rupees"){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             
             $tp_rate  = $p->distributor_price; 

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
             //$d_stock->payment=$cost;
            
             $tp_rate  = $p->distributor_price;

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

              $d_stock->payment=$cost-(($cost*$discount)/100);

               $total_price=$total_price+$cost-(($cost*$discount)/100);


           }

        }

        
      if($sub_distributer->has_dsf == 0){

         $sub_id =$dsfshop->sub_id;
       
        $ase_id    =$ase->id;

        $date    =date("Y-m-d");
     $getdate     = explode('-', $date);

     $dt     = Carbon::create($getdate[0],$getdate[1],$getdate[2]);

     $olddate  = $dt->subDays(7);    ////7weeks days///

      $week_date       = $olddate->toDateString();


      $Sdvisitopeningstock =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$ase_id)->whereBetween('date',[$week_date,$date])->where('status','completed')->get();
       
   
     

          if(count($Sdvisitopeningstock) > 0){

            
           $check_points = PointSystem::where('user_id',$ase->asm_id)->where('product_id',$stock['product_id'])->first();
         
           

        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $get_total_points = $get_total_points + $product_points;
          $d_stock->points =  $product_points;
        }

        }

           ///// visit get ////

    $Sdvisit =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$ase_id)->where('date',$date)->first();
    if(count($Sdvisit) == 0){

      $Sdvisit          = new Sdvisitopeningstock();
      $Sdvisit->sub_id =$sub_id;
      $Sdvisit->date    =$date;
      $Sdvisit->ase_id    =$ase_id;
      $Sdvisit->status    ='repeat';
      $Sdvisit->save();   


    }

      }

      if($sub_distributer->has_dsf == 1){
          
               
           $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();
         

        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $get_total_points = $get_total_points + $product_points;
          $d_stock->points =  $product_points;
        } 

      }


        $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$request->shop_id)->where('product_id',$stock['product_id'])->first();

        if($ProductDiscountDsfShops){

          $ProductDiscountDsfShops->discount = $d_stock->discount;
          $ProductDiscountDsfShops->save();
        }else{

          $ProductDiscountDsfShops = new ProductDiscountDsfShops();
          $ProductDiscountDsfShops->dsf_shop_id = $request->shop_id;
          $ProductDiscountDsfShops->product_id = $stock['product_id'];
          $ProductDiscountDsfShops->discount = $d_stock->discount;
          $ProductDiscountDsfShops->save();

        }

        $d_stock->save();


        if(count($stock['product_category'])>0){
          foreach ($stock['product_category'] as $category){
            $cat=new StockBookingDetailCategory();
            $cat->stock_booking_detail_id=$d_stock->id;
            $cat->product_category_id=$category['id'];
            $cat->quantity=$category['quantity'];
            $cat->dispatch_quantity=$category['quantity'];
            $cat->delivered=0;
            $cat->save();
          }
        }
      }
    }

    $get_ase_for_points = User::where('id',$request->ase_id)->first();

    $get_ase_for_points->total_points = $get_ase_for_points->total_points + $get_total_points;

    $get_ase_for_points->save();


    if($get_total_points > 0 ){
    /// asm points ///
    $asm_user= User::where('id',$get_ase_for_points->asm_id)->first();
    $asm_user->total_points = $asm_user->total_points + $get_total_points;

    $asm_user->save();



   /// ase log ///

    $remarks  = getremarks($get_ase_for_points->id,$dis_stoc->party_id);

    $UserPointTrail = new UserPointTrail();

    $UserPointTrail->user_id = $get_ase_for_points->id;

    $UserPointTrail->points =   $get_total_points;

    $UserPointTrail->type = "Ase_order";

    $UserPointTrail->detail_id = $dis_stoc->id;

    $UserPointTrail->total_points = $get_ase_for_points->total_points;

    $UserPointTrail->remarks = $remarks;
    $UserPointTrail->save();


/////  
     /// asm  points log ///
    


    $UserPointTrails = new UserPointTrail();

    $UserPointTrails->user_id = $asm_user->id;

    $UserPointTrails->points =   $get_total_points;

    $UserPointTrails->type = "Ase_order";

    $UserPointTrails->detail_id = $dis_stoc->id;

    $UserPointTrails->remarks = $remarks;

    $UserPointTrails->total_points = $asm_user->total_points;

    $UserPointTrails->save();

 ///
  }

    $dis_stoc->price=$price;
    $dis_stoc->total_points = $get_total_points;
    if(!empty($dsf)){
      $dis_stoc->payment=$total_price;
  
      $dis_stoc->save();
    }else{
      $dis_stoc->payment=$total_price;
    }
    $dis_stoc->save();

  
    if($sub_distributer->has_dsf == 1){

    $bookingno  = DsfBookingNumber::where('user_id',$dsf->id)->latest()->first();

    if($bookingno){
         $order_no=$bookingno->order_no;
      $bookingno  = new DsfBookingNumber();

         $bookingno->user_id = $dsf->id; 
         $bookingno->order_no = $order_no + 1;
         $bookingno->stock_booking_id = $dis_stoc->id;
         if($vourcher){
         $bookingno->voucher_id = $vourcher->id;
        }
        
        $bookingno->save();


    }else{

          $bookingno  = new DsfBookingNumber();
          $bookingno->user_id = $dsf->id; 
          $bookingno->order_no = 1;
          $bookingno->stock_booking_id = $dis_stoc->id;
           if($vourcher){
          $bookingno->voucher_id = $vourcher->id;
        }
          $bookingno->save();
        }
      }

        if($sub_distributer->has_dsf == 0){

          
              $bookingno  = DsfBookingNumber::where('user_id',$ase->id)->latest()->first();

    if($bookingno){
         $order_no=$bookingno->order_no;
      $bookingno  = new DsfBookingNumber();

         $bookingno->user_id = $ase->id; 
         $bookingno->order_no = $order_no + 1;
         $bookingno->stock_booking_id = $dis_stoc->id;
      
        
        $bookingno->save();


    }else{

          $bookingno  = new DsfBookingNumber();
          $bookingno->user_id = $ase->id; 
          $bookingno->order_no = 1;
          $bookingno->stock_booking_id = $dis_stoc->id;
        
          $bookingno->save();
        }

        

     

    }
                // push notification recipients fetch
    $recipients = User::select('id')->whereHas('roles', function ($query) {
      $query->wherein('name', ['admin','super_admin']);
    })->get()->toarray();
    if(count($recipients)>0){
                    // push notification device token fetch
      $fetch=[];
      $body=null;
      if(!empty($dis_stoc->remarks)){
        $body=  $dis_stoc->remarks;
      }elseif(!empty($dis_stoc->Book_By->firstname)){
        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
      }

      $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
      $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
      if(count($device_token)>0){
                        // push notification send
        push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'asm_order');
      }
    }
    return API::response()->array(['success' => true,
      'message' => 'Stock Booking ',
      'data'    => $dis_stoc], 200);
  }


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

public function getstockBookingCottonasestockdetail(Request $request){

 try{ 



    
   

      $user_id = $request->user_id;
    

   $role  =  $this->getUserRole($user_id);



  if($request->shop_id == 0){

    if($role == 'ase'){

    $StockBookingDsf    = StockBooking::where('booked_by',$user_id)->where('party_check','ase')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();
  }
  if($role == 'asm'){

     $StockBookingDsf    = StockBooking::where('booked_by',$user_id)->where('party_check','asm_shop')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();

  }
  }
  else{

    if($role == 'ase'){
    $StockBookingDsf    = StockBooking::where('booked_by',$user_id)->where('party_id',$request->shop_id)->where('party_check','ase')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();
  }

     if($role == 'asm'){

          $StockBookingDsf    = StockBooking::where('booked_by',$user_id)->where('party_id',$request->shop_id)->where('party_check','asm_shop')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();

        }
  }
  if($StockBookingDsf){


   return API::response()->array(['success' => true,
    'message' => 'ase Stock details',
    'data'    => $StockBookingDsf], 200);
 }
 else{

  return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}

}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}


public function Getshopstockdetailsbyase(Request $request){

 try{ 


       $id =$request->id;
      
 
    $data =[];

  if($id > 0){


       $Sdvisitopening =Sdvisitopeningstock::where('id',$id)->with(['subdistributer_info','products'])->first();

        $tomorrow = $Sdvisitopening->date;
        $check  = explode('-', $tomorrow);
        $minus       = $check[2] - 1;
        $minus       = "0".$minus;
      
        $get_old_date = $check[0]."-".$check[1]."-".$minus;
       
       $Sdvisitopeningolds = Sdvisitopeningstock::where('sub_id',$Sdvisitopening->sub_id)->where('id', '<' , $id)->where('status','completed')->with('products')->first();

    

         $checksdvisitopening = Sdvisitopeningstock::where('sub_id',$Sdvisitopening->sub_id)->get();


            if(!$Sdvisitopeningolds){
              $Sdvisitopeningold  = null;

       
             $end_date  = $Sdvisitopening->date;
      

            }else{

              $Sdvisitopeningold  =   $Sdvisitopeningolds;

       
       $start_date =  $Sdvisitopeningold->date;
       $end_date  = $Sdvisitopening->date;



            }
      
   
      $dsfshop = Dsfshop::select('id')->where('sub_id',$Sdvisitopening->sub_id)->get()->toArray();
    
      $Sdvisitopeningstock =StockBooking::where('date',$end_date)->whereIn('party_id',$dsfshop)->whereIn('party_check',['ase','dsf'])->with('stock_details')->get();
   
   if($Sdvisitopeningolds){
    $Sdvisitopeningstockold =StockBooking::whereIn('party_id',$dsfshop)->whereIn('party_check',['ase','dsf']) ->whereBetween('date', [$start_date, $get_old_date])->with('stock_details')->get();

      $biltiold =Bilti::where('po_no_rsm','!=',0)->where('party_id',$Sdvisitopening->sub_id) ->whereBetween('bilti_date', [$start_date, $end_date])->with('bilty_detail')->get();   
    }
         $data['stock_detail'] = $Sdvisitopening;
         $data['orders']= $Sdvisitopeningstock;
         $data['previousopeningstock']= $Sdvisitopeningold;
         $data['previousorders']= $Sdvisitopeningstockold;
         $data['bilties']=$biltiold;


  }
  else{

    return API::response()->array(['success' => false,
    'message' => 'no record found'], 404);
 
  }
  if($data){


   return API::response()->array(['success' => true,
    'message' => 'shop stock details by ase',
    'data'    => $data], 200);
 }
 else{

  return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}

public function Getsdvisitopeningstockbyase(Request $request){

 try{ 


       $sub_id =$request->sub_id;
    
    $ase_id    =$request->user_id;
    $start_date = $request->start_date;
    $end_date = $request->end_date;

    

  if($request->sub_id == 0){
   
    

    $Sdvisitopeningstock =Sdvisitopeningstock::whereBetween('date', [$start_date, $end_date])->where('ase_id',$ase_id)->with('subdistributer_info')->get();
 

  }
  else{

   $Sdvisitopeningstock =Sdvisitopeningstock::whereBetween('date', [$start_date, $end_date])->where('sub_id',$sub_id)->where('ase_id',$ase_id)->with('subdistributer_info')->get();
 
  }
  if($Sdvisitopeningstock){


   return API::response()->array(['success' => true,
    'message' => 'ase opening stock details',
    'data'    => $Sdvisitopeningstock], 200);
 }
 else{

  return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}

public function updatepoints(Request $request){

 try{ 

  
    $user = User::where('id',$request->ase_id)->first();
 $stock_bookings = StockBooking::select('id')->where('booked_by',$request->ase_id)->where('party_check','=','ase')->where('total_points',0)->get();
   $total_points = 0;
foreach ($stock_bookings as $key1 => $stockbooking) {

        if ($stockbooking->stock_details_without_product){


          foreach ($stockbooking->stock_details_without_product as $key2 => $stock) {

          
     $check_points = PointSystem::where('user_id',$user->asm_id)->where('product_id',$stock->product_id)->first();
  
        if($check_points){
          $quantityforpoints = $stock->quantity/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $total_points = $total_points + $product_points;
         $update = StockBookingDetail::where('id',$stock->id)->first();
         
        $update->points = $product_points;

       
         $update->save();
        
        }
          } /// stockbookingdetail loop

         
      
     }

     $update_stock = StockBooking::where('id',$stockbooking->id)->first();
     $update_stock->total_points = $total_points;
      $update_stock->save();
       $total_points = 0;
   }  /// stockboookingtable list
      
 return API::response()->array(['success' => true,
    'message' => 'Point successfully edit'], 200);

}
catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}

}



public function monthlyaseorpartysalespercentage(Request $request){
    try {

        $start    = (new DateTime($request->start_date))->modify('first day of this month');
        $end      = (new DateTime($request->end_date))->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
        $obj=null;

        if($request->ase_id != 0){

            $user=User::where('id',$request->ase_id)->first();

            foreach ($period as $key=> $dt) {

                $start_date[$key] = $dt->format("Y-m-00");

                $end_date[$key] =  $dt->add($interval)->format("Y-m-00");


                if(!empty($user)){
                    $party= Subdistributor::where('ase_id',$request->ase_id)->get();

                    

                    foreach ($party as $key2=>$pa){
                       $obj[$key][$key2]['date']=$start_date[$key];
                       $obj[$key][$key2]['id']=$pa['id'];
                       $obj[$key][$key2]['sale']=UserExpenseDetail::
                       where('party_id',$pa['id'])
                       ->where('type','Sub_sale')
                       ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                       ->groupBy('type')
                       ->sum('amount');

                       $obj[$key][$key2]['recovery']=UserExpenseDetail::
                       where('party_id',$pa['id'])
                       ->where('type','Sub_recovery')
                       ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                       ->groupBy('type')
                       ->sum('amount');
                   }

               }

           }
       }


       return API::response()->array(['success' => true,
        'message' => 'Ase Parties sales ',
        'data'    => $obj], 200);
   } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}




 public function Asesale(Request $request)
    {
        try {
           $start=$request->start_date;
           $end=$request->end_date;

$period = getDatesFromRange($start, $end);

  


           $dsf_user = $request->user_id;
           $obj3 =[]; 
           $obj4 =[]; 
          // $dsf = DsfShop::select('id')->where('dsf_id',$dsf_user)->get()->toArray();
          
            $obj= StockBooking::select(DB::raw('party_id,sum(payment) as sale_amount,sum(total_points) as points,booked_by,date'))
           //->wherein('party_id',$dsf)
           ->where('booked_by',$dsf_user)
           ->whereIn('party_check',['dsf','ase'])->wherebetween('date',[$start,$end])
           ->groupBy('date','type')
           ->orderBy('date', 'ASC')
           ->get();
               
          foreach ($obj as $key => $val) {
         
                  $obj3[$key]['date'] = $val['date'];
                  $obj3[$key]['sale_amount'] = $val['sale_amount'];
                   $obj3[$key]['points'] = $val['points'];
                  $obj3[$key]['booked_by'] = $val['booked_by'];
                 
          }
          
          // Iterate over the period
    $i = 0;
foreach ($period as $key1 => $date) {
         
    foreach($obj3 as $key2 => $data ){
  
          if( $data['date'] == $date){

                             $obj4[$key1]['date'] = $date;
                  
                    $obj4[$key1]['sale_amount'] =  $obj3[$key2]['sale_amount'];
                    $obj4[$key1]['points'] =  $obj3[$key2]['points'];
                    $obj4[$key1]['booked_by'] =  $obj3[$key2]['booked_by'];

                
                  $i = 1;
          }
         
    }
    if($i == 0){
                    
                    $obj4[$key1]['date'] = $date;
                  
                    $obj4[$key1]['sale_amount'] =  0;
                    $obj4[$key1]['points'] =  0;
                    $obj4[$key1]['booked_by'] =  0;
                  
                  
                  

         
    }
     $i= 0;
        }
     //
     
           
       } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Ase Sale ',
        'data' => $obj4], 200);
}
public function getlistallase(Request $request){

    try{
    

     $users=User::whereHas('roles', function($query) {
        $query->where('name', '=', 'ase');
    })->where('asm_id',$request->asm_id)->get();


   return API::response()->array(['success' => true, 'message' => 'All ASE List','data' => $users], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function getuserpointtrails(Request $request){

    try{
    
          $start_date = $request->start_date." 00:00:00";
          
    $end_date = $request->end_date." 23:59:59";

          $users =UserPointTrail::where('user_id',$request->id)->whereRaw(
  "(created_at >= ? AND created_at <= ?)", 
  [$start_date, $end_date])->get();

    return API::response()->array(['success' => true, 'message' => 'All UserPoint List','data' => $users], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function updateasesubditributer(Request $request){

    try{
         $Subdistributor =Subdistributor::where('id',$request->id)->first();
         if($Subdistributor){

          if($request->ase_id == 0){
          $Subdistributor->ase_id = 0;
        }
        if($request->ase_id > 0){
          $Subdistributor->ase_id = $request->ase_id;
        }
        
          $Subdistributor->save();

         }else{

            return API::response()->array(['success' => false, 'message' => 'user not found'], 404);

         }

    return API::response()->array(['success' => true, 'message' => 'updated successfully','data' => $users], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}



}