<?php

namespace App\Http\Controllers;

use App\Models\Area;
//use Mail;
//use Illuminate\Mail\Mailer;
use App\Models\Bilti;
use App\Models\VendorInvoice;
use App\Models\InventoryReport;
use App\Models\BiltiDetail;
use App\Models\ExpenseTag;
use App\Models\Tag;
use App\Models\Tagtype;
use App\Models\Region;
use App\Models\BiltiDetialType;
use App\Models\BiltyImage;
use App\Models\Customer;
use App\Models\RawMaterial;
use App\Models\CustomerImage;
use App\Models\Expense;
use App\Models\ExpenseImage;
use App\Models\Feedback;
use App\Models\Order;
use App\Models\OrderProduct;
use App\Models\OrderProductCategory;
use App\Models\PartyName;
use App\Models\PartyRates;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\Product;
use App\Models\ProductRaw;
use App\Models\ProductPrice;
use App\Models\RawProductVendor;
use App\Models\RsmTarget;
use App\Models\RsmPayment;
use App\Models\DsfTarget;
use App\Models\AsmTarget;
use App\Models\DistributorTarget;
use App\Models\Subdistributor;
use App\Models\SoStock;
use App\Models\SoTarget;
use App\Models\SoTargetDetail;
use App\Models\StockBooking;
use App\Models\StockBookingDetail;
use App\Models\StockBookingDetailCategory;
use App\Models\SupplierSo;
use App\Models\WareHouse;
use App\Models\WarehouseStocks;
use App\Models\WarehouseStockVariant;
use App\Models\User;
use App\Models\UserArea;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\SoStockDetail;
use Dingo\Api\Facade\API;
use Illuminate\Http\Request;
use League\Flysystem\Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Str;
use App\Models\PaymentRemark;
use App\Models\RawProductVendorDesktop;
use App\Models\Factoryinventory;

class AsmTargetController extends BaseController
{
    /***
     * @var Order
     */
    private $_orderModel;

    /***
     * Constructor
     *
     * @param $request
     * @param Order $orderModel
     */
    public function __construct(Request $request, Order $orderModel)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_orderModel = $orderModel;
    }

    /***
     * Book or update orders
     *
     * @param $orderId
     * @param $request
     *
     * @return mixed
     */
     
    // Get ASM BY Sole Distributer/Parties 
    public function getASMByPartyID(Request $request){
     //  return $request;
        try {
            $party_id = $request->party_id;
                $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
                })->where('party_id','=',$party_id)->get()->toArray();

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM By Parties',
            'data' => $users], 200);
    }
    
     
    /***
     * Get ASM Targets
     *
     * @param Request $request
     * @return mixed
     */
   public function addASMTarget(Request $request){
           // return $request->asm_assign_target_list->target_id;
        try {
         //   return $request->asm_assign_target_list;
            foreach($request->asm_assign_target_list as $list){
                $exist  =  AsmTarget::where('asm_id', $list['asm_id'])->where('coupan_scheme_id', $list['coupan_scheme_id'])->first();
               // return $list['target_id'];
              //  return $targetid;
              if(!$exist){
                $obj = new AsmTarget();
                $obj->rsm_target_id = $list['target_id'];
                $obj->asm_id = $list['asm_id'];
                $obj->party_id = $list['party_id'];
                $obj->coupan_scheme_id = $list['coupan_scheme_id'];
                $obj->rsm_id = $list['rsm_id'];
                $obj->sales_target = $list['sales_target'];
                $obj->recovery_target=$list['recovery_target'];
                $obj->total_recovery_target = $list['total_recovery_target'];
                $obj->total_sale_target=$list['total_sale_target'];
                $obj->start_date = $list['start_date'];
                $obj->end_date=$list['end_date'];
                $obj->status='Processed';
                $obj->save();
              }else{
                $obj = "Already Added";
              }
            }
            

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Targets Assign Sucessfully',
            'data' => $obj], 200);
    }

    // Get ASM BY Party Id And Thir Sales Return 
    public function getASMByPartyIDAndSaleReturn(Request $request){
      // return $request;
        try {
            $party_id = $request->party_id;
            $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
                })->where('party_id','=',$party_id)->get();
           // return $users;    
            $obj= array();
            $obj['asm_list']=array();
            foreach($users as $key1=>$user){
                
                $targets= AsmTarget::where('asm_id',$user->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                $asmId = $targets->asm_id;
                $obj['asm_list'][$key1]['id'] = $user->id;
                $obj['asm_list'][$key1]['firstname']=$user->firstname;
                $obj['asm_list'][$key1]['lastname']=$user->lastname;

                $obj['asm_list'][$key1]['target']=$targets;
                $obj['asm_list'][$key1]['sales_achieved']=Bilti::where('delivered_to_id',$asmId)
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['asm_list'][$key1]['recovery_achieved']=RsmPayment::where('payment_by',$asmId)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['asm_list'][$key1]['sale_return']=StockBooking::where('booked_by',$asmId)->where('type','=','sub_sale_return')->sum('payment');
                
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM By Parties',
            'data' => $obj], 200);
    }
    
    
        // Get Single ASM BY Party Id And Thir Sales Return Without Coupan Scheme
    public function getASMSaleReturnWithOutCoupanScheme(Request $request){
      // return $request;
        try {
            // $party_id = $request->party_id;
            $users=User::where('id',$request->asm_id)->first();
            $sub_users   = Subdistributor::where('asm_id',$request->asm_id)->with(['subdistributerTarget'=>function($query){
                $query->where('status',"Processed")->get();
            }])->get();
          //  return $sub_users;    
        //  $targets= DistributorTarget::where('sub_distributor_id',$user->id)->first();
            $obj= array();
            $obj['asm_info']=array();

                $targets= AsmTarget::where('asm_id',$request->asm_id)->where('status',"Processed")->first();
               // return $targets;
                $obj['asm_info']['sub_distributers'] = $sub_users;
                $obj['asm_info']['id'] = $users->id;
                $obj['asm_info']['firstname']=$users->firstname;
                $obj['asm_info']['lastname']=$users->lastname;

                $obj['asm_info']['target']=$targets;
                $obj['asm_info']['sales_achieved']=Bilti::where('delivered_to_id',$request->asm_id)
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['asm_info']['recovery_achieved']=RsmPayment::where('payment_by',$request->asm_id)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])->sum('amount');
                $obj['asm_info']['sale_return']=StockBooking::where('booked_by',$request->asm_id)->where('type','=','sub_sale_return')->sum('payment');
                

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM By Parties',
            'data' => $obj], 200);
    }
    
    // Get Single ASM BY Party Id And Thir Sales Return 
    public function getASMSaleReturn(Request $request){
      // return $request;
        try {
            $coupan_scheme_id = $request->coupan_scheme_id;
            // $party_id = $request->party_id;
            $users=User::where('id',$request->asm_id)->first();
            $sub_users   = Subdistributor::where('asm_id',$request->asm_id)->with(['subdistributerTarget'=>function($query)use($coupan_scheme_id){
                $query->where('coupan_scheme_id',$coupan_scheme_id)->get();
            }])->get();
          //  return $sub_users;    
        //  $targets= DistributorTarget::where('sub_distributor_id',$user->id)->first();
            $obj= array();
            $obj['asm_info']=array();

                $targets= AsmTarget::where('asm_id',$request->asm_id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
               // return $targets;
                $obj['asm_info']['sub_distributers'] = $sub_users;
                $obj['asm_info']['id'] = $users->id;
                $obj['asm_info']['firstname']=$users->firstname;
                $obj['asm_info']['lastname']=$users->lastname;

                $obj['asm_info']['target']=$targets;
                $obj['asm_info']['sales_achieved']=Bilti::where('delivered_to_id',$request->asm_id)
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['asm_info']['recovery_achieved']=RsmPayment::where('payment_by',$request->asm_id)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])->sum('amount');
                $obj['asm_info']['sale_return']=StockBooking::where('booked_by',$request->asm_id)->where('type','=','sub_sale_return')->sum('payment');
                

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM By Parties',
            'data' => $obj], 200);
    }
    // Add Sub Distributors And DSF Target
    public function addDistributorTarget(Request $request){
          //  return $request;
        try {
         //   return $request->asm_assign_target_list;
            foreach($request->subdistributor_assign_target_list as $list){
                
               // return $list['dsf'];
                foreach($list['dsf'] as $dsf){
// return $dsf;
                        $obj = new DsfTarget();
                        $obj->dsf_id = $dsf['id'];
                        $obj->coupan_scheme_id = $list['coupan_scheme_id'];
                        $obj->rsm_target_id = $list['target_id'];
                        $obj->asm_id = $dsf['asm_id'];
                        $obj->party_id = $list['party_id'];
                        $obj->sub_distributor_id = $list['id'];
                        $obj->rsm_id = $dsf['rsm_id'];
                        $obj->sales_target = $dsf['sales_target'];
                        $obj->recovery_target=$dsf['recovery_target'];
                        $obj->total_recovery_target = $dsf['total_recovery_target'];
                        $obj->total_sale_target=$dsf['total_sale_target'];
                        $obj->start_date = $list['start_date'];
                        $obj->end_date=$list['end_date'];
                        $obj->status='Processed';
                        $obj->save();
                      //  return $dsf;
                }
                  //  return $targetid;
                    $obj = new DistributorTarget();
                    $obj->rsm_target_id = $list['target_id'];
                    $obj->coupan_scheme_id = $list['coupan_scheme_id'];
                    $obj->asm_id = $list['asm_id'];
                    $obj->party_id = $list['party_id'];
                    $obj->sub_distributor_id = $list['id'];
                    $obj->rsm_id = $list['rsm_id'];
                    $obj->sales_target = $list['sales_target'];
                    $obj->recovery_target=$list['recovery_target'];
                    $obj->total_recovery_target = $list['total_recovery_target'];
                    $obj->total_sale_target=$list['total_sale_target'];
                    $obj->start_date = $list['start_date'];
                    $obj->end_date=$list['end_date'];
                    $obj->status='Processed';
                    $obj->save();
            }
            

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Targets Assign Sucessfully',
            'data' => $rsm], 200);
    }
    
    
    
    
    //Get DSF id and sale return
    
      public function getlistalldsf(Request $request){
       //return $request;
        try {
            $sub_distributor_id = $request->sub_distributor_id;
           // $sub_users   = Subdistributor::where('id',$request->sub_distributor_id)->get();
            $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'dsf');
                })->where('subdistributer_id','=',$sub_distributor_id)->get()->toArray();
            
          //  return $users;    
            $obj= array();
            $obj['dsf_list']=array();
            foreach($users as $key1=>$user){
              //  return $user;
              //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DsfTarget::where('dsf_id',$user[id])->first();
              //   return $targets;
                  $obj['dsf_list'][$key1]['id'] = $user[id];
                  $obj['dsf_list'][$key1]['name']=$user[firstname]." ".$user[lastname];
                 // $obj['dsf_list'][$key1]['lastname']=$user->lastname;

                $obj['dsf_list'][$key1]['target']=$targets;
                $obj['dsf_list'][$key1]['sales_achieved']=UserExpenseDetail::where('user_id',$user[id])->where('type','dsf_sale')->orwhere('type','shop_sale')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['dsf_list'][$key1]['recovery_achieved']=UserExpenseDetail::where('user_id',$user[id])->where('type','dsf_recovery')->orwhere('type','shop_recovery')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                // $obj['dsf_list'][$key1]['sale_return']=StockBooking::where('party_id',$user->id)->where('type','=','sub_sale_return')->sum('payment');
                
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'DSF LIST By Subdistributers',
            'data' => $obj], 200);
    }
    
    //Get DSF Target Details BY ID AND SAles Return
    
      public function getdsftargetbyid(Request $request){
      // return $request;
        try {
            $dsf_id = $request->dsf_id;
           // $sub_users   = Subdistributor::where('id',$request->sub_distributor_id)->get();
            $user=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'dsf');
                })->where('id','=',$dsf_id)->first();
            
          //  return $user;    
            $obj= array();
            $obj['dsf_view']=array();
              //  return $user;
              //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DsfTarget::where('dsf_id',$user->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
              //   return $targets;
                  $obj['dsf_view']['id'] = $user->id;
                  $obj['dsf_view']['name']=$user->firstname." ".$user->lastname;
                 // $obj['dsf_list'][$key1]['lastname']=$user->lastname;

                $obj['dsf_view']['target']=$targets;
                $obj['dsf_view']['sales_achieved']=UserExpenseDetail::where('user_id',$user->id)->where('type','dsf_sale')->orwhere('type','shop_sale')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['dsf_view']['recovery_achieved']=UserExpenseDetail::where('user_id',$user->id)->where('type','dsf_recovery')->orwhere('type','shop_recovery')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                // $obj['dsf_list'][$key1]['sale_return']=StockBooking::where('party_id',$user->id)->where('type','=','sub_sale_return')->sum('payment');
                
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'DSF LIST By Subdistributers',
            'data' => $obj], 200);
    }
    
    // Get Sub Distributors BY ASM Id And Thir Sales Return 
    
    
    public function getDistributorTargetByASMidAndSaleReturn(Request $request){
      // return $request;
        try {
            $asm_id = $request->asm_id;
            $sub_users   = Subdistributor::where('asm_id',$request->asm_id)->get();
            
        //    return $sub_users;    
            $obj= array();
            $obj['sub_distributor_list']=array();
            foreach($sub_users as $key1=>$user){
               //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DistributorTarget::where('sub_distributor_id',$user->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                 
                 $distributerID = $targets->sub_distributor_id;
              //  return $targets;
                 $obj['sub_distributor_list'][$key1]['id'] = $user->id;
                 $obj['sub_distributor_list'][$key1]['name']=$user->name;
                // $obj['asm_list'][$key1]['lastname']=$user->lastname;

                $obj['sub_distributor_list'][$key1]['target']=$targets;
                $obj['sub_distributor_list'][$key1]['sales_achieved']=Bilti::where('party_id',$distributerID)->where('po_no_rsm','>','0')
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['sub_distributor_list'][$key1]['recovery_achieved']=RsmPayment::where('sub_id',$distributerID)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['sub_distributor_list'][$key1]['sale_return']=StockBooking::where('party_id',$distributerID)->where('type','=','sub_sale_return')->sum('payment');
                
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Distributors Targets By ASM',
            'data' => $obj], 200);
    }
    
        // Get Single Sub Distributors Target Thir Sales Return 
    public function getDistributorTargetAndSaleReturn(Request $request){
    //   return $request;
        try {
          //  $asm_id = $request->asm_id;
            $user   = Subdistributor::where('id',$request->sub_distributor_id)->first();
            
            $dsf=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'dsf');
                })->where('subdistributer_id','=',$request->sub_distributor_id)->get()->toArray();
         //   return $user;    
            $obj= array();
            $obj['sub_distributor_user']=array();
               //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DistributorTarget::where('sub_distributor_id',$user->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
               //  return $targets;
                 $obj['sub_distributor_user']['id'] = $user->id;
                 $obj['sub_distributor_user']['name']=$user->name;
                // $obj['asm_list'][$key1]['lastname']=$user->lastname;
                $obj['sub_distributor_user']['dsf']=$dsf;
                $obj['sub_distributor_user']['target']=$targets;
                $obj['sub_distributor_user']['sales_achieved']=Bilti::where('party_id',$user->id)->where('po_no_rsm','>','0')
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['sub_distributor_user']['recovery_achieved']=RsmPayment::where('sub_id',$user->id)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['sub_distributor_user']['sale_return']=StockBooking::where('party_id',$user->id)->where('type','=','sub_sale_return')->sum('payment');
                

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Distributor Target',
            'data' => $obj], 200);
    }

    //////DSF Targets
            // Get Single ASM BY Party Id And Thir Sales Return Without Coupan Scheme
    public function getDSFSaleReturnWithOutCoupanScheme(Request $request){
        try {
          $targets= DsfTarget::where('dsf_id',$request->dsf_id)->first();
            $obj= array();
            $obj['dsf_info']=array();
            $obj['dsf_info']['target']=$targets;
            $obj['dsf_info']['sales_achieved']=UserExpenseDetail::where('user_id',$request->dsf_id)->where('type','dsf_sale')->orwhere('type','shop_sale')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
            $obj['dsf_info']['recovery_achieved']=UserExpenseDetail::where('user_id',$request->dsf_id)->where('type','dsf_recovery')->orwhere('type','shop_recovery')
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'DSF Single Target',
            'data' => $obj], 200);
    }
        // Get Sub Distributors BY ASM Id And Thir Sales Return 
    public function getDistributorTargetWithDSFByASMidAndSaleReturn(Request $request){
      // return $request;
        try {
            $asm_id = $request->asm_id;
            $sub_users   = Subdistributor::where('asm_id',$request->asm_id)->get();
            
            $obj= array();
            $obj['sub_distributer_user']=array();
            foreach($sub_users as $key1=>$user){
                $obj['sub_distributer_user'][$key1]['dsf'] = $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'dsf');
                })->where('subdistributer_id', $user->id)->get();
               //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DistributorTarget::where('sub_distributor_id',$user->id)->first();
                // return $targets;
                 $obj['sub_distributer_user'][$key1]['id'] = $user->id;
                 $obj['sub_distributer_user'][$key1]['name']=$user->name;
                // $obj['asm_list'][$key1]['lastname']=$user->lastname;

                $obj['sub_distributer_user'][$key1]['target']=$targets;
                $obj['sub_distributer_user'][$key1]['sales_achieved']=Bilti::where('party_id',$user->id)->where('po_no_rsm','>','0')
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['sub_distributer_user'][$key1]['recovery_achieved']=RsmPayment::where('sub_id',$user->id)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['sub_distributer_user'][$key1]['sale_return']=StockBooking::where('party_id',$user->id)->where('type','=','sub_sale_return')->sum('payment');
                
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Distributors Targets By ASM',
            'data' => $obj], 200);
    }
    
    //RSM Tree Targets
    public function getrsmtreetargets(Request $request )
    {
      //  return $request;
        try {
            $coupan_scheme_id = $request->coupan_scheme_id;
            $user=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'rsm');
            })
                    ->where('id','<>',46)
            ->get();
    
    $targets= RsmTarget::where('coupan_scheme_id',$request->coupan_scheme_id)->get();
  //  return $targets;
            $obj= array();
            $par = array();
    
            foreach($targets as $key0=>$target)
            {
   // return $target;
                if(!empty($target)){
                    foreach ($user as $key=>$use){
    
  //  return $use;
                        $obj[$key]['id']=$use['id'];
                        $obj[$key]['firstname']=$use['firstname'];
                        $obj[$key]['lastname']=$use['lastname'];
                        $obj[$key]['image']=$use['image'];
                        
                        $Asms =User::whereHas('roles', function($query) {
                            $query->where('name', '=', 'asm');
                        })->where('rsm_id',$use['id'])->get();
                       $obj[$key]['asm']=$Asms;
                      //  return $obj;
                        foreach($Asms as $key3=>$asm){
                            if(!empty($asm)){
                            $Asmtargets= AsmTarget::where('asm_id',$asm->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                            $obj[$key]['asm'][$key3]['asm_target']=$Asmtargets;
                            $sub_users= Subdistributor::where('asm_id',$asm->id)->with(['subdistributerTarget'=>function($query)use($coupan_scheme_id){
                                $query->where('coupan_scheme_id',$coupan_scheme_id)->get();
                            }])->get();
                            $obj[$key]['asm'][$key3]['sub_distributer_user']=$sub_users;
                            foreach($sub_users as $key4=>$subdistributor){
                                $dsfs=User::whereHas('roles', function($query) {
                                    $query->where('name', '=', 'dsf');
                                })->where('subdistributer_id','=',$subdistributor->id)->get();
                                $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'] = $dsfs;
                                foreach($dsfs as $key5=>$dsf){
                                    $dsftargets= DsfTarget::where('dsf_id',$dsf->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                                    $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'][$key5]['dsf_target'] = $dsftargets;
                                }
                                
                            }
                            }
                        }
                     //   return $obj;
                        if(!empty($use) && !empty($use['region_id'])){
    
                            $party= PartyName::where('region_id',$use['region_id'])
    //                    ->where('id','<>',14)
                            ->get();
                            foreach ($party as $key2=>$pa){
                                $obj[$key]['parties'][$key2]['id']=$pa['id'];
                                $obj[$key]['parties'][$key2]['name']=$pa['name'];
                                if($target->party_id==$pa->id && $target->sales_target!=0 && $target->recovery_target!=0)
                                {
                                    $obj[$key]['parties'][$key2]['sales_target']=$target->sales_target;
                                    $obj[$key]['parties'][$key2]['recovery_target']=$target->recovery_target;
    
                                    $obj[$key]['parties'][$key2]['sales_achieved']=Bilti::where('party_id',$pa['id'])
                                    ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                                    ->sum('payment');
                                    $obj[$key]['parties'][$key2]['recovery_achieved']=RsmPayment::where('party_id',$pa['id'])
                                    ->whereBetween('date', [$target->start_date,$target->end_date])
                                    ->sum('amount');
    
                                     $obj[$key]['parties'][$key2]['sale_returns'] =$target->stock_bookings; 
    
                                }
                            }
                        }
                        
                    }
                    
                }
           // return $obj;    
           // $par = $obj;
            }
            
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
}

    //RSM Tree Targets
    public function getallrsmtreetargets(Request $request )
    {
      //  return $request;
        try {
            $coupan_scheme_id = $request->coupan_scheme_id;
    
            $user=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'rsm');
            })
            ->where('id','=',$request->rsm_id)
            ->get();
    
            $targets= RsmTarget::where('rsm_id',$request->rsm_id)->where('coupan_scheme_id',$request->coupan_scheme_id)->get();
    
            $obj= array();
    
            foreach($targets as  $target)
            {
                if(!empty($target)){
                    foreach ($user as $key=>$use){
    
                        $obj[$key]['id']=$use['id'];
                        $obj[$key]['firstname']=$use['firstname'];
                        $obj[$key]['lastname']=$use['lastname'];
                        $obj[$key]['image']=$use['image'];
                        
                        $Asms =User::whereHas('roles', function($query) {
                            $query->where('name', '=', 'asm');
                        })->where('rsm_id',$use['id'])->get();
                        $obj[$key]['asm']=$Asms;
                        
                        foreach($Asms as $key3=>$asm){
                            $Asmtargets= AsmTarget::where('asm_id',$asm->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                            $obj[$key]['asm'][$key3]['asm_target']=$Asmtargets;
                            $obj[$key]['asm'][$key3]['sales_achieved']=Bilti::where('delivered_to_id',$asm->id)
                                ->whereBetween('bilti_date', [$Asmtargets->start_date,$Asmtargets->end_date])
                              ->sum('payment');
                            $obj[$key]['asm'][$key3]['recovery_achieved']=RsmPayment::where('payment_by',$asm->id)
                                ->whereBetween('date', [$Asmtargets->start_date,$Asmtargets->end_date])->sum('amount');
                            $obj[$key]['asm'][$key3]['sale_return']=StockBooking::where('booked_by',$asm->id)->where('type','=','sub_sale_return')->sum('payment');
                            $sub_users= Subdistributor::where('asm_id',$asm->id)->with(['subdistributerTarget'=>function($query)use($coupan_scheme_id){
                                $query->where('coupan_scheme_id',$coupan_scheme_id)->get();
                            }])->get();
                            $obj[$key]['asm'][$key3]['sub_distributer_user']=$sub_users;
                            
                            foreach($sub_users as $key4=>$subdistributor){
                               // return $Asmtargets->start_date;
                                $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['sales_achieved']=Bilti::where('party_id',$subdistributor->id)->where('po_no_rsm','>','0')
                                        ->whereBetween('bilti_date', [$Asmtargets->start_date,$Asmtargets->end_date])->sum('payment');
                                $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['recovery_achieved']=RsmPayment::where('sub_id',$subdistributor->id)
                                        ->whereBetween('date', [$Asmtargets->start_date,$Asmtargets->end_date])
                                      ->sum('amount');
                                $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['sale_return']=StockBooking::where('party_id',$subdistributor->id)->where('type','=','sub_sale_return')->sum('payment');
                              ///  return $subdistributor;
                                $dsfs=User::whereHas('roles', function($query) {
                                    $query->where('name', '=', 'dsf');
                                })->where('subdistributer_id','=',$subdistributor->id)->get();
                                $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'] = $dsfs;
                                foreach($dsfs as $key5=>$dsf){
                                    $dsftargets= DsfTarget::where('dsf_id',$dsf->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
                                    $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'][$key5]['dsf_target'] = $dsftargets;
                                    $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'][$key5]['sales_achieved']=UserExpenseDetail::where('user_id',$dsftargets->dsf_id)->where('type','dsf_sale')->orwhere('type','shop_sale')
                                        ->whereBetween('date', [$dsftargets->start_date,$dsftargets->end_date])
                                      ->sum('amount');
                                    $obj[$key]['asm'][$key3]['sub_distributer_user'][$key4]['dsf_user'][$key5]['recovery_achieved']=UserExpenseDetail::where('user_id',$dsftargets->dsf_id)->where('type','dsf_recovery')->orwhere('type','shop_recovery')
                                        ->whereBetween('date', [$dsftargets->start_date,$dsftargets->end_date])
                                      ->sum('amount');
                                    
                                }
                                
                            }
                        }
                        
                        //
                        if(!empty($use) && !empty($use['region_id'])){
    
                            $party= PartyName::where('region_id',$use['region_id'])
    //                    ->where('id','<>',14)
                            ->get();
                            foreach ($party as $key2=>$pa){
                                $obj[$key]['parties'][$key2]['id']=$pa['id'];
                                $obj[$key]['parties'][$key2]['name']=$pa['name'];
                                if($target->party_id==$pa->id && $target->sales_target!=0 && $target->recovery_target!=0)
                                {
                                    $obj[$key]['parties'][$key2]['sales_target']=$target->sales_target;
                                    $obj[$key]['parties'][$key2]['recovery_target']=$target->recovery_target;
    
                                    $obj[$key]['parties'][$key2]['sales_achieved']=Bilti::where('party_id',$pa['id'])
                                    ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                                    ->sum('payment');
                                    $obj[$key]['parties'][$key2]['recovery_achieved']=RsmPayment::where('party_id',$pa['id'])
                                    ->whereBetween('date', [$target->start_date,$target->end_date])
                                    ->sum('amount');
    
                                     $obj[$key]['parties'][$key2]['sale_returns'] =$target->stock_bookings; 
    
                                }
                            }
                        }
                        //
                    }
                }
                
            }
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
}

    public function getSubdistributorsByAseAndTargets(Request $request){
        try {
        $obj= array();    
        $aseList = User::whereHas('roles', function($query) {
            $query->where('name', '=', 'ase');
        })->where('id',$request->user_id)->get();
                         
       // return $aseList;
            $users   = Subdistributor::where('ase_id',$request->user_id)->get()->toArray();
            foreach($users as $key=>$user){
                $obj[$key]['subdistributor']=$user;
                $obj[$key]['subdistributor']['distributor_target']= DistributorTarget::where('sub_distributor_id',$user['id'])->first();
                $start_date = $obj[$key]['subdistributor']['distributor_target']->start_date;
                $end_date = $obj[$key]['subdistributor']['distributor_target']->end_date;
                $obj[$key]['subdistributor']['recovery_achieved']=RsmPayment::where('sub_id',$user['id'])
                    ->whereBetween('date', [$start_date,$end_date])
                  ->sum('amount');
                $obj[$key]['subdistributor']['sales_achieved']=Bilti::where('party_id',$user['id'])->where('po_no_rsm','>','0')
                    ->whereBetween('bilti_date', [$start_date,$end_date])
                  ->sum('payment');  
                $obj[$key]['subdistributor']['sale_return']=StockBooking::where('party_id',$user['id'])->where('type','=','sub_sale_return')->sum('payment');  
            }
            
           // return $user;
            
        /*    $dsf=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'dsf');
                })->where('subdistributer_id','=',$request->sub_distributor_id)->get()->toArray();
         //   return $user;    
            
            $obj['sub_distributor_user']=array();
               //  $obj['dsf_list'][$key1]['list'] = $user;
                 $targets= DistributorTarget::where('sub_distributor_id',$user->id)->where('coupan_scheme_id',$request->coupan_scheme_id)->first();
               //  return $targets;
                 $obj['sub_distributor_user']['id'] = $user->id;
                 $obj['sub_distributor_user']['name']=$user->name;
                // $obj['asm_list'][$key1]['lastname']=$user->lastname;
                $obj['sub_distributor_user']['dsf']=$dsf;
                $obj['sub_distributor_user']['target']=$targets;
                $obj['sub_distributor_user']['sales_achieved']=Bilti::where('party_id',$user->id)->where('po_no_rsm','>','0')
                    ->whereBetween('bilti_date', [$targets->start_date,$targets->end_date])
                  ->sum('payment');
                $obj['sub_distributor_user']['recovery_achieved']=RsmPayment::where('sub_id',$user->id)
                    ->whereBetween('date', [$targets->start_date,$targets->end_date])
                  ->sum('amount');
                $obj['sub_distributor_user']['sale_return']=StockBooking::where('party_id',$user->id)->where('type','=','sub_sale_return')->sum('payment'); */
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
            
    }

}
?>