<?php

namespace App\Http\Controllers;

use App\Agency;
use App\Models\TargetPoint;
use App\Models\User;
use App\Models\Token;
use Dingo\Api\Facade\API;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\Subdistributor;
use Validator;
use DB;

use Illuminate\Support\Facades\Hash;

class AuthController extends BaseController
{
    /***
     * Login User
     *
     * @return mixed
     */
    public function changePassword(Request $request)
{

    $user = User::where('id',$request->user_id)->first();
     $validator = \Validator::make($this->input, $user->validationRulesuserunique());

        if ($validator->fails()) {
            return API::response()->array(['success' => false,'error' => 'Required parameters are missing or incorrect!','message' => $validator->errors()->first()], 400);
        }else{


        
    $username = $request->username;
  
    $new_password = $request->new_password;
      $password2 = $request->new_password;

    if (empty($username) || empty($new_password)) {
        return API::response()->array(['success' => false,
            'message' => 'Required parameters username or password missing!',
            'error' => 'Login Failed, Please try again later!'], 400);
    }
    $userModel = new User();
//       $user = User::where('username',$username)->first();
    $user = $userModel->getUserInfoWithAreas(['username' => $username]);

    $flag = 1;



    if($flag)
    {
        
        $new_password=Hash::make($new_password);
      
        $use = User::where('id',$request->user_id)->first();
        $use->username = $request->username;
          $use->password = $new_password;

            $use->password2 = $password2;
            
            $use->save(); 
        return API::response()->array(['success' => true,], 200);

    }
    else{
        return API::response()->array(['success' => false,], 200);
    }

}
}


    
    public function login()
    {

        $username = $this->getParam('username');
        $password = $this->getParam('password');
        if (empty($username) || empty($password)) {
            return API::response()->array(['success' => false,
                                           'message' => 'Required parameters username or password missing!',
                                            'error' => 'Login Failed, Please try again later!'], 400);
        }
        $userModel = new User();
//        $user = User::where('username',$username)->first();
        $user = $userModel->getUserInfoWithAreas(['username' => $username]);
//        $agency = \App\Models\Agency::where('id',$user->agency_id)->first();
//        if($agency->status != 1){
//            return API::response()->array(['success' => false,
//                'message' => 'Agency Inactive',
//                'error' => 'Login Failed, Please contact admin!'], 400);
//        }
//        $user = $userModel->getUserInfoWithRegions(['username' => $username]);
        if (!empty($user)) {
            $flag = (Hash::check($password, $user->password));
            if ($flag) {
                $token = DB::table('user_tokens')->select(['token'])->where('user_id',$user->id)->first();
                $userHolidays = DB::table('user_holidays')->where('user_id',$user->id)->get();
                if (!empty($token->token)) {
//                if (!empty($user->tokens) && $user->tokens->count() > 0) {
                    $token = $token->token;
                } else {
                    $token = $this->gen_uuid();
                    $obj = new Token();

                    $obj->token = $token;
                    $obj->user_id = $user->id;
                    $obj->status = 'active';
                    $obj->issue_date = Carbon::now();
                    $obj->save();

                }
                unset($user->password);
                unset($user->remember_token);
                unset($user->tokens);
                $target_points=TargetPoint::all();
                return API::response()->array(['success' => true, 'data' =>
                                              ['token' => $token,'holidays' => $userHolidays, 'user' => $user,'target_points'=>$target_points]], 200);

            }
            return API::response()->array(['success' => false,
                                           'message' => 'Invalid Credentials',
                                           'error' => 'Login Failed, Please try again later!'], 400);
        } else {
            return API::response()->array(['success' => false,
                                           'message' => 'User Not Registered',
                                            'error' => 'Login Failed, Please try again later!'], 400);
        }
    }
    /**
     * Register a User
     *
     */
    public function register(Request $request)
    {
        $user = new User();
        $validator = \Validator::make($this->input, $user->validationRules());

        if ($validator->fails()) {
            return API::response()->array(['success' => false,'error' => 'Required parameters are missing or incorrect!','message' => $validator->errors()->first()], 400);
        }else{
            $user = new User();
            $result = $user->registerUser($this->input);

            if($result){
                $token = $this->gen_uuid ();
                $obj = new Token();

                $obj->token = $token;
                $obj->user_id = $result->id;
                $obj->status = 'active';
                $obj->issue_date = Carbon::now ();
                $obj->save ();
                unset( $user->password );
                unset( $user->remember_token );
                unset( $user->tokens );

                $returnUser = User::where('id', $user->id)->first(['id','username','firstname',
                                                                    'lastname', 'email',
                                                                   'profile_image', 'reset_token']);


                return API::response ()->array ( [ 'success' => true, 'data' => [ 'token' => $token, 'user' => $returnUser ] ], 200 );
            }else{
                return API::response()->array(['success' => false,'message' => 'User registration failed!','error' => ['1010' => 'User registration failed!']], 400);
            }
        }
    }
    
  /* asm models */

  public function addASMUser(Request $request)
    {
         try {

                $rsmid = $this->getUserIdFromToken($request);
            
        $new=false;
        if($request['email']) {

            $user = User::where('email', '=', $request['email'])->first();

            
        }

        if(is_null($user)) {
            $validator = Validator::make($request->all(), [
            'username'  => 'required|unique:users,username',
            'name' => 'required|string|max:255',
            'phone' => 'required|string|max:255',
            'email' => 'unique:users,email',
            'password' => 'required',
            
        ]);   
        if ($validator->fails()) {
            return API::response()->array(['success' => false,'error' => 'Required parameters are missing or incorrect!','message' => $validator->errors()->first()], 400);
    
        }

            $new=true;
            $user = new User();
            
        }

        $splitName = split_name($request['name']);
        if(count($splitName) > 1) {

            $user->firstname = $splitName[0];
            $user->lastname  = $splitName[1];
        }
        
        $user->address  =  $request['address'];
        $user->phone_1  =  $request['phone_1'];
        $user->email = $request['email'];
        $user->party_id = $request['party_id'];
        $user->password = Hash::make($request['password']);
        $user->username = $request['username'];
        $user->agency_id = 1;
        $user->country_id = 1;
        $user->rsm_id = $rsmid;
        if($request->image){

         $image = upload_base64_image($request->image, 'uploads/asmuser/',
                    'image-');
        }
        $user->image = 'http://'.$image;

        $user->save();

        if($new && $new==true){
            $role = \App\Models\Role::findOrFail(3);
            $user = User::findOrFail($user->id);
            $user->attachRole($role);
        }
        if($new==true){
                $obj = new Token();
                $obj->token = generate_uuid();
                $obj->user_id = $user->id;
                $obj->status = 'active';
                $obj->issue_date = Carbon::now ();
                $obj->save ();
                $token = $obj->token;
            }else{

                $token = Token::where('user_id',$user->id)->first();
                $token =$token->token;
                
            }
        $returnUser = User::where('id', $user->id)->first(['id','username','firstname',
                                                                    'lastname', 'email',
                                                                   'image', 'reset_token']);

                return API::response ()->array ( [ 'success' => true, 'data' => [ 'token' => $token, 'user' => $returnUser ] ], 200 );
    

     }catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
   }

public function adddsfUser(Request $request)
    {
         try {

          
        $new=false;
        if($request['email']) {

            $user = User::where('email', '=', $request['email'])->first();

            
        }

        if(is_null($user)) {
            $validator = Validator::make($request->all(), [
            'username'  => 'required|unique:users,username',
            'firstname' => 'required|string|max:255',
            'phone' => 'required|string|max:255',
            'password' => 'required',
            
        ]);   
        if ($validator->fails()) {
            return API::response()->array(['success' => false,'error' => 'Required parameters are missing or incorrect!','message' => $validator->errors()->first()], 400);
    
        }

           
            
        }
         $sub  = Subdistributor::where('id',$request->subdistributer_id)->first();
         if($sub){
          $asm_id  = $sub->asm_id;
          $rsm_id   =  $sub->rsm_id;
          $party_id = $sub->party_id;
     }

           $new=true;
            $user = new User();

            $user->firstname = $request->firstname;
            $user->lastname  = $request->lastname;
       
            
        $user->address  =  $request->address;

        $user->phone_1  =  $request->phone;
        $user->subdistributer_id = $request->subdistributer_id;
        $user->party_id = $party_id;
        $user->password2 = $request->password;
        $user->password = Hash::make($request->password);
        $user->username = $request->username;
          $user->opening_balance = $request->opening_balance;
         $user->balance = $request->opening_balance;
        $user->agency_id = 1;
        $user->country_id = 1;
        $user->rsm_id = $rsm_id;
        $user->asm_id = $asm_id;
      
        if($request->image){

         $image = upload_base64_image($request->image, 'uploads/asmuser/',
                    'image-');
           
        }

      $user->image = 'http://'.$image;


        $user->save();
        
            //For stroing Whatsapp Number
      $whatsappPhone = $request->phone;
      $UserName = $request->firstname." ".$request->lastname;
      // Grab the first number. 
        $first_number = substr($whatsappPhone, 0, 1); 
        if ($first_number == 0) {
          // Check if the first number is 0.
          // Get rid of the first number.
          $whatsappPhone = preg_replace('/^0?/', '92', $whatsappPhone);
        }
      if($whatsappPhone != NULL){
          $obj=array();
          $obj['mobile_no']="$whatsappPhone";
          $obj['name']="$UserName";
          $obj['contact_name']="$UserName";
          $obj['is_active']="1";
          $obj['priority']="0";
          $obj['category']="DSF";
          $obj['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
          header('Content-Type: application/json'); // Specify the type of data
                        
          $ch = curl_init('http://whatsapi.co.uk/api/whatsapi/store'); // Initialise cURL   
                        
          $post = json_encode($obj); // Encode the data array into a JSON string
                        
          curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
          curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
          curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
          curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
          $whatsapp = curl_exec($ch); // Execute the cURL statement
          curl_close($ch); // Close the cURL connection
      }
    //For storeing Whatsapp Number End
      
        
        if($new && $new==true){
            $role = \App\Models\Role::findOrFail(20);
            $user = User::findOrFail($user->id);
             
            $user->attachRole($role);
        }
        if($new==true){
                $obj = new Token();
                $obj->token = generate_uuid();
                $obj->user_id = $user->id;
                $obj->status = 'active';
                $obj->issue_date = Carbon::now ();
                $obj->save ();
                $token = $obj->token;
            }else{

                $token = Token::where('user_id',$user->id)->first();
                $token =$token->token;
                
            }
        $returnUser = User::where('id', $user->id)->first(['id','username','firstname',
                                                                    'lastname', 'email',
                                                                   'image', 'reset_token']);

                return API::response ()->array ( [ 'success' => true, 'data' => [ 'token' => $token, 'user' => $returnUser ] ], 200 );
    

     }catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
   }



}


