<?php

namespace App\Http\Controllers;

use App\Models\CustomerBalanceRecorder;
use App\Models\CustomerBalanceRecorderImage;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\UserExpenseDetail;
use App\Models\PartyName;

use Dingo\Api\Facade\API;

use League\Flysystem\Exception;

class BalanceRecorderController extends Controller
{


    public function addBalanceChange(Request $request)
    {
        try {

           $obj=new CustomerBalanceRecorder();

           $obj->party_id=$request->get('party_id');
           $obj->balance=$request->get('amount');
           $obj->remarks=$request->get('remarks');
            $x= PartyName::where('id', $request->get('party_id'))->first();
             $obj->previous_balance=$x->opening_balance;
 $obj->save();
            if(!empty($request->get('images'))) {
                $images = [];
                foreach($request->get('images') as $image) {
                    $image = upload_base64_image($image, 'uploads/userExpense/',
                        'image-');
                    $customerImage = new CustomerBalanceRecorderImage();
                    $customerImage->image =  'http://'.$image;
                    $customerImage->customer_balance_id=$obj->id;
                    $images[] = $customerImage;
                }
                if(count($images) > 0) {
                    $obj->balance_images()->saveMany($images);
                }
            }
           
        $x= PartyName::where('id', $request->get('party_id'))
        
        ->update(['opening_balance'=>$request->get('amount')]);


if($x==1){
    $obj=PartyName::where('id',$request->get('party_id'))->with(['party_ledger'=>function($query){$query->orderBy('date', 'ASC');}])->first();
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
                if(!empty($update)){
                    switch ($update['type']){
                        case 'Sale':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Recovery':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Credit Note':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                }
                $update->save();
            }
            $obj->balance=$opening;
            $obj->save();
        }
}


            return API::response()->array(['success' => true,
                'message' => 'Balance Updated',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function GetCutomerBalance(Request $request)
    {
        try {

           $obj= CustomerBalanceRecorder::where('party_id',$request->get('party_id'))->orderBy('created_at', 'ASC')->with(['party_info','balance_images'])->get();



            return API::response()->array(['success' => true,
                'message' => 'Balance Retrirved',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }




}
