<?php
namespace App\Http\Controllers;
use App\Models\Account;
use App\Models\Bilti;
use App\Models\BiltiDetail;
use App\Models\InventoryReport;
use App\Models\BiltyImage;
use App\Models\BiltiDetialType;
use App\Models\Region;
use App\Models\AsmSchedule;
use App\Models\Customer;
use App\Models\UserFixedExpense;
use App\Models\Expense;
use App\Models\ExpenseTag;
use App\Models\StockBooking;
use App\Models\StockImage;
use App\Models\StockbookingImage;
use App\Models\StockBookingDetail;
use App\Models\SubdistributorRates;
use App\Models\StockBookingDetailCategory;
use App\Models\Product;
use App\Models\ProductPrice;
use App\Models\PartyRates;
use App\Models\Order;
use App\Models\PartyName;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\RsmPayment;
use App\Models\RsmPaymentImage;
use App\Models\SupplierSo;
use App\Models\Target;
use App\Models\RsmTarget;
use App\Models\CoupanScheme;
use App\Models\TargetDetail;
use App\Models\User;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\UserExpenseDetailsledger;
use App\Models\UserPoint;
use App\Models\PaymentRemark;
use App\Models\PointSystem;
use App\Models\Visit;
use App\Models\VisitDetail;
use App\Models\Subdistributor;
use App\Models\CashAdjustmentLog;
use App\Models\BalanceAdjustmentImage;
use App\Models\SoStock;
use App\Models\StockSubdistributer;
use App\Models\StockDetailSubdistributer;
use App\Models\StockProductAdjustment; 
use App\Models\Transferpayment;
use App\Models\DsfArea;
use App\Models\DsfBookingNumber;
use App\Models\DsfShop;
use App\Models\DsfPayment;
use App\Models\DsfShopImage;
use App\Models\Vouchers;
use App\Models\ProductDiscountDsfShops;
use App\Models\Sdvisitopeningstock; //
use App\Models\Sdopeningstockdetails; //
use App\Models\Sdopeningstockdetailcategory; //
use App\Models\UserPointTrail; //
use Carbon\Carbon;
use Carbon\CarbonPeriod;
use DateTime;
use DatePeriod;
use DateInterval;
use Dingo\Api\Facade\API;
use League\Flysystem\Exception;
use Illuminate\Http\Request;
use Edujugon\PushNotification\PushNotification;
use App\Models\PushNotificationToken;
use DB;
use PhpParser\Node\Expr\AssignOp\Concat;
use Illuminate\Support\Str;
class DsfController extends BaseController
{



  private $_dsfModel;

    /***
     * Constructor
     *
     * @param $request
     * @param User $userModel
     */
    public function __construct(Request $request, DsfArea $dsfModel)
    {
    	set_time_limit(8000000);
      parent::__construct($request);
      $this->_dsfModel = $dsfModel;
    }

    public function getdsflistbyasmid(Request $request){


    	try{
    		$asm_id = $request->asm_id;
        $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('asm_id','=',$asm_id)->with(['Subdistributor_info'])->get();
        return API::response()->array(['success' => true, 'message' => 'All DSF list in Asm',
          'data' => $users], 200);

      }catch (Exception $e) {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }


    }
    public function getdsflist(Request $request){


      try{
     
        $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->get();
        return API::response()->array(['success' => true, 'message' => 'All DSF list',
          'data' => $users], 200);

      }catch (Exception $e) {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }


    }
    
    //usman
        public function storedsfexpenses(Request $request){
        
        try{
          
            
            
         $exist  =  UserFixedExpense::where('user_id', $request->user_id)->first();
                
         if($exist){

             
           $dsfexpenses = UserFixedExpense::where('user_id', $request->user_id)->first();

         $dsfexpenses->basic_salary = $request->basic_salary;
         $dsfexpenses->attendence_allownce = $request->attendence_allowance;
         $dsfexpenses->mobile_allownce = $request->mobile_allowance;
         $dsfexpenses->car_maintenance = $request->car_maintenance;
         $dsfexpenses->ta_per_day = $request->ta_per_day;
         $dsfexpenses->ta_per_km = $request->ta_per_km;
         $dsfexpenses->da_per_day = $request->da_per_day;
         $dsfexpenses->daily_allownce = $request->daily_allowance;
        
         $dsfexpenses->save();

              


         }else{

         	 $newdsfexpenses = new UserFixedExpense();
          $newdsfexpenses->user_id = $request->user_id;     
         $newdsfexpenses->basic_salary = $request->basic_salary;
         $newdsfexpenses->attendence_allownce = $request->attendence_allowance;
         $newdsfexpenses->mobile_allownce = $request->mobile_allowance;
         $newdsfexpenses->car_maintenance = $request->car_maintenance;
         $newdsfexpenses->ta_per_day = $request->ta_per_day;
         $newdsfexpenses->ta_per_km = $request->ta_per_km;
         $newdsfexpenses->da_per_day = $request->da_per_day;
         $newdsfexpenses->daily_allownce = $request->daily_allowance;
        

         $newdsfexpenses->save();
         }

        //  }
         
               
         return API::response()->array(['success' => true, 'message' => 'Added',
            'data' => null], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        
    }

///// dsf sale & recovery ///// 

  public function dsfsaleRecovery(Request $request)
    {
        try {
           $start=$request->start_date;
           $end=$request->end_date;

$period = getDatesFromRange($start, $end);

  


           $dsf_user = $request->user_id;
           $obj3 =[]; 
           $obj4 =[]; 
           $dsf = DsfShop::select('id')->where('dsf_id',$dsf_user)->get()->toArray();
          
            $obj= StockBooking::select(DB::raw('party_id,sum(payment) as sale_amount,sum(total_points) as points,booked_by,date'))
           ->wherein('party_id',$dsf)
           ->where('party_check','=','dsf')->wherebetween('date',[$start,$end])
           ->groupBy('date','type')
           ->orderBy('date', 'ASC')
           ->get();

             $obj2 = UserExpenseDetailsledger::select(DB::raw('sum(amount) as recovery_amount,date'))
            ->where('type','shop_recovery')->where('is_raw',0)->where('user_id',$dsf_user)
            ->wherein('party_id',$dsf)->wherebetween('date',[$start,$end])
            ->groupBy('date','type')
             ->orderBy('date', 'ASC')
             ->get();
            
            
          foreach ($obj as $key => $val) {
              
              if($obj2){
            if($val['date'] == $obj2[$key]['date']){

                  $obj3[$key]['date'] = $val['date'];
                  
                  $obj3[$key]['sale_amount'] = $val['sale_amount'];
                    $obj3[$key]['points'] = $val['points'];
                  $obj3[$key]['booked_by'] = $val['booked_by'];

                  $obj3[$key]['shop_recovery'] = $obj2[$key]['recovery_amount'];
             

            }
            else{
                  $obj3[$key]['date'] = $val['date'];
                  $obj3[$key]['sale_amount'] = $val['sale_amount'];
                   $obj3[$key]['points'] = $val['points'];
                  $obj3[$key]['booked_by'] = $val['booked_by'];
                  $obj3[$key]['shop_recovery'] = 0;

            }
            } 
         
          }
          
        
          //foreach ($obj3 as $key => $val) {
            //return $val['date'];
          
          // Iterate over the period
    $i = 0;
foreach ($period as $key1 => $date) {
         
    foreach($obj3 as $key2 => $data ){
  
          if( $data['date'] == $date){

                             $obj4[$key1]['date'] = $date;
                  
                    $obj4[$key1]['sale_amount'] =  $obj3[$key2]['sale_amount'];
                    $obj4[$key1]['points'] =  $obj3[$key2]['points'];
                    $obj4[$key1]['booked_by'] =  $obj3[$key2]['booked_by'];

                  $obj4[$key1]['shop_recovery'] = $obj2[$key2]['recovery_amount'];
                  $i = 1;
          }
         
    }
    if($i == 0){
                    
                  $obj4[$key1]['date'] = $date;
                  
                    $obj4[$key1]['sale_amount'] =  0;
                    $obj4[$key1]['points'] =  0;
                    $obj4[$key1]['booked_by'] =  0;
                  $obj4[$key1]['shop_recovery'] = 0;
                  
                  

         
    }
     $i= 0;
        }
     //
     
           
       } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Dsf Sale & Recovery',
        'data' => $obj4], 200);
}


    public function OpeningStockSubdistributer(Request $request){

      try{
    //$request->sub_id;





       $sub_id=Subdistributor::where('id',$request->sub_id)->first();



       if($sub_id){

        $party=PartyName::where('id',$sub_id->party_id)->first();


        foreach ($request->products as $stock){


         $cot=Product::where('id',$stock['product_id'])->first();

         if($cot){
          $quantity =  $stock['quantity'];
          $obj=new StockSubdistributer();

          $obj->so_id=$request->sub_id;
          $obj->product_id=$stock['product_id'];
          $obj->qty=$quantity;
          $obj->opening_qty= $quantity;

          $cost=$this->CalculateInvoice($stock['product_id'],0,$stock['quantity'],'Distributor');

          $obj->price=$cost;
          if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){
            $obj->discount=$party->discount;
            $obj->payment=$cost-(($cost*$party->discount)/100);

          }else{
            $obj->discount=0;
            $obj->payment=$cost;
          }

          $obj->save();

          $so_stock_detail  = new StockDetailSubdistributer();
          $so_stock_detail->so_id = $request->sub_id;
          $so_stock_detail->product_id = $stock['product_id'];
          $so_stock_detail->stock_in = $quantity;
          $so_stock_detail->total_stock = $quantity;
          $so_stock_detail->date = date("Y-m-d");
          $so_stock_detail->save();




        }

        if(count($stock['product_category'])>0){

          foreach($stock['product_category'] as $product_category){

            $catquantity =  $product_category['quantity'];

            $obj1=new StockSubdistributer();

            $obj1->so_id=$request->sub_id;
            $obj1->product_id=$stock['product_id'];
            $obj1->product_category_id =$product_category['product_category_id'];
            $obj1->qty=$catquantity;
            $obj1->opening_qty= $catquantity; 

            $cost2=$this->CalculateInvoice($stock['product_id'],0,$product_category['quantity'],'Distributor');

            $obj1->price=$cost2;
            if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){
              $obj1->discount=$party->discount;
              $obj1->payment=$cost2-(($cost2*$party->discount)/100);

            }else{
              $obj1->discount=0;
              $obj1->payment=$cost2;
            }
            $obj1->save();

            $so_stock_detail  = new StockDetailSubdistributer();
            $so_stock_detail->so_id = $request->sub_id;
            $so_stock_detail->product_id = $stock['product_id'];
            $so_stock_detail->product_category_id = $product_category['product_category_id'];
            $so_stock_detail->stock_in = $catquantity;
            $so_stock_detail->total_stock = $catquantity;
            $so_stock_detail->date = date("Y-m-d");
            $so_stock_detail->save();

          }

        }

      }

      $sub_id->has_dsf = 1;
      $sub_id->save();

    
     if (!empty($request->uploadimages)) {
        $images = [];
        foreach ($request->uploadimages as $image) {
         $image = upload_base64_image($image, 'uploads/stock/',
          'image-');
         $dsfshopimage  =   new  StockImage();
         $dsfshopimage->so_stock_id = $obj->id;
         $dsfshopimage->type = "subdistributer_stock";
         $dsfshopimage->image_url = 'http://' . $image;
         $dsfshopimage->save();


       }

     }

    }


    return API::response()->array(['success' => true, 'message' => 'Opening stock successfully entered'], 200);

  }
  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }

}

public function GetOpeningStockSubdistributer(Request $request){

  try{


    $obj1= StockSubdistributer::where('so_id',$request->sub_id)->with(['stock_product','stock_product_category','stock_images'])->get();



    return API::response()->array(['success' => true, 'message'=>'get opening stock subdistributer',
      'data' => $obj1], 200);

  }
  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }

}

public function CalculateInvoice($product_id,$quantity,$type){
  switch ($type){
    case 'Distributor':
    $p= ProductPrice::where('product_id',$product_id)->first();
    if(!empty($p) && !empty($p->distributor_price)){
      return $p->distributor_price * $quantity;
    }
    break;
    default:
    return 0;
  }
}
public function CalculateExportInvoice($product_id,$quantity,$party_id){
  $p= PartyRates::where('product_id',$product_id)
  ->where('party_id',$party_id)->first();
  if(!empty($p)){
    return $p->price * $quantity;
  }else{
    return 0;


  }

}

public function subdistributerstockreport(Request $request){

  try{

    if($request->product_category_id == 0){

     $SoStockDetails = StockDetailSubdistributer::where(['so_id' => $request->sub_id,'product_id'=>$request->product_id])->whereBetween('date', [$request->start_date, $request->end_date])->orderBy('id', 'ASC')->get();
   }else{

    $SoStockDetails = StockDetailSubdistributer::where(['so_id' => $request->sub_id,'product_id'=>$request->product_id,'product_category_id'=>$request->product_category_id])->whereBetween('date', [$request->start_date, $request->end_date])->orderBy('id', 'ASC')->get();

  }


  if(!empty($SoStockDetails)){
    $opening_stock=0;
    foreach ($SoStockDetails as $key=>$SoStockDetail){
      $update=\App\Models\StockDetailSubdistributer::where('id',$SoStockDetail['id'])->first();


      if(!empty($update)){
        if($update->stock_in > 0){


          $opening_stock=$opening_stock+$update->stock_in;
          $update->total_stock=$opening_stock;
          $update->save();

        }
        if($update->sale_return_dsf > 0){

          $opening_stock=$opening_stock+$update->sale_return_dsf;
          $update->total_stock=$opening_stock;
          $update->save();

        }
        if($update->stock_out > 0){

          $opening_stock=$opening_stock-$update->stock_out;
          $update->total_stock=$opening_stock;
          $update->save();

        }
        if($update->sale_return_subdistributer > 0){

          $opening_stock=$opening_stock-$update->sale_return_subdistributer;
          $update->total_stock=$opening_stock;
          $update->save();

        }


      }
      $update->save();
    }
    return $opening_stock;
  }


  if($request->product_category_id == 0){

   $SoStockReports = StockDetailSubdistributer::where(['so_id' => $request->sub_id,'product_id'=>$request->product_id])->whereBetween('date', [$request->start_date, $request->end_date])->orderBy('id', 'ASC')->get();
 }else{
  $SoStockReports = StockDetailSubdistributer::where(['so_id' => $request->sub_id,'product_id'=>$request->product_id,'product_category_id'=>$request->product_category_id])->whereBetween('date', [$request->start_date, $request->end_date])->orderBy('id', 'ASC')->get();

}




if(empty($SoStockReports)){
 return API::response()->array(['success' => true,
  'message' => 'Record not found'], 200);

}
return API::response()->array(['success' => true,
  'message' => 'User Stock details',
  'data'    => $SoStockReports], 200);

} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}

//// add or get areas ////

public function addorupdatedsfareas(Request $request){

 try{ 
  if($request->id == 0){
    $user = User::where('id',$request->user_id)->first();
    $area          = new DsfArea();
    $area->user_id =$request->user_id;
    $area->sub_id =$user->subdistributer_id;
    $area->name    =$request->name;
    $area->save();

    return API::response()->array(['success' => true, 'message' => 'Area  successfully added'], 200);
  }
  if($request->id != 0)

    $area    = DsfArea::where('id',$request->id)->first();
  if($area){
    $area->name =$request->name;
    $area->save();

    return API::response()->array(['success' => true, 'message' => 'Area  successfully updated'], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }

}
catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}
///

public function getdsfareas(Request $request){

 try{ 

  $area    = DsfArea::where('user_id',$request->user_id)->get();
  if($area){


    return API::response()->array(['success' => true,
      'message' => 'Dsf area lists',
      'data'    => $area], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}
public function deletedsfareas(Request $request){

 try{ 

  $area    = DsfArea::where('id',$request->id)->first();
  if($area){

    $area->delete();
    return API::response()->array(['success' => true, 'message' => 'Area has been successfully deleted'], 404);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}


/////dsf shops and shops images ////

public function CreateUpdateShop(Request $request){

  try {


   $userId = $this->getUserIdFromToken($request);
   $role  =  $this->getUserRole($userId);

   if($role == 'dsf'){

    if($request->id == 0){
      $user = User::where('id',$request->user_id)->first();
      $asm_id  = $user->asm_id;

      $dsfshop  =   new  DsfShop();
      $dsfshop->shop_name = $request->shop_name;

      if(!empty($request->area_id)){
      $dsfshop->area_id = $request->area_id;
    }else{
      return API::response()->array(['success' => false,
  'message' => 'please select area '], 404);

    }

         $getshopphoneno  =  Dsfshop::select('whatsapp_ph','shop_name')->get()->toArray();

      foreach ($getshopphoneno as $key => $value) {


        if(in_array($request->phone, $value))
{
  return API::response()->array(['success' => false,
  'message' => 'This number already attached with'. " " .$value['shop_name']], 404);


}
      }
    
      $dsfshop->address = $request->address;
      $dsfshop->phone = $request->phone;
      $dsfshop->whatsapp_ph = $request->whatsapp_ph;
      $dsfshop->oppening_balance = $request->opening_balance;
      $dsfshop->balance = $request->opening_balance;
      $dsfshop->discount = $request->discount;
      $dsfshop->shopkeeper_name = $request->shopkeeper_name;
      $dsfshop->asm_id = $asm_id;
      $dsfshop->dsf_id = $request->user_id;
      $dsfshop->sub_id = $user->subdistributer_id;
      $dsfshop->rsm_id = $user->rsm_id;
       $dsfshop->oppening_balance_status = 1;

      $dsfshop->save();


      if (!empty($request->uploadimages)) {
        $images = [];
        foreach ($request->uploadimages as $image) {
         $image = upload_base64_image($image, 'uploads/shop/',
          'image-');
         $dsfshopimage  =   new  DsfShopImage();
         $dsfshopimage->dsf_shop_id = $dsfshop->id;
         $dsfshopimage->image_url = 'http://' . $image;
         $dsfshopimage->save();


       }

     }
     
   }
   if($request->id != 0){
   

    $dsfshop  =  DsfShop::where('id',$request->id)->first();
    $dsfshop->shop_name = $request->shop_name;
    $dsfshop->address = $request->address;
     $dsfshop->area_id = $request->area_id;
     
     
         $getshopphoneno  =  Dsfshop::select('whatsapp_ph','shop_name')->get()->toArray();

      foreach ($getshopphoneno as $key => $value) {


        if(in_array($request->phone, $value))
{
  return API::response()->array(['success' => false,
  'message' => 'This number already attached with'. " " .$value['shop_name']], 404);


}
      }
      
    $dsfshop->phone = $request->phone;
       $dsfshop->oppening_balance = $request->opening_balance;
    $dsfshop->whatsapp_ph = $request->whatsapp_ph;
    $dsfshop->shopkeeper_name = $request->shopkeeper_name;
    $dsfshop->discount = $request->discount;
    $dsfshop->save();

    
    if (!empty($request->uploadimages)) {
      $images = [];
      foreach ($request->uploadimages as $image) {
       $image = upload_base64_image($image, 'uploads/shop/',
        'image-');
       $dsfshopimage  =   new  DsfShopImage();
       $dsfshopimage->dsf_shop_id = $dsfshop->id;
       $dsfshopimage->image_url = 'http://' . $image;
       $dsfshopimage->save();


     }

   }

 }
}
else{
 return API::response()->array(['success' => false,
  'message' => 'please login to dsf user'], 404);

}


return API::response()->array(['success' => true,
  'message' => 'dsf shop added Sucessfully'], 200);
} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

public function addcategoryofshops(Request $request){

 try{ 

     $dsfshop  =  DsfShop::where('id',$request->id)->first();
  if($dsfshop){

     $dsfshop->type = $request->type;
     $dsfshop->grade = $request->grade;
     $dsfshop->save();

    return API::response()->array(['success' => true,
      'message' => 'Dsf area lists',
      'data'    => $dsfshop], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}

public function ListShopbydsf(Request $request){

  try{ 

      
      $data = [];
      $user_dsf = [];
    if($request->user_id == 0 ){

      $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->get();

          foreach ($users as $key => $val) {
    

             $user_dsf[] = $val->subdistributer_id;
              
            
             

          }
      
     $dsfshops    = DsfShop::whereIn('sub_id',$user_dsf)->with('shop_images','area')->get();
     foreach ($dsfshops as $key => $dsfshop) {
            $data[$key] = $dsfshop;
          
   
    }
    
    }
   
  
    else{

    $dsfshops    = DsfShop::where('dsf_id',$request->user_id)->with('shop_images','area')->get();
   
      foreach ($dsfshops as $key => $dsfshop) {
            $data[$key] = $dsfshop;
          

    }

    }
    if($data){


      return API::response()->array(['success' => true,
        'message' => 'Dsf shop lists',
        'data'    => $data], 200);
    }
    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}
public function Show_Shopdetail(Request $request){

 try{ 

  $dsfshop    = DsfShop::where('id',$request->id)->with('shop_images','area')->first();

  if($dsfshop){
     return API::response()->array(['success' => true,
      'message' => 'Dsf shops details ',
      'data'    => $dsfshop], 200);
  }
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}


public function DeleteShop(Request $request){

 try{ 

  $dsfshop    = DsfShop::where('id',$request->id)->first();

  if($dsfshop){

   $order =StockBooking::where('party_id',$dsfshop->id)->where('party_check','dsf')->first();

   if(empty($order)){

    $shop  = $dsfshop->shop_images;

    if($shop){

      foreach($shop as $img) {

        $fileToUnlink = public_path() . '/uploads/shop/' .
        get_filename_url($img);
        if (file_exists($fileToUnlink)) {
          unlink($fileToUnlink);
        }
        $img->delete();
      }

    }
    $dsfshop->delete();

    return API::response()->array(['success' => true, 'message' => 'Dsfshop has been successfully deleted'], 404);
  }
  else{
    return API::response()->array(['success' => false, 'message' => 'DsfShop Cannot be deleted'], 404);
  }
}
  else{

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

  }
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}


}


public function deletestockBookingCottondsf(Request $request){
  try {


    $validator = \Validator::make($request->all(),['stock_booking_id'=>'required|not_in:0']);
    if ($validator->fails()) {
      return API::response()->array(['success' => false,
        'error'   => 'Required parameters are missing or incorrect!',
        'error_message' => $validator->errors()], 400);
    }else{



      $get_total_points = 0;
      $StockBooking = StockBooking::where('id',$request->stock_booking_id)->first();

      if($StockBooking){
        $dsf=User::where('id',$StockBooking->booked_by)->first();
 
        foreach ($StockBooking->stock_details as $key => $value) {
           
             $get_total_points = $get_total_points + $value->points;
          
            $value->delete();

         } 


      $role = $this->getUserRole($StockBooking->booked_by);

         if($role == 'dsf' || $role == 'ase'){


         $dsf->total_points = $dsf->total_points  - $get_total_points;
         $dsf->save();

         $asm_user = User::where('id',$dsf->asm_id)->first();


         $asm_user->total_points = $asm_user->total_points  - $get_total_points;
         $asm_user->save();

         /// dsf or ase log ///

     $remarks  = getdeletedremarks($dsf->id,$StockBooking->party_id);

  $UserPointTrail = new UserPointTrail();

$UserPointTrail->user_id = $dsf->id;

$UserPointTrail->points =   $get_total_points;

$UserPointTrail->type = "delete_shop_order";

$UserPointTrail->detail_id = $request->stock_booking_id;

$UserPointTrail->total_points = $dsf->total_points;

$UserPointTrail->remarks = $remarks;
$UserPointTrail->save();


/////
 $asm_remarks  = getdeletedremarks($dsf->asm_id,$StockBooking->party_id);


  $UserPointTrail = new UserPointTrail();

$UserPointTrail->user_id = $asm_user->id;

$UserPointTrail->points =   $get_total_points;

$UserPointTrail->type = "delete_shop_order";

$UserPointTrail->detail_id = $request->stock_booking_id;

$UserPointTrail->remarks = $asm_remarks;

$UserPointTrail->total_points = $asm_user->total_points;

$UserPointTrail->save();



         $dsfbookingorder =  DsfBookingNumber::where('stock_booking_id',$request->stock_booking_id)->first();
         if($dsfbookingorder){
         $dsfbookingorder->delete();
         }
         $StockBooking->delete();
    }

    if($role == 'asm'){

         $dsf->total_points = $dsf->total_points  - $get_total_points;
         $dsf->save();

         /// dsf or ase log ///

     $remarks  = getdeletedremarks($dsf->id,$StockBooking->party_id);

  $UserPointTrail = new UserPointTrail();

  $UserPointTrail->user_id = $dsf->id;

  $UserPointTrail->points =   $get_total_points;

  $UserPointTrail->type = "delete_shop_order";

 $UserPointTrail->detail_id = $request->stock_booking_id;

 $UserPointTrail->total_points = $dsf->total_points;

 $UserPointTrail->remarks = $remarks;
 $UserPointTrail->save();

          $dsfbookingorder =  DsfBookingNumber::where('stock_booking_id',$request->stock_booking_id)->first();
          if($dsfbookingorder){
         $dsfbookingorder->delete();
       }
         $StockBooking->delete();
    }



      }else{

         return API::response()->array(['success' => true,
      'message' => 'order not found'], 200);

      }

    

    return API::response()->array(['success' => true,
      'message' => 'delete successfully'], 200);
  }


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}
//////

public function stockBookingCottondsfclone(Request $request){
   // return $request;
  try {


    $validator = \Validator::make($request->all(),['dsf_id'=>'required|not_in:0']);
    if ($validator->fails()) {
      return API::response()->array(['success' => false,
        'error'   => 'Required parameters are missing or incorrect!',
        'error_message' => $validator->errors()], 400);
    }else{


      $dsf=User::where('id',$request->dsf_id)->first();

       $voucher = 0;

      $dsf_accountant = $dsf->Subdistributor_info->sd_accountant_id;
     $subdistributer = $dsf->Subdistributor_info;
     
   
      if($dsf_accountant){
        $sub = Subdistributor::where('id',$subdistributer->id)->first();


        $sub->has_voucher = 1;
        $sub->save();

        $now_date= date("Y-m-d");

        $vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->where('date',$now_date)->first();

        if(empty($vourchers)){


         $get_vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->latest()->first();


         if($get_vourchers){
           $serial_no=$get_vourchers->serial_no + 1;
         }else{
          $serial_no = 1;
        }
        $vourcher  = new Vouchers();
        $vourcher->soul_user_id = $dsf_accountant; 
        $vourcher->serial_no = $serial_no;
        $vourcher->dsf_id = $dsf->id;
        $vourcher->date = date("Y-m-d");

        $vourcher->save();


      }else{

        $vourcher = $vourchers;
      }
    }


      $dis_stoc=new StockBooking();
     
      $dis_stoc->booked_by=$request->dsf_id;
      $dis_stoc->booked_to = $request->asm_id;
      $dis_stoc->booked_to = $request->asm_id;
       if(!empty($request->shop_id)){
      $dis_stoc->party_id = $request->shop_id;
    }else{
      return API::response()->array(['success' => false,
  'message' => 'please select party '], 404);

    }
      $dis_stoc->party_check = "dsf";
      $dis_stoc->date=date("Y-m-d");

      $dis_stoc->remarks=$request->remarks;

      $dis_stoc->status='Booked';

      $dis_stoc->vendor_flag = 0;  
      

     $dis_stoc->save();

                // stock booking adda
      if(!empty($request->get('adda'))){
        foreach ($request->get('adda') as $adda){
          $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
          if(empty($ad)){
            $ad=new StockBookingAdda();
          }
          $ad->vendor_id=$adda['vendor_id'];
          $ad->adda_id=$adda['adda_id'];
            //$ad->save();
        }
      }
      $price=0;
      $total_price=0;
      $get_total_points = 0;

      if(count($request->products)>0){

        foreach ($request->products as $stock){

          $d_stock=new StockBookingDetail();
          $d_stock->stock_booking_id=$dis_stoc->id;
          $d_stock->product_id=$stock['product_id'];

          $cot=Product::where('id',$stock['product_id'])->first();


          if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];

            if($stock['discount_type'] == "percentage" && $stock['unit_price'] == 0){

             

             $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             $dsfshop  =  DsfShop::where('id',$request->shop_id)->first();
             $tp_rate  = $p->distributor_price;

             $cost = $tp_rate*$stock['quantity'];
             $price=$price+$cost;

             $d_stock->price=$cost;
             $d_stock->discount=$dsfshop->discount;
             $d_stock->payment=$cost-(($cost*$dsfshop->discount)/100);

             $total_price=$total_price+($cost-(($cost*$dsfshop->discount)/100));
          
           }

          //// one ////
           if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0 && $stock['customer_tp'] == 0 ){

                
            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
            $tp_rate  = $p->distributor_price;
            
             $cost = $tp_rate*$stock['quantity'];
            
              $price=$price+$cost;

             $d_stock->price=$cost;
            
             $d_stock->discount=$stock['discount'];

             $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

             $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));

             

           }

           if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0 && $stock['customer_tp'] > 0 ){

                
          
            $tp_rate  = $stock['customer_tp'];
            
             $cost = $tp_rate*$stock['quantity'];
            
              $price=$price+$cost;

             $d_stock->price=$cost;
            
             $d_stock->discount=$stock['discount'];

             $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

             $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));

             

           }


           if($stock['discount_type'] == "rupees" && $stock['customer_tp'] == 0){

               
            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             
             $tp_rate  = $p->distributor_price; 

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
             //$d_stock->payment=$cost;
            
             $tp_rate  = $p->distributor_price;

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

              $d_stock->payment=$cost-(($cost*$discount)/100);

               $total_price=$total_price+$cost-(($cost*$discount)/100);


           }

           if($stock['discount_type'] == "rupees" && $stock['customer_tp'] > 0){

               
           
             
             $tp_rate  = $stock['customer_tp'];

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
         
            
             $tp_rate  = $stock['customer_tp'];

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

              $d_stock->payment=$cost-(($cost*$discount)/100);

               $total_price=$total_price+$cost-(($cost*$discount)/100);


           }

        }
     
        if($dsf_accountant){

            $reduce_point_check = $sub->reduce_points;

           $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();


        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
           if($reduce_point_check == 0){
          $get_total_points = $get_total_points + $product_points;
          
          $d_stock->points =  $product_points;
        }
        if($reduce_point_check == 1) {
        
            $product_points = $product_points - (($product_points * 30) / 100);

            $get_total_points = $get_total_points + $product_points;
           
           $d_stock->points =  $product_points;
        }
        }

        }else{
        $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();

        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $get_total_points = $get_total_points + $product_points;
          $d_stock->points =  $product_points;
        }
      }
        $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$request->shop_id)->where('product_id',$stock['product_id'])->first();

        if($ProductDiscountDsfShops){

          $ProductDiscountDsfShops->discount = $d_stock->discount;
          if($stock['customer_tp'] > 0){

              $ProductDiscountDsfShops->customer_tp = $stock['customer_tp'];

          }
          $ProductDiscountDsfShops->save();
        }else{

          $ProductDiscountDsfShops = new ProductDiscountDsfShops();
          $ProductDiscountDsfShops->dsf_shop_id = $request->shop_id;
          $ProductDiscountDsfShops->product_id = $stock['product_id'];
          $ProductDiscountDsfShops->discount = $d_stock->discount;
          if($stock['customer_tp'] > 0){

              $ProductDiscountDsfShops->customer_tp = $stock['customer_tp'];

          }
          
          $ProductDiscountDsfShops->save();

        }

        $d_stock->save();


        if(count($stock['product_category'])>0){
          foreach ($stock['product_category'] as $category){
            $cat=new StockBookingDetailCategory();
            $cat->stock_booking_detail_id=$d_stock->id;
            $cat->product_category_id=$category['id'];
            $cat->quantity=$category['quantity'];
            $cat->dispatch_quantity=$category['quantity'];
            $cat->delivered=0;
            $cat->save();
          }
        }
        $name[] = $cot->name." (Order: ".round($stock['quantity'],2).")";
      }
      $productname = implode("\n", $name);
    }

    $dsf->total_points = $dsf->total_points + $get_total_points;

    $dsf->save();
    
    /// asm points ///
    $asm_user= User::where('id',$dsf->asm_id)->first();
    $asm_user->total_points = $asm_user->total_points + $get_total_points;

    $asm_user->save();



   /// dsf or ase log ///

    $remarks  = getremarks($dsf->id,$dis_stoc->party_id);

    $UserPointTrail = new UserPointTrail();

    $UserPointTrail->user_id = $dsf->id;

    $UserPointTrail->points =   $get_total_points;

    $UserPointTrail->type = "dsf_order";

    $UserPointTrail->detail_id = $dis_stoc->id;

    $UserPointTrail->total_points = $dsf->total_points;

    $UserPointTrail->remarks = $remarks;
    $UserPointTrail->save();


/////  
     /// asm  points log ///
    


    $UserPointTrails = new UserPointTrail();

    $UserPointTrails->user_id = $asm_user->id;

    $UserPointTrails->points =   $get_total_points;

    $UserPointTrails->type = "dsf_order";

    $UserPointTrails->detail_id = $dis_stoc->id;

    $UserPointTrails->remarks = $remarks;

    $UserPointTrails->total_points = $asm_user->total_points;

    $UserPointTrails->save();

 ///

    $dis_stoc->price=$price;
    $dis_stoc->total_points = $get_total_points;
    if(!empty($dsf)){
      $dis_stoc->payment=$total_price;
  
      $dis_stoc->save();
    }else{
      $dis_stoc->payment=$total_price;
    }
    $dis_stoc->save();




    $bookingno  = DsfBookingNumber::where('user_id',$dsf->id)->latest()->first();

    if($bookingno){
         $order_no=$bookingno->order_no;
      $bookingno  = new DsfBookingNumber();

         $bookingno->user_id = $dsf->id; 
         $bookingno->order_no = $order_no + 1;
         $bookingno->stock_booking_id = $dis_stoc->id;
         if($vourcher){
         $bookingno->voucher_id = $vourcher->id;
         }
        
        $bookingno->save();


    }else{

          $bookingno  = new DsfBookingNumber();
          $bookingno->user_id = $dsf->id; 
          $bookingno->order_no = 1;
          $bookingno->stock_booking_id = $dis_stoc->id;
          if($vourcher){
           $bookingno->voucher_id = $vourcher->id;
          }
          $bookingno->save();
        

    }
                // push notification recipients fetch
    $recipients = User::select('id')->whereHas('roles', function ($query) {
      $query->wherein('name', ['admin','super_admin']);
    })->get()->toarray();
    if(count($recipients)>0){
                    // push notification device token fetch
      $fetch=[];
      $body=null;
      if(!empty($dis_stoc->remarks)){
        $body=  $dis_stoc->remarks;
      }elseif(!empty($dis_stoc->Book_By->firstname)){
        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
      }

      $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
      $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
      if(count($device_token)>0){
                        // push notification send
        push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'asm_order');
      }
    }
    
    


    return API::response()->array(['success' => true,
      'message' => 'Stock Booking ',
      'data'    => $dis_stoc], 200);
  }


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

//////

public function stockBookingCottondsf(Request $request){
  try {


    $validator = \Validator::make($request->all(),['dsf_id'=>'required|not_in:0']);
    if ($validator->fails()) {
      return API::response()->array(['success' => false,
        'error'   => 'Required parameters are missing or incorrect!',
        'error_message' => $validator->errors()], 400);
    }else{


      $dsf=User::where('id',$request->dsf_id)->first();
      
      
     $voucher = 0;

      $dsf_accountant = $dsf->Subdistributor_info->sd_accountant_id;

        $subdistributer = $dsf->Subdistributor_info;
        $sub = Subdistributor::where('id',$subdistributer->id)->first();
    
     if($dsf_accountant){
        $sub = Subdistributor::where('id',$subdistributer->id)->first();


        $sub->has_voucher = 1;
        $sub->save();

        $now_date= date("Y-m-d");

        $vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->where('date',$now_date)->first();

        if(empty($vourchers)){


         $get_vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->latest()->first();


         if($get_vourchers){
           $serial_no=$get_vourchers->serial_no + 1;
         }else{
          $serial_no = 1;
        }
        $vourcher  = new Vouchers();
        $vourcher->soul_user_id = $dsf_accountant; 
        $vourcher->serial_no = $serial_no;
        $vourcher->dsf_id = $dsf->id;
        $vourcher->date = date("Y-m-d");

        $vourcher->save();


      }else{

        $vourcher = $vourchers;
      }
    }
        
      $dis_stoc=new StockBooking();

      $dis_stoc->booked_by=$request->dsf_id;
      $dis_stoc->booked_to = $request->asm_id;
      $dis_stoc->booked_to = $request->asm_id;
       if(!empty($request->shop_id)){
      $dis_stoc->party_id = $request->shop_id;
    }else{
      return API::response()->array(['success' => false,
  'message' => 'please select party '], 404);

    }
      $dis_stoc->party_check = "dsf";
      $dis_stoc->date=date("Y-m-d");

      $dis_stoc->remarks=$request->remarks;

      $dis_stoc->status='Booked';

      $dis_stoc->vendor_flag = 0;  
      

     $dis_stoc->save();

                // stock booking adda
      if(!empty($request->get('adda'))){
        foreach ($request->get('adda') as $adda){
          $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
          if(empty($ad)){
            $ad=new StockBookingAdda();
          }
          $ad->vendor_id=$adda['vendor_id'];
          $ad->adda_id=$adda['adda_id'];
            //$ad->save();
        }
      }
      $price=0;
      $total_price=0;
      $get_total_points = 0;

      if(count($request->products)>0){

        foreach ($request->products as $stock){

          $d_stock=new StockBookingDetail();
          $d_stock->stock_booking_id=$dis_stoc->id;
          $d_stock->product_id=$stock['product_id'];

          $cot=Product::where('id',$stock['product_id'])->first();


          if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];

            if($stock['discount_type'] == "percentage" && $stock['unit_price'] == 0){



             $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             $dsfshop  =  DsfShop::where('id',$request->shop_id)->first();
             $tp_rate  = $p->distributor_price;

             $cost = $tp_rate*$stock['quantity'];
             $price=$price+$cost;

             $d_stock->price=$cost;
             $d_stock->discount=$dsfshop->discount;
             $d_stock->payment=$cost-(($cost*$dsfshop->discount)/100);
             $total_price=$total_price+($cost-(($cost*$dsfshop->discount)/100));
          
           }

           if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
            $tp_rate  = $p->distributor_price;
            
             $cost = $tp_rate*$stock['quantity'];
            
              $price=$price+$cost;

             $d_stock->price=$cost;
            
             $d_stock->discount=$stock['discount'];

             $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

             $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));

             

           }


           if($stock['discount_type'] == "rupees"){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             
             $tp_rate  = $p->distributor_price; 

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
             //$d_stock->payment=$cost;
            // $total_price=$total_price+$cost;
             $tp_rate  = $p->distributor_price;

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

              $d_stock->payment=$cost-(($cost*$discount)/100);
               $total_price=$total_price+$cost-(($cost*$discount)/100);



           }

        }
       
       if($dsf_accountant){

            $reduce_point_check = $sub->reduce_points;

           $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();


        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
           if($reduce_point_check == 0){
          $get_total_points = $get_total_points + $product_points;
          
          $d_stock->points =  $product_points;
        }
        if($reduce_point_check == 1) {
        
            $product_points = $product_points - (($product_points * 30) / 100);

            $get_total_points = $get_total_points + $product_points;
           
           $d_stock->points =  $product_points;
        }
        }

        }else{
        $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();

        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $get_total_points = $get_total_points + $product_points;
          $d_stock->points =  $product_points;
        }
      }
        $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$request->shop_id)->where('product_id',$stock['product_id'])->first();

        if($ProductDiscountDsfShops){

          $ProductDiscountDsfShops->discount = $d_stock->discount;
          $ProductDiscountDsfShops->save();
        }else{

          $ProductDiscountDsfShops = new ProductDiscountDsfShops();
          $ProductDiscountDsfShops->dsf_shop_id = $request->shop_id;
          $ProductDiscountDsfShops->product_id = $stock['product_id'];
          $ProductDiscountDsfShops->discount = $d_stock->discount;
          $ProductDiscountDsfShops->save();

        }
        
        $d_stock->save();


        if(count($stock['product_category'])>0){
          foreach ($stock['product_category'] as $category){
            $cat=new StockBookingDetailCategory();
            $cat->stock_booking_detail_id=$d_stock->id;
            $cat->product_category_id=$category['id'];
            $cat->quantity=$category['quantity'];
            $cat->dispatch_quantity=$category['quantity'];
            $cat->delivered=0;
            $cat->save();
          }
        }
        $name[] = $cot->name." (Order: ".round($stock['quantity'],2).")";
      }
      $productname = implode("\n", $name);
    }

    $dsf->total_points = $dsf->total_points + $get_total_points;
    $dsf->save();

    $dis_stoc->price=$price;
    $dis_stoc->total_points = $get_total_points;
    if(!empty($dsf)){
      $dis_stoc->payment=$total_price;
  
      $dis_stoc->save();
    }else{
      $dis_stoc->payment=$total_price;
    }
    $dis_stoc->save();




    $bookingno  = DsfBookingNumber::where('user_id',$dsf->id)->latest()->first();

    if($bookingno){
         $order_no=$bookingno->order_no;
      $bookingno  = new DsfBookingNumber();

         $bookingno->user_id = $dsf->id; 
         $bookingno->order_no = $order_no + 1;
         $bookingno->stock_booking_id = $dis_stoc->id;
            if($vourcher){
         $bookingno->voucher_id = $vourcher->id;
        }
        $bookingno->save();


    }else{

      $bookingno  = new DsfBookingNumber();
         $bookingno->user_id = $dsf->id; 
         $bookingno->order_no = 1;
         $bookingno->stock_booking_id = $dis_stoc->id;
         //if($vourcher){
          // $bookingno->voucher_id = $vourcher->id;
         // }
        $bookingno->save();
        

    }
                // push notification recipients fetch
    $recipients = User::select('id')->whereHas('roles', function ($query) {
      $query->wherein('name', ['admin','super_admin']);
    })->get()->toarray();
    if(count($recipients)>0){
                    // push notification device token fetch
      $fetch=[];
      $body=null;
      if(!empty($dis_stoc->remarks)){
        $body=  $dis_stoc->remarks;
      }elseif(!empty($dis_stoc->Book_By->firstname)){
        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
      }

      $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
      $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
      if(count($device_token)>0){
                        // push notification send
        push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'asm_order');
      }
    }

    


    return API::response()->array(['success' => true,
      'message' => 'Stock Booking ',
      'data'    => $dis_stoc], 200);
  }


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}


/////

/////


public function getstockBookingCottondsf(Request $request){

 try{ 

         $role= $this->getUserRole($request->dsf_id);



  if($request->shop_id == 0){

    if($role == 'ase'){

    $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_check','ase')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();
  }
  if($role == 'dsf'){

     $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_check','dsf')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();

  }
  }
  else{

     if($role == 'ase'){
    $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_id',$request->shop_id)->where('party_check','ase')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();

  }
  if($role == 'dsf'){
    $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_id',$request->shop_id)->where('party_check','dsf')->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','Booked_By','shop_info','order_no')->get();
  }
  }
  if($StockBookingDsf){


   return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $StockBookingDsf], 200);
 }
 else{

  return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}



public function getstockBookingCottondsfstockdetail(Request $request){

 try{ 


    $name = explode('-',$request->start_date);
     $name2 = explode('-',$request->end_date);
     //// get perivious month last day   and yesterday date /// 
    $month   =  $name[1];
    $year = $name[0];
    

     $end_month   =  $name2[1];
    $end_year = $name2[0];
    $end_yesterday =  $name2[2] - 1;
  

    if ($month == 1){

       $year = $year -1;
       $month = 12;
       $day = 31;
    }

    else{

        $month = $month - 1;
        $month = "0".$month;

    }
      $date = $year."-".$month;
      $start_date =  dateset($date);
  
      $end_date  = $name2[0]."-".$name2[1]."-".$end_yesterday;

      
  if($request->shop_id == 0){

    $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_check','dsf')->whereBetween('date', [$start_date, $end_date])->with('stock_details')->get();

  }
  else{

    $StockBookingDsf    = StockBooking::where('booked_by',$request->dsf_id)->where('party_id',$request->shop_id)->where('party_check','dsf')->whereBetween('date', [$start_date, $end_date])->with('stock_details')->get();
  }
  if($StockBookingDsf){


   return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $StockBookingDsf], 200);
 }
 else{

  return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}
}



catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}
////// sale return dsf to subdistributer ////




  
  public function editstockBookingCottondsf(Request $request){
  try {


    $validator = \Validator::make($request->all(),['id'=>'required|not_in:0']);
    if ($validator->fails()) {
      return API::response()->array(['success' => false,
        'error'   => 'Required parameters are missing or incorrect!',
        'error_message' => $validator->errors()], 400);
    }else{


      $dsf=User::where('id',$request->booked_by)->first();


      $dis_stoc=StockBooking::where('id',$request->id)->first();

      $dis_stoc->booked_to = $request->asm_id;
      $dis_stoc->booked_to = $request->asm_id;
      $dis_stoc->party_id = $request->party_id;
      $dis_stoc->party_check = "dsf";

      $dis_stoc->remarks=$request->remarks;

      $dis_stoc->status='Booked';

      $dis_stoc->vendor_flag = 0;  
      
     // return $dis_stoc;

     $dis_stoc->save();

                // stock booking adda
      
      $price=0;
      $total_price=0;
      $get_total_points = 0;
      $deletepoints = 0;
        ///first delete booking detail and then add ii...
      $d_stocks=StockBookingDetail::where('stock_booking_id',$request->id)->get();
      foreach ($d_stocks as $key => $d_stoc) {
            $deletepoints=$deletepoints+ $d_stoc->points;
            $d_stoc->delete();
      }
        
        $dis_stoc->total_points = $dis_stoc->total_points - $deletepoints;
        $dis_stoc->save();
       $dsf->total_points = $dsf->total_points - $deletepoints;
       $dsf->save();

      if(count($request->products)>0){

        foreach ($request->products as $stock){
          
          
            $d_stock=new StockBookingDetail();
          $d_stock->stock_booking_id=$dis_stoc->id;
          $d_stock->product_id=$stock['product_id'];

          $cot=Product::where('id',$stock['product_id'])->first();


          if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];

            if($stock['discount_type'] == "percentage" && $stock['unit_price'] == 0){



             $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             $dsfshop  =  DsfShop::where('id',$request->shop_id)->first();
             $tp_rate  = $p->distributor_price;

             $cost = $tp_rate*$stock['quantity'];
             $price=$price+$cost;

             $d_stock->price=$cost;
             $d_stock->discount=$dsfshop->discount;
             $d_stock->payment=$cost-(($cost*$dsfshop->discount)/100);
             $total_price=$total_price+($cost-(($cost*$dsfshop->discount)/100));
          
           }

           if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
            $tp_rate  = $p->distributor_price;
            
             $cost = $tp_rate*$stock['quantity'];
            
              $price=$price+$cost;

             $d_stock->price=$cost;
            
             $d_stock->discount=$stock['discount'];

             $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

             $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));

             

           }


           if($stock['discount_type'] == "rupees"){

            $p= ProductPrice::where('product_id',$stock['product_id'])->first();
             
             $tp_rate  = $p->distributor_price; 

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
             //$d_stock->payment=$cost;
             $total_price=$total_price+$cost;
             $tp_rate  = $p->distributor_price;

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

              $d_stock->payment=$cost-(($cost*$discount)/100);


           }

        }
        
        $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();
    
        if($check_points){
          $quantityforpoints = $stock['quantity']/12;

          $product_points = ($check_points->points)* $quantityforpoints;
          $get_total_points = $get_total_points + $product_points;
          $d_stock->points =  $product_points;
        }
        $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$dis_stoc->party_id)->where('product_id',$stock['product_id'])->first();

        if($ProductDiscountDsfShops){

          $ProductDiscountDsfShops->discount = $d_stock->discount;
          $ProductDiscountDsfShops->save();
        }

        $d_stock->save();


        if(count($stock['product_category'])>0){
          foreach ($stock['product_category'] as $category){
            $cat=new StockBookingDetailCategory();
            $cat->stock_booking_detail_id=$d_stock->id;
            $cat->product_category_id=$category['id'];
            $cat->quantity=$category['quantity'];
            $cat->dispatch_quantity=$category['quantity'];
            $cat->delivered=0;
            $cat->save();
          }
        }
      }
    }

    $dsf->total_points = $dsf->total_points + $get_total_points;
    $dsf->save();

    $dis_stoc->price=$price;
    $dis_stoc->total_points = $get_total_points;
    if(!empty($dsf)){
      $dis_stoc->payment=$total_price;
  
      $dis_stoc->save();
    }else{
      $dis_stoc->payment=$total_price;
    }
    $dis_stoc->save();

    return API::response()->array(['success' => true,
      'message' => 'Stock Booking ',
      'data'    => $dis_stoc], 200);
  }


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

public function getdsfwithstockorders(Request $request){


    try {


        if($request->asm_id == 0 && $request->rsm_id == 0 && $request->dsf_id == 0 && $request->ase_id == 0){

        $users=User::where('hide_user',0)->whereHas('roles', function($query) {
        $query->whereIn('name',['dsf','ase','asm']);
      })->with('asm_info','rsm_detail','Subdistributor_info','sub_distributer_users','sub_distributer_user')->get();


      }
       if ($request->asm_id != 0 ) {
        
         $users=User::where('hide_user',0)->whereHas('roles', function($query) {
         $query->whereIn('name',['dsf','ase']);
        })->where('asm_id',$request->asm_id)->with('asm_info','rsm_detail','Subdistributor_info','sub_distributer_users')->get();
      }
      

      if($request->rsm_id != 0){

         $users=User::where('hide_user',0)->whereHas('roles', function($query) {
         $query->whereIn('name',['dsf','ase']);
        })->where('rsm_id',$request->rsm_id)->with('asm_info','rsm_detail','Subdistributor_info','sub_distributer_users')->get();
      }

       if($request->dsf_id != 0){

         $user=User::where('hide_user',0)->where('id',$request->dsf_id)->with('asm_info','rsm_detail','Subdistributor_info')->first();
            $dsf_users = [];
        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
       

              $dsf_users= $user;
              $dsf_users['total_shops']=DsfShop::where('dsf_id',$user->id)->count(); 
              $dsf_users['total_areas']=DsfArea::where('user_id',$user->id)->count(); 
              $dsf_users['StockBooking']    = StockBooking::where('booked_by',$user->id)->where('party_check','dsf')->whereBetween('date', [$startDate, $endDate])->get();  

           return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $dsf_users], 200); 
          
        }


       if($request->ase_id != 0){

         $user=User::where('hide_user',0)->where('id',$request->ase_id)->with('asm_info','rsm_detail','sub_distributer_users')->first();
            $dsf_users = [];
        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
       

              $dsf_users= $user;
              $dsf_users['total_shops']=DsfShop::where('dsf_id',$user->id)->count(); 
              $dsf_users['total_areas']=DsfArea::where('user_id',$user->id)->count(); 
              $dsf_users['StockBooking']    = StockBooking::where('booked_by',$user->id)->where('party_check','ase')->whereBetween('date', [$startDate, $endDate])->get();  

           return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $dsf_users], 200); 
          
        }
      


        $dsf_users = [];
        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        foreach ($users as $key => $user) {

              $dsf_users[]= $user;

              $dsf_users[$key]['total_shops']=DsfShop::where('dsf_id',$user->id)->count(); 

              $dsf_users[$key]['total_areas']=DsfArea::where('user_id',$user->id)->count(); 


              $dsf_users[$key]['StockBooking']    = StockBooking::where('booked_by',$user->id)->whereIn('party_check',['dsf','ase','asm_shop'])->whereBetween('date', [$startDate, $endDate])->get();   

             
          
        }
    
  if(empty($dsf_users)){

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}


   return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $dsf_users], 200);
 
 
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}
public function getdsfwithstockorderswithdetails(Request $request){


    try {


        if($request->asm_id == 0 && $request->rsm_id == 0){

        $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }
       if ($request->asm_id != 0 ) {
        
         $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('asm_id',$request->asm_id)->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }
      

      if($request->rsm_id != 0){

         $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('rsm_id',$request->rsm_id)->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }


        $dsf_users = [];
        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        foreach ($users as $key => $user) {

              $dsf_users[]= $user;
              $dsf_users[$key]['total_shops']=DsfShop::where('dsf_id',$user->id)->count(); 
              $dsf_users[$key]['total_areas']=DsfArea::where('user_id',$user->id)->count(); 
              $dsf_users[$key]['StockBooking']    = StockBooking::where('booked_by',$user->id)->where('party_check','dsf')->whereBetween('date', [$startDate, $endDate])->with('stock_details_without_product')->get();   
          
        }
    
  if(empty($dsf_users)){

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}


   return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $dsf_users], 200);
 
 
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}


//// bility add by dsf ////

  public function AddBiltydsf(Request $request)
  {

    try {
          $now_date =date("Y-m-d");
      
         $bilty=  Bilti::where('delivered_to_id',$request->dsf_id)->where('bilti_date',$now_date)->first();

         if($bilty){

              return API::response()->array(['success' => false, 'message' => 'Bilty all ready added'], 200);


         }else{

   

     $user = User::where('id',$request->dsf_id)->first();

     $sub = Subdistributor::where('id',$user->subdistributer_id)->first();
    
      if($sub->sd_accountant_id > 0){
         return API::response()->array(['success' => false, 'message' => 'user can not add this bilty'], 200);
      }
    
     $bilty= new Bilti();
     $bilty->stock_booking_id= 0;
        $bilty->supplier_id=$user->subdistributer_id;  /// dis
        $bilty->delivered_to_id=$user->id;   //dsf 
        $bilty->party_id=0;
        $bilty->bilti_no="dsf_bilty";
        $bilty->bilti_date=date("Y-m-d");
        $bilty->delivered_date = date("Y-m-d");
        $bilty->gatepass="gatepass";
        $bilty->uuid="";
        $bilty->remarks=$request->remarks;
        $bilty->status='On The Way';
        $total_price=0;
        $totalvendor_price = 0;
        $vendor_price=0;



        if(count($request->products)>0) {

          foreach ($request->products as $stock) {

            if($stock['quantity'] > 0){
              $vendor_price = ($product_prices->vendor_price)* $stock['quantity'];

              $totalvendor_price = $totalvendor_price + $vendor_price;

            }

          }
        }

        $bilty->vendor_price=$totalvendor_price;

     $bilty->save();   /////////////



     $price=0;
     $vendor_price=0;
     $is_mehandi=false;


     $dsf=User::where('id',$request->dsf_id)->first();

     $asm_id     = $dsf->asm_id;
     if($asm_id){

      $asm_user = User::where('id',$asm_id)->first();
    }
    $userbalance = $dsf->balance;
    
    if($dsf){


     $distributer_id  = $dsf->sub_id; 



   }


            // add stock product
   if(count($request->products)>0){


    $allproduct_ids=Product::select('id')->get()->toArray();
    $get_total_points = 0;

    foreach ($request->products as $stock){

      if($stock['quantity'] > 0){



            ///
        
            ////
            $detail=new BiltiDetail();
            $detail->bilti_id=$bilty->id;
            $detail->product_id=$stock['product_id'];
            $detail->quantity=$stock['quantity'];
            $detail->delivered_date = date("Y-m-d");

            $product_prices = Product::where('id', $stock['product_id'])->get();


            $detail->vendor_price=($product_prices[0]->vendor_price)*$stock['quantity'];


            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity'],'Distributor');

            $price=$price+$cost;
            $detail->price=$cost;
            $detail->discount=10;
            $detail->payment=$cost-(($cost*10)/100);
            $total_price=$total_price+($cost-(($cost*10)/100));
            
            $check_points = PointSystem::where('user_id',$asm_id)->where('product_id',$stock['product_id'])->first();

            if($check_points){
              $quantityforpoints = $stock['quantity']/12;

              $product_points = ($check_points->points)* $quantityforpoints;
              $get_total_points = $get_total_points + $product_points;
              $detail->points =  $product_points;
              $detail->assigned_point = $check_points->points;

            }

            $detail->save();

             



                    ///
                    // add stock product category

         if(count($stock['product_category'])>0){
          foreach($stock['product_category'] as $product_category){
            if(!empty($product_category['quantity'])){
              $product_cat=new BiltiDetialType();
              $product_cat->bilti_detial_id=$detail->id;
              $product_cat->product_category_id=$product_category['product_category_id'];
              $product_cat->quantity=$product_category['quantity'];
//                                    $facial=$facial+($product_category['quantity']*$cot->cotton);
              $product_cat->save();
            }
          }
        }
                    // auto complete stock order

      }

    }
  }

  //$dsf->total_points = $dsf->total_points - $get_total_points;

  //$dsf->save();
  $bilty->total_points = $get_total_points;
  $bilty->price=$price;

  if(!empty($dsf)){
    $bilty->discount=10;
    $bilty->payment=$total_price;

  }
                // ledger add
        $bilty->save();

     

       $dsf_payments = new DsfPayment();
       $dsf_payments->bilti_id = $bilty->id;
       $dsf_payments->amount = $request->total_recovery;
       $dsf_payments->save();
     
     //Image upload
        if(!empty($request->uploadimages)) {
          $images = [];
          foreach($request->uploadimages as $image) {
            $image = upload_base64_image($image, 'uploads/bilty/',
              'image-');
            $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
            $customerImage->image =  'http://'.$image;
            $images[] = $customerImage;
          }
          if(count($images) > 0) {
            $bilty->biltyImages()->saveMany($images);
          }
        }
       

      }
    
    }

      catch(Exception $e)
      {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }
      return API::response()->array(['success' => true, 'message' => 'Bilty Added',
        'data' => $bilty], 200);
    }

    public function getLedgerdsf(Request $request){
      try {
        $start=$request->start_date;
        $end=$request->end_date;
        $dsf_id=$request->dsf_id;

        LedgerAdjustdsf($dsf_id);


        $obj=User::select(['id','firstname','balance','opening_balance'])->where('id',$dsf_id)
        ->with(['ledger'=>function($query) use($start,$end,$dsf_id){ $query ->where('user_id',$dsf_id)->wherein('type',['dsf_sale','dsf_recovery'])->wherebetween('date',[$start,$end])->get();}])->first();
        return API::response()->array(['success' => true,
          'message' => 'Ledger',
          'data'    => $obj], 200);
      } catch(Exception $e) {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }
    }

    public function deletebilitydsf(Request $request){

      try{

        $bilty = Bilti::where('id',$request->bilty_id)->where('po_no','=',null)->where('po_no_adv','=',0)->where('po_no_rsm','=',0)->where('po_no_warehouse','=',0)->first();
        
        $total_points = $bilty->total_points;

        $soul_distributer = null;
        if($bilty){

        $dsfpayments=DsfPayment::where('bilti_id',$bilty->id)->first();
        if($dsfpayments){

          $dsfpayments->delete();
        }
         $user = User::where('id',$bilty->delivered_to_id)->first();

         $user->total_points = $user->total_points + $total_points;
         $user->save();

         $SoStockReports = StockDetailSubdistributer::where('ref_id', $request->bilty_id)->get();

         if($SoStockReports)
          foreach ($SoStockReports as $key => $SoStockReport) {
           $SoStockReport->delete();
         }

         


         foreach ($bilty->bilty_detail as $key => $biltydetail) {

          $biltycatagorys = $biltydetail->bilty_detail_type;
          if($biltycatagorys){

            foreach ($biltycatagorys as $key => $biltycat) {


              $stock_product_catagory  = StockSubdistributer::where('so_id',$bilty->supplier_id)->where('product_id', $biltydetail['product_id'])->where('product_category_id', $biltycat->product_category_id)->first();

              if($stock_product_catagory){
               $stock_qty   =  $stock_product_catagory->qty + $biltycat->quantity;

               $stock_product_catagory->qty = $stock_qty;

               $stock_product_catagory->save();
             }

           }
         }




         $stock_product  = StockSubdistributer::where('so_id',$bilty->supplier_id)->where('product_id', $biltydetail['product_id'])->where('product_category_id', 0)->first();


         if($stock_product){
           $stock_qty   =  $stock_product->qty + $biltydetail->quantity;

           $stock_product->qty = $stock_qty;

           $stock_product->save();
         }

         $biltydetail->delete();


       }
       UserExpenseDetail::where('detail_id', $request->bilty_id)->where('type','dsf_sale')->delete();
       $bilty->delete();
     }else{

       return API::response()->array(['success' => false, 'message' => 'bilty not found'], 400);


     }


     return API::response()->array(['success' => true, 'message' => 'dsf bility deleted successfully'], 200);

   }catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
}
public function getasmwithdsfbilties(Request $request){


    try {

        $asm_id = $request->asm_id;
         $users=User::select('id')->whereHas('roles', function($query) {
        $query->where('name', '=', 'dsf');
    })->where('asm_id','=',$asm_id)->get();

         $dsf_users = [];
         foreach ($users as $key => $user) {
            $dsf_users[] = $user->id;
         }

       
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        $data = [];
        $status = $request->status;
        
        
        if($status == "pending"){

         $biltys=  Bilti::where('po_no','=',null)->where('po_no_adv',0)->where('po_no_rsm',0)->where('po_no_warehouse',0)->where('bilti_no','dsf_bilty')->where('admin_status',0)->whereIn('delivered_to_id',$dsf_users)->whereBetween('delivered_date', [$startDate,$endDate])->with(['bilty_detail'=>function($query)
        
    {
      $query->with('bilty_product');
  },'bookBy','bilty_supplier'])->get();
   
         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }
    else{
       
   
       $biltys=  Bilti::where('po_no','=',null)->where('po_no_adv','=',0)->where('po_no_rsm','=',0)->where('po_no_warehouse','=',0)->where('bilti_no','dsf_bilty')->whereIn('delivered_to_id',$dsf_users)->whereBetween('delivered_date', array([$startDate,$endDate]))->with(['bilty_detail'=>function($query)
        
    {
      $query->with('bilty_product');
  },'bookBy','bilty_supplier'])->get();

         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }
  

    if(!empty($data)){


        return API::response()->array((['success' => true, 'message' => 'All Bilties by product wise in asm ',
         'data' => $data]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}


public function getdsfwithbilties(Request $request){


    try {

        $dsf_id = $request->dsf_id;
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        $data = [];
        $status = $request->status;
        
      
        if($status == "pending"){

         $biltys=  Bilti::where('po_no','=',null)->where('po_no_adv',0)->where('po_no_rsm',0)->where('po_no_warehouse',0)->where('bilti_no','dsf_bilty')->where('admin_status',0)->where('delivered_to_id',$dsf_id)->whereBetween('delivered_date', [$startDate,$endDate])->with('dsf_recovery')->get();
         
         /*->with(['bilty_detail'=>function($query)
        
    {
      $query->with('bilty_product');
  },'bookBy','bilty_supplier']) */

   
         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }
    else{
     
       $biltys=  Bilti::where('po_no','=',null)->where('po_no_adv','=',0)->where('po_no_rsm','=',0)->where('po_no_warehouse','=',0)->where('bilti_no','dsf_bilty')->where('delivered_to_id',$dsf_id)->whereBetween('delivered_date', [$startDate,$endDate])->with('dsf_recovery')->get();
       /*->with(['bilty_detail'=>function($query)
        
    {
      $query->with('bilty_product');
  },'bookBy','bilty_supplier']) */

  

         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }
  

    if(!empty($data)){


        return API::response()->array((['success' => true, 'message' => 'All Bilties by product wise in asm ',
         'data' => $data]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}



public function approvedbiltybyasm(Request $request)
  {

    try {

   $bilty=  Bilti::where('id',$request->id)->first();

     $name = explode('-',$bilty->delivered_date);
     //// get perivious month last day   and yesterday date /// 
    $month   =  $name[1];
    $year = $name[0];
    $yesterday =  $name[2] - 1;
  
    if ($month == 1){

       $year = $year -1;
       $month = 12;
       $day = 31;
    }
    else{

        $month = $month - 1;
        $month = "0".$month;

    }
      $date = $year."-".$month;
   
      $start_date =  dateset($date);

      $end_date  = $name[0]."-".$name[1]."-".$yesterday;

     $stockorderpoints    = StockBooking::where('booked_by',$bilty->delivered_to_id)->where('party_check','dsf')->whereBetween('date', [$start_date,$end_date])->sum('total_points');

 if($bilty->admin_status == 0){
     $bilty->admin_status = 1;
     $bilty->save();
     $user = User::where('id',$bilty->delivered_to_id)->first();
    
     $price=0;
     $vendor_price=0;
     $is_mehandi=false;


     $dsf=User::where('id',$bilty->delivered_to_id)->first();

     $asm_id     = $dsf->asm_id;
     if($asm_id){

      $asm_user = User::where('id',$asm_id)->first();
    }
    $userbalance = $dsf->balance;
 
    if($dsf){


     $distributer_id  = $dsf->subdistributer_id; 



   }
   

            // add stock product
   if(count($bilty->bilty_detail)>0){



    $allproduct_ids=Product::select('id')->get()->toArray();
    $get_total_points = 0;

    foreach ($bilty->bilty_detail as $stock){
        
      if($stock->quantity > 0){



            ///
        if(!empty($distributer_id)){

          $stock_product  = StockSubdistributer::where('so_id',$distributer_id)->where('product_id',$stock->product_id)->where('product_category_id', 0)->first();


          if(!empty($stock_product)){
            $stock_product->qty  = $stock_product->qty - $stock->quantity;

                $stock_product->save();////////////

                $so_stock_detail  = new StockDetailSubdistributer();
                $so_stock_detail->so_id = $distributer_id;
                $so_stock_detail->ref_id = $bilty->id;
                $so_stock_detail->product_id = $stock->product_id;
                $so_stock_detail->stock_out = $stock->quantity;
                $so_stock_detail->total_stock = $stock_product->qty;
                $so_stock_detail->date = date("Y-m-d");
                $so_stock_detail->save();

              }else{
                $stock_product  = new StockSubdistributer();
                $stock_product->so_id = $distributer_id;
                $stock_product->product_id = $stock->product_id;
                $stock_product->opening_qty = $stock->quantity;
                $stock_product->qty = $stock->quantity;
                $stock_product->save();

                $so_stock_detail  = new StockDetailSubdistributer();
                $so_stock_detail->so_id = $distributer_id;
                $so_stock_detail->ref_id = $bilty->id;
                $so_stock_detail->product_id = $stock->product_id;
                $so_stock_detail->stock_out = $stock->quantity;
                $so_stock_detail->total_stock = $stock->quantity;
                $so_stock_detail->date = date("Y-m-d");
                $so_stock_detail->save();


              }
            }
        
            $check_points = PointSystem::where('user_id',$asm_id)->where('product_id',$stock->product_id)->first();

            if($check_points){
              $quantityforpoints = $stock->quantity/12;

              $product_points = ($check_points->points)* $quantityforpoints;
              $get_total_points = $get_total_points + $product_points;

            }
          

         

          

            if(count($stock->bilty_detail_type)>0){
              
              foreach($stock->bilty_detail_type as $product_category){
                
               if(!empty($distributer_id)){

                $stock_product  = StockSubdistributer::where('so_id',$distributer_id)->where('product_id',$stock->product_id)->where('product_category_id',$product_category->product_category_id)->first();
                

                if(!empty($stock_product)){
                  $stock_product->qty  = $stock_product->qty - $product_category->quantity;

                  $stock_product->save();

                  $so_stock_detail  = new StockDetailSubdistributer();
                  $so_stock_detail->so_id = $distributer_id;
                  $so_stock_detail->ref_id = $bilty->id;
                  $so_stock_detail->product_id = $stock->product_id;
                  $so_stock_detail->product_category_id = $product_category->product_category_id;
                  $so_stock_detail->stock_out = $product_category->quantity;
                  $so_stock_detail->total_stock = $stock_product->qty;
                  $so_stock_detail->date = date("Y-m-d");


                  $so_stock_detail->save();

                }
                else{



                 $so_stock_product  = new StockSubdistributer();
                 $so_stock_product->so_id = $distributer_id;
                 $so_stock_product->product_id = $stock->product_id;
                 $so_stock_product->product_category_id = $product_category->product_category_id;
                 $so_stock_product->qty = $product_category->quantity;
                 $so_stock_product->save();

                 $so_stock_details  = new StockDetailSubdistributer();
                 $so_stock_details->so_id = $distributer_id;
                 $so_stock_detail->ref_id = $bilty->id;
                 $so_stock_details->product_id = $stock->product_id;
                 $so_stock_details->product_category_id = $product_category->product_category_id;
                 $so_stock_details->stock_out = $product_category->quantity;
                 $so_stock_details->total_stock = $product_category->quantity;
                 $so_stock_details->date = date("Y-m-d");
                $so_stock_details->save();

               }
             }

             
           }
         }


      }

    }
  }

    $old_point = $dsf->total_points;
    
if($stockorderpoints >= $get_total_points){
   
    $diff = $stockorderpoints - $get_total_points;

    $dsf->total_points = $dsf->total_points -$diff;
    $asm_user->total_points = $asm_user->total_points - $diff;
  }
 else{

        $diff = $get_total_points - $stockorderpoints;

        $diff = $diff * 2;

        $dsf->total_points = $dsf->total_points - $diff;
         $asm_user->total_points = $asm_user->total_points - $diff;
  }

    //$remark =$remark ."Bilty_id: ".$bilty->id."<br>Bilty_points: ".$get_total_points."<br>StockBooking_points:" .$stockorderpoints."<br>User_old_Point:".$old_point."<br>User_new_point: ".$dsf->total_points."<br>difference:".$diff."<br>";
  
    $remark = [
    'Bilty_id' => $bilty->id,
    'Bilty_points' => $get_total_points,
    'StockBooking_points' => $stockorderpoints,
    'User_old_Point' => $old_point,
    'User_new_point' => $dsf->total_points,
    'difference' => $diff,
    
];

      $asm_user->save();
  $dsf->save();
  
  $bilty->total_points = $get_total_points;
  $bilty->remarks = $bilty->remarks. $remark;

  /////dsf sale //////
  if(!empty($dsf)){

    $dsf->balance=($dsf->balance)+($bilty->payment);

    $dsf->save();
  }
                // ledger add

        $e= new UserExpenseDetail();
        $e->user_id=$dsf->id;     
        $e->detail_id=$bilty->id;
        $e->vendor_id=$dsf->subdistributer_id; //distributer id 
        $e->amount=$bilty->payment;
        $e->vendor_price=0;
        $e->balance =   ($userbalance)+$bilty->payment;
        $e->type='dsf_sale';
        $e->date=date("Y-m-d");
        $e->save();
/////////// dsf recovery /////
        if(!empty($dsf)){

      $dsf_payment   = DsfPayment::where('bilti_id',$request->id)->first();
    
    $dsf->balance=($dsf->balance)-($dsf_payment->amount);
    $dsf->save();

  }

         $e= new UserExpenseDetail();
        $e->user_id=$dsf->id;     
        $e->detail_id=$dsf_payment->id;
        $e->vendor_id=$dsf->subdistributer_id; //distributer id 
        $e->amount=$dsf_payment->amount;
        $e->vendor_price=0;

        $e->balance = $dsf->balance;

        $e->type='dsf_recovery';
        $e->date=date("Y-m-d");
        $e->save();



        $bilty->save();


       

 }
 else{
        
        return API::response()->array(['success' => true, 'message' => 'Bilty Already Added'], 200);

      }
      
}

      catch(Exception $e)
      {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }
      return API::response()->array(['success' => true, 'message' => 'Bilty Added',
        'data' => $bilty], 200);
    }
public function getdsfshopdiscount(Request $request){
      try {
  
          $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$request->shop_id)->get();

          if($ProductDiscountDsfShops){
            return API::response()->array(['success' => true,
          'message' => 'Get dsf Shop discount history',
          'data'    => $ProductDiscountDsfShops], 200);

          }
          else{
            return API::response()->array(['success' => true,
          'message' => 'Record Not Found'], 404);

          }

        
        return API::response()->array(['success' => true,
          'message' => 'Get dsf Shop discount history',
          'data'    => $ProductDiscountDsfShops], 200);

      } catch(Exception $e) {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }
    }
    
    public function getshopordersbyid(Request $request){


    try {

        $shop_id   = $request->shop_id;
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
    
        
  
       $stock    = StockBooking::where('party_id',$shop_id)->where('party_check','dsf')->where('type',null)->whereBetween('date', [$request->start_date, $request->end_date])->with('stock_details','shop_info')->get();


  

    if(!empty($stock)){


        return API::response()->array((['success' => true, 'message' => 'All Shop Orders ',
         'data' => $stock]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}


//Zain Whatsapp Report Message Function
public function getdfsdailysalereport(Request $request){
    try {
        if($request->asm_id == 0 && $request->rsm_id == 0){

        $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }
       if ($request->asm_id != 0 ) {
        
         $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('asm_id',$request->asm_id)->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }
      

      if($request->rsm_id != 0){

         $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('rsm_id',$request->rsm_id)->with('asm_info','rsm_detail','Subdistributor_info')->get();
      }


        $dsf_users = [];
        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        foreach ($users as $key => $user) {

              $dsf_users[]= $user;
              $dsf_users[$key]['total_shops']=DsfShop::where('dsf_id',$user->id)->count(); 
              $dsf_users[$key]['total_areas']=DsfArea::where('user_id',$user->id)->count(); 
              $dsf_users[$key]['StockBooking']    = StockBooking::where('booked_by',$user->id)->where('party_check','dsf')->whereBetween('date', [$startDate, $endDate])->get();   
          
        }
    
  if(empty($dsf_users)){

    return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

}


   return API::response()->array(['success' => true,
    'message' => 'dsf Stock details',
    'data'    => $dsf_users], 200);
 
 
}

catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}



}
//// dsf bilty check its exist or not ////
 public function checkdsfbilty(Request $request){


    try {

        $dsf_id   = $request->dsf_id;
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
      
        
  
       $bilty    = Bilti::where('delivered_to_id',$dsf_id)->where('bilti_no','dsf_bilty')->whereBetween('delivered_date', [$request->start_date, $request->end_date])->first();


    if(!empty($bilty)){

        return API::response()->array((['success' => true, 'message' => 'Get bilty successfully',
         'data' => $bilty]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

}
public function gettotalshopsledger(Request $request){
  try {



    $start_date =  $request->start_date; 

    $end_date     =  $request->end_date;


    $obj=[];

    $Dsfshop=Dsfshop::where('dsf_id',$request->dsf_id)->get();

    if(!empty($Dsfshop)){
      foreach ($Dsfshop as $key=>$p){
       $sales = 0;
       $recoveries = 0;
     
       $getsales = UserExpenseDetailsledger::select(DB::raw('sum(amount) as sale'))
       ->wherebetween('date',[$start_date,$end_date])
       ->where('party_id',$p->id)
       ->where('type','shop_sale')
       ->get();

         
       foreach ($getsales as $key2 => $sale) {
         $sales   =  $sale['sale'];
       }
       $getrecovery= UserExpenseDetailsledger::select(DB::raw('sum(amount) as recovery'))
       ->wherebetween('date',[$start_date,$end_date])
       ->where('party_id',$p->id)
       ->where('type','shop_recovery')
       ->get();
       foreach ($getrecovery as $key3 => $recovery) {
        $recoveries   =  $recovery['recovery'];
      }

      $obj[$key]=$p;
      $obj[$key]['total_sale']=$sales;
      $obj[$key]['total_recovery']=$recoveries;

    }



  }

  return API::response()->array(['success' => true,
    'message' => 'All Asm Party Payment ',
    'data' => $obj], 200);


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

public function checkalldsfbilty(Request $request){


  try {


    $startDate = $request->start_date;
    $endDate   = $request->end_date;
    $user_id = $request->user_id;

    $check = $this->getUserRole($user_id);

    if($check  == 'rsm' ){

     $dsfs=User::whereHas('roles', function($query) {
      $query->where('name', '=', 'dsf');
    })->where('rsm_id', $user_id)->with('Subdistributor_info','asm_info','rsm_detail')->get();

   }

   if($check == 'asm'){

     $dsfs=User::whereHas('roles', function($query) {
      $query->where('name', '=', 'dsf');
    })->where('asm_id',$user_id)->with('Subdistributor_info','asm_info','rsm_detail')->get();

   }

   if($check == 'super_admin' || $check == 'admin' ){

     $dsfs=User::whereHas('roles', function($query) {
      $query->where('name', '=', 'dsf');
    })->with('Subdistributor_info','asm_info','rsm_detail')->get();

   }


   $data = [];

   foreach ($dsfs as $key => $dsf) {

    $data[$key] = $dsf;

    $data[$key]['bilties']   = Bilti::where('delivered_to_id',$dsf->id)->where('bilti_no','dsf_bilty')->whereBetween('delivered_date', [$request->start_date, $request->end_date])->with('dsf_recovery')->get();

    $dsfshop = DsfShop::select('id')->where('dsf_id',$dsf->id)->get()->toArray();


$data[$key]['dsf_total_points'] = StockBooking::wherein('party_id',$dsfshop)
->where('party_check','=','dsf')->wherebetween('date',[$request->start_date,$request->end_date])->sum('total_points');

$data[$key]['total_dsf_recovery'] = UserExpenseDetailsledger::where('type','shop_recovery')->where('is_raw',0)->wherein('party_id',$dsfshop)->wherebetween('date',[$request->start_date,$request->end_date])->sum('amount');

$data[$key]['total_dsf_sale'] = UserExpenseDetailsledger::where('type','shop_sale')->where('is_raw',0)->wherein('party_id',$dsfshop)->wherebetween('date',[$request->start_date,$request->end_date])->sum('amount');

  
  }
  



  if(!empty($data)){

    return API::response()->array((['success' => true, 'message' => 'Get bilty successfully',
     'data' => $data]), 200);
  }else{
    return API::response()->array(['success' => true,
      'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}

}

public function gettotalsingleshopsledger(Request $request){
  try {
    $start=$request->start_date;
    $end=$request->end_date;
    $shop_id=$request->shop_id;

    LedgerAdjustshop($shop_id);



    $obj=DsfShop::where('id',$shop_id)
    ->with(['ledger_shops'=>function($query) use ($start,$end,$shop_id){ $query ->where('party_id',$shop_id)->wherebetween('date',[$start,$end])->get();}])->first();
    return API::response()->array(['success' => true,
      'message' => 'Ledger',
      'data'    => $obj], 200);
  } catch(Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
}
/*
public function gettotalsingleshopsledger(Request $request){
    try {
   
        $start_date =  $request->start_date; 

        $end_date     =  $request->end_date;

        $obj=[];
        $obj2= [];

        $p=Dsfshop::where('id',$request->shop_id)->first();
     
        if(!empty($p)){
           
               $sales = 0;
               $recoveries = 0;

$period = CarbonPeriod::create($start_date, $end_date);

// Iterate over the period
    $i =0;
foreach ($period as $key=> $date) {

          $getdate   =$date->format('Y-m-d');


        if($i == 0){
          $obj[$key]=$p;
          $i++;
          }
           $getsale[$key] = StockBooking::where('date',$getdate)
             ->where('party_id',$p->id)
             ->where('party_check','dsf')
             ->get();

             if($getsale[$key] != null){
$obj[$key]['sales']= $getsale[$key] ;
}
           
           
     $getrecovery[$key] = UserExpenseDetailsledger::where('date',$getdate)
             ->where('party_id',$p->id)
             ->where('type','shop_recovery')
             ->get();

                      if($getrecovery[$key] != null){
$obj[$key]['recoveries']= $getrecovery[$key];
}

            
  
         }

        
         foreach ($obj as $key => $ob) {
                 $obj2[]  = $ob;
           # code...
         }


       
    }

    return API::response()->array(['success' => true,
        'message' => 'single shop ledger',
        'data' => $obj2], 200);


} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

*/
public function updateshopdsfandarea(Request $request){

  try{ 

      
      
      $dsf_id = $request->dsf_id;
      $area_id = $request->area_id;

      $remarks = " ";
     $dsfshops    = DsfShop::where('id',$request->shop_id)->first();

     if($dsfshops){
        if($dsf_id != $dsfshops->dsf_id){

          $olduser = User::where('id',$dsfshops->dsf_id)->first();
          $newuser = User::where('id',$dsf_id)->first();

            $remarks_dsf ="Old dsf: ". $olduser->firstname . "<br> New_dsf:". $newuser->firstname."<br>";

        }
        if($area_id != $dsfshops->area_id){

           $old_Area=DsfArea::where('id',$dsfshops->area_id)->first();

           $new_Area = DsfArea::where('id',$area_id)->first();

          $remark_area ="Old area: ".$old_Area->name . "<br> New_area: " .  $new_Area->name."<br>";

        }

        $remarks = $remarks_dsf.$remark_area;
        $remarks;
        $dsfshops->dsf_id = $dsf_id;
        $dsfshops->area_id = $area_id;
        $dsfshops->remarks = $remarks;
        $dsfshops->save();

return API::response()->array(['success' => true,
        'message' => 'Shop info updated successfully'], 200);

     }
  

    else{

      return API::response()->array(['success' => false, 'message' => 'Record not found'], 404);

    }
  }

  catch (Exception $e) {
    return API::response()->array(['success' => false,
      'message' => $e->getTraceAsString()], 400);
  }
  

}

 public function alldsfsaleRecovery(Request $request)
    {
        try {
           $start=$request->start_date;
           $end=$request->end_date;
           $rsm_id = $request->rsm_id;
             $asm_id = $request->asm_id;

           $users_array =[]; 

$period = getDatesFromRange($start, $end);

    if($rsm_id != 0){
     $check = $this->getUserRole($rsm_id);
    }

    if($asm_id != 0){
     $check = $this->getUserRole($asm_id);
    }
    
    if($rsm_id == 0 && $asm_id == 0){

         $userId = $this->getUserIdFromToken($request);
          $check = $this->getUserRole($userId);

    }


if($check  == 'rsm'  || $check == 'asm' || $check == "admin" || $check == "super_admin" || $check ==  "gm"){
        if($check  == 'rsm' ){
            $users=User::select('id')->whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('rsm_id',$rsm_id)->get();

          foreach ($users as $key => $val) {
            $users_array[] = $val->id;
          }

        }
        if($check == 'asm'){
          $users=User::select('id')->whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->where('asm_id',$asm_id)->get();

          foreach ($users as $key => $val) {
            $users_array[] = $val->id;
          }


      }
      if ($check == "admin" || $check == "super_admin" || $check ==  "gm"){


         $users=User::select('id')->whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->get();

          foreach ($users as $key => $val) {
            $users_array[] = $val->id;
          }

    }

  }


         

           $obj3 =[]; 
           $obj4 =[]; 

     
       
            

           $dsf = DsfShop::select('id')->whereIn('dsf_id',$users_array)->get()->toArray();
          
            $obj= StockBooking::select(DB::raw('party_id,sum(payment) as sale_amount,sum(total_points) as points,booked_by,date'))
           ->wherein('party_id',$dsf)
           ->where('party_check','=','dsf')->wherebetween('date',[$start,$end])
           ->groupBy('date','type')
           ->orderBy('date', 'ASC')
           ->get();

             $obj2 = UserExpenseDetailsledger::select(DB::raw('sum(amount) as recovery_amount,date'))
            ->where('type','shop_recovery')->where('is_raw',0)->where('user_id',$dsf_user->id)
            ->wherein('party_id',$dsf)->wherebetween('date',[$start,$end])
            ->groupBy('date','type')
             ->orderBy('date', 'ASC')
             ->get();
            
            
          foreach ($obj as $key4 => $val) {
              
              if($obj2){
            if($val['date'] == $obj2[$key4]['date']){

                  $obj3[$key4]['date'] = $val['date'];
                  
                  $obj3[$key4]['sale_amount'] = $val['sale_amount'];
                    $obj3[$key4]['points'] = $val['points'];
                  $obj3[$key4]['booked_by'] = $val['booked_by'];

                  $obj3[$key4]['shop_recovery'] = $obj2[$key4]['recovery_amount'];
             

            }
            else{
                  $obj3[$key4]['date'] = $val['date'];
                  $obj3[$key4]['sale_amount'] = $val['sale_amount'];
                   $obj3[$key4]['points'] = $val['points'];
                  $obj3[$key4]['booked_by'] = $val['booked_by'];
                  $obj3[$key4]['shop_recovery'] = 0;

            }
            } 
         
          }
          
        
    $i = 0;
foreach ($period as $key5 => $date) {
         
    foreach($obj3 as $key6 => $data ){
  
          if( $data['date'] == $date){

                             $obj4[$key5]['date'] = $date;
                  
                    $obj4[$key5]['sale_amount'] =  $obj3[$key6]['sale_amount'];
                    $obj4[$key5]['points'] =  $obj3[$key6]['points'];
                    $obj4[$key5]['booked_by'] =  $obj3[$key6]['booked_by'];

                  $obj4[$key5]['shop_recovery'] = $obj2[$key6]['recovery_amount'];
                  $i = 1;
          }
         
    }
    if($i == 0){
                    
                  $obj4[$key5]['date'] = $date;
                  
                    $obj4[$key5]['sale_amount'] =  0;
                    $obj4[$key5]['points'] =  0;
                    $obj4[$key5]['booked_by'] =  0;
                  $obj4[$key5]['shop_recovery'] = 0;
                  
                  

         
    }
     $i= 0;
        }
      
     //
     
           
       } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Dsf Sale & Recovery',
        'data' => $obj4], 200);
}


//////// ......... /////////

///// Asm sale & recovery ///// 

  public function AsmsaleRecovery(Request $request)
  {
    try {
     $start=$request->start_date;
     $end=$request->end_date;

     $period = getDatesFromRange($start, $end);




     $dsf_user = $request->user_id;
     $obj3 =[]; 
     $obj4 =[]; 
     $dsf = DsfShop::select('id')->where('dsf_id',$dsf_user)->get()->toArray();

     $obj= StockBooking::select(DB::raw('party_id,sum(payment) as sale_amount,sum(total_points) as points,booked_by,date'))
       ->where('booked_by',$dsf_user)
     ->where('party_check','=','asm_shop')->wherebetween('date',[$start,$end])
     ->groupBy('date','type')
     ->orderBy('date', 'ASC')
     ->get();

     $obj2 = UserExpenseDetailsledger::select(DB::raw('sum(amount) as recovery_amount,date'))
     ->where('type','shop_recovery')->where('is_raw',0)->where('user_id',$dsf_user)
     ->wherein('party_id',$dsf)->wherebetween('date',[$start,$end])
     ->groupBy('date','type')
     ->orderBy('date', 'ASC')
     ->get();


     foreach ($obj as $key => $val) {

      if($obj2){
        if($val['date'] == $obj2[$key]['date']){

          $obj3[$key]['date'] = $val['date'];

          $obj3[$key]['sale_amount'] = $val['sale_amount'];
          $obj3[$key]['points'] = $val['points'];
          $obj3[$key]['booked_by'] = $val['booked_by'];

          $obj3[$key]['shop_recovery'] = $obj2[$key]['recovery_amount'];


        }
        else{
          $obj3[$key]['date'] = $val['date'];
          $obj3[$key]['sale_amount'] = $val['sale_amount'];
          $obj3[$key]['points'] = $val['points'];
          $obj3[$key]['booked_by'] = $val['booked_by'];
          $obj3[$key]['shop_recovery'] = 0;

        }
      } 

    }


          //foreach ($obj3 as $key => $val) {
            //return $val['date'];

          // Iterate over the period
    $i = 0;
    foreach ($period as $key1 => $date) {

      foreach($obj3 as $key2 => $data ){

        if( $data['date'] == $date){

         $obj4[$key1]['date'] = $date;

         $obj4[$key1]['sale_amount'] =  $obj3[$key2]['sale_amount'];
         $obj4[$key1]['points'] =  $obj3[$key2]['points'];
         $obj4[$key1]['booked_by'] =  $obj3[$key2]['booked_by'];

         $obj4[$key1]['shop_recovery'] = $obj2[$key2]['recovery_amount'];
         $i = 1;
       }

     }
     if($i == 0){

      $obj4[$key1]['date'] = $date;

      $obj4[$key1]['sale_amount'] =  0;
      $obj4[$key1]['points'] =  0;
      $obj4[$key1]['booked_by'] =  0;
      $obj4[$key1]['shop_recovery'] = 0;




    }
    $i= 0;
  }
     //


} catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Dsf Sale & Recovery',
  'data' => $obj4], 200);
}



public function Editbiltydsf(Request $request)
  {

    try {
        
         $total_price=0;
        $totalvendor_price = 0;
        $vendor_price=0;
          
     

     $bilty=Bilti::where('id',$request['id'])->first();
 
       $user = User::where('id',$bilty->delivered_to_id)->first();

      
     if(count($request->products)>0) {

          foreach ($request->products as $stock) {
            $product_prices = Product::where('id', $stock['product_id'])->get();

            if($stock['quantity'] > 0){
              $vendor_price = ($product_prices[0]->vendor_price)*$stock['quantity'];

              $totalvendor_price = $totalvendor_price + $vendor_price;

            }

          }
        }
        
        
        
        $bilty->vendor_price=$totalvendor_price;

     //$bilty->save();   /////////////


     $price=0;
     $vendor_price=0;
     $is_mehandi=false;

     $asm_id = $user->asm_id;

    


            // add stock product
   if(count($request->products)>0){


    $allproduct_ids=Product::select('id')->get()->toArray();
    $get_total_points = 0;

    foreach ($request->products as $stock){

     

            $detail= BiltiDetail::where('bilti_id',$request['id'])->where('product_id',$stock['id'])->first();

            if($detail){
            //return $detail->quantity;    
            $detail->quantity=$stock['quantity'];
          
            $product_prices = Product::where('id', $stock['product_id'])->get();


            $detail->vendor_price=($product_prices[0]->vendor_price)*$stock['quantity'];


            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity'],'Distributor');

            $price=$price+$cost;
            $detail->price=$cost;
            $detail->discount=10;
            $detail->payment=$cost-(($cost*10)/100);
            $total_price=$total_price+($cost-(($cost*10)/100));

            $check_points = PointSystem::where('user_id',$asm_id)->where('product_id',$stock['product_id'])->first();

            if($check_points){
              $quantityforpoints = $stock['quantity']/12;

              $product_points = ($check_points->points)* $quantityforpoints;
              $get_total_points = $get_total_points + $product_points;
              $detail->points =  $product_points;
              $detail->assigned_point = $check_points->points;

            }
         
           $detail->save();
          }


          else{


             if($stock['quantity'] > 0){

           
                  ////
            $detail=new BiltiDetail();
            $detail->bilti_id=$bilty->id;
            $detail->product_id=$stock['product_id'];
            $detail->quantity=$stock['quantity'];
            $detail->delivered_date = date("Y-m-d");

            $product_prices = Product::where('id', $stock['product_id'])->get();


            $detail->vendor_price=($product_prices[0]->vendor_price)*$stock['quantity'];


            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity'],'Distributor');

            $price=$price+$cost;
            $detail->price=$cost;
            $detail->discount=10;
            $detail->payment=$cost-(($cost*10)/100);
            $total_price=$total_price+($cost-(($cost*10)/100));

            $check_points = PointSystem::where('user_id',$asm_id)->where('product_id',$stock['product_id'])->first();

            if($check_points){
              $quantityforpoints = $stock['quantity']/12;

              $product_points = ($check_points->points)* $quantityforpoints;
              $get_total_points = $get_total_points + $product_points;
              $detail->points =  $product_points;
              $detail->assigned_point = $check_points->points;

            }

            $detail->save();
          }
        }
             


                    ///
                    // add stock product category
     
         if(count($stock['product_category'])>0){
          foreach($stock['product_category'] as $product_category){

              $product_cat= BiltiDetialType::where('bilti_detial_id',$detail->id)->where('product_category_id',$product_category['product_category_id'])->first();
           

              if($product_cat){

                $product_cat->quantity=$product_category['quantity'];

                $product_cat->save();

              }

                else{
            
            if(!empty($product_category['quantity'])){

              
              $product_cat=new BiltiDetialType();
              $product_cat->bilti_detial_id=$detail->id;
              $product_cat->product_category_id=$product_category['product_category_id'];
              $product_cat->quantity=$product_category['quantity'];

              $product_cat->save();
            }
          }
          }
        }
                    // auto complete stock order

      

    }

  }



 
  $bilty->total_points = $get_total_points;
  $bilty->price=$price;

  if(!empty($dsf)){
    $bilty->discount=10;
    $bilty->payment=$total_price;

  }
                // ledger add
        $bilty->save();

   

      $dsf_payments = DsfPayment::where('bilti_id',$request['id'])->first();

     if($dsf_payments){
       
       $dsf_payments->amount = $request->amount;
       $dsf_payments->save();
      }


      

    }
      catch(Exception $e)
      {
        return API::response()->array(['success' => false,
          'message' => $e->getTraceAsString()], 400);
      }
      return API::response()->array(['success' => true, 'message' => 'Bilty Added',
        'data' => $bilty], 200);
    }

public function savedistributeridindsfshops(Request $request){

        try{

           
 $users=User::whereHas('roles', function($query) {
          $query->whereIn('name',['dsf','ase']);
        })->get();

          foreach ($users as $key => $val) {
    

             $dsfshops = Dsfshop::where('dsf_id',$val->id)->get();

             foreach ($dsfshops as $key => $dsfshop) {
               $dsfshop->rsm_id = $val->rsm_id;
               $dsfshop->save();
             }
             

          }
           
            return API::response()->array(['success' => true, 'message' => 'Creditnote approved  successfully',
            'data' => $creditnote], 200);


        

             
          


     }catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function savedistributeridindsfareas(Request $request){

        try{

           
 $users=User::whereHas('roles', function($query) {
          $query->where('name', '=', 'dsf');
        })->get();

          foreach ($users as $key => $val) {
    

             $dsfshops = DsfArea::where('user_id',$val->id)->get();
              
             foreach ($dsfshops as $key => $dsfshop) {
               $dsfshop->sub_id = $val->subdistributer_id;
               $dsfshop->save();
             }
             

          }
           
            return API::response()->array(['success' => true, 'message' => 'Creditnote approved  successfully',
            'data' => $creditnote], 200);


        

             
          


     }catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function getshoporderbyshopid(Request $request){

        try{


          $start = $request->start_date;
          $end = $request->end_date;


           $obj =DsfShop::where('id',$request->id)->with(['stock_bookings'=>function($query) use($start,$end){ $query->wherebetween('date',[$start,$end])->with('stock_details','Booked_By','shop_info','order_no')->get();}])->first();

           if($obj){
            return API::response()->array(['success' => true, 'message' => 'Top 100 record successfully show ',
            'data' => $obj], 200);
           }else{

             return API::response()->array(['success' => false, 'message' => 'record not found',
            'data' => $obj], 200);

           }

             
            


     }catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function getdeadshops(Request $request){
    try {
     

         $date = \Carbon\Carbon::now();

         $start_date =  $date->subMonth(2)->format('Y-m-d'); 

         $end_date     =  \Carbon\Carbon::now()->format('Y-m-d');

         $dsf_id = $request->dsf_id;
       $asm_id = $request->asm_id;
         $obj=[];

         if($dsf_id > 0){



            $obj =DB::select("SELECT dsf_shops.id,dsf_shops.shop_name,dsf_shops.address,dsf_shops.dsf_id,count(stock.id) as total, MAX(stock1.id) as orderId, MAX(stock1.date)as order_date, dsf_areas.name as area_name from dsf_shops
           
            JOIN dsf_areas ON dsf_shops.area_id = dsf_areas.id

            /* to get latest  use in select max variable  shop order */
            INNER JOIN stock_bookings as stock1 ON dsf_shops.id=stock1.party_id 

            AND stock1.party_check = 'dsf'           
            AND stock1.status != 'Cancelled'
            /*........ */
            
            LEFT JOIN stock_bookings as stock ON ( dsf_shops.id = stock.party_id)

            

            AND DATE(stock.date) BETWEEN DATE('$start_date') AND DATE('$end_date')  

         
            AND stock.party_check = 'dsf'  AND stock.status != 'Cancelled'    GROUP BY dsf_shops.id
            
            HAVING dsf_shops.dsf_id = $dsf_id ");  /// having is use to get just specific dsf shops data /// 


            }else if($asm_id>0)
            {
     $obj =DB::select("SELECT dsf_shops.id,dsf_shops.shop_name,dsf_shops.address,dsf_shops.dsf_id,dsf_shops.asm_id,count(stock.id) as total, MAX(stock1.id) as orderId, MAX(stock1.date)as order_date, dsf_areas.name as area_name from dsf_shops
           
            JOIN dsf_areas ON dsf_shops.area_id = dsf_areas.id

            /* to get latest  use in select max variable  shop order */
            INNER JOIN stock_bookings as stock1 ON dsf_shops.id=stock1.party_id 

            AND stock1.party_check = 'dsf'           
            AND stock1.status != 'Cancelled'
            /*........ */
            
            LEFT JOIN stock_bookings as stock ON ( dsf_shops.id = stock.party_id)

            

            AND DATE(stock.date) BETWEEN DATE('$start_date') AND DATE('$end_date')  

         
            AND stock.party_check = 'dsf'  AND stock.status != 'Cancelled'    GROUP BY dsf_shops.id
            
            HAVING dsf_shops.asm_id = $asm_id ");  /// having is use to get just specific dsf shops data /// 

                
            }
            else{
  

           $obj =DB::select("SELECT dsf_shops.id,dsf_shops.shop_name,dsf_shops.address,dsf_shops.dsf_id,count(stock.id) as total, MAX(stock1.id) as orderId, MAX(stock1.date)as order_date, dsf_areas.name as area_name from dsf_shops
           
            JOIN dsf_areas ON dsf_shops.area_id = dsf_areas.id
           INNER JOIN stock_bookings as stock1 ON dsf_shops.id=stock1.party_id 

            AND stock1.party_check = 'dsf'
            AND stock1.status != 'Cancelled'



            LEFT JOIN stock_bookings as stock ON ( dsf_shops.id = stock.party_id)

            

            AND DATE(stock.date) BETWEEN DATE('$start_date') AND DATE('$end_date')  

            AND stock.party_check = 'dsf'  AND stock.status != 'Cancelled'    GROUP BY dsf_shops.id ");
 
            

            }




    return API::response()->array(['success' => true,
        'message' => 'shop order record list successfully ',
        'data' => $obj], 200);
}

 catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function getsubdistributershoptotalmonthsale(Request $request){

        try{

          $start_date = $request->start_date;
          $end_date = $request->end_date;

          $obj =DB::select("SELECT dsf_shops.id,dsf_shops.shop_name, stock_bookings.date,users.id as dsf_id, concat(users.firstname,' ',users.lastname) as dsf_name,users.image as dsf_image, asm.id  as asm_id, concat(asm.firstname, ' ', asm.lastname)  as asm_name,asm.image as asm_image, rsm.id  as rsm_id, concat(rsm.firstname, ' ', rsm.lastname)  as rsm_name,rsm.image as rsm_image, sub_distributors.id as sd_id,  sub_distributors.name as sd_name,sub_distributors.city as sd_city, party.id as party_id,party.name as party_name,  SUM(stock_bookings.payment) as total_sale from dsf_shops

           INNER JOIN stock_bookings ON dsf_shops.id = stock_bookings.party_id 
           INNER JOIN users ON dsf_shops.dsf_id = users.id
           INNER JOIN users as asm ON dsf_shops.asm_id = asm.id
           INNER JOIN users as rsm ON dsf_shops.rsm_id = rsm.id
           INNER JOIN sub_distributors ON dsf_shops.sub_id= sub_distributors.id 
           LEFT JOIN party_names as party ON sub_distributors.party_id=party.id 
               
           WHERE stock_bookings.party_check = 'dsf' AND stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.status != 'Cancelled'  GROUP BY dsf_shops.id ORDER BY total_sale");

            return API::response()->array(['success' => true, 'message' => 'Top 100 record successfully show ',
            'data' => $obj], 200);


     }catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

         ////// asm shop order module //// asm place shop orders ////


 public function stockBookingCottonasmshop(Request $request){
          try {

            $validator = \Validator::make($request->all(),['asm_id'=>'required|not_in:0']);
            if ($validator->fails()) {
              return API::response()->array(['success' => false,
                'error'   => 'Required parameters are missing or incorrect!',
                'error_message' => $validator->errors()], 400);
            }else{

        $role = "";      ////its check who's create area if asm then check  the subdistributer of this area have dsf or ase if no then check the sdviststock of asm otherwise just give him 100 % point , if area create dsf or ase then just give him(asm) 100 % point , ///

        $asm=User::where('id',$request->asm_id)->first();

        $dsfshop =Dsfshop::where('id',$request->shop_id)->first();

        if($dsfshop){

         $dsfarea = DsfArea::where('id',$dsfshop->area_id)->first();


         if($dsfarea){


          $role = $this->getUserRole($dsfarea->user_id);

        }


        else{
          return API::response()->array(['success' => false,
            'message' => 'Area not found from database'],404);
        }
      }

     

      if($role == "dsf"){

        $dsf =User::where('id',$dsfarea->user_id)->first();

        $voucher = 0;

        $dsf_accountant = $dsf->Subdistributor_info->sd_accountant_id;

        $subdistributer = $dsf->Subdistributor_info;

         if($dsf_accountant > 0){

          $sub = Subdistributor::where('id',$subdistributer->id)->first();

          $sub->has_voucher = 1;
          $sub->save();

          $now_date= date("Y-m-d");


          $vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->where('date',$now_date)->first();

          if(empty($vourchers)){
            $get_vourchers  = Vouchers::where('soul_user_id',$dsf_accountant)->where('dsf_id',$dsf->id)->first();

            if($get_vourchers){
             $serial_no=$get_vourchers->serial_no + 1;
           }else{
            $serial_no = 1;
          }
          $vourcher  = new Vouchers();
          $vourcher->soul_user_id = $dsf_accountant; 
          $vourcher->serial_no = $serial_no;
          $vourcher->dsf_id = $dsf->id;
          $vourcher->date = date("Y-m-d");
          
          $vourcher->save();


        }else{

          $vourcher = $vourchers;
        }
      }
    }

    if($role == "ase"){
      $dsf =User::where('id',$dsfarea->user_id)->first();
    }

    $dis_stoc=new StockBooking();
    $dis_stoc->booked_by=$request->asm_id;
    $dis_stoc->booked_to = $request->asm_id;

    if(!empty($request->shop_id)){
      $dis_stoc->party_id = $request->shop_id;
    }else{
      return API::response()->array(['success' => false,
        'message' => 'please select party '], 404);

    }
    $dis_stoc->party_check = "asm_shop";
    $dis_stoc->date=date("Y-m-d");

    $dis_stoc->remarks=$request->remarks;

    $dis_stoc->status='Booked';

    $dis_stoc->vendor_flag = 0;  


    $dis_stoc->save();

                // stock booking adda
    if(!empty($request->get('adda'))){
      foreach ($request->get('adda') as $adda){
        $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
        if(empty($ad)){
          $ad=new StockBookingAdda();
        }
        $ad->vendor_id=$adda['vendor_id'];
        $ad->adda_id=$adda['adda_id'];
        $ad->save();
      }
    }
    $price=0;
    $total_price=0;
    $get_total_points = 0;

    if(count($request->products)>0){

      foreach ($request->products as $stock){

        $d_stock=new StockBookingDetail();
        $d_stock->stock_booking_id=$dis_stoc->id;
        $d_stock->product_id=$stock['product_id'];

        $cot=Product::where('id',$stock['product_id'])->first();


        if(!empty($cot)){
          $d_stock->quantity=$stock['quantity'];
          $d_stock->dispatch_quantity=$stock['quantity'];

          if($stock['discount_type'] == "percentage" && $stock['unit_price'] == 0){



           $p= ProductPrice::where('product_id',$stock['product_id'])->first();
           $dsfshop  =  DsfShop::where('id',$request->shop_id)->first();
           $tp_rate  = $p->distributor_price;

           $cost = $tp_rate*$stock['quantity'];
           $price=$price+$cost;

           $d_stock->price=$cost;
           $d_stock->discount=$dsfshop->discount;
           $d_stock->payment=$cost-(($cost*$dsfshop->discount)/100);

           $total_price=$total_price+($cost-(($cost*$dsfshop->discount)/100));

         }

         if($stock['discount_type'] == "percentage" && $stock['unit_price'] > 0){

          $p= ProductPrice::where('product_id',$stock['product_id'])->first();
          $tp_rate  = $p->distributor_price;

          $cost = $tp_rate*$stock['quantity'];

          $price=$price+$cost;

          $d_stock->price=$cost;

          $d_stock->discount=$stock['discount'];

          $d_stock->payment=$cost-(($cost*$stock['discount'])/100);

          $total_price=$total_price+($cost-(($cost*$stock['discount'])/100));



        }


        if($stock['discount_type'] == "rupees"){

          $p= ProductPrice::where('product_id',$stock['product_id'])->first();

          $tp_rate  = $p->distributor_price; 

             $cost = $tp_rate*$stock['quantity'];  ///2185.8
             
             $realcost = $tp_rate*$stock['quantity']; ///2185.8
             
             $price=$price+$realcost;
             
             $d_stock->price=$realcost; 
             //$d_stock->payment=$cost;

             $tp_rate  = $p->distributor_price;

             $get_discount = ($stock['discount']/$tp_rate)*100;


             $d_stock->discount = $discount = number_format((float)$get_discount, 2, '.', '');

             $d_stock->payment=$cost-(($cost*$discount)/100);

             $total_price=$total_price+$cost-(($cost*$discount)/100);


           }

         }

         if($role == "asm" ){

           $sub_id =$dsfshop->sub_id;

           $asm_id    =$asm->id;



           if($sub->has_dsf == 0 && $sub->ase_id == 0){

             $date = date("Y-m-d");
             $Sdvisitopeningstock =Sdvisitopeningstock::where('sub_id',$sub_id)->where('ase_id',$asm_id)->where('date',$date)->where('status','completed')->first();



             if(count($Sdvisitopeningstock) > 0){



               $check_points = PointSystem::where('user_id',$asm->id)->where('product_id',$stock['product_id'])->first();



               if($check_points){
                $quantityforpoints = $stock['quantity']/12;

                $product_points = ($check_points->points)* $quantityforpoints;
                $get_total_points = $get_total_points + $product_points;
                $d_stock->points =  $product_points;



              }

            }
          }
          else{
           $check_points = PointSystem::where('user_id',$asm->id)->where('product_id',$stock['product_id'])->first();

           


           if($check_points){
            $quantityforpoints = $stock['quantity']/12;

            $product_points = ($check_points->points)* $quantityforpoints;
            $get_total_points = $get_total_points + $product_points;
            $d_stock->points =  $product_points;

          }

        }
      }

      if($role == "dsf"  || $role == "ase" ){


       $check_points = PointSystem::where('user_id',$dsf->asm_id)->where('product_id',$stock['product_id'])->first();



       if($check_points){
        $quantityforpoints = $stock['quantity']/12;

        $product_points = ($check_points->points)* $quantityforpoints;
        $get_total_points = $get_total_points + $product_points;
        $d_stock->points =  $product_points;
      } 

    }


    $ProductDiscountDsfShops =ProductDiscountDsfShops::where('dsf_shop_id',$request->shop_id)->where('product_id',$stock['product_id'])->first();

    if($ProductDiscountDsfShops){

      $ProductDiscountDsfShops->discount = $d_stock->discount;
      $ProductDiscountDsfShops->save();
    }else{

      $ProductDiscountDsfShops = new ProductDiscountDsfShops();
      $ProductDiscountDsfShops->dsf_shop_id = $request->shop_id;
      $ProductDiscountDsfShops->product_id = $stock['product_id'];
      $ProductDiscountDsfShops->discount = $d_stock->discount;
      $ProductDiscountDsfShops->save();

    }


    $d_stock->save();


    if(count($stock['product_category'])>0){
      foreach ($stock['product_category'] as $category){
        $cat=new StockBookingDetailCategory();
        $cat->stock_booking_detail_id=$d_stock->id;
        $cat->product_category_id=$category['id'];
        $cat->quantity=$category['quantity'];
        $cat->dispatch_quantity=$category['quantity'];
        $cat->delivered=0;
        $cat->save();
      }
    }
  }


  $get_ase_for_points = User::where('id',$request->asm_id)->first();

  $get_ase_for_points->total_points = $get_ase_for_points->total_points + $get_total_points;

  $get_ase_for_points->save();




  $dis_stoc->price=$price;
  $dis_stoc->total_points = $get_total_points;
  if(!empty($dsf)){
    $dis_stoc->payment=$total_price;

    $dis_stoc->save();
  }else{
    $dis_stoc->payment=$total_price;
  }
  $dis_stoc->save();





  $remarks_asms  = getremarks($get_ase_for_points->id,$dis_stoc->party_id);



  if($get_total_points > 0){

    $UserPointTrail = new UserPointTrail();

    $UserPointTrail->user_id = $get_ase_for_points->id;

    $UserPointTrail->points =  $get_total_points;

    $UserPointTrail->type = "asm_shop_order";

    $UserPointTrail->detail_id = $dis_stoc->id;

    $UserPointTrail->remarks = $remarks_asms;

    $UserPointTrail->total_points = $get_ase_for_points->total_points;

    $UserPointTrail->save();
  }
}


if($role == "dsf"){

  $bookingno  = DsfBookingNumber::where('user_id',$dsf->id)->latest()->first();

  if($bookingno){
   $order_no=$bookingno->order_no;
   $bookingno  = new DsfBookingNumber();

   $bookingno->user_id = $dsf->id; 
   $bookingno->order_no = $order_no + 1;
   $bookingno->stock_booking_id = $dis_stoc->id;
   if($vourcher){
     $bookingno->voucher_id = $vourcher->id;
   }

   $bookingno->save();


    }else{  ////ase order number

      $bookingno  = new DsfBookingNumber();
      $bookingno->user_id = $dsf->id; 
      $bookingno->order_no = 1;
      $bookingno->stock_booking_id = $dis_stoc->id;
      if($vourcher){
        $bookingno->voucher_id = $vourcher->id;
      }
      $bookingno->save();
    }
  }

  if($role =='asm'){


    $bookingno  = DsfBookingNumber::where('user_id',$asm->id)->latest()->first();

    if($bookingno){
     $order_no=$bookingno->order_no;
     $bookingno  = new DsfBookingNumber();

     $bookingno->user_id = $asm->id; 
     $bookingno->order_no = $order_no + 1;
     $bookingno->stock_booking_id = $dis_stoc->id;


     $bookingno->save();


   }else{

    $bookingno  = new DsfBookingNumber();
    $bookingno->user_id = $asm->id; 
    $bookingno->order_no = 1;
    $bookingno->stock_booking_id = $dis_stoc->id;

    $bookingno->save();
  }





}
                // push notification recipients fetch
$recipients = User::select('id')->whereHas('roles', function ($query) {
  $query->wherein('name', ['admin','super_admin']);
})->get()->toarray();
if(count($recipients)>0){
                    // push notification device token fetch
  $fetch=[];
  $body=null;
  if(!empty($dis_stoc->remarks)){
    $body=  $dis_stoc->remarks;
  }elseif(!empty($dis_stoc->Book_By->firstname)){
    $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
  }

  $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
  $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
  if(count($device_token)>0){
                        // push notification send
    push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'asm_order');
  }
}
return API::response()->array(['success' => true,
  'message' => 'Stock Booking ',
  'data'    => $dis_stoc], 200);
}


} catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

}

