<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Product;
use App\Models\Bilti;
use App\Models\VendorInvoice;
use App\Models\BiltiDetail;
use App\Models\UserExpense;
use Dingo\Api\Facade\API;
use App\Models\ProductCategory;
use App\Models\PaymentRemark;
use App\Models\PointSystem;
use App\Models\MonthlyProduct;
use App\Models\Subdistributor;
use App\Models\DsfShop;
use App\Models\StockBooking;
use App\Models\Role;
use Carbon\Carbon;
use DateTime;
use DatePeriod;
use DateInterval;
use Illuminate\Support\Str;
use App\Models\User;
use League\Flysystem\Exception;
use DB;

class PointSystemController extends BaseController
{

private $_pointModel;

    public function __construct(Request $request, PointSystem $pointModel)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_pointModel = $pointModel;
    }

   
 public function addproductspoints(Request $request)
 {
    try {

       $validator = \Validator::make($request->all(), $this->_pointModel->validationRules());

        if ($validator->fails()) {
            return API::response()->array(['success' => false,
                'error'   => 'Required parameters are missing or incorrect!',
                'message' => $validator->errors()], 400);
        } else {


             $check = PointSystem::where('user_id',$request->user_id)->where('product_id',$request->product_id)->first();
             if(empty($check)){
              $PointSystem  =   new  PointSystem();
                $PointSystem->user_id = $request->user_id;
                $PointSystem->product_id = $request->product_id;
                $PointSystem->points = $request->point;
                $PointSystem->carton = $request->carton;
                $PointSystem->save();
             }
             else{
               return API::response()->array(['success' => true,
            'message' => 'Points Already Added'], 200);


             }     

        }
        return API::response()->array(['success' => true,
            'message' => 'Points Added Sucessfully'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
public function addproductspointstoallasm(Request $request)
 {
    try {
         $userid = $this->getUserIdFromToken($request, true);
        
        $users=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->get();

        foreach ($users as $key => $user) {
        
        
             $check = PointSystem::where('user_id',$user->id)->where('product_id',$request->product_id)->first();
               $old_point = $check->points;
             if(empty($check)){
              $PointSystem  =   new  PointSystem();
                $PointSystem->user_id = $user->id;
                $PointSystem->product_id = $request->product_id;
                $PointSystem->points = $request->point;
                $PointSystem->carton = $request->carton;
                $PointSystem->save();
             }
         
             else{
                 $check->points = $request->point;
                 $check->carton = $request->carton;
                 $check->save();

                  $product = Product::where('id',$request->product_id)->first();
                  $user = User::where('id',$user->id)->first();

                 $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $check->id;

                
                $paymentRemark->type = "Points_Update";
                $remark ="ASM name: ".$user->firstname. "<br> product name:".$product->name ."<br> Privious Point:" . $old_point."<br> New Point:" . $request->point."<br>";

                $paymentRemark->remarks = $remark;

                $paymentRemark->user_remarks = "multiple asms points updated as a product";
                $paymentRemark->user_id = $userid->id;

                $paymentRemark->save();


             } 
             }
            $monthly_check   = MonthlyProduct::where('product_id',$request->product_id)->first();
            if(empty($monthly_check)){

                  $MonthlyProduct  =   new  MonthlyProduct();
                $MonthlyProduct->product_id = $request->product_id;
                 $MonthlyProduct->point = $request->point;
                $MonthlyProduct->save();

            }else{
                $monthly_check->product_id = $request->product_id;
                $monthly_check->point = $request->point;

                $monthly_check->save();
                $product = Product::where('id',$request->product_id)->first();
               

                 $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $monthly_check->id;

                
                $paymentRemark->type = "Monthly_Points_Update";
                $remark ="Product name:".$product->name ."<br> Privious Point:" . $old_point."<br> New Point:" . $request->point."<br>";

                $paymentRemark->remarks = $remark;

                $paymentRemark->user_remarks = "Monthly product points updated";
                $paymentRemark->user_id = $userid->id;

                $paymentRemark->save();
            }
        
        return API::response()->array(['success' => true,
            'message' => 'Points Added  Sucessfully'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
  public function getproductspointsbyuserid(Request $request)
 {
    try {

      if($request->user_id == 0){

        $PointSystem = PointSystem::with(['user','monthly_product','product'=>function($query){
              $query->with('images');
            }])->get();
         return API::response()->array(['success' => true,
            'message' => 'Show Points Sucessfully',
            'data' => $PointSystem], 200);
      }
      else{
      $PointSystem = PointSystem::where('user_id',$request->user_id)->with(['user','monthly_product','product'=>function($query){
              $query->with('images');
            }])->get();
             if(!empty($PointSystem)){
               return API::response()->array(['success' => true,
            'message' => 'Show Points Sucessfully',
            'data' => $PointSystem], 200);
             }
              else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    
           }
            

    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
} 
 public function getproductspointsbyid(Request $request)
 {
    try {

  
      $PointSystem = PointSystem::where('id',$request->id)->with(['user','monthly_product','product','logs'])->first();
             if(!empty($PointSystem)){
               return API::response()->array(['success' => true,
            'message' => 'Show Points Sucessfully',
            'data' => $PointSystem], 200);
             }
              else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    
           
            

    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
} 
public function monthlyproductactive(Request $request)
 {
    try {

  
        $monthly_check   = MonthlyProduct::where('id',$request->id)->first();
            if($monthly_check){

                  
                  $monthly_check->active = $request->active;
                 
                  $monthly_check->save();
               return API::response()->array(['success' => true,
            'message' => 'Monthly product active Sucessfully'], 200);
             }
              else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    
           
            

    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }

}
public function editproductspoints(Request $request)
  {
    try {
            $userid = $this->getUserIdFromToken($request, true);
             $PointSystem = PointSystem::where('id',$request->id)->first();

             if(!empty($PointSystem)){
              $old_point = $PointSystem->points;
              ////
                $PointSystem->user_id = $request->user_id;
                $PointSystem->product_id = $request->product_id;
                $PointSystem->points = $request->point;
                $PointSystem->carton = $request->carton;
              

                $product = Product::where('id',$request->product_id)->first();
                $user = User::where('id',$request->user_id)->first();


                 $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $PointSystem->id;

                
                $paymentRemark->type = "Points_Update";
                $remark ="Soul distributer name: ".$user->firstname. "<br> product name:".$product->name ."<br> Privious Point:" . $old_point."<br> New Point:" . $request->point."<br>";
                $paymentRemark->remarks = $remark;
                $paymentRemark->user_remarks = $request->remarks;
                $paymentRemark->user_id = $userid->id;

                $paymentRemark->save();
                 
                 $PointSystem->save();


             }
             else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    

        return API::response()->array(['success' => true,
            'message' => 'Points Edit Sucessfully'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
} 
 public function deleteproductspoints(Request $request)
 {
    try {

             $PointSystem = PointSystem::where('id',$request->id)->first();
           
             if(!empty($PointSystem)){
               
                $PointSystem->delete();
             }
             else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    

        return API::response()->array(['success' => true,
            'message' => 'Points Deleted Sucessfully'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function deletemonthlyproducts(Request $request)
 {
    try {


             $MonthlyProduct = MonthlyProduct::where('id',$request->id)->first();

            
             if(!empty($MonthlyProduct)){

               $pointproducts   =  PointSystem::where('product_id',$MonthlyProduct->product_id)->get();
               foreach ($pointproducts as $key => $pointproduct) {
                   $pointproduct->points = $request->point;
                   $pointproduct->save();
               }
                
                  $MonthlyProduct->delete();
             }
             else{
               return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

             }    

        return API::response()->array(['success' => true,
            'message' => 'MonthlyProduct Deleted Sucessfully'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
public function monthlyproductslist(Request $request)
 {
    try {

                $MonthlyProduct = MonthlyProduct::where('point','>',0)->with(['product'=>function($query){
              $query->with('images');
            }])->with('logs')->get();
           
            if($MonthlyProduct){
             return API::response()->array(['success' => true,
            
            'message' => 'monthly product list',
            'data'    => $MonthlyProduct], 200);

             }
             else{
                return API::response()->array(['success' => false,
            'message' => 'No Monthly Product found'], 400);

             }    

        
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function monthlyproductdetailwithlog(Request $request)
 {
    try {

             $MonthlyProduct = MonthlyProduct::where('id',$request->id)->with(['product'=>function($query){
              $query->with('images');
            }])->with('logs')->first();
           
            if($MonthlyProduct){
             return API::response()->array(['success' => true,
            
            'message' => 'monthly product list',
            'data'    => $MonthlyProduct], 200);

             }
             else{
                return API::response()->array(['success' => false,
            'message' => 'No Monthly Product found'], 400);

             }    

        
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}




public function getpointbilityasm(Request $request){
    try {

       $startDate = new Carbon($request->start_date);
$endDate = new Carbon($request->end_date);
$all_dates = array();
while ($startDate->lte($endDate)){
  $all_dates[] = $startDate->toDateString();

  $startDate->addDay();
}

        $partyinasm=Subdistributor::select('id')->where('asm_id','=',$request->asm_id)->get()->toArray();
        
        $obj=null;

       foreach ($all_dates as $key => $value){


            $obj[$key]['date']=$value;

          
          $obj[$key]['bilties']= Bilti::where('po_no',null)->where('po_no_raw',0)->where('po_no_adv',0)->wherein('party_id',$partyinasm)->where('delivered_date', $value)->with('bilty_detail')->get();

        }

        return API::response()->array(['success' => true,
            'message' => 'Asm Party sales and recovery monthly percentage ',
            'data'    => $obj], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function getpointbilityallasm(Request $request){
    try {

       $startDate = new Carbon('first day of this month');
     
$endDate = Carbon::now();
$all_dates = array();
while ($startDate->lte($endDate)){
  $all_dates[] = $startDate->toDateString();

  $startDate->addDay();
}
$users=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->get();
$obj=null;
$total_month_point = 0;
  foreach ($users as $key => $use) {

            $obj[$key]['id']=$use['id'];
            $obj[$key]['firstname']=$use['firstname'];
            $obj[$key]['lastname']=$use['lastname'];
            $obj[$key]['phone_1']=$use['phone_1'];
            $obj[$key]['image']=$use['image'];
            $obj[$key]['sale_rating']=$use['sale_rating'];
            $obj[$key]['recovery_rating']=$use['recovery_rating'];
            $obj[$key]['total_points']=$use['total_points'];
    $partyinasm=Subdistributor::select('id')->where('asm_id','=',$use['id'])->get()->toArray();
        
       foreach ($all_dates as $key2 => $value){
   
$bilties= Bilti::where('po_no',null)->where('po_no_raw',0)->where('po_no_adv',0)->wherein('party_id',$partyinasm)->where('delivered_date', $value)->get();
if(count($bilties) > 0){
foreach ($bilties as $key3 => $bil) {
      foreach ($bil->bilty_detail as $key4 => $bilty_detail) {
       
       $total_month_point = $total_month_point + $bilty_detail->points;

      }

}
 
}

    }
    $obj[$key]['Monthly_total_points'] = $total_month_point;
    $total_month_point = 0;
      
  }
        

        return API::response()->array(['success' => true,
            'message' => 'Asm Party sales and recovery monthly percentage ',
            'data'    => $obj], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

///// periorty set /// 

public function monthlyproductpriority(Request $request)
 {
    try {

        

         foreach ($request->products as $key => $value) {
            
             $MonthlyProduct = MonthlyProduct::where('product_id',$value['product_id'])->first();
          
            if($MonthlyProduct){
                $MonthlyProduct->priority = $value['priority'];
                $MonthlyProduct->save();

            }
             else{
                $MonthlyProduct  =   new  MonthlyProduct();
                  $MonthlyProduct->product_id = $value['product_id'];
                  $MonthlyProduct->priority = $value['priority'];
                  $MonthlyProduct->active = 1;
                  $MonthlyProduct->save();

              

             } 
         

                

        
    }
      return API::response()->array(['success' => true,
            
            'message' => 'monthly product periorty set',
            'data'    => $MonthlyProduct], 200);

    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}


/////////

public function getasmpointsproductwise(Request $request){


    try {

        
        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        //// overall date ////
          $start_tenure_date = '2021-02-01';
          $end_tenure_date   = date("Y-m-d");
        ////
        $total_points= 0;
        $all_total_points= 0;
        $obj=null;
        $getasms = [];

if($request->asm_id == 0){


  $users=User::select('id')->whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->get()->toArray();
  
  foreach ($users as $key => $user) {
      $getasms[] = $user['id'];
  }
 
    $asm_users   = Subdistributor::whereIn('asm_id',$getasms)->get();
    $products = Product::where('category_id',1)->where('show_rsm','!=' , 1)->get();

     foreach ($products as $key => $product) {

           $product_id = $product->id;

          foreach ($asm_users as $key2 => $asm_user) {
           $asm    = $asm_user->id;

         $biltys=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$startDate,$endDate])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id);
       }])->get();

         $allbilties=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$start_tenure_date,$end_tenure_date])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id);
       }])->get();

         foreach ($biltys as $key3 => $bilty) {


            if(count($bilty->bilty_detail) > 0) {

              foreach ($bilty->bilty_detail as $key4 => $value) {
               $total_points       = $total_points +  $value->points;

              }  

            }
        }
        foreach ($allbilties as  $bilt) {


            if(count($bilt->bilty_detail) > 0) {

              foreach ($bilt->bilty_detail as $key4 => $val) {
               $all_total_points       = $all_total_points +  $val->points;

              }
            
                
               

            }
        }
        
       

    }
       
         $obj[$key]=$product;
         $obj[$key]['images'] = $product->images;
         $obj[$key]['total_points']=$total_points;
         $obj[$key]['all_total_points']=$all_total_points;
       
         $all_total_points = 0;
         $total_points = 0;


        }


      }else{


        $asm_users   = Subdistributor::where('asm_id',$request->asm_id)->get();
        $products = Product::where('category_id',1)->where('show_rsm','!=' , 1)->get();

        foreach ($products as $key => $product) {

          $product_id = $product->id;


          foreach ($asm_users as $key2 => $asm_user) {
           $asm    = $asm_user->id;

         $biltys=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$startDate,$endDate])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id);
       }])->get();

         $allbilties=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$start_tenure_date,$end_tenure_date])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id);
       }])->get();


         foreach ($biltys as $key3 => $bilty) {


            if(count($bilty->bilty_detail) > 0) {

              foreach ($bilty->bilty_detail as $key4 => $value) {
               $total_points       = $total_points +  $value->points;

              }
            
                
               

            }
        }
           foreach ($allbilties as  $bilt) {


            if(count($bilt->bilty_detail) > 0) {

              foreach ($bilt->bilty_detail as $key4 => $val) {
               $all_total_points       = $all_total_points +  $val->points;

              }
            
                
               

            }
        }
       

    }
       
          $obj[$key]=$product;
         $obj[$key]['images'] = $product->images;
         $obj[$key]['total_points']=$total_points;
         $obj[$key]['all_total_points']=$all_total_points;
          $getpoints   = PointSystem::where('user_id',$request->asm_id)->where('product_id',$product_id)->first();
          if($getpoints){

            $obj[$key]['assigned_point']=$getpoints->points;
          }
       
        $all_total_points = 0;
         $total_points = 0;


        }



      }

        

    if(!empty($obj)){


        return API::response()->array((['success' => true, 'message' => 'All Bilties by product wise in asm ',
         'data' => $obj]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}

public function Updatepointstatus(Request $request)
 {
    try {

          //  return $request;
             $name = ['rsm','asm','dsf','ase'];   
          $userroles  =  Role::whereIn('name',$name)->get();
           foreach ($userroles as $key => $userrole) {
              $userrole->status_points = $request->status_points;
              $userrole->save();
           }

           return API::response()->array(['success' => true, 'message' => 'Point Status Update Sucessfully'], 200);

        
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function Showpointstatus(Request $request)
 {
    try {

          //  return $request;
             $name = ['rsm','asm','dsf','ase'];   
          $userroles  =  Role::whereIn('name',$name)->get();
          $obj = 0;
           foreach ($userroles as $key => $userrole) {
              if($userrole->status_points == 1){
                $obj = 1;
              }
              
           }

                 return API::response()->array(['success' => true,
                                       'message' => 'Show Status Sucessfully',
                                       'data' => $obj], 200);

        
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function getpointbilityasmprimary(Request $request){
  try {
 

 $asm_id = $request->asm_id;
 $start_date = $request->start_date;
    $end_date = $request->end_date;

    $obj = [];

//// dsf points ///
$totalDsfPoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'dsf' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=20 AND users.asm_id = '$asm_id')");


$obj['dsf_points'] = $totalDsfPoints;
 //$points[]=$dsfPoints;
//// ase point //
$totalasePoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'ase' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=9 AND users.asm_id = '$asm_id')");


$obj['ase_points'] = $totalasePoints;
 
 ///// asm secondary points ////
$asmordersQuery= DB::select("SELECT SUM(total_points) AS points FROM stock_bookings WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'asm_shop' AND stock_bookings.booked_by = '$asm_id'");

  $obj['asm_secondary'] = $asmordersQuery;

/////  asm primary  points //// 

  $asmordersPrimary= DB::select("SELECT SUM(total_points) AS points FROM biltis WHERE biltis.delivered_date >= '$start_date'  AND biltis.delivered_date <= '$end_date' AND biltis.po_no IS NULL  AND biltis.po_no_raw = 0 AND biltis.po_no_adv = 0  AND biltis.delivered_to_id = '$asm_id'");

$obj['asm_primary'] = $asmordersPrimary;

      $simple_array = array(); //simple array

      foreach($obj as $d)
      { 
            $simple_array[]=$d[0]->points; 

      }

      
      $done=array("dsf_points"=>$simple_array[0],"ase_points"=>$simple_array[1],"asm_secondary"=>$simple_array[2],"asm_primary"=>$simple_array[3],);

 return API::response()->array(['success' => true,
  'message' => 'shop order record list successfully ',
  'data' => $done], 200);
}

catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

//// list of asms primary secondary point /////
public function getpointbilityasmsprimary(Request $request){
  try {
 

 $asm_id = $request->asm_id;
 $start_date = $request->start_date;
    $end_date = $request->end_date;

    $obj = [];

  $users=User::whereHas('roles', function($query) {
        $query->where('name', '=', 'asm');
    })->get();


foreach ($users as $key => $user) {


    $asm_id = $user->id;

//// dsf points ///
$totalDsfPoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'dsf' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=20 AND users.asm_id = '$asm_id')");


$obj['dsf_points'] = $totalDsfPoints;
 //$points[]=$dsfPoints;
//// ase point //
$totalasePoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'ase' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=9 AND users.asm_id = '$asm_id')");


$obj['ase_points'] = $totalasePoints;
 
 ///// asm secondary points ////
$asmordersQuery= DB::select("SELECT SUM(total_points) AS points FROM stock_bookings WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'asm_shop' AND stock_bookings.booked_by = '$asm_id'");

  $obj['asm_secondary'] = $asmordersQuery;

/////  asm primary  points //// 

  $asmordersPrimary= DB::select("SELECT SUM(total_points) AS points FROM biltis WHERE biltis.delivered_date >= '$start_date'  AND biltis.delivered_date <= '$end_date' AND biltis.po_no IS NULL  AND biltis.po_no_raw = 0 AND biltis.po_no_adv = 0  AND biltis.delivered_to_id = '$asm_id'");

$obj['asm_primary'] = $asmordersPrimary;

      $simple_array = array(); //simple array

      foreach($obj as $d)
      { 
            $simple_array[]=$d[0]->points; 

      }

      $done[$key]['user']['id']=$user->id;
      $done[$key]['user']['name']=$user->firstname.' '.$user->lastname;
 
      $done[$key]['points']=array("dsf_points"=>$simple_array[0],"ase_points"=>$simple_array[1],"asm_secondary"=>$simple_array[2],"asm_primary"=>$simple_array[3],);

    }

 return API::response()->array(['success' => true,
  'message' => 'shop order record list successfully ',
  'data' => $done], 200);
}

catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

/// list of rsm in asm primary  points secondary ..... /////

public function getpointbilityrsmasmsprimary(Request $request){
  try {
 

 $rsm_id = $request->rsm_id;
 $start_date = $request->start_date;
    $end_date = $request->end_date;

    $obj = [];

    $obj2 = [];



if($rsm_id == 0){
  $rsms=User::whereHas('roles', function($query) {
        $query->where('name', '=', 'rsm');
    })->get();
}
if($rsm_id > 0){

$rsms=User::where('id',$rsm_id)->get();

}


foreach ($rsms as $key => $rsm) {

   $obj2[$key]['id'] = $rsm->id;
   $obj2[$key]['name'] = $rsm->firstname.' '.$rsm->lastname;
   $obj2[$key]['image'] = $rsm->image;
  $users=User::whereHas('roles', function($query) {
        $query->where('name', '=', 'asm');
    })->where('rsm_id',$rsm->id)->get();


foreach ($users as $key1 => $user) {


    $asm_id = $user->id;




     $obj2[$key]['asm'][$key1]['id']=$user->id;
     $obj2[$key]['asm'][$key1]['name']=$user->firstname.' '.$user->lastname;
     $obj2[$key]['asm'][$key1]['image']=$user->image;

    

//// dsf points ///
$totalDsfPoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'dsf' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=20 AND users.asm_id = '$asm_id')");


$obj['dsf_points'] = $totalDsfPoints;
 //$points[]=$dsfPoints;
//// ase point //
$totalasePoints = DB::select("SELECT SUM(total_points) AS points FROM stock_bookings  WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'ase' AND  booked_by  IN (SELECT users.id FROM users JOIN role_user WHERE role_user.user_id=users.id AND role_user.role_id=9 AND users.asm_id = '$asm_id')");


$obj['ase_points'] = $totalasePoints;
 
 ///// asm secondary points ////
$asmordersQuery= DB::select("SELECT SUM(total_points) AS points FROM stock_bookings WHERE stock_bookings.date >= '$start_date'  AND stock_bookings.date <= '$end_date' AND stock_bookings.party_check = 'asm_shop' AND stock_bookings.booked_by = '$asm_id'");

  $obj['asm_secondary'] = $asmordersQuery;

/////  asm primary  points //// 

  $asmordersPrimary= DB::select("SELECT SUM(total_points) AS points FROM biltis WHERE biltis.delivered_date >= '$start_date'  AND biltis.delivered_date <= '$end_date' AND biltis.po_no IS NULL  AND biltis.po_no_raw = 0 AND biltis.po_no_adv = 0  AND biltis.delivered_to_id = '$asm_id'");

$obj['asm_primary'] = $asmordersPrimary;

      $simple_array = array(); //simple array

      foreach($obj as $d)
      { 
            $simple_array[]=$d[0]->points; 

      }

     
 
     $obj2[$key]['asm'][$key1]['points']=array("dsf_points"=>$simple_array[0],"ase_points"=>$simple_array[1],"asm_secondary"=>$simple_array[2],"asm_primary"=>$simple_array[3],);


   

    }

  }

 return API::response()->array(['success' => true,
  'message' => 'shop order record list successfully ',
  'data' => $obj2], 200);
}

catch(Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}





}
