<?php

namespace App\Http\Controllers;

use App\Models\Order;
use Dingo\Api\Facade\API;
use Illuminate\Http\Request;
use League\Flysystem\Exception;
use App\Models\Product;
use App\Models\PartyName;
use App\Models\ProductImage;
use App\Models\MonthlyProduct;
use App\Models\ProductPrice;
use App\Models\PaymentRemark;
use App\Models\PartyRates;
use App\Models\User;
use App\Models\Bilti;
use App\Models\BiltiDetail;
use DateTime;
use DatePeriod;
use DateInterval;
use DB;

class ProductController extends BaseController
{
    /***
     * @var Product
     */
    private $_productModel;

    /***
     * Constructor
     *
     * @param $request
     * @param Product $productModel
     */
    public function __construct(Request $request, Product $productModel)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_productModel = $productModel;
    }

    /***
     * List Products
     *
     * @param $request
     * @return mixed
     */
//    public function listProducts(Request $request)
//    {
//        try {
//            $userId = $request->get('user_id');
//            $agencyId = $request->get('agency_id');
//            $page = $request->get('page', 1);
//            $avoidPagination = $request->get('avoid_pagination', false);
//
//            if(IsNullOrEmptyString($userId)) {
//                $userId = $this->getUserIdFromToken($request);
//            }
//            if(IsNullOrEmptyString($agencyId)) {
//                $userModel = new User();
//                $agencyId = $userModel->getUserAgencyId($userId);
//            }
//
////            $products = $this->_productModel->getProducts($agencyId, $avoidPagination, $page);
//            $products = Product::where('agency_id',$agencyId)->get();
//        }
//        catch(Exception $e)
//        {
//            return API::response()->array(['success' => false,
//                                           'message' => $e->getTraceAsString()], 400);
//        }
//        return API::response()->array(['success' => true, 'message' => 'Products found',
//            'data' => $products], 200);
//    }
       public function listProducts(Request $request)
    {
        try {

            $userId = $request->get('user_id');
            $agencyId = $request->get('agency_id');

            $page = $request->get('page', 1);
            $avoidPagination = $request->get('avoid_pagination', false);
            $userrole = null;
            if(IsNullOrEmptyString($userId)) {
                $userId = $this->getUserIdFromToken($request);
                $userrole = $this->getUserRole($userId);

            }
            if(IsNullOrEmptyString($agencyId)) {
                $userModel = new User();
                $agencyId = $userModel->getUserAgencyId($userId);

            }

//            $products = $this->_productModel->getProducts($agencyId, $avoidPagination, $page);
//            $products = Product::where('agency_id',$agencyId)->get();
            $products = $this->_productModel->getProductsPrices($agencyId,$userrole);
        }

        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Products found',
            'data' => $products], 200);
    }
    
    public function InsertProduct(Request $request)
    {
      
      try {  
        $product= new Product();
        $product->name= $request->name;
        $product->category_id= 1;
        $product->agency_id =  1;
        $product->po_vendor_id = $request->po_vendor_id;
        $product->type= "Cream";
        $product->product_code= 0;
        $product->cotton= $request->cotton;
        $product->tp_rate= 0;

        $product->is_scheme=0;
        $product->scheme_quantity=null;
        $product->scheme_free_quantity=null;

        $product->vendor_price = $request->vendor_price/12;

        $product->show_rsm = $request->show_rsm;

        $product->save();
 
        
               
                    $discount=  new ProductPrice();
                    $discount->product_id=$product->id;
                    $discount->currency_id=1;
                    $discount->retail_price=$request->price/12;
                    $discount->wholesale_price=$request->price/12;
                    $discount->distributor_price=$request->price/12;
                    $discount->vendor_price = $request->vendor_price;
                    $discount->discount = $request->discount;
                   $discount->save();
                 
                  $MonthlyProduct  =   new  MonthlyProduct();
                  $MonthlyProduct->product_id = $product->id;
                  $MonthlyProduct->point = 1;
                  $MonthlyProduct->save();


                    if(!empty($request->images)) {
        
        foreach($request->images as $imagee) {
              $image    = $imagee['image'];
            $image = upload_base64_image($image, 'uploads/bilty/',
                'image-');

            $ProductImage = new ProductImage();

            $ProductImage->image_url =  'http://'.$image;
            $ProductImage->product_id = $product->id;
            $ProductImage->save();
        }
        
    }
  
  }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }

        return API::response()->array(['success' => true, 'message' => 'Products added successfully'], 200);
                
}
    
    
    public function advrtsmntProducts(Request $request)
    {
        try {
           $obj= Product::where('category_id',$request->get('category_id'))->with(['images'])->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Products found',
            'data' => $obj], 200);
    }

    /***
     * Get Product Detail
     *
     * @param $productId
     * @return mixed
     */
    public function productDetail($productId)
    {
        try {
            $product = $this->_productModel->getProductDetail($productId);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => is_null($product) ? 'Product not found' : 'Product found',
                                       'data' => $product], 200);
    }
    // productSalesDetail
    public function productSalesDetail(Request $request)
    {
        try {
            $orders=Order::select('orders.id','orders.booked_by','orders.date_to_deliver','products.name','order_products.product_id','order_products.quantity','order_products.scheme_free_quantity')
                ->where('booked_by',$request->get('so_id'))
                ->where('status','Delivered')
                ->where('order_products.product_id',$request->get('product_id'))
                ->whereBetween('date_to_deliver', [$request->get('start_date'), $request->get('end_date')])
                ->orderBy('date_to_deliver')
                ->join('order_products', 'orders.id', '=', 'order_products.order_id')
                ->join('products', 'products.id', '=', 'order_products.product_id')
                ->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => is_null($orders) ? 'Orders Product Details not found' : 'Orders Product Details found',
                                       'data' => $orders], 200);
    }
    // productSalesDetail
    public function productSalesDetailCustomer(Request $request)
    {
        try {
            $product_id=$request->get('product_id');
            $orders=Order::select('id','shop_id')
                ->where('booked_by',$request->get('so_id'))
                ->where('status','Delivered')
                ->whereBetween('date_to_deliver', [$request->get('start_date'), $request->get('end_date')])
                ->orderBy('date_to_deliver')
                ->with(['customer'=>function($query){return $query->select('id','name')->with('images');},'order_products'=>function($query)use($product_id){return $query->where('product_id',$product_id);}])
                ->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => is_null($orders) ? 'Orders Product Details not found' : 'Orders Product Details found',
                                       'data' => $orders], 200);
    }
    
   
       public function monthlyproductsalepercentage(Request $request){
        try {



            $start    = (new DateTime($request->start_date))->modify('first day of this month');
$end      = (new DateTime($request->end_date))->modify('first day of next month');
$interval = DateInterval::createFromDateString('1 month');
$period   = new DatePeriod($start, $interval, $end);
$obj = null;
$products = Product::where('category_id', 1)->get();

$rsm_id = $request->rsm_id;
$party = $request->party_id;
if($request->rsm_id == 0  ){

    $end = dateset($request->end_date);
    
 $bilty_id=$this->tenureproductBilty($request->start_date,$end,$party,$rsm_id);


            $party_id=Bilti::select('id')->wherein('id',$bilty_id)->get()->toarray();
          } else{
          $start  = $request->start_date;
         $end = dateset($request->end_date);
        $party=$this->rsmPartybility($request->start_date,$request->end_date,$request->party_id,$request->rsm_id);
         

          $party_id=Bilti::select('id')->wherein('party_id',$party)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get()->toarray();
         
          
          }
      

$sum = 0;
$bilty =[];
foreach ($products as $key => $product) {

                      


                $obj[$key]['id']=$product->id;
                $obj[$key]['name']=$product->name;

                 foreach ($period as $key2=> $dt) {
                            
                        $start_date[$key2] = $dt->format("Y-m-00");

                         $end_date[$key2] =  $dt->add($interval)->format("Y-m-00");


                         $obj[$key]['monthly_sales'][$key2]['date']= $start_date[$key2];

                  $obj[$key]['monthly_sales'][$key2]['qty']=BiltiDetail::
                            where('product_id',$product->id)->wherein('bilti_id',$party_id)
                            ->whereBetween('delivered_date',[$start_date[$key2],$end_date[$key2]])
                            ->sum('quantity');                   
        
}

}

            return API::response()->array(['success' => true,
                'message' => 'Party sales ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }


      public function tenureproductBilty($start,$end,$party_id = 0,$rsm_id=0){
        //5000 shah filter
  $start    = $start . '-00';
   $end =  $end;

   


    $bil=Bilti::query();

      if($rsm_id!=0){
      
      $bil=$bil->where('delivered_to_id',$rsm_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end]);
     
  }
  if($party_id!=0){
     if($party_id==5000){

    $party_id = PartyName::select('id')->whereNotIn('id', [19,20,33])->where('region_id','!=' , 2)->get();

    $bil=$bil->wherein('party_id',$party_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();
  
}elseif($party_id==5001){
//            export 50001 filter

    $party_id = PartyName::select('id')->whereNotIn('id', [19,20,33])->where('region_id','=' , 2)->get();
   
    $bil=$bil->wherein('party_id',$party_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();
     
    
}

else{

    $bil=$bil->where('party_id',$party_id)->whereNotIn('id', [19,20,33])->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();

}
}
else{

    
   
 
$bil=$bil->whereBetween('delivered_date', [$start, $end])->whereNotIn('party_id', [19,20,33])->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->get();

}

$bil_id=[];
if(!empty($bil)){

    foreach ($bil as $bi){
        $bil_id []=$bi['id'];
    }
}
return $bil_id;
}

public function rsmPartybility($start,$end,$part_id=0,$rsm_id=0){

    $obj = [];
    if($rsm_id!=0){


        $user = User::where('id',$rsm_id)->first();

        $region_id = $user->region_id;
        if(!empty($region_id)){
            $party= PartyName::where('region_id',$region_id)->get();

            foreach ($party as $key=>$pa){

                $obj[$key]=$pa['id'];

            }

        }
        return $obj;

    }        

}
      public function partyratesupdates(Request $request){
        try {

        

            $user = User::where('id',$request->user_id)->first();

            $name =  $user->firstname . ' ' .  $user->lastname;

            $old  =  PartyRates::where('party_id',$request->party_id)->where('product_id',$request->product_id)->first();
           
            if($old){
                
                $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $request->product_id;
                 $paymentRemark->party_id = $request->party_id;
                $paymentRemark->type = "party_rates_update";
                $remark = "user: ". $name ." updated the price"."<br>old price is: " . $old->price."<br> new price:" .  $request->price;

      
                $paymentRemark->remarks = $remark;
                $paymentRemark->save();

                $old->price = $request->price;
                $old->save();
                return API::response()->array(['success' => true, 'message' => 'party rate Updated ',
        'data' => $old], 200);

                }
                else{

                      $PartyRates  =   new  PartyRates();
                      $PartyRates->party_id = $request->party_id;
                      $PartyRates->product_id = $request->product_id;
                      $PartyRates->price =  $request->price;
                      $PartyRates->save();

                       $paymentRemark  =   new  PaymentRemark();
                    $paymentRemark->rsm_id = $request->product_id;
                    $paymentRemark->party_id = $request->party_id;
                  $paymentRemark->type = "party_rates_update";
                   $remark = "user: ". $name ." added the product"."<br> price is: " . $request->price;
                   $paymentRemark->remarks = $remark;
                $paymentRemark->save();

                 return API::response()->array(['success' => true, 'message' => 'party rate added ',
        'data' => $PartyRates], 200);



                }
                

                 
                
                 } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function getpartyratesupdates(Request $request){
        try {

            $product_log  =  PaymentRemark::where('rsm_id',$request->product_id)->where('party_id',$request->party_id)->where('type','party_rates_update')->get();
           
            if($product_log){
                 return API::response()->array(['success' => true, 'message' => 'party rate Updated ',
              'data' => $product_log], 200);
                    
                }
                else{
                     return API::response()->array(['success' => true, 'message' => 'party rate Updated ',
        'data' => $product_log], 200);

                }
                

                
                
                 } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function savedateinbilitydetail(Request $request){
        try {

            $bilty  =  Bilti::get();


            if($bilty){
              
                foreach ($bilty as $key => $bil) {
                  $date = $bil->delivered_date;

                $BiltiDetails  = BiltiDetail::where('bilti_id',$bil->id)->get();
                if($BiltiDetails){
                foreach ($BiltiDetails as $key => $BiltiDet) {

                  $BiltiDet->delivered_date = $date;
                  $BiltiDet->save();
                  
                }
              }
                  
                }
                return API::response()->array(['success' => true, 'message' => 'date added '], 200);
                    
                }
                else{
                     return API::response()->array(['success' => true, 'message' => 'party rate Updated ',
        'data' => $product_log], 200);

                }
                

                
                
                 } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function productpriorityset(Request $request){
        try {

           
               foreach ($request->products as $key => $value) {

                  Product::where('id',$value['id'])->update(array('priority' => $value['priority']));
               }

                return API::response()->array(['success' => true, 'message' => 'Product priority updated successfully '], 200);
                    
                }
                
                  catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

}