<?php

namespace App\Http\Controllers;

use App\Models\RawMaterial;
use App\Models\RawMaterialInvoice;
use App\Models\RawProductVendor;
use Illuminate\Http\Request;
use App\Models\UserExpense;
use Dingo\Api\Facade\API;
use App\Models\ProductRaw;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\RawMaterialAdjustment;
use App\Models\PaymentRemark;
use App\Models\InventoryReport;
use League\Flysystem\Exception;
use DB;

class RawMaterialController extends Controller
{
  public function addRawMaterial(Request $request)
 {
    try {


        $find=RawMaterial::where('id',$request->get('id'))->first();
        if(!empty($find) && $find->id==$request->get('id'))

        {
          
         
            $image=$find->image;
            if(!empty($request->get('image'))) {

                $image = upload_base64_image($request->get('image'), 'uploads/userExpense/',
                    'image-');

                $image =  'http://'.$image;


            }
            //return $request->vendor_id;
          //return $find->vendor_id;
        //  $vendor = array($find->vendor_id);
          
          // array_push($vendor,$request->vendor_id);
         // return $vendor;
           $sumqty = $request->get('quantity') + $find->quantity;

            $find->update(['name'=>$request->get('name'),'multi_used'=>$request->get('multi_used'),'unit'=>$request->get('unit'),'price'=>$request->get('price'),'quantity' => $sumqty,'threshold'=>$request->get('threshold'),
                'vendor_id'=>$request->get('vendor_id'),'image'=>$image]);

              $find_vendor = RawProductVendor::where('raw_id',$find->id)->where('vendor_id',$request->vendor_id)->first();
              
              if(!empty($find_vendor)){

                if(isset($request->price)){
                  
         $check  = $find_vendor->price - $request->price;
          if($check != 0){

                $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $find->id;
                $paymentRemark->type = "Raw_Price_Update";
                $remark ="vendor name:".$find_vendor->vendor->firstname ."<br> Privious Price:" . $find_vendor->price."<br> New Price:" .  $request->get('price')."<br>";

                $paymentRemark->remarks = $remark;
                $paymentRemark->user_remarks = $request->remarks;
                $paymentRemark->user_id = $request->user_id;


                $paymentRemark->save();

          }
       }

            $find_vendor->update(['price' =>$request->get('price')]);
        }else
        {
            $objvendor = new RawProductVendor();
            $objvendor->raw_id = $find->id;
            $objvendor->vendor_id = $request->get('vendor_id');
            $objvendor->quantity =  $request->get('quantity');
            $objvendor->price = $request->get('price');
            $objvendor->save();


        }

      }
        else{
            $obj=new RawMaterial();

            $obj->name=$request->get('name');
            $obj->unit=$request->get('unit');
            $obj->price=$request->get('price');
            $obj->quantity = $request->get('quantity');
            $obj->opening_balance = $request->get('quantity');
            $obj->threshold = $request->get('threshold');
            $obj->multi_used = $request->get('multi_used');
            $obj->vendor_id=$request->get('vendor_id');
            if(!empty($request->get('image'))) {

                $image = upload_base64_image($request->get('image'), 'uploads/userExpense/',
                    'image-');

                $obj->image =  'http://'.$image;


            }
            $obj->save();

            $objvendor = new RawProductVendor();
            $objvendor->raw_id = $obj->id;
            $objvendor->vendor_id = $request->get('vendor_id');;
            $objvendor->quantity =  $request->get('quantity');
            $objvendor->price = $request->get('price');
            $objvendor->save();

        }


        return API::response()->array(['success' => true,
            'message' => 'Raw Material Added',
            'data' => $find], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}

public function GetRawMaterial(Request $request)
{
    try {

        if($request->get('vendor_id') == 0){
           

               
               $obj= RawMaterial::with(['raw_product_vendors'=>function($query)
                {
                  $query->with(['vendor']);
                },'product_raw_details'=>function($query)
                 {$query->with(['product']);},])->get();


            
        }
        else
        {

           $vendor = $request->get('vendor_id');
          $obj= RawMaterial::where('id',$request->get('rsm_id'))->with(['raw_product_vendors'=>function($query) use ($vendor)
                {
                  $query->where('vendor_id',$vendor)->with(['vendor']);
                },'product_raw_details'=>function($query)
                 {$query->with(['product']);},])->get();


          /*
          $obj= RawProductVendor::where('vendor_id',$request->get('vendor_id'))->with(['vendor','RawMaterial'=>function($query)
          {
            $query->with(['product_raw_details'=>function($querry)
                 {$querry->with(['product']);}]);
          }
        ])->get();

          */


        
        }


        return API::response()->array(['success' => true,
            'message' => 'RawMaterials Retrirved',
            'data' => $obj], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}


   public  function rawadjustment(Request $request){

    try {
       $adjust = new RawMaterialAdjustment();

    $adjust->qty=$request->quantity;
    $adjust->comments =$request->remarks;
    $adjust->type=$request->type;
     $adjust->raw_id = $request->id;
     
     $adjust->save();

    if($adjust->type == 'Add'){
    
      $qty  =  $adjust->qty + $adjust->RawMaterial->quantity;
     
    $adjust->RawMaterial->update(['quantity'=> $qty]);

    $RawProductVendor = RawProductVendor::where('raw_id',$request->id)->where('vendor_id',$request->vendor_id)->first();

    $RawProductVendor->quantity =$adjust->qty + $RawProductVendor->quantity;

    $RawProductVendor->save();

    }
    if($adjust->type == 'Minus'){
      $qty  = $adjust->RawMaterial->quantity - $adjust->qty;
   $adjust->RawMaterial->update(['quantity'=> $qty]);

   $RawProductVendor = RawProductVendor::where('raw_id',$request->id)->where('vendor_id',$request->vendor_id)->first();

    $RawProductVendor->quantity = $RawProductVendor->quantity-$adjust->qty;

    $RawProductVendor->save();
    }
    //$adjust->save();

    return API::response()->array(['success' => true,
            'message' => 'RawMaterials Updated'], 200);

      

  }
  catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}




  public function GetRawMaterialsingle(Request $request)
{
    try {

           
            
              $obj= RawMaterial::where('id',$request->id)->with(['logs'=>function($query){
              $query->with('user_detail');
            },'raw_product_vendors'=>function($query){
              $query->with('vendor');
            },'product_raw_details'=>function($query)
                 {$query->with(['product','sub_product']);},])->first();
       


        return API::response()->array(['success' => true,
            'message' => 'RawMaterials Retrirved',
            'data' => $obj], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}


public function addbundle(Request $request)
{

    try {
        $flag = 0 ; 
        foreach ($request->raw_detail as $key => $raw) {

            if ($flag == 0){
              if($raw['product_category_id'] == 0){
            $objs=ProductRaw::where('product_id',$raw['product_id'])->get();
            }
            else
            {
               $objs=ProductRaw::where('sub_product_id',$raw['product_category_id'])->get();

            }
         if(!empty($objs))

         {
          foreach($objs as $pro) {
            $RaMaterial=RawMaterial::where('id',$pro->raw_id)->first();
            $RaMaterial->used = 0;
            $RaMaterial->save();

              $pro->delete();
          }
      }
  } 
  $flag = 1;

      $RMaterial=RawMaterial::where('id',$raw['raw_id'])->first();


      $RMaterial->update(['used'=>1]);


      $obj=new ProductRaw();

      $obj->product_id=$raw['product_id'];
      $obj->raw_id=$raw['raw_id'];
      $obj->bundle= $raw['bundle'];
      $obj->sub_product_id = $raw['product_category_id'];
      $obj->save();

            //}
  }

  return API::response()->array(['success' => true,
    'message' => 'Product bundle Added',
    'data' => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

////add prduct raw bundle ////
public function addproductbundle(Request $request)
{

    try {
      
      $RMaterial=RawMaterial::where('id',$request->raw_id)->first();


      $RMaterial->update(['used'=>1]);

     $product_raw=ProductRaw::where('raw_id',$request->raw_id)->where('product_id',$request->product_id)->where('sub_product_id',$request->product_category_id)->first();

     

     if($product_raw){

      return API::response()->array(['success' => true,
    'message' => 'bundle all ready Added'], 200);
     }else{

      $obj=new ProductRaw();

      $obj->product_id=$request->product_id;
      $obj->raw_id=$request->raw_id;
      $obj->bundle= $request->bundle;
      $obj->sub_product_id = $request->product_category_id;
      $obj->save();

    }

            
  

  return API::response()->array(['success' => true,
    'message' => 'Product bundle Added',
    'data' => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function destroybundle(Request $request)
{
 
    try{

        $product_raw=ProductRaw::where('id',$request->id)->first();
        if($product_raw){

          $product_raw->delete();
        }else{

           return API::response()->array(['success' => false,
        'message' => 'Data not found'], 400);
        }
       
      return API::response()->array(['success' => true,
        'message' => 'Delete Sucessfully'], 200);
  }
  catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

}
public function editbundle(Request $request)
{
 
    try{

        $product_raw=ProductRaw::where('id',$request->id)->first();

        if($product_raw){

      $product_raw->bundle= $request->bundle;
     
 

          $product_raw->save();
        }else{

           return API::response()->array(['success' => false,
        'message' => 'Data not found'], 400);
        }
       
      return API::response()->array(['success' => true,
        'message' => 'edit bundle Sucessfully'], 200);
  }
  catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

}




    ////// 1////3////2020////

public function getbundle(Request $request)
{
    try {
           
      if ($request->product_category_id == 0){
       $pro_obj=Product::where('id',$request->get('product_id'))->with(['raw_product'=>function($query)
                    {$query->with('RawMaterial');}])->first();
      }
      else
      {
                     $pro_obj=ProductCategory::where('id',$request->get('product_category_id'))->with(['raw_product'=>function($query)
                    {$query->with('RawMaterial');}])->first();

         
          //   return $pro_obj;
      }
       return API::response()->array(['success' => true,
        'message' => 'Product bundle Added',
        'data' => $pro_obj], 200);



   } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}


public function getRawMaterialAdjustment(Request $request)
{
    try{
       $raw_id = $request->get('id');
      if(!empty($raw_id)){
        $pro_obj=RawMaterialAdjustment::where('raw_id',$raw_id)->with(['RawMaterial'])->get();
     
       return API::response()->array(['success' => true,
        'message' => 'RawMaterialAdjustment',
        'data' => $pro_obj], 200);
     }
       else
       {
        $pro_obj=RawMaterialAdjustment::with(['RawMaterial'])->get();
     
       return API::response()->array(['success' => true,
        'message' => 'RawMaterialAdjustment',
        'data' => $pro_obj], 200);
       }
  }
  catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

}
public function testingRoute(Request $request)
    {

        try {
         $RMaterial=RawMaterial::get();
        foreach ($RMaterial as $key => $RMaterial) {
            $objvendor = new RawProductVendor();
            $objvendor->raw_id = $RMaterial->id;
            $objvendor->vendor_id = $RMaterial->vendor_id;
            $objvendor->quantity =   $RMaterial->quantity;
            $objvendor->price =  $RMaterial->price;
            $objvendor->save();


           # code...
         } 
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Order Status Changed',
         'data' => $order], 200);
    }


  public function testinginvtory(Request $request)
    {

        try {
         $InventoryReports=InventoryReport::get();
        foreach ($InventoryReports as $key => $InventoryReport) {

            $RawProductVendor = RawProductVendor::where('raw_id', $InventoryReport->raw_materiel_id)->first();
            
          $price =  $RawProductVendor->price * $InventoryReport->total_qty;
          
          
            $InventoryReport->price = $price;
        
            $InventoryReport->save();


           # code...
         } 
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'InventoryReport updated',
         'data' => $order], 200);
    }

    public function updatenewrawmaterialquantity(Request $request){

 try {
   $RAWMaterials=RawMaterial::get();
    $sum = null;
   $inv_sum = null;
   $adjustval=null;
   foreach ($RAWMaterials as $key => $RAWMaterial) {
     # code...
   
   
  
   foreach ($RAWMaterial->bilty_detail as $key => $bilty_detail) {

     $type  = $bilty_detail->bilty->bilty_stock_order;
 
     if($type->type == "Raw"){

      $sum   = $sum+$bilty_detail->quantity;
     }
   };
   
      $total = $RAWMaterial->opening_balance+$sum;
     
     $adjusts = RawMaterialAdjustment::where('raw_id',$RAWMaterial->id)->get();
    
     foreach ($adjusts as $key => $adjust) {
       if($adjust->type == "Add"){
        $adjustval = $adjustval+$adjust->qty;
       }
      if($adjust->type == 'Minus'){
         $adjustval = $adjustval-$adjust->qty;

      }

    }

    $Amount = $adjustval+$total;
    
   $outs = InventoryReport::where('raw_materiel_id',$RAWMaterial->id)->get();

   foreach ($outs as $key => $out) {

     $inv_sum = $inv_sum+ $out->total_qty;
   }

   $andamount = $Amount-$inv_sum;
   
   $RAWMaterial->quantity = $andamount;

   $RAWMaterial->save();
   
   $sum = null;
   $inv_sum = null;
   $adjustval=null;

 }
}
  catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RawMaterial value updated',
         'data' => $order], 200);



    } 

public function RawMaterialImageUpdate(Request $request){
      try{
         $RMaterial=RawMaterial::where('id',$request->raw_id)->first();
      if(!empty($request->image)) {

                $image = upload_base64_image($request->image, 'uploads/userExpense/',
                    'image-');

                $RMaterial->image =  'http://'.$image;

                $RMaterial->save();

            }
            return API::response()->array(['success' => true, 'message' => 'Image updated successfully'], 200);
            
    }
    catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }

    } 


}
