<?php
/**
 * Created by PhpStorm.
 * User: Ali
 * Date: 7/30/2018
 * Time: 12:21 PM
 */

namespace App\Http\Controllers;

use App\Models\Bilti;
use App\Models\BiltiDetail;
use App\Models\ProductVariation;
use App\Models\BiltyAdda;
use App\Models\VendorDetail;
use App\Models\VendorInvoice;
use Carbon\Carbon;
use DateTime;
use DatePeriod;
use DateInterval;
use App\Models\RawProductVendor;

use App\Models\Customer;
use App\Models\DistributerStockDetail;

use App\Models\Order;
use App\Models\VendorInvoiceDetails;
use App\Models\RawMaterial;
use App\Models\OrderProduct;
use App\Models\PartyName;
use App\Models\PartyRates;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\Product;
use App\Models\ProductPrice;
use App\Models\PushNotificationToken;
use App\Models\Region;
use App\Models\RsmPayment;
use App\Models\SoStock;
use App\Models\StockBooking;
use App\Models\StockbookingImage;
use App\Models\StockBookingAdda;
use App\Models\StockBookingDetail;
use App\Models\StockBookingDetailCategory;
use App\Models\SoStockDetail;
use App\Models\User;
use App\Models\UserExpenseDetail;
use App\Models\WareHouse;
use App\Models\WarehouseStocks;
use App\Models\WarehouseStockVariant;
use Dingo\Api\Facade\API;
use App\Models\DistributerStock;
use App\Models\StockAdjustmentProduct;
use App\Models\Soadjustmentlog;

use Illuminate\Http\Request;
use App\Models\PaymentRemark;
use Edujugon\PushNotification\PushNotification;
use DB;
class StockController extends BaseController
{
    public function __construct(Request $request )
    {
        set_time_limit(8000000);
        parent::__construct($request);
    }
    public function getdistributerStock(Request $request){
        try {
                $dis_stock =  DistributerStock::where('shop_id',$request->get('shop_id'))
                    ->where('asm_id',$request->get('asm_id'))
                    ->where('date',$request->get('date'))
                    ->with(['stock_details'=>function($query){return $query->with('product');}])
                    ->first();
            return API::response()->array(['success' => true,
                'message' => 'Distributer Stock  ',
                'data'    => $dis_stock], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function distributerStock(Request $request){
        try {
            $dis_stoc=DistributerStock::where('shop_id',$request->get('shop_id'))
                     ->where('asm_id',$request->get('asm_id'))
                     ->where('date',$request->get('date'))->first();
            if(!empty($dis_stoc)){
                return API::response()->array(['success' => false,
                    'message' => 'You already added Stock']);
            }

                $dis_stock = new DistributerStock();
                $dis_stock->shop_id=$request->get('shop_id');
                $dis_stock->asm_id=$request->get('asm_id');
                $dis_stock->date=$request->get('date');
                $dis_stock->save();
                if(count($request->get('products')>0)){
                    foreach ($request->get('products') as $stock){
                        $detail=new DistributerStockDetail();
                        $detail->distributer_stock_id=$dis_stock->id;
                        $detail->product_id=$stock['product_id'];
                        $detail->quantity=$stock['quantity'];
                        $detail->remaining=$stock['quantity'];
                        $detail->booked=0;
                        $detail->save();
                    }
                }
            return API::response()->array(['success' => true,
                'message' => 'Distributer Stock added ',
                'data'    => $dis_stock], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function mainSupplier(){
        try {
            $dis_stoc = User::whereHas('roles', function($query) {
                $query->where('name', '=', 'main_su');
            })->get();

            return API::response()->array(['success' => true,
                'message' => 'Main Suppliers ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockBooking(Request $request){
        try {
            $dis_stoc=new StockBooking();
            $dis_stoc->booked_by=$request->get('booked_by');
            $dis_stoc->date=$request->get('date');
            $dis_stoc->remarks=$request->get('remarks');
            $dis_stoc->zone=$request->get('zone');
            $dis_stoc->status='Booked';
            $dis_stoc->save();
            if(count($request->get('products'))>0){
                foreach ($request->get('products') as $stock){
                    $d_stock=new StockBookingDetail();
                    $d_stock->stock_booking_id=$dis_stoc->id;
                    $d_stock->product_id=$stock['product_id'];
                    $d_stock->quantity=$stock['quantity']*12;
                    $d_stock->save();
                    if(count($stock['product_category'])>0){
                        foreach ($stock['product_category'] as $category){
                            $cat=new StockBookingDetailCategory();
                            $cat->stock_booking_detail_id=$d_stock->id;
                            $cat->product_category_id=$category['id'];
                            $cat->quantity=$category['quantity']*12;
                            $cat->delivered=0;
                            $cat->save();
                        }
                    }
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    


  


  public function logproductadjust(Request $request){
         
        try {
         
       
             
        $stocklog = StockAdjustmentProduct::where('id',$request->id)->with('log_details')->first();
        return  $stocklog;
     
            if($stocklog){
                
                      return API::response()->array(['success' => true,
                'message' => 'stock adjustment detail',
                'data'    => $stocklog], 200);
            }else{
                  return API::response()->array(['success' => false,
                'message' => 'no record found'], 200);
                
            }
    
          
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

    
    
    
    
    
     public function addpoNumber(Request $request){
         
        try {
            $dis_stoc=PoNumber::where('user_id',$request->get('user_id'))
                ->where('stock_booking_id',$request->get('stock_booking_id'))
                ->first();
                
                
            if(empty($dis_stoc) && empty($dis_stoc['po_number'])){
                
                $dis_stoc=new PoNumber();
                
                     $dis_stoc=new PoNumber();
                $max_num = PoNumber::max('po_number_raw');
                $max_num2=PoNumber::max('po_number');
                $newpo=0;
                if($max_num>$max_num2)
                
                {
                      $newpo=$max_num;
                }
                
                else {
                         $newpo=$max_num2;
                    }
                
               
//                dd((int)$max_num + 1);
                $dis_stoc->po_number = (int)$newpo + 1;
                
               
                $dis_stoc->remarks =$request->get('remarks');
                $dis_stoc->user_id=$request->get('user_id');
                $dis_stoc->date=date('Y-m-d');
                $dis_stoc->stock_booking_id=$request->get('stock_booking_id');
                $dis_stoc->save();
            }else{
                return API::response()->array(['success' => false,
                    'message' => 'PO number already created',
                    'data'    => $dis_stoc], 400);
            }
            return API::response()->array(['success' => true,
                'message' => 'PO number added ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function addpoNumberAdv(Request $request){
        try {
            $dis_stoc=PoNumber::where('user_id',$request->get('user_id'))
                ->where('stock_booking_id',$request->get('stock_booking_id'))
                ->first();
            if(empty($dis_stoc) && empty($dis_stoc['po_number'])){
               $dis_stoc=new PoNumber();
              
                $max_num_adv = PoNumber::max('po_number_adv');
                
            
               
               
//                dd((int)$max_num + 1);
                $dis_stoc->po_number_adv = (int)$max_num_adv + 1;
                $dis_stoc->remarks =$request->get('remarks');
                $dis_stoc->user_id=$request->get('user_id');
                $dis_stoc->date=date('Y-m-d');
                $dis_stoc->stock_booking_id=$request->get('stock_booking_id');
                $dis_stoc->save();
            }else{
                return API::response()->array(['success' => false,
                    'message' => 'PO number already created',
                    'data'    => $dis_stoc], 400);
            }
            return API::response()->array(['success' => true,
                'message' => 'PO number added ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

     public function addpoNumberRaw(Request $request){
        try {
            $dis_stoc=PoNumber::where('user_id',$request->get('user_id'))
                ->where('stock_booking_id',$request->get('stock_booking_id'))
                ->first();
            if(empty($dis_stoc) && empty($dis_stoc['po_number'])){
                  $stocks  =StockBookingDetail::where('stock_booking_id',$request->stock_booking_id)
        ->get();

            /*
        if($request->user_id != 99){
        foreach ($stocks as $key => $stock) {

         $RawProductVendor  = RawProductVendor::where('vendor_id',$request->user_id)->where('raw_id',$stock->product_id)->with('RawMaterial')->first();
          if($RawProductVendor){
            if($RawProductVendor->price == 0){
                return API::response()->array(['success' => false,
        'message' => 'PO number can not be created.because this product price is 0',
        'data'    => $RawProductVendor], 400);

            }
          }

         }
         } 
         */
               $dis_stoc=new PoNumber();
                $max_num = PoNumber::max('po_number_raw');
                $max_num1 = PoNumber::max('po_number_adv');
                
                $max_num2=PoNumber::max('po_number');
                $newpo=0;
                 $dis_stoc=new PoNumber();
                $max_num = PoNumber::max('po_number_raw');
                $max_num2=PoNumber::max('po_number');
                $newpo=0;
                if($max_num>$max_num2)
                
                {
                      $newpo=$max_num;
                }
                
                else {
                         $newpo=$max_num2;
                    }
               

                $dis_stoc->po_number_raw = (int)$newpo + 1;
                $dis_stoc->remarks =$request->get('remarks');
                $dis_stoc->user_id=$request->get('user_id');
                $dis_stoc->date=date('Y-m-d');
                $dis_stoc->stock_booking_id=$request->get('stock_booking_id');
                $dis_stoc->save();
            }else{
                return API::response()->array(['success' => false,
                    'message' => 'PO number already created',
                    'data'    => $dis_stoc], 400);
            }
            return API::response()->array(['success' => true,
                'message' => 'PO number added ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
      public function dispatchQquantity(Request $request){
          $userDetail = User::where('id',$request->user_id)->first();
//return $userDetail;
        try {
            
            $result="";
          $post="";
            
            $id=StockBooking::where('id',$request->stock_booking_id)->first();
            $products=array();
            
             $po_number= PoNumber::where('user_id',$request->user_id)->where('stock_booking_id',$request->stock_booking_id)->first();


if($po_number->user_id==45)
        {

            $party=PartyName::where('id',$id->party_id)->first();

             if($party->region_id == 2){

            if($id->party_id==23 )
            {

                PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                ->update(array('remarks' => $request->remarks));
                foreach ($request->products as $key=> $product){
                    $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                    ->where('stock_booking_id',$request->stock_booking_id)
                    ->first();



                    if(!empty($dis_stoc)){
                        $dis_stoc->dispatch_quantity=$product['dispatch_quantity'];
                        $dis_stoc->save();

                        $product_id=ProductVariation::where('product_id',$product['product_id'])->where('variation_name','Like',"%Thailand%")->first();

                        if(empty($product_id->id))
                        {
                            $product_id2=Product::where('id',$product['product_id'])->first();

                            $products[$key]['id']=$product_id2->vendor_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                        }
                        else
                        {
                            $products[$key]['id']=$product_id->variation_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];

                        }

                    }


                    if(count($product['product_category'])>0){
                        foreach ($product['product_category'] as $category){
                            $cat= StockBookingDetailCategory::where('stock_booking_detail_id',$dis_stoc['id'])
                            ->where('product_category_id',$category['product_category_id'])->first();
                            $cat->dispatch_quantity=$category['dispatch_quantity'];
                            $cat->save();
                        }
                    }

                }
            }
            else{

                 PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                ->update(array('remarks' => $request->remarks));
                foreach ($request->products as $key=> $product){
                    $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                    ->where('stock_booking_id',$request->stock_booking_id)
                    ->first();



                    if(!empty($dis_stoc)){
                        $dis_stoc->dispatch_quantity=$product['dispatch_quantity'];
                        $dis_stoc->save();

                        $product_id=ProductVariation::where('product_id',$product['product_id'])->where('variation_name','Like',"%Export%")->first();

                        if(empty($product_id->id))
                        {
                            $product_id2=Product::where('id',$product['product_id'])->first();

                            $products[$key]['id']=$product_id2->vendor_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                        }
                        else
                        {
                            $products[$key]['id']=$product_id->variation_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];

                        }

                    }


                    if(count($product['product_category'])>0){
                        foreach ($product['product_category'] as $category){
                            $cat= StockBookingDetailCategory::where('stock_booking_detail_id',$dis_stoc['id'])
                            ->where('product_category_id',$category['product_category_id'])->first();
                            $cat->dispatch_quantity=$category['dispatch_quantity'];
                            $cat->save();
                        }
                    }

                }




            }
        }

            else
            {
                PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                ->update(array('remarks' => $request->remarks));
                
                foreach ($request->products as $key=> $product){
                    $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                    ->where('stock_booking_id',$request->stock_booking_id)
                    ->first();
                    

                    if(!empty($dis_stoc)){
                        $dis_stoc->dispatch_quantity=$product['dispatch_quantity'];
                        $dis_stoc->save();


                        $product_id2=Product::where('id',$product['product_id'])->first();

                        $products[$key]['id']=$product_id2->vendor_id;
                        $products[$key]['qty']=$product['dispatch_quantity'];



                    }


                    if(count($product['product_category'])>0){
                        foreach ($product['product_category'] as $category){
                            $cat= StockBookingDetailCategory::where('stock_booking_detail_id',$dis_stoc['id'])
                            ->where('product_category_id',$category['product_category_id'])->first();
                            $cat->dispatch_quantity=$category['dispatch_quantity'];
                            $cat->save();


                            
                        }
                    }

                }
            }

                            $data = array();
                            $data['other']=array('city'=>$party->city,'remarks'=>$request->remarks,'po_number'=>$po_number->po_number);
                            $data['products']=$products;
                            
                            header('Content-Type: application/json'); // Specify the type of data
                            $ch = curl_init('http://demo.biotecherp.work/public/api/biocos-purchase-orders/store'); // Initialise cURL
                            $post = json_encode($data);


                            // Encode the data array into a JSON string

                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                            $result = curl_exec($ch); // Execute the cURL statement
                        
                            curl_close($ch); // Close the cURL connection

}


else
{
      if($id->party_id==23)
            {

                PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                    ->update(array('remarks' => $request->remarks));
                foreach ($request->products as $key=> $product){
                    $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                        ->where('stock_booking_id',$request->stock_booking_id)
                        ->first();



                    if(!empty($dis_stoc)){
                        $dis_stoc->dispatch_quantity=$product['dispatch_quantity'];
                        $dis_stoc->save();

                        $product_id=ProductVariation::where('product_id',$product['product_id'])->where('variation_name','Like',"%Thailand%")->first();
                
                        if(empty($product_id->id))
                        {
                            $product_id2=Product::where('id',$product['product_id'])->first();

                            $products[$key]['id']=$product_id2->vendor_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                           
                        }
                        else
                        {
                            $products[$key]['id']=$product_id->variation_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                          
                        }

                    }


                    if(count($product['product_category'])>0){
                        foreach ($product['product_category'] as $category){
                            $cat= StockBookingDetailCategory::where('stock_booking_detail_id',$dis_stoc['id'])
                                ->where('product_category_id',$category['product_category_id'])->first();
                            $cat->dispatch_quantity=$category['dispatch_quantity'];
                            $cat->save();
                        }
                    }

                }
            }

            else
            {
                PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                    ->update(array('remarks' => $request->remarks));
                foreach ($request->products as $key=> $product){
                    $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                        ->where('stock_booking_id',$request->stock_booking_id)
                        ->first();

                    if(!empty($dis_stoc)){
                        $dis_stoc->dispatch_quantity=$product['dispatch_quantity'];
                        $dis_stoc->save();


                        $product_id=ProductVariation::where('product_id',$product['product_id'])->first();
                       
                        if(empty($product_id->id))
                        {
                            $product_id2=Product::where('id',$product['product_id'])->first();

                            $products[$key]['id']=$product_id2->vendor_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                            
                        }
                        else
                        {
                            $products[$key]['id']=$product_id->variation_id;
                            $products[$key]['qty']=$product['dispatch_quantity'];
                            
                        }

                    }


                    if(count($product['product_category'])>0){
                        foreach ($product['product_category'] as $category){
                            $cat= StockBookingDetailCategory::where('stock_booking_detail_id',$dis_stoc['id'])
                                ->where('product_category_id',$category['product_category_id'])->first();
                            $cat->dispatch_quantity=$category['dispatch_quantity'];
                            $cat->save();


                            $party=PartyName::where('id',$id->party_id)->first();


                            

                            
                        }
                    }

                }
            }
}
            $party=PartyName::where('id',$id->party_id)->first();
            $partyName = $party->name;
            foreach ($request->products as $product){
                $dis_stoc=Product::where('id',$product['product_id'])->first();
                    $name[] = $dis_stoc->name." (Order: ".$product['dispatch_quantity']/$dis_stoc->cotton.")";
            }
            $productname = implode("\n", $name);
            $VendorPhone = $userDetail->phone_1;
            $PoNumber = $po_number->po_number;
            $Vendorobj=array();
            $Vendorobj['number']="923338162959";
            $Vendorobj['text']="You Have Received A New Order From\n$partyName"."\nPo Number = $PoNumber\n$productname";
            $Vendorobj['instance']="biocos";
            $Vendorobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chVendor = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postVendor = json_encode($Vendorobj); // Encode the data array into a JSON string
    
            curl_setopt($chVendor, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chVendor, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chVendor, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chVendor, CURLOPT_POSTFIELDS, $postVendor); // Set the posted fields
            curl_setopt($chVendor, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultVendor = curl_exec($chVendor); // Execute the cURL statement
            curl_close($chVendor); // Close the cURL connection
               
            

            return API::response()->array(['success' => true,
                'message' => 'dispatch quantity added' , 'data'=>$result,'sada'=>$post,'Whatsapp Status'=>$resultVendor
                ], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
   
   
//   public function dispatchQquantityRaw(Request $request){
       
//         try {





//             $id=StockBooking::where('id',$request->get('stock_booking_id'))->first();
//             $products=array();
//             $po_number= PoNumber:: where('stock_booking_id',$request->get('stock_booking_id'))->first();
            
            
            
            
            
            
            
            
            
            
//                 PoNumber:: where('stock_booking_id', $request->get('stock_booking_id'))
//                     ->update(array('remarks' => $request->get('remarks')));
//                 foreach ($request->get('products') as $key => $product) {
//                     $dis_stoc = StockBookingDetail::where('product_id', $product['product_id'])
//                         ->where('stock_booking_id', $request->get('stock_booking_id'))
//                         ->first();

//                     if (!empty($dis_stoc)) {
//                         $dis_stoc->dispatch_quantity = $product['dispatch_quantity'];
//                         $dis_stoc->save();


                     


//                     }

//                 }
            



//             return API::response()->array(['success' => true,
//                 'message' => 'dispatch quantity added' , 'data'=>$request->get('products')
//             ], 200);
//         } catch(Exception $e) {
//             return API::response()->array(['success' => false,
//                 'message' => $e->getTraceAsString()], 400);
//         }
//     }
  
  
   public function dispatchQquantityRaw(Request $request){

        try {





            $id=StockBooking::where('id',$request->stock_booking_id)->first();
            $products=array();
            $po_number= PoNumber:: where('stock_booking_id',$request->stock_booking_id)->first();

                PoNumber:: where('stock_booking_id', $request->stock_booking_id)
                    ->update(array('remarks' => $request->remarks));
                foreach ($request->products as $key => $product) {
                    $dis_stoc = StockBookingDetail::where('product_id', $product['product_id'])
                        ->where('stock_booking_id', $request->stock_booking_id)
                        ->first();

                    if($po_number->user_id==45)
                    {


                        PoNumber:: where('stock_booking_id',$request->stock_booking_id)
                            ->update(array('remarks' => $request->remarks));
                        foreach ($request->products as $key=> $product){
                            $dis_stoc=StockBookingDetail::where('product_id',$product['product_id'])
                                ->where('stock_booking_id',$request->stock_booking_id)
                                ->first();

                            if(!empty($dis_stoc)){

                                    $dis_stoc->dispatch_quantity = $product['dispatch_quantity'];
                                    $dis_stoc->save();
                                    $product_id = RawMaterial::where('id', $product['product_id'])->first();
                                  
                                    $products[$key]['id'] = $product_id->vendor_product_id;
                                    $products[$key]['qty'] = $product['dispatch_quantity'];
                               

                            }
                            
       
                            $ali=1;

                        }
                        $party=PartyName::where('id',$id->party_id)->first();

                        $data = array();
                        $data['other']=array('type'=>'raw','city'=>$party->city,'remarks'=>$request->remarks,'po_number'=>$po_number->po_number);
                        $data['products']=$products;

                            return $data;
                        header('Content-Type: application/json'); // Specify the type of data
                        $ch = curl_init('http://demo.biotecherp.work/public/api/biocos-purchase-orders/store'); // Initialise cURL
                        $post = json_encode($data);

                        // Encode the data array into a JSON string

                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $result = curl_exec($ch); // Execute the cURL statement

                        curl_close($ch); // Close the cURL connection

                    }
                   else {


                       if (!empty($dis_stoc)) {
                           $dis_stoc->dispatch_quantity = $product['dispatch_quantity'];
                           $dis_stoc->save();
                           $product_id = RawMaterial::where('id', $product['product_id'])->first();
                           $products[$key]['id'] = $product_id->id;
                           $products[$key]['qty'] = $product['dispatch_quantity'];


                       }
                   }
                }




            return API::response()->array(['success' => true,
                'message' => 'dispatch quantity added' , 'data'=>"OK"
            ], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    } 
   
    public function vendorAllBilty(Request $request){
        try {
            Bilti::where('supplier_id',$request->get('supplier_id'))->get();

            return API::response()->array(['success' => true,
                'message' => 'vendor All Bilty'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function vendorApproval(Request $request){
        try {
            
           
             $data=$request->json()->all();


            $x=implode(",",$data);
            $z=json_decode($x);




            PoNumber::where('po_number',$z->po_number)->update(['vendor_approval'=>$z->approval_status]);

            return API::response()->array(['success' => true,
                'message' => 'vendor Approval Status Changed','data'=>$data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
     public function vendorPaymentApproval(Request $request){
        try {

            $data=$request->json()->all();


          //  $x=implode(",",$data);
          //  $z=json_decode($x);




            RsmPayment::where('id',$data['payment']['vendor_payment_id'])->update(['vendor_approval'=>$data['payment']['payment_approval'],'vendor_remarks'=>$data['payment']['payment_approval_remarks'],'vendor_refno'=>$data['payment']['id']]);

            return API::response()->array(['success' => true,
                'message' => 'vendor Approval Status Changed','data'=>$data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
        public function vendorinvoiceApproval(Request $request)
    {
        
        $result="";
    $flag="";

        try {
            
              if($request->get('type')=='Biotech'){
           
      $data =  DB::table('vendor_invoices')->where('id',$request->get('id'))->get();
     
      $obj=array();
      $obj['ref_id']=$data[0]->id;
      $obj['status']=$request->get('status');
       $obj['invoice_no']=$data[0]->invoice_no;
          $obj['remarks']=$request->get('remarks');
          
       header('Content-Type: application/json'); // Specify the type of data
            $ch = curl_init('http://www.biotecherp.work/public/api/invoices/invoice_approval'); // Initialise cURL
            $post = json_encode($obj);


            // Encode the data array into a JSON string

            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $result = curl_exec($ch); // Execute the cURL statement

            curl_close($ch); // Close the cURL connection
              }
              
             

         if($result==1 || $result==2 )
         {
             $data =  DB::table('vendor_invoices')->where('id',$request->get('id'))->update(['status'=>$request->get('status'),'remarks'=>$request->get('remarks')]); 
           
         }
           
                if($request->get('type')=='Other'){
                   
                      $obj= bilti::find($request->get('id'));

                     $obj=$obj->update(['admin_status'=>$request->get('status')]);
                     $result=101;
                   
               }
             
      
            }

        catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        
       
         if(!empty($result) && $result==1)
        {
            return API::response()->array(['success' => true, 'message' => 'Invoice Approved Both Side',
            'data' =>  $result  ], 200);

        }
        
         if(!empty($result) && $result==2)
        {
            return API::response()->array(['success' => true, 'message' => 'Invoice Rejected Both Side',
            'data' =>  $result  ], 200);

        }
        
          if(!empty($result) && $result==3 )
        {
            return API::response()->array(['success' => true, 'message' => 'Invoice Already Approved Both Side',
            'data' =>  $result  ], 200);

        }
        
          if(!empty($result) && $result==101 )
        {
            return API::response()->array(['success' => true, 'message' => 'Invoice Of vendor Other than Biotech Approved ',
            'data' =>  $result  ], 200);

        }
        
       

    }
    
    
    
    
     
       public function vendorInvoices(Request $request)
    {

        try {$data='';
        $rawdata  = array();
        $data2=array();
            $invoices=array();
           // return $request;
            if($request->filter == "all"){
            try{
                $raw_id = $request->raw_id;

              $dataget = VendorInvoice::get();
                $i = 0;
              foreach ($dataget as $key => $dat) {
                                
                $bilty[$key] = Bilti::where('vendor_invoice_no',$dat->id)->first();
                $stock_type = $bilty[$key]->bilty_stock_order->type;

                if($stock_type == "Raw"){
                    
                $bilty_details = $bilty[$key]->bilty_detail;  
                foreach ($bilty_details as $key2 => $bilty_detail) {
                    if($bilty_detail->quantity > 0 ) {
                  $product_id[$key2]= $bilty_detail->product_id;
                       if($product_id[$key2] == $raw_id){
                        
                        array_push($rawdata,$dat);

                        
                    }

                }
            }
                 
                }
                $i++;  
              }

             
            $invoices['biotech'] = $rawdata;
            


if($raw_id == 0){

$data2=Bilti::where('supplier_id','!=',45)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->where('supplier_id','!=',99)->where('accountant_vendor_price','!=',0)->whereDate('bilti_date','>=','2019-6-30')->with('bilty_supplier')->get();


            $invoices['other']=$data2;
        }
    }
             catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
            return API::response()->array(['success' => true, 'message' => 'Invoice Approved',
            'data' => $invoices], 200);
            
            }

            
            else{



            if($request->get('accountant_status')!==-1  && $request->get('status')==-1 && $request->get('type')==-1 )
            {
                
                $data = VendorInvoice::where('accountant_status',$request->get('accountant_status'))->with('VendorInvoiceDetail')->with('VendorInvoiceDetail.Purchases_order')->with('VendorInvoiceDetail.Purchases_order.stock_orders')->with('VendorInvoiceDetail.Purchases_order.stock_orders.party_info')->get();
                
                if($request->get('accountant_status')!=2)
                {
                     $data2=Bilti::where('supplier_id','!=',45)->where('supplier_id','!=',98)->where('supplier_id','!=',99)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->where('accountant_vendor_status',$request->get('accountant_status'))->whereDate('bilti_date','>=','2019-6-30')->with(['bilty_supplier','party_info'])->get();
                }
               

            }


            else if($request->get('status')!=-1 && $request->get('type')==-1 ) //accountant pending
            {
               
                $data = VendorInvoice::where('status',$request->get('status'))->with('VendorInvoiceDetail')->with('VendorInvoiceDetail.Purchases_order')->with('VendorInvoiceDetail.Purchases_order.stock_orders')->with('VendorInvoiceDetail.Purchases_order.stock_orders.party_info')->get();

  $data2=Bilti::where('supplier_id','!=',45)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->where('supplier_id','!=',99)->where('admin_status',$request->get('status'))->where('accountant_vendor_price','!=',0)->whereDate('bilti_date','>=','2019-6-30')->with('bilty_supplier')->get();

            }



            else if($request->get('status')!=-1 && $request->get('type')!=-1 )
            //admin pending
            {

                $data = VendorInvoice::where('status',$request->get('status'))->where('accountant_status',$request->get('type'))->with('VendorInvoiceDetail')->with('VendorInvoiceDetail.Purchases_order')->with('VendorInvoiceDetail.Purchases_order.stock_orders')->with('VendorInvoiceDetail.Purchases_order.stock_orders.party_info')->get();


$data2=Bilti::where('supplier_id','!=',45)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->where('supplier_id','!=',99)->where('accountant_vendor_price','!=',0)->where('admin_status',$request->get('status'))->where('accountant_vendor_status',$request->get('type'))->whereDate('bilti_date','>=','2019-6-30')->with('bilty_supplier')->get();


            }
            
            else{

 

                
            }
           
           
            
            

            }







            $invoices['biotech']=$data;
            $invoices['other']=$data2;

        }





        catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Invoice Approved',
            'data' => $invoices], 200);


    }
//      public function vendorInvoicesDetail(Request $request)
//     {

//         try {$data="";

// if($request->get('biotech_id')!=0)
// {
    

//                           $data = VendorInvoiceDetails::where('vendor_invoices_id',$request->get('biotech_id'))->with('Product')->with('VendorInvoice')->with('Purchases_order')->with('Purchases_order.stock_orders')->with('Purchases_order.stock_orders.party_info')->with('Purchases_order.stock_orders.stock_bilty')->get();
  

//              if(count($data)==0)
//              {
//                  $data = VendorInvoice::where('id',$request->get('biotech_id'))->first();

//              }
// }

// if($request->get('other_id')!=0)
// {
//     $data=Bilti::where('id',$request->get('other_id'))->with(['bilty_supplier','bilty_detail','bookBy','bilty_stock_order','biltyImages','party_info'])->get();

// }

//         }

//         catch (Exception $e) {
//             return API::response()->array(['success' => false,
//                 'message' => $e->getTraceAsString()], 400);
//         }
//         return API::response()->array(['success' => true, 'message' => 'Invoice Approved',
//             'data' => $data], 200);


//     }
    
    
      public function vendorInvoicesDetail(Request $request)
    {

        try {
            
            $data="";
        $falg=0;

if($request->get('biotech_id')!=0)
{
    
if($request->get('type')=="raw")
{
    $data = VendorInvoice::where('id',$request->get('biotech_id'))->with(['Bilti_raw','Bilti_raw.bilty_detail','Bilti_raw.bilty_detail.bilty_product_raw'])
        ->first();
        
        $flag=1;
  

}
else
{
    $data = VendorInvoiceDetails::where('vendor_invoices_id',$request->get('biotech_id'))->with('Product')->
    with('VendorInvoice')->with('Purchases_order')->with('Purchases_order.stock_orders')->
    with('Purchases_order.stock_orders.party_info')->
    with(['Purchases_order.stock_orders.stock_bilty'=>function($query)
    {$query->where('supplier_id', 45);}])
        ->get();
        
 if(count($data)==0)
 {
     $flag=0 ;
 }
 else
 {
    $flag=1; 
 }
 

}


             if($flag==0 )
             {
                 $data = VendorInvoice::where('id',$request->get('biotech_id'))->first();

             }
}

if($request->get('other_id')!=0)
{
    $data=Bilti::where('id',$request->get('other_id'))->with(['bilty_supplier','bilty_detail','bookBy','bilty_stock_order','biltyImages','party_info'])->get();

}

        }

        catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Invoice Approved',
            'data' => $data], 200);


    }
    
    
    public function stockBookingCancel(Request $request){
        try {
            StockBooking::where('id',$request->get('id'))->update(['status'=>'Cancelled']);

            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Cancelled'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function PoCompleted(Request $request){
        try {
            $userId = $this->getUserIdFromToken($request);
            $obj=PoNumber::where('po_number',$request->get('po_number'))->first();
            if(!empty($obj)){
                $obj->status="Completed";
                $obj->completed_by = $userId;
                $obj->save();
                $ob= PoNumber::where('stock_booking_id',$obj->stock_booking_id)
                    ->wherein('status', ['Booked','Cancelled','Delivered'])
                    ->get();
//                dd(count($ob));
                if( count($ob)<1){
                    StockBooking::where('id',$obj->stock_booking_id)->update(array('status' => 'Completed'));
                }
            }
//            PoNumber::where('po_number',$request->get('po_number'))->update(array('status' => 'Completed'));;

            return API::response()->array(['success' => true,
                'message' => 'Vendor PO Completd'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockBookingCancelled(Request $request){
        try {
           StockBooking::where('id',$request->get('id'))->update(['status'=>'Cancelled']);
           PoNumber::where('stock_booking_id',$request->get('id'))->update(['status'=>'Cancelled']);
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Canceled'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorPayment(Request $request){
        try {
           $obj= RsmPayment::where('payment_to',$request->get('user_id'))->where('status',$request->get('status'))->with(['payment_images','account_info','payment_by_info','party_info'])->get();
            return API::response()->array(['success' => true,
                'message' => 'vendor Payment',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorPaymentReverse(Request $request){
        try {
           $obj= RsmPayment::where('id',$request->get('id'))->update(array('vendor_refno' => null,'vendor_remarks' => null,'status' => 'Pending'));;
            return API::response()->array(['success' => true,
                'message' => 'vendor Payment Reverse',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorPaymentRange(Request $request){
        try {
           $obj= RsmPayment::where('payment_to',$request->get('user_id'))
               ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
               ->wherein('status',['Pending','Approved','Closed','Completed'])->with(['payment_images','account_info','payment_by_info','party_info'])->get();
            return API::response()->array(['success' => true,
                'message' => 'vendor Payment',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorPaymentReceived(Request $request){
        try {
           $obj= RsmPayment::where('id',$request->get('id'))
               ->where('payment_to',$request->get('user_id'))
               ->update(array('vendor_refno' => $request->get('vendor_refno'),'vendor_remarks' => $request->get('vendor_remarks'),'status' => $request->get('status')));

            return API::response()->array(['success' => true,
                'message' => 'vendor Payment approved',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
  public function HOPayment(Request $request){
        try {
            if(!empty($request->get('vendor_id')))

            {
                if($request->get('vendor_id')==45)
                {
                     $obj= RsmPayment::where('vendor_approval',0)->where('sub_id', 0)->where('payment_to',$request->get('vendor_id'))->whereDate('date','>=','2019-07-1')
                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
                }
                else{
                     $obj= RsmPayment::where('status',$request->get('status'))->where('sub_id', 0)->where('payment_to',$request->get('vendor_id'))
                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
                }
                
            }

            else{
                $obj= RsmPayment::where('status',$request->get('status'))->where('sub_id', 0)->where('payment_to','!=',45)
                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
            }

            return API::response()->array(['success' => true,
                'message' => 'HO Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function HOPaymentrange(Request $request){
        try {
            $obj= RsmPayment::where('status','Completed')
                ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'HO Payment Completed ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function HOPaymentcomplete(Request $request){
        try {

            $obj= RsmPayment::where('id',$request->get('id'))
                ->first();

if($obj->payment_to==44 ||$obj->payment_to==98||$obj->payment_to==99||$obj->payment_to==100)
{
    $obj->completed_by=$request->get('user_id');
    $obj->closed_date=date("Y-m-d");
    $obj->admin_refno=$request->get('admin_refno');
    $obj->vendor_refno=$request->get('admin_refno');
    $obj->admin_remarks=$request->get('admin_remarks');
    $obj->vendor_remarks=$request->get('vendor_remarks');
    $obj->status=$request->get('status');

    $obj->save();

}
           else{
               $obj->completed_by=$request->get('user_id');
               $obj->closed_date=date("Y-m-d");
               $obj->admin_refno=$request->get('admin_refno');
               $obj->admin_remarks=$request->get('admin_remarks');
               $obj->status=$request->get('status');

               $obj->save();

           }

            return API::response()->array(['success' => true,
                'message' => 'HO Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

    public function partyDetail(Request $request){
        try {
            $obj=  PartyName::where('id',$request->get('party_id'))->first();
            return API::response()->array(['success' => true,
                'message' => 'Party Name',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorOrder(Request $request){
        try {
            $start_date=$request->get('start_date');
            $end_date=$request->get('end_date');
            $product_id=[];
            switch ($request->get('user_id')){
                case 3;
//                    $product_id[]=2;
                    $product_id[]=3;
                    break;
                case 43;
                // Danish Lab
                    $product_id[]=18;
                    $product_id[]=17;
                    $product_id[]=16;
                    $product_id[]=14;
                    $product_id[]=2;
                    $product_id[]=1;
                    break;
                // Biotech
                case 45;
                    $product_id[]=15;   // facial booster kit
                    $product_id[]=13;
                    $product_id[]=12;   // facial booster
                    $product_id[]=11;
                    $product_id[]=10;
                    $product_id[]=9;
                    $product_id[]=8;
                    $product_id[]=7;
                    $product_id[]=6;
                    $product_id[]=5;
                    $product_id[]=4;
                    $product_id[]=3;
                    break;
                default:
                    break;

            }
            $po_numbers=PoNumber::where('user_id',$request->get('user_id'))
                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders', function($q) use($start_date,$end_date,$product_id) {
                    $q->whereHas('stock_details', function($q) use($start_date,$end_date,$product_id) {
                            $q->wherein('product_id', $product_id);
                        });
                })
                ->with(['stock_orders'=>function($query) use($product_id) {return $query->with(['Book_By','stock_details'=>function($query) use($product_id){ return $query->wherein('product_id',$product_id)->get();}]);}])
                ->get();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorOrderstatus(Request $request){
            try {
                $status=[];

                switch($request->get('status')){
                    case'UD';
                    $status=['Booked','Delivered'];
                    break;
                    case'CM';
                    $status=['Completed'];
                    break;
                    case'CN';
                    $status=['Cancelled'];
                    break;
                    default:
                    $status=['Booked','Delivered','Completed','Cancelled'];
                    break;
                }
                $product_id=vendorProduct($request->user_id);

                $po_numbers=PoNumber::where('user_id',$request->user_id)->where('po_number_raw',0)->wherein('status',$status)

                ->whereHas('stock_orders', function($q) use($product_id) {
                    $q->whereHas('stock_details', function($q) use($product_id) {
                        $q->wherein('product_id', $product_id);
                    });
                })
                ->with(['stock_orders'=>function($query) use($product_id) {return $query->with(['party_info','Book_By','stock_details'=>function($query) use($product_id){ return $query->wherein('product_id',$product_id)->get();}]);},'po_remarks'])
                ->get();

                return API::response()->array(['success' => true,
                    'message' => 'vendor Order',
                    'data' => $po_numbers], 200);
            } catch(Exception $e) {
                return API::response()->array(['success' => false,
                    'message' => $e->getTraceAsString()], 400);
            }
        }
    
     public function vendorOrderstatusRaw(Request $request){
        try {
            $status=[];

            switch($request->get('status')){
                case'UD';
                    $status=['Booked','Delivered'];
                    break;
                case'CM';
                    $status=['Completed'];
                    break;
                case'CN';
                    $status=['Cancelled'];
                    break;
                default:
                    $status=['Booked','Delivered','Completed','Cancelled'];
                    break;
            }
            $product_id=RawProductVendor::select('raw_id')->where('vendor_id',$request->get('user_id'))->get()->toArray();
            $po_numbers=PoNumber::where('user_id',$request->get('user_id'))->wherein('status',$status)
//                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders_raw', 
                
                
                
                function($q) use($product_id) {
                    
                    $q->whereHas('stock_details_raw', function($q) use($product_id) {
                            $q->wherein('product_id',$product_id );
                        });
                })
                ->with(['stock_orders_raw'=>function($query) use($product_id) {return
                    $query->with(['BookTo','Book_By','stock_details_raw'=>function($query) use($product_id)
                    { return $query->wherein('product_id',$product_id)->get();}]);}])
                ->get();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
    public function allvendorOrder(Request $request){
        try {
            $start_date=$request->get('start_date');
            $end_date=$request->get('end_date');
            $product_id=vendorProduct($request->get('user_id'));;
            $po_numbers=PoNumber::where('user_id',$request->get('user_id'))
                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders', function($q) use($start_date,$end_date,$product_id) {
                    $q->whereHas('stock_details', function($q) use($start_date,$end_date,$product_id) {
                            $q->wherein('product_id', $product_id);
                        });
                })
                ->with(['stock_orders'=>function($query) use($product_id) {return $query->with(['Book_By','stock_details'=>function($query) use($product_id){ return $query->wherein('product_id',$product_id)->get();}]);}])
                ->get();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorOrderDetail(Request $request){
        try {
           
            $po_number=$request->po_number;
            $product_id=vendorProduct($request->user_id);
            $po_numbers=PoNumber::where('user_id',$request->user_id)
            ->where('po_number',$request->po_number)
//                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders', function($q) use($product_id) {
                    $q->whereHas('stock_details', function($q) use($product_id) {
                        $q->wherein('product_id', $product_id);
                    });
                })
                ->with(['edit_remarks','stock_orders'=>function($query) use($product_id) {
                    return $query->with(['party_info','Book_By','stock_adda','stock_details'=>function($query) use($product_id){ return $query->wherein('product_id',$product_id)->get();},
                    'stock_bilty'=>function($query)use($product_id){
                        $query->whereHas('bilty_detail', function($q) use($product_id) {
                            $q->wherein('product_id', $product_id)->with(['bilty_detail_type']);
                        });
                    }]);},'po_remarks'])
                ->first();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order Detail',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function vendorOrderDetailADV(Request $request){
        try {
            $product_id=vendorProduct($request->get('user_id'));
            $po_numbers=PoNumber::where('user_id',$request->get('user_id'))
                ->where('po_number_adv',$request->get('po_number'))
//                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders', function($q) use($product_id) {
                    $q->whereHas('stock_details', function($q) use($product_id) {
                        $q->wherein('product_id', $product_id);
                    });
                })
                ->with(['stock_orders'=>function($query) use($product_id) {
                    return $query->with(['party_info','Book_By','stock_details'=>function($query) use($product_id){ return $query->wherein('product_id',$product_id)->get();},
                        'stock_bilty'=>function($query)use($product_id){
                            $query->whereHas('bilty_detail', function($q) use($product_id) {
                                $q->wherein('product_id', $product_id)->with(['bilty_detail_type']);
                            });
                        }]);}])
                ->first();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order Detail',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
      public function vendorOrderDetailRaw(Request $request){
        try {
            $product_id=RawProductVendor::select('raw_id')->where('vendor_id',$request->get('user_id'))->get()->toArray();
            $po_numbers=PoNumber::where('user_id',$request->get('user_id'))
                ->where('po_number_raw',$request->get('po_number'))
//                ->wherebetween('date', [$start_date,$end_date])
                ->whereHas('stock_orders_raw', function($q) use($product_id) {
                    $q->whereHas('stock_details_raw', function($q) use($product_id) {
                        $q->wherein('product_id', $product_id);
                    });
                })
                ->with(['stock_orders_raw'=>function($query) use($product_id) {
                    return $query->with(['Book_By','BookTo','stock_details_raw'=>function($query)
                    use($product_id){ return $query->wherein('product_id',$product_id)->get();},
                        'stock_bilty_raw'=>function($query)use($product_id){
                            $query->whereHas('bilty_detail', function($q) use($product_id) {
                                $q->wherein('product_id', $product_id);
                            });
                        }]);}])
                ->first();

            return API::response()->array(['success' => true,
                'message' => 'vendor Order Detail',
                'data' => $po_numbers], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
    
    public function stockBookingCotton(Request $request){
        try {
            $validator = \Validator::make($request->all(),['party_id'=>'required|not_in:0']);
            if ($validator->fails()) {
                return API::response()->array(['success' => false,
                    'error'   => 'Required parameters are missing or incorrect!',
                    'error_message' => $validator->errors()], 400);
            }else{
                $party=PartyName::where('id',$request->get('party_id'))->first();
                $dis_stoc=new StockBooking();
                $dis_stoc->booked_by=$request->get('booked_by');
//                $dis_stoc->bilty_adda_id=$request->get('bilty_adda_id');
                $dis_stoc->party_id=$request->get('party_id');
                $dis_stoc->date=$request->get('date');
                $dis_stoc->remarks=$request->get('remarks');
//            $dis_stoc->zone=$request->get('zone');
//            $dis_stoc->business_name=$request->get('business_name');
                $dis_stoc->status='Booked';
                 if($party->region_id == 2 ){
                 $dis_stoc->vendor_flag = 1;
                }else{
                  $dis_stoc->vendor_flag = 0;  
                }
                $dis_stoc->save();

                // stock booking adda
                if(!empty($request->get('adda'))){
                    foreach ($request->get('adda') as $adda){
                        $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
                        if(empty($ad)){
                            $ad=new StockBookingAdda();
                        }
                        $ad->vendor_id=$adda['vendor_id'];
                        $ad->adda_id=$adda['adda_id'];
                        $ad->save();
                    }
                }
                $price=0;
                $total_price=0;
                
                if(count($request->get('products'))>0){
                    foreach ($request->get('products') as $stock){
                        $d_stock=new StockBookingDetail();
                        $d_stock->stock_booking_id=$dis_stoc->id;
                        $d_stock->product_id=$stock['product_id'];
                        $cot=Product::where('id',$stock['product_id'])->first();
                        if(!empty($cot)){
                            $d_stock->quantity=$stock['quantity']*$cot->cotton;
                            $d_stock->dispatch_quantity=$stock['quantity']*$cot->cotton;
//                        $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,'Distributor');
                            if(!empty($party)&& !empty($party->region_id) && $party->region_id==2){
                                $cost=$this->CalculateExportInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,$party->id);

                            }else{
                                $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,'Distributor');
                            }


                              $price=$price+$cost;
                            $d_stock->price=$cost;

                             if($party->region_id !=2 && ($stock['product_id'] ==41 || $stock['product_id'] ==43 ||$stock['product_id'] ==44 ||$stock['product_id']==38 || $stock['product_id'] == 16 || $stock['product_id'] == 30)){
                $p= ProductPrice::where('product_id',$stock['product_id'])->first();
                
                 $d_stock->discount=$p->discount;
                $d_stock->payment=$cost-(($cost*$p->discount)/100);
                $total_price=$total_price+($cost-(($cost*$p->discount)/100));

            } else{


                            if(!empty($party) && !empty($party->discount) &&  $party->discount!=0){
                                $d_stock->discount=$party->discount;
                                $d_stock->payment=$cost-(($cost*$party->discount)/100);
                                $total_price=$total_price+($cost-(($cost*$party->discount)/100));
                            }else{
                                $d_stock->discount=0;
                                $d_stock->payment=$cost;
                                $total_price=$total_price+$cost;
                            }
                        }
                    }
                        $d_stock->save();
                        if(count($stock['product_category'])>0){
                            foreach ($stock['product_category'] as $category){
                                $cat=new StockBookingDetailCategory();
                                $cat->stock_booking_detail_id=$d_stock->id;
                                $cat->product_category_id=$category['id'];
                                $cat->quantity=$category['quantity']*$cot->cotton;
                                $cat->dispatch_quantity=$category['quantity']*$cot->cotton;
                                $cat->delivered=0;
                                $cat->save();
                            }
                        }
                    }
                }

                $dis_stoc->price=$price;
                if(!empty($party)){
                    $amount=$price;
                    if($party->discount==0){
                        $dis_stoc->discount=0;
                        $dis_stoc->payment=$price;
                    }else{
                        $dis_stoc->discount=$party->discount;
//                        $dis=($price*$party->discount)/100;
//                        $dis_stoc->payment=$price-$dis;
                        $dis_stoc->payment=$total_price;
                    }
                    $dis_stoc->save();
                }else{
                    $dis_stoc->discount=0;
                    $dis_stoc->payment=$price;
                }
                $dis_stoc->save();
                // push notification recipients fetch
                $recipients = User::select('id')->whereHas('roles', function ($query) {
                    $query->wherein('name', ['admin','super_admin']);
                })->get()->toarray();
                if(count($recipients)>0){
                    // push notification device token fetch
                    $fetch=[];
                    $body=null;
                    if(!empty($dis_stoc->remarks)){
                        $body=  $dis_stoc->remarks;
                    }elseif(!empty($dis_stoc->Book_By->firstname)){
                        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
                    }

                    $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
                    $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
                    if(count($device_token)>0){
                        // push notification send
                        push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'rsm_order');
                    }
                }
                return API::response()->array(['success' => true,
                    'message' => 'Stock Booking ',
                    'data'    => $dis_stoc], 200);
            }

        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function stockBookingCottonbytype(Request $request){
        
        try {
     
            $validator = \Validator::make($request->all(),['party_id'=>'required|not_in:0']);
            if ($validator->fails()) {
                return API::response()->array(['success' => false,
                    'error'   => 'Required parameters are missing or incorrect!',
                    'error_message' => $validator->errors()], 400);
            }else{
               $party=PartyName::where('id',$request->get('party_id'))->first();
               $dis_stoc=new StockBooking();
               $dis_stoc->booked_by=$request->booked_by;
//                $dis_stoc->bilty_adda_id=$request->get('bilty_adda_id');
               $dis_stoc->party_id=$request->party_id;
               $dis_stoc->date=$request->date;
               $dis_stoc->remarks=$request->remarks;
//            $dis_stoc->zone=$request->get('zone');
//            $dis_stoc->business_name=$request->get('business_name');
               $dis_stoc->status='Booked';
               if($party->region_id == 2 ){
                   $dis_stoc->vendor_flag = 1;
               }else{
                  $dis_stoc->vendor_flag = 0;  
              }
            //  return $party;
             $dis_stoc->save();

                // stock booking adda
              if(!empty($request->adda)){
                foreach ($request->adda as $adda){
                    $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
                    if(empty($ad)){
                        $ad=new StockBookingAdda();
                    }
                    $ad->vendor_id=$adda['vendor_id'];
                    $ad->adda_id=$adda['adda_id'];
                   $ad->save();
                }
            }
            $price=0;
            $total_price=0;

            if(count($request->products)>0){
                $name = array();
                foreach ($request->products as $stock){

                    $d_stock=new StockBookingDetail();
                    $d_stock->stock_booking_id=$dis_stoc->id;
                    $d_stock->product_id=$stock['product_id'];
                    $cot=Product::where('id',$stock['product_id'])->first();
                    
                    if(!empty($cot)){
                        if($stock['unit'] == "Dozen"){
                            
                        $d_stock->quantity=$stock['quantity']*12;
                        $d_stock->dispatch_quantity=$stock['quantity']*12;
                         if(!empty($party)&& !empty($party->region_id) && $party->region->custom_prices == 1){
                            $cost=$this->CalculateExportInvoice($stock['product_id'],$stock['quantity']*12,$party->id);

                        }else{
                            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*12,'Distributor');
                        }

                        }
                         elseif($stock['unit'] == "PCS"){

                                $d_stock->quantity=$stock['quantity'];
                        $d_stock->dispatch_quantity=$stock['quantity'];
                         if(!empty($party)&& !empty($party->region_id) && $party->region->custom_prices == 1){
                            $cost=$this->CalculateExportInvoice($stock['product_id'],$stock['quantity'],$party->id);

                        }else{
                            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity'],'Distributor');
                        }

                        }
                        
                        else{
                            
                        $d_stock->quantity=$stock['quantity']*$cot->cotton;
                        $d_stock->dispatch_quantity=$stock['quantity']*$cot->cotton;
                         if(!empty($party)&& !empty($party->region_id) && $party->region->custom_prices == 1){
                            $cost=$this->CalculateExportInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,$party->id);

                        }else{
                            $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,'Distributor');
                        }
                    }
//                        $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,'Distributor');
                       


                        $price=$price+$cost;
                        $d_stock->price=$cost;

                    if($party->region_id !=2 ){

                    $p= ProductPrice::where('product_id',$stock['product_id'])->first();

                    if($p->discount > 0){
                        $d_stock->discount=$p->discount;
                        $d_stock->payment=$cost-(($cost*$p->discount)/100);
                        $total_price=$total_price+($cost-(($cost*$p->discount)/100));
                    }else{


                        if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){

                            $d_stock->discount=$party->discount;
                            $d_stock->payment=$cost-(($cost*$party->discount)/100);
                            $total_price=$total_price+($cost-(($cost*$party->discount)/100));
                        }
                    }

                } else{

                    $d_stock->discount=0;
                    $d_stock->payment=$cost;
                    $total_price=$total_price+$cost;
                    $is_mehandi=true;
                    

                }
                    }
                    
                    $d_stock->save();
                    if(count($stock['product_category'])>0){
                        foreach ($stock['product_category'] as $category){
                            $cat=new StockBookingDetailCategory();
                            $cat->stock_booking_detail_id=$d_stock->id;
                            $cat->product_category_id=$category['id'];
                            $cat->quantity=$category['quantity']*$cot->cotton;
                            $cat->dispatch_quantity=$category['quantity']*$cot->cotton;
                            $cat->delivered=0;
                            $cat->save();
                        }
                    }
                    $productId = $stock['product_id'];
                   // return $party=PartyName::where('id',$request->party_id)->with(['soul_distributer'])->get();
                    $party=PartyName::where('id',$request->party_id)->with(['soul_distributer'=>function($query)use($productId){
                        $query->with(['so_stock'=>function($query)use($productId){
                            $query->where('product_id', $productId)->first();
                        }]);
                    }])->first();
                    foreach ($party->soul_distributer->so_stock as $availableStock){
                        $availableqty = round($availableStock->qty/$availableStock->cotton, 2);
                    }
                   // return $party->show_gm;
                    $name[] = $cot->name." (Order: ".$stock['quantity'].") (Available: ".$availableqty.")";
                    
                }
                $productname = implode("\n", $name);
              //  return $productname;
            }

            $dis_stoc->price=$price;
            if(!empty($party)){
                $amount=$price;
                if($party->discount==0){
                    $dis_stoc->discount=0;
                    $dis_stoc->payment=$price;
                }else{
                 $dis_stoc->discount=$party->discount;
//                        $dis=($price*$party->discount)/100;
//                        $dis_stoc->payment=$price-$dis;
                 $dis_stoc->payment=$total_price;
             }
             $dis_stoc->save();
         }else{
            $dis_stoc->discount=0;
            $dis_stoc->payment=$price;
        }
        $dis_stoc->save();
       // return $party;
        
        if($party->phone_1 != NULL){
           // return $party->phone_1;
            $PartyPhone = $party->phone_1;
            $partyobj=array();
            $partyobj['number']="923060675099";
            $partyobj['text']="Dear Sir,\nYour Order Has Been Placed For"."\n\n$productname\n\nThank You\nBiocos Int (PVT) LTD.";
            $partyobj['instance']="biocos";
            $partyobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postPARTY = json_encode($partyobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postPARTY); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }        
                
        if($dis_stoc->Book_By->phone_1 != NULL){
            $RSMPhone = $dis_stoc->Book_By->phone_1;
            $rsmobj=array();
            $rsmobj['number']="923338162959";
            $rsmobj['text']="You Have Placed New Order For"."\n$party->name \n$productname\n\nThank You\nBiocos Int (PVT) LTD.";
            $rsmobj['instance']="biocos";
            $rsmobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postRSM = json_encode($rsmobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postRSM); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }
        
        
        if($party->show_gm == 1){
            $rsmobj=array();
            $rsmobj['number']="923338162959";
            $rsmobj['text']="Dear Sir,\nNew Order Has Been Placed For"."\n$party->name \n$productname\n\nThank You\nBiocos Int (PVT) LTD.";
            $rsmobj['instance']="biocos";
            $rsmobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postRSM = json_encode($rsmobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postRSM); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }else{
            $rsmobj=array();
            $rsmobj['number']="923236600464";
            $rsmobj['text']="Dear Sir,\nNew Order Has Been Placed For"."\n$party->name \n$productname\n\nThank You\nBiocos Int (PVT) LTD.";
            $rsmobj['instance']="biocos";
            $rsmobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postRSM = json_encode($rsmobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postRSM); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }
                // push notification recipients fetch
        $recipients = User::select('id')->whereHas('roles', function ($query) {
            $query->wherein('name', ['admin','super_admin']);
        })->get()->toarray();
        if(count($recipients)>0){
            
            // push notification device token fetch
            $fetch=[];
            $body=null;
            if(!empty($dis_stoc->remarks)){
                $body=  $dis_stoc->remarks;
            }elseif(!empty($dis_stoc->Book_By->firstname)){
                $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
            }

            $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
            $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
            if(count($device_token)>0){
                        // push notification send
                push_notification_send($dis_stoc->id,'New Order',$body,fetch_column_from_array($device_token,'token'),'rsm_order');
            }
            $obj=array();
            $obj['number']="923338162959";
            $obj['text']="New Order\n"."$body.\n$party->name \n$productname\n\nThank You\nBiocos Int (PVT) LTD.";
            $obj['instance']="biocos";
            $obj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $ch = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $post = json_encode($obj); // Encode the data array into a JSON string
    
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $result = curl_exec($ch); // Execute the cURL statement
            curl_close($ch); // Close the cURL connection
        }

    
        return API::response()->array(['success' => true,
            'message' => 'Stock Booking ',
            'data'    => $dis_stoc,'whatsapp' => $result,'RSM WhtasAPP Status' =>$resultRSM], 200);
    }

} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

    public function stockBookingCottonUpdate(Request $request){
       
        try {
            
         $stockbooking = StockBooking::where('id',$request->id)->first();
         
         $stockbooking->vendor_flag = 1;
        
        $stockbooking->save();
         
         foreach ($request['stock_details'] as $key => $stock_detail) {
   
              $stock_det= StockBookingDetail::where('id',$stock_detail['id'])->first();
              
              $stock_det->gm_quantity = $stock_detail['quantity'];
              $stock_det->save();
         }
         return API::response()->array(['success' => true,
                    'message' => 'Stock Booking updated '], 200); 
    }
    catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
}
    
    
     public function stockReturnCotton(Request $request){
    try {


        if($request->id == 0){

            $party=PartyName::where('id',$request->party_id)->first();

            $dis_stoc=new StockBooking();
            $dis_stoc->booked_by=$request->booked_by;

            $dis_stoc->party_id=$request->party_id;
            $dis_stoc->discount=$request->discount;
            $dis_stoc->date=$request->date;
            $dis_stoc->remarks=$request->remarks;
            $dis_stoc->type="Sale Return";

            $dis_stoc->status='';
            $dis_stoc->save();

                 //////
                  //Image upload
            if(!empty($request->get('uploadimages'))) {
                $images = [];
                foreach($request->get('uploadimages') as $image) {
                    $image = upload_base64_image($image, 'uploads/stockimages/',
                        'image-');
                    $stockImage = new StockbookingImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                    $stockImage->image =  'http://'.$image;
                    $images[] = $stockImage;
                }
                if(count($images) > 0) {
                    $dis_stoc->stockImages()->saveMany($images);
                }
            }
                //////

            $price=0;
            $total_price=0;
            $soul_distributer  = $party->user_id;

            ///stock add in warehouse 
            if($request->add_to_warehouse == 1){
                if(count($request->products)>0){

                 foreach ($request->products as $stock) {

                    if($stock['quantity'] > 0 ){
                        $product_prices = Product::where('id', $stock['product_id'])->first();

                     $warehouse  = WareHouse::where('active',1)->first();
                     if($warehouse){

                      $warehousestocks =  $warehouse->WarehouseStocks;
                      if($warehousestocks){
                        foreach ($warehousestocks as $key => $warehousestock) {

                            $warehouse = WarehouseStocks::where('product_id',$stock['product_id'])->where('warehouse_id',$warehousestock->id)->first();
                            if($warehouse){
                             $warehouse->quantity   =  $warehouse->quantity + $stock['quantity'];
                             $warehouse->save();
                         }
                     }

                 }
             }

             if (count($product_prices->productCategory) > 0 ){                        

                foreach ($stock['product_category'] as $key => $subproduct) {

                   $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$subproduct['id'])->first();
                   if($warehousestockvariant){
                       $warehousestockvariant->quantity  =  $warehousestockvariant->quantity + $subproduct['quantity']; 

                       $warehousestockvariant->save();
                   }


               }

        }




    }

}

}
}
//////stock code added ////

    if(count($request->products)>0){

     foreach ($request->products as $stock) {
     

        if($stock['quantity'] > 0 ){
            $product_prices = Product::where('id', $stock['product_id'])->first();


            if($soul_distributer){
               $stock_product  = SoStock::where('so_id',$soul_distributer)->where('product_id', $stock['product_id'])->where('product_category_id', 0)->first();

               if($stock_product){
                 $stock_qty   =  $stock_product->qty - $stock['quantity'];

                 $stock_product->qty = $stock_qty;

                 $stock_product->save();

                      //// how much stock in at soul distributers parent products ///
                 $so_stock_detail  = new SoStockDetail();
                 $so_stock_detail->so_id = $soul_distributer;
                 $so_stock_detail->ref_id = $dis_stoc->id;
                 $so_stock_detail->product_id = $stock['product_id'];
                 $so_stock_detail->sale_return_company = $stock['quantity'];
                 $so_stock_detail->total_stock = $stock_qty;
                 $so_stock_detail->date = date("Y-m-d");
                 $so_stock_detail->save();
             }
         }   

         if(count($stock['product_category']) > 0){
                foreach ($stock['product_category'] as $category){                      
             if(!empty($soul_distributer)){

            $stock_product  = SoStock::where('so_id',$soul_distributer)->where('product_id',$category['product_id'])->where('product_category_id',$category['id'])->first();


                if(!empty($stock_product)){
                    $stock_product->qty  = $stock_product->qty - $category['quantity'];

                    $stock_product->save();

                    $so_stock_detail  = new SoStockDetail();
                    $so_stock_detail->so_id = $soul_distributer;
                    $so_stock_detail->ref_id = $dis_stoc->id;
                    $so_stock_detail->product_id = $stock['product_id'];
                    $so_stock_detail->product_category_id = $category['id'];
                    $so_stock_detail->sale_return_company = $category['quantity'];
                    $so_stock_detail->total_stock = $stock_product->qty;
                    $so_stock_detail->date = date("Y-m-d");
                    $so_stock_detail->save();

                }
            }
        }

        }




    }

}

}
//////


$party=PartyName::where('id',$request->party_id)->first();
if(count($request->products)>0){
    foreach ($request->products as $stock){
        $d_stock=new StockBookingDetail();
        $d_stock->stock_booking_id=$dis_stoc->id;
        $d_stock->product_id=$stock['product_id'];
        $cot=Product::where('id',$stock['product_id'])->first();
        if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];




            $d_stock->price=$stock['price'];
            $d_stock->payment=$stock['payment'];
             $price = $price +  $stock['price'];

            $total_price = $total_price + $stock['payment'];

            

        }
        $d_stock->save();
        if(count($stock['product_category'])>0){
            foreach ($stock['product_category'] as $category){
                $cat=new StockBookingDetailCategory();
                $cat->stock_booking_detail_id=$d_stock->id;
                $cat->product_category_id=$category['id'];
                $cat->quantity=$category['quantity'];
                $cat->dispatch_quantity=$category['quantity'];
                $cat->delivered=0;
                $cat->save();
            }
        }
    }
}

$dis_stoc->price=$price;
$dis_stoc->payment=$total_price;


$dis_stoc->save();


if(!empty($dis_stoc)) {

    /*
    $party->balance=($party->balance)-($dis_stoc->payment);
    $party->save();

    $e = new UserExpenseDetail();
    $e->user_id = $request->booked_by;
    $e->party_id = $request->party_id;
    $e->detail_id = $dis_stoc->id;
    $e->amount = $dis_stoc->payment;
    $e->balance = $party->balance;
    */
}




return API::response()->array(['success' => true,
    'message' => 'Stock Booking ',
    'data'    => $dis_stoc], 200);
}
else{

   if(!empty($request->uploadimages)) {
    $images = [];
    foreach($request->uploadimages as $image) {
        $image = upload_base64_image($image, 'uploads/stockimages/',
            'image-');
        $stockImage = new StockbookingImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
        $stockImage->image =  'http://'.$image;
        $stockImage->stock_booking_id = $request->id;
        $stockImage->save();
    }
    
}

return API::response()->array(['success' => true,
    'message' => 'Stock Booking images updated'], 200);


}


} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

    }//Return Products
    //Return Products
    
    public function stockBookingAdv(Request $request){
        try {
            $validator = \Validator::make($request->all(),['party_id'=>'required|not_in:0']);
            if ($validator->fails()) {
                return API::response()->array(['success' => false,
                    'error'   => 'Required parameters are missing or incorrect!',
                    'message' => $validator->errors()], 400);
            }else{
                $dis_stoc=new StockBooking();
                $dis_stoc->booked_by=$request->get('booked_by');
                $dis_stoc->booked_to=99;
                $dis_stoc->bilty_adda_id=$request->get('bilty_adda_id');
                $dis_stoc->party_id=$request->get('party_id');
                $dis_stoc->date=$request->get('date');
                $dis_stoc->remarks=$request->get('remarks');
                $dis_stoc->status='Booked';
                $dis_stoc->save();
                if(count($request->get('products'))>0){
                    foreach ($request->get('products') as $stock){
                        $d_stock=new StockBookingDetail();
                        $d_stock->stock_booking_id=$dis_stoc->id;
                        $d_stock->product_id=$stock['product_id'];
                        $cot=Product::where('id',$stock['product_id'])->first();
                        if(!empty($cot)){
                            $d_stock->quantity=$stock['quantity']*$cot->cotton;
                            $d_stock->dispatch_quantity=$stock['quantity']*$cot->cotton;
                            $d_stock->price=0;
                            $d_stock->discount=0;
                            $d_stock->payment=0;
                        }
                        $d_stock->save();
                    }
                }
                $dis_stoc->price=0;
                $dis_stoc->discount=0;
                $dis_stoc->payment=0;
                $dis_stoc->save();
                // push notification recipients fetch
                $recipients = User::select('id')->whereHas('roles', function ($query) {
                    $query->wherein('name', ['admin','super_admin']);
                })->get()->toarray();
                if(count($recipients)>0){
                    // push notification device token fetch
                    $fetch=[];
                    $body=null;
                    if(!empty($dis_stoc->remarks)){
                        $body=  $dis_stoc->remarks;
                    }elseif(!empty($dis_stoc->Book_By->firstname)){
                        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
                    }
                    $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
                    $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
                    if(count($device_token)>0){
                        // push notification send
                        push_notification_send($dis_stoc->id,'New Order',$body,fetch_column_from_array($device_token,'token'),'rsm_order');
                    }
                }
                return API::response()->array(['success' => true,
                    'message' => 'Stock Booking ',
                    'data'    => $dis_stoc], 200);
            }
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
     public function stockBookingRaw(Request $request){
        try {

                $dis_stoc=new StockBooking();
                $dis_stoc->booked_by=$request->get('booked_by');
                $dis_stoc->booked_to=$request->get('vendor_id');
                $dis_stoc->date=$request->get('date');
                $dis_stoc->remarks=$request->get('remarks');
            $dis_stoc->type=$request->get('type');
            $dis_stoc->vendor_id=$request->get('vendor_id');
                $dis_stoc->status='Booked';
                $dis_stoc->save();

                if(count($request->get('products'))>0){
                    foreach ($request->get('products') as $stock){
                        $d_stock=new StockBookingDetail();
                        $d_stock->stock_booking_id=$dis_stoc->id;
                        $d_stock->product_id=$stock['id'];
                        $cot=RawMaterial::where('id',$stock['id'])->first();
                        if(!empty($cot)){
                            $d_stock->quantity=$stock['quantity'];
                            $d_stock->dispatch_quantity=$stock['quantity'];
                            $dis_stoc->discount=0;
                            $d_stock->price=$stock['quantity']*$cot->price;

                            $d_stock->payment=$stock['quantity']*$cot->price;
                        }
                        $d_stock->save();
                    }
                }
                $dis_stoc->price=$d_stock->price;
                $dis_stoc->discount=0;
                $dis_stoc->payment=$d_stock->payment;
                $dis_stoc->save();

        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        
        
         return API::response()->array(['success' => true,
                'message' => 'Stock Booking ',
                'data'    => $dis_stoc], 200);
        
    }
    
    public function Updatestockorderstatus(Request $request){
        try {

            $remarks = "";

            $dis_stoc= StockBooking::where('id',$request->id)->where('booked_to',99)->first();
            if($dis_stoc){
            
           

            $po_number = PoNumber::where('stock_booking_id',$dis_stoc->id)->first();
            if($po_number){
$remarks ="new order status:Completed <br> Old order status: " . $dis_stoc->status."<br> new po number status:Completed <br> Old po number status: " . $po_number->status."<br>";

                $po_number->status ='Completed';

                $po_number->save();
            }
            $dis_stoc->status='Completed';
             $dis_stoc->save();
           

             $stock_log  =   new  PaymentRemark();
         $stock_log->rsm_id = $dis_stoc->id;
         $stock_log->user_id = $request->user_id;
         $stock_log->type = "adv_order_completed";
         $stock_log->user_remarks = $request->remarks;
         $stock_log->remarks = $remarks;
         $stock_log->save();

           } 
           else{
             return API::response()->array(['success' => true,
            'message' => 'Not found'], 400);

           }  


        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        
        
        return API::response()->array(['success' => true,
            'message' => 'Stock Booking status and po number status updated ',
            'data'    => $dis_stoc], 200);
        
    }

    
    //Raw Materials
    
    
    public function CalculateInvoice($product_id,$quantity,$type){
        switch ($type){
            case 'Distributor':
                $p= ProductPrice::where('product_id',$product_id)->first();
                if(!empty($p) && !empty($p->distributor_price)){
                    return $p->distributor_price * $quantity;
                }
                break;
            default:
                return 0;
        }
    }
    public function CalculateExportInvoice($product_id,$quantity,$party_id){
        $p= PartyRates::where('product_id',$product_id)
            ->where('party_id',$party_id)->first();
        if(!empty($p)){
            return $p->price * $quantity;
        }else{
            return 0;
        }
    }
     
  public function stockBookingOrder(Request $request){
        try {
        
            if(!empty($request->get('id'))){
                $dis_stoc= StockBooking::where('booked_by',$request->get('id'))
                ->where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL);
                
                if(!empty($request->get('start_date')) && !empty($request->get('end_date'))){
                    $dis_stoc=$dis_stoc->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
                }
                 if($request->get('status')=='Booked' ){
                    $dis_stoc=$dis_stoc ->where('party_id',$request->get('status'))->whereIn('status', ['Booked', 'Delivered'])->with(['stock_details','Book_By','po_numbers','party_info','stock_adda'])->get();
                }else{
                    $dis_stoc=$dis_stoc->with(['stock_details','Book_By','po_numbers','party_info','stock_adda'])->get();
                }
            }
            
            else if($request->get('status')=='Booked' && $request->get('party_id')!==0 && $request->get('vendor_id')!==0){
                
                $product_id=vendorProduct($request->get('vendor_id'));
                
                
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->where('party_id',$request->get('party_id'))->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By',
                    
                    'stock_details'=>function($query) use($product_id){
                        
                        $query->wherein('product_id',$product_id)->get();
                        
                     }
                    
                    ,'po_numbers','party_info','stock_adda'])->get();
                }
                else if($request->get('status')=='Booked' && $request->get('party_id')!=0 && $request->get('party_id')!= 5000 && $request->get('party_id')!=5001 && $request->get('vendor_id')==0){
                
               
                
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->where('party_id',$request->get('party_id'))->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By', 'stock_details','po_numbers','party_info','stock_adda'])->get();
                }
                
                else if($request->get('status')=='Booked' && $request->get('party_id')==5000 && $request->get('vendor_id')==0){
                
                
               $party=PartyName::select('id')->where('region_id','!=',2)->get()->toArray();
                
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->whereIn('party_id',$party)->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By', 'stock_details','po_numbers','party_info','stock_adda'])->get();
                }
                
                
                
                 else if($request->get('status')=='Booked' && $request->get('party_id')==5000 && $request->get('vendor_id')!==0){
                
                $product_id=vendorProduct($request->get('vendor_id'));
                
                 $party=PartyName::select('id')->where('region_id','!=',2)->where('id','!=',20)->get()->toArray();
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->wherein('party_id',$party)->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By',
                    
                    'stock_details'=>function($query) use($product_id){
                        
                        $query->wherein('product_id',$product_id)->get();
                        
                     }
                    
                    ,'po_numbers','party_info','stock_adda'])->get();
                }
                else if($request->get('status')=='Booked' && $request->get('party_id')==5001 && $request->get('vendor_id')==0){
                
               $party=PartyName::select('id')->where('region_id','=',2)->get()->toArray();
                
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->whereIn('party_id',$party)->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By', 'stock_details','po_numbers','party_info','stock_adda'])->get();
                }
                
                
                
                else if($request->get('status')=='Booked' && $request->get('party_id')==0 && $request->get('vendor_id')!=0){
                
                $product_id=vendorProduct($request->get('vendor_id'));
              
                
                    $dis_stoc=StockBooking::where('booked_to','<>',99)->where('type','=',NULL)->where('party_check','=',NULL)->whereIn('status', ['Booked', 'Delivered'])->with(['Book_By',
                    
                    'stock_details'=>function($query) use($product_id){
                        
                        $query->wherein('product_id',$product_id)->get();
                        
                     }
                    
                    
                    ,'po_numbers','party_info','stock_adda'])->get();
                }
                
                
            else{

                 $userId = $request->get('user_id');
                 $showparty= PartyName::select('id')->where('region_id','=',2)->get()->toArray();
                 $userId = $this->getUserIdFromToken($request);
            if ($userId == 103){
                $userrole = $this->getUserRole($userId);
              $dis_stoc= StockBooking::query();
                $dis_stoc=$dis_stoc ->where('type','=',NULL);
                $dis_stoc=$dis_stoc->where('party_check','=',NULL);
                $dis_stoc=$dis_stoc->where('booked_to','<>',99);
                $dis_stoc = $dis_stoc->wherein('party_id',$showparty);
                if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                    $dis_stoc = $dis_stoc->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);

                }
                if ($request->get('status') == 'Booked') {

                    $dis_stoc = $dis_stoc->whereIn('status', ['Booked', 'Delivered'])->with(['stock_details', 'Book_By','po_numbers','party_info','stock_adda'])->get();
                } else {
                    $dis_stoc = $dis_stoc->with(['stock_details', 'Book_By','po_numbers','party_info','stock_adda'])->get();
                }

            }else{

           
                $dis_stoc= StockBooking::query();
                $dis_stoc=$dis_stoc ->where('type','=',NULL);
                 $dis_stoc=$dis_stoc->where('party_check','=',NULL);
                $dis_stoc=$dis_stoc->where('booked_to','<>',99);
                
                if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                    $dis_stoc = $dis_stoc->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);

                }
                if ($request->get('status') == 'Booked') {

                    $dis_stoc = $dis_stoc->whereIn('status', ['Booked', 'Delivered'])->with(['stock_details', 'Book_By','po_numbers','party_info','stock_adda'])->get();
                }
                    //// get orders who's po number not created yet ///
    elseif($request->status == "new"){

            $data = [];
             $objs = $dis_stoc->where('status','Booked')->with(['stock_details','po_numbers','Book_By','party_info','stock_adda'])->get();

             foreach ($objs as $key => $obj) {

           if ($obj->po_numbers->isEmpty()){
            
            $data[] =  $obj;


        }

    }

     return API::response()->array(['success' => true,
            'message' => 'Stock Booking',
            'data'    => $data], 200);

        }

        ////
                
                else {
                    $dis_stoc = $dis_stoc->with(['stock_details', 'Book_By','po_numbers','party_info','stock_adda'])->get();
                }
            }
        }
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
   
   public function stockBookingOrderadv(Request $request){
        try {

            if(!empty($request->get('id'))){
                $dis_stoc= StockBooking::where('booked_by',$request->get('id'))
                    ->where('booked_to',99);
                if(!empty($request->get('start_date')) && !empty($request->get('end_date'))){
                    $dis_stoc=$dis_stoc->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
                }
                if($request->get('status')=='Booked'){
                    $dis_stoc=$dis_stoc ->whereIn('status', ['Booked', 'Delivered'])->with(['stock_details','Book_By','po_numbers','party_info'])->get();
                }else{
                    $dis_stoc=$dis_stoc->with(['stock_details','Book_By','po_numbers','party_info'])->get();
                }
            }else{
                $dis_stoc= StockBooking::query();
                $dis_stoc=$dis_stoc->where('booked_to',99);
                if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                    $dis_stoc = $dis_stoc->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
                }
                if ($request->get('status') == 'Booked') {
                    $dis_stoc = $dis_stoc->whereIn('status', ['Booked', 'Delivered'])->with(['stock_details', 'Book_By','po_numbers','party_info'])->get();
                } else {
                    $dis_stoc = $dis_stoc->with(['stock_details', 'Book_By','po_numbers','party_info'])->get();
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function stockBookingOrderAdjustment(Request $request){


    try {
        $userId = $this->getUserIdFromToken($request);
        $total_price = 0;
        
        if ( count($request['products']) >  0){

            foreach ($request['products'] as $key => $val) {
            
    $stock_detail  = StockBookingDetail::where('stock_booking_id',$request->id)->where('product_id',$val['product_id'])->first();

                if($stock_detail){
                    $stock_detail->quantity = $val['quantity'];
                    
                    $price = $val['quantity'] * $val['price'];


                   // $discount_price = $price-(($price*$request->discount)/100);

                   

                    $stock_detail->price = $price;

                    $stock_detail->payment = $price;

                    $stock_detail->save();



                }
           

           }

           $stocks= StockBookingDetail::where('stock_booking_id',$request->id)->get();
           foreach ($stocks as $key => $stock) {
            
               $total_price     = $total_price + $stock->price;

              


           }

             $stock_booking = StockBooking::where('id',$request->id)->first();
             if($stock_booking){

                $stock_booking->price = $total_price;
                $discount_price = $total_price-(($total_price*$request->discount)/100);
                $stock_booking->payment = $discount_price;
                $stock_booking->discount = $request->discount;

                $stock_booking->save();


                
             }
          
           

           }

        else{

             $stock_booking = StockBooking::where('id',$request->id)->first();
             if($stock_booking){

                
                $discount_price = $stock_booking->price-(($stock_booking->price*$request->discount)/100);
               
                $stock_booking->payment = $discount_price;
               
                $stock_booking->discount = $request->discount;

                $stock_booking->save();
            }
        }
        
        if($stock_booking){
          $remarks  = new PaymentRemark();
          $remarks->rsm_id = $request->id;
          $remarks->user_id = $userId;
          $remarks->type = "sale-return-edit";
          $remarks->remarks = "sale return price discount change";
          $remarks->user_remarks = $request->remarks;
          $remarks->save();
    }
        return API::response()->array(['success' => true,
            'message' => 'Stock Booking sales return  update'], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }

}
   
   
    public function stockBilty(Request $request){
        try {
            $dis_stoc=Bilti::where('stock_booking_id',$request->get('id')) ->with(['biltyImages','bilty_supplier','bilty_detail'=>function($query)
            {$query->with(['bilty_product','bilty_detail_type'=>function($query)
            {$query->with(['productCategory'])->get();}])->get();},])->get();
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Bilty ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockIn(Request $request){
        try {
            $dis_stoc=Bilti::where('delivered_to_id',$request->get('delivered_to_id'))
                ->whereBetween('bilti_received_date',[$request->get('start_date'),$request->get('end_date')])
                ->with(['biltyImages','bilty_supplier','bookBy','party_info','bilty_detail'=>function($query)
                {$query->with(['bilty_product','bilty_detail_type'=>function($query)
                {$query->with(['productCategory'])->get();}])->get();},])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'Stock In Detail',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockInDetail(Request $request){
        try {
            $dis_stoc=Bilti::where('id',$request->get('id'))
                ->with(['biltyImages','bilty_supplier','bookBy','party_info','bilty_detail'=>function($query)
                {$query->with(['bilty_product','bilty_detail_type'=>function($query)
                {$query->with(['productCategory'])->get();}])->get();},])
                ->first();
            return API::response()->array(['success' => true,
                'message' => 'Stock In Detail',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockPrevious(Request $request){
        try {
            $cur_stock=SoStock::where('so_id',$request->get('so_id'))->get();
            $salesStock=$this->soCustomersSales($request->get('so_id'),$request->get('date'));
            $ReceicedStock=$this->soDispatchProduct($request->get('so_id'),$request->get('date'));
            $data=[];
            if(!empty($cur_stock)){
                foreach ($cur_stock as $key=>$cStock){
                    $data[$key]['product_id']=$cStock['product_id'];
                    $data[$key]['product_name']=$cStock['product_name'];
                    $data[$key]['cotton']=$cStock['cotton'];
                    $data[$key]['cur_stock']=$cStock['qty'];
                    $data[$key]['sales_stock']=0;
                    $data[$key]['received_stock']=0;
                    if(!empty($salesStock) && count($salesStock)>0){
                        foreach ($salesStock as $sStock){
                            if($sStock['product_id']==$cStock['product_id']){
                                $data[$key]['sales_stock']=$sStock['quantity'];
                                break;
                            }
                        }
                    }
                    if(!empty($ReceicedStock) && count($ReceicedStock)>0){
                        foreach ($ReceicedStock as $rStock){
                            if($rStock['product_id']==$cStock['product_id']){
                                $data[$key]['received_stock']=$rStock['quantity_received'];
                                break;
                            }
                        }
                    }
                }

            }



            return API::response()->array(['success' => true,
                'message' => 'Stock In Detail',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function partyoutstandingPrevious(Request $request){
        try {
            $party=PartyName::select(['id','name','balance'])->get();
            $data=[];
            if(count($party)>0){
                foreach ($party as $key=>$cus){
                    $data[$key]['id']=$cus['id'];
                    $data[$key]['name']=$cus['name'];
                    $balance= (int) $cus['balance'];
                    $sales=UserExpenseDetail::where('party_id',$cus['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$request->get('date'),date('Y-m-d')])
                        ->sum('amount');
                    $balance=$balance-$sales;
                    $recovery=UserExpenseDetail::where('party_id',$cus['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$request->get('date'),date('Y-m-d')])
                        ->sum('amount');
                    $balance=$balance+$recovery;
                    $data[$key]['balance']=(int) $cus['balance'];
                    $data[$key]['previous_balance']=round($balance);
                    $data[$key]['sales']=$sales;
                    $data[$key]['recovery']=$recovery;
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Party Previous Balance',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function outstandingPrevious(Request $request){
        try {
            $customer=Customer::select(['id','name','balance'])->where('sale_officer_id',$request->get('so_id'))->get();
            $data=[];
            if(count($customer)>0){
              foreach ($customer as $key=>$cus){
                  $data[$key]['id']=$cus['id'];
                  $data[$key]['name']=$cus['name'];
                  $balance=(-1)* (int) $cus['balance'];
                  $sales=Order::where('shop_id',$cus['id'])
                      ->whereBetween('date_to_deliver', [$request->get('date'),date('Y-m-d')])
                      ->where('type', '!=', 'Sample')
                      ->where(function ($query) {
                          $query->where('status', 'Delivered')
                              ->orWhere('status', 'Returned');
                      })
                      ->sum('payment');
                  $balance=$balance-$sales;
                  $recovery=PaymentReceived::where('shop_id',$cus['id'])
                      ->whereBetween('promise_cheque_date', [$request->get('date'),date('Y-m-d')])
                      ->where('payment_type', '!=', 'Promise')->where('payment_type', '!=', 'Cheque')
                      ->sum('amount');
                  $balance=$balance+$recovery;
                  $data[$key]['balance']=(-1)* (int) $cus['balance'];
                  $data[$key]['previous_balance']=round($balance);
                  $data[$key]['sales']=$sales;
                  $data[$key]['recovery']=$recovery;
              }
            }
            return API::response()->array(['success' => true,
                'message' => 'Stock In Detail',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function soDispatchProduct($so_id,$date){
        $bilti_all=[];
        // so bilty get
        $bil=Bilti::select('id')->where('delivered_to_id',$so_id)
            ->whereBetween('bilti_received_date', [$date,date('Y-m-d')])
            ->get();
        if(!empty($bil) && count($bil)>0){
            foreach ($bil as $key=>$bi){
                $bilti_all[$key]=$bi['id'];
            }
        }
        // so bilty products get
        $bil_prod=BiltiDetail::select(DB::raw('sum(quantity_received) as quantity_received,product_id'))
            ->wherein('bilti_id',$bilti_all)
            ->groupBy('product_id')
            ->get();
        return $bil_prod;
    }
    public function soCustomersSales($so_id,$date){
        $cus_all=[];
        // so customer get
        $cus=Customer::select('id')->where('sale_officer_id',$so_id)->get();
        if(!empty($cus) && count($cus)>0){
            foreach ($cus as $key=>$cu){
                $cus_all[$key]=$cu['id'];
            }
        }
        $all_sales=[];
        // so customer sales get
        $sales=Order::wherein('shop_id',$cus_all)
            ->whereBetween('date_to_deliver', [$date,date('Y-m-d')])
            ->get();
        if(!empty($sales) && count($sales)>0){
            foreach ($sales as $key=>$su){
                $all_sales[$key]=$su['id'];
            }
        }
        // so customer sales product get
        $salesProduct=OrderProduct::select(DB::raw('sum(quantity) as quantity,product_id'))
            ->wherein('order_id',$all_sales)
            ->groupBy('product_id')
            ->get();


        return $salesProduct;
    }

    //   public function partyledger(Request $request){
    //     try {
            
    //          $obj=PartyName::where('id',$request->get('party_id'))->with(['party_ledger'=>function($query)
        
    //     {$query->orderBy('date', 'ASC');}])->first();
    //     if(!empty($obj) && !empty($obj->party_ledger)){
    //         $opening=$obj->opening_balance;
    //         foreach ($obj->party_ledger as $key=>$item){
    //             $update=UserExpenseDetail::where('id',$item['id'])->first();
    //             if(!empty($update)){
    //                 switch ($update['type']){
    //                     case 'Sale':
    //                         $opening=$opening+$update['amount'];
    //                         $update->balance=$opening;
    //                         $update->save();
    //                         break;
    //                     case 'Recovery':
    //                         $opening=$opening-$update['amount'];
    //                         $update->balance=$opening;
    //                         $update->save();
    //                         break;
    //                     case 'Credit Note':
    //                         $opening=$opening-$update['amount'];
    //                         $update->balance=$opening;
    //                         $update->save();
    //                         break;
    //                 }
    //             }
    //             $update->save();
    //         }
    //         $obj->balance=$opening;
    //         $obj->save();
    //     }
        
            
    //         $start=$request->get('start_date');
    //         $end=$request->get('end_date');
    //         $obj=PartyName::where('id',$request->get('party_id'))
            
            
            
    //         ->with(['party_ledger'=> function ($query) use($start,$end)
    //           {
                  
    //               $query->orderBy('date','ASC');
    //       //  $query->wherebetween('date',[$start,$end]);
                    
    //         //  },
            
            
            
    //         // 'party_ledger_credit' => function ($query) use($start,$end)
    //         //  {
                 
    //         //      $query->whereHas('user_expense',function($query1) use($start,$end){
                     
    //         //         $query1->where('accountant_check_credit','!=','0')->where('status','Approved');}
                      
    //         //           )->wherebetween('date',[$start,$end])->get();;
                     
                 
    //       }
             
             
    //          ])->first();

       
               

    //         return API::response()->array(['success' => true,
    //             'message' => 'Party Ledger',
    //             'data'    => $obj], 200);
    //     } catch(Exception $e) {
    //         return API::response()->array(['success' => false,
    //             'message' => $e->getTraceAsString()], 400);
    //     }
    // }
    
      public function partyledger(Request $request){
        try {
            $userId = $this->getUserIdFromToken($request);


 if($userId == 93){

      return API::response()->array(['success' => false,
        'message' => 'sorry you can not access this ledger'], 200);

 }
   
                   $obj=PartyName::where('id',$request->party_id)->with(['party_ledger'=>function($query)
        
        {$query->where('vendor_id',null)->orderBy('id', 'ASC');}])->first();
       
     
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
          
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
               //return $update;
                if(!empty($update)){
                    switch ($update['type']){
                        
                        case 'Sale':
                          
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                           
                           $update->save();
                            break;
                            case 'Debit Note':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                            
                        case 'Recovery':
                            
                            $opening=$opening-$update['amount'];
                        
                            $update->balance=$opening;
                            
                            $update->save();
                            break;
                        case 'Credit Note':
                           
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                              
                            $update->save();
                            
                            break;
                            
                            case 'Sale Return':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                    
                }
             
               $update->save();
            }
            
            
            $obj->balance=$opening;
            $obj->save();
        }
         
            
            $start=$request->start_date;
            $end=$request->end_date;
            $obj=PartyName::where('id',$request->party_id)
            
            
            
            ->with(['party_ledger'=> function ($query) use($start,$end)
              {   
                  
                  $query->orderBy('id','ASC');
                  
           
           }
             
             
             ])->first();

       
               

            return API::response()->array(['success' => true,
                'message' => 'Party Ledger',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function partyRecovery(Request $request){
        try {
            $obj=RsmPayment::where('id',$request->get('detail_id'))
                ->with(['party_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'Party Recovery Details',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function partySale(Request $request){
        try {
            $obj=Bilti::where('id',$request->get('detail_id'))
                ->with(['party_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'Party Sale Details',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function partyPrice(Request $request){
        try {
            $obj=PartyRates::where('party_id',$request->get('party_id'))
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'Party Prices Details',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
//     public function tenureBilty($start,$end,$part_id=0,$rsm_id=0){
//         //5000 shah filter
//         $bil=Bilti::query();
//         if($rsm_id!=0){
//             $bil=$bil->where('delivered_to_id',$rsm_id);
//         }
//         if($part_id==5000){
//             $bil=$bil->wherein('party_id',[1,2,3,4,5,6,7,8,18,24])->whereBetween('bilti_date', [$start, $end])->get();
//         }elseif($part_id==5001){
// //            export 50001 filter
//             $bil=$bil->whereNotIn('party_id',[1,2,3,4,5,6,7,8,18,19,20])->whereBetween('bilti_date', [$start, $end])->get();
//         }elseif($part_id!=0){
//             $bil=$bil->where('party_id',$part_id)->whereBetween('bilti_date', [$start, $end])->get();
//         }else{
//             $bil=$bil->whereBetween('bilti_date', [$start, $end])->get();
//         }
//         $bil_id=[];
//         if(!empty($bil)){
//             foreach ($bil as $bi){
//                 $bil_id []=$bi['id'];
//             }
//         }
//         return $bil_id;
//     }

        
             public function rsmParty($start,$end,$part_id=0,$rsm_id=0){
                
        $obj = [];
        if($rsm_id!=0){
                
                
                $user = User::where('id',$rsm_id)->first();
                
                 $region_id = $user->region_id;
                 if(!empty($region_id)){
                    $party= PartyName::where('region_id',$region_id)->get();
                    
                    foreach ($party as $key=>$pa){
                         
                        $obj[$key]=$pa['id'];
                       
                    }
                   
                }
                return $obj;
                   
                }        
                 
             }
        
    
   public function tenureBilty($start,$end,$part_id=0,$rsm_id=0){
        //5000 shah filter

        //    $start    = $start . ' 00:00:00';
        //    $end=  $end . ' 00:00:00';
    $bil=Bilti::query();
    if($rsm_id!=0){

      $bil=$bil->where('delivered_to_id',$rsm_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0);
  }
  if($part_id==5000){

    $party_id = PartyName::select('id')->whereNotIn('id', [19,20,33])->where('region_id','!=' , 2)->get();

    $bil=$bil->wherein('party_id',$party_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw','=',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();
}elseif($part_id==5001){
//            export 50001 filter
    $party_id = PartyName::select('id')->whereNotIn('id', [19,20,33])->where('region_id','=' , 2)->get();
    $bil=$bil->whereIn('party_id',$party_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();
}elseif($part_id!=0){
    $bil=$bil->where('party_id',$part_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw','=',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->get();
}else{


    $bil=$bil->whereBetween('delivered_date', [$start, $end])->whereNotIn('party_id', [19,20,33])->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw','=',0)->where('po_no_adv',0)->get();
}
$bil_id=[];
if(!empty($bil)){

    foreach ($bil as $bi){
        $bil_id []=$bi['id'];
    }
}
return $bil_id;
}
       
    public function rsmpartysalespercentage(Request $request){
        try {
            $user=User::where('id',$request->get('user_id'))->first();
            $obj=null;
            if(!empty($user) && !empty($user['region_id'])){
               $party= PartyName::where('region_id',$user['region_id'])->get();
               foreach ($party as $key=>$pa){
                   $obj[$key]['name']=$pa['name'];
                   $obj[$key]['sale']=UserExpenseDetail::where('party_id',$pa['id'])->where('type','Sale')
                       ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                       ->sum('amount');
               }
            }
            return API::response()->array(['success' => true,
                'message' => 'Party sales ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function allrsmpartysalespercentage(Request $request){
        try {
            $user=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'rsm');
            })
                ->where('id','<>',46)
                ->get();
            $obj=null;
            foreach ($user as $key=>$use){
                $obj[$key]['id']=$use['id'];
                $obj[$key]['firstname']=$use['firstname'];
                $obj[$key]['lastname']=$use['lastname'];
                 $obj[$key]['sale_rating']=$use['sale_rating'];
            $obj[$key]['recovery_rating']=$use['recovery_rating'];

                $obj[$key]['image']=$use['image'];
                if(!empty($use) && !empty($use['region_id'])){
                    $party= PartyName::where('region_id',$use['region_id'])
                    ->where('id','<>',14)
                        ->get();
                    foreach ($party as $key2=>$pa){
                        $obj[$key]['parties'][$key2]['id']=$pa['id'];
                        $obj[$key]['parties'][$key2]['name']=$pa['name'];
                        $obj[$key]['parties'][$key2]['sale']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Sale')
                            ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                            ->groupBy('type')
                            ->sum('amount');
                        $obj[$key]['parties'][$key2]['recovery']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Recovery')
                            ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                            ->groupBy('type')
                            ->sum('amount');
                    }
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Party sales ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
     /* ---- 12/27/2019 */

      public function monthlyrsmpartysalespercentage(Request $request){
        try {

            $start    = (new DateTime($request->start_date))->modify('first day of this month');
$end      = (new DateTime($request->end_date))->modify('first day of next month');
$interval = DateInterval::createFromDateString('1 month');
$period   = new DatePeriod($start, $interval, $end);
$user=User::whereHas('roles', function($query) {
$query->where('name', '=', 'rsm');
            })->where('id','<>',46) ->get();
            $obj=null;


 //Booking::whereBetween($dateTime->format('Y-m-00'), [DB::raw('start_date'), DB::raw('end_date')])->get();




                 foreach ($period as $key=> $dt) {
                            
                        $start_date[$key] = $dt->format("Y-m-00");

                        $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
                         $obj[$key]['date']=$start_date[$key];
           

            foreach ($user as $key2=>$use){
                $obj[$key]['data'][$key2]['id']=$use['id'];
                $obj[$key]['data'][$key2]['firstname']=$use['firstname'];
                $obj[$key]['data'][$key2]['lastname']=$use['lastname'];
                $obj[$key]['data'][$key2]['image']=$use['image'];
                  $obj[$key]['data'][$key2]['sale_rating']=$use['sale_rating'];
                $obj[$key]['data'][$key2]['recovery_rating']=$use['recovery_rating'];
                if(!empty($use) && !empty($use['region_id'])){
                    $party= PartyName::where('region_id',$use['region_id'])
                    ->where('id','<>',14)
                        ->get();
                       
                            
                    foreach ($party as $key3=>$pa){

                        $obj[$key]['data'][$key2]['parties'][$key3]['id']=$pa['id'];
                        $obj[$key]['data'][$key2]['parties'][$key3]['name']=$pa['name'];
                        $obj[$key]['data'][$key2]['parties'][$key3]['sale']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Sale')
                            ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                            ->groupBy('type')
                            ->sum('amount');
                        $obj[$key]['data'][$key2]['parties'][$key3]['recovery']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Recovery')
                            ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                            ->groupBy('type')
                            ->sum('amount');
                    }
                    
                }
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Party sales ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
///// filter monthlywise and rsmwise and partywise sale recovery 


///// filter monthlywise and rsmwise and partywise sale recovery 


public function monthlyrsmorpartysalespercentage(Request $request){
    try {

        $start    = (new DateTime($request->start_date))->modify('first day of this month');
        $end      = (new DateTime($request->end_date))->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
          $obj=null;

        if($request->rsm_id != 0){

        $user=User::where('id',$request->rsm_id)->first();

        foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
           

                if(!empty($user) && !empty($user->region_id)){
                    $party= PartyName::where('region_id',$user->region_id)->whereNotIn('id', [19,20,33])
                    ->where('id','<>',14)
                    ->get();


                    foreach ($party as $key2=>$pa){
                         $obj[$key][$key2]['date']=$start_date[$key];
                        $obj[$key][$key2]['id']=$pa['id'];
                        $obj[$key][$key2]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                        $obj[$key][$key2]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                    }
                    
                }
            
        }
    }
        if($request->party_id != 0){
            if($request->party_id == 5000){
                
             
                 foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
           
                   
                       $party = PartyName::where('show_gm', 1)->whereNotIn('id', [19,20,33])->get();
                    
                    
                    foreach ($party as $key2=>$pa){
                         $obj[$key][$key2]['date']=$start_date[$key];
                        $obj[$key][$key2]['id']=$pa['id'];
                        $obj[$key][$key2]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                        $obj[$key][$key2]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                    }
                     
        }


        }elseif($request->party_id == 5001){

         
//            export 50001 filter
    
     foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
           
                   
                       $party = PartyName::where('region_id','=' , 2)->whereNotIn('id', [19,20,33])->get();
                    
                
                    foreach ($party as $key2=>$pa){
                         $obj[$key][$key2]['date']=$start_date[$key];
                        $obj[$key][$key2]['id']=$pa['id'];
                        $obj[$key][$key2]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                        $obj[$key][$key2]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                    }
                     
        }
}

        
            else{

            foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
           
                    $party= PartyName::where('id',$request->party_id)->whereNotIn('id', [19,20,33])

                    ->get();


                    foreach ($party as $key2=>$pa){
                         $obj[$key][$key2]['date']=$start_date[$key];
                        $obj[$key][$key2]['id']=$pa['id'];
                        $obj[$key][$key2]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                        $obj[$key][$key2]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                    }
                     
        }

    }
        }
        if($request->rsm_id == 0 && $request->party_id == 0){


        foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
      
                    $party= PartyName::whereNotIn('id', [19,20,33])->get();
                   

                    
                 
                    foreach ($party as $key2=>$pa){
                         $obj[$key][$key2]['date']=$start_date[$key];
                        $obj[$key][$key2]['id']=$pa['id'];
                        $obj[$key][$key2]['sale']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Sale')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                        $obj[$key][$key2]['recovery']=UserExpenseDetail::
                        where('party_id',$pa['id'])
                        ->where('type','Recovery')
                        ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                        ->groupBy('type')
                        ->sum('amount');
                    }
                    
                
            
        }
        }
    
        return API::response()->array(['success' => true,
            'message' => 'Party sales ',
            'data'    => $obj], 200);
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
/* ------ */
/* ........ clone  .......    ///// filter monthlywise and rsmwise and partywise sale recovery and asm recovery */

public function monthlyrsmorpartysalespercentageasm(Request $request){
    try {

        $start    = (new DateTime($request->start_date))->modify('first day of this month');
        $end      = (new DateTime($request->end_date))->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
        $obj=null;

        if($request->rsm_id != 0){

            $user=User::where('id',$request->rsm_id)->first();

            foreach ($period as $key=> $dt) {

                $start_date[$key] = $dt->format("Y-m-00");

                $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
                

                if(!empty($user) && !empty($user->region_id)){
                    $party= PartyName::where('region_id',$user->region_id)->whereNotIn('id', [19,20,33])
                    ->where('id','<>',14)
                    ->get();


                    foreach ($party as $key2=>$pa){
                      $user_id =[];
                      $users=User::whereHas('roles', function($query) {
                        $query->where('name', '=', 'asm');
                    })->select('id')->where('party_id','=',$pa['id'])->get()->toArray();


                      foreach ($users as $key3 => $use) {
                          $user_id[] = $use['id'];
                      }
                      $obj[$key][$key2]['date']=$start_date[$key];
                      $obj[$key][$key2]['id']=$pa['id'];
                      $obj[$key][$key2]['rsm_id']= $pa->region->rsm_id;
                      $obj[$key][$key2]['sale']=UserExpenseDetail::
                      where('party_id',$pa['id'])
                      ->where('type','Sale')
                      ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                      ->groupBy('type')
                      ->sum('amount');
                      $obj[$key][$key2]['recovery']=UserExpenseDetail::
                      where('party_id',$pa['id'])
                      ->where('type','Recovery')
                      ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                      ->groupBy('type')
                      ->sum('amount');

                       $obj[$key][$key2]['asm_recovery']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_recovery')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');

              $obj[$key][$key2]['asm_sale']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_sale')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');
                  }

              }

          }
      }
      if($request->party_id != 0){
        if($request->party_id == 5000){


         foreach ($period as $key=> $dt) {

            $start_date[$key] = $dt->format("Y-m-00");

            $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
            
            
            $party = PartyName::where('show_gm', 1)->whereNotIn('id', [19,20,33])->get();
            
            
            foreach ($party as $key2=>$pa){
               $user_id =[];
               $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->select('id')->where('party_id','=',$pa['id'])->get()->toArray();
               foreach ($users as $key3 => $user) {
                  $user_id[] = $user['id'];
              }

              $obj[$key][$key2]['date']=$start_date[$key];
              $obj[$key][$key2]['id']=$pa['id'];
              $obj[$key][$key2]['rsm_id']= $pa->region->rsm_id;
              $obj[$key][$key2]['sale']=UserExpenseDetail::
              where('party_id',$pa['id'])
              ->where('type','Sale')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');
              $obj[$key][$key2]['recovery']=UserExpenseDetail::
              where('party_id',$pa['id'])
              ->where('type','Recovery')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');

              $obj[$key][$key2]['asm_recovery']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_recovery')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');

              $obj[$key][$key2]['asm_sale']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_sale')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');
          }

      }


  }elseif($request->party_id == 5001){


//            export 50001 filter

     foreach ($period as $key=> $dt) {

        $start_date[$key] = $dt->format("Y-m-00");

        $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
        
        
        $party = PartyName::where('region_id','=' , 2)->whereNotIn('id', [19,20,33])->get();
        
        


          $obj[$key][$key2]['date']=$start_date[$key];
          $obj[$key][$key2]['id']=$pa['id'];
          $obj[$key][$key2]['rsm_id']= $pa->region->rsm_id;
          $obj[$key][$key2]['sale']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Sale')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');
          $obj[$key][$key2]['recovery']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Recovery')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');
          
          
      }

  }
}


else{

    foreach ($period as $key=> $dt) {

        $start_date[$key] = $dt->format("Y-m-00");

        $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
        
        $party= PartyName::where('id',$request->party_id)->whereNotIn('id', [19,20,33])

        ->get();


        foreach ($party as $key2=>$pa){
           $user_id =[];
           $users=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->select('id')->where('party_id','=',$pa['id'])->get()->toArray();

           foreach ($users as $key3 => $user) {
              $user_id[] = $user['id'];
          }

          $obj[$key][$key2]['date']=$start_date[$key];
          $obj[$key][$key2]['id']=$pa['id'];
          $obj[$key][$key2]['rsm_id']= $pa->region->rsm_id;

          $obj[$key][$key2]['sale']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Sale')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');

          $obj[$key][$key2]['recovery']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Recovery')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');

           $obj[$key][$key2]['asm_recovery']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_recovery')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');

              $obj[$key][$key2]['asm_sale']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_sale')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');
      }

  }

}

if($request->rsm_id == 0 && $request->party_id == 0){






    foreach ($period as $key=> $dt) {

        $start_date[$key] = $dt->format("Y-m-00");

        $end_date[$key] =  $dt->add($interval)->format("Y-m-00");
        
        $party= PartyName::whereNotIn('id', [19,20,33])->get();

        

        
        foreach ($party as $key2=>$pa){

            $user_id =[];



            $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->select('id')->where('party_id','=',$pa['id'])->get()->toArray();

            
            foreach ($users as $key3 => $user) {
              $user_id[] = $user['id'];
          }

          $obj[$key][$key2]['date']=$start_date[$key];
          $obj[$key][$key2]['id']=$pa['id'];
          $obj[$key][$key2]['rsm_id']= $pa->region->rsm_id;
     

          $obj[$key][$key2]['sale']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Sale')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');

          $obj[$key][$key2]['recovery']=UserExpenseDetail::
          where('party_id',$pa['id'])
          ->where('type','Recovery')
          ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
          ->groupBy('type')
          ->sum('amount');

           $obj[$key][$key2]['asm_recovery']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_recovery')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');

              $obj[$key][$key2]['asm_sale']=UserExpenseDetail::
              whereIn('user_id',$user_id)
              ->where('type','Sub_sale')
              ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
              ->groupBy('type')
              ->sum('amount');
      }



  }
}

return API::response()->array(['success' => true,
    'message' => 'Party sales ',
    'data'    => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function allrsmpartysalespercentageExport(Request $request){
    try {

           $userId = $this->getUserIdFromToken($request);
                //return $userId;
        $userrole = $this->getUserRole($userId);
        $user = null;
        if($userrole == 'gm'){
        $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'rsm');
        })->where('id','<>',46)
        ->get();
    }
    elseif ($userrole == 'rsm') {

        $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'rsm');
        })->where('id','=',$userId)
        ->get();

    }else{
         $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'rsm');
        })
         //->where('id','<>',46)
        ->get();

    }

        $obj=null;
       // $obj['total'] = 0;

        foreach ($user as $key=>$use){
            if(!empty($use) && !empty($use['region_id'])){
             
               $obj[$key]['id']=$use['id'];
               $obj[$key]['firstname']=$use['firstname'];
               $obj[$key]['lastname']=$use['lastname'];
               $obj[$key]['phone_1']=$use['phone_1'];
               $obj[$key]['image']=$use['image'];
               $party= PartyName::where('region_id',$use['region_id'])
//                    ->where('id','<>',14)
               ->get();
               $asm=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'asm');
        })->where('rsm_id',$use['id'])->get();
//                    ->where('id','<>',14)
             
               

           }
           if($party !=null){
            foreach ($party as $key2=>$pa){
                $obj[$key]['parties'][$key2]['id']=$pa['id'];
                $obj[$key]['parties'][$key2]['name']=$pa['name'];
                $obj[$key]['parties'][$key2]['region']=$pa['region_id'];
                $obj[$key]['parties'][$key2]['sale']=UserExpenseDetail::
                where('party_id',$pa['id'])
                ->where('type','Sale')
                ->whereBetween('date', [$request->start_date, $request->end_date])
                ->groupBy('type')
                ->sum('amount');
                $obj[$key]['parties'][$key2]['recovery']=UserExpenseDetail::
                where('party_id',$pa['id'])
                ->where('type','Recovery')
                ->whereBetween('date', [$request->start_date, $request->end_date])
                ->groupBy('type')
                ->sum('amount');

               // $obj['total'] = $obj['total'] + $obj[$key]['parties'][$key2]['sale'];
            }
        }
        if($asm !=null){
              foreach ($asm as $key3=>$as){
                $obj[$key]['asm'][$key3]=$as;
                
               // $obj['total'] = $obj['total'] + $obj[$key]['parties'][$key2]['sale'];
            }
        }


        }
    

return API::response()->array(['success' => true,
    'message' => 'Party sales ',
    'data'    => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
   public function saleProductwise(Request $request){
        try {
            $userId = $this->getUserIdFromToken($request);

        $userrole = $this->getUserRole($userId);

        
        if($userrole == "super_admin"){
            $pro=Product::where('category_id',1)->get();
             
        }else{
            $pro=Product::where('category_id',1)->where('show_rsm',0)->get();
             
        }
            $obj=[];
            if($request->rsm_id == 0  ){
            $bilty_id=$this->tenureBilty($request->start_date,$request->end_date,$request->party_id,$request->rsm_id);
            
             $dubai_party_id=Bilti::select('id')->wherein('id',$bilty_id)->where('party_id','=',14)->get()->toarray();
           
            $party_id=Bilti::select('id')->wherein('id',$bilty_id)->where('party_id','!=',14)->get()->toarray();
                 foreach ($pro as $key=>$pr){
                $obj[$key]['id']= $pr['id'];
                $obj[$key]['name']= $pr['name'];
                $obj[$key]['cotton']= $pr['cotton'];
                $obj[$key]['quantity']=0;
                $obj[$key]['payment']=0;
               
                $bil=BiltiDetail::select(DB::raw('sum(quantity) as quantity,sum(payment) as payment'))
                    ->wherein('bilti_id',$party_id)->where('product_id',$pr['id'])
                    ->groupBy('product_id')
                    ->first();
                    
                    $dubai_bil=BiltiDetail::select(DB::raw('sum(quantity) as quantity,sum(payment) as payment'))
                    ->wherein('bilti_id',$dubai_party_id)->where('product_id',$pr['id'])
                    ->groupBy('product_id')
                    ->first();
                    
                if(!empty($bil) && !empty($bil['quantity'])){
                    $obj[$key]['quantity']=$bil['quantity'];
                  
                        $obj[$key]['payment']=$bil['payment']+($dubai_bil['payment']);
                    

                }
            }



                }
                else
                {
                    $start  = $request->start_date;
                   $end = $request->end_date;
                     $party=$this->rsmParty($request->start_date,$request->end_date,$request->party_id,$request->rsm_id);
                   
                      $dubai_party_id=Bilti::select('id')->wherein('party_id',$party)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->where('party_id','=',14)->get()->toarray();

          $bilty_id=Bilti::select('id')->wherein('party_id',$party)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start, $end])->where('party_id','!=',14)->get()->toarray();
      
                foreach ($pro as $key=>$pr){
                $obj[$key]['id']= $pr['id'];
                $obj[$key]['name']= $pr['name'];
                $obj[$key]['cotton']= $pr['cotton'];
                $obj[$key]['quantity']=0;
                $obj[$key]['payment']=0;
               
                $bil=BiltiDetail::select(DB::raw('sum(quantity) as quantity,sum(payment) as payment'))
                    ->wherein('bilti_id',$bilty_id)->where('product_id',$pr['id'])
                    ->groupBy('product_id')
                    ->first();
                    
                    $dubai_bil=BiltiDetail::select(DB::raw('sum(quantity) as quantity,sum(payment) as payment'))
                    ->wherein('bilti_id',$dubai_party_id)->where('product_id',$pr['id'])
                    ->groupBy('product_id')
                    ->first();
                    
                if(!empty($bil) && !empty($bil['quantity'])){
                    $obj[$key]['quantity']=$bil['quantity'];
                  
                        $obj[$key]['payment']=$bil['payment']+($dubai_bil['payment']);
                    

                }
            }





 
                }
           
           
            return API::response()->array(['success' => true,
                'message' => 'Party Prices Details',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function addAdda(Request $request){
        try {
            $adda=new BiltyAdda();
            $adda->user_id=$request->get('user_id');
            $adda->party_id=$request->get('party_id');
            $adda->name=$request->get('name');
            $adda->address=$request->get('address');
            $adda->phone=$request->get('phone');
            $filename='';
            if ($request->hasFile('image')) {
                $filename = 'image-' . time() . rand(99, 199) . '.' . $request->file('image')->getClientOriginalExtension();
                $request->file('image')->move(public_path() . '/uploads/bilty_adda/', $filename);
            }
            if(!empty($filename)){
                $adda->image=url('/uploads/bilty_adda/'.$filename) ;
            }else{
                $adda->image=$filename;
            }
            $adda->save();
            return API::response()->array(['success' => true,
                'message' => 'Bilty Adda added',
                'data'    => $adda], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function getAdda(Request $request){
        try {
            $adda= BiltyAdda::where('party_id',$request->get('party_id'))->get();


            return API::response()->array(['success' => true,
                'message' => 'Bilty Adda ',
                'data'    => $adda], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockBookingStatus(Request $request){
        try {
           $dis_stoc= StockBooking::where('id',$request->get('id'))->first();
           if(!empty($dis_stoc)){
               $dis_stoc->status=$request->get('status');
               
                PoNumber:: where('stock_booking_id',$request->get('id'))
                    ->update(array('status' =>'Completed' ));
               
               $dis_stoc->save();
           }
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Completed ',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function stockBookingDetail(Request $request){
        try {
            $obj = StockBooking::query();
            if (!empty($request->get('booked_by'))) {
                $obj = $obj->where('booked_by',$request->get('booked_by'));
            }
            if (!empty($request->get('type'))) {
                if(($request->get('type')=='Advertisement')){
                    $obj = $obj->where('booked_to',99);
                }else{
                    $obj = $obj->where('booked_to','<>',99);
                }
            }
            $obj = $obj->with(['stock_details','Bilty_Adda','party_info'])->get();
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Details',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function stockBookingDetailRaw(Request $request){
    try {

        if($request->status == "new"){
            $data = [];
             $objs = StockBooking::where('type',$request->type)->whereIn('status',['Booked'])->with(['BookTo','po_numbers'])->get();

             foreach ($objs as $key => $obj) {

           if ($obj->po_numbers->isEmpty()){
            
            $data[] =  $obj;


        }

    }

     return API::response()->array(['success' => true,
            'message' => 'Stock Booking Details',
            'data'    => $data], 200);

        }else{
        $obj = StockBooking::query();
        if (!empty($request->type)) {
            $obj = $obj->where('type',$request->type)->whereIn('status',['Booked','Delivered']);
        }

        $obj = $obj->with(['BookTo','po_numbers'])->get();
        return API::response()->array(['success' => true,
            'message' => 'Stock Booking Details',
            'data'    => $obj], 200);
    }
    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
    
    
    
    
    
    public function BookingBiltyDetail(Request $request){
        try {

            $dis_stoc=StockBookingDetail::where('stock_booking_id',$request->get('id'))->with(['product_category','product'])->get();


            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Bilty Details',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
       public function stockbookingupdate(Request $request)
 {
    try {
        
        if(!empty( $request['stock_orders']['stock_details']))

        {
        foreach ( $request['stock_orders']['stock_details'] as $key => $stock) {
          
          $find=StockBookingDetail::where('product_id',$stock['product_id'])->where('stock_booking_id',$request->get('stock_booking_id'))->first();
         
          if(!empty($find)){
          
          $find->dispatch_quantity = $stock['dispatch_quantity'];
   
          $find->save();
               
        }
    }
    $remarks  = new PaymentRemark();
                $remarks->rsm_id = $request->get('po_number');
                $remarks->type = "po_update";
                $remarks->remarks = $request->get('remarks');
                $remarks->save();
    }

         
         
         return API::response()->array(['success' => true,
            'message' => 'Stock booking updated'], 200);

     } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
}
public function stockbookingandpostatusupdate(Request $request)
{
    try {
        $userId = $this->getUserIdFromToken($request);
         $id =  $request->stock_id;

        if ($id){
            if($request->status == "Completed"){


                 $find=StockBooking::where('id',$id)->first();
                $old_status   =  $find->status;
                $find->status = $request->status;

                $find->save();
               

               $ponumber    = PoNumber::where('stock_booking_id',$find->id)->first();
              if($ponumber){
               $old_po_status = $ponumber->status;
               $ponumber->status = $request->status;
               $new_po_status = $request->status;

               $ponumber->save();
           }else{
                $old_po_status = "no po";
                $new_po_status = "no po";
           }
  $stock_log  =   new  PaymentRemark();
   $stock_log->rsm_id = $id;
   $stock_log->user_id = $userId;
   $stock_log->type = "stock_po_status_log";
    $remark =$remark ."old stockbooking status: ". $old_status . "<br> updated stockbooking status: " .  $request->status."% <br> old po status: " .  $old_po_status."<br> update po status: " .  $new_po_status."<br>";
   $stock_log->remarks = $remark;



   $stock_log->user_remarks = $request->remarks;
   $stock_log->save();


            }
            if($request->status == "Cancelled"){

                 $find=StockBooking::where('id',$id)->first();
               
                $old_status   =  $find->status;
                $find->status = $request->status;

                $find->save();
               

               $ponumber    = PoNumber::where('stock_booking_id',$find->id)->first();
              if($ponumber){
               $old_po_status = $ponumber->status;
               $ponumber->status = $request->status;
                $new_po_status = $request->status;
               $ponumber->save();
           }else
           {
              $old_po_status = "no po";
                $new_po_status = "no po";
           }
  $stock_log  =   new  PaymentRemark();
   $stock_log->rsm_id = $id;
   $stock_log->user_id = $userId;
   $stock_log->type = "stock_po_status_log";
    $remark =$remark ."old stockbooking status: ". $old_status . "<br> updated stockbooking status: " .  $request->status."% <br> old po status: " .  $old_po_status."<br> update po status: " .  $new_po_status."<br>";
   
   $stock_log->remarks = $remark;

   $stock_log->user_remarks = $request->remarks;
   $stock_log->save();

            }

        }else{

            return API::response()->array(['success' => false,
        'message' => 'not found'], 400);
        }

      return API::response()->array(['success' => true,
        'message' => 'Stock booking updated'], 200);

  } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

}

// public function VendorPendingOrderNotification(Request $request){
//     $vendor = VendorDetail::select('user_id')->get()->toarray();
//     $users=User::wherein('id',$vendor)->with(['vendor_products'=>function($query){
//                     $query->with(['productBookingDetails'=>function($query){
//                         $query->with(['bookingStatus'=>function($query){
//                             $query->get();
//                         }])->get();
//                     }])->get();
//                 }])->get();
    
//     foreach($users as $user){
//         return $user;
//     }
// }

public function getrsmpartystock(Request $request){
        try {
            $obj= Region::where('rsm_id','=',$request->id)->first();

            $parties =PartyName::where('region_id',$obj->id)->with('soul_distributer')->get();
         
            if($parties){

                  return API::response()->array(['success' => true,
                'message' => 'Party with stock',
                'data'    => $parties], 200);

            }
              
            return API::response()->array(['success' => true,
                'message' => 'Party sales ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }


public function VendorPendingOrderNotification(Request $request){
    
    $vendor = VendorDetail::select('user_id')->where('sms','1')->get()->toarray();
    $users=User::wherein('id',$vendor)->with(['vendor_products'=>function($query){
        $query->where('category_id',1)->get();
    }])->get();
    
   
      //  $results = DB::table('stock_booking_details')->get();
    
   // $results = DB::select( DB::raw("SELECT * FROM stock_booking_details ") );
   $results = StockBooking::select('id')->wherein('status',['Booked','Delivered'])->where('party_check','=',NULL)->where('type','=',NULL)->get()->toarray();
  // $results = StockBooking::select('id')->whereBetween('date', [$startdate,$enddate])->get();
   
 //  return $result;
   
   $obj = array();
    $q1 = 0;
    $d1 = 0;
   foreach($users as $key1=>$user){
     //  return $user->vendor_products;
       $phone = $user->phone_1;
       // $obj[$key1]['user'];
      // return $user;
       foreach($user->vendor_products as $key2=>$product){
           //return $product->id;
            $obj[$key2]['id']= $product->id;
            $obj[$key2]['product']= $product->name;
            //return $obj;
            $obj[$key2]['cotton']=$product->cotton;
            $BookingDetails=StockBookingDetail::wherein('stock_booking_id',$results)->where('product_id','=',$product->id)->get()->toarray();
            //return $BookingDetails[1];
            $i = 0;
            foreach($BookingDetails as $key3=>$BookingDetail){
                    
                    $var = $BookingDetail['dispatch_quantity'];
                    //return $var;
                          $q1    =  $q1 + $var;
                          $d1 = $d1 + $BookingDetail['delivered'];              
                 
                 
            }
            
                 $obj[$key2]['qty'] = $q1;
                 $obj[$key2]['delivered'] = $d1;
                 $obj[$key2]['total'] = round(($q1 - $d1)/$product->cotton,2);
             
      //  $aaa    = $BookingDetails->where('product_id',$product->id)->get();
      //  return $BookingDetails;
      
     $q1 = 0;
     $d1 = 0;
       }
    //   $stock = StockBookingDetail::wherein('stock_booking_id',$results)->get();
     //  return $obj;
    //   $user
    foreach($obj as $ob){
       // return $ob;
       if($ob['total'] != 0){
        $name[] = $ob['product']." (QTY: ".$ob['total'].")";
       }
    }
    $productName = implode("\n", $name);
      // return $productName;
            $Vendorobj=array();
            $Vendorobj['number']="$phone";
            $Vendorobj['text']="Dear Sir,\n\n*Please Focus On These Pending Orders.*\n\n$productName\n\n*Thank You*";
            $Vendorobj['instance']="biocos";
            $Vendorobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chVendor = curl_init('http://whatsapi.co.uk/api/sendMessage'); // Initialise cURL   
    
            $postVendor = json_encode($Vendorobj); // Encode the data array into a JSON string
    
            curl_setopt($chVendor, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chVendor, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chVendor, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chVendor, CURLOPT_POSTFIELDS, $postVendor); // Set the posted fields
            curl_setopt($chVendor, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultVendor = curl_exec($chVendor); // Execute the cURL statement
            curl_close($chVendor); // Close the cURL connection  
           // $productName = '';
           unset($obj);
            unset($name);
   }
//  
    
  //  return $users;         
}

}