<?php
/**
 * Created by PhpStorm.
 * User: raza
 * Date: 10/22/17
 * Time: 4:37 PM
 */

namespace App\Http\Controllers;
use App\Models\Account;
use App\Models\Bilti;
use App\Models\AsmTarget;
use App\Models\DsfTarget;
use App\Models\Region;
use App\Models\AsmSchedule;
use App\Models\Customer;
use App\Models\Expense;
use App\Models\SubExpense;
use App\Models\ExpenseTag;
use App\Models\StockBooking;
use App\Models\Order;
use App\Models\PartyName;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\RsmPayment;
use App\Models\RsmPaymentImage;
use App\Models\SupplierSo;
use App\Models\Target;
use App\Models\RsmTarget;
use App\Models\CoupanScheme;
use App\Models\TargetDetail;
use App\Models\VendorInvoice;
use App\Models\User;
use App\Models\PaymentRemark;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\UserPoint;
use App\Models\AsmAssignParty;
use App\Models\Visit;
use App\Models\VisitDetail;
use Carbon\Carbon;
use DateTime;
use DatePeriod;
use DateInterval;
use App\Models\Subdistributor;
use Dingo\Api\Facade\API;
use League\Flysystem\Exception;
use Illuminate\Http\Request;
use DB;
use PhpParser\Node\Expr\AssignOp\Concat;

class TargetController extends BaseController
{
    /***
     * @var UserPoint
     */
    private $_userPointsModel;

    /***
     * Constructor
     *RSMAddPayment
     * @param $request
     * @param UserPoint $userPointsModel
     */
    public function __construct(Request $request, UserPoint $userPointsModel)
    {
        parent::__construct($request);
        $this->_userPointsModel = $userPointsModel;
    }

    /***
     *Get User points
     *
     * @param $request
     * @return mixed
     */
    public function getUserPoints(Request $request)
    {
        try {
            $userId = $request->get('user_id');
            $startDate = $request->get('start_date');
            $endDate   = $request->get('end_date');
            $points = $this->_userPointsModel->getUserPoints($userId, $startDate, $endDate);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points',
            'data' => $points], 200);
    }
    public function UserPointsDetails(Request $request)
    {
        try {
            $points = $this->_userPointsModel->UserPointsDetails($request->get('user_id'), $request->get('start_date'),$request->get('end_date'));
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points',
            'data' => $points], 200);
    }
    public function UserPointsDetail(Request $request)
    {
        try {
            $points = $this->_userPointsModel->UserPointsDetail($request->get('user_id'),$request->get('date'),$request->get('point_type_id'));
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points Details',
            'data' => $points], 200);
    }
    public function UserDozenPointsDetail(Request $request)
    {
        try {
            $points = $this->_userPointsModel->UserDozenPointsDetail($request->get('user_id'),$request->get('date'),$request->get('point_type_id'));
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points Details',
            'data' => $points], 200);
    }

    public function UserPointsTenure(Request $request)
    {
        try {
            $points = $this->_userPointsModel->UserPointsTenure($request->get('user_id'), $request->get('start_date'),$request->get('end_date'),$request->get('point_type_id'));
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points',
            'data' => $points], 200);
    }
    public function UserPoints(Request $request)
    {
        try {
            $userId = $request->get('user_id');
            $startDate = $request->get('start_date');
            $endDate   = $request->get('end_date');
            $sendDateWise = $request->get('date_wise');

            if(!is_null($startDate)) {
                //$startDate = Carbon::parse($startDate)->toDateString();
                //$endDate = Carbon::parse($endDate)->toDateString();
            }
            if(IsNullOrEmptyString($userId)) {
                $userId = $this->getUserIdFromToken($request);
            }
            $points = $this->_userPointsModel->UserPoints($userId, $startDate, $endDate, $sendDateWise);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'User points',
            'data' => $points], 200);
    }
    /***
     *Get Expense Type
     */
    public function expenseTypes(Request $request)
    {
        try {
            $types = $this->_userPointsModel->expenseTypes($request);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Types',
            'data' => $types], 200);
    }
   
    
     public function creditnote(Request $request)
    {
        try {
            
            if($request->user_id==0 ) {


                $obj = UserExpense::select('party_id')->get()->toarray();
             $party=PartyName::select('id')->where('region_id','!=',2)->whereIn('id',$obj)->get()->toarray(); 
             $obj=UserExpense::whereIn('party_id',$party)->wherein('expense_id',[71,82])->with(['party_info'])
                ->get();
            }else 
             if($request->user_id==101 ) {

                $obj = UserExpense::select('party_id')->get()->toarray();
             $party=PartyName::select('id')->where('region_id','!=',2)->whereIn('id',$obj)->get()->toarray(); 
             $obj=UserExpense::whereIn('party_id',$party)->wherein('expense_id',[71,82])->with(['party_info'])
                ->get();
             
            }
            else if ($request->status=="accountant_pending") {
             
                $obj = UserExpense::select('party_id')->get()->toarray();
              $party=PartyName::select('id')->whereIn('id',$obj)->get()->toarray(); 
                
              $obj=UserExpense::whereIn('party_id',$party)->where('status',"Approved")->where('accountant_check_credit',null)->wherein('expense_id',[71,82])->with(['party_info'])
                ->get();


            } 

    
         else{

             $party=$request->party_id;
                  
             $obj = null;
              if (!empty($request->user_id) && $request->status=='All') {

                     if(empty($request['tags'])){
                       
                       $obj=UserExpense::wherein('expense_id',[71,82])->with(['party_info'])
                ->get();
                }
                
                     
                     else{

                     $getid = [];

                     $obj2 =[];           

                     foreach ($request['tags'] as $key => $tag) {
                           
                            
                                 array_push($getid, $tag['id']);

                           }


                     
                $expensestags = ExpenseTag::wherein('tag_id',$getid)->get();

                foreach ($expensestags as $key2 => $expensestag) {
                    $check = $expensestag->User_expensetag;
                    if($check){
                        $obj2[]= $check;
         
                    }
                }

                $obj =  array_values(array_unique($obj2));
                

               
            
        }
        
            
            }
            else{
                  $obj = UserExpense::query();
           
            if (!empty($request->status) && $request->status=='Pending' && $party!=0 ) {

                $obj = $obj->where('status', 'Pending')->where('party_id',$party);
            }
             
            if (!empty($request->status) && $request->status=='Cancelled' && $party!=0 ) {
                $obj = $obj->where('status', 'Cancelled')->where('party_id',$party);
            }
            if (!empty($request->status) && $request->status=='Approved' && $party!=0 ) {
                    $obj = $obj->where('status', 'Approved')->where('party_id',$party);
                }
                
                if (!empty($request->start_date) && !empty($request->end_date)) {
                        $obj = $obj->whereBetween('date', [$request->start_date, $request->end_date]);
                    }
                    if (!empty($request->status) && $request->status=='Pending') {
                        $obj = $obj->where('status', 'Pending');
                    }
                    if (!empty($request->status) && $request->status=='Cancelled') {
                        $obj = $obj->where('status', 'Cancelled');
                    }
                    if (!empty($request->status) && $request->status=='Approved') {
                        $obj = $obj->where('status', 'Approved');
                    }
                
            $obj = $obj->wherein('expense_id',[71,82])->with(['party_info'])
                ->get();
                
         }
     }
   
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Credit Note',
            'data' => $obj], 200);
    }
      public function debitnote(Request $request)
    {
        try {

            if($request->get('user_id')==0 ) {

                 $obj = UserExpense::select('party_id')->get()->toarray();

             $party=PartyName::select('id')->where('region_id','!=',2)->whereIn('id',$obj)->get()->toarray();


            if (!empty($request->status) && $request->status=='Pending') {
               $obj=UserExpense::where('status','Pending')->whereIn('party_id',$party)->wherein('expense_id',[93,94])->with(['party_info'])->get();
            }
            if (!empty($request->status) && $request->status=='Cancelled' ) {
                 $obj=UserExpense::where('status','Cancelled')->whereIn('party_id',$party)->wherein('expense_id',[93,94])->with(['party_info'])->get();
            }
            if (!empty($request->status) && $request->status=='Approved' ) {
                     $obj=UserExpense::where('status','Approved')->whereIn('party_id',$party)->wherein('expense_id',[93,94])->with(['party_info'])->get();
                }
            }else
             if($request->get('user_id')==101 ) {
                $obj = UserExpense::select('party_id')->get()->toarray();
             $party=PartyName::select('id')->where('region_id','!=',2)->whereIn('id',$obj)->get()->toarray();
             $obj=UserExpense::whereIn('party_id',$party)->wherein('expense_id',[93,94])->with(['party_info'])
                ->get();
            }

         else{
             $party=$request->get('party_id');
                    $obj = UserExpense::query();
            if (!empty($request->get('start_date')) && !empty($request->get('end_date')) && $request->get('party_id')!=0 ) {
                $obj = $obj->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])->where('party_id',$party);
            }
            if (!empty($request->get('status')) && $request->get('status')=='Pending' && $request->get('party_id')!=0 ) {
                $obj = $obj->where('status', 'Pending')->where('party_id',$party);
            }
            if (!empty($request->get('status')) && $request->get('status')=='Cancelled' && $request->get('party_id')!=0 ) {
                $obj = $obj->where('status', 'Cancelled')->where('party_id',$party);
            }
            if (!empty($request->get('status')) && $request->get('status')=='Approved' && $request->get('party_id')!=0 ) {
                    $obj = $obj->where('status', 'Approved')->where('party_id',$party);
                }
                if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                        $obj = $obj->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
                    }
                    if (!empty($request->get('status')) && $request->get('status')=='Pending') {
                        $obj = $obj->where('status', 'Pending');
                    }
                    if (!empty($request->get('status')) && $request->get('status')=='Cancelled') {
                        $obj = $obj->where('status', 'Cancelled');
                    }
                    if (!empty($request->get('status')) && $request->get('status')=='Approved') {
                        $obj = $obj->where('status', 'Approved');
                    }
            $obj = $obj->wherein('expense_id',[93,94])->with(['party_info'])
                ->get();
         }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Debit Note',
            'data' => $obj], 200);
    }
    
     public function salereturn(Request $request)
    {
        try {

             $party=$request->get('party_id');
                    $obj = StockBooking::query();
            if (!empty($request->get('start_date')) && !empty($request->get('end_date')) && $request->get('party_id')!=0 ) {
                $obj = $obj->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])->where('party_id',$party);
            }
            if (!empty($request->get('status')) && $request->get('status')=='Pending' && $request->get('party_id')!=0 ) {
                $obj = $obj->where('status', '')->where('party_id',$party);
            }

            if (!empty($request->get('status')) && $request->get('status')=='Completed' && $request->get('party_id')!=0 ) {
                    $obj = $obj->where('status', 'Completed');
                }

                if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                        $obj = $obj->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
                    }
                    if (!empty($request->get('status')) && $request->get('status')=='Pending') {
                        $obj = $obj->where('status', '');
                    }
                    if (!empty($request->get('status')) && $request->get('status')=='Completed') {
                        $obj = $obj->where('status', 'Completed');
                    }

            $obj = $obj->where('type', 'Sale Return')->with(['party_info'])
                ->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Sale Returns',
            'data' => $obj], 200);
    }
    
   public function editcreditnote(Request $request)
    {
        try {
          $newbalance=0;
          
           $obj = UserExpense::where('id',$request->get('id'))->update(['date'=> $request->get('date')]);
         
            $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('party_id',$request->get('party_id'))->where('type','Credit Note')->update(['date'=> $request->get('date')]);
            
    $obj=PartyName::where('id',$request->get('party_id'))->with(['party_ledger'=>function($query){$query->orderBy('date', 'ASC');}])->first();
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
                if(!empty($update)){
                    switch ($update['type']){
                        case 'Sale':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Recovery':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Credit Note':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                }
                $update->save();
            }
            $obj->balance=$opening;
            $obj->save();
        }

       
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,'data'=>$rooms, 'message' => 'Date Changed Credit Note',
        ], 200);
    }
    
    
    public function editPayment(Request $request)
    {
        try {
           
            $newbalance=0;
$party_id=$obj = RsmPayment::where('id',$request->get('id'))->first();
         
            if($request->get('type')=="Date")
            {
                 $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $request->get('id');
                $paymentRemark->type = "payment_date";
                $paymentRemark->remarks = $request->get('remarks');
                $paymentRemark->save();
                
                $obj = RsmPayment::where('id',$request->get('id'))->update(['date'=> $request->get('date')]);
                $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('type','Recovery')->update(['date'=> $request->get('date')]);

            }
            
              if($request->get('type')==="amount")
           {
                
                $obj = RsmPayment::where('id',$request->get('id'))->update(['amount'=> $request->get('amount')]);
                $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('type','Recovery')->update(['amount'=> $request->get('amount')]);
                 $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('type','Cash_Received')->update(['amount'=> $request->get('amount')]);

            }
            
               if($request->get('type')==="delete")
           {
                
                $obj = RsmPayment::where('id',$request->get('id'))->delete();
                $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('type','Recovery')->where('party_id',$party_id->party_id)->delete();

            }

         $obj=PartyName::where('id',$party_id->party_id)->with(['party_ledger'=>function($query)
        {$query->orderBy('date', 'ASC');}])->first();
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
                if(!empty($update)){
                    switch ($update['type']){
                        case 'Sale':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Recovery':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Credit Note':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                }
                $update->save();
            }
            $obj->balance=$opening;
            $obj->save();
        }


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,'data'=>$obj->balance, 'message' => 'Amount Changed Credit Note',
        ], 200);
    }
    
     public function Fixvendorbalance(Request $request)
    {
        try {$xx="";
        $obj='';
    if($request->get('id')==45)

        {
                $obj = User::where('id', $request->get('id'))->with(['ledger_vendor' => function ($query) {
                    $query->whereDate('date','>=','2019-06-30')->orderBy('date', 'asc');
                }])->first();
                if (!empty($obj) && !empty($obj->ledger_vendor)) {
                 $xx=   $opening = $obj->opening_balance;
                    foreach ($obj->ledger_vendor as $key => $item) {
                        $update = UserExpenseDetail::where('id', $item['id'])->first();
                        if (!empty($update)) {
                            switch ($update['type']) {
                                case 'Sale':
                                    $opening = $opening + $update['vendor_price'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break;
                                case 'Recovery':
                                    $opening = $opening - $update['amount'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break;
                                
                            }
                        }
                        $update->save();
                    }
                    $obj->balance = $opening;
                    $obj->save();
              }
}
         else  if($request->get('id')==43){
             $opening=0;
           
                $obj = User::where('id', $request->get('id'))->with(['ledger_vendor' => function ($query) {
                     $query->whereDate('date','>=','2019-07-5')->orderBy('date', 'ASC');
                }])->first();
              if (!empty($obj) && !empty($obj->ledger_vendor)) {
                 $xx=   $opening = $obj->opening_balance;
                    foreach ($obj->ledger_vendor as  $item) {
                        $update = UserExpenseDetail::where('id', $item->id)->first();
                        if (!empty($update)) {
                            switch ($update['type']) {
                                case 'Sale':
                                    $opening = $opening + $update['vendor_price'];
                                    
                                   UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
 
                                    break;
                                case 'Recovery':
                                    $opening = $opening - $update['amount'];
                                  UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                                    break;
                            }
                        }
                       // $update->save();
                    }
                    $obj->balance = $opening;
                    $obj->save();
              }
}
else
{
    
}
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,'data'=>$obj, 'message' => 'Ledger Synced',
        ], 200);
    }

 public function Fixpartybalance(Request $request)
    {
        
         try {
        $obj=PartyName::where('id',$request->get('id'))->with(['party_ledger'=>function($query)
        
        {$query->orderBy('date', 'ASC');}])->first();
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
                if(!empty($update)){
                    switch ($update['type']){
                        case 'Sale':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Recovery':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Credit Note':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                }
                $update->save();
            }
            $obj->balance=$opening;
            $obj->save();
        }
        
         }
       catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Refreshed','data'=>$obj,
        ], 200);
    }
    
    public function Fixpartybalance1(Request $request)
    {
        
         try {
             
             
        $party=PartyName::all();
        foreach($party as $party)
        $obj=PartyName::where('id',$request->get('id'))->with(['party_ledger'=>function($query)
        {$query->orderBy('date', 'ASC');}])->first();
        if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
            foreach ($obj->party_ledger as $key=>$item){
                $update=UserExpenseDetail::where('id',$item['id'])->first();
                if(!empty($update)){
                    switch ($update['type']){
                        case 'Sale':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Recovery':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                        case 'Credit Note':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                }
                $update->save();
            }
            $obj->balance=$opening;
            $obj->save();
        }
        
         }
       catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Refreshed','data'=>$obj,
        ], 200);
    }
    
     public function adminexpenseDetail()
    {
        $obj="";
        try {
             $obj = UserExpenseDetail::whereIn('user_id',[91,165])->where('date','>=','2019-06-01')->where('type','Expense')->
            whereHas(
                'user_expense', function ($q) {
                $q->where('accountant_amount', '=', 0)->whereDate('date','>','2019-06-05');
            }
            )->with('user_expense.expense')->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
    
    
      public function RSMpaymentbiotech()
    {
        $obj="";
        try {

            $obj = RsmPayment::whereDate('date','>','2019-06-30')->where('payment_to',45)->where('vendor_approval',0)->with(['account_info','payment_images','party_info'])->get();

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
    public function RSMPaymentsCEO(Request $request)
    {
        try{
            if($request->status == "Pending"){
                 $Payments = RsmPayment::where('received_by', 9)->where('ceo_approval',$request->status)->with('party_info')->get();
                  return API::response()->array(['success' => true,
                'message' => 'RSM Payment ',
                'data' => $Payments], 200);
            }
            else{
            $Payments = RsmPayment::where('received_by', 9)->with('party_info')->get();
             return API::response()->array(['success' => true,
                'message' => 'RSM Payment ',
                'data' => $Payments], 200);
        }
    }
    
        catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }

     }
     public function RSMCEOPayment(Request $request){
        try{
            
            RsmPayment::where('id', $request->id)->update(['ceo_approval'=> $request->status]);
             return API::response()->array(['success' => true,
                'message' => 'Status Updated',], 200);
        }
        catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }


     }
    
     public function PObiotech()
    {
        $obj="";
        try {


            $obj = PoNumber::whereDate('date','>','2019-06-30')->where('user_id',45)->where('vendor_approval',0)->where('po_number_raw',0)->where('po_number_adv',0)->with(['stock_orders'])->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
     public function accountant_creditnote()
    {
        $obj="";
        try {
            $obj = UserExpenseDetail::where('date','>=','2019-08-01')->where('type','Credit Note')
            ->
            whereHas(
                'user_expense', function ($q) {
                   
                $q->where('status',"Approved")->where('accountant_check_credit',null)->whereDate('date','>=','2019-08-01');
            })
            ->with(['party_info'])->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
     public function accountant_debitnote()
    {
        $obj="";
        try {
            $obj = UserExpenseDetail::where('date','>=','2019-08-01')->where('type','Debit Note')
            ->
            whereHas(
                'user_expense', function ($q) {

                $q->where('status',"Approved")->where('accountant_check_credit',null)->whereDate('date','>=','2019-08-01');
            })
            ->with(['party_info'])->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
     public function accountant_SaleReturn()
    {
        $obj="";
        try {
            $obj = StockBooking::where('type','Sale Return')
            ->where('status','Completed')->where('accountant_check_return',NULL)
            ->with(['party_info'])->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
   public function adminexpenseissueupdate(Request $request)
    {
        $id=$request->detail_id;
        $user_expense_detail_id = $request->id;
        try {
            
            
             $pre_balance= UserExpenseDetail::where('detail_id','<',$id)->where('type',"Expense")->where('user_id',91)->orderBy('id','desc')->first();
             
             $per = $request->previous_balance;
             $amt = $request->amount;
           $balance_now=  $per - $amt;
          // return $balance_now . "  " . $per . "   " . $amt;
            $obj1 = UserExpenseDetail::where('detail_id',$id)->where('type',"Expense")->
           update(['balance'=>$balance_now,'amount'=>$request->get('amount'),'status_check'=>0]);

       $user = UserExpense::where('id',$id)->first();
           
            $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $id;
                $paymentRemark->type = "expense_update";
                $remark = "previous amount is :" . $user->amount."<br> updated amount is :" .  $request->amount."<br>".$request->remarks;
                $paymentRemark->remarks = $remark;
                $paymentRemark->save();
                
                
           $obj = UserExpense::where('id',$id)->update(['accountant_amount'=> 0,'amount'=>$request->get('amount')]);
           
        
                
    
              $obj2 = User::where('id', $user->user_id)->with(['ledger' => function ($query) use($user,$user_expense_detail_id) {
                 $query->where('party_id','=',null)->where('id','>=',$user_expense_detail_id)->orderBy('id', 'ASC');
                }])->first();
               
                if (!empty($obj2) && !empty($obj2->ledger)) {
                $opening = $balance_now;
                $flag = 0;
                    foreach ($obj2->ledger as $key => $item) {
                        $update = UserExpenseDetail::where('id', $item['id'])->first();
                        if (!empty($update)) {
                             
                            switch ($update['type']) {
                                case 'Expense':
                                     if($flag == 0){
                                    $update->balance = $opening;
                                    $update->save();
                                    $flag = 1;
                                    break;
                                }else{
                                     $opening = $opening - $update['amount'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break;

                                }
                                case 'Recovery':
                                    $opening = $opening + $update['amount'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break;
                                 case 'Cash_Received':
                                    $opening = $opening + $update['amount'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break; 
                                    case 'Cash_Transfer':
                                    $opening = $opening - $update['amount'];
                                    $update->balance = $opening;
                                    $update->save();
                                    break;
     
                            }
                        }
                        $update->save();
                    }
                    $obj2->balance = $opening;
                    $obj2->save();
              }
            
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Amount Updated ','data'=>$balance_now,
        ], 200);
    }
    
    
    public function approvedCreditnote(Request $request)
    {
        try {
            $obj = UserExpense::where('id',$request->id)->first();
            if(!empty($obj)){
                $obj->status='Approved';
                $obj->save();
                $pname=PartyName::where('id',$obj->party_id)->first();
                if(!empty($pname)){
                    $pname->balance=($pname->balance)-($obj['amount']);

                    $pname->save();



                    $e= new UserExpenseDetail();
                    $e->user_id=$obj->user_id;
                    $e->detail_id=$obj->id;
                    $e->party_id=$obj->party_id;
                    $e->amount=$obj->amount;
                    $e->balance=$pname->balance;
                    $e->type='Credit Note';
                   $e->date=date("Y-m-d");
                    $e->save();

                     if($request->minus == 1){
                    $user = User::where('id',$pname->user_id)->first();

                    if($user){

                        $user->balance =($user->balance)-($obj['amount']);  
                        $user->save();

                    $e1 = new UserExpenseDetail();
                    $e1->user_id=$obj->user_id;
                    $e1->detail_id=$obj->id;
                    $e1->vendor_id=$user->id;
                    $e1->amount=$obj->amount;
                    $e1->balance=$user->balance;
                    $e1->type='Credit Note';
                    $e1->date=date("Y-m-d");
                    $e1->save();

                    }
                    }

                }





              //  if(!empty($obj->party_id)){
                //    LedgerAdjust($obj->party_id);
               // }
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Approved Credit Note',
            ], 200);
    }
    
    ////remove credit note after approved   //////

    

    public function removedsoulCreditnote(Request $request)
    {
        try {

        
               
               $creditnote = UserExpenseDetail::where('id',$request->id)->first();

               if($creditnote){

                    $creditnote->delete();
                }

            
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Removed Credit Note soul distributer For User expense detail ',
            ], 200);
    }
    public function approvedSaleReturn(Request $request)
    {
        try {
            $obj = StockBooking::where('id',$request->get('id'))->first();
            if(!empty($obj)){
                $obj->status='Completed';
                $obj->save();

                }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Approved Sale Return',
            ], 200);
    }
    
     public function approvedDebitnote(Request $request)
    {
        try {
            $obj = UserExpense::where('id',$request->get('id'))->first();
            if(!empty($obj)){
                $obj->status='Approved';
                $obj->save();
                $pname=PartyName::where('id',$obj->party_id)->first();
                if(!empty($pname)){
                    $pname->balance=($pname->balance)+($obj->amount);
                    $pname->save();
                    $e= new UserExpenseDetail();
                    $e->user_id=$obj->user_id;
                    $e->detail_id=$obj->id;
                    $e->party_id=$obj->party_id;
                    $e->amount=$obj->amount;
                    $e->balance=$pname->balance;
                    $e->type='Debit Note';
                    $e->date=$obj->date;
                    $e->save();
                }

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Approved Credit Note',
        ], 200);
    }
    
    public function cancelledCreditnote(Request $request)
    {
        try {
            $obj = UserExpense::where('id',$request->get('id'))->update(['status' => 'Cancelled','remarks_1' => $request->get('remarks_1')]);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Cancelled Credit Note',
        ], 200);
    }
    public function expenseDetail(Request $request)
    {
      try {

             $userId = $this->getUserIdFromToken($request);
               $role = $this->getUserRole($userId);
             


            $types = $this->_userPointsModel->expenseDetail($request,$role);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Types',
            'data' => $types], 200);
    }
    /***
     * Add or update Feedback
     *
     * @param Request $request
     */
    public function addOrUpdateFeedback(Request $request)
    {
        try {
            $feedback = $request->all();
            $feedbackModel = new Feedback();
            $feedbackk = $feedbackModel->addOrUpdateFeedback($feedback);
            if (is_null($feedback)) {
                return API::response()->array(['success' => false,
                    'error' => 'Feedback Not Found'], 400);
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Feedback Updated/Created',
            'data' => $feedbackk], 200);
    }
    /***
     * Add or update Expense
     *
     * @param Request $request
     */
    public function addOrUpdateExpenseType(Request $request)
    {
        try {
            $expense = $request->all();
            $expenseModel = new Expense();
            $user = $this->getUserIdFromToken($request, true);
            $expense['agency_id'] = $user->agency_id;
            $expensee = $expenseModel->addOrUpdateExpense($expense);
            if (is_null($expensee)) {
                return API::response()->array(['success' => false,
                    'error' => 'Expense Not Found'], 400);
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Updated/Created',
            'data' => $expensee], 200);
    }
    
    ////// add sub expenses head //////

 public function addsubexpensehead(Request $request)
    {
        try {
            $expense = $request->all();
            
            $expenseModel = new SubExpense();
             $expenseModel->expense_id = $request->expense_id;
             $expenseModel->name = $request->name;
             $expenseModel->save();

            

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Sub Expense Created succfully'], 200);
    }

public function GetSubExpenseHeadbyExpenseid(Request $request)
    {
        try {
           
            $expense = Expense::where('id',$request->id)->with('sub_expenses')->first();
            
          

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'show sub expense',
            'data' => $expense], 200);
    }
    
    ////// edit sub expenses head //////

 public function editsubexpensehead(Request $request)
    {
        try {
            
        
             $subexpense        = SubExpense::where('id',$request->id)->first();

             if($subexpense){

             $subexpense->name = $request->name;
             $subexpense->save();

         }

            

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Sub Expense Edit succfully'], 200);
    }

    public function editexpense(Request $request)
    {
        try {
            

             $expense        = Expense::where('id',$request->id)->first();
             if($expense){
                
             $expense->name = $request->name;
             $expense->save();

         }

            

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Edit succfully'], 200);
    }


    /***
     * ASM Target
     *
     * @param Request $request
     */
    public function ASMTarget(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->orwhere('id',$request->get('asm_id'))
                ->get();
            $data=[];
            foreach ($asm as $key=>$as){
                $data[$key]['id']=$as['id'];
                $data[$key]['fullname']=$as['firstname'].' '.$as['lastname'];
                $data[$key]['image']=$as['image'];
                $target=TargetDetail::where('date',$request->get('date'))->where('user_id',$as['id'])->first();
                if(!empty($target)){
                    $data[$key]['sales_target']= $target['sales_target'];
                    $data[$key]['recovery_target']= $target['recovery_target'];
                }else{
                    $data[$key]['sales_target']= 0;
                    $data[$key]['recovery_target']= 0;
                }
                $data[$key]['sales']=Order::where('booked_by',$as['id'])
//                    ->whereBetween('date_to_deliver',[$request->get('start_date'),$request->get('end_date')])
                    ->Where('date_to_deliver', 'like', '%' . $request->get('date') . '%')
                    ->where('status','=','Delivered')->where('type','!=','Sample')
                    ->sum('payment');

                $customer=Customer::select('id')->where('sale_officer_id',$as['id'])->get();
                $user_ids=[];
                $cus_ids=[];
                $user_ids[]=$as['id'];

                foreach ($customer as $cu){
                    $user_ids[]=$cu['id'];
                    $cus_ids[]=$cu['id'];
                }
//                // So supplier addition
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$as['id'])->get();
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }
                $data[$key]['recovery']=PaymentReceived:: wherein('user_id', $user_ids)
                    ->where('payment_type','=','Cash')
                    ->Where('promise_cheque_date', 'like', '%' . $request->get('date') . '%')
                    ->where('shop_id','!=',0)
                    ->wherein('shop_id',$cus_ids)
                    ->sum('amount');
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Targets',
            'data' => $data], 200);
    }
    public function AllRsm(Request $request)
    {
        try {
            $asm=User::where('id','!=',46)->whereHas('roles', function($query) {
                $query->where('name', '=', 'rsm');
            })->get();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All RSM',
            'data' => $asm], 200);
    }
    public function AllParty(Request $request)
    {
        try {
            $asm=PartyName::all();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Party',
            'data' => $asm], 200);
    }
    public function AllPartysaleRecovery(Request $request)
    {
        try {
           $start=$request->get('start_date');
           $end=$request->get('end_date');
            $obj= UserExpenseDetail::select(DB::raw('party_id,sum(amount) as amount,date,type'))
                ->wherein('type',['Sale','Recovery'])->where('is_raw',0)
                ->where('party_id','<>',null)->wherebetween('date',[$start,$end])
                ->groupBy('date','type')
                ->orderBy('date', 'ASC')
                ->get();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Party Sale & Recovery',
            'data' => $obj], 200);
    }
     public function AllPartysale(Request $request)
    {
        try {
           $start=$request->get('start_date');
           $end=$request->get('end_date');
            $obj= UserExpenseDetail::select(DB::raw('party_id,amount,date,detail_id,type'))
                ->wherein('type',['Sale'])->where('is_raw',0)
                ->where('party_id','<>',null)->wherebetween('date',[$start,$end])
                ->with(['party_info'])
                ->get();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Party Sale',
            'data' => $obj], 200);
    }
    public function AllPartyRecovery(Request $request)
    {
        try {
           $start=$request->get('start_date');
           $end=$request->get('end_date');
            $obj= UserExpenseDetail::select(DB::raw('party_id,amount,detail_id,date,type'))
                ->wherein('type',['Recovery'])
                ->where('party_id','<>',null)->wherebetween('date',[$start,$end])
                ->with(['party_info'])
                ->get();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Party Sale',
            'data' => $obj], 200);
    }
    public function allVenodor(Request $request)
    {
        try {
             $asm=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'main_su');
        })->with('vendor_details')->get();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All RSM',
            'data' => $asm], 200);
    }
    public function getAccount(Request $request)
    {
        try {
            $asm=Account::query();
            if (!empty($request->get('status'))) {
                switch ($request->get('status')){
                    case 'Active':
                        $asm = $asm->where('status','Active');
                        break;
                    case 'Inactive':
                        $asm = $asm->where('status','Inactive');
                        break;
                    default:
                        break;
                }
            }
            $asm= $asm->where('user_id', $request->get('user_id'))->with(['bank_info'])->get();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Vendor Account',
            'data' => $asm], 200);
    }
    public function modifyAccount(Request $request)
    {
        try {
            $obj= Account::where('id',$request->get('id'))->update(['status'=>$request->get('status')]);
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => ' Account Modify',
            ], 200);
    }
    public function addAccount(Request $request)
    {
        try {
            $obj=new Account();
            $obj->bank_id=$request->get('bank_id');
            $obj->user_id=$request->get('user_id');
            $obj->added_by=$request->get('added_by');
            $obj->account_title=$request->get('account_title');
            $obj->account_title=$request->get('account_title');
            $obj->account_no=$request->get('account_no');
            $obj->save();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'New Account Added',
            'data' => $obj], 200);
    }
    /***
     * ASM User
     *
     * @param Request $request
     */
    public function ASMUser(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->get();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Users',
            'data' => $asm], 200);
    }
    public function RSMPayment(Request $request){
        try {
            $obj= RsmPayment::where('payment_by',$request->get('user_id'))
                ->whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                ->with(['payment_by_info','payment_to_info','account_info','party_info','payment_images'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'RSM Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
     public function TagRSMPayment(Request $request)
    {
        try {$customerImage="";


            if(!empty($request['payment_tags'])) {
                $tags = [];
                foreach($request['payment_tags'] as $tag) {
                    $customerImage = new ExpenseTag();
                    $customerImage->payment_id=$request->get('id');
                    $customerImage->expense_id="";
                    $customerImage->tag_id=$tag;
                    $tags[] = $customerImage;
                }
                if(count($tags) > 0) {
                    $customerImage->save();
                }
            }


        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Tags Payment Added',
            'data' => $customerImage], 200);
    }
    
    
    public function RSMPaymentPartial(Request $request){
        try {
            $obj= RsmPayment::where('party_id',$request->get('party_id'))
                ->where('status', '<>', 'Completed')
                ->with(['payment_by_info','payment_to_info','account_info','party_info','payment_images'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'RSM Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function RSMPaymentAll(Request $request){
        try {
            $obj= RsmPayment::query();
            if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                $obj = $obj->where('sub_id', 0)->whereBetween('date', [$request->get('start_date'), $request->get('end_date')]);
            }
            if (!empty($request->get('user_id')) && ($request->get('user_id')!=9 ) && ($request->get('user_id')!=91 )&& ($request->get('user_id')!=101 )) {
                $obj = $obj->where('payment_to', $request->get('user_id'))->where('sub_id', 0);
            }
            if (!empty($request->get('rsm_id')) && ($request->get('rsm_id')!=0)) {
                $obj = $obj->where('payment_by', $request->get('rsm_id'))->where('sub_id', 0);
            }
            if (!empty($request->get('party_id'))) {
                switch ($request->get('party_id')){
                    case 5000:
                        $party=PartyName::select('id')->where('region_id','!=',2)->where('id','!=',20)->get()->toArray();
                        $obj = $obj->wherein('party_id',$party)->where('sub_id', 0);
                        break;
                    case 5001:
                        //export 5001 filter

                        $party=PartyName::select('id')->where('region_id','=',2)->get()->toArray();
                        $obj = $obj->wherein('party_id',$party)->where('sub_id', 0);
                        break;
                    case 0:
                        break;
                    default:
                        //party filter
                        $obj = $obj->where('party_id',$request->get('party_id'))->where('sub_id', 0);
                        break;
                }
            }
            $obj = $obj ->with(['payment_by_info','payment_to_info','account_info','party_info','payment_images'])
                ->get();
//            $obj= RsmPayment::whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
//                ->with(['payment_by_info','payment_to_info','account_info','party_info','payment_images'])
//                ->get();
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
  public function RSMPaymentPartywise(Request $request){
        try {
            $obj= RsmPayment::whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                ->where('party_id',$request->get('party_id'))->where('sub_id', 0)
                ->with(['payment_to_info','account_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function vendorPaymentPartywise(Request $request){
        try {
            $obj= RsmPayment::whereBetween('date', [$request->get('start_date'), $request->get('end_date')])
                ->where('payment_to',$request->get('vendor_id'))
                ->with(['payment_to_info','account_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'All Vendor Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function RSMSalesPartywise(Request $request){
        try {
            $obj= UserExpenseDetail::select(DB::raw('party_id,amount,date,type,detail_id'))
                ->where('type','Sale')
                ->where('party_id',$request->get('party_id'))
                ->wherebetween('date',[$request->get('start_date'),$request->get('end_date')])
                ->with(['party_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'All Party Sales ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function VendorSalesPartywise(Request $request){
        try {
            $obj= UserExpenseDetail::select(DB::raw('vendor_id,vendor_price,date,type,detail_id,is_raw'))
                ->where('type','Sale')
                ->where('vendor_id',$request->get('vendor_id'))
                ->wherebetween('date',[$request->get('start_date'),$request->get('end_date')])
                ->with(['party_info'])
                ->get();
            return API::response()->array(['success' => true,
                'message' => 'All Vendor Sales ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function RSMPaymentTotal(Request $request){
        try {
            
             if($request->party_id==5000)
            {
                
                   $party=PartyName::select('id')->where('region_id','!=',2)->where('id','!=',20)->get()->toArray();
                       
                
                $obj=DB::table('rsm_payments')
                ->select('rsm_payments.party_id as party_id',DB::raw('sum(amount) as amount'),'party_names.name as name','party_names.region_id as region_id' )
                ->where('rsm_payments.sub_id',0)
                ->whereBetween('rsm_payments.date', [$request->start_date, $request->end_date])->wherein('rsm_payments.party_id',$party)
                ->join('party_names', 'rsm_payments.party_id', '=', 'party_names.id')
                ->groupBy('party_id')
                ->get();
            }
            
           else  if($request->party_id==5001)
            {
                 $party=PartyName::select('id')->where('region_id','=',2)->get()->toArray();
                      
                
                 $obj=DB::table('rsm_payments')
                ->select('rsm_payments.party_id as party_id',DB::raw('sum(amount) as amount'),'party_names.name as name','party_names.region_id as region_id' )
                 ->where('rsm_payments.sub_id',0)
                ->whereBetween('rsm_payments.date', [$request->start_date, $request->end_date])->wherein('rsm_payments.party_id',$party)
                ->join('party_names', 'rsm_payments.party_id', '=', 'party_names.id')
                ->groupBy('party_id')
                ->get();
            }
            
            
            
              else  if($request->party_id!=0)
            {
 
                 $obj=DB::table('rsm_payments')
                ->select('rsm_payments.party_id as party_id',DB::raw('sum(amount) as amount'),'party_names.name as name','party_names.region_id as region_id' )
                 ->where('rsm_payments.sub_id',0)
                ->whereBetween('rsm_payments.date', [$request->start_date, $request->end_date])->where('rsm_payments.party_id',$request->party_id)
                ->join('party_names', 'rsm_payments.party_id', '=', 'party_names.id')
                ->groupBy('party_id')
                ->get();
            }
                
                
              else{



                  $user = $this->getUserIdFromToken($request, true);

            $check = $this->getUserRole($user->id);
          
            $start=$request->start_date;
            $end=$request->end_date;
            $obj=[];
            if($check == 'gm'){


        
               $obj=DB::table('rsm_payments')
                ->select('rsm_payments.party_id as party_id',DB::raw('sum(amount) as amount'),'party_names.name as name','party_names.region_id as region_id' )
                ->where('rsm_payments.sub_id',0)
                ->whereBetween('rsm_payments.date', [$request->start_date, $request->end_date])
                ->join('party_names',function($join)
{ 
        $join->on(  'rsm_payments.party_id', '=', 'party_names.id');
            })
                ->where('party_names.show_gm', '!=', 0)
                ->groupBy('party_id')
                ->get();
         

            }else{
              $obj=DB::table('rsm_payments')
                ->select('rsm_payments.party_id as party_id',DB::raw('sum(amount) as amount'),'party_names.name as name','party_names.region_id as region_id' )
                ->where('rsm_payments.sub_id',0)
                ->whereBetween('rsm_payments.date', [$request->start_date, $request->end_date])
                ->join('party_names', 'rsm_payments.party_id', '=', 'party_names.id')
                ->groupBy('party_id')
                ->get();
               } 
            }
                 
                
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function RSMSalesTotal(Request $request){
        try {
            $user = $this->getUserIdFromToken($request, true);

            $check = $this->getUserRole($user->id);
           
            $start=$request->start_date;
            $end=$request->end_date;
            $obj=[];
            if($check == 'gm'){

                $party=PartyName::where('show_gm', '!=' , 0)->get();
                

            }else{
            $party=PartyName::get();
            }
            if(!empty($party)){
                foreach ($party as $key=>$p){
                   $detail= UserExpenseDetail::select('type',DB::raw('sum(amount) as amount'))
                        ->wherebetween('date',[$start,$end])
                        ->where('party_id',$p->id)
                        ->wherein('type',['Sale','Recovery'])
                        ->groupBy('type')
                        ->get();
                        
                        $last=array();
                        $last=UserExpenseDetail::select('balance')->where('party_id',$p->id)->orderby('date','desc')->orderby('id','desc')->orderby('created_at','desc')->latest()->first();
                        
                   
                    
                    if($p->balance!=$last)
                    {

                        LedgerAdjust($p->id);
                         $obj[$key]['refresh']="YES";
                          $detail1= UserExpenseDetail::select('type',DB::raw('sum(amount) as amount'))
                        ->wherebetween('date',[$start,$end])
                        ->where('party_id',$p->id)
                        ->wherein('type',['Sale','Recovery'])
                        ->groupBy('type')
                        ->get();
                        $party = PartyName::where('id',$p->id)->first();
                        $obj[$key]=$party;
                         $obj[$key]['party_ledger']=$detail1;
                    }
                   
                    else{
                         $obj[$key]=$p;
                        $obj[$key]['party_ledger']=$detail;
                    }
                    
                    $obj[$key]['last_balance']=$last;
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function VendorSalesTotal(Request $request){
        try {
            
            $start=$request->start_date;
            $end=$request->end_date;
            $userId=$request->user_id;
            $salefatima = 0;
            
            $obj=[];
            $userrole = $this->getUserRole($userId);
            $party = null;
            if($userrole == "super_admin" || $userrole == "Accountant"){
            $party= $asm=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'main_su');
            })->get();}
             if($userrole == "admin"){
            $party= $asm=User::whereNotIn('id',[43,45])->whereHas('roles', function($query) {
                $query->where('name', '=', 'main_su');
            })->get();}
            
            if(!empty($party)){
                foreach ($party as $key=>$p){
                   if($p->id == 45){
                          
                        $detail= UserExpenseDetail::select('type',DB::raw('sum(vendor_price) as amount'))
                       ->wherebetween('date',[$start,$end])
                       ->where('vendor_id',$p->id)
                      ->wherein('type',['Recovery'])
                       ->groupBy('type')
                       ->get();

                       $date_from2 = $start. " 00:00:00";
                        $date_to2 = $end. " 23:59:59";
                        $data      =  VendorInvoice::whereBetween('created_at', [$date_from2, $date_to2])->get();
                      
                      
                      foreach ($data as $key4 => $dat) {
                       
                        $salefatima = $salefatima + $dat->total_amount;
                          
                      }
                        
                     
                        $obj[$key]['ledger_vendor']=$salefatima;

                   }else{

                     $detail= UserExpenseDetail::select('type',DB::raw('sum(vendor_price) as amount'))
                       ->wherebetween('date',[$start,$end])
                       ->where('vendor_id',$p->id)
                      ->wherein('type',['Recovery','Sale'])
                       ->groupBy('type')
                       ->get();
                   }

                        $last=array();
                        $last=UserExpenseDetail::select('balance')->where('vendor_id',$p->id)->orderby('date','desc')->orderby('id','desc')->orderby('created_at','desc')->latest()->first();

                    $obj[$key]=$p;

                    if($p->balance!=$last->balance)
                    {
                        //LedgerAdjustvendor($p->id);
                         $obj[$key]['refresh']="YES";
                          $detail1= UserExpenseDetail::select('type',DB::raw('sum(vendor_price) as amount'))
                        ->wherebetween('date',[$start,$end])
                        ->where('vendor_id',$p->id)
                        ->wherein('type',['Sale'])
                        ->groupBy('type')
                        ->get();
                           $obj[$key]['ledger_vendor']=$detail1;
                            
                              $detail2= UserExpenseDetail::select('type',DB::raw('sum(amount) as amount'))
                        ->wherebetween('date',[$start,$end])
                        ->where('vendor_id',$p->id)
                        ->where('type','Recovery')
                        ->groupBy('type')
                        ->get();
 
                         $obj[$key]['ledger_recovery']=$detail2;
                        //return $obj[$key]['ledger_vendorr'];
                         
                    }

                    else{
                        $obj[$key]['ledger_vendor']=$detail;
                        if($p->id == 45){
                            $obj[$key]['ledger_sale']=$salefatima;

                        }
                    }

                    $obj[$key]['last_balance']=$last;
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'All Vendor Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
     public function ExportSalesTotal(Request $request){
        try {
            $start=$request->get('start_date');
            $end=$request->get('end_date');
            $obj=[];
          //  $party_id=showPartyToExport();
        // $party=PartyName::where('region_id',2)->wherein('id',$party_id)->get();
            $party=PartyName::where('region_id',2)->get();
            if(!empty($party)){
                foreach ($party as $key=>$p){
                   $detail= UserExpenseDetail::select('type',DB::raw('sum(amount) as amount'))
                        ->wherebetween('date',[$start,$end])
                        ->where('party_id',$p->id)
                        ->wherein('type',['Sale','Recovery'])
                        ->groupBy('type')
                        ->get();
                    $obj[$key]=$p;
                    $obj[$key]['party_ledger']=$detail;
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
    public function RSMSalesTotal2(Request $request){
        try {
            $start=$request->get('start_date');
            $end=$request->get('end_date');
            $obj=PartyName::with(['party_ledger'=>function($query) use($start,$end){
                $query->select(DB::raw('party_id,sum(amount) as amount,type'))
                    ->wherein('type',['Sale','Recovery'])
//                    ->where('party_id','<>',null)
                    ->wherebetween('date',[$start,$end])
                    ->groupBy('type')
                    ->get();
            }])->get();
            return API::response()->array(['success' => true,
                'message' => 'All Party Payment ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function RSMPaymentDetail(Request $request){
        try {

  $obj= RsmPayment::where('id',$request->get('id'))
                ->with(['payment_by_info','payment_remarks','received_by_info','completed_by_info','payment_to_info','account_info','account_from_info','party_info','payment_images'])
                ->first();
               
            return API::response()->array(['success' => true,
                'message' => 'RSM Payment ',
                'data' => $obj], 200);
        }  catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
  public function RSMAddPayment(Request $request)
    {
      //  return $request;
        try {
            $out="";
            $result="";
            $account1="";
            $data="";

            if($request->payment_to==45){

              
                $obj = new RsmPayment();

                $account1=$account=Account::where('id',$request->get('account_id'))->with('bank_info')->first();


                $obj->payment_by = $request->get('payment_by');
                $obj->vendor_approval =0;
                $obj->payment_to = $request->get('payment_to');
                $obj->account_from_id = $request->get('account_from_id');
                $obj->account_id = $request->get('account_id');
                $obj->rsm_refno = $request->get('rsm_refno');
                $obj->type = $request->get('type');
                $obj->amount = $request->get('amount');

                $obj->party_id = $request->get('zone');
                $obj->remarks = $request->get('remarks');
                $obj->date = $request->get('date');
                $obj->status = 'Pending';
                $obj->save();
                if (!empty($obj) && !empty($obj->party_id)) {
                    $pname = PartyName::where('id', $obj->party_id)->first();
                    if (!empty($pname)) {
                        $pname->balance = ($pname->balance) - ($obj->amount);
                        $pname->save();
                        $e = new UserExpenseDetail();
                        $e->user_id = $obj->payment_by;
                        $e->detail_id = $obj->id;
                        $e->party_id = $obj->party_id;
                        $e->amount = $obj->amount;
                        $e->balance = $pname->balance;
                        $e->type = 'Recovery';
                        $e->date = $request->get('date');
                        $e->save();
                    }
                    $soul_user = User::where('id',$pname->user_id)->first();

    if($soul_user){


        $soul_user->balance =($soul_user->balance)-($obj->amount); 
        $soul_user->save();

        $led2 = new UserExpenseDetail();
        $led2->user_id = $soul_user->id;
        $led2->vendor_id = $soul_user->id;
        $led2->detail_id = $obj->id;
        $led2->type = 'Recovery';
        $led2->amount = $request->amount;
        $led2->balance =  $soul_user->balance;
        $led2->date = $request->date;
        $led2->save();


    }
                }
                if($request->zone == 0)
                    {

                           $updated_balance = ($obj->payment_by_info->balance) - ($obj->amount);
                           
                            User::where('id',  $obj->payment_by )->update(['balance'=> $updated_balance]);
                              $e = new UserExpenseDetail();
                            $e->user_id = $obj->payment_by;
                       
                            $e->detail_id = $obj->id;
                            $e->amount = $obj->amount;
                           
                            $e->balance =  $updated_balance;
                            $e->type = 'Cash_Transfer';
                            $e->date = $request->date;
                               
                            $e->save();

                              $Role = User::find( $obj->payment_by )->roles->first()->name;

                              if( $Role == 'super_admin'){
                        /// if role is super admin then also subtract the balance from personal account//

                           $personal_user=User::whereHas('roles', function($query) {
                                    $query->where('name', '=', 'personal_account');
                              })->first();
                      
                           $updated_balance = ($personal_user->balance) - ($obj->amount);

                            User::where('id',  $personal_user->id )->update(['balance'=> $updated_balance]);
                              $e = new UserExpenseDetail();
                            $e->user_id = $personal_user->id;
                       
                            $e->detail_id = $obj->id;
                            $e->amount = $obj->amount;
                           
                            $e->balance =  $updated_balance;
                            $e->type = 'Cash_Transfer';
                            $e->date = $request->date;
                               
                             $e->save();

                                
                       
    
                    }
                }
            
                   
                    $user = User::where('id', $obj->payment_to)->first();
                    if (!empty($user)) {
                        $user->balance = $user->balance - $request->get('amount');
                        $user->save();
                        $led = new UserExpenseDetail();
                        $led->vendor_id = $request->get('payment_to');
                        $led->user_id = $obj->payment_to;
                        $led->detail_id = $obj->id;
                        $led->type = 'Recovery';
                        $led->amount = $request->get('amount');
                        $led->balance = $user->balance;
                        $led->date = $request->get('date');
                        $led->save();
                    }
               
                //Image upload
                if (!empty($request->get('images'))) {
                    $images = [];
                    foreach ($request->get('images') as $image) {
                        $image = upload_base64_image($image, 'uploads/rsm_payment/',
                            'image-');
                        $customerImage = new RsmPaymentImage();

                        $customerImage->image_url = 'http://' . $image;
                        $images[] = $customerImage;
                    }
                    if (count($images) > 0) {
                        $obj->payment_images()->saveMany($images);
                    }
                }
                if ($request->get('date') != date('Y-m-d')) {
                    LedgerAdjust($obj->party_id);

                }

                $data = array();
                $data['payment_id']=   $obj->id;
                $data['account']=$account;
                $data['party']=$pname;
                $data['type']= $obj->type;
                $data['amount']= $obj->amount;
                $data['date']=  $obj->date;
                $data['remarks']=  $obj->remarks;
                $data['slip']=   $obj->rsm_refno;
                $data['image']= $images;


            }

            else{
                
                $user_details   =   DB::transaction(function() use($request)
                {
                    
                    $obj = new RsmPayment();

                    $obj->vendor_approval =0;
                    $obj->payment_by = $request->payment_by;
                    $obj->payment_to = $request->payment_to;
                    $obj->account_from_id = $request->account_from_id;
                    $obj->account_id = $request->account_id;
                    $obj->rsm_refno = $request->rsm_refno;
                    $obj->type = $request->type;
                    $obj->amount = $request->amount;
                    if($request->type == "Cash" && $request->payment_to == 98 ){

                         $obj->received_by = $request->received_by;
                    }

                    
                    $obj->party_id = $request->zone;

                   
                    $obj->remarks = $request->remarks;
                    $obj->date = $request->date;
                    $obj->status = 'Pending';


                    $obj->save();
                      if($request->zone == 0)
                    {
                           $updated_balance = ($obj->payment_by_info->balance) - ($obj->amount);
                           
                            User::where('id',  $obj->payment_by )->update(['balance'=> $updated_balance]);
                              $e = new UserExpenseDetail();
                            $e->user_id = $obj->payment_by;
                       
                            $e->detail_id = $obj->id;
                            $e->amount = $obj->amount;
                           
                            $e->balance =  $updated_balance;
                            $e->type = 'Cash_Transfer';
                            $e->date = $request->date;
                               
                             $e->save();

                              $Role = User::find( $obj->payment_by )->roles->first()->name;

                              if( $Role == 'super_admin'){
                        /// if role is super admin then also subtract the balance from personal account//

                           $personal_user=User::whereHas('roles', function($query) {
                                    $query->where('name', '=', 'personal_account');
                              })->first();

                           $updated_balance = ($personal_user->balance) - ($obj->amount);

                            User::where('id',  $personal_user->id )->update(['balance'=> $updated_balance]);
                              $e = new UserExpenseDetail();
                            $e->user_id = $personal_user->id;
                       
                            $e->detail_id = $obj->id;
                            $e->amount = $obj->amount;
                           
                            $e->balance =  $updated_balance;
                            $e->type = 'Cash_Transfer';
                            $e->date = $request->date;
                               
                             $e->save();

                                
                       
    
                    }
                }
                
                 if($request->type == "Bank Transfer"){
                    //if bank transfer directyly send to this account ///

                    $account=Account::where('id',$request->account_id)->with('bank_info')->first();
                   $update_user = $account->update_user;

                   if($update_user){

                       $user = User::where('id',$update_user)->first();

                    if($user){
                        

                        $user->balance =($user->balance)+($obj->amount); 
                        $user->save();

                            $led2 = new UserExpenseDetail();
                            $led2->user_id = $user->id;
                            $led2->vendor_id = $user->id;
                            $led2->detail_id = $obj->id;
                            $led2->type = 'Cash_Received';
                            $led2->amount = $request->amount;
                            $led2->balance =  $user->balance;
                            $led2->date = $request->date;
                            $led2->save();


                    }



                   }
                 } 

                   

                    if (!empty($obj) && !empty($obj->party_id)) {
                        
                        $pname = PartyName::where('id', $obj->party_id)->first();
                        
                        if (!empty($pname)) {
                            $pname->balance = ($pname->balance) - ($obj->amount);

                            $pname->save();

                               

                            $e = new UserExpenseDetail();
                            $e->user_id = $obj->payment_by;
                       
                            $e->detail_id = $obj->id;
                            $e->amount = $obj->amount;
                            $e->party_id = $obj->party_id;
                            $e->balance =  $pname->balance;
                            $e->type = 'Recovery';
                            $e->date = $request->date;
                               
                             $e->save();
                              
                               
                              //   return $u;
                        }

                         $soul_user = User::where('id',$pname->user_id)->first();

                    if($soul_user){
                        

                        $soul_user->balance =($soul_user->balance)-($obj->amount); 
                        $soul_user->save();

                            $led2 = new UserExpenseDetail();
                            $led2->user_id = $soul_user->id;
                            $led2->vendor_id = $soul_user->id;
                            $led2->detail_id = $obj->id;
                            $led2->type = 'Recovery';
                            $led2->amount = $request->amount;
                            $led2->balance =  $soul_user->balance;
                            $led2->date = $request->date;
                            $led2->save();


                    }



                    }
                    
                        // Kashif diamong advertisement ledger
                       $user = User::where('id', $obj->payment_to)->first();
                        if (!empty($user)) {
                            
                            $user->balance = $user->balance + $request->amount;
                            $user->save();
                            $led = new UserExpenseDetail();
                            $led->user_id = $obj->payment_to;
                            $led->vendor_id = $request->payment_to;
                            $led->detail_id = $obj->id;
                            $led->type = 'Recovery';
                            $led->amount = $request->amount;
                            $led->balance = $user->balance;
                            $led->date = $request->date;
                            $led->save();
                        }

                         if($request->type == "Cash" && $request->payment_to == 98 && $obj->received_by == 91){
                            
                            $user = User::where('id', $obj->received_by)->first();
                        if (!empty($user)) {
                            $user->balance = $user->balance + $request->amount;
                            $user->save();
                            $led = new UserExpenseDetail();
                            $led->user_id = $obj->received_by;
                            $led->detail_id = $obj->id;
                            $led->type = 'Cash_Received';
                            $led->amount = $request->amount;
                            $led->balance = $user->balance;
                            $led->date = $request->date;
                            $led->save();
                        }


                         }
                         if($request->type == "Cash" && $request->payment_to == 98 && $obj->received_by == 165){

    $user = User::where('id', $obj->received_by)->first();
    if (!empty($user)) {
        $user->balance = $user->balance + $request->amount;
        $user->save();
        $led = new UserExpenseDetail();
        $led->user_id = $obj->received_by;
        $led->detail_id = $obj->id;
        $led->type = 'Cash_Received';
        $led->amount = $request->amount;
        $led->balance = $user->balance;
        $led->date = $request->date;
        $led->save();
    }


}


                         if($request->type == "Cash" && $request->payment_to == 98 && $obj->received_by == 9){
                            $user = User::where('id', $obj->received_by)->first();
                        if (!empty($user)) {
                            $user->balance = $user->balance + $request->amount;
                            $user->save();
                            $led = new UserExpenseDetail();
                            $led->user_id = $obj->received_by;
                            $led->detail_id = $obj->id;
                            $led->type = 'Cash_Received';
                            $led->amount = $request->amount;
                            $led->balance = $user->balance;
                            $led->date = $request->date;
                            $led->save();
                        }
                        $id = 149;
                          $user = User::where('id', $id)->first();
                        if (!empty($user)) {
                            $user->balance = $user->balance + $request->amount;
                            $user->save();
                            $led = new UserExpenseDetail();
                            $led->user_id = $id;
                            $led->detail_id = $obj->id;
                            $led->type = 'Cash_Received';
                            $led->amount = $request->amount;
                            $led->balance = $user->balance;
                            $led->date = $request->date;
                            $led->save();
                        }


                         }
                    
                 
                 

                    //Image upload
                    if (!empty($request->images)) {
                        $images = [];
                        foreach ($request->images as $image) {
                            $image = upload_base64_image($image, 'uploads/rsm_payment/',
                                'image-');
                            $customerImage = new RsmPaymentImage();

                            $customerImage->image_url = 'http://' . $image;
                            $images[] = $customerImage;
                        }
                        if (count($images) > 0) {
                            $obj->payment_images()->saveMany($images);
                        }
                    }
                    if ($request->date != date('Y-m-d')) {
                        LedgerAdjust($obj->party_id);

                    }
                    
                    $PaymentByInfo = User::where('id',$request->payment_by)->first();
                    $PaymentByPhone = $PaymentByInfo->phone_1;
                    $PaymentByName = $PaymentByInfo->firstname." ".$PaymentByInfo->lastname;
                    
                    $PaymentToUser=PartyName::where('id',$request->zone)->first();
                    
                    $from = $PaymentToUser->name;
                    $fromBalance = floor($PaymentToUser->balance);
                    $To = $user->firstname." ".$user->lastname;
                    $ToBalance = floor($user->balance);
                    $AmountDeposit = $request->amount;
                    $TranferType = $request->type;
                    $ToPhone = $user->phone_1;
                    $date = $request->date;
                    
                    //Get Party Accountant Number
                    $PartyAccontantId = $PaymentToUser->user_id;
                    $PartyAccountantInfo = User::where('id',$PartyAccontantId)->first();
                    $PartyAccountantNumber = $PaymentToUser->phone_1;
                   
                    
                    //RSM Message
                    if($PaymentByPhone != NULL){
                        $PaymentByobj=array();
                        $PaymentByobj['messageNumber']="923338162959";
                        $PaymentByobj['message_body']="Dear $PaymentByName,\n\nYou Have Added A New Payment In App Of Rs ".$AmountDeposit." For ".$from.".Remaining Balance Is (".$fromBalance.").\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $PaymentByobj['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $PaymentBych = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $PaymentBypost = json_encode($PaymentByobj); // Encode the data array into a JSON string
                
                        curl_setopt($PaymentBych, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($PaymentBych, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($PaymentBych, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($PaymentBych, CURLOPT_POSTFIELDS, $PaymentBypost); // Set the posted fields
                        curl_setopt($PaymentBych, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $PaymentBywhatsapp = curl_exec($PaymentBych); // Execute the cURL statement
                        curl_close($PaymentBych); // Close the cURL connection
                    }
                    //Party Accountant Message
                    if($PartyAccountantNumber != NULL){
                        $acc=array();
                        $acc['messageNumber']="923338162959";
                        $acc['message_body']="Dear $PaymentByName,\n\nYou Have Added A New Payment In App Of Rs ".$AmountDeposit." For ".$from.".Remaining Balance Is (".$fromBalance.").\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $acc['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $chAcc = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $postAcc = json_encode($acc); // Encode the data array into a JSON string
                
                        curl_setopt($chAcc, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($chAcc, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($chAcc, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($chAcc, CURLOPT_POSTFIELDS, $postAcc); // Set the posted fields
                        curl_setopt($chAcc, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $whatsappAcc = curl_exec($chAcc); // Execute the cURL statement
                        curl_close($chAcc); // Close the cURL connection
                    } 
                    //GM Message
                    if($PaymentToUser->show_gm == 1){
                        $RsmGm=array();
                        $RsmGm['messageNumber']="923338162959";
                        $RsmGm['message_body']="Dear $PaymentByName,\n\nYou Have Added A New Payment In App Of Rs ".$AmountDeposit." For ".$from.".Remaining Balance Is (".$fromBalance.").\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $RsmGm['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $chRsmGm = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $postRsmGm = json_encode($RsmGm); // Encode the data array into a JSON string
                
                        curl_setopt($chRsmGm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($chRsmGm, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($chRsmGm, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($chRsmGm, CURLOPT_POSTFIELDS, $postRsmGm); // Set the posted fields
                        curl_setopt($chRsmGm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $whatsappRsmGm = curl_exec($chRsmGm); // Execute the cURL statement
                        curl_close($chRsmGm); // Close the cURL connection
                    }elseif($PaymentToUser->region_id == 2){
                        $ExportGm=array();
                        $ExportGm['messageNumber']="923338162959";
                        $ExportGm['message_body']="Dear $PaymentByName,\n\nYou Have Added A New Payment In App Of Rs ".$AmountDeposit." For ".$from.".Remaining Balance Is (".$fromBalance.").\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $ExportGm['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $chExportGm = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $postExportGm = json_encode($RsmGm); // Encode the data array into a JSON string
                
                        curl_setopt($chExportGm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($chExportGm, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($chExportGm, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($chExportGm, CURLOPT_POSTFIELDS, $postExportGm); // Set the posted fields
                        curl_setopt($chExportGm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $whatsappExportGm = curl_exec($chExportGm); // Execute the cURL statement
                        curl_close($chExportGm); // Close the cURL connection
                    }
                    //Vendor Message
                    if($ToPhone != NULL){
                        $obj=array();
                        $obj['messageNumber']="923338162959";
                        $obj['message_body']="Dear $To,\n\nYou Have Received a New Payment Of Rs ".$AmountDeposit.".Please Approve This Payment From App.\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $obj['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $ch = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $post = json_encode($obj); // Encode the data array into a JSON string
                
                        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $whatsapp = curl_exec($ch); // Execute the cURL statement
                        curl_close($ch); // Close the cURL connection
                        }
                        
   
                    
                    //Usman Ellahi
                    if($user->id != 149 && $user->id != 165){
                        if($user->id == 98){
                            $To = "Shahid Islam";
                        }
                        $Bossobj=array();
                        $Bossobj['messageNumber']="923338162959";
                        $Bossobj['message_body']="Dear Sir,\n\nA New Payment Made By\n".$from." To ".$To." Of Rs ".$AmountDeposit.".\n".$from." Remaining Balance(".$fromBalance.").\n".$To." Remaining Balance(".$ToBalance.").\n\nDate: $date.\nThank You\nBiocos Int (PVT) LTD.";
                        $Bossobj['token']="EyJpdiI6Ilp6N3Z4UTRjaklTSlpMXC9OUHdkSXlBPT0iLCJ2YWx1ZSI6IlI0NXZDMnIwQUxITWNvNHU2ZGhFc3c9PSIsIm1hYyI6IjM5OWNjZDNhYWUyODQ4MDJmMGYzYWFlMTNjYjU4MWFhOWMyODcwYjEyYTll";
                
                        header('Content-Type: application/json'); // Specify the type of data
                
                        $Bossch = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
                        $Bosspost = json_encode($Bossobj); // Encode the data array into a JSON string
                
                        curl_setopt($Bossch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
                        curl_setopt($Bossch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($Bossch, CURLOPT_POST, 1); // Specify the request method as POST
                        curl_setopt($Bossch, CURLOPT_POSTFIELDS, $Bosspost); // Set the posted fields
                        curl_setopt($Bossch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                        $Bosswhatsapp = curl_exec($Bossch); // Execute the cURL statement
                        curl_close($ch); // Close the cURL connection
                    }
                    
                    
                });

           

            }
        
        
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        if($request->get('payment_to')==45){
            return API::response()->array(['success' => true, 'message' => 'RSM Payment Added',
                'data' => $result], 200);
        }
        else
        {
            return API::response()->array(['success' => true, 'message' => 'RSM Payment Added',
                'data' => $request->payment_to,'Whatsapp Status' => $whatsapp,'Boss Whatsapp' => $Bosswhatsapp], 200);
        }

    }
 public function RSMupdatePaymentparty(Request $request)
{
    try {

         $userId = $this->getUserIdFromToken($request);

        $obj= RsmPayment::where('id',$request->id)->first();

        if(!empty($obj)){

            $date2 = date('Y-m-d');
            $date1 =  date('Y-m-d', strtotime($obj->created_at));

            $ts1 = strtotime($date1);
            $ts2 = strtotime($date2);

            $year1 = date('Y', $ts1);
            $year2 = date('Y', $ts2);

            $month1 = date('m', $ts1);
            $month2 = date('m', $ts2);

            $diff = (($year2 - $year1) * 12) + ($month2 - $month1);



            if($diff == 0){

                $oldparty = $obj->party_id;
                
                $oldparty = Subdistributor::where('id',$oldparty)->first();

                $oldparties = $oldparty->name;
                  $newparty = $request->party_id;
                $newparty = Subdistributor::where('id',$newparty)->first();
                $newparties = $newparty->name;

                $obj->party_id = $request->party_id;
                $obj->sub_id = $request->party_id;

               $obj->save();

               $user_expense_detail=  UserExpenseDetail::where('detail_id',$request->id)->where('type','Sub_recovery')->where('vendor_id',null)->first();
               if($user_expense_detail){
               $user_expense_detail->party_id = $request->party_id;
               $user_expense_detail->save();
           }
                $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $obj->id;
                $paymentRemark->type = "party_update";
                 
                $remark ="Old party: ".$oldparties ."<br> Updated party: " .  $newparties."<br>";
                $paymentRemark->remarks = $remark;
                $paymentRemark->user_remarks = $request->remarks;
                $paymentRemark->user_id = $userId;


                $paymentRemark->save();




            }else{
               return API::response()->array(['success' => false, 'message' => 'Sorry time over to revert this.'], 200);

           }


       }
   } catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'RSM Payment party updated'], 200);
}

public function RSmPaymentResend(Request $request){
    try{
        
     

      $obj = RsmPayment::where('id',$request->id)->first();

      if($obj){ 

        if($obj->payment_to == 45 ){

        $obj->vendor_approval = 0;


        $obj->save();



        
        $account1=$account=Account::where('id',$obj->account_id)->with('bank_info')->first();
        $pname = PartyName::where('id', $obj->party_id)->first();

        $payment_images  = RsmPaymentImage::where('rsm_payment_id',$obj->id)->get();

        if (!empty($payment_images)) {
            $images = [];
            foreach ($payment_images as $image) {
                
                $images[] = $image->image_url;
            }
        }
        

        $data = array();
        $data['payment_id']=   $obj->id;
        $data['account']=$account;
        $data['party']=$pname;
        $data['type']= $obj->type;
        $data['amount']= $obj->amount;
        $data['date']=  $obj->date;
        $data['remarks']=  $obj->remarks;
        $data['slip']=   $obj->rsm_refno;
        $data['image']= $images;




        


                header('Content-Type: application/json'); // Specify the type of data
               $ch = curl_init('http://demo.biotecherp.work/public/api/biocos-payment-rec/store'); // Initialise cURL
               $post = json_encode($data);


                // Encode the data array into a JSON string

               curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
                curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
                $result = curl_exec($ch); // Execute the cURL statement

                curl_close($ch);
            }
            else{
                 return API::response()->array(['success' => false, 'message' => 'payment to is not fatima international'], 200);

            }
        }

        }
        catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }

        return API::response()->array(['success' => true, 'message' => 'RSM Payment Resend Successfully',
            'data' => $data], 200);

    }

    public function RSMModifyPayment(Request $request)
    {
        try {
            $obj= RsmPayment::where('id',$request->get('id'))->first();
            if(!empty($obj)){
                $obj->remarks=$request->get('remarks');
                $obj->save();
                //Image upload
                if(!empty($request->get('uploadimages'))) {
                    $images = [];
                    foreach($request->get('uploadimages') as $image) {
                        $image = upload_base64_image($image, 'uploads/rsm_payment/',
                            'image-');
                        $customerImage = new RsmPaymentImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                        $customerImage->image_url =  'http://'.$image;
                        $images[] = $customerImage;
                    }
                    if(count($images) > 0) {
                        $obj->payment_images()->saveMany($images);
                    }
                }
            }
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Payment Added',
            'data' => $obj], 200);
    }
    
    /***
     * ASM Target
     *
     * @param Request $request
     */
    public function RSMTarget(Request $request)
    {
        try {
            $data=[];
            $rsm_sales=0;
            $rsm_recovery=0;
            $rsm=User::select('id','firstname','lastname','image')
                ->where('rsm_id',$request->get('rsm_id'))
                ->whereHas('roles', function($query) {
                    $query->where('name', '=', 'asm');
                })
                ->with(['all_children'])
                ->get();
            foreach ($rsm as $key=>$rs){
                $data[$key]['id']=$rs['id'];
                $data[$key]['fullname']=$rs['firstname'].' '.$rs['lastname'];
                $data[$key]['image']=$rs['image'];
                $data[$key]['role_user']=$rs['role_user'];
                $target=TargetDetail::where('date',$request->get('date'))->where('user_id',$rs['id'])->first();
                if(!empty($target)){
                    $data[$key]['sales_target']= $target['sales_target'];
                    $data[$key]['recovery_target']= $target['recovery_target'];
                }else{
                    $data[$key]['sales_target']= 0;
                    $data[$key]['recovery_target']= 0;
                }
                $asm_sales=0;
                $asm_recovery=0;
                if(count($rs['all_children'])>0){
                    foreach ($rs['all_children'] as $key2=>$child){
                        $sales=Order::where('booked_by',$child['id'])
                            ->Where('date_to_deliver', 'like', '%' . $request->get('date') . '%')
                            ->where('status','=','Delivered')->where('type','!=','Sample')
                            ->sum('payment');
                        $asm_sales=$asm_sales+$sales;
                        $customer=Customer::select('id')->where('sale_officer_id',$child['id'])->get();
                        $user_ids=[];
                        $cus_ids=[];
                        $user_ids[]=$child['id'];

                        foreach ($customer as $cu){
                            $user_ids[]=$cu['id'];
                            $cus_ids[]=$cu['id'];
                        }
//                // So supplier addition
                        $supplier=SupplierSo::select('supplier_id')->where('so_id',$child['id'])->get();
                        foreach ($supplier as $su){
                            $user_ids[]=$su['supplier_id'];
                        }
                        $recovery=PaymentReceived:: wherein('user_id', $user_ids)
                            ->where('payment_type','=','Cash')
                            ->Where('promise_cheque_date', 'like', '%' . $request->get('date') . '%')
                            ->where('shop_id','!=',0)
                            ->wherein('shop_id',$cus_ids)
                            ->sum('amount');
                        $asm_recovery=$asm_recovery+$recovery;
                    }
                }
                $data[$key]['sales']=$asm_sales;
                $rsm_sales=$rsm_sales+$asm_sales;
                $rsm_recovery=$rsm_recovery+$asm_recovery;
                $data[$key]['recovery']=$asm_recovery;
            }
            $target=Target::select('id','rsm_id','date_start','date_end','sales_target','recovery_target')
                -> where('rsm_id',$request->get('rsm_id'))
                ->Where('date_start','<=', $request->get('date') )
                ->Where('date_end','>=', $request->get('date') )
                ->with(['user'=>function($query){return $query->select('id','firstname','lastname','image');}])->first();
            $object = new \stdClass();
            $object->id = $target->user->id;
            $object->fullname = $target->user['firstname'].$target->user['lastname'];
            $object->image = $target->user['image'];
            $object->role_user = $target->user['role_user'];
            $object->sales_target = $target['sales_target'];
            $object->recovery_target = $target['recovery_target'];
            $object->sales = $rsm_sales;
            $object->recovery = $rsm_recovery;
            $object->asm = $data;
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets',
            'data' => $object], 200);
    }
    /***
     * RSMAssignTarget
     *
     * @param Request $request
     */
    public function RSMAssignTarget(Request $request)
    {
        try {
           $target=Target::where('id',$request->get('id'))
               ->with('target_details')
               ->first();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Assign Targets',
            'data' => $target], 200);
    }
    /***
     * RSMAllTarget
     *
     * @param Request $request
     */
    public function RSMAllTarget(Request $request)
    {
        try {
           $target=Target::where('rsm_id',$request->get('rsm_id'))
               ->get();
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM All Targets',
            'data' => $target], 200);
    }
    
    /***
     * RSMAllTargetbypartyid
     *
     * @param Request $request
     */
    public function RSMAllTargetbypartyid(Request $request)
    {
        try {
        
           $target=RsmTarget::where('party_id',$request->party_id)->with('part_info')
           ->get();
       } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'RSM All Targets',
        'data' => $target], 200);
}

    /***
     * Asm Schedule
     *
     * @param Request $request
     */
    public function Visit(Request $request,$visitId=0)
    {
        try {
                if($visitId==0){
                    $visit=new Visit();
                }else{
                    $visit= Visit::where('id',$visitId)->first();
                }
                $visit->user_id=$request->get('user_id');
                $visit->date=$request->get('date');
                $visit->remarks=$request->get('remarks');
                $visit->save();
            if(count($request->get('users'))){
                VisitDetail::where('visit_id',$visit->id)->delete();
                foreach ($request->get('users') as $user){
                    $detail=new VisitDetail();
                    $detail->visit_id=$visit->id;
                    $detail->user_id=$user;
                    $detail->save();
                }
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Visit added',
            'data' => $visit], 200);
    }
    /***
     * VisitDetail
     *
     * @param Request $request
     */
    public function VisitDetail(Request $request)
    {
        try {
            $asm= Visit::where('user_id',$request->get('user_id'))
                ->whereBetween('date',[$request->get('start_date'),$request->get('end_date')])
                ->with(['visit_detail'=>function($query){return $query->with(['user'=>function($query){return $query->select('id','firstname','lastname');}]);}])->get();


        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Visit Detail ',
            'data' => $asm], 200);
    }
    /***
     * ASM_AchieveTarget
     *
     * @param Request $request
     */
    public function ASM_AchieveTarget(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->orwhere('id',$request->get('asm_id'))
                ->get();
            $data=[];
            $users=[];
            $c_user=[];
            $users[]=$request->get('asm_id');
            foreach ($asm as $key=>$as){
                $users[]=$as['id'];
                $c_user[$key]['id']=$as['id'];
                if($as['id']==$request->get('asm_id')){
                    $data['id']=$as['id'];
                    $data['fullname']=$as['firstname'].' '.$as['lastname'];
                    $data['image']=$as['image'];
                }
            }

            $target=TargetDetail::where('date',$request->get('date'))->where('user_id',$request->get('asm_id'))->first();
            if(!empty($target)){
                $data['sales_target']= $target['sales_target'];
                $data['recovery_target']=$target['recovery_target'];
            }else{
                $data['sales_target']=0;
                $data['recovery_target']= 0;
            }
            $data['sales']=Order::wherein('booked_by',$users)
                ->Where('date_to_deliver', 'like', '%' . $request->get('date') . '%')
                ->where('status','=','Delivered')->where('type','!=','Sample')
                ->sum('payment');
            $data['recovery']=0;

            foreach ($c_user as $key=>$as){
                $customer=Customer::select('id')->where('sale_officer_id',$as['id'])->get();
                $user_ids=[];
                $cus_ids=[];
                $user_ids[]=$as['id'];

                foreach ($customer as $cu){
                    $user_ids[]=$cu['id'];
                    $cus_ids[]=$cu['id'];
                }
//                // So supplier addition
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$as['id'])->get();
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }
                $recovery=PaymentReceived:: wherein('user_id', $user_ids)
                    ->where('payment_type','=','Cash')
                    ->Where('promise_cheque_date', 'like', '%' . $request->get('date') . '%')
                    ->where('shop_id','!=',0)
                    ->wherein('shop_id',$cus_ids)
                    ->sum('amount');
                $data['recovery']=$data['recovery']+$recovery;
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Targets',
            'data' => $data], 200);
    }
    /***
     * RSM Target
     *
     * @param Request $request
     */
    public function RSM_ASM_SAleRecovery(Request $request)
    {
        try {
            $rsm=User::select('id','firstname','lastname','image')
                ->where('rsm_id',$request->get('rsm_id'))
//                ->orwhere('id',$request->get('rsm_id'))
                ->get();
            $data=[];
            $r_asm=[];
            foreach ($rsm as $key=>$rs){
                if($rs['role_user']=="Area Sale Manager"){
                    $r_asm[]=$rs;
                }
            }
            foreach ($r_asm as $key=>$rs){
                $asm=User::select('id','firstname','lastname','image')
                    ->where('parent_id',$rs['id'])
                    ->orwhere('parent_id_2',$rs['id'])
                    ->orwhere('id',$rs['id'])
                    ->get();

                $users=[];
                $c_user=[];
//                $users[]=$rs['id'];
                $data[$key]['id']=$rs['id'];
                $data[$key]['fullname']=$rs['firstname'].' '.$rs['lastname'];
                $data[$key]['image']=$rs['image'];
                foreach ($asm as $key2=>$as){
                    $users[]=$as['id'];
                    $c_user[$key2]['id']=$as['id'];

                }
                $data[$key]['sales']=0;
                $data[$key]['sales']=Order::wherein('booked_by',$users)
                    ->whereBetween('date_to_deliver',[$request->get('start_date'),$request->get('end_date')])
                    ->where('status','=','Delivered')->where('type','!=','Sample')
                    ->sum('payment');
                $data[$key]['recovery']=0;
                if($rs['id']==4){
                    return $data[$key]['sales'];
                }

                foreach ($c_user as $key3=>$as){
                    $customer=Customer::select('id')->where('sale_officer_id',$as['id'])->get();
                    $user_ids=[];
                    $cus_ids=[];
                    $user_ids[]=$as['id'];

                    foreach ($customer as $cu){
                        $user_ids[]=$cu['id'];
                        $cus_ids[]=$cu['id'];
                    }
//                // So supplier addition
                    $supplier=SupplierSo::select('supplier_id')->where('so_id',$as['id'])->get();
                    foreach ($supplier as $su){
                        $user_ids[]=$su['supplier_id'];
                    }
                    $recovery=PaymentReceived:: wherein('user_id', $user_ids)
                        ->where('payment_type','=','Cash')
                        ->whereBetween('promise_cheque_date',[$request->get('start_date'),$request->get('end_date')])
                        ->where('shop_id','!=',0)
                        ->wherein('shop_id',$cus_ids)
                        ->sum('amount');
                    $data[$key]['recovery']=$data[$key]['recovery']+$recovery;
                }
            }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'ASM Sales & Recovery',
            'data' => $data], 200);
    }
    /***
     * RSMUser
     *
     * @param Request $request
     */
    public function RSMUser(Request $request)
    {
        try {
            $rsm=User::select('id','firstname','lastname','image')
                ->where('rsm_id',$request->get('rsm_id'))
                ->get();

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Users',
            'data' => $rsm], 200);
    }



    /***
     * Coupan Schemes
     *
     * @param Request $request
     */
    public function storecoupanscheme(Request $request)
    {
        try {
            $coupan=new CoupanScheme();
            $coupan->name=$request->get('name');
            $coupan->save();


        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Coupan Scehme Added',
            'data' => $coupan], 200);
    }
    public function getcoupanschemes( )
    {
        try {
            
            $coupan=CoupanScheme::all();


        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $coupan], 200);
    }
    
    public function getcoupanschemestargets(Request $request )
    {
        try {
            
            $obj= array();
            
             $targets= RsmTarget ::where('coupan_scheme_id',$request->get('coupan_scheme_id'))->with(['added_by','rsm_info','part_info'])->get();
             
             foreach($targets as $key=> $target)
             {
                
            if(!empty($target)){
               $sales= Bilti::where('party_id',$target->party_id)
                   ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                   ->sum('payment');
               $recovery= RsmPayment::where('party_id',$target->party_id)
                  ->whereBetween('date', [$target->start_date,$target->end_date])
                   ->sum('amount');
          
                $obj[$key]['party_id']=$target->party_id;
                $obj[$key]['sales_target']=$target->sales_target;
                $obj[$key]['recovery_target']=$target->recovery_target;
                $obj[$key]['sales_achieved']=$sales;
                $obj[$key]['recovery_achieved']=$recovery;
            }
            
            
             }
            

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
    }
    
    
     public function getcoupanschemesrsmtargets(Request $request )
{
    try {

        $user=User::whereHas('roles', function($query) {
            $query->where('name', '=', 'rsm');
        })
                ->where('id','<>',46)
        ->get();

$targets= RsmTarget::where('coupan_scheme_id',$request->coupan_scheme_id)->with(['stock_bookings','added_by','rsm_info','part_info'])->get();

        $obj= array();

        foreach($targets as  $target)
        {

            if(!empty($target)){
                foreach ($user as $key=>$use){


                    $obj[$key]['id']=$use['id'];
                    $obj[$key]['firstname']=$use['firstname'];
                    $obj[$key]['lastname']=$use['lastname'];
                    $obj[$key]['image']=$use['image'];
                    if(!empty($use) && !empty($use['region_id'])){

                        $party= PartyName::where('region_id',$use['region_id'])
//                    ->where('id','<>',14)
                        ->get();
                        foreach ($party as $key2=>$pa){
                            $obj[$key]['parties'][$key2]['id']=$pa['id'];
                            $obj[$key]['parties'][$key2]['name']=$pa['name'];
                            if($target->party_id==$pa->id && $target->sales_target!=0 && $target->recovery_target!=0)
                            {
                                $obj[$key]['parties'][$key2]['sales_target']=$target->sales_target;
                                $obj[$key]['parties'][$key2]['recovery_target']=$target->recovery_target;

                                // $obj[$key]['parties'][$key2]['sales_achieved']=Bilti::where('party_id',$pa['id'])
                                // ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                                // ->sum('payment');
                              //  return $pa['id'];
                                $obj[$key]['parties'][$key2]['sales_achieved']=UserExpenseDetail::where('party_id',$pa['id'])->where('type','sale')->whereBetween('date', [$target->start_date,$target->end_date])->sum('amount');
                                $obj[$key]['parties'][$key2]['recovery_achieved']=RsmPayment::where('party_id',$pa['id'])
                                ->whereBetween('date', [$target->start_date,$target->end_date])
                                ->sum('amount');

                                 $obj[$key]['parties'][$key2]['sale_returns'] =$target->stock_bookings; 

                            }


                        }
                    }
                }
            }
            
            
        }


    } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
        'data' => $obj], 200);
}
    
    public function getcoupanschemessinglersmtargets(Request $request )
    {
      //  return $request;
        try {
            $party='';
            $rsm_id=$request->rsm_id;
            
            $use=User::where('id',$rsm_id)->first();

                
                $targets= RsmTarget::where('coupan_scheme_id',$request->coupan_scheme_id)->where('rsm_id',$rsm_id)->with(['stock_bookings'])->get();
             //  return $targets;
             $obj= array();
             $obj['parties']=array();
        
        
        foreach($targets as $target)
        {
            if(!empty($target)){
          
        
                $obj['id']=$use['id'];
                $obj['firstname']=$use['firstname'];
                $obj['lastname']=$use['lastname'];
                $obj['image']=$use['image'];
                if(!empty($use) && !empty($use['region_id'])){
                    
                    $party= PartyName::where('region_id',$use['region_id'])
//                    ->where('id','<>',14)
                        ->get();
      
                    foreach ($party as $key2=>$pa){
                        $obj['parties'][$key2]['id']=$pa['id'];
                        $obj['parties'][$key2]['name']=$pa['name'];
    
                       if($target->party_id==$pa->id && $target->sales_target!=0 && $target->recovery_target!=0)
                        {
                            $obj['parties'][$key2]['sales_target']=$target->sales_target;
                $obj['parties'][$key2]['recovery_target']=$target->recovery_target;
                
                // $obj['parties'][$key2]['sales_achieved']=Bilti::where('party_id',$pa['id'])
                //     ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                //   ->sum('payment');
                $obj['parties'][$key2]['sales_achieved']=UserExpenseDetail::where('party_id',$pa['id'])->where('type','sale')->whereBetween('date', [$target->start_date,$target->end_date])->sum('amount');
                        $obj['parties'][$key2]['recovery_achieved']=RsmPayment::where('party_id',$pa['id'])
                    ->whereBetween('date', [$target->start_date,$target->end_date])
                   ->sum('amount');
                   
                   $obj['parties'][$key2]['sale_returns'] =$target->stock_bookings; 
                
                        }
                    }
                }
            }
             
        }
            
             
    

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
    }
    

    public function getcoupanschemessinglersmtargetsbytype(Request $request )
{
    try {

 
    
     
        if($request->type == "local"){
         $parties= PartyName::where('show_gm',1)->get();
        }else{
             $parties= PartyName::where('show_gm',0)->get();

        }
        


      

        $obj= array();
        
        
        foreach($parties as $key => $party)
        {
            if(!empty($party)){
               
               $obj[$key]=$party;
               $targets= RsmTarget::where('coupan_scheme_id',$request->coupan_scheme_id)->where('party_id',$party->id)->first();
               $obj[$key]['target'] = $targets;

            }

        }




    } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
        'data' => $obj], 200);
}


public function getcoupanschemessinglersmtargetslatest(Request $request )
{
    try {
        $party='';
        $rsm_id=$request->rsm_id;

        $use=User::where('id',$rsm_id)->first();


       $target= RsmTarget::where('rsm_id',$rsm_id)->with(['stock_bookings'])->latest()->first();
       // return $target;
        $obj= array();
        $obj['parties']=array();
        
        
        
            if(!empty($target)){


                $obj['id']=$use['id'];
                $obj['firstname']=$use['firstname'];
                $obj['lastname']=$use['lastname'];
                $obj['image']=$use['image'];
                $obj['target_id'] = $target['id'];
                $obj['coupan_scheme_id'] = $target['coupan_scheme_id'];
                if(!empty($use) && !empty($use['region_id'])){

                    $party= PartyName::where('region_id',$use['region_id'])
//                    ->where('id','<>',14)
                    ->get();

                    foreach ($party as $key=>$pa){
                        $obj['parties'][$key]['id']=$pa['id'];
                        $obj['parties'][$key]['name']=$pa['name'];
                        
                        if($target->party_id==$pa->id && $target->sales_target!=0 && $target->recovery_target!=0)
                        {

                            $obj['parties'][$key]['sales_target']=$target->sales_target;
                            $obj['parties'][$key]['recovery_target']=$target->recovery_target;

                            $obj['parties'][$key]['sales_achieved']=Bilti::where('party_id',$pa['id'])
                            ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                            ->sum('payment');
                            $obj['parties'][$key]['recovery_achieved']=RsmPayment::where('party_id',$pa['id'])
                            ->whereBetween('date', [$target->start_date,$target->end_date])
                            ->sum('amount');

                             $obj['parties'][$key]['sale_returns'] =$target->stock_bookings; 

                        }
                    }
                }
            }

        




    } catch (Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
        'data' => $obj], 200);
}




 public function getcoupanschemespartytargets(Request $request )
    {
        try {
                $coupan_scheme_id = $request->coupan_scheme_id;
                $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
                })->where('party_id','=',$request->party_id)->with(['asm_target'=>function($query)use($coupan_scheme_id){
                    $query->where('coupan_scheme_id',$coupan_scheme_id)->get();
                }])->get();
                
             //   return $users;
                
                 $target= RsmTarget::where('coupan_scheme_id',$request->coupan_scheme_id)->where('party_id',$request->party_id)->with(['part_info','stock_bookings'])->first();
             $obj= array();
             
         //  return $target;
                
           
           if(!empty($target)){
              // $sales= Bilti::where('party_id',$target->party_id)
               //    ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                //   ->sum('payment');
                 $sales=UserExpenseDetail::where('party_id',$target->party_id)->where('type','sale') ->whereBetween('date', [$target->start_date,$target->end_date])
       ->sum('amount');
               $recovery= RsmPayment::where('party_id',$target->party_id)
                  ->whereBetween('date', [$target->start_date,$target->end_date])
                   ->sum('amount');
                 $obj['asm_count'] = $users;  
                 $obj['party_info']=$target->part_info;
                $obj['party_id']=$target->party_id;
                  $obj['sale_returns']=$target->stock_bookings;
                $obj['sales_target']=$target->sales_target;
                $obj['recovery_target']=$target->recovery_target;
                   $obj['start_date']=$target->start_date;
                      $obj['end_date']=$target->end_date;
                $obj['sales_achieved']=$sales;
                $obj['recovery_achieved']=$recovery;
                $obj['id']=$target->id;
                 $obj['status']=$target->status;
            }
            
             
    

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Coupan Scehmes',
            'data' => $obj], 200);
    }
    
    public function updatepayementvendor(Request $request )
    {
        try {
            
               

$party_id=$obj = RsmPayment::where('id',$request->get('id'))->first();
         
            if(!empty($party_id))
            {
                
                $obj = RsmPayment::where('id',$request->get('id'))->update(['payment_to'=> $request->get('vendor_id')]);
                $obj = UserExpenseDetail::where('detail_id',$request->get('id'))->where('type','Recovery')->where('party_id',null)->update(['vendor_id'=> $request->get('vendor_id')]);
                $remarks  = new PaymentRemark();
                $remarks->rsm_id = $request->get('id');
                $remarks->type = "payment_vendor_change";
                $remarks->remarks = $request->remarks;
                $remarks->save();

            }
                
                 
    

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'vendor has been updated'], 200);
    }

/* asm models*/


    public function getasminrsm(Request $request){

        try{
            $rsmid = $request->rsm_id;

             $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->where('rsm_id','=',$rsmid)
                ->get();
               

         return API::response()->array(['success' => true, 'message' => 'All ASM in RSM',
            'data' => $users], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    //all bilites at rsm in asm ///
//all bilites at rsm in asm ///
public function getrsminasmwithsubdistributerbilties(Request $request){


    try {

        $rsmid = $request->rsm_id;
        $product_id = $request->product_id;

        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        $i = 0;
        $data = [];
        $asm_users   = Subdistributor::where('rsm_id',$request->rsm_id)->get();

        foreach ($asm_users as $key => $asm_user) {
         $asm    = $asm_user->id;

         $biltys=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$startDate,$endDate])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id)->with('bilty_product');
       },'subdistributer_info','bilty_asm_stock_order'])->get();

         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }

    if(!empty($data)){


        return API::response()->array((['success' => true, 'message' => 'All Bilties by product wise in asm ',
         'data' => $data]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}

public function getasmwithsubdistributerbilties(Request $request){


    try {

        $rsmid = $request->asm_id;
        $product_id = $request->product_id;

        $startDate = $request->start_date;
        $endDate   = $request->end_date;
        $i = 0;
        $data = [];
        $asm_users   = Subdistributor::where('asm_id',$request->asm_id)->get();

        foreach ($asm_users as $key => $asm_user) {
         $asm    = $asm_user->id;

         $biltys=  Bilti::where('po_no_rsm','!=',0)->where('party_id',$asm_user->id)->whereBetween('delivered_date', [$startDate,$endDate])->with(['bilty_detail'=>function($query) use ($product_id)
         {
           $query->where('product_id',$product_id)->with('bilty_product');
       },'subdistributer_info','bilty_asm_stock_order'])->get();

         foreach ($biltys as $key => $bilty) {

            if(count($bilty->bilty_detail) > 0) {
                
                $data[] =  $bilty;

            }
        }
        $biltys = null;

    }

    if(!empty($data)){


        return API::response()->array((['success' => true, 'message' => 'All Bilties by product wise in asm ',
         'data' => $data]), 200);
    }else{
      return API::response()->array(['success' => true,
        'message' => 'not found'], 200);
  }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'All Bilty ',
    'data' => $bilty], 200);
}
  
      public function getasminrsmwithouttoken(Request $request){

        try{
            $rsmid = $request->rsm_id;
              $startDate = $request->start_date;
              $endDate   = $request->end_date;


             $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->where('rsm_id','=',$rsmid)->with(['sub_distributer_user'=>function($query) use ($startDate,$endDate)
                {
                  $query->with(['ledger' => function ($query) use ($startDate,$endDate){

                    $query->whereBetween('date', [$startDate,$endDate])->wherein('type',['Sub_sale','Sub_recovery'])->get();
                   }]);
                },'party_info'])->get();

                
               
return API::response()->array(['success' => true, 'message' => 'All ASM in RSM',
            'data' => $users], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function getasminpartywithouttoken(Request $request){

        try{
              $dis_id = $request->dis_id;
              $startDate = $request->start_date;
              $endDate   = $request->end_date;

              $party =PartyName::where('user_id',$dis_id)->first();

             $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->where('party_id','=',$party->id)->with(['sub_distributer_user'=>function($query) use ($startDate,$endDate)
                {
                  $query->with(['ledger' => function ($query) use ($startDate,$endDate){

                    $query->whereBetween('date', [$startDate,$endDate])->wherein('type',['Sub_sale','Sub_recovery'])->get();
                   }]);
                },'party_info'=>function($query){return $query->with('soul_distributer');}])->get();

                
               
return API::response()->array(['success' => true, 'message' => 'All ASM in party with souldistributer',
            'data' => $users], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
       public function getrsmwithsubdistributerbilties(Request $request){

      
    try {
        $rsmid = $request->rsm_id;
        $asmid = $request->asm_id;
         $startDate = $request->start_date;
              $endDate   = $request->end_date;

         $data = [];

         $biltys= Bilti::where('po_no_rsm','!=',0)->whereBetween('delivered_date', [$startDate,$endDate])->with(['subdistributer_info'=>function($query)use ($rsmid,$asmid)
        {
            if($asmid == 0){
                if($rsmid != 0){
              $query->where('rsm_id',$rsmid);
          }else{

            
          }
          }else{

            $query->where('asm_id',$asmid);
        }
    },'bilty_detail'=>function($query)
                {
                  $query->with('bilty_product');
                }])->get();
       
       foreach ($biltys as $key => $bilty) {
        
               if ($bilty->subdistributer_info != null){
                
                $data[] =  $bilty;
               
               
               }
               
            }

            if(!empty($data)){

            
            return API::response()->array((['success' => true, 'message' => 'All Bilty ',
             'data' => $data]), 200);
            }else{
              return API::response()->array(['success' => true,
                'message' => 'not found'], 200);
            }



    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Bilty ',
        'data' => $bilty], 200);
}
    
      public function getasmassignedparty(Request $request){

        try{

      
          $asm_user = AsmAssignParty::where('asm_id',$request->asm_id)->with(['parties'=>function($query)
                    {$query->with('soul_distributer');}])->get();
      
              
return API::response()->array(['success' => true, 'message' => ' ASM  assigned party with souldistributer',
            'data' => $asm_user], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

     public function getallasm(Request $request){

        try{
             $startDate = $request->start_date;
              $endDate   = $request->end_date;
            
             $users=User::whereHas('roles', function($query) {
                $query->where('name', '=', 'asm');
            })->with(['sub_distributer_user'=>function($query) use ($startDate,$endDate)
                {
                  $query->with(['ledger' => function ($query) use ($startDate,$endDate){

                    $query->whereBetween('date', [$startDate,$endDate])->wherein('type',['Sub_sale','Sub_recovery'])->get();
                   }]);
                },'party_info'])->get();
                
               
return API::response()->array(['success' => true, 'message' => 'All ASM ',
            'data' => $users], 200);

        }catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function getlistallasm(Request $request){

    try{
    

     $users=User::whereHas('roles', function($query) {
        $query->where('name', '=', 'asm');
    })->get();


    return API::response()->array(['success' => true, 'message' => 'All ASM ',
        'data' => $users], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}



    public function getlistalldsf(Request $request){

    try{
    

     $dsfusers=DsfTarget::where('sub_distributor_id',$request->sub_distributor_id)->get();
    
    


    return API::response()->array(['success' => true, 'message' => 'All DSF ',
        'data' => $dsfusers], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}




    
    /* ---- 21/07/2020 */

      public function monthlyasmpartysalespercentage(Request $request){
        try {

            $start    = (new DateTime($request->start_date))->modify('first day of this month');
$end      = (new DateTime($request->end_date))->modify('first day of next month');
$interval = DateInterval::createFromDateString('1 month');
$period   = new DatePeriod($start, $interval, $end);
$user=User::whereHas('roles', function($query) {
$query->where('name', '=', 'asm');
            })->get();


            $obj=null;

                 foreach ($period as $key=> $dt) {
                            
                        $start_date[$key] = $dt->format("Y-m-00");

                        $end_date[$key] =  $dt->add($interval)->format("Y-m-00");

                        
                         $obj[$key]['date']=$start_date[$key];
           

            foreach ($user as $key2=>$use){
                $obj[$key]['data'][$key2]['id']=$use['id'];
                $obj[$key]['data'][$key2]['firstname']=$use['firstname'];
                $obj[$key]['data'][$key2]['lastname']=$use['lastname'];
                $obj[$key]['data'][$key2]['total_points']=$use['total_points'];
                $obj[$key]['data'][$key2]['sale_rating']=$use['sale_rating'];
                $obj[$key]['data'][$key2]['recovery_rating']=$use['recovery_rating'];
                $obj[$key]['data'][$key2]['image']=$use['image'];
                if(!empty($use)){
                    $party= Subdistributor::where('asm_id',$use['id'])
                        ->get();
                       
                            
                    foreach ($party as $key3=>$pa){

                        $obj[$key]['data'][$key2]['parties'][$key3]['id']=$pa['id'];
                        $obj[$key]['data'][$key2]['parties'][$key3]['name']=$pa['name'];
                        $obj[$key]['data'][$key2]['parties'][$key3]['sale']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Sub_sale')
                            ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                            ->groupBy('type')
                            ->sum('amount');
                        $obj[$key]['data'][$key2]['parties'][$key3]['recovery']=UserExpenseDetail::
                            where('party_id',$pa['id'])
                            ->where('type','Sub_recovery')
                            ->whereBetween('date', [$start_date[$key],  $end_date[$key]])
                            ->groupBy('type')
                            ->sum('amount');
                    }
                    
                }
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Asm Party sales and recovery monthly percentage ',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }


public function podelayremarks(Request $request){

    try{

         $PaymentRemark  =   new  PaymentRemark();
         $PaymentRemark->rsm_id = $request->po_number;
         $PaymentRemark->user_id = $request->user_id;
         $PaymentRemark->type = "po_delay_remarks";
         $PaymentRemark->remarks = $request->remarks;
         $PaymentRemark->save();



    return API::response()->array(['success' => true, 'message' => 'po delay remarks updated',
        'data' => $users], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
   /* ------ */
  
public function setledger(Request $request){
    
   LedgerAdjustvendor($request->id);
}
  
public function salereturnasm(Request $request){

    try{
    foreach ($request->orders as $key => $order) {
            

       $stock   = StockBooking::where('id',$order['id'])->first();
        $subdistributer = Subdistributor::where('id',$stock->party_id)->first();
         

         $stock->booked_by =$subdistributer->asm_id;
          $stock->save();
    }
    return API::response()->array(['success' => true, 'message' => 'done'], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function rsmpaymentsettozero(Request $request)
    {
        try {
            $obj= RsmPayment::where('id',$request->id)->first();


            if(!empty($obj)){
                $type = ['Cash_Transfer','Cash_Received','Recovery'];

               $UserExpenseDetails  = UserExpenseDetail::where('detail_id',$obj->id)->whereIn('type',$type)->get();
               foreach ($UserExpenseDetails as $key => $UserExpenseDetail) {
                   
                   $UserExpenseDetail->amount = 0;
                   $UserExpenseDetail->save();
               }
            $obj->accountant_remarks = "wrong entry  ".$obj->amount; 
            $obj->amount = 0;

            $obj->save();
             
            }
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Payment set to zero',
            'data' => $obj], 200);
    }



}