<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Product;
use App\Models\Bilti;
use App\Models\VendorInvoice;
use App\Models\BiltiDetail;
use App\Models\UserExpense;
use Dingo\Api\Facade\API;
use App\Models\ProductCategory;
use App\Models\PaymentRemark;
use App\Models\PointSystem;
use App\Models\MonthlyProduct;
use App\Models\Subdistributor;
use App\Models\DsfShop;
use App\Models\StockBooking;
use App\Models\PointRewardMap;
use Carbon\Carbon;
use DateTime;
use DatePeriod;
use DateInterval;
use Illuminate\Support\Str;
use App\Models\User;
use App\Models\Role;
use League\Flysystem\Exception;
use DB;

class WalletSystemController extends BaseController
{

    private $_pointrewardModel;

    public function __construct(Request $request, PointRewardMap $pointrewardmap)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_pointrewardModel = $pointrewardmap;
    }

    
    public function addrewardpointlists (Request $request)
    {
        try {

          

          $role = Role::where('name',$request->name)->first();

           $role_id     = $role->id;


           if($role_id){

            foreach ($request->points_segments as $key => $points_segment) {
              
            

              $PointRewardMap  =   new  PointRewardMap();
              $PointRewardMap->role_id = $role_id;
              $PointRewardMap->start_amount = $points_segment['start_amount'];
              $PointRewardMap->end_amount = $points_segment['end_amount'];
              $PointRewardMap->rewards = $points_segment['rewards'];
              $PointRewardMap->save();
          }
        }
           

     
     return API::response()->array(['success' => true,
        'message' => 'Reward list Added Sucessfully'], 200);
 } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}



 public function deleterewardpointlists (Request $request)
    {
        try {

          

          $role = Role::where('name',$request->name)->first();

           $role_id     = $role->id;


           if($role_id){

            
              $PointRewardMaps  = PointRewardMap::where('role_id',$role_id)->get();
             foreach ($PointRewardMaps as $key => $PointRewardMap) {
              $PointRewardMap->delete();
          }
        }
           

     
     return API::response()->array(['success' => true,
        'message' => 'Reward list Added Sucessfully'], 200);
 } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

 public function editpointreward (Request $request)
    {
        try {

        
           $id     = $request->id;
           if($id){

              $PointRewardMaps  = PointRewardMap::where('id',$id)->first();
            
              $PointRewardMaps->start_amount = $request->start_amount;
              $PointRewardMaps->end_amount = $request->end_amount;
              $PointRewardMaps->rewards = $request->rewards;
              $PointRewardMaps->save();
              
          }
        
           

     
     return API::response()->array(['success' => true,
        'message' => 'edit list Added Sucessfully'], 200);
 }catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

  public function getpointreward (Request $request)
    {
        try {


           $role = Role::where('name',$request->name)->first();

           $role_id     = $role->id;


           if($role_id){
        
             
              $data  = PointRewardMap::where('role_id',$role_id)->get();
           
            }


           return API::response()->array(['success' => true,
            'message' => 'reward list Show Sucessfully',
            'data' => $data], 200);
     

    
 }catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}



 

}
