<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Product;
use App\Models\Bilti;
use App\Models\BiltiDetail;
use App\Models\BiltiDetialType;
use App\Models\BiltyImage;
use App\Models\SoStock;
use App\Models\SoStockDetail;
use App\Models\StockBooking;
use App\Models\StockBookingDetail;
use App\Models\StockBookingDetailCategory;
use App\Models\User;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\PartyName;
use App\Models\PartyRates;
use App\Models\ProductPrice;
use App\Models\PoNumber;
use App\Models\WareHouse;
use App\Models\WarehouseStocks;
use App\Models\WarehouseStockVariant;
use App\Models\WarehouseCustomer;
use Dingo\Api\Facade\API;
use App\Models\PushNotificationToken;
use App\Models\ProductCategory;
use App\Models\PaymentRemark;
use Carbon\Carbon;
use DateTime;
use DatePeriod;
use DateInterval;
use Illuminate\Support\Str;
use League\Flysystem\Exception;
use DB;

class WareHouseController extends BaseController
{

    private $_warehouseModel;

    public function __construct(Request $request, WareHouse $WareHouse)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_warehouseModel = $WareHouse;
    }


    public function addwarehouse(Request $request)
    {
        try {


           $validator = \Validator::make($request->all(), $this->_warehouseModel->validationRules());

           if ($validator->fails()) {
            return API::response()->array(['success' => false,
                'error'   => 'Required parameters are missing or incorrect!',
                'message' => $validator->errors()], 400);
        } else {


           $WareHouse  =   new  WareHouse();

           $WareHouse->name = $request->name;
           $WareHouse->city = $request->city;
           $WareHouse->save();
       }    


       return API::response()->array(['success' => true,
        'message' => 'warehouse Added Sucessfully'], 200);
   } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

public function getwarehousewithstock(Request $request)
{
    try {


      $WareHouse = WareHouse::where('id',$request->id)->with(['WarehouseStocks' =>function($query)
       {$query->with(['product' =>function($query) {$query->with(['images'

   ]);}

   ]);}])->first();
      if(!empty($WareHouse)){
         return API::response()->array(['success' => true,
            'message' => 'Show warehouse Sucessfully',
            'data' => $WareHouse], 200);
     }
     else{
         return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

     }    



 } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
} 

public function getwarehouse(Request $request)
{
    try {


      $WareHouse = WareHouse::get();
      if(!empty($WareHouse)){
         return API::response()->array(['success' => true,
            'message' => 'Show warehouse Sucessfully',
            'data' => $WareHouse], 200);
     }
     else{
         return API::response()->array(['success' => false,
            'message' => 'record not found'], 400);

     }    



 } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
} 

public function addwarehousecutomers(Request $request)
{
    try {


       $validator = \Validator::make($request->all(), $this->_warehouseModel->validationRulescustomers());

       if ($validator->fails()) {
        return API::response()->array(['success' => false,
            'error'   => 'Required parameters are missing or incorrect!',
            'message' => $validator->errors()], 400);
    } else {


       $WarehouseCustomer  =   new  WarehouseCustomer();

       $WarehouseCustomer->name = $request->name;
       $WarehouseCustomer->email = $request->email;
       $WarehouseCustomer->phone = $request->phone;
       $WarehouseCustomer->save();
   }    


   return API::response()->array(['success' => true,
    'message' => 'warehouse customer Added Sucessfully'], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

public function editwarehousecutomers(Request $request)
{
    try {




       $WarehouseCustomer  =  WarehouseCustomer::where('id',$request->id)->first();
       if($WarehouseCustomer){

           $WarehouseCustomer->name = $request->name;
           $WarehouseCustomer->email = $request->email;
           $WarehouseCustomer->phone = $request->phone;
           $WarehouseCustomer->save();

       }



       return API::response()->array(['success' => true,
        'message' => 'warehouse customer updated Sucessfully'], 200);
   } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

public function deletewarehousecutomers(Request $request)
{
    try {




       $WarehouseCustomer  =  WarehouseCustomer::where('id',$request->id)->first();
       if($WarehouseCustomer){

           $WarehouseCustomer->delete();

       }else{
           return API::response()->array(['success' => false,
            'message' => 'not found'], 
            400);

       }



       return API::response()->array(['success' => true,
        'message' => 'warehouse customer deleted Sucessfully'], 200);
   } catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

public function getwarehousecutomers(Request $request)
{
    try {

       $WarehouseCustomer  =  WarehouseCustomer::get();
       if($WarehouseCustomer){
        return API::response()->array(['success' => true,
            'message' => 'warehouse customers',
            'data' => $WarehouseCustomer], 200);

    }else{
       return API::response()->array(['success' => false,
        'message' => 'not found'], 
        400);

   }




} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}







public function AddBiltywarehouse(Request $request)
{

    try {

        $bilty= new Bilti();
        $bilty->stock_booking_id=$request->stock_booking_id;
        $bilty->supplier_id=$request->supplier_id;
        $bilty->delivered_to_id=$request->booked_by;

        $bilty->party_id=$request->party_id;

        $bilty->bilti_no=$request->biltyNo;
        $bilty->bilti_date=date("Y-m-d");
        $bilty->delivered_date = date("Y-m-d");

        $bilty->gatepass=$request->gate_pass;
        $bilty->po_no=$request->po_no;


        $bilty->uuid=$request->uuid;

        $bilty->remarks=$request->remarks;

        $bilty->status='On The Way';

        $total_price=0;
        $totalvendor_price = 0;
        $vendor_price=0;
        if(count($request->stock_details)>0) {

            foreach ($request->stock_details as $stock) {

                if($stock['quantity'] > 0 ){
                    $product_prices = Product::where('id', $stock['product_id'])->first();

                    if (count($product_prices->productCategory) > 0 ){
                        //// new work 12/18/2019 ////




                        foreach ($stock['product_category'] as $key => $subproduct) {

                         $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$subproduct['id'])->first();
                         if($warehousestockvariant){
                         $warehousestockvariant->quantity  =  $warehousestockvariant->quantity - $subproduct['quantity']; 

                         $warehousestockvariant->save();
                         }
                     }



                 }

                 $warehouse  = WareHouse::where('active',1)->first();
                 if($warehouse){

                  $warehousestocks =  $warehouse->WarehouseStocks;
                  if($warehousestocks){
                    foreach ($warehousestocks as $key => $warehousestock) {

                        $warehouse = WarehouseStocks::where('product_id',$stock['product_id'])->where('warehouse_id',$warehousestock->id)->first();
                        if($warehouse){
                           $warehouse->quantity   =  $warehouse->quantity - $stock['quantity'];
                           $warehouse->save();
                       }
                   }

               }
           }



           $vendor_price = ($product_prices->vendor_price)* $stock['quantity'];

           $totalvendor_price = $totalvendor_price + $vendor_price;

       }

   }
}

$bilty->vendor_price=$totalvendor_price;

$bilty->save();

$price=0;
$vendor_price=0;
$is_mehandi=false;
PoNumber::where('po_number',$request->po_no)->update(array('status' => 'Delivered'));
  // PoNumber::where('po_number',$request->get('po_no'))->update(array('status' => 'Delivered'));;
$party=PartyName::where('id',$request->party_id)->first();

$distributer_id  = $party->user_id;



if(count($request->stock_details)>0){

    foreach ($request->stock_details as $stock){
        if($stock['quantity'] > 0 ){
            if(!empty($distributer_id)){
             $stock_product  = SoStock::where('so_id',$distributer_id)->where('product_id',$stock['product_id'])->where('product_category_id', 0)->first();
             if($stock_product){
                $stock_product->qty  = $stock_product->qty + $stock['quantity'];

                $stock_product->save();
                 //// how much stock in at soul distributers parent products ///
                $so_stock_detail  = new SoStockDetail();
                $so_stock_detail->so_id = $distributer_id;
                 $so_stock_detail->ref_id = $bilty->id;
                $so_stock_detail->product_id = $stock['product_id'];
                $so_stock_detail->stock_in = $stock['quantity'];
                $so_stock_detail->total_stock = $stock_product->qty;
                $so_stock_detail->date = date("Y-m-d");
                $so_stock_detail->save();
            }else{

               $stock_product  = new SoStock();
               $stock_product->so_id = $distributer_id;
               $stock_product->product_id = $stock['product_id'];
               $stock_product->qty = $stock['quantity'];
               $stock_product->save();
               
               $so_stock_detail  = new SoStockDetail();
             $so_stock_detail->so_id = $distributer_id;
             $so_stock_detail->ref_id = $bilty->id;
             $so_stock_detail->product_id = $stock['product_id'];
             $so_stock_detail->stock_in = $stock['quantity'];
             $so_stock_detail->total_stock = $stock['quantity'];
             $so_stock_detail->date = date("Y-m-d");
             $so_stock_detail->save();
           }



       }
       $detail=new BiltiDetail();
       $detail->bilti_id=$bilty->id;
       $detail->product_id=$stock['product_id'];
       $detail->quantity=$stock['quantity'];
       $detail->delivered_date = date("Y-m-d");

       $product_prices = Product::where('id', $stock['product_id'])->get();


       $detail->vendor_price=($product_prices[0]->vendor_price)*$stock['quantity'];


       if(!empty($party)&& !empty($party->region_id) && $party->region->custom_prices == 1){
        $cost=$this->CalculateExportInvoice($stock['product_id'],$detail->quantity,$party->id);
        if($cost == 0){

            $cost=$this->CalculateInvoice($stock['product_id'],$detail->quantity,'Distributor');

        }
//                        dd($cost);
    }else{

        $cost=$this->CalculateInvoice($stock['product_id'],$detail->quantity,'Distributor');

    }

    $price=$price+$cost;
    $detail->price=$cost;



    if($party->region_id !=2 && ($stock['product_id'] ==41 || $stock['product_id'] ==43 ||$stock['product_id'] ==44 ||$stock['product_id']==38 || $stock['product_id'] == 16 || $stock['product_id'] == 30)){
        $p= ProductPrice::where('product_id',$stock['product_id'])->first();

        $detail->discount=$p->discount;
        $detail->payment=$cost-(($cost*$p->discount)/100);
        $total_price=$total_price+($cost-(($cost*$p->discount)/100));

    } else{



        if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){

            $detail->discount=$party->discount;
            $detail->payment=$cost-(($cost*$party->discount)/100);
            $total_price=$total_price+($cost-(($cost*$party->discount)/100));
        }else{

            $detail->discount=0;
            $detail->payment=$cost;
            $total_price=$total_price+$cost;
            $is_mehandi=true;
        }
    }

    $detail->save();
    $s_detail=StockBookingDetail::where('id',$stock['id'])->first();
    if(!empty($s_detail)){
        $s_detail->delivered=$s_detail->delivered+$stock['quantity'];
        $s_detail->save();
    }
                    ///  12/23/2019 /////

    if(count($stock['product_category'])>0){
        foreach($stock['product_category'] as $product_category){

            if(!empty($distributer_id)){

                $stock_product  = SoStock::where('so_id',$distributer_id)->where('product_id',$stock['product_id'])->where('product_category_id',$product_category['product_category_id'])->first();

                if(!empty($stock_product)){
                    $stock_product->qty  = $stock_product->qty + $product_category['quantity'];

                    $stock_product->save();
                    $so_stock_detail  = new SoStockDetail();
                    $so_stock_detail->so_id = $distributer_id;
                    $so_stock_detail->ref_id = $bilty->id;
                    $so_stock_detail->product_id = $stock['product_id'];
                    $so_stock_detail->product_category_id = $product_category['product_category_id'];
                    $so_stock_detail->stock_in = $product_category['quantity'];
                    $so_stock_detail->total_stock = $stock_product->qty;
                    $so_stock_detail->date = date("Y-m-d");
                    $so_stock_detail->save();


                }
                else{

             $so_stock_product  = new SoStock();
             $so_stock_product->so_id = $distributer_id;
             $so_stock_product->product_id = $stock['product_id'];
             $so_stock_product->product_category_id =$product_category['product_category_id'];
             $so_stock_product->qty = $product_category['quantity'];
             $so_stock_product->save();

             $so_stock_details  = new SoStockDetail();
             $so_stock_details->so_id = $distributer_id;
             $so_stock_detail->ref_id = $bilty->id;
             $so_stock_details->product_id = $stock['product_id'];
             $so_stock_details->product_category_id = $product_category['product_category_id'];
             $so_stock_details->stock_in = $product_category['quantity'];
             $so_stock_details->total_stock = $product_category['quantity'];
             $so_stock_details->date = date("Y-m-d");
             $so_stock_details->save();
                }
            }


            $s_detail=StockBookingDetailCategory::where('stock_booking_detail_id',$stock['id'])->where('product_category_id',$product_category['product_category_id'])->first();

            if(!empty($s_detail)){
                $s_detail->delivered=$s_detail->delivered+$product_category['quantity'];
                $s_detail->save();
            }
        }
    }



                    ///
                    // add stock product category

    if(count($stock['product_category'])>0){
        foreach($stock['product_category'] as $product_category){
            if(!empty($product_category['quantity'])){
                $product_cat=new BiltiDetialType();
                $product_cat->bilti_detial_id=$detail->id;
                $product_cat->product_category_id=$product_category['product_category_id'];
                $product_cat->quantity=$product_category['quantity'];

                $product_cat->save();
            }
        }
    }
                    // auto complete stock order
    $com= StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
    ->where('stock_booking_id',$request->stock_booking_id)->first();
    if(!empty($com) && ($com['dispatch_quantity']<=$com['delivered'])){
        StockBooking::where('id',$request->stock_booking_id)->update(array('status'=>'Completed'));
    }
    $p_com=StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
    ->where('stock_booking_id',$request->stock_booking_id)
    ->wherein('product_id',vendorProduct($request->supplier_id))
    ->first();
    if(!empty($p_com) && ($p_com['dispatch_quantity']<=$p_com['delivered'])){
        PoNumber::where('stock_booking_id',$request->stock_booking_id)
        ->where('user_id',$request->supplier_id)
        ->where('po_number',$request->po_no)
        ->update(array('status'=>'Completed'));
    }

} ///quantity condition exit

} //loop exit stock check

} ///condition exit


$bilty->price=$price;

if(!empty($party)){
//                $amount=$price;
    if($party->discount==0){
        $bilty->discount=0;
        $bilty->payment=$price;
        $party->balance=($party->balance)+($price);
        $party->save();
    }else{
        if($is_mehandi){
            $bilty->discount=0;
        }else{
            $bilty->discount=$party->discount;
        }

        $dis=($price*$party->discount)/100;
//                    $bilty->payment=$price-$dis;
        $bilty->payment=$total_price;
//                    $amount=$price-$dis;
        $party->balance=($party->balance)+($total_price);
//                    $party->balance=($party->balance)+($price-$dis);
        $party->save();
    }
                // ledger add
    $e= new UserExpenseDetail();
    $e->user_id=$request->booked_by;
               // $e->party_id=$request->get('party_id');
    $e->detail_id=$bilty->id;
        $e->vendor_id=$request->supplier_id; //distributer id 
        $e->amount=$total_price;
        $e->vendor_price=$totalvendor_price;
        if($request->supplier_id==43 || $request->supplier_id== 100)
        {
            $user_vendor=User::where('id',$request->supplier_id)->first();

            $e->balance=$user_vendor->balance+$totalvendor_price;


            $xx="";

            {
             $opening=0;

             $obj = User::where('id', $request->supplier_id)->with(['ledger_vendor' => function ($query) {
                 $query->whereDate('date','>=','2019-07-5')->orderBy('date', 'ASC');
             }])->first();
             if (!empty($obj) && !empty($obj->ledger_vendor)) {
                 $xx=   $opening = $obj->opening_balance;
                 foreach ($obj->ledger_vendor as  $item) {
                    $update = UserExpenseDetail::where('id', $item->id)->first();
                    if (!empty($update)) {
                        switch ($update['type']) {
                            case 'Sale':
                            $opening = $opening + $update['vendor_price'];

                            UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);


                            break;
                            case 'Recovery':
                            $opening = $opening - $update['amount'];
                            UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                            break;

                        }
                    }
                       // $update->save();
                }
                $obj->balance = $opening;
                $obj->save();
            }
        }

            //     if (!empty($obj) && !empty($obj->ledger_vendor)) {
            //      $xx=   $opening = $obj->opening_balance;
            //         foreach ($obj->ledger_vendor as $key => $item) {
            //             $update = UserExpenseDetail::where('id', $item['id'])->first();
            //             if (!empty($update)) {
            //                 switch ($update['type']) {
            //                     case 'Sale':
            //                         $opening = $opening + $update['vendor_price'];
            //                         $update->balance = $opening;
            //                         $update->save();
            //                         break;
            //                     case 'Recovery':
            //                         $opening = $opening - $update['amount'];
            //                         $update->balance = $opening;
            //                         $update->save();
            //                         break;

            //                 }
            //             }
            //             $update->save();
            //         }
            //         $obj->balance = $opening;
            //         $obj->save();
            //   }


    }

    else{
        $e->balance=$party->balance;


    }

    $e->type='Sale';
    $e->date=date("Y-m-d");
    $e->save();

                    //// bilal code ////
    $e= new UserExpenseDetail();
    $e->user_id=$request->booked_by;
    $e->party_id=$request->party_id;
    $e->detail_id=$bilty->id;
                //$e->vendor_id=$request->get('supplier_id');
    $e->amount=$total_price;
    $e->vendor_price=$totalvendor_price;
    $e->balance = $party->balance + $total_price;
    $e->type='Sale';
    $e->date=date("Y-m-d");
    $e->save();


    if(!empty($party))
    {
     LedgerAdjust($party->id);
 }
}else{
    $bilty->discount=0;
    $bilty->payment=$price;
}
$bilty->save();


            //Image upload
if(!empty($request->uploadimages)) {
    $images = [];
    foreach($request->uploadimages as $image) {
        $image = upload_base64_image($image, 'uploads/bilty/',
            'image-');
        $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
        $customerImage->image =  'http://'.$image;
        $images[] = $customerImage;
    }
    if(count($images) > 0) {
        $bilty->biltyImages()->saveMany($images);
    }
}
}

catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'Bilty Added',
    'data' => $bilty], 200);
}



public function stockBookingCottonWarehouse(Request $request){
    try {

        $validator = \Validator::make($request->all(),['party_id'=>'required|not_in:0']);
        if ($validator->fails()) {
            return API::response()->array(['success' => false,
                'error'   => 'Required parameters are missing or incorrect!',
                'error_message' => $validator->errors()], 400);
        }else{
         $party=PartyName::where('id',$request->party_id)->first();

         $dis_stoc=new StockBooking();
         $dis_stoc->booked_by=$request->booked_by;
         $dis_stoc->party_id=$request->party_id;
         $dis_stoc->party_check = "warehouse";
         $dis_stoc->date=$request->date;
         $dis_stoc->remarks=$request->remarks;

         $dis_stoc->status='Booked';
         if($party->region_id == 2 ){
             $dis_stoc->vendor_flag = 1;
         }else{
          $dis_stoc->vendor_flag = 0;  
      }
      $dis_stoc->save();



      $bilty= new Bilti();
        $bilty->stock_booking_id=$dis_stoc->id;
        $bilty->supplier_id=98;
        $bilty->delivered_to_id=$request->booked_by;

        $bilty->party_id=$request->party_id;

        $bilty->bilti_no="auto-generate";
        $bilty->bilti_date=date("Y-m-d");
        $bilty->delivered_date = date("Y-m-d");

        $bilty->gatepass="00";

        $bilty->po_no_warehouse = "1";

        $bilty->status='On The Way';

        $bilty->save();



                // stock booking adda
      if(!empty($request->get('adda'))){
        foreach ($request->get('adda') as $adda){
            $ad= StockBookingAdda::where('adda_id',$adda['adda_id'])->where('vendor_id',$adda['vendor_id'])->first();
            if(empty($ad)){
                $ad=new StockBookingAdda();
            }
            $ad->vendor_id=$adda['vendor_id'];
            $ad->adda_id=$adda['adda_id'];
            $ad->save();
        }
    }
    $price=0;
    $total_price=0;

        ///stock less from warehouse  //
    if(count($request->products)>0){

       foreach ($request->products as $stock) {

        if($stock['quantity'] > 0 ){
            $product_prices = Product::where('id', $stock['product_id'])->first();

            if (count($product_prices->productCategory) > 0 ){                        

                foreach ($stock['product_category'] as $key => $subproduct) {

                 $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$subproduct['id'])->first();
                 if($warehousestockvariant){
                 $warehousestockvariant->quantity  =  $warehousestockvariant->quantity - $subproduct['quantity']; 

                 $warehousestockvariant->save();
             }

             }



         }

         $warehouse  = WareHouse::where('active',1)->first();
         if($warehouse){

          $warehousestocks =  $warehouse->WarehouseStocks;
          if($warehousestocks){
            foreach ($warehousestocks as $key => $warehousestock) {

                $warehouse = WarehouseStocks::where('product_id',$stock['product_id'])->where('warehouse_id',$warehousestock->id)->first();
                if($warehouse){
                   $warehouse->quantity   =  $warehouse->quantity - $stock['quantity'];
                   $warehouse->save();
               }
           }

       }
   }


}

}

}


if(count($request->products)>0){
    foreach ($request->products as $stock){
        $detail=new BiltiDetail();
       $detail->bilti_id=$bilty->id;
       $detail->product_id=$stock['product_id'];
       $detail->quantity=$stock['quantity'];
       $detail->delivered_date = date("Y-m-d");

        $d_stock=new StockBookingDetail();
        $d_stock->stock_booking_id=$dis_stoc->id;
        $d_stock->product_id=$stock['product_id'];
        $cot=Product::where('id',$stock['product_id'])->first();
        if(!empty($cot)){
            $d_stock->quantity=$stock['quantity'];
            $d_stock->dispatch_quantity=$stock['quantity'];
//                        $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity']*$cot->cotton,'Distributor');
            if(!empty($party)&& !empty($party->region_id) && $party->region_id==2){
                $cost=$this->CalculateExportInvoice($stock['product_id'],$stock['quantity'],$party->id);

            }else{
                $cost=$this->CalculateInvoice($stock['product_id'],$stock['quantity'],'Distributor');
            }


            $price=$price+$cost;
            $d_stock->price=$cost;
            $detail->price = 0;

            if($party->region_id !=2 && ($stock['product_id'] ==41 || $stock['product_id'] ==43 ||$stock['product_id'] ==44 ||$stock['product_id']==38 || $stock['product_id'] == 16 || $stock['product_id'] == 30)){
                $p= ProductPrice::where('product_id',$stock['product_id'])->first();

                $d_stock->discount=$p->discount;
                $d_stock->payment=$cost-(($cost*$p->discount)/100);
                $total_price=$total_price+($cost-(($cost*$p->discount)/100));

                $detail->discount=$p->discount;
                $detail->payment=$cost-(($cost*$p->discount)/100);
                $total_price=$total_price+($cost-(($cost*$p->discount)/100));

                

            } else{


                if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){
                    $d_stock->discount=$party->discount;
                    $d_stock->payment=$cost-(($cost*$party->discount)/100);
                    $total_price=$total_price+($cost-(($cost*$party->discount)/100));

                     $detail->discount=0;
                    $detail->payment=0;
                 
                }else{
                    $d_stock->discount=0;
                    $d_stock->payment=$cost;
                    $total_price=$total_price+$cost;

                     $detail->discount=0;
                     $detail->payment=0;
                    
                    

                }
            }
        }
        $d_stock->save();
        $detail->save();
        if(count($stock['product_category'])>0){
            foreach ($stock['product_category'] as $category){
                $cat=new StockBookingDetailCategory();
                $cat->stock_booking_detail_id=$d_stock->id;
                $cat->product_category_id=$category['id'];
                $cat->quantity=$category['quantity'];
                $cat->dispatch_quantity=$category['quantity'];
                $cat->delivered=0;
                $cat->save();
            }
        }
    }
}

$dis_stoc->price=$price;
$bilty->price=0;
$bilty->discount=0;
    $bilty->payment=0;
    $bilty->save();


 $e= new UserExpenseDetail();
    $e->user_id=$request->booked_by;
    $e->party_id=$request->party_id;
    $e->detail_id=$bilty->id;
                //$e->vendor_id=$request->get('supplier_id');
    $e->amount=0;
    $e->vendor_price=0;
    $e->balance = 0;
    $e->type='Warehouse_sale';
    $e->date=date("Y-m-d");
    $e->save();

if(!empty($party)){
    $amount=$price;
    if($party->discount==0){
        $dis_stoc->discount=0;
        $dis_stoc->payment=$price;
    }else{
       $dis_stoc->discount=$party->discount;
//                        $dis=($price*$party->discount)/100;
//                        $dis_stoc->payment=$price-$dis;
       $dis_stoc->payment=$total_price;
   }
   $dis_stoc->save();
}else{
    $dis_stoc->discount=0;
    $dis_stoc->payment=$price;
}
$dis_stoc->save();



                // push notification recipients fetch
$recipients = User::select('id')->whereHas('roles', function ($query) {
    $query->wherein('name', ['admin','super_admin']);
})->get()->toarray();
if(count($recipients)>0){
                    // push notification device token fetch
    $fetch=[];
    $body=null;
    if(!empty($dis_stoc->remarks)){
        $body=  $dis_stoc->remarks;
    }elseif(!empty($dis_stoc->Book_By->firstname)){
        $body='Stock Order From '.$dis_stoc->Book_By->firstname.' '.$dis_stoc->Book_By->lastname;
    }

    $fetch=fetch_column_from_array($recipients,'id');
//                $fetch[]=$dis_stoc->delivered_to_id;
    $device_token=PushNotificationToken::select('id','token')->wherein('user_id',$fetch)->get();
    if(count($device_token)>0){
                        // push notification send
        push_notification_send($dis_stoc->id,'New  Order',$body,fetch_column_from_array($device_token,'token'),'rsm_order');
    }
}
return API::response()->array(['success' => true,
    'message' => 'Stock Booking ',
    'data'    => $dis_stoc], 200);
}

} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}


public function saleProductwisewarehouse(Request $request){
    try {
        $userId = $this->getUserIdFromToken($request);

        $userrole = $this->getUserRole($userId);

        
        if($userrole == "super_admin" || $userrole == "admin"){
            $pro=Product::where('category_id',1)->get();
             
        }else{
            $pro=Product::where('category_id',1)->where('show_rsm',0)->get();
             
        }
       
        $obj=[];
            $bilty_id=$this->tenureBiltywarehouse($request->start_date,$request->end_date,$request->party_id,$request->rsm_id);


            $party_id=Bilti::select('id')->wherein('id',$bilty_id)->get()->toarray();

           
            foreach ($pro as $key=>$pr){
                $obj[$key]['id']= $pr['id'];
                $obj[$key]['name']= $pr['name'];
                $obj[$key]['cotton']= $pr['cotton'];
                $obj[$key]['quantity']=0;
    

                $bil=BiltiDetail::select(DB::raw('sum(quantity) as quantity,sum(payment) as payment'))
                ->wherein('bilti_id',$party_id)->where('product_id',$pr['id'])
                ->groupBy('product_id')
                ->first();

                if(!empty($bil) && !empty($bil['quantity'])){
                    $obj[$key]['quantity']=$bil['quantity'];

                }
            }



        


    return API::response()->array(['success' => true,
        'message' => 'Party Prices Details',
        'data'    => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
public function tenureBiltywarehouse($start,$end,$part_id=0,$rsm_id=0){
        //5000 shah filter

        //    $start    = $start . ' 00:00:00';
        //    $end=  $end . ' 00:00:00';
    $bil=Bilti::query();

    $bil=$bil->whereBetween('delivered_date', [$start, $end])->where('supplier_id','=',98)->get();
$bil_id=[];
if(!empty($bil)){

    foreach ($bil as $bi){
        $bil_id []=$bi['id'];
    }
}
return $bil_id;
}

public function getbilty_warehouse(Request $request)
{
    try {

            $bilty= Bilti::query();

              $bilty = $bilty->whereBetween('delivered_date', [$request->start_date, $request->end_date])->where('supplier_id', '=',98)->with(['party_info','customer_info','bilty_detail'=>function($query)
                {$query->with(['bilty_product',
                    'bilty_detail_type'=>function($query)
                    {$query->with(['productCategory'])->get();}])->get();},'bilty_supplier','bookBy'])->get();
          if($bilty){
            return API::response()->array(['success' => true, 'message' => 'All Bilty clone',
        'data' => $bilty], 200);

          }else{
            return API::response()->array(['success' => false, 'message' => 'not found'], 400);

          }       

    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Bilty clone',
        'data' => $bilty], 200);
}


public function deletebilityWarehouse(Request $request){

  try{

    $bilty = Bilti::where('id',$request->bilty_id)->where('po_no_warehouse','=',1)->first();

    if($bilty){
      foreach ($bilty->bilty_detail as $key => $biltydetail) {

       $warehouse  = WareHouse::where('active',1)->first();

       if($warehouse){

        $WarehouseStocks = WarehouseStocks::where('product_id',$biltydetail['product_id'])->where('warehouse_id',$warehouse->id)->first();

        if($WarehouseStocks){
         $WarehouseStocks->quantity   =  $WarehouseStocks->quantity + $biltydetail['quantity'];

         $WarehouseStocks->save();
       }

       $biltycatagorys = $biltydetail->bilty_detail_type;

       if($biltycatagorys){
        
        foreach ($biltycatagorys as $key => $biltycatagory) {

          $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$biltycatagory['product_category_id'])->first();
          if($warehousestockvariant){
           $warehousestockvariant->quantity  =  $warehousestockvariant->quantity + $biltycatagory['quantity'];


           $warehousestockvariant->save();
         }


         $biltycatagory->delete();

       }
     }


   }
 $biltydetail->delete();


 }
 
 UserExpenseDetail::where('detail_id', $request->bilty_id)->where('type','Warehouse_sale')->delete();
 $bilty->delete();
}else{

 return API::response()->array(['success' => false, 'message' => 'bilty not found'], 400);


}


return API::response()->array(['success' => true, 'message' => 'deleted successfully',
  'data' => $sub], 200);

}catch (Exception $e) {
  return API::response()->array(['success' => false,
    'message' => $e->getTraceAsString()], 400);
}
}

public function CalculateInvoice($product_id,$quantity,$type){
    switch ($type){
        case 'Distributor':
        $p= ProductPrice::where('product_id',$product_id)->first();
        if(!empty($p) && !empty($p->distributor_price)){
            return $p->distributor_price * $quantity;
        }
        break;
        default:
        return 0;
    }
}
public function CalculateExportInvoice($product_id,$quantity,$party_id){
    $p= PartyRates::where('product_id',$product_id)
    ->where('party_id',$party_id)->first();
    if(!empty($p)){
        return $p->price * $quantity;
    }else{
        return 0;
    }
}



}


