<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/



if (version_compare(PHP_VERSION, '7.2.0', '>=')) {
// Ignores notices and reports all other kinds... and warnings
    error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
// error_reporting(E_ALL ^ E_WARNING); // Maybe this is enough
}


$app->get('/', function () {
    return 'Hi, I am biocos API!!!!!!!!!!///';
});
$api = app('Dingo\Api\Routing\Router');
$api->version('v1', function ($api) {
    /***
     * Login Route
     */
    $api->post('/login', 'App\Http\Controllers\AuthController@login');
    $api->post('/change-password', 'App\Http\Controllers\AuthController@changePassword');
    /***
     * Register Route
     */
    $api->post('/register', 'App\Http\Controllers\AuthController@register');


    
    /***
     * Push notification detail
     */
    $api->post('/add-notification-detail', 'App\Http\Controllers\CustomerController@addnotificationDetail');
    /***
     * List jobs call
     */
    $api->get('/list-jobs', 'App\Http\Controllers\JobController@listJobs');
    /***
     * List region call
     */
    $api->get('/list-regions', 'App\Http\Controllers\RegionController@listRegions');
    
    $api->get('/list-regions-party', 'App\Http\Controllers\RegionController@listRegionsparty');
    
    $api->get('rsm-payment-biotech', 'App\Http\Controllers\TargetController@RSMpaymentbiotech');
    $api->get('rsm-po-biotech', 'App\Http\Controllers\TargetController@PObiotech');


 /***
     * Biotech call
     */

    $api->get('/biotech-add-po', 'App\Http\Controllers\BiotechControllerr@addpoNumber');
    $api->post('/biotech-products', 'App\Http\Controllers\BiotechController@listProducts');
    /***
     * List area call
     */
    $api->get('/list-areas', 'App\Http\Controllers\RegionController@listAreas');
    $api->post('/role-details', 'App\Http\Controllers\RegionController@roleDetails');
    /***
     * List Customer call
     */
    $api->get('/list-customers', 'App\Http\Controllers\CustomerController@listCustomers');
    /***
     * List products ADs
     */
    $api->get('/list-products', 'App\Http\Controllers\ProductController@listProducts');

    

    $api->post('/add-product', 'App\Http\Controllers\ProductController@InsertProduct');

    $api->post('/advrtsmnt-products', 'App\Http\Controllers\ProductController@advrtsmntProducts');
    /***
     * Get Product Details
     */
    $api->get('/product-details/{productId}', 'App\Http\Controllers\ProductController@productDetail');
    
     $api->post('/product_priority_set', 'App\Http\Controllers\ProductController@productpriorityset');
    /***
     * Get User details api call
     */
    $api->get('/user-info/{userId?}', 'App\Http\Controllers\UserController@userInfo');
    /// get users list ////
     $api->post('/users_list', 'App\Http\Controllers\UserController@userlists');
    
     $api->post('/partydead', 'App\Http\Controllers\UserController@party_dead');
    /***
     * Add Vendor 
     */
    $api->post('/add-new-vendor', 'App\Http\Controllers\UserController@addvendor');
    
     /***
     * Add Party
     */
     $api->post('/add-new-party', 'App\Http\Controllers\UserController@addparty');

    /***
     * Put Book or update order
     */
    $api->put('/book-update-order/{orderId?}', 'App\Http\Controllers\OrderController@bookOrUpdateOrder');
    /***
     * Put Book or update expense
     */
    $api->put('/book-update-expense/{expenseId?}', 'App\Http\Controllers\OrderController@bookOrUpdateExpense');
    $api->post('/add-adv-invoice/', 'App\Http\Controllers\OrderController@addAdvInvoice');
    /***
     * Put Book or update order
     */
    $api->put('/book-update-return-order/{orderId?}', 'App\Http\Controllers\OrderController@bookOrUpdateReturnOrder');
    /***
     * Put Update Bilty
     */
    $api->put('/update-bilty/{biltyId}', 'App\Http\Controllers\OrderController@updateBilty');
    /***
     * Get Order Details
     */
    $api->get('/order-details/{orderId}', 'App\Http\Controllers\OrderController@getOrderDetails');
    /***
     * Get SO Orders
     */
    $api->get('/so_orders/{soId}', 'App\Http\Controllers\OrderController@getSoOrders');
    /***
     * Get Countries
     */
    $api->get('/list-countries', 'App\Http\Controllers\OrderController@getCountries');
    /***
     * Add or Update Customer
     */
    $api->put('/add-update-customer/{customerId?}', 'App\Http\Controllers\CustomerController@addOrUpdateCustomer');
     /***
     * Add or Update Images
     */
     $api->put('/add-update-images', 'App\Http\Controllers\CustomerController@addOrUpdateImages');
    /***
     * Get Customer Details
     */
    $api->get('/customer-details/{customerId}', 'App\Http\Controllers\CustomerController@getCustomerDetails');
    /***
     * Add Display Images
     */

    $api->post('/add-display-images', 'App\Http\Controllers\CustomerController@addDisplayimages');
    $api->post('/get-display-image-detail', 'App\Http\Controllers\CustomerController@getDisplayimageDetail');
    /***
     * Add or Update Customer
     */
    $api->put('/add-update-region/{regionId?}', 'App\Http\Controllers\RegionController@addOrUpdateRegion');
    /***
     * List orders
     */
    $api->get('/list-orders', 'App\Http\Controllers\OrderController@listOrders');
    /***
     * Get Constants
     */
    $api->get('/get-constants', 'App\Http\Controllers\Controller@getConstants');
    /***
     * Update profile
     */
    $api->put('/update-profile/{userId}', 'App\Http\Controllers\UserController@updateProfile');

    $api->post('/update-profile-image', 'App\Http\Controllers\UserController@updateUserimage');

    
    /***
     * Update jobs order
     */
    $api->put('/update-jobs-order', 'App\Http\Controllers\JobController@updateJobsOrder');
    /***
     * Sync Data
     */
    $api->put('/sync-data', 'App\Http\Controllers\Controller@syncData');
    /***
     * Sync Images
     */
    $api->put('/sync-images', 'App\Http\Controllers\Controller@syncImages');
    /***
     * Shops Status
     */
    $api->post('/shop-status', 'App\Http\Controllers\CustomerController@shopStatus');
    /***
     * List distributer
     */
    $api->post('/list-distributer', 'App\Http\Controllers\CustomerController@listDistributer');
    /***
     * Shops Display Remarks
     */
    $api->post('/shop-display-remarks', 'App\Http\Controllers\CustomerController@shopDisplayRemarks');
    /***
     * Add or update payment received
     */
    $api->put('/add-update-payment-received', 'App\Http\Controllers\OrderController@addOrUpdatePaymentReceived');
    /***
     * Add or update payment received
     */
    $api->put('/add-update-feedback', 'App\Http\Controllers\OrderController@addOrUpdateFeedback');
    /***
     * Assign or Update Regions
     */
    $api->put('/assign-update-regions', 'App\Http\Controllers\RegionController@assignOrUpdateRegions');
    /***
     * Get SO Targets
     */
    $api->get('main-supplier', 'App\Http\Controllers\StockController@mainSupplier');
    /***
     * add-adda
     */
    $api->post('/add-adda', 'App\Http\Controllers\StockController@addAdda');
    $api->post('/get-adda', 'App\Http\Controllers\StockController@getAdda');
    /***
     * stock-bilty
     */
    $api->post('/stock_in', 'App\Http\Controllers\StockController@stockIn');
    $api->post('/stock_in_detail', 'App\Http\Controllers\StockController@stockInDetail');
    $api->post('/stock_previous', 'App\Http\Controllers\StockController@stockPrevious');
    $api->post('/outstanding_previous', 'App\Http\Controllers\StockController@outstandingPrevious');
    $api->post('/party_outstanding_previous', 'App\Http\Controllers\StockController@partyoutstandingPrevious');
    $api->post('/stock-bilty', 'App\Http\Controllers\StockController@stockBilty');
    /***
     * stock-booking
     */
    $api->post('/stock-booking-orders', 'App\Http\Controllers\StockController@stockBookingOrder');
    //// stock booking sale return update 
     
     $api->post('/stock-booking-orders-adjustment', 'App\Http\Controllers\StockController@stockBookingOrderAdjustment');
     $api->post('/stock-booking-orders-adv', 'App\Http\Controllers\StockController@stockBookingOrderadv');
      $api->post('/stock-adjustment-logs', 'App\Http\Controllers\StockController@logproductadjust');
     
     
    /***
     * stock-booking
     */
    $api->post('/stock-booking', 'App\Http\Controllers\StockController@stockBooking');
    $api->post('/stock-booking-update', 'App\Http\Controllers\StockController@stockbookingupdate');
    $api->post('/stock-booking-and-po-status-update', 'App\Http\Controllers\StockController@stockbookingandpostatusupdate');

    
    /***
     * add-po-number
     */
    $api->post('/add-po-number', 'App\Http\Controllers\StockController@addpoNumber');
    $api->post('/add-po-number-adv', 'App\Http\Controllers\StockController@addpoNumberAdv');
    
    $api->post('/add-po-number-raw', 'App\Http\Controllers\StockController@addpoNumberRaw');

    /***
     * dispatch_quantity
     */
    $api->post('/dispatch_quantity', 'App\Http\Controllers\StockController@dispatchQquantity');
    $api->post('/dispatch_quantity_raw', 'App\Http\Controllers\StockController@dispatchQquantityRaw');
    
    /***
     * dispatch_quantity
     */
    $api->post('/po_completed', 'App\Http\Controllers\StockController@PoCompleted');
    /***
     * dispatch_quantity
     */
    $api->post('/vendor_order', 'App\Http\Controllers\StockController@vendorOrder');
    $api->post('/vendor_invoices_payment_ledger', 'App\Http\Controllers\BiotechController@vendorBiotechLedger');
    
    $api->post('/party_detail', 'App\Http\Controllers\StockController@partyDetail');

    $api->post('/vendor_payment', 'App\Http\Controllers\StockController@vendorPayment');
    $api->post('/vendor_payment_reverse', 'App\Http\Controllers\StockController@vendorPaymentReverse');
    $api->post('/vendor_payment_range', 'App\Http\Controllers\StockController@vendorPaymentRange');
    $api->post('/vendor_payment_received', 'App\Http\Controllers\StockController@vendorPaymentReceived');
    $api->post('/ho_payments', 'App\Http\Controllers\StockController@HOPayment');
    $api->post('/ho_payments_complete', 'App\Http\Controllers\StockController@HOPaymentcomplete');
    $api->post('/ho_payments_range', 'App\Http\Controllers\StockController@HOPaymentrange');

    /***
     * dispatch_quantity
     */
    $api->post('/vendor_order_status', 'App\Http\Controllers\StockController@vendorOrderstatus');
    $api->post('/vendor_order_status_raw', 'App\Http\Controllers\StockController@vendorOrderstatusRaw');
    $api->post('/party_ledger', 'App\Http\Controllers\StockController@partyledger');
    $api->post('/party_recovery', 'App\Http\Controllers\StockController@partyRecovery');
    $api->post('/party_sale', 'App\Http\Controllers\StockController@partySale');
    $api->post('/party_price', 'App\Http\Controllers\StockController@partyPrice');
    $api->post('/sale_productwise', 'App\Http\Controllers\StockController@saleProductwise');
    $api->post('/rsm_party_sales_percentage', 'App\Http\Controllers\StockController@rsmpartysalespercentage');
    $api->post('/all_rsm_party_sales_percentage', 'App\Http\Controllers\StockController@allrsmpartysalespercentage');
    /*     12/27/2019   */

    $api->post('/monthly_rsm_party_sales_percentage', 'App\Http\Controllers\StockController@monthlyrsmpartysalespercentage');

    

    //// 17082020
       $api->post('/monthly_rsm_or_party_salespercentage', 'App\Http\Controllers\StockController@monthlyrsmorpartysalespercentage');
       
       $api->post('/monthly_rsm_or_party_sales_percentage_asm', 'App\Http\Controllers\StockController@monthlyrsmorpartysalespercentageasm');

    /*   */
    /* product sale monthly */
    $api->post('/monthly-product-sale-percentage', 'App\Http\Controllers\ProductController@monthlyproductsalepercentage');




    $api->post('/all_rsm_party_sales_percentage_with_export', 'App\Http\Controllers\StockController@allrsmpartysalespercentageExport');
    /***
     * Vendor_Sync
     */
    $api->post('/all_vendor_order', 'App\Http\Controllers\StockController@allvendorOrder');
    $api->post('/vendor_invoices', 'App\Http\Controllers\StockController@vendorInvoices');
    $api->post('/vendor_invoices_detail', 'App\Http\Controllers\StockController@vendorInvoicesDetail');
    $api->post('/vendor_approval', 'App\Http\Controllers\StockController@vendorApproval');
    $api->post('/vendor_Payment_approval', 'App\Http\Controllers\StockController@vendorPaymentApproval');
    $api->post('/vendor_invoice_approval', 'App\Http\Controllers\StockController@vendorinvoiceApproval');
    $api->post('/vendor_invoice_add', 'App\Http\Controllers\BiotechController@vendorAddInvoice');
    
    /***
     * dispatch_quantity
     */
    $api->post('/vendor_order_detail', 'App\Http\Controllers\StockController@vendorOrderDetail');
    $api->post('/vendor_order_detail_adv', 'App\Http\Controllers\StockController@vendorOrderDetailADV');
    $api->post('/vendor_order_detail_raw', 'App\Http\Controllers\StockController@vendorOrderDetailRaw');
    /***
     * stock-booking
     */
    $api->post('/stock-booking-cotton', 'App\Http\Controllers\StockController@stockBookingCotton');

    ///by type its dozen or cotton ///

     $api->post('/stock-booking-cotton-type', 'App\Http\Controllers\StockController@stockBookingCottonbytype');

    

    $api->post('/stock-booking-cotton-update', 'App\Http\Controllers\StockController@stockBookingCottonUpdate');

    $api->post('/stock-booking-return', 'App\Http\Controllers\StockController@stockReturnCotton');
    $api->post('/stock-booking-cancelled', 'App\Http\Controllers\StockController@stockBookingCancelled');
    $api->post('/stock-booking-adv', 'App\Http\Controllers\StockController@stockBookingAdv');
    $api->post('/stock-booking-raw', 'App\Http\Controllers\StockController@stockBookingRaw');
    $api->post('/update-stock-order-status', 'App\Http\Controllers\StockController@Updatestockorderstatus');
   
    /***
     * stock-booking
     */
    $api->post('/stock-booking-status', 'App\Http\Controllers\StockController@stockBookingStatus');
    /***
     * stock-booking
     */
    $api->post('/stock-booking-details', 'App\Http\Controllers\StockController@stockBookingDetail');
    $api->post('/stock-booking-details-raw', 'App\Http\Controllers\StockController@stockBookingDetailRaw');
    /***
     * distributer-stock
     */
    $api->post('/distributer-stock', 'App\Http\Controllers\StockController@distributerStock');
    /***
     * distributer-stock
     */

    $api->post('/distributer-stock-detail', 'App\Http\Controllers\StockController@getdistributerStock');
    
     $api->post('/get-rsm-party-stock', 'App\Http\Controllers\StockController@getrsmpartystock');

    
    /***
     * Get User regions
     */
    $api->get('list-user-regions', 'App\Http\Controllers\RegionController@listUserRegions');
    /***
     * Insert user locations
     */
    $api->put('/add-user-locations', 'App\Http\Controllers\UserController@addUserLocations');
    /****
     * List user locations
     */

    $api->get('list-user-locations', 'App\Http\Controllers\UserController@listUserLocations');
    /***
     * List payment received
     */
    $api->get('list-customer-payments', 'App\Http\Controllers\OrderController@listPaymentReceived');
    /***
     * Per Month product sales
     */
    $api->post('/product-sales', 'App\Http\Controllers\OrderController@salepermonth');
    /***
     * Per Month areas
     */
    $api->post('/areas-monthly', 'App\Http\Controllers\RegionController@areasPerMonth');
    /***
     * Updating areas
     */
    $api->post('/updating-areas', 'App\Http\Controllers\RegionController@updatingAreas');
    /***
     * order filter by customer or region
     */


    $api->post('/filter-order-pending', 'App\Http\Controllers\CustomerController@pending');
    
    $api->post('/filter-order', 'App\Http\Controllers\CustomerController@filterorder');

    $api->post('/filter-all-order', 'App\Http\Controllers\CustomerController@filterallorder');
    /***
     * Update Order Status Order
     */
    $api->post('update-order-status', 'App\Http\Controllers\OrderController@updateOrderStatus');
    /***
     * Update Order Status Order Sync
     */
    $api->post('update-order-status-sync', 'App\Http\Controllers\OrderController@updateOrderStatusSync');
    /***
     * Cancel Order Status Order
     */
    $api->post('status-order', 'App\Http\Controllers\OrderController@statusOrder');
    /****
     * Log no order API
     */
    $api->post('log-no-order', 'App\Http\Controllers\JobController@logNoOrder');
    /***
     * Log re-visit
     */
    $api->post('log-revisit', 'App\Http\Controllers\JobController@logRevisit');
    /***
     * Get user points
     */
    $api->get('user-points', 'App\Http\Controllers\TargetController@UserPoints');
    /***
     * Get user points
     */
    $api->post('get-user-points', 'App\Http\Controllers\TargetController@getUserPoints');
    /***
     * Get user points
     */
    $api->post('get-user-points-detail', 'App\Http\Controllers\TargetController@UserPointsDetail');
    $api->post('get-user-dozen-points-detail', 'App\Http\Controllers\TargetController@UserDozenPointsDetail');
    $api->post('get-user-points-details', 'App\Http\Controllers\TargetController@UserPointsDetails');
    $api->post('get-user-points-tenure', 'App\Http\Controllers\TargetController@UserPointsTenure');
    /***
     * Get Supplier SO
     */
    $api->post('supplier-so', 'App\Http\Controllers\OrderController@supplierSo');
    /***
     * Get Supplier SO Customers
     */
    $api->post('supplier-so-customers', 'App\Http\Controllers\OrderController@supplierSoCustomers');
    /***
     * Get Supplier SO Orders
     */
    $api->post('supplier-so-orders', 'App\Http\Controllers\OrderController@supplierSoOrders');
    /***
     * Get SO Orders Products
     */
    $api->post('so-orders-products', 'App\Http\Controllers\OrderController@soOrdersProducts');
    /***
     * Get SO Stock Products
     */
    $api->post('so-stock-products', 'App\Http\Controllers\OrderController@soStockProducts');
    $api->post('stock-booking-bilty-details', 'App\Http\Controllers\OrderController@BookingDetail');
    
    $api->post('stock-booking-bilty-details-raw', 'App\Http\Controllers\OrderController@BookingDetailRaw');
    /***
     * Get SO Stock Products
     */
    $api->post('so-product', 'App\Http\Controllers\OrderController@soProduct');
//    $api->post('so-orders-products-tenure', 'App\Http\Controllers\OrderController@soOrdersProductsTenure');
    /***
     * Get Supplier SO Payments
     */
    $api->post('supplier-so-payments', 'App\Http\Controllers\OrderController@supplierPayments');
    /***
     * Get SO Tenure Orders
     */
    $api->post('so-tenure-orders', 'App\Http\Controllers\OrderController@soTenureOrders');
    /***
     * Get SO Tenure Return Orders
     */
    $api->post('so-tenure-return-orders', 'App\Http\Controllers\OrderController@soTenureReturnOrders');
    /***
     * Get Customer Tenure Ledger
     */
    $api->post('customer-tenure-ledger', 'App\Http\Controllers\OrderController@customerTenureLedger');
    /***
     * Get Customer Tenure Orders
     */
    $api->post('customer-tenure-orders', 'App\Http\Controllers\OrderController@customerTenureOrders');
    /***
     * Get Customer Tenure Return Orders
     */
    $api->post('customer-tenure-return-orders', 'App\Http\Controllers\OrderController@customerTenureReturnOrders');
    /***
     * Get Customer Orders_id
     */
    $api->post('customer-orders-id', 'App\Http\Controllers\OrderController@customerOrdersId');
    /***
     * Get Customer Outstanding Balance
     */
    $api->post('customer-outstanding-balance', 'App\Http\Controllers\OrderController@customerOutstandingBalance');
    /***
     * Get Customer Tenure Recovery
     */
    $api->post('customer-tenure-recovery', 'App\Http\Controllers\OrderController@customerTenureRecovery');
    /***
     * Get Customer Pending Checks
     */
    $api->post('customer-pending-checks', 'App\Http\Controllers\OrderController@customerPendingChecks');
    /***
     * Testing Route
     */
    $api->post('testing-route', 'App\Http\Controllers\OrderController@testingRoute');

    $api->post('updatenew-rawmaterialquantity', 'App\Http\Controllers\RawMaterialController@updatenewrawmaterialquantity');

    $api->post('raw_material_image_update', 'App\Http\Controllers\RawMaterialController@RawMaterialImageUpdate');
    
    
    /***
     * Get SO Tenure Sale Recovery
     */
    $api->post('so-tenure-sale-recovery', 'App\Http\Controllers\OrderController@soTenureSaleRecovery');
    /***
     * /***
     * Get SO Tenure Sale Recovery
     */
    $api->post('so-tenure-sale-recovery-pk', 'App\Http\Controllers\OrderController@soTenureSaleRecoverypk');
    /***
     * Get SO Tenure Sale Recovery Expenses Checks
     */
    $api->post('so-tenure-sale-recovery-expenses-checks', 'App\Http\Controllers\OrderController@soTenureSaleRecoveryExpensesChecks');
    /***
     * Get SO Tenure Expense Recovery
     */
    $api->post('so-tenure-expense-recovery', 'App\Http\Controllers\OrderController@soTenureExpenseRecovery');
    $api->post('get-ledger', 'App\Http\Controllers\OrderController@getLedger');
    $api->put('checkexpense/{userexpenseID?}', 'App\Http\Controllers\OrderController@checkexpense');
    $api->post('get-ledger-adv', 'App\Http\Controllers\OrderController@getLedgeradv');
    $api->post('get-pettycash', 'App\Http\Controllers\OrderController@getPettyCash');
    /***
     * Get SO Tenure Sale Recovery
     */
    $api->post('so-tenure-expenses', 'App\Http\Controllers\OrderController@soTenureExpenses');
    /***
     * Get SO Tenure Expense Detail
     */
    $api->post('so-tenure-expense-detail', 'App\Http\Controllers\OrderController@soTenureExpenseDetail');
    /***
     * Get SO Tenure Expense wise Detail
     */
    $api->post('so-tenure-expense-wise-detail', 'App\Http\Controllers\OrderController@soTenureExpenseWiseDetail');
    /***
     * Get SO Payments Cheque
     */
    $api->post('so-payments-cheque', 'App\Http\Controllers\OrderController@soPaymentsCheque');
    /***
     * /***
     * Get SO Payments Cheque
     */
    $api->post('so-payments-cheque-pk', 'App\Http\Controllers\OrderController@soPaymentsChequePK');
    /***
     * Get SO Payments
     */
    $api->post('so-payments', 'App\Http\Controllers\OrderController@soPayments');
    $api->post('so-payments-detail', 'App\Http\Controllers\OrderController@soPaymentsDetail');
    /***
     * /***
     * Get SO Payments
     */
    $api->post('so-payments-pk', 'App\Http\Controllers\OrderController@soPaymentsPk');
    /***
     * Get SO Bilties
     */
    $api->post('so-bilties', 'App\Http\Controllers\OrderController@soBilties');
    $api->post('bilty-status', 'App\Http\Controllers\OrderController@BiltyStatus');
    /***
     * Get SO Bilty Detail
     */
    $api->post('so-bilty-detail', 'App\Http\Controllers\OrderController@soBiltyDetail');
    $api->post('so-bilty-detail-raw', 'App\Http\Controllers\OrderController@soBiltyDetailRaw');

    $api->post('add-bilty', 'App\Http\Controllers\OrderController@AddBilty');
    $api->post('delete-bilty', 'App\Http\Controllers\OrderController@deletebility');
    $api->post('delete-bilty-raw', 'App\Http\Controllers\OrderController@deletebilityraw');
    
    $api->post('add-bilty-adv', 'App\Http\Controllers\OrderController@AddBiltyAdv');
    
    $api->post('add-bilty-raw', 'App\Http\Controllers\OrderController@AddBiltyRaw');
    $api->post('add-bilty-raw-biotech', 'App\Http\Controllers\OrderController@AddBiltyRawBiotech');
    
    
    $api->post('modify-bilty', 'App\Http\Controllers\OrderController@modifyBilty');
    $api->post('add-bilty-invoice', 'App\Http\Controllers\OrderController@AddBiltyInvoice');

    $api->post('all-bilty', 'App\Http\Controllers\OrderController@AllBilty');
        $api->post('all-bilty-clone', 'App\Http\Controllers\OrderController@AllBiltyclone');

    $api->post('edit-bilty', 'App\Http\Controllers\OrderController@Edit_Bilty');

    $api->post('edit-bilty-product', 'App\Http\Controllers\OrderController@Edit_Bilty_Product');

    $api->post('get-productwise-bilties', 'App\Http\Controllers\OrderController@getproductwisebilties');
    

    
    $api->post('filter-bilty', 'App\Http\Controllers\OrderController@FilterBilty');
    $api->post('update-bilty-accountant', 'App\Http\Controllers\OrderController@FilterBiltyUpdateAccountant');
    $api->post('update-expense-accountant', 'App\Http\Controllers\OrderController@ExpenseAmountUpdateAccountant');

    $api->post('update-credit-accountant', 'App\Http\Controllers\OrderController@CreditAmountUpdateAccountant');
    $api->post('update-sale_return-accountant', 'App\Http\Controllers\OrderController@SaleReturnAmountUpdateAccountant');

    $api->post('all-bilty-adv', 'App\Http\Controllers\OrderController@AllBiltyAdv');
    $api->post('update-status-accountant', 'App\Http\Controllers\OrderController@PaymentStatusUpdateAccountant');
    $api->get('expense-issue-accountant', 'App\Http\Controllers\OrderController@ExpenseIssueAccountant');

    $api->get('vendor-invoices-accountant', 'App\Http\Controllers\OrderController@VendorInvoicesAccountant');

    $api->post('vendor-invoices-accountant-total', 'App\Http\Controllers\OrderController@VendorInvoicesAccountantTotal');



    $api->post('filter-rsm-payment', 'App\Http\Controllers\OrderController@FilterRsmPayment');
    $api->post('update-payment-vendor', 'App\Http\Controllers\TargetController@updatepayementvendor');
    /***
     * Get SO Product Bilty
     */
    $api->post('so-product-bilty', 'App\Http\Controllers\OrderController@soProductBilty');
    /***
     * Get SO Targets
     */
    $api->post('add-rsm-target', 'App\Http\Controllers\OrderController@addRsmTarget');
    $api->post('get-rsm-target', 'App\Http\Controllers\OrderController@getRsmTarget');
    $api->post('get-rsm-target-achieved', 'App\Http\Controllers\OrderController@getRsmTargetachieved');
    $api->post('modify-rsm-target-status', 'App\Http\Controllers\OrderController@modifyRsmTargetStatus');
    $api->post('modify-rsm-target-enddate', 'App\Http\Controllers\OrderController@modifyRsmTargetenddate');
    $api->post('so-targets', 'App\Http\Controllers\OrderController@soTargets');
    /***
     * Get SO Ordered Customers
     */
    $api->post('so-ordered-customers', 'App\Http\Controllers\OrderController@soOrderedCustomers');
    /***
     * Get SO Targets Product Wise
     */
    $api->post('so-targets-products', 'App\Http\Controllers\OrderController@soTargetsProducts');
    /***
     * Get SO Targets Customers
     */
    $api->post('so-targets-customers', 'App\Http\Controllers\OrderController@soTargetsCustomers');
    /***
     * Get SO Customers New Added
     */
    $api->post('so-customers-added', 'App\Http\Controllers\OrderController@soCustomersAdded');
    /***
     * Get Supplier SO Payments
     */
    $api->post('supplier-so-promises', 'App\Http\Controllers\OrderController@supplierSoPromises');
    /***
     * Get Supplier SO All Order
     */
    $api->post('supplier-so-all-order', 'App\Http\Controllers\OrderController@supplierSoAllOrder');
    /***
     * Update Promise Received
     */
    $api->put('/update-promise-received', 'App\Http\Controllers\OrderController@updatePromiseReceived');
    /***
     * Get Area Orders
     */
    $api->post('area-orders', 'App\Http\Controllers\OrderController@areaOrders');
    /***
     * Get SO Areas
     */
    $api->post('so-areas', 'App\Http\Controllers\OrderController@soAreas');
    /***
     * Get SO Deliver Products
     */
    $api->post('so-deliver-products', 'App\Http\Controllers\OrderController@soDeliverProducts');
    /***
     * Get SO Deliver Sample
     */
    $api->post('so-deliver-sample', 'App\Http\Controllers\OrderController@soDeliverSample');
    /***
     * Add Order Invoice Number
     */
    $api->post('add-invoice-number', 'App\Http\Controllers\OrderController@bookOrderInvoices');
    /***
     * Get Expense Types
     */

    $api->post('saleretuns', 'App\Http\Controllers\TargetController@salereturn');
    $api->post('debitnote', 'App\Http\Controllers\TargetController@debitnote');
    $api->post('creditnote', 'App\Http\Controllers\TargetController@creditnote');
    $api->put('editcreditnote/', 'App\Http\Controllers\TargetController@editcreditnote');
    $api->put('editpayment/', 'App\Http\Controllers\TargetController@editpayment');
    $api->post('fixitbalanceofvendor/', 'App\Http\Controllers\TargetController@Fixvendorbalance');

    $api->post('fixitbalanceofparty/', 'App\Http\Controllers\TargetController@Fixpartybalance');
    $api->post('approved_debitnote', 'App\Http\Controllers\TargetController@approvedDebitnote');

    $api->post('approved_salereturn', 'App\Http\Controllers\TargetController@approvedSaleReturn');

    $api->post('approved_creditnote', 'App\Http\Controllers\TargetController@approvedCreditnote');

     $api->post('removed_soul_creditnote', 'App\Http\Controllers\TargetController@removedsoulCreditnote');

    $api->post('cancelled_creditnote', 'App\Http\Controllers\TargetController@cancelledCreditnote');
    $api->post('expense-types', 'App\Http\Controllers\TargetController@expenseTypes');
    $api->get('admin-expense-detail', 'App\Http\Controllers\TargetController@adminexpenseDetail');
    ////
    $api->get('super-admin-expense-detail', 'App\Http\Controllers\TargetController@superadminexpenseDetail');
    

    $api->post('admin-expense-issue-update', 'App\Http\Controllers\TargetController@adminexpenseissueupdate');
    $api->get('accountant-credit-notes', 'App\Http\Controllers\TargetController@accountant_creditnote');
    $api->get('accountant-debit-notes', 'App\Http\Controllers\TargetController@accountant_debitnote');
    $api->post('accountant-sale-returns', 'App\Http\Controllers\TargetController@accountant_SaleReturn');
    
    $api->post('expense-detail', 'App\Http\Controllers\TargetController@expenseDetail');
    $api->post('get-expense-pending', 'App\Http\Controllers\OrderController@getExpensePending');
    $api->post('get-expense-issues', 'App\Http\Controllers\OrderController@getExpenseIssues');
    /***
     * Get product sales detail
     */
    $api->post('product-sales-detail', 'App\Http\Controllers\ProductController@productSalesDetail');
    $api->post('party-rates-updates', 'App\Http\Controllers\ProductController@partyratesupdates');
    $api->post('get-party-rates-updates', 'App\Http\Controllers\ProductController@getpartyratesupdates');
    $api->post('product-sales-detail-customer', 'App\Http\Controllers\ProductController@productSalesDetailCustomer');
    /***
     * Get Expense Types
     */
    $api->put('add-update-expense-type', 'App\Http\Controllers\TargetController@addOrUpdateExpenseType');

     /***
     * sub expense routes
     */
      $api->post('add-sub-expense', 'App\Http\Controllers\TargetController@addsubexpensehead');
      $api->post('get-sub-head-by-Expense-id', 'App\Http\Controllers\TargetController@GetSubExpenseHeadbyExpenseid');

      $api->post('edit-sub-expense', 'App\Http\Controllers\TargetController@editsubexpensehead');
      $api->post('edit-expense', 'App\Http\Controllers\TargetController@editexpense');
   
    

    /***
     * Test Email
     */
    /***
     * Get ASM Sale & Recovery
     */
    $api->post('asm-sale-recovery-pk', 'App\Http\Controllers\OrderController@AsmSaleRecoveryPk');
    /***
     * Get ASM Sale & Recovery
     */
    $api->post('asm-so-pending-cheque', 'App\Http\Controllers\OrderController@asmSoPendingCheque');
    /***
     * Get ASM Sale & Recovery
     */
    $api->post('asm-so-outstanding-balance', 'App\Http\Controllers\OrderController@AsmSo_Oustanding_balance');

    $api->post('rates_party', 'App\Http\Controllers\OrderController@Party_Rates');
    $api->post('Single_Party_Rates', 'App\Http\Controllers\OrderController@Single_Party_Rates');
    
    /***
     * Get rsm-asm-outstanding-balance
     */
    $api->post('rsm-asm-outstanding-balance', 'App\Http\Controllers\OrderController@Rsm_ASM_Oustanding_balance');
    /***
     * rsm-add-payment
     */
    $api->post('rsm-add-payment', 'App\Http\Controllers\TargetController@RSMAddPayment');
    
    $api->post('rsm-payment-set-to-zero', 'App\Http\Controllers\TargetController@rsmpaymentsettozero');
    

     $api->post('rsm-resend-payment', 'App\Http\Controllers\TargetController@RSmPaymentResend');

    
    $api->post('rsm-update-payment-party', 'App\Http\Controllers\TargetController@RSMupdatePaymentparty');
    $api->post('update-ceo-payment', 'App\Http\Controllers\TargetController@RSMCEOPayment');
    $api->post('rsm-payment-ceo', 'App\Http\Controllers\TargetController@RSMPaymentsCEO');
    
    $api->post('rsm-modify-payment', 'App\Http\Controllers\TargetController@RSMModifyPayment');
    $api->post('rsm-payment', 'App\Http\Controllers\TargetController@RSMPayment');
    $api->post('rsm-payment-partial', 'App\Http\Controllers\TargetController@RSMPaymentPartial');
    $api->post('rsm-payment-all', 'App\Http\Controllers\TargetController@RSMPaymentAll');
    $api->post('rsm-payment-partywise', 'App\Http\Controllers\TargetController@RSMPaymentPartywise');
    $api->post('vendor-payment-individual', 'App\Http\Controllers\TargetController@vendorPaymentPartywise');
    $api->post('rsm-payment-total', 'App\Http\Controllers\TargetController@RSMPaymentTotal');
    $api->post('rsm-payment-detail', 'App\Http\Controllers\TargetController@RSMPaymentDetail');

    $api->post('rsm-sales-partywise', 'App\Http\Controllers\TargetController@RSMSalesPartywise');
    $api->post('vendor-sales-individual', 'App\Http\Controllers\TargetController@vendorSalesPartywise');
    $api->post('rsm-sales-total', 'App\Http\Controllers\TargetController@RSMSalesTotal');
    $api->post('vendor-sales-total', 'App\Http\Controllers\TargetController@VendorsalesTotal');
    $api->post('export-sales-total', 'App\Http\Controllers\TargetController@ExportSalesTotal');
    $api->post('rsm-sales-total-2', 'App\Http\Controllers\TargetController@RSMSalesTotal2');
    /***
     * ASM Target
     */
    $api->post('rsm-target', 'App\Http\Controllers\TargetController@RSMTarget');
    /***
     * rsm-assign-target
     */
    $api->post('rsm-assign-target', 'App\Http\Controllers\TargetController@RSMAssignTarget');
    /***
     * rsm-all-target
     */
    $api->post('rsm-all-target', 'App\Http\Controllers\TargetController@RSMAllTarget');
    


     $api->post('show-rsm-target-with-party', 'App\Http\Controllers\TargetController@RSMAllTargetbypartyid');
    /***
     * RSM Users
     */
    $api->post('rsm-users', 'App\Http\Controllers\TargetController@RSMUser');
    /***
     * ASM Target
     */
    $api->post('asm-target', 'App\Http\Controllers\TargetController@ASMTarget');
    /***
     * ASM Target
     */
    $api->get('all-rsm', 'App\Http\Controllers\TargetController@AllRsm');
    $api->get('all-party', 'App\Http\Controllers\TargetController@AllParty');
    $api->post('party-sale-recovery', 'App\Http\Controllers\TargetController@AllPartysaleRecovery');
    $api->post('party-sale', 'App\Http\Controllers\TargetController@AllPartysale');
    $api->post('party-recovery', 'App\Http\Controllers\TargetController@AllPartyRecovery');

    $api->get('all-venodor', 'App\Http\Controllers\TargetController@allVenodor');

    $api->post('get-account', 'App\Http\Controllers\TargetController@getAccount');
    $api->post('modify-account-status', 'App\Http\Controllers\TargetController@modifyAccount');
    $api->post('add-account', 'App\Http\Controllers\TargetController@addAccount');
    
    
    
    
    /***
     * ASM Users
     */
    $api->post('asm-members', 'App\Http\Controllers\TargetController@ASMUser');
    /***
     * ASM Schedule
     */
    $api->post('visit-detail', 'App\Http\Controllers\TargetController@VisitDetail');
    
    $api->post('export-sales', 'App\Http\Controllers\RegionController@all_export_Regions');
    /***
     * ASM Schedule
     */
    $api->post('visit/{visitId?}', 'App\Http\Controllers\TargetController@Visit');
    $api->get('/all-region/{userid?}', 'App\Http\Controllers\RegionController@allRegions');
    $api->get('/all-export-region', 'App\Http\Controllers\RegionController@allexportRegions');

    /***
     * ASM Target
     */
    $api->post('asm-achieve-target', 'App\Http\Controllers\TargetController@ASM_AchieveTarget');
    /***
     * ASM Target
     */
    $api->post('rsm-with-asm-sales-recovery', 'App\Http\Controllers\TargetController@RSM_ASM_SAleRecovery');
    

    
    /***
     * BalanceRecorder
     */

    $api->post('add-customer-balance-recorder', 'App\Http\Controllers\BalanceRecorderController@addBalanceChange');
    $api->post('get-customer-balance-recorder', 'App\Http\Controllers\BalanceRecorderController@GetCutomerBalance');
    
    
      /***
     * Tags
     */
      $api->post('add-tags', 'App\Http\Controllers\OrderController@AddTags');
      $api->post('get-tags', 'App\Http\Controllers\OrderController@GetTags');

    /*

    
    */
    $api->post('expense-tags', 'App\Http\Controllers\OrderController@expensetags');

 /***
     * RawMaterial calls
     */
 $api->post('add-raw-materials', 'App\Http\Controllers\RawMaterialController@addRawMaterial');
 $api->post('add-raw-materials-invoice', 'App\Http\Controllers\RawMaterialController@addRawMaterialInvoice');
 $api->post('get-raw-materials', 'App\Http\Controllers\RawMaterialController@GetRawMaterial');
 $api->post('get-raw-materials-single', 'App\Http\Controllers\RawMaterialController@GetRawMaterialsingle');

 $api->post('/testingrecord', 'App\Http\Controllers\RawMaterialController@testingRoute');

 $api->post('/testinginvtory', 'App\Http\Controllers\RawMaterialController@testinginvtory');


 $api->post('raw-adjustment', 'App\Http\Controllers\RawMaterialController@rawadjustment');

 $api->post('get-raw-adjustment', 'App\Http\Controllers\RawMaterialController@getRawMaterialAdjustment');
 $api->post('update-raw-adjustment', 'App\Http\Controllers\RawMaterialController@updateRawMaterialAdjustment');



 $api->post('add-bundle', 'App\Http\Controllers\RawMaterialController@addbundle');
 $api->post('get-bundle', 'App\Http\Controllers\RawMaterialController@getbundle');
 $api->post('delete-bundle', 'App\Http\Controllers\RawMaterialController@destroybundle');
  $api->post('edit-bundle', 'App\Http\Controllers\RawMaterialController@editbundle');
 $api->post('add-product-bundle', 'App\Http\Controllers\RawMaterialController@addproductbundle');

 
/***
   * Inventory calls
   */
$api->post('inventory-detail', 'App\Http\Controllers\InventoryController@inventory_detail');



/***
     * Order without PO Count
     */

$api->get('get-orders-count-without-po', 'App\Http\Controllers\OrderController@getordercount');
/* accountant entry revers from bility table */
$api->post('accountant-entry-revers', 'App\Http\Controllers\OrderController@accountantentryrevers');

/* account bilities issue get */
$api->post('accountant-price-issue-bilties', 'App\Http\Controllers\OrderController@accountantpriceissuebilties');


 // $api->post('get-ledger', 'App\Http\Controllers\OrderController@getLedger');


    /***
     * Coupan Scheme
     */


    $api->post('add-coupan-scehme', 'App\Http\Controllers\TargetController@storecoupanscheme');
    $api->get('get-coupan-scehme', 'App\Http\Controllers\TargetController@getcoupanschemes');
    $api->post('get-coupan-scehme-targets', 'App\Http\Controllers\TargetController@getcoupanschemestargets');
    $api->post('get-coupan-scheme-rsm-targets', 'App\Http\Controllers\TargetController@getcoupanschemesrsmtargets');
    $api->post('get-coupan-scheme-rsm-targets-type', 'App\Http\Controllers\TargetController@getcoupanschemessinglersmtargetsbytype');
    
    $api->post('get-coupan-scheme-single-rsm-targets', 'App\Http\Controllers\TargetController@getcoupanschemessinglersmtargets');
    $api->post('get-coupan-schemes-single-rsm-targets-latest', 'App\Http\Controllers\TargetController@getcoupanschemessinglersmtargetslatest');

    
    $api->post('get-coupan-scheme-party-targets', 'App\Http\Controllers\TargetController@getcoupanschemespartytargets');
     /////18/3/2020///
    $api->post('get_asm', 'App\Http\Controllers\UserController@getasmuserregion');

     /////// asm routesss  subdristrubuter /////////
    $api->post('/add-asm-user', 'App\Http\Controllers\AuthController@addASMUser');

    $api->post('get_asm_in_rsm', 'App\Http\Controllers\TargetController@getasminrsm');

    $api->post('get_asm_in_rsm_without_token', 'App\Http\Controllers\TargetController@getasminrsmwithouttoken');
    $api->post('get_asm_in_party_without_token', 'App\Http\Controllers\TargetController@getasminpartywithouttoken');

     $api->post('get_asm_assigned_party', 'App\Http\Controllers\TargetController@getasmassignedparty');

    
    
    

    $api->post('add_sub_distributer', 'App\Http\Controllers\SubdistributerController@store');
    $api->post('show_all_subdistributer_by_rsm', 'App\Http\Controllers\SubdistributerController@showallsubdistributerbyrsm');
    $api->post('show_subdistributer_pending', 'App\Http\Controllers\SubdistributerController@showsubdistributerpending');
    
    $api->post('delete_sub_distributer', 'App\Http\Controllers\SubdistributerController@deletesubdistributer');

    $api->post('get_sub_distributer', 'App\Http\Controllers\SubdistributerController@getsubdistributer');
    
    $api->post('get_subdistributer_list', 'App\Http\Controllers\SubdistributerController@getsubdistributerlist');

    $api->post('stock_booking_cotton_asm', 'App\Http\Controllers\SubdistributerController@stockBookingCottonAsm');

    $api->post('stock_booking_order_asm', 'App\Http\Controllers\SubdistributerController@stockBookingOrderAsm');

    $api->post('booking-detail-order-asm', 'App\Http\Controllers\SubdistributerController@BookingDetailAsm');

    $api->post('add-ponumber-with-stockdetail', 'App\Http\Controllers\SubdistributerController@addpoNumberRSMwithStockdetail');

    $api->post('update-stockdetail-by-gm', 'App\Http\Controllers\SubdistributerController@updateStockdetailByGm');

    $api->post('sub-order-details', 'App\Http\Controllers\SubdistributerController@subOrderstatus');

    $api->post('add-bilty-by-distributer', 'App\Http\Controllers\SubdistributerController@AddBiltyasm');
    $api->post('delete-bility-asm', 'App\Http\Controllers\SubdistributerController@deletebilityasm');
    

    $api->post('vendor-order-detail-asm', 'App\Http\Controllers\SubdistributerController@vendorOrderDetailasm');
    $api->post('so-bilty-detail-asm', 'App\Http\Controllers\SubdistributerController@soBiltyDetailasm');

    $api->post('asm-add-payment', 'App\Http\Controllers\SubdistributerController@ASMAddPayment');

    $api->post('rsm-payment-detail-asm', 'App\Http\Controllers\SubdistributerController@RSMPaymentDetailasm');

   $api->post('asm-delete-payment', 'App\Http\Controllers\SubdistributerController@ASMdeletePayment');
    $api->post('get-delete-payment-log', 'App\Http\Controllers\SubdistributerController@GetDeletePaymentLog');

    $api->post('get-rsm', 'App\Http\Controllers\SubdistributerController@getrsm');


    $api->post('getrsm-with-souldistributer-info', 'App\Http\Controllers\SubdistributerController@getrsmwithsouldistributerinfo');


    $api->post('get-ledger-subdistributer', 'App\Http\Controllers\SubdistributerController@getLedgersubdistributer');
    $api->post('get-ledger-asm-or-rsm-subdistributer', 'App\Http\Controllers\SubdistributerController@getLedgerasmorrsm');


    $api->post('add-stock-product-distributer', 'App\Http\Controllers\SubdistributerController@addstockproductdistributer');

    $api->post('stock-product-adjustment', 'App\Http\Controllers\SubdistributerController@stockproductadjustment');
    $api->post('get-stock-by-party', 'App\Http\Controllers\SubdistributerController@getstockbyparty');

    $api->post('delete-order-by-asm', 'App\Http\Controllers\SubdistributerController@deleteorderbyasm');

    $api->post('get-partywise-stock-rsm', 'App\Http\Controllers\SubdistributerController@getPartywisestockrsm');

      /// ye wali api live kerna rehti hai abi  comment date 1may2020  ///  
    $api->post('transfer-payment', 'App\Http\Controllers\SubdistributerController@transferpayment');
//

     $api->post('get-dead-subdistributer', 'App\Http\Controllers\SubdistributerController@getdeadsubdistributer');

    $api->post('sales-total-asm-party', 'App\Http\Controllers\SubdistributerController@SalesTotalAsmParties');
    $api->post('asm-sales-partywise', 'App\Http\Controllers\SubdistributerController@ASMSalesPartywise');
    $api->post('asm-payment-partywise', 'App\Http\Controllers\SubdistributerController@ASMPaymentPartywise');



    $api->post('sales-total-rsm-asm-party', 'App\Http\Controllers\SubdistributerController@SalesTotalRsMAsmParties');
    $api->post('get-ledger-souldistributer', 'App\Http\Controllers\SubdistributerController@getLedgersouldistributer');

//// distributer expense///

    $api->put('/add-update-expense/distributer/{expenseId?}', 'App\Http\Controllers\SubdistributerController@bookOrUpdateExpensesouldistributer');

    ///cash adjustment soul distributer ///

    
    $api->post('/cash-adjustment-souldistributer', 'App\Http\Controllers\SubdistributerController@cashadjustmentsouldistributer');

    $api->post('/cash-adjustment-souldistributer-images', 'App\Http\Controllers\SubdistributerController@cashadjustmentsouldistributerimages');
    

   $api->post('/get-cash-adjustment-log-by-id', 'App\Http\Controllers\SubdistributerController@cashadjustmentlogbyid');
    
    $api->post('/cash-transfer-to-admin', 'App\Http\Controllers\SubdistributerController@cashtransfertoadmin');
    
    

    

            //for ceo just ///
    $api->post('stock_booking_order_all_asm', 'App\Http\Controllers\SubdistributerController@stockBookingOrderallAsmforadmin');
       ///



  ///stockreturn subdistributer ////



    $api->post('stock-return-cotton-subdistributer', 'App\Http\Controllers\SubdistributerController@stockReturnCottonsubdistributer');
    $api->post('get_partywises_souldisributer_rsm', 'App\Http\Controllers\SubdistributerController@getPartywisessoudisributerrsm');
    $api->post('get_partywises_souldisributer_rsms', 'App\Http\Controllers\SubdistributerController@getPartywisessoudisributerrsms');
    
    $api->post('sale-return-order-Asm', 'App\Http\Controllers\SubdistributerController@salereturnOrderAsm');
    $api->post('all_rsm_asm_sale_recovery', 'App\Http\Controllers\SubdistributerController@AllrsmasmsaleRecovery');

    $api->post('all_sub_party_sale', 'App\Http\Controllers\SubdistributerController@AllSubPartysale');

    $api->post('all_sub_party_recovery', 'App\Http\Controllers\SubdistributerController@AllSubPartyRecovery');

    $api->post('get_rsm_asm_subdistributer_detais', 'App\Http\Controllers\SubdistributerController@getrsmasmsubdistributer');

    $api->post('get-ledger-home-user', 'App\Http\Controllers\SubdistributerController@getLedgerhomeuser');

     $api->post('/set-monthly-expense', 'App\Http\Controllers\SubdistributerController@updatemonthlyexpensedistributer');

       $api->post('/set-vendor-ledger', 'App\Http\Controllers\SubdistributerController@vendorledgerset');
       
       $api->post('/subdistributer-update-ceo', 'App\Http\Controllers\SubdistributerController@subdistributerupdateceo');



       ////
  $api->post('get-all-asm', 'App\Http\Controllers\TargetController@getallasm');

  /////// 26082020 ////
  $api->post('get-list-all-asm', 'App\Http\Controllers\TargetController@getlistallasm');
  
   $api->post('get-list-all-dsf', 'App\Http\Controllers\AsmTargetController@getlistalldsf');
  ////

 $api->post('get-rsm-with-subdistributer-bilties', 'App\Http\Controllers\TargetController@getrsmwithsubdistributerbilties');

 $api->post('getrsm-in-asm-with-subdistributer-bilties', 'App\Http\Controllers\TargetController@getrsminasmwithsubdistributerbilties');

 $api->post('getasm-with-subdistributer-bilties', 'App\Http\Controllers\TargetController@getasmwithsubdistributerbilties');
 
 

$api->post('/monthly_asm_party_sales_percentage', 'App\Http\Controllers\TargetController@monthlyasmpartysalespercentage');



//cron job //
$api->post('/monthly-winner-rsm', 'App\Http\Controllers\SubdistributerController@monthlywinnerrsm');

$api->post('/monthly-winner-asm', 'App\Http\Controllers\SubdistributerController@monthlywinnerasm');



$api->post('/bility-reverse', 'App\Http\Controllers\SubdistributerController@bilityreverse');

$api->post('/monthly-record-sale-recovery-points', 'App\Http\Controllers\SubdistributerController@monthlyrecordsalerecoverypoints');



/////point system //////

$api->post('/add-product-point', 'App\Http\Controllers\PointSystemController@addproductspoints');
$api->post('/add-product-point-all-asm', 'App\Http\Controllers\PointSystemController@addproductspointstoallasm');


$api->post('/monthly-products-list', 'App\Http\Controllers\PointSystemController@monthlyproductslist');

$api->post('/monthly-product-detail-with-log', 'App\Http\Controllers\PointSystemController@monthlyproductdetailwithlog');

$api->post('/get-product-point-by-user', 'App\Http\Controllers\PointSystemController@getproductspointsbyuserid');
$api->post('/get-product-point-by-id', 'App\Http\Controllers\PointSystemController@getproductspointsbyid');

$api->post('/edit-product-point', 'App\Http\Controllers\PointSystemController@editproductspoints');
$api->post('/delete-product-point', 'App\Http\Controllers\PointSystemController@deleteproductspoints');
$api->post('/delete-monthly-product', 'App\Http\Controllers\PointSystemController@deletemonthlyproducts');

$api->post('/get-point-bility-asm', 'App\Http\Controllers\PointSystemController@getpointbilityasm');

$api->post('/get-point-bility-all-asm', 'App\Http\Controllers\PointSystemController@getpointbilityallasm');

$api->post('/monthly-product-active', 'App\Http\Controllers\PointSystemController@monthlyproductactive');

$api->post('/get-asm-points-productwise', 'App\Http\Controllers\PointSystemController@getasmpointsproductwise');

 $api->post('/monthly_product_priority', 'App\Http\Controllers\PointSystemController@monthlyproductpriority');
 $api->post('/update_point_status', 'App\Http\Controllers\PointSystemController@Updatepointstatus');
 
 $api->post('/show-point-status', 'App\Http\Controllers\PointSystemController@Showpointstatus');
  $api->post('/get-point-bility-asm-primary', 'App\Http\Controllers\PointSystemController@getpointbilityasmprimary');
$api->post('/get-point-bility-asms-primary', 'App\Http\Controllers\PointSystemController@getpointbilityasmsprimary');
$api->post('/get-point-bility-rsm-asms-primary', 'App\Http\Controllers\PointSystemController@getpointbilityrsmasmsprimary');


     


////warehouse module ////

$api->post('/add-ware-house', 'App\Http\Controllers\WareHouseController@addwarehouse');
$api->post('/get-warehouse', 'App\Http\Controllers\WareHouseController@getwarehouse');
$api->post('/get-warehouse-with-stock', 'App\Http\Controllers\WareHouseController@getwarehousewithstock');
$api->post('/add-bilty-warehouse', 'App\Http\Controllers\WareHouseController@AddBiltywarehouse');
//warehouse customers ///

$api->post('/add-warehouse-cutomer', 'App\Http\Controllers\WareHouseController@addwarehousecutomers');
$api->post('/edit-warehouse-cutomer', 'App\Http\Controllers\WareHouseController@editwarehousecutomers');
$api->post('/delete-warehouse-cutomer', 'App\Http\Controllers\WareHouseController@deletewarehousecutomers');
$api->post('/get-warehouse-cutomers', 'App\Http\Controllers\WareHouseController@getwarehousecutomers');

///STOCKBOOKING COTTON WAREHOUSE //


$api->post('/stock-booking-cotton-warehouse', 'App\Http\Controllers\WareHouseController@stockBookingCottonWarehouse');

$api->post('/sale-productwise-warehouse', 'App\Http\Controllers\WareHouseController@saleProductwisewarehouse');

$api->post('/get-bilty-warehouse', 'App\Http\Controllers\WareHouseController@getbilty_warehouse');


$api->post('/delete-bility-warehouse', 'App\Http\Controllers\WareHouseController@deletebilityWarehouse');

$api->post('/po-delay-remarks', 'App\Http\Controllers\TargetController@podelayremarks');

//// credit note subdistributer 14 12 2020 ///


$api->post('/add_creditnote_subdistributer', 'App\Http\Controllers\SubdistributerController@addcreditnotesubdistributer');
$api->post('/rsm_approve_creditnote_subdistributer', 'App\Http\Controllers\SubdistributerController@rsmapprovecreditnotesubdistributer');

$api->post('/show_creditnote_to_accountant', 'App\Http\Controllers\SubdistributerController@showcreditnotetoaccountant');

$api->post('/show_creditnote_to_rsm', 'App\Http\Controllers\SubdistributerController@showcreditnotetorsm');
$api->post('/approved_creditnote_subdistributer_by_accountant', 'App\Http\Controllers\SubdistributerController@approvecreditnotesubdistributer');

$api->post('/get_detail_credit_note', 'App\Http\Controllers\SubdistributerController@getdetailcreditnote');

//ceo //
$api->post('/show_creditnote_to_ceo', 'App\Http\Controllers\SubdistributerController@showcreditnotetoceo');
$api->post('/approvecredittoceo', 'App\Http\Controllers\SubdistributerController@approvecreditnotebyceo');


///debitnot to subdistributer ////


$api->post('/add_debitnote_subdistributer', 'App\Http\Controllers\SubdistributerController@adddebittnotesubdistributer');
$api->post('/show_debitnote_to_accountant', 'App\Http\Controllers\SubdistributerController@showdebitnotetoaccountant');

$api->post('/show_debitnote_to_rsm', 'App\Http\Controllers\SubdistributerController@showdebitnotetorsm');

//




///// dsf module ///// 

    $api->post('/add-dsf-user', 'App\Http\Controllers\AuthController@adddsfUser');


     $api->post('/get-dsf-list-by-asm-id', 'App\Http\Controllers\DsfController@getdsflistbyasmid');
      $api->post('/get-dsf-list', 'App\Http\Controllers\DsfController@getdsflist');
     // subdistributers opening stocks/// 

     $api->post('/Opening-Stock-Subdistributer', 'App\Http\Controllers\DsfController@OpeningStockSubdistributer');
     $api->post('/get-opening-stock-subdistributer', 'App\Http\Controllers\DsfController@GetOpeningStockSubdistributer');
     
     $api->post('/subdistributer-stock-report', 'App\Http\Controllers\DsfController@subdistributerstockreport');
     ////

     ///dsf areas ////
    $api->post('/add-or-update-dsf-areas', 'App\Http\Controllers\DsfController@addorupdatedsfareas');
    $api->post('/delete-dsf-areas', 'App\Http\Controllers\DsfController@deletedsfareas');
    $api->post('/get-dsf-areas', 'App\Http\Controllers\DsfController@getdsfareas');
    $api->post('/update-shop-dsf-and-area', 'App\Http\Controllers\DsfController@updateshopdsfandarea');
    ////

        //// dsf shops ////

    $api->post('/create_update_shop', 'App\Http\Controllers\DsfController@CreateUpdateShop');
    $api->post('/add_category_of_shops', 'App\Http\Controllers\DsfController@addcategoryofshops');
     $api->post('/get_dsf_shop_discount', 'App\Http\Controllers\DsfController@getdsfshopdiscount');
   
    $api->post('/list_shop_by_dsf', 'App\Http\Controllers\DsfController@ListShopbydsf');
    $api->post('/get_shop_orders_by_id', 'App\Http\Controllers\DsfController@getshopordersbyid');
    $api->post('/show_shop_detail', 'App\Http\Controllers\DsfController@Show_Shopdetail');
    $api->post('/delete_shop', 'App\Http\Controllers\DsfController@DeleteShop');

        //// booking stock dsf ///
    $api->post('/stock_booking_cotton_dsf', 'App\Http\Controllers\DsfController@stockBookingCottondsf');
     $api->post('/stock_booking_cotton_dsf_clone', 'App\Http\Controllers\DsfController@stockBookingCottondsfclone');
    $api->post('/edit_stock_booking_cotton_dsf', 'App\Http\Controllers\DsfController@editstockBookingCottondsf');
    $api->post('/delete_stock_booking_cotton_dsf', 'App\Http\Controllers\DsfController@deletestockBookingCottondsf');

    //just stock record show ///
    $api->post('/get-stock_booking_cotton_dsf', 'App\Http\Controllers\DsfController@getstockBookingCottondsf');
    
    /////just stock detail get not other obj get with this route ///
    
    $api->post('/get_stock_booking_cotton_dsf_stockdetail', 'App\Http\Controllers\DsfController@getstockBookingCottondsfstockdetail');
        /// stock record with all dsf info ///

    $api->post('/get_dsf_with_stock_orders', 'App\Http\Controllers\DsfController@getdsfwithstockorders');
    
     $api->post('/get_dsf_with_stock_orders_details', 'App\Http\Controllers\DsfController@getdsfwithstockorderswithdetails');
     
     $api->post('/dsf_sale_recovery', 'App\Http\Controllers\DsfController@dsfsaleRecovery');
     
     $api->post('/asm_sale_recovery', 'App\Http\Controllers\DsfController@AsmsaleRecovery');
     
      $api->post('/all_dsf_sale_recovery', 'App\Http\Controllers\DsfController@alldsfsaleRecovery');  /// new 

    
    /// dsf shops ledger ////
    
     $api->post('/get-total-shop-ledger', 'App\Http\Controllers\DsfController@gettotalshopsledger');
     $api->post('/get-total-single-shop-ledger', 'App\Http\Controllers\DsfController@gettotalsingleshopsledger');  
     
     $api->post('/get-shop-order-by-shop-id', 'App\Http\Controllers\DsfController@getshoporderbyshopid'); 
     
    //$api->post('/stock-return-cotton-dsf', 'App\Http\Controllers\DsfController@stockReturnCottonDsf');

    $api->post('/add-bilty-dsf', 'App\Http\Controllers\DsfController@AddBiltydsf');
     $api->post('/check-dsf-bilty', 'App\Http\Controllers\DsfController@checkdsfbilty');
     $api->post('/check-all-dsf-bilty', 'App\Http\Controllers\DsfController@checkalldsfbilty');
    $api->post('/get-ledger-dsf', 'App\Http\Controllers\DsfController@getLedgerdsf');
    $api->post('/delete-bility-dsf', 'App\Http\Controllers\DsfController@deletebilitydsf');
    $api->post('/approved-bilty-by-asm', 'App\Http\Controllers\DsfController@approvedbiltybyasm'); 
    $api->post('/get-asm-with-dsf-bilties', 'App\Http\Controllers\DsfController@getasmwithdsfbilties');
    $api->post('/get-dsf-with-bilties', 'App\Http\Controllers\DsfController@getdsfwithbilties');
    
     $api->post('/edit-bilty-dsf', 'App\Http\Controllers\DsfController@Editbiltydsf');
       
           $api->post('/get_subdistributer_shop_total_month_sale','App\Http\Controllers\DsfController@getsubdistributershoptotalmonthsale');
      
            $api->post('/get_dead_shops','App\Http\Controllers\DsfController@getdeadshops');


    
    ///book ordr for shops by asm //////

        $api->post('/stock_booking_cotton_shop_by_asm','App\Http\Controllers\DsfController@stockBookingCottonasmshop');
    ////// ase module /////

      $api->post('/get-subdistributer-by-ase', 'App\Http\Controllers\AseController@getsubdistributerbyase');
      $api->post('/add-or-update-ase-areas', 'App\Http\Controllers\AseController@addorupdateaseareas');
        $api->post('/get-area-ase', 'App\Http\Controllers\AseController@getaseareas');
         $api->post('/create-update-shop-ase', 'App\Http\Controllers\AseController@CreateUpdateShopAse');
          $api->post('/list-shop-by-ase', 'App\Http\Controllers\AseController@ListShopbyase');
          $api->post('/all-subdistributers-areas-with-shops-by-ase', 'App\Http\Controllers\AseController@allsubdistributersareaswithshopsbyase');
          
          //////// ase visits to sudistributer /////////
    $api->post('/add-visit-opening-stock-status', 'App\Http\Controllers\AseController@addvisitopeningstockstatus');
    $api->post('/add-opening-stock-subdistributer', 'App\Http\Controllers\AseController@addopeningstocksubdistributer');
    $api->post('/get-visit-opening-stock-status', 'App\Http\Controllers\AseController@getvisitopeningstockstatus');
    $api->post('/check-visit-opening-stock-status', 'App\Http\Controllers\AseController@checkvisitopeningstockstatus');
     
     $api->post('/stock-booking-cotton-ase', 'App\Http\Controllers\AseController@stockBookingCottonase');
     
          $api->post('/get-stock-booking-cotton-ase-stockdetail', 'App\Http\Controllers\AseController@getstockBookingCottonasestockdetail');
      
     $api->post('/get-sdvisitopening-stock-by-ase', 'App\Http\Controllers\AseController@Getsdvisitopeningstockbyase');
      
     $api->post('/get-shop-stockdetails-by-ase', 'App\Http\Controllers\AseController@Getshopstockdetailsbyase');

       $api->post('/update-points-ase', 'App\Http\Controllers\AseController@updatepoints');
      
$api->post('/monthly_ase_or_party_salespercentage','App\Http\Controllers\AseController@monthlyaseorpartysalespercentage');

 $api->post('/get_list_all_ase', 'App\Http\Controllers\AseController@getlistallase'); 
      
      $api->post('/Ase_sale', 'App\Http\Controllers\AseController@Asesale');
      
     $api->post('/get_user_point_trails', 'App\Http\Controllers\AseController@getuserpointtrails'); 

    $api->post('/update_ase_subditributer', 'App\Http\Controllers\AseController@updateasesubditributer');
    
   ////// wallet system /////

      $api->post('/add-reward-point-lists', 'App\Http\Controllers\WalletSystemController@addrewardpointlists');
      
       $api->post('/get-reward-point', 'App\Http\Controllers\WalletSystemController@getpointreward');

      $api->post('/delete-reward-point-lists', 'App\Http\Controllers\WalletSystemController@deleterewardpointlists');
        
        $api->post('/edit-reward-point', 'App\Http\Controllers\WalletSystemController@editpointreward');

      //////
    
    
    //usman Api
    
    $api->post('get_attendance_by_date_dsf', 'App\Http\Controllers\UserAttendanceController@getattendancebydatedsf');
    $api->post('add_dsf_expenses', 'App\Http\Controllers\DsfController@storedsfexpenses');
     $api->post('getvouchers', 'App\Http\Controllers\VouchersystemController@getvouchers'); 
      $api->post('create-vouchers', 'App\Http\Controllers\VouchersystemController@createvoucher'); 
     
      $api->post('get-voucher-orders', 'App\Http\Controllers\VouchersystemController@getorders');
        $api->post('store-return-recovery', 'App\Http\Controllers\VouchersystemController@storereturn');
          $api->post('shop-openning-balance', 'App\Http\Controllers\VouchersystemController@openningBalance');
           $api->post('asm-get-vouchers', 'App\Http\Controllers\VouchersystemController@asmgetvouchers');
            $api->post('get-voucher-orders-byasm', 'App\Http\Controllers\VouchersystemController@getordersofdsfbyasm');
             $api->post('asm-change-voucher-status', 'App\Http\Controllers\VouchersystemController@changestatus');
              
              $api->post('shop-credit-note', 'App\Http\Controllers\VouchersystemController@creditnotestore');
                $api->post('shop-debit-note', 'App\Http\Controllers\VouchersystemController@debitnotestore');
                 $api->post('get-all-vouchers', 'App\Http\Controllers\VouchersystemController@getallvouchers');
                 $api->post('show-all-vouchers', 'App\Http\Controllers\VouchersystemController@showallvouchers');
                 $api->post('show-credit-note', 'App\Http\Controllers\VouchersystemController@showcreditnote');
                   $api->post('edit-dsf-voucher', 'App\Http\Controllers\VouchersystemController@editvoucher');
                     $api->post('get-voucher-images', 'App\Http\Controllers\VouchersystemController@getvouchersimages');
                     $api->post('asm-credit-status', 'App\Http\Controllers\VouchersystemController@asmcreditstatus');
                      $api->post('single-credit-note', 'App\Http\Controllers\VouchersystemController@singlecredit');
                      
                      
                      
    
    
    
    
    
    
    
      
      
      
     
     
    
///// ASM module(Zain) /////
$api->post('add_asm_attendance', 'App\Http\Controllers\UserAttendanceController@store'); 
$api->post('add_dsf_attendance', 'App\Http\Controllers\UserAttendanceController@storedsfattandance');
$api->post('check_dsf_attendance', 'App\Http\Controllers\UserAttendanceController@checkdsfattandances');
$api->post('get_asm_attendance', 'App\Http\Controllers\UserAttendanceController@getasmattendance');
$api->post('get_asm_attendance_detail', 'App\Http\Controllers\UserAttendanceController@getasmattendancedetail');
$api->post('get_dsf_attendance_details', 'App\Http\Controllers\UserAttendanceController@getdsfattendancedetaills');
$api->post('get_dsf_attendance_list', 'App\Http\Controllers\UserAttendanceController@getdsfattendancelist');


$api->post('get_dsf_attendance_detail', 'App\Http\Controllers\UserAttendanceController@getdsfattendancedetail');
$api->post('get_attendance_by_subdistributer', 'App\Http\Controllers\UserAttendanceController@getattendancebysubdistributer');
$api->post('get_attendance_by_date', 'App\Http\Controllers\UserAttendanceController@getattendancebydate');
$api->post('get_user_visits_expenses_types', 'App\Http\Controllers\UserAttendanceController@getuservisitsexpensestypes');
$api->post('get_user_visits_expenses_types_by_id', 'App\Http\Controllers\UserAttendanceController@getuservisitsexpensestypesbyid');
$api->post('add_user_attendance_expense_details', 'App\Http\Controllers\UserAttendanceController@adduserattendanceexpensedetails');
$api->post('get_user_attendance_expense_details_by_user', 'App\Http\Controllers\UserAttendanceController@getuserattendanceexpensedetailsbyuser');
$api->post('get_user_attendance_expense_details_by_id', 'App\Http\Controllers\UserAttendanceController@getuserattendanceexpensedetailsbyid');
$api->post('get_user_attendance_expense_details_by_head', 'App\Http\Controllers\UserAttendanceController@getuserattendanceexpensedetailsbyhead');
$api->post('get_all_user_attendance_expense_details_by_user', 'App\Http\Controllers\UserAttendanceController@getalluserattendanceexpensedetails');
$api->post('get_all_fixed_expense_by_user', 'App\Http\Controllers\UserAttendanceController@getUserFixedExpensesById');
$api->post('get_asm_by_distributors', 'App\Http\Controllers\UserAttendanceController@getAsmByDistributors');
$api->post('get_distributor_visit_detail', 'App\Http\Controllers\UserAttendanceController@GetDistributorVisitDetail');
$api->post('updatenumberofwhatsapp', 'App\Http\Controllers\SubdistributerController@updateNumbers');
$api->post('whatsapp-notification', 'App\Http\Controllers\UserAttendanceController@attendanceNotification');
$api->post('update-attendance', 'App\Http\Controllers\UserAttendanceController@updateAttendance');
$api->post('update-total-distance', 'App\Http\Controllers\UserAttendanceController@UpdateTotalDistance');
$api->post('update-holidays', 'App\Http\Controllers\UserAttendanceController@UpdateHolidays');
// ASE Attendance
$api->post('get_ase_attendance_detail', 'App\Http\Controllers\UserAttendanceController@getAseattendancedetaills');
$api->post('get_ase_attendance_by_date', 'App\Http\Controllers\UserAttendanceController@getaseattendancebydate');
// RSM Attendance
$api->post('get_rsm_attendance_detail', 'App\Http\Controllers\UserAttendanceController@getRSMattendancedetaills');
$api->post('get_rsm_attendance_by_date', 'App\Http\Controllers\UserAttendanceController@getrsmattendancebydate');
///////
///// DSF module(Zain) /////
$api->post('get-dfs-daily-sale-report', 'App\Http\Controllers\DsfController@getdsfwithstockorders');
/////
///// Subdistributor module(Zain) /////
$api->post('update-distributor-distance', 'App\Http\Controllers\UserAttendanceController@updateDistance');
/////
// ASM Targets (Zain)
$api->post('add-asm-target', 'App\Http\Controllers\AsmTargetController@addASMTarget');
$api->post('get-asm-by-partyid', 'App\Http\Controllers\AsmTargetController@getASMByPartyID');
$api->post('get-asm-by-partyid-and-sales-return', 'App\Http\Controllers\AsmTargetController@getASMByPartyIDAndSaleReturn');
$api->post('get-asm-sales-return', 'App\Http\Controllers\AsmTargetController@getASMSaleReturn');
$api->post('get-asm-sales-return-without-coupan-scheme', 'App\Http\Controllers\AsmTargetController@getASMSaleReturnWithOutCoupanScheme');
$api->post('add-distributor-target', 'App\Http\Controllers\AsmTargetController@addDistributorTarget');
$api->post('get-distributers-target-by-asmid-and-sales-return', 'App\Http\Controllers\AsmTargetController@getDistributorTargetByASMidAndSaleReturn');
$api->post('get-distributers-target-and-sales-return', 'App\Http\Controllers\AsmTargetController@getDistributorTargetAndSaleReturn');
$api->post('get-distributers-target-with-dsf-by-asmid-and-sales-return', 'App\Http\Controllers\AsmTargetController@getDistributorTargetWithDSFByASMidAndSaleReturn');
// DSF Targets (Zain)
$api->post('get-dsf-target-by-id', 'App\Http\Controllers\AsmTargetController@getdsftargetbyid');
$api->post('get-dsf-sales-return-without-coupan-scheme', 'App\Http\Controllers\AsmTargetController@getDSFSaleReturnWithOutCoupanScheme');
// ASE Targets (Zain)
$api->post('get-subdistributors-by-ase-and-targets', 'App\Http\Controllers\AsmTargetController@getSubdistributorsByAseAndTargets');
// Team Expence (Zain)
$api->post('get-asm-team-expence', 'App\Http\Controllers\UserAttendanceController@getAsmTeamExpence');
$api->post('get-single-asm-team-expence', 'App\Http\Controllers\UserAttendanceController@getSingleAsmTeamExpence');
$api->post('get-subdistributer-by-rsm', 'App\Http\Controllers\UserAttendanceController@getsubdistributerbyrsm');
$api->post('get-subdistributer-ase', 'App\Http\Controllers\UserAttendanceController@getsubdistributerase');
// Stock Threshold (Zain)
$api->post('update-stock-threshold-by-party', 'App\Http\Controllers\SubdistributerController@UpdateStockThresholdByParty');
$api->post('vendor-pending-order-notification', 'App\Http\Controllers\StockController@VendorPendingOrderNotification');
$api->post('distributors-monthly-outstanding', 'App\Http\Controllers\SubdistributerController@DistributorsMonthlyOutstanding');
$api->post('out-of-stock-products-msg', 'App\Http\Controllers\SubdistributerController@OutOfStockProductsMsg');
$api->post('get-dead-subdistributer-by-asm', 'App\Http\Controllers\SubdistributerController@getdeadsubdistributerbyasm');
// Salary Approval Expenses (Zain)
$api->post('add-expense-for-approval', 'App\Http\Controllers\UserAttendanceController@addExpenseForApproval');
$api->post('ceo-attendance-approval-list', 'App\Http\Controllers\UserAttendanceController@CeoAttendanceApprovalList');
$api->post('attendance-approved-by-id', 'App\Http\Controllers\UserAttendanceController@AttendanceApprovedById');

// Target Report
$api->post('get-rsm-tree-targets', 'App\Http\Controllers\AsmTargetController@getrsmtreetargets');
$api->post('get-all-rsm-tree-targets', 'App\Http\Controllers\AsmTargetController@getallrsmtreetargets');
// Check User Holidays Report
$api->post('check-user-holiday', 'App\Http\Controllers\UserAttendanceController@CheckUserHoliday');


//// 17092020

     $api->post('/get-Recovery-Sale-Point-Record', 'App\Http\Controllers\SubdistributerController@getRecoverySalePointRecord');

     $api->post('/soul-user-stock-report', 'App\Http\Controllers\SubdistributerController@souluserstockreport');
      $api->post('/monthly_asm_or_party_salespercentage','App\Http\Controllers\SubdistributerController@monthlyasmorpartysalespercentage');

       $api->post('/stock_sub_sale_manage', 'App\Http\Controllers\SubdistributerController@stocksubsalemanage');

       
      $api->post('/sub-order-status-update', 'App\Http\Controllers\SubdistributerController@subOrderstatusupdate');
       
       
    
    ////**** test /////
    $api->post('test', 'App\Http\Controllers\OrderController@test');


       
    

     $api->post('/save-date-in-bility-detail', 'App\Http\Controllers\ProductController@savedateinbilitydetail');

    
    /***
     * Test Email
     */
    $api->post('/setledger', 'App\Http\Controllers\TargetController@setledger');
    $api->post('/salereturnasm', 'App\Http\Controllers\TargetController@salereturnasm');
    $api->post('mail_test', 'App\Http\Controllers\UserController@Mail');
     $api->post('/savedistributeridindsfshops', 'App\Http\Controllers\DsfController@savedistributeridindsfshops');
    $api->post('/savedistributeridindsfareas', 'App\Http\Controllers\DsfController@savedistributeridindsfareas');
    
    /***
     * Migrate Endpoint
     */
    $api->get('/migrate', function()
    {
        echo 'init with app tables migrations...';
        \Illuminate\Support\Facades\Artisan::call('migrate');
        echo 'done with app tables migrations';
    });
});