<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Database\Eloquent\SoftDeletes;
class Agency extends Model
{
    use SoftDeletes;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /***
     * List Agencies
     *
     * @return mixed
     */
    public function listAgencies(Request $request)
    {
        $data = $this::orderBy('id', 'Desc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('name', 'like', '%' . $request->search_name . '%');
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update Agency
     *
     * @return mixed
     */
    public function InsertOrUpdateAgency(Request $request,$id=0)
    {
        if($id>0){
            $agency=$this->findOrFail($id);
        }else{
            $agency=new $this();
        }
        $agency->name= $request->input('name');
        $agency->status = $request->status=='0' ? 0 : 1;
        if($agency->save()){
            return true;
        }else{
            return false;
        }
    }
}
