<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class Area extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /**
     * Get the City that owns the Area.
     */
    public function city()
    {
        return $this->belongsTo('App\Models\City')->with(['region'=>function($query){$query->with('country');}]);;
//        return $this->belongsTo('App\Models\City')->with(['region'=>function($query){$query->with('country');}]);
    }
    public function distributor()
    {
        return $this->belongsTo('App\Models\Customer','shop_id','id');
    }
    public function area_customers() {
        return $this->hasMany('App\Models\Customer','area_id');
    }
    public function orders() {
        return $this->hasMany('App\Models\Order','shop_id');
    }

//    public function area_customers() {
//        return $this->belongsToMany('App\Models\Customer','orders',
//            'booked_by','shop_id');
//
//    }
}
