<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Bilti extends Model
{
      protected $guarded = [ 'id' ];
    
    public function bilty_detail() {
        return $this->hasMany('App\Models\BiltiDetail','bilti_id','id');

    }
    public function bilty_supplier() {
        return $this->belongsTo('App\Models\User','supplier_id');

    }
    public function bookBy() {
        return $this->belongsTo('App\Models\User','delivered_to_id');

    }
  public function dsf_recovery() {
        return $this->belongsTo('App\Models\DsfPayment','id','bilti_id');

    }
    public function bilty_stock_order() {
        return $this->belongsTo('App\Models\StockBooking','stock_booking_id')->with(['party_info']);

    }
     public function bilty_asm_stock_order() {
        return $this->belongsTo('App\Models\StockBooking','stock_booking_id')->with(['subdistributer_info','Book_By']);

    }
     public function logs_remarks() {
        return $this->hasMany('App\Models\PaymentRemark','rsm_id','id')->with(['user_detail']);;
    }
    public function biltyImages() {
        return $this->hasMany('App\Models\BiltyImage','bilty_id','id');
    }
     public function Inventory_report() {
        return $this->hasMany('App\Models\InventoryReport','bilty_id','id');
    }
    public function party_info()
    {
        return $this->belongsTo('App\Models\PartyName', 'party_id');
    }
    public function customer_info()
    {
        return $this->belongsTo('App\Models\WarehouseCustomer', 'party_id');
    }
    public function subdistributer_info()
    {
        return $this->belongsTo('App\Models\Subdistributor', 'party_id');
    }
}
