<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class Expense extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /**
     * Get the Agency that owns the Area.
     */
    public function agency()
    {
        return $this->belongsTo('App\Agency');
    }
    public function sub_expenses()
    {
        return $this->hasMany('App\Models\SubExpense', 'expense_id');
    }
    /***
     * List Expense
     *
     * @return mixed
     */
    public function listExpense(Request $request)
    {
        $data = $this::orderBy('id', 'Desc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('name', 'like', '%' . $request->search_name . '%');
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update 
     *
     * @return mixed
     */
    public function InsertOrUpdate(Request $request,$id=0)
    {
        $new=true;
        if($id>0){
            $expense=$this->findOrFail($id);
            $new=false;
        }else{
            $expense=new $this();
        }
        $expense->name= $request->input('name');
        if($expense->save()){
            return true;
        }else{
            return false;
        }
    }
    /***
     * Add or Update Expense
     *
     * @param $expense
     * @return Model|null|static
     */
    public function addOrUpdateExpense($expense)
    {
        $expenseObj = new $this();
//        if(($expenseObj['id'] != 0)) {
//            $feedbackObj = $this->where('id', $feedback['id'])
//                ->first();
//            //Feedback not found
//            if(is_null($feedbackObj)) {
//                $feedbackObj = new   $this();
//                $feedbackObj->user_id     = $feedback['user_id'];
//            }
//        } else {
//            $feedbackObj->user_id     = $feedback['user_id'];
//        }
        $expenseObj->name           = $expense['name'];
        $expenseObj->agency_id           = $expense['agency_id'];
        $expenseObj->user_id           = $expense['user_id'];
        $expenseObj->country_id           = $expense['country_id'];
        $expenseObj->save();

        return $this->getExpenseDetails($expenseObj->id);
    }
    /***
     * Get Expense Details
     *
     * @param $id
     * @return mixed
     */
    public function getExpenseDetails($id)
    {
        return $this->where('id', $id)
            ->first();
    }
}
