<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Feedback extends Model
{
    /***
     * Add or Update Feedback
     *
     * @param $feedback
     * @return Model|null|static
     */
    public function addOrUpdateFeedback($feedback)
    {
        $feedbackObj = new $this();
        if(($feedback['id'] != 0)) {
            $feedbackObj = $this->where('id', $feedback['id'])
                ->first();
            //Feedback not found
            if(is_null($feedbackObj)) {
                $feedbackObj = new   $this();
                $feedbackObj->user_id     = $feedback['user_id'];
            }
        } else {
            $feedbackObj->user_id     = $feedback['user_id'];
        }
        $feedbackObj->comments           = $feedback['comments'];
        $feedbackObj->save();

        return $this->getFeedbackDetails($feedbackObj->id);
    }
    /***
     * Get Feedback Details
     *
     * @param $id
     * @return mixed
     */
    public function getFeedbackDetails($id)
    {
        return $this->where('id', $id)
            ->first();
    }
}
