<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class OrderProduct extends Model
{
    public $timestamps = false;
    public $appends =['product_name'];
    public function order_product_category()
    {
        return $this->hasMany('App\Models\OrderProductCategory', 'order_product_id','id');
    }
    public function product()
    {
        return $this->belongsTo('App\Models\Product', 'product_id');
    }
    public function order_sales_points()
    {
        return $this->hasMany('App\Models\UserPoint', 'detail_id','order_id');
    }
    public function getProductNameAttribute()
    {
         $product=Product::where('id',$this->product_id)->first();
        if(!empty($product) ){
            return $product->name;
        }else{
            return "";
        }
    }
}
