<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
class PartyName extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /**
     * Get the Region that owns the City.
     */
    public function region()
    {
        return $this->belongsTo('App\Models\Region')->with('country');
    }
    public function soul_distributer() {
        return $this->belongsTo('App\Models\User','user_id','id')->with('so_stock');
    }
     public function soul_distributer_info() {
        return $this->belongsTo('App\Models\User','user_id','id');
    }

//   public function party_ledger()
//     {
//         return $this->hasMany('App\Models\UserExpenseDetail', 'party_id','id')->where('type','!=','Credit Note');
//     }

public function party_ledger()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'party_id','id' )->where('type','!=','Warehouse_sale')->where('type','!=','sub_credit_note')->where('type','!=','Debit Note')->where('type','!=','sub_sale_return')->where('type','!=','Sub_recovery')->where('type','!=','Sub_sale')->where('type','!=','Credit Note')->orwhere('type','=','Credit Note')->
        wherehas('user_expense',function($query1) {
                $query1->where('accountant_check_credit','!=','0')->where('status','Approved');
            })->orwhere('type','=','Debit Note')->
        wherehas('user_expense',function($query1) {
                $query1->where('accountant_check_credit','!=','0')->where('status','Approved');
 
            });
    }
    
public function parties_ledger()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'party_id','id');
    }
    
    public function party_ledger_credit()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'party_id','id')->where('type','=','Credit Note');
        
      
    }


    /***
     * List Cities
     *
     * @return mixed
     */
    public function listAll(Request $request)
    {
        $data = $this::orderBy('id', 'Desc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('name', 'like', '%' . $request->search_name . '%');
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update City
     *
     * @return mixed
     */
    public function InsertOrUpdate(Request $request,$id=0)
    {
        if($id>0){
            $city=$this->findOrFail($id);
        }else{
            $city=new $this();
        }

        $city->region_id= $request->input('region');
        $city->name= $request->input('name');
        $city->balance= $request->input('balance');
        if($city->save()){
            return true;
        }else{
            return false;
        }
    }
}
