<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Auth;
class ProductDiscount extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /***
     * List ProductDiscount
     *
     * @return mixed
     */
    public function listProductDiscount(Request $request)
    {
        $data = $this::where('agency_id',Auth::user()->agency_id)->orderBy('id', 'Asc');
        if ($request->search_name != '') {
            $data->where(function ($query) use ($request) {
                return $query
                    ->Where('grade', 'like', '%' . $request->search_name . '%')
                    ->orWhere('value',  $request->search_name );
            });
        }
        return $data->paginate(session()->get('site_settings')['results_per_page']);
    }
    /***
     * Insert/Update ProductDiscount
     *
     * @return mixed
     */
    public function InsertOrUpdateDiscounts(Request $request,$id=0)
    {
        if($id>0){
            $discount=$this->findOrFail($id);
        }else{
            $discount=new $this();
        }
        $discount->grade= $request->input('grade');
        $discount->agency_id =  Auth::user()->agency_id;
        $discount->value= $request->input('discount');
        if($discount->save()){
            return true;
        }else{
            return false;
        }
    }
}
