<?php
/**
 * Created by PhpStorm.
 * User: raza
 * Date: 10/21/17
 * Time: 11:33 PM
 */

namespace App\Models;

use Carbon\Carbon;
use DB;
use Illuminate\Database\Eloquent\Model;
use Zizaco\Entrust\EntrustRole;
class Role extends EntrustRole
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $table = 'roles';
    /***
     * @var array
     */
    protected $guarded = ['id'];
    /***
     * Timestamps does not exists
     *
     * @var bool
     */
    public $timestamps = false;
    // Append attribute
    protected $appends = [
        'permissions',
    ];

    public function getPermissionsAttribute()
    {
        return DB::table('permission_role')
            ->select('permission_role.*','permissions.name','permissions.display_name')
            ->where('role_id', $this->id)
            ->join('permissions', 'permissions.id', '=', 'permission_role.permission_id')
            ->get();
    }
}