<?php

namespace App\Models;

use Dingo\Api\Http\Request;
use Illuminate\Database\Eloquent\Model;

class RsmPayment extends Model
{
    public function payment_images() {
        return $this->hasMany('App\Models\RsmPaymentImage','rsm_payment_id','id');
    }
     public function payment_remarks() {
        return $this->hasMany('App\Models\PaymentRemark','rsm_id','id')->wherein('type',['payment_vendor_change,payment_date']);  
    }
    public function account_info()
    {
        return $this->belongsTo('App\Models\Account', 'account_id')->with(['bank_info']);
    }
    public function account_from_info()
    {
        return $this->belongsTo('App\Models\Account', 'account_from_id')->with(['bank_info']);
    }
    public function payment_by_info()
    {
        return $this->belongsTo('App\Models\User', 'payment_by');
    }
    public function received_by_info()
    {
        return $this->belongsTo('App\Models\User', 'received_by');
    }
    public function completed_by_info()
    {
        return $this->belongsTo('App\Models\User', 'completed_by');
    }
    public function payment_to_info()
    {
        return $this->belongsTo('App\Models\User', 'payment_to')->with(['vendor_details']);
    }
    public function party_info()
    {
        return $this->belongsTo('App\Models\PartyName', 'party_id');
    }
      public function subdistributer_info()
    {
        return $this->belongsTo('App\Models\Subdistributor', 'party_id');
    }

    public static function boot()
    {
        parent::boot();

        self::creating(function($model){

            // party ledger maintains for payment add on previous date
//            $party=PartyName::where('id',$model['party_id'])->first();
//            if($model['date']!=date('Y-m-d') && !empty($party)){
//                // Handle in case previous latest ledger exist
//                $previous_date_balance= UserExpenseDetail::where('party_id',$model['party_id'])
//                    ->whereNotBetween('date', [$model['date'], date('Y-m-d')])
//                    ->orderBy('date','DESC')
//                    ->first();
//                if(!empty($previous_date_balance)){
//                    $opening=$previous_date_balance->balance;
//                    $obj=UserExpenseDetail::where('party_id',$model['party_id'])
//                        ->whereBetween('date', [$model['date'], date('Y-m-d')])
//                        ->orderBy('date','ASC')
//                        ->get()->toarray();
//                    foreach ($obj as $key=>$item){
//                        $update=UserExpenseDetail::where('id',$item['id'])->first();
//
//                        if(!empty($update)){
//                            switch ($update['type']){
//                                case 'Sale':
//                                    $opening=$opening+$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Recovery':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Credit Note':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                            }
//                        }
////                        $update->save();
//                    }
//                    $party->balance=$opening;
//                    $party->save();
//                }
//                // Handle in case previous latest ledger not exist then party opening balance and ledger adjustment
//
//                if(empty($previous_date_balance)){
//                    $opening=$party->opening_balance;
//                    $obj=UserExpenseDetail::where('party_id',$model['party_id'])
//                        ->orderBy('date','ASC')
//                        ->get();
//                    foreach ($obj as $key=>$item){
//                        $update=UserExpenseDetail::where('id',$item['id'])->first();
//                        if(!empty($update)){
//                            switch ($update['type']){
//                                case 'Sale':
//                                    $opening=$opening+$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Recovery':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Credit Note':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                            }
//                        }
////                        $update->save();
//                    }
//                    $obj->balance=$opening;
//                    $obj->save();
//                }
//            }
        });

        self::created(function($model){
            // party ledger maintains for payment add on previous date
//            $party=PartyName::where('id',$model['party_id'])->first();
//            if($model['date']!=date('Y-m-d') && !empty($party)){
//                // Handle in case previous latest ledger not exist then party opening balance and ledger adjustment
//                if(empty($previous_date_balance)){
//                    $opening=$party->opening_balance;
//                    $obj=UserExpenseDetail::where('party_id',$model['party_id'])
//                        ->orderBy('date','ASC')
//                        ->get();
//                    foreach ($obj as $key=>$item){
//                        $update=UserExpenseDetail::where('id',$item['id'])->first();
//                        if(!empty($update)){
//                            switch ($update['type']){
//                                case 'Sale':
//                                    $opening=$opening+$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Recovery':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                                case 'Credit Note':
//                                    $opening=$opening-$update['amount'];
//                                    $update->balance=$opening;
//                                    $update->save();
//                                    break;
//                            }
//                        }
////                        $update->save();
//                    }
//                    $party->balance=$opening;
//                    $party->save();
//                }
//            }

        });

        self::updating(function($model){
            // ... code here
        });

        self::updated(function($model){
            // ... code here
        });

        self::deleting(function($model){
            // ... code here
        });

        self::deleted(function($model){
            // ... code here
        });
    }

}
