<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class SoStock extends Model
{
    public $appends =['product_name','cotton','subproduct_name','show_rsm'];
    public function stock_product() {
        return $this->belongsTo('App\Models\Product','product_id');
    }
    public function stock_product_category() {
        return $this->belongsTo('App\Models\ProductCategory','product_category_id');
    }
    
    public function getProductNameAttribute()
    {
        $product=Product::where('id',$this->product_id)->first();
        if(!empty($product) ){
            return $product->name;
        }else{
            return "";
        }
    }
    public function getShowRsmAttribute()
    {
        $product=Product::where('id',$this->product_id)->first();
        if(!empty($product) ){
            return $product->show_rsm;
        }else{
            return "";
        }
    }
     public function getSubproductNameAttribute()
    {
        $product=ProductCategory::where('id',$this->product_category_id)->first();
        if(!empty($product) ){
            return $product->name;
        }else{
            return "";
        }
    }
    public function getCottonAttribute()
    {
        $product=Product::where('id',$this->product_id)->first();
        if(!empty($product) ){
            return $product->cotton;
        }else{
            return "";
        }
    }
    
      public function stockimages() {
        return $this->hasMany('App\Models\StockImage','so_stock_id','so_id');
    }
}