<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class StockBooking extends Model
{
    public function stock_details() {
        return $this->hasMany('App\Models\StockBookingDetail','stock_booking_id','id')->with(['product'=>function($query){return $query->select('id','category_id','po_vendor_id','name','cotton');},'product_category']);
    }
    
    public function stock_details_without_product() {
        return $this->hasMany('App\Models\StockBookingDetail','stock_booking_id','id');
    }
    
    
     public function stock_details_raw() {
        return $this->hasMany('App\Models\StockBookingDetail','stock_booking_id','id')->with('product_raw');
            
           
    }
    
    public function order_no() {
        return $this->hasOne('App\Models\DsfBookingNumber','stock_booking_id','id');
    }
    
    public function stock_adda() {
        return $this->hasMany('App\Models\StockBookingAdda','stock_booking_id','id')->with(['adda_info','vendor_info']);
    }
     public function stockImages() {
        return $this->hasMany('App\Models\StockbookingImage','stock_booking_id','id');
    }
   
    public function stock_bilty() {
        return $this->hasMany('App\Models\Bilti','stock_booking_id','id')->with(['bilty_detail'=>function($query){return $query->with(['bilty_product','bilty_detail_type'=>function($query){return $query->with('productCategory');}]);},'bilty_supplier','biltyImages']);
    }
    
     public function stock_bilty_invoices() {
        return $this->hasMany('App\Models\Bilti','stock_booking_id','bilti_no')->with(['bilty_detail'=>function($query){return $query->with(['bilty_product','bilty_detail_type'=>function($query){return $query->with('productCategory');}]);},'bilty_supplier','biltyImages']);
    }
    
    
     public function stock_bilty_raw() {
        return $this->hasMany('App\Models\Bilti','stock_booking_id','id')->with(
            ['bilty_detail'=>function($query){return $query->with(['bilty_product_raw'])
            ;},'bilty_supplier','biltyImages']);
    }
    
    
    public function Book_By()
    {
        return $this->belongsTo('App\Models\User', 'booked_by');
    }
    ////
    public function Booked_By()
    {
        return $this->belongsTo('App\Models\User', 'booked_by')->with('party_info_with_soul','Subdistributor_info');
    }
    ////
    public function BookTo()
    {
        return $this->belongsTo('App\Models\User', 'booked_to');
    }
    
    public function Bilty_Adda()
    {
        return $this->belongsTo('App\Models\BiltyAdda', 'bilty_adda_id','id');
    }

    public function po_numbers() {
        return $this->hasMany('App\Models\PoNumber','stock_booking_id','id');
    }
    public function party_info()
    {
        return $this->belongsTo('App\Models\PartyName', 'party_id');
    }
    public function shop_info()
    {
        return $this->belongsTo('App\Models\DsfShop', 'party_id')->with('shop_images','area','shops_discounts');
    }
     public function subdistributer_info()
    {
        return $this->belongsTo('App\Models\Subdistributor', 'party_id');
    }
     public function stock_logs() {
       return $this->hasMany('App\Models\PaymentRemark','rsm_id','id')->where('type','stock_po_status_log');

    }
}
