<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class StockBookingDetail extends Model
{
    protected $appends = ['is_po'];
    public function product()
    {
        return $this->belongsTo('App\Models\Product', 'product_id')->with('productPrice');
    }
    public function bookingStatus()
    {
        return $this->belongsTo('App\Models\StockBooking', 'stock_booking_id', 'id')->where('status','Booked')->orwhere('status','Delivered')->where('party_check','Null');
    }
     public function product_raw()
    {
        return $this->belongsTo('App\Models\RawMaterial', 'product_id')->with('raw_product_vendors');
    }
    
    public function product_category() {
        return $this->hasMany('App\Models\StockBookingDetailCategory','stock_booking_detail_id','id')->with(['product'=>function($query){return $query->select('id','name');}]);
    }
    public function getispoattribute()
    {
        $ret=false;
        $obj=PoNumber::where('stock_booking_id',$this->stock_booking_id)->get();
        if(empty($obj)){
            return $ret;
        }else{
            foreach ($obj as $ob){
                if (in_array($this->product_id, vendorProduct($ob['user_id'])))
                {
                    $ret= true;
                    break;
                }
            }
        }
        return $ret;
    }
}
