<?php
namespace App\Models;
use Illuminate\Database\Eloquent\Model;

class Subdistributor extends Model
{
     protected $guarded = [ 'id' ];
    
     protected $table = 'sub_distributors';
     
   public function subdistributerTarget() {
        return $this->belongsTo('App\Models\DistributorTarget','id','sub_distributor_id');

    }
   public function party() {
        return $this->belongsTo('App\Models\PartyName','party_id','id');

    }
       public function rsm_info() {
        return $this->belongsTo('App\Models\User','rsm_id','id');

    }
    public function asm_info() {
        return $this->belongsTo('App\Models\User','asm_id','id');

    }
    public function ase_info() {
        return $this->belongsTo('App\Models\User','ase_id','id');

    }
     public function users()
    {
        return $this->hasMany('App\Models\User', 'subdistributer_id');
    }
    public function asm_attendance_by_subdistributer() {
        return $this->hasMany('App\Models\UserVisit','sub_distributer_id','id');

    }
    public function getrecoverybydistributer() {
        return $this->hasMany('App\Models\RsmPayment','sub_id','id');

    }
      public function ledger()
    {
        return $this->hasMany('App\Models\UserExpenseDetailsledger', 'party_id');
    }
    public function areas()
    {
        return $this->hasMany('App\Models\DsfArea', 'sub_id','id');
    }
     public function bilty()
    {
        return $this->hasMany('App\Models\Bilti', 'party_id')->where('po_no_rsm','!=',0);
    }
  public function addOrUpdateExpense($expense,$expenseId = 0)
    {
        $giveUserPoints = true;
        $userPointsModel = new UserPoint();

     
       
        $expenseObj = new UserExpense();

        if (!empty($expense['expense_id'])&& $expense['expense_id']!=0) {
            $expenseObj = UserExpense::where('id', $expense['expense_id'])
                ->first();

            // for credit note only  amount update
            if((!empty($expense['id']))&&(($expense['id']==71) || ($expense['id']==82))){
                $expenseObj->amount = $expense['amount'];
                $expenseObj->status = 'Pending';
            }

            $giveUserPoints = false;
            //Expense not found
            if (is_null($expenseObj)) {
                return $expenseObj;
            }
        }

        if ( $expense['expense_id']==0) {
          
            if($expense['amount'] != 0) {
                $expenseObj->uuid = $expense['uuid'];
                $expenseObj->user_id = $expense['user_id'];
                $expenseObj->expense_id = $expense['id'];
                 $expenseObj->sub_expense_id = $expense['sub_expense_id'];
                if(!empty($expense['account_from_id'])){
                    $expenseObj->account_from_id = $expense['account_from_id'];
                }
                if(!empty($expense['account_to_id'])){
                    $expenseObj->account_to_id = $expense['account_to_id'];
                }

                $expenseObj->amount = $expense['amount'];
                $expenseObj->date = $expense['date'];
                $expenseObj->saller_name = $expense['saller_name'];
                $expenseObj->saller_phone_no = $expense['saller_phone_no'];
                $expenseObj->invoice_no = $expense['invoice_no'];
                $expenseObj->remarks = $expense['remarks'];
               if($expense['id'] == 0 || $expense['sub_expense_id'] == 0){

                return 'false';
              }
              $expenseObj->save();

              ///create reccord in user expense detail tabel for expense tabel//
             
                    $userExpenseObj = new UserExpenseDetail();
                    $userExpenseObj->detail_id=$expenseObj->id;
                    if (array_key_exists('type', $expense)) {
                        $userExpenseObj->type = $expense['type'];
                    } else {
                        $userExpenseObj->type = 'Expense';
                    }
                    $user = User::where('id', $expense['user_id'])->first();
                    
                    $old_balance = $user['balance'];
                    $new_balance = $expense['amount'];

                    if(!empty($expense['type']) && $expense['type']=='Recovery'){
                        $total_balance = $old_balance + $new_balance;
                        User::where('id', $expense['user_id'])->update(array('balance' => $total_balance));
                    }else{
                        $total_balance = $old_balance - $new_balance;
                        User::where('id', $expense['user_id'])->update(array('balance' => $total_balance));
                    }
                    $userExpenseObj->user_id = $expense['user_id'];
                    $userExpenseObj->vendor_id = $expense['user_id'];
                    $userExpenseObj->balance = $total_balance;
                    $userExpenseObj->amount = $expense['amount'];
                    $userExpenseObj->date = $expense['date'];
                    $userExpenseObj->save();
                    $Role = User::find($expense['user_id'] )->roles->first()->name;

                    if( $Role == 'personal_account' ){
                        /// if role is personal account then also subtract the balance from super user//
                        $useridsuperadmin = 9;
                         $userExpenseObj = new UserExpenseDetail();
                     
                    $userExpenseObj->detail_id=$expenseObj->id;
                     $user = User::where('id', $useridsuperadmin)->first();
                      $old_balance = $user['balance'];
                    $new_balance = $expense['amount'];
                    if(!empty($expense['type']) && $expense['type']=='Recovery'){
                        $total_balance = $old_balance + $new_balance;
                        User::where('id', $useridsuperadmin)->update(array('balance' => $total_balance));
                    }else{
                        $total_balance = $old_balance - $new_balance;
                        User::where('id', $useridsuperadmin)->update(array('balance' => $total_balance));
                    }
                    $userExpenseObj->user_id = $useridsuperadmin;
                    $userExpenseObj->vendor_id = $useridsuperadmin;
                    $userExpenseObj->balance = $total_balance;
                     $userExpenseObj->type = 'Expense';
                    $userExpenseObj->amount = $expense['amount'];
                    $userExpenseObj->date = $expense['date'];
                    $userExpenseObj->save();

                     }
                     if( $Role == 'super_admin'){
                        /// if role is super admin then also subtract the balance from personal account//

                           $personal_user=User::whereHas('roles', function($query) {
                                    $query->where('name', '=', 'personal_account');
                              })->first();

                         $userExpenseObj = new UserExpenseDetail();
                      
                    $userExpenseObj->detail_id=$expenseObj->id;
                     $user = User::where('id', $personal_user->id)->first();
                      $old_balance = $user['balance'];
                    $new_balance = $expense['amount'];
                    if(!empty($expense['type']) && $expense['type']=='Recovery'){
                        $total_balance = $old_balance + $new_balance;
                        User::where('id', $personal_user->id)->update(array('balance' => $total_balance));
                    }else{
                        $total_balance = $old_balance - $new_balance;
                        User::where('id', $personal_user->id)->update(array('balance' => $total_balance));
                    }
                    $userExpenseObj->user_id = $personal_user->id;
                    $userExpenseObj->vendor_id = $personal_user->id;
                    $userExpenseObj->balance = $total_balance;
                     $userExpenseObj->type = 'Expense';
                    $userExpenseObj->amount = $expense['amount'];
                    $userExpenseObj->date = $expense['date'];
                    $userExpenseObj->save();

                     }
                
                //    $total_balance = $old_balance - $new_balance;
                //    User::where('id', $expense['user_id'])->update(array('balance' => $total_balance));




            }
        }else{
            $expenseObj->invoice_no = $expense['invoice_no'];
            $expenseObj->remarks = $expense['remarks'];
            $expenseObj->save();
        }
//    Image upload
        if(!empty($expense['uploadimages'])) {
            $images = [];
            foreach($expense['uploadimages'] as $image) {

                $image = upload_base64_image($image, 'uploads/userExpense/',
                    'image-');
                $customerImage = new ExpenseImage();
                $customerImage->image =  'http://'.$image;
                $images[] = $customerImage;
            }
            if(count($images) > 0) {
                $expenseObj->images()->saveMany($images);
            }
        }
         if(!empty($expense['expense_tags'])) {
            $tags = [];
            foreach($expense['expense_tags'] as $tag) {
                $customerImage = new ExpenseTag();
                $customerImage->expense_id=$expenseObj->id;
                $customerImage->tag_id=$tag;
                $tags[] = $customerImage;
            }
            if(count($tags) > 0) {
               $expenseObj->Tags()->saveMany($tags);
            }
        }
        return 'success';
    }
    
}
