<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class Target extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ 'id' ];
    /**
     * Get the user that owns the target.
     */
    public function user()
    {
        return $this->belongsTo('App\models\User','rsm_id','id');
    }
    /***
     * Order Product Relationship
     *
     * @return \Illuminate\Database\Eloquent\Relations\hasMany
     */
    public function target_details()
    {
        return $this->hasMany('App\Models\TargetDetail', 'target_id')->with(['user'=>function($query){return $query->select('id','firstname','lastname','image');}]);
    }
    // CMonth Recovery
    public function CMonthRecovery($user_id) {
        $payments=Payment::where('user_id',$user_id)
            ->where('payment_type', 'Cash')
            ->whereBetween('promise_cheque_date',[date('Y-m-01'),date("Y-m-d")])
            ->sum('amount');
        return $payments;
    }
    //CMonth Sales
    public function CMonthSales($user_id) {
        $orders=Order::where('booked_by',$user_id)
            ->where('status','Delivered')
            ->where('type', '!=', 'Sample')
            ->whereBetween('date_to_deliver',[date('Y-m-01'),date("Y-m-d")])
            ->sum('payment');
        return $orders;
    }

}
