<?php
/**
 * Created by PhpStorm.
 * User: raza
 * Date: 10/21/17
 * Time: 11:36 PM
 */

namespace App\Models;


use Illuminate\Database\Eloquent\Model;

class TargetPoint extends Model
{
    /***
     * Target Points type constants
     */
    CONST ADD_PAYMENT = 'add_payment';
    CONST PLACE_ORDER = 'place_order';
    CONST FIRST_ORDER = 'First Order';
    CONST CONFIRM_ORDER = 'confirm_order';
    CONST ADD_CUSTOMER = 'Add Customer';
    CONST COMPLETE_JOB = 'complete_job';
    CONST PAYMENT_ADDED = 'payment_added';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $table = 'target_points';
    /***
     * @var array
     */
    protected $guarded = ['id'];
    /***
     * Timestamps does not exists
     *
     * @var bool
     */
    public $timestamps = false;

    /***
     * Get points for specific type
     *
     * @param $type
     * @return integer $points
     *
     */
    public function getTypePoints($type)
    {
        $result = $this->where('type', $type)
                       ->first(['points']);
        return !is_null($result) ? $result->points : 0;
    }
    /***
     * Get id for specific type
     *
     * @param $type
     * @return integer $id
     *
     */
    public function getTypeId($type)
    {
        $result = $this->where('type', $type)
                       ->first(['id']);
        return !is_null($result) ? $result->id : 0;
    }
    public function user_points()
    {
        return $this->hasMany('App\Models\UserPoint', 'point_type_id');
    }
}