<?php

namespace App\Models;

use App\models\Category;
use Barryvdh\LaravelIdeHelper\Eloquent;
use Carbon\Carbon;
use Illuminate\Auth\Authenticatable;
use Laravel\Lumen\Auth\Authorizable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Contracts\Auth\Access\Authorizable as AuthorizableContract;
use Illuminate\Support\Facades\Hash;
use DB;
use Auth;
use Zizaco\Entrust\Traits\EntrustUserTrait;
//class User extends Model implements AuthenticatableContract, AuthorizableContract
class User extends Model implements AuthenticatableContract, AuthorizableContract
//class User extends Authenticatable
{
    use Authenticatable;
//    use Authenticatable, Authorizable;
    use EntrustUserTrait;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'firstname', 'lastname', 'email', 'password'
    ];
    /***
     * Hidden attributes of array
     *
     * @var array
     */
    protected $hidden = [
        'created_at', 'updated_at', 'deleted_at', 'pivot', 'password'
    ];
    // Append attribute
     protected $appends = [
        'role_user','is_adv','role_detail'
    ];
//    public $appends = ['so_orders_count'];
//
//    public function getSoOrdersCountAttribute()
//    {
//        return $this->so_orders()->count() ;
//    }
    // role user append
    public function getRoleUserAttribute()
    {
        $role= UserRole::select('user_id','role_id')->where('user_id',$this->id)->first();
        if(!empty($role->role_id)){
            $role_name=Role::select('id','name','display_name')->where('id',$role->role_id)->first();
            if(!empty($role_name->display_name)){
                return $role_name->display_name;
            }else{
                return null;
            }
        }else{
           return null;
        }

    }

    public function getRoleDetailAttribute()
    {
        $role= UserRole::select('user_id','role_id')->where('user_id',$this->id)->first();
        if(!empty($role->role_id)){
            $role_name=Role::select('id','name','display_name')->where('id',$role->role_id)->first();
            if(!empty($role_name->name)){
                return $role_name;
            }else{
                return "";
            }
        }else{
            return "";
        }

    }
    public function getIsAdvAttribute()
    {
        if($this->id==99){
            return true;
        }else{
            return false;
        }

    }
    public function vendor_products() {

        return $this->hasMany('App\Models\Product','po_vendor_id','id');
    }
    public function agency() {
        return $this->belongsTo('App\Models\Agency','agency_id','id');
    }
     public function Subdistributor_info() {
        return $this->belongsTo('App\Models\Subdistributor','subdistributer_id','id');
    }
    public function attendance_by_user() {
        return $this->belongsTo('App\Models\UserAttendance','id','asm_id');
    }
    public function asm_attendance() {
        return $this->hasMany('App\Models\UserAttendance','asm_id','id');
    }
    public function fixed_expence_by_user() {
        return $this->belongsTo('App\Models\UserFixedExpense','id','user_id');
    }
    public function user_other_expense_by_heads() {
        return $this->hasMany('App\Models\UserAttendanceExpenseDetail','user_id','id');
    }
    public function holidays() {
        return $this->hasMany('App\Models\UserHoliday','user_id','id');
    }
    public function asm_target()
    {
        return $this->belongsTo('App\Models\AsmTarget','id','asm_id');
    }
    public function sale_returns() {
        return $this->hasMany('App\Models\StockBooking','booked_by','id')->where('party_check','asm')->where('type','sub_sale_return');
    }
    public function children()
    {
        return $this
            ->hasMany('App\Models\User', 'parent_id');
    }
    public function children2()
    {
        return $this
            ->hasMany('App\Models\User', 'parent_id_2');
    }
    public function all_children(){
        return $this->children()->union($this->children2()->toBase());
    }
    
      public function rsm_detail()
    {
        return $this
            ->hasOne('App\Models\User', 'id','rsm_id');
    }
     public function asm_info() {
        return $this->belongsTo('App\Models\User','asm_id','id');
    }
public function party_info()
    {
        return $this->hasOne('App\Models\PartyName', 'id','party_id');
    }
    public function party_info_with_soul()
    {
        return $this->hasOne('App\Models\PartyName', 'id','party_id')->with('soul_distributer_info');
    }
    public function vendor_details() {

        return $this->belongsTo('App\Models\VendorDetail','id','user_id');
    }
    
     public function rsm_party_info()
    {
        return $this->hasMany('App\Models\PartyName', 'region_id','region_id')->with('soul_distributer');
    }
    
    public function ledger()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'user_id');
    }
    
    
    
    public function vendor_ledger()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'vendor_id');
    }
    
    public function so_stock() {
        return $this->hasMany('App\Models\SoStock','so_id','id')->with('stock_product');

    }
     public function stock_images() {
        return $this->hasMany('App\Models\StockImage','so_stock_id','id');

    }
     public function sub_distributer_user()
    {
        return $this->hasMany('App\Models\Subdistributor', 'asm_id');
    }
     public function get_sub_distributer_by_rsm()
    {
        return $this->hasMany('App\Models\Subdistributor', 'rsm_id');
    }
    public function get_sub_distributer_by_ase()
    {
        return $this->hasMany('App\Models\Subdistributor', 'ase_id');
    }
     public function sub_distributer_users() {
        return $this->hasMany('App\Models\Subdistributor','ase_id','id');
    }
     public function app_user_permissions(){
        return $this->hasMany('App\Models\AppUserPermissions', 'user_id', 'id');


    }

 public function ledger_vendor()
    {
        return $this->hasMany('App\Models\UserExpenseDetail', 'vendor_id');
    }
    public function registerUser($input)
    {
        $this->firstname = $input['firstname'];
        $this->lastname = $input['lastname'];
        if(array_key_exists('email', $input)) {
            $this->email = $input['email'];
        }
        $this->password = Hash::make($input['password']);
//        if(array_key_exists('user_type', $input)) {
//            $this->user_type = $input['user_type'];
//        }
        $this->username = $input['username'];
        $this->save();
        return $this;
    }
     /***
     * Get email against faceebook id
     *
     * @param $fbId
     * @return mixed
     */
    public function fetchEmail($fbId){
        return $this->where('fb_id','=',$fbId)
                    ->select('email')->first();
    }

    /***
     * Validation rules for add user
     *
     * @param null $attributes
     * @return array
     */
    public function validationRules( $attributes = null )
    {
        $rules = [
            'username'  => 'required|unique:users,username',
            'firstname' => 'required|string|max:255',
            'lastname' => 'required|string|max:255',
            'email' => 'unique:users,email',
            'password' => 'required',
            'user_type' => 'required'
        ];

        // no list is provided
        if(!$attributes)
            return $rules;

        // a single attribute is provided
        if(!is_array($attributes))
            return [ $attributes => $rules[$attributes] ];

        // a list of attributes is provided
        $newRules = [];
        foreach ( $attributes as $attr )
            $newRules[$attr] = $rules[$attr];
        return $newRules;
    }

 public function validationRulesuserunique( $attributes = null )
    {
        $rules = [
            'username'  => 'required|unique:users,username'
            
           
        ];

        // no list is provided
        if(!$attributes)
            return $rules;

        // a single attribute is provided
        if(!is_array($attributes))
            return [ $attributes => $rules[$attributes] ];

        // a list of attributes is provided
        $newRules = [];
        foreach ( $attributes as $attr )
            $newRules[$attr] = $rules[$attr];
        return $newRules;
    }
    /***
     * Validation rules for update profile
     *
     * @param $userId
     * @param null $attributes
     * @return array
     */
    public function validationRulesUpdateProfile($userId, $attributes = null)
    {
        $rules = [
            'username'  => 'unique:users,username,'.$userId,
            'firstname' => 'string|max:255',
            'lastname'  => 'string|max:255',
            'email'     => 'unique:users,email,'.$userId

        ];

        // no list is provided
        if(!$attributes)
            return $rules;

        // a single attribute is provided
        if(!is_array($attributes))
            return [ $attributes => $rules[$attributes] ];

        // a list of attributes is provided
        $newRules = [];
        foreach ( $attributes as $attr )
            $newRules[$attr] = $rules[$attr];
        return $newRules;
    }

    /***
     * User regions
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function regions() {
        return $this->belongsToMany('App\Models\Region', 'user_regions',
                                    'user_id', 'region_id')
                    ->withPivot(['date', 'execution_time', 'id']);
    }
    public function region() {
        return $this->belongsTo('App\Models\Region','region_id','id');
    }
    /***
     * User areas
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function areas() {
        return $this->belongsToMany('App\Models\Area', 'user_areas',
            'user_id', 'area_id');
    }
//    public function areas() {
//        return $this->belongsToMany('App\Models\Area', 'user_areas',
//            'user_id', 'area_id')->with(['area_customers'=>function($query)
//        {$query->select(['id','area_id',]);},
//        ]);
//    }
    /***
     * User Role
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user_role() {
        return $this->belongsTo('App\Models\UserRole','id','user_id')->with('role');

    }


    public function so_orders() {
        return $this->hasMany('App\Models\Order','booked_by','id')
            ->where('status','!=','Delivered')
            ->where('status','!=','Cleared')
            ->where('status','!=','Rejected')
            ->where('status','!=','Cancelled');

    }
    public function so_customers() {
        return $this->hasMany('App\Models\Customer','sale_officer_id','id');

    }
    public function so_targets() {
        return $this->hasMany('App\Models\TargetDetail','user_id','id');

    }
    public function so_bilties() {
        return $this->hasMany('App\Models\Bilti','delivered_to_id','id');

    }

    /***
     * Get agency id of user
     * @param $userId
     * @return integer
     */
    public function getUserAgencyId($userId) {
        $user = $this->where('id', '=', $userId)
                     ->first(['agency_id']);
        return !is_null($user) ? $user->agency_id : 0;
    }

    /***
     * Get User Info With Regions
     *
     * @param $filtersWithValues
     * @return Model|null|static
     */
    public function getUserInfoWithRegions($filtersWithValues)
    {
        $query = $this->with('regions');
        foreach($filtersWithValues as $filter => $value) {
            $query->where($filter, '=', $value);
        }
        return $query->first();
    }
    /***
     * Get User Info With Areas
     *
     * @param $filtersWithValues
     * @return Model|null|static
     */
    public function getUserInfoWithAreas($filtersWithValues)
    {
         $query = $this->with(['Subdistributor_info','asm_info','rsm_detail','party_info','holidays','user_role','areas'=>function($query){$query->with('city');},'region','app_user_permissions'=>function($query)
                    {
                        $query->with(['app_user_permission'])->get();
                    }]);
      //  ->with(['region'=>function($query){$query->with('country');}]);
        foreach($filtersWithValues as $filter => $value) {
            $query->where($filter, '=', $value);
        }
        return $query->first();
    }

    /***
     * Get constants
     *
     * @return array
     */
    public function getConstants()
    {
        $constants = [];
        //Jobs Status
        $constants['job_status'] = getEnumValues('jobs', 'status');
        //Jobs Visit Type
//        $constants['job_visit_type'] = getEnumValues('jobs', 'visit_type');
        //Order Status
        $constants['order_status'] = getEnumValues('orders', 'status');
        //Currencies
        $constants['currencies'] = $this->getCurrencies();
        //Product Discount
        $constants['product_discount'] = $this->getProductDiscount();
//        //Order Type
        $constants['order_type'] = getEnumValues('orders', 'type');
        //Product Category
        $constants['product_category'] = $this->getCategories();
        $constants['whatsapp_messages'] =  
array( array(
        "message" => "Assalam O Alaikum <br>Please check and confirm availability of this stock.", 
        "type" => "share_all_available_products", 
    
    ),
array( 
        "message" => "Assalam O Alaikum <br>Please check and confirm availability of this stock.", 
        "type" =>"share_single_available_product", 
        
    ),
array(  
        "message" => "Ässalam O Alaikum <br>Please check and confirm Outstanding Balance, Sales and Recovery<br>And focus on customer whose sale and recovery figure is highlighted by red color.", 
        "type" => "share_sub_distributors", 
        
    ),
);
        //Bank List
        $constants['banks'] = $this->getBanks();
//        //Product Category
//        $constants['product_category'] = getEnumValues('products', 'category');
//        //Product Type
        $constants['product_type'] = getEnumValues('products', 'type');
//        //Customer Type
        $constants['customer_type'] = getEnumValues('shops', 'customer_type');
//      All Zone
        $constants['all-zone'] =  $this->allzone();
//        //Shop Type
        $constants['shop_type'] = getEnumValues('shops', 'shop_type');
        //        //Vendors Products
        $constants['Danish_Lab'] = [1,2,4,14,16,17,18,30,33,36,37,38,41,42,43,44,40,51,52];
        $constants['Soap'] = [9,10,11];
        $constants['zh'] = [29,33];
        $constants['Biotech'] = [3,5,6,7,8,12,13,15,47,50];
        $constants['export_party'] = [29,28,17,9,23,16,12,22,35,15,14,39,43,44,45,46,47];

//        //Discount Percentage
        $constants['shop_discount_percentage'] = setDiscountPercentageArrayConstants();
        $constants['grades'] = setGradeArrayConstants(
                                    getEnumValues('shops', 'Category'));
        return $constants;
    }

    public function getCategories(){
        $categoriy=[];
        $categories = \App\Models\Category::select(['name'])->get()->toarray();
        foreach ($categories as $category){
            $categoriy[]=$category['name'];
        }
        return $categoriy;
    }
    public function allzone(){
       return Region::select('id','name')->get();
    }
    public function getBanks(){
        $banks=[];
        $bankes = \App\Models\Bank::select(['name','id'])->get()->toarray();
        foreach ($bankes as $key =>$bank){
            $banks[$key]['name']=$bank['name'];
            $banks[$key]['id']=$bank['id'];
        }
        return $banks;
    }
    public function getCurrencies(){
        $currency=[];
        $currencies= \App\Models\Currency::select(['name','id'])->get()->toarray();
        foreach ($currencies as $key =>$currencyy){
            $currency[$key]['name']=$currencyy['name'];
            $currency[$key]['id']=$currencyy['id'];
        }
        return $currency;
    }

    /***
     * Get product detail using id
     *
     * @return mixed
     */
    public function getProductDiscount()
    {
        $product_discount=[];
        $products = ProductDiscount::select(['grade','value','id'])->get()->toarray();
        foreach ($products as $key =>$product){
            $product_discount[$key]['grade']=$product['grade'];
            $product_discount[$key]['value']=$product['value'];
            $product_discount[$key]['id']=$product['id'];
        }
        return $product_discount;

    }

    /***
     * Update user
     *
     * @param $updateUser
     * @param $userId
     * @return User|Model|null
     */
    public function updateUser($updateUser, $userId)
    {
        $response = null;
        $user = $this->where('id', '=', $userId)->first();
        if(!is_null($user)) {
            if(array_key_exists('username', $updateUser)) {
               $user->username = $updateUser['username'];
            }
             if(array_key_exists('password', $updateUser)) {
               $user->password =  Hash::make($updateUser['password']);
               $user->password2 =  $updateUser['password'];


            }
            if(array_key_exists('firstname', $updateUser)) {
                $user->firstname = $updateUser['firstname'];
            }
            if(array_key_exists('lastname' , $updateUser)) {
                $user->lastname = $updateUser['lastname'];
            }
            if(array_key_exists('email', $updateUser)) {
                $user->email = $updateUser['email'];
            }
            if(array_key_exists('phone_1', $updateUser)) {
                $user->phone_1 = $updateUser['phone_1'];
            }
            if(array_key_exists('phone_2', $updateUser)) {
                $user->phone_2 = $updateUser['phone_2'];
            }
            if (array_key_exists('photo', $updateUser)) {
                $photo = $updateUser['photo'];
                $imageUpload = upload_base64_image($photo, 'uploads/user/', 'profileimage-');
                if(!IsNullOrEmptyString($user->profile_image)) {
                    $fileToUnlink = public_path() . '/uploads/user/' .
                                get_filename_url($user->profile_image);
                    if (file_exists($fileToUnlink)) {
                        unlink($fileToUnlink);
                    }
                }
                $user->profile_image = $imageUpload;
            }
            $user->save();
            $response = $this->getUserInfoWithAreas(['id' => $userId ]);
        }
        return $response;
    }
    
      public function updateUserimage($updateUser, $userId)
    {


        $response = null;
        $user = $this->where('id', '=', $userId)->first();
        if(!is_null($user)) {
            if (array_key_exists('image', $updateUser)) {
                $photo = $updateUser['image'];
                $imageUpload = upload_base64_image($photo, 'uploads/user/', 'profileimage-');
                if(!IsNullOrEmptyString($user->image)) {
                    $fileToUnlink = public_path() . '/uploads/user/' .
                                get_filename_url($user->image);
                    if (file_exists($fileToUnlink)) {
                        unlink($fileToUnlink);
                    }
                }
                $user->image = 'http://'.$imageUpload;
            }
            $user->save();
            $response = $this->getUserInfoWithAreas(['id' => $userId ]);
        }
        return $response;
    }
    
    
    public function updateUserbalance($userbalance, $userId)
    {
        
        
        $user = $this->where('id', '=', $userId)->first();

        if(!is_null($user)) {
          
               $user->balance = $userbalance;
            }
            
            $user->save();
          
         return $user;
        
    }

    /***
     * Create or update user
     *
     * @param $data
     * @return mixed
     */
    public function createOrUpdateUser($data)
    {

        if(array_key_exists('email', $data)) {
            $user = $this->where('email', '=', $data['email'])
                ->first();
        } else {
            $user = $this->where('phone_1', '=', $data['phone_1'])
                ->first();
        }
        $new=0;
        if(is_null($user)) {
            $user = new User();
            if(array_key_exists('email', $data)) {
                $user->email = $data['email'];
            }
            $new=1;
        }
        $splitName = split_name($data['name']);
        if(count($splitName) > 1) {
            $user->firstname = $splitName[0];
            $user->lastname  = $splitName[1];
        }
        $user->address  =  $data["address"];
        $user->landline =  $data['landline'];
        $user->phone_1  =  $data['phone_1'];
        $user->phone_2  =  $data['phone_2'];
        $user->save();

        if($new==1) {
            $new_role = new UserRole();
            $new_role->user_id = $user->id;
            $new_role->role_id = 8;
            $new_role->save();
        }
        return $user->id;
    }
    /***
     * Assign or update Regions
     *
     * @param $regions
     * @param $userId
     * @return array
     */
    public function assignOrUpdateRegions($regions, $userId)
    {
        $userRegionModel = new UserRegion();
        $userRegions = [];
        $userRegionIds = [];
        if(is_array($regions) > 0) {
            foreach ($regions as $region) {
                $userRegion = null;
                if (array_key_exists('id', $region)) {
                    $userRegion = $userRegionModel->getUserRegions($userId, 0, $region['id']);
                } elseif(array_key_exists('date', $region) && array_key_exists('region_id', $region)
                    && is_null($userRegion)) {
                    $userRegion = $userRegionModel->getUserRegionWithDateAndRegion($userId, $region['region_id'],
                                                                                   $region['date']);
                }
                if (is_null($userRegion)) {
                    $userRegionIds[] = $userRegionModel->insertUserRegion([
                                            'date' => Carbon::parse($region['date']),
                                            'user_id' => $userId,
                                            'region_id' => $region['region_id']
                                        ]);
                } else {
                    $userRegionIds[] = $userRegionModel->updateUserRegion($userRegion, $region);
                }
            }
            $userRegions = $this->getUserRegionsWithPivot($userId, $userRegionIds);
        }
        return $userRegions;
    }

    /***
     * Get user regions with pivot values
     *
     * @param $userId
     * @param $userRegionIds
     * @param $doNotFilter
     * @return array
     */
    public function getUserRegionsWithPivot($userId, $userRegionIds = [], $doNotFilter = false)
    {
        $userRegions = [];
        $userWithRegions = $this->with(['regions' => function($query) use ($userRegionIds, $doNotFilter){
                                    if(!$doNotFilter) {
                                        $query->whereIn('user_regions.id', $userRegionIds);
                                    }
                                }])
                                ->where('id', $userId)->first();
        if(!is_null($userWithRegions)) {
            $userRegions = $userWithRegions->regions;
        }
        return $userRegions;
    }
    /***
     * Get user areas with pivot values
     *
     * @param $userId
     * @return array
     */
    public function getUserAreasWithPivot($userId)
    {
       $user = User::where('id',$userId)->with(['areas'])->first();
        return $user;
    }
}
