<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class UserExpenseDetail extends Model
{
    protected $appends = ['invoice_no','status','remarks','account_info','bilty_info','payment_to_info'];

    public function party_info()
    {
        return $this->belongsTo('App\Models\PartyName', 'party_id');
    }
    public function subdistributer_info()
    {
        return $this->belongsTo('App\Models\Subdistributor', 'party_id')->with('asm_info','party');
    }
    public function user_expense()
    {
        return $this->belongsTo('App\Models\UserExpense','detail_id');
    }
    
     public function user_expense_credit()
    {
        return $this->belongsTo('App\Models\UserExpense','detail_id');
    }
    
    
    public function getPaymentToInfoAttribute()
    {
        if(($this->user_id!=13) && $this->party_id!=null){
            switch ($this->type){
                case 'Recovery':
                    $obj=RsmPayment::where('id',$this->detail_id)->with(['payment_to_info'])->first();
                    if(!empty($obj) && $obj->payment_to_info){
                        return $obj->payment_to_info;
                    }else{
                        return null;
                    }
                    break;
                    case 'Sub_recovery':
                          $obj=RsmPayment::where('id',$this->detail_id)->with(['payment_to_info'])->first();
                    if(!empty($obj) && $obj->payment_to_info){
                        return $obj->payment_to_info;
                    }else{
                        return null;
                    }
                    break;
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }
    }
    public function getAccountInfoAttribute()
    {
        if(($this->user_id!=13) && $this->party_id!=null){
            switch ($this->type){
                case 'Recovery':
                    $obj=RsmPayment::where('id',$this->detail_id)->with(['account_info'])->first();
                    if(!empty($obj) && $obj->account_info){
                        return $obj->account_info;
                    }else{
                        return null;
                    }
                    break;
                case 'Sub_recovery':
                          $obj=RsmPayment::where('id',$this->detail_id)->with(['account_info'])->first();
                    if(!empty($obj) && $obj->account_info){
                        return $obj->account_info;
                    }else{
                        return null;
                    }
                    break;
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }

    }
    public function getBiltyInfoAttribute()
    {
        if(($this->user_id!=13) && $this->party_id!=null){
            switch ($this->type){
                case 'Sale':
                    $obj=Bilti::where('id',$this->detail_id)->with(['bilty_detail'=>function($query)
                        {$query->with('bilty_product');},'biltyImages','party_info'])->first();
                    return $obj;
                    
                    break;
                    case 'Sub_sale':
                     $obj=Bilti::where('id',$this->detail_id)->with(['bilty_detail'=>function($query)
                        {$query->with('bilty_product');},'biltyImages','party_info'])->first();
                    return $obj;
                    
                    break;
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }

    }
    public function getInvoiceNoAttribute()
    {

        //if(($this->user_id!=13) && $this->party_id!=null)
        if(($this->user_id!=13))
        {
            switch ($this->type){
                case 'Recovery':
                    $obj=RsmPayment::where('id',$this->detail_id)->first();
                    if(!empty($obj) && $obj->admin_refno){
                        return $obj->accountant_refno;
                    }else{
                        return null;
                    }
                    break;
                case 'Sale':
                    $obj=Bilti::where('id',$this->detail_id)->first();
                    if(!empty($obj) && $obj->invoice_no){
                        return $obj->po_no.'/'.$obj->invoice_no;
                    }else{
                        return null;
                    }
                    break;
                case 'Credit Note':
                    $obj=UserExpense::where('id',$this->detail_id)->first();
                    if(!empty($obj) && $obj->invoice_no){
                        return $obj->invoice_no;
                    }else{
                        return null;
                    }
                    break;
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }

    }
    public function getStatusAttribute()
    {
        if(($this->user_id!=13) && $this->party_id!=null){
            switch ($this->type){
                case 'Recovery':
                    $obj=RsmPayment::where('id',$this->detail_id)->first();
                    if(!empty($obj) && $obj->status){
                        return $obj->status;
                    }else{
                        return null;
                    }
                    break;
                    case 'Sub_recovery':
                    $obj=RsmPayment::where('id',$this->detail_id)->first();
                    if(!empty($obj) && $obj->status){
                        return $obj->status;
                    }else{
                        return null;
                    }
                    break;
//            case 'Sale':
//                $obj=Bilti::where('id',$this->detail_id)->first();
//                if(!empty($obj) && $obj->invoice_no){
//                    return $obj->po_no.'/'.$obj->invoice_no;
//                }else{
//                    return null;
//                }
//                break;
//            case 'Credit Note':
//                $obj=UserExpense::where('id',$this->detail_id)->first();
//                if(!empty($obj) && $obj->invoice_no){
//                    return $obj->invoice_no;
//                }else{
//                    return null;
//                }
//                break;
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }
    }
    public function getRemarksAttribute()
    {
        if(($this->user_id!=13) && $this->party_id!=null){
            switch ($this->type){
                case 'Recovery':
                    if($this->user_id==91 && $this->party_id==null){
                        $obj=UserExpense::where('id',$this->detail_id)->first();
                        if(!empty($obj) && !empty($obj['remarks'])){
                            return $obj['remarks'];
                        }
                    }else{

                    }
                    return null;
                    break;
                    
                default:
                    return null;
                    break;
            }
        }else{
            return null;
        }
    }
}
