<?php

namespace App\Models;


use Illuminate\Database\Eloquent\Model;

class WareHouse extends Model
{
    protected $table = 'ware_houses';
      protected $guarded = ['id'];


     public function WarehouseStocks() {
       return $this->hasMany('App\Models\WarehouseStocks','warehouse_id','id');

    }

    public function product() {
        return $this->belongsTo('App\Models\Product','product_id','id');

    }

    public function validationRules( $attributes = null )
    {

    	////// name of that parameters which developer use in request ....... //////
        $rules = [
            
            'name'     => 'required',
            'city'           => 'required'
           
            
        ];

        // no list is provided
        if(!$attributes)
            return $rules;

        // a single attribute is provided
        if(!is_array($attributes))
            return [ $attributes => $rules[$attributes] ];

        // a list of attributes is provided
        $newRules = [];
        foreach ( $attributes as $attr )
            $newRules[$attr] = $rules[$attr];
        return $newRules;
    }

    public function validationRulescustomers( $attributes = null )
    {

        ////// name of that parameters which developer use in request ....... //////
        $rules = [
            
            'name'     => 'required',
            'email'           => 'required|email',
            'phone'           => 'required'
           
            
        ];

        // no list is provided
        if(!$attributes)
            return $rules;

        // a single attribute is provided
        if(!is_array($attributes))
            return [ $attributes => $rules[$attributes] ];

        // a list of attributes is provided
        $newRules = [];
        foreach ( $attributes as $attr )
            $newRules[$attr] = $rules[$attr];
        return $newRules;
    }


}
