<?php
use Edujugon\PushNotification\PushNotification;
use Carbon\Carbon;
use App\Models\User;
use App\Models\DsfShop;
if ( ! function_exists('config_path'))
{
    /**
     * Get the configuration path.
     *
     * @param  string $path
     * @return string
     */
    function config_path($path = '')
    {
        return app()->basePath() . '/config' . ($path ? '/' . $path : $path);
    }
    /**
     * Check if given string is null or empty.vendorProduct
     *
     * @param  string $string
     * @return bool
     */
    function IsNullOrEmptyString($string){
        return (!isset($string) || trim($string)=='');
    }
}


if (!function_exists('public_path')) {
    /**
     * Return the path to public dir
     *
     * @param null $path
     *
     * @return string
     */
    function public_path($path = null)
    {
        return rtrim(app()->basePath('public/' . $path), '/');
    }
}

function getParam($array, $key){
    return isset($array[$key]) ? $array[$key] : null;
}

if (!function_exists('urlGenerator')) {
    /**
     * @return \Laravel\Lumen\Routing\UrlGenerator
     */
    function urlGenerator() {
        return new \Laravel\Lumen\Routing\UrlGenerator(app());
    }
}

if (!function_exists('asset')) {
    /**
     * @param $path
     * @param bool $secured
     *
     * @return string
     */
    function asset($path, $secured = false) {
        return urlGenerator()->asset($path, $secured);
    }
}

/**
 * Sort Question Array
 *
 * @param $a
 * @param $b
 * @return bool
 */
function cmp($a, $b) {
    return $a->question_id > $b->question_id;
}

/***
 * Create recursive path with mod 777
 *
 * @param $path
 * @return bool
 */
function createPath($path) {
    return (file_exists($path)) ? true : mkdir($path, 07777, true);
}


function calculate_offset($page, $itemsPerPage = 10) {
    $offset = ($page - 1) * $itemsPerPage;
    return $offset;
}

function getEnumValues($tableName, $fieldName){
    $type = \DB::select(\DB::raw("SHOW COLUMNS FROM $tableName WHERE Field = '$fieldName'"))[0]->Type;
    preg_match('/^enum\((.*)\)$/', $type, $matches);
    $values = array();
    foreach(explode(',', $matches[1]) as $value){
        $values[] = trim($value, "'");
    }
    return $values;
}
function getTable($tableName, $condtion){

}
/***
 * Set discount percentage array constants
 *
 * @return array
 */
function setDiscountPercentageArrayConstants() {
    $discountPercentageColorMapping = [
        'Wholesaler' => '#CC6A55',
        'Retail Saler' => '#47C10A',
        'Distributer' => '#C1182D'
    ];
    $discountPercentageMapping = [
            'Wholesaler' => '10',
            'Retail Saler' => '4',
            'Distributer' => '15'
    ];
    $newConstants = [];
    foreach($discountPercentageMapping as $discountType => $percentage){
        $object = new \stdClass();
        $object->discount_type = $discountType;
        $object->discount_percentage = $percentage;
        $object->color = $discountPercentageColorMapping[$discountType];
        $newConstants[] = $object;
    }
    return $newConstants;
}

/****
 * Upload base64 image
 *
 * @param string $base64EncodeString
 * @param string $path
 * @param string $imageNamePrefix
 * @param bool $fetchNameOnly
 * @return null|string
 */
function upload_base64_image($base64EncodeString = '',$path = 'images', $imageNamePrefix = 'userimage-', $fetchNameOnly = false)
{
    try {
        $decodedFile = base64_decode($base64EncodeString);
        $opeFileToGetInfo = finfo_open();
        $fileExtension = explode('/', finfo_buffer($opeFileToGetInfo, $decodedFile, FILEINFO_MIME_TYPE))[1];

        $image_name = $imageNamePrefix . time() . str_random(4)."." . $fileExtension;
        $imagePath = public_path($path) . "/" . $image_name;
        createPath(public_path($path));
        file_put_contents($imagePath, $decodedFile);
        return ($fetchNameOnly) ? $image_name : env('APP_URL') . '/' . $path . $image_name;

    } catch (Exception $ex) {
        return null;
    }
}
/***
 * Get filename from url
 *
 * @param $url
 * @return null
 */
function get_filename_url($url) {
    $filename = null;
    if(!IsNullOrEmptyString($url)) {
        $path = parse_url($url, PHP_URL_PATH);
        $path = explode('/', $path);
        $filename = $path[sizeof($path) - 1];
    }
    return $filename;
}

function LedgerAdjust($party_id){
    $obj=\App\Models\PartyName::where('id',$party_id)->with(['party_ledger'=>function($query){$query->where('vendor_id',null)->orderBy('id', 'ASC');}])->first();
   
    if(!empty($obj) && !empty($obj->party_ledger)){
            $opening=$obj->opening_balance;
          
            foreach ($obj->party_ledger as $key=>$item){
                $update=\App\Models\UserExpenseDetail::where('id',$item['id'])->first();
               
                if(!empty($update)){
                    switch ($update['type']){
                        
                        case 'Sale':
                          
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                           
                           $update->save();
                            break;
                            case 'Debit Note':
                            $opening=$opening+$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                            
                        case 'Recovery':
                            
                            $opening=$opening-$update['amount'];
                        
                            $update->balance=$opening;
                            
                            $update->save();
                            break;
                        case 'Credit Note':
                           
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                              
                            $update->save();
                            
                            break;
                            
                            case 'Sale Return':
                            $opening=$opening-$update['amount'];
                            $update->balance=$opening;
                            $update->save();
                            break;
                    }
                    
                }
             
               $update->save();
            }
            
            
            $obj->balance=$opening;
            $obj->save();
        }
    return true;
}
function LedgerAdjustvendor($user_id){
    $obj=\App\Models\User::where('id',$user_id)->with(['vendor_ledger'=>function($query){$query->where('party_id',null)->orderBy('id', 'ASC');}])->first();
  
    if(!empty($obj) && !empty($obj->vendor_ledger)){
        $opening=$obj->opening_balance;
        foreach ($obj->vendor_ledger as $key=>$item){
            $update=\App\Models\UserExpenseDetail::where('id',$item['id'])->first();
            if(!empty($update)){
                switch ($update['type']){
                    case 'Sale':
                        $opening=$opening+$update['vendor_price'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                    case 'Recovery':
                        $opening=$opening-$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                   
                }
            }
            $update->save();
        }
        $obj->balance=$opening;
        $obj->save();
    }
     return true;
}
function LedgerAdjustsubdistributer($party_id){
    $obj=\App\Models\Subdistributor::where('id',$party_id)->with(['ledger'=>function($query){$query->orderBy('id', 'ASC');}])->first();

    if(!empty($obj) && !empty($obj->ledger)){
        $opening=$obj->opening_balance;
       
        foreach ($obj->ledger as $key=>$item){
            $update=\App\Models\UserExpenseDetail::where('id',$item['id'])->first();

            if(!empty($update)){
                switch ($update['type']){
                    case 'Sub_sale':
                        $opening=$opening+$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                    case 'Sub_recovery':
                        $opening=$opening-$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                    case 'sub_sale_return':
                        $opening=$opening-$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                        case 'sub_credit_note':
                        $opening=$opening-$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                         case 'sub_debit_note':
                        $opening=$opening+$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                }
            }
            $update->save();
        }
        $obj->balance=$opening;
        $obj->save();
    }
    return true;
}
function LedgerAdjustdsf($user_id){
    $obj=\App\Models\User::where('id',$user_id)->with(['ledger'=>function($query){$query->orderBy('id', 'ASC');}])->first();
    
    if(!empty($obj) && !empty($obj->ledger)){
        $opening=$obj->opening_balance;
       
        foreach ($obj->ledger as $key=>$item){
            $update=\App\Models\UserExpenseDetail::where('id',$item['id'])->first();

            if(!empty($update)){
                switch ($update['type']){
                    case 'dsf_sale':
                        $opening=$opening+$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                         case 'dsf_recovery':
                        $opening=$opening - $update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                   
                }
            }
            $update->save();
        }
        $obj->balance=$opening;
        $obj->save();
    }
    return true;
}
//// shop recovery and shop sale update 

function LedgerAdjustshop($user_id){
    $obj=\App\Models\DsfShop::where('id',$user_id)->with(['ledger_shops'=>function($query){$query->orderBy('id', 'ASC');}])->first();
    

    if(!empty($obj) && !empty($obj->ledger_shops)){
        $opening = $obj->oppening_balance;
       
        foreach ($obj->ledger_shops as $key=>$item){
            $update=\App\Models\UserExpenseDetail::where('id',$item['id'])->first();

           
            if(!empty($update)){
                switch ($update['type']){
                         case 'shop_sale':
                        $opening=$opening+$update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                         case 'shop_recovery':
                        $opening=$opening - $update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                         case 'shop_credit_note':
                        $opening=$opening - $update['amount'];
                        $update->balance=$opening;
                        $update->save();
                        break;
                   
                }
            }
            $update->save();
        }
        $obj->balance=$opening;
        $obj->save();
    }
    return true;
}


function productlist($category){
    $product_id=[];
    switch ($category){
        case 3:
            $product_id= [19,20,21,22,23,24,25];
            break;
        default:
            $product_id= [1,2,14,16,17,18,3,4,5,6,7,8,9,10,11,12,13,15];
            break;

    }
    return $product_id;

}
function vendorProduct($user_id) {
    if($user_id == 98){
        
   $objs=\App\Models\Product::select('id')->get()->toarray();
   $obj = array_flatten($objs);
   return $obj;
}else{
      $obj=\App\Models\Product::select('id')->where('po_vendor_id',$user_id)->get()->toarray();
  $obj  = array_flatten($obj);
   return $obj;

}
}
function dateset($end){

    
$name = explode('-',$end);
    
  $month   =  $name[1];
  $year = $name[0];

if($month == 02){

   $isLeap = DateTime::createFromFormat('Y', $year)->format('L') === "1";
    if ($isLeap == true){

        $end=  $end . '-29';
    }else{

            $end=  $end . '-28';
    }



}
elseif($month == '04' || $month == '06' || $month == '09' || $month == '11') 
   {

          $end =  $end . '-30';
}

else{
    $end =  $end . '-31';
}

return $end;

}
function setGradeArrayConstants($grades) {
    $gradePointsMapping = [
        'A+' => '5.0',
        'A'  => '4.5',
        'B'  => '4',
        'C'  => '3',
        'D'  => '2'
    ];
    $newConstants = [];
    foreach($grades as $constant){
        $object = new \stdClass();
        $object->grade = $constant;
        $object->point = array_key_exists($constant, $gradePointsMapping) ?
            $gradePointsMapping[$constant] : "";
        $newConstants[] = $object;
    }
    return $newConstants;
}

/***
 * Split name from full name
 * @param $name
 * @return array
 */
function split_name($name) {
    $name = trim($name);
    $last_name = (strpos($name, ' ') === false) ? '' : preg_replace('#.*\s([\w-]*)$#', '$1', $name);
    $first_name = trim( preg_replace('#'.$last_name.'#', '', $name ) );
    return array($first_name, $last_name);
}

 function getDatesFromRange($date_time_from, $date_time_to)
    {

        // cut hours, because not getting last day when hours of time to is less than hours of time_from
        // see while loop
        $start = Carbon::createFromFormat('Y-m-d', substr($date_time_from, 0, 10));
        $end = Carbon::createFromFormat('Y-m-d', substr($date_time_to, 0, 10));

        $dates = [];

        while ($start->lte($end)) {

            $dates[] = $start->copy()->format('Y-m-d');

            $start->addDay();
        }

        return $dates;
    }


/***
 * Prepend HTTP
 *
 * @param $value
 * @return string
 */
function prepend_http($value) {
    $url = parse_url($value);
    if ( ! $url OR ! isset($url['scheme']))
    {
        return 'http://'.$value;
    }
    return $value;
}
/***
 * Genrate uuid
 */
function generate_uuid() {
    return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),
        mt_rand( 0, 0xffff ),
        mt_rand( 0, 0x0fff ) | 0x4000,
        mt_rand( 0, 0x3fff ) | 0x8000,
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
    );
}
// fetch id from array
function fetch_column_from_array($array,$coulumn) {
    $idz=[];
    foreach ($array as $arr){
        $idz[]=$arr[$coulumn];
    }
    return $idz;
}
// push notification api_key
function push_notification_api_key() {
    return 'AIzaSyCkhSBL_ApfOdYv2HsZSdL1QZzB8s3s3t8';
}
// push noification send
function push_notification_send($id,$title,$body,$device_token,$type){
    $push= new PushNotification('fcm');
    $push->setMessage([
        'data' => [
            'id'=>$id,
            'title'=>$title,
            'body'=>$body,
            'type'=>$type,
            'sound' => 'default'
        ],
    ])->setApiKey(push_notification_api_key())
        ->setDevicesToken($device_token)
        ->send();
    return true;
}

 function showPartyToExport()
    {
        $party_id=\App\Models\PartyName::select('id')->wherein('id',[15,29,28,17,9,23,16,12,22,35,37,39,43,44,45,46,47,58])->get();
        
        return $party_id;
    }
  
function twopoints_on_earth($latitudeFrom, $longitudeFrom, $latitudeTo,  $longitudeTo) { 
    $long1 = deg2rad($longitudeFrom); 
    $long2 = deg2rad($longitudeTo); 
    $lat1 = deg2rad($latitudeFrom); 
    $lat2 = deg2rad($latitudeTo); 

    //Haversine Formula 
    $dlong = $long2 - $long1; 
    $dlati = $lat2 - $lat1; 

    $val = pow(sin($dlati/2),2)+cos($lat1)*cos($lat2)*pow(sin($dlong/2),2); 

    $res = 2 * asin(sqrt($val)); 

    $radius = 3958.756; 

    return ($res*$radius); 
}
function getremarks($user_id,$shop_id)
    {

        $user = User::where('id',$user_id)->first();
 
        $dsfshop = DsfShop::where('id',$shop_id)->first();
        
       $remark = $user->firstname." ".$user->lastname. " booked order of ".  $dsfshop->shop_name."<br>";
        return $remark;
    }
 function getdeletedremarks($user_id,$shop_id)
    {

        $user = User::where('id',$user_id)->first();
 
        $dsfshop = DsfShop::where('id',$shop_id)->first();
        
       $remark = $user->firstname." ".$user->lastname. " deleted order of ".  $dsfshop->shop_name."<br>";
        return $remark;
    }



