# Log no order

    POST /api/so-tenure-orders

## Description
Returns data of payments of tenure

## Headers
- **X-Auth-Token** — Authorization token of user


## Return format
A JSON object containing key **data**

- **Data** — So Customers orders of tenure


## Example
**Request**

    /api/so-tenure-orders

**Json Body**
```javascript
{"supplier_id":15,"date_to_deliver_start":"2018-03-17","date_to_deliver_end":"2018-03-31"}
```


**Return** __shortened for example purpose__
``` json
{
    "success": true,
    "message": "Payments found",
    "data": [
        {
            "date": "2018-03-17",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-18",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-19",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-20",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-21",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-22",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-23",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-24",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-25",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-26",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-27",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-28",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": [
                                {
                                    "id": 30,
                                    "uuid": "5adea7ce-e2f5-41f3-9df6-f8822f54ca4a",
                                    "agency_id": 1,
                                    "shop_id": 22,
                                    "booked_by": 13,
                                    "country_id": 2,
                                    "price": 255,
                                    "discount": 0,
                                    "payment": 255,
                                    "balance": 238745,
                                    "type": "Order",
                                    "status": "Delivered",
                                    "date_to_deliver": "2018-03-28",
                                    "delivery_time": "00:00",
                                    "remarks": "",
                                    "is_discounted": 0,
                                    "latitude": 31.5143862,
                                    "longitude": 74.3375123,
                                    "created_by": 13,
                                    "updated_by": null,
                                    "created_at": "2018-03-27 08:52:06",
                                    "updated_at": "2018-03-28 07:39:47",
                                    "deleted_at": null,
                                    "is_discounted_2": false
                                }
                            ]
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": [
                                {
                                    "id": 33,
                                    "uuid": "49978fb8-1600-471d-bff5-74cd2dec5efe",
                                    "agency_id": 1,
                                    "shop_id": 32,
                                    "booked_by": 13,
                                    "country_id": 2,
                                    "price": 256.67,
                                    "discount": 0,
                                    "payment": 256.67,
                                    "balance": -256.67,
                                    "type": "Order",
                                    "status": "Delivered",
                                    "date_to_deliver": "2018-03-28",
                                    "delivery_time": "00:00",
                                    "remarks": "",
                                    "is_discounted": 0,
                                    "latitude": 31.5143911,
                                    "longitude": 74.3375173,
                                    "created_by": 13,
                                    "updated_by": null,
                                    "created_at": "2018-03-28 09:15:58",
                                    "updated_at": "2018-03-28 09:16:04",
                                    "deleted_at": null,
                                    "is_discounted_2": false
                                }
                            ]
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": [
                                {
                                    "id": 32,
                                    "uuid": "f6a08297-0560-413b-b1b9-49d40aefa542",
                                    "agency_id": 1,
                                    "shop_id": 33,
                                    "booked_by": 13,
                                    "country_id": 2,
                                    "price": 1743,
                                    "discount": 0,
                                    "payment": 1743,
                                    "balance": 539,
                                    "type": "Order",
                                    "status": "Delivered",
                                    "date_to_deliver": "2018-03-28",
                                    "delivery_time": "00:00",
                                    "remarks": "",
                                    "is_discounted": 1,
                                    "latitude": 31.5143862,
                                    "longitude": 74.3375123,
                                    "created_by": 13,
                                    "updated_by": null,
                                    "created_at": "2018-03-28 09:06:05",
                                    "updated_at": "2018-03-28 09:14:34",
                                    "deleted_at": null,
                                    "is_discounted_2": true
                                }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-29",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": [
                                {
                                    "id": 15,
                                    "uuid": "8a6ad1fa-7ef7-4578-a542-feb26da3d41d",
                                    "agency_id": 1,
                                    "shop_id": 22,
                                    "booked_by": 13,
                                    "country_id": 2,
                                    "price": 205,
                                    "discount": 0,
                                    "payment": 205,
                                    "balance": 238540,
                                    "type": "Order",
                                    "status": "Delivered",
                                    "date_to_deliver": "2018-03-29",
                                    "delivery_time": "00:00",
                                    "remarks": "",
                                    "is_discounted": 0,
                                    "latitude": 31.5144834,
                                    "longitude": 74.3375173,
                                    "created_by": 13,
                                    "updated_by": null,
                                    "created_at": "2018-03-09 14:26:26",
                                    "updated_at": "2018-03-29 07:04:41",
                                    "deleted_at": null,
                                    "is_discounted_2": false
                                }
                            ]
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-30",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        },
        {
            "date": "2018-03-31",
            "so_order": [
                {
                    "id": 13,
                    "firstname": "Malik",
                    "lastname": "Shamas",
                    "image": "http://adminpanel.biocospk.com/uploads/users/image-1517930129151.jpeg",
                    "so_customers": [
                        {
                            "id": 21,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "16dec0fd-3f1e-4ff3-88a5-4e83a6a80325",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hamid",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 88732,
                            "location": "multan road",
                            "latitude": 31.5144793,
                            "longitude": 74.3375159,
                            "phone_1": "03215285369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:17:13",
                            "updated_at": "2018-03-28 12:54:05",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 63,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605038O7iz.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 64,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039nZna.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 65,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039fryF.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 66,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605039n7Iy.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 67,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040htvb.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 68,
                                    "shop_id": 21,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605040tZ5S.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 22,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "5ffad04b-f92a-4dd2-99cd-13209168e1b6",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Akbar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 240540,
                            "location": "multan road",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:26:00",
                            "updated_at": "2018-03-30 10:56:03",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 69,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605566byG8.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 70,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571Dn5r.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 71,
                                    "shop_id": 22,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605571CB2p.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 23,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "63d77b6d-5a01-48c8-9c64-b4b4437ab818",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Sohaib",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144834,
                            "longitude": 74.3375173,
                            "phone_1": "07852655533",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 14:31:11",
                            "updated_at": "2018-03-09 14:31:11",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 72,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605877vUek.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 73,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605879y4lT.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 74,
                                    "shop_id": 23,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520605880giER.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 24,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d4f178ca-b2be-44af-a5de-aec25f8939e4",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Zubair",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 27000,
                            "location": "faisalabad",
                            "latitude": 31.4434575,
                            "longitude": 73.0863424,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-09 20:39:06",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 75,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627954migW.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 76,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627959XsyC.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 77,
                                    "shop_id": 24,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520627960lCwP.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 25,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "d8b1deb2-fd4f-4df2-8fe2-5ab838a7a97f",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "Babar",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.443428,
                            "longitude": 73.0861405,
                            "phone_1": "03215252369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-11 04:00:59",
                            "updated_at": "2018-03-11 04:00:59",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 78,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740875Cxmq.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 79,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740891k8Tp.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 80,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1520740902IhnY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 81,
                                    "shop_id": 25,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-15207409043Gos.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 30,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "513c1109-9210-4243-9f21-24b418bb52d7",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "bilL",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 0,
                            "location": "abc",
                            "latitude": 31.5144801,
                            "longitude": 74.3375187,
                            "phone_1": "03215236985",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:49:42",
                            "updated_at": "2018-03-14 11:49:42",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 97,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028187Ttn4.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 98,
                                    "shop_id": 30,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028188u7jY.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 31,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "51f5e455-1fdd-401c-9502-d2fde9daf28c",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "hjsjh",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -325,
                            "location": "ahhfh",
                            "latitude": 31.5144474,
                            "longitude": 74.3374413,
                            "phone_1": "0324828859596",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 11:52:37",
                            "updated_at": "2018-03-14 12:09:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 99,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028361vlGn.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 100,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028364mXcO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 101,
                                    "shop_id": 31,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521028365A3yl.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 32,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "f585c58f-7d05-4edb-b778-7a517dc1359d",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "abc",
                            "email": "",
                            "opening_balance": 0,
                            "balance": -257,
                            "location": "abc",
                            "latitude": 31.5144432,
                            "longitude": 74.3375301,
                            "phone_1": "03212525369",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:16:04",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 102,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029368omkO.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 103,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029369vZl3.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 104,
                                    "shop_id": 32,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029370sJnk.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        },
                        {
                            "id": 33,
                            "parent_id": null,
                            "agency_id": 1,
                            "sale_officer_id": 13,
                            "area_id": 4,
                            "target_visit_id": 4,
                            "currency_id": 2,
                            "uuid": "cfbfb09f-6a0e-4053-9982-d21fe0a23410",
                            "proprietor_id": 14,
                            "contact_person_id": 14,
                            "name": "vHbz",
                            "email": "",
                            "opening_balance": 0,
                            "balance": 62539,
                            "location": "abcVv",
                            "latitude": 31.5144357,
                            "longitude": 74.3375224,
                            "phone_1": "0321825239 ",
                            "phone_2": "",
                            "discount_percentage": "0",
                            "biocos_ratting": 5,
                            "status": "Rejected",
                            "customer_type": "Wholesaler",
                            "shop_type": "",
                            "Category": "A+",
                            "created_by": 13,
                            "updated_by": null,
                            "deleted_by": null,
                            "created_at": "2018-03-14 12:09:07",
                            "updated_at": "2018-03-28 09:15:07",
                            "deleted_at": null,
                            "images": [
                                {
                                    "id": 105,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029372cXfe.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 106,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029373nNkQ.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                },
                                {
                                    "id": 107,
                                    "shop_id": 33,
                                    "image_url": "http://demoapi.biocospk.com/uploads/shops/image-1521029374UZ4U.jpeg",
                                    "created_at": null,
                                    "updated_at": null
                                }
                            ],
                            "orders": []
                        }
                    ]
                }
            ]
        }
    ]
}