<?php

namespace App\Http\Controllers;

use App\Models\Area;
//use Mail;
//use Illuminate\Mail\Mailer;
use App\Models\Bilti;
use App\Models\VendorInvoice;
use App\Models\InventoryReport;
use App\Models\BiltiDetail;
use App\Models\ExpenseTag;
use App\Models\Tag;
use App\Models\Tagtype;
use App\Models\Region;
use App\Models\BiltiDetialType;
use App\Models\BiltyImage;
use App\Models\Customer;
use App\Models\RawMaterial;
use App\Models\CustomerImage;
use App\Models\Expense;
use App\Models\ExpenseImage;
use App\Models\Feedback;
use App\Models\Order;
use App\Models\OrderProduct;
use App\Models\OrderProductCategory;
use App\Models\PartyName;
use App\Models\PartyRates;
use App\Models\PaymentReceived;
use App\Models\PoNumber;
use App\Models\Product;
use App\Models\ProductRaw;
use App\Models\ProductPrice;
use App\Models\RawProductVendor;
use App\Models\RsmPayment;
use App\Models\RsmTarget;
use App\Models\DsfTarget;
use App\Models\AsmTarget;
use App\Models\DistributorTarget;
use App\Models\SoStock;
use App\Models\SoTarget;
use App\Models\SoTargetDetail;
use App\Models\StockBooking;
use App\Models\StockBookingDetail;
use App\Models\StockBookingDetailCategory;
use App\Models\SupplierSo;
use App\Models\WareHouse;
use App\Models\WarehouseStocks;
use App\Models\WarehouseStockVariant;
use App\Models\User;
use App\Models\UserArea;
use App\Models\UserExpense;
use App\Models\UserExpenseDetail;
use App\Models\SoStockDetail;
use Dingo\Api\Facade\API;
use Illuminate\Http\Request;
use League\Flysystem\Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Str;
use App\Models\PaymentRemark;
use App\Models\RawProductVendorDesktop;
use App\Models\Factoryinventory;

class OrderController extends BaseController
{
    /***
     * @var Order
     */
    private $_orderModel;

    /***
     * Constructor
     *
     * @param $request
     * @param Order $orderModel
     */
    public function __construct(Request $request, Order $orderModel)
    {
        set_time_limit(8000000);
        parent::__construct($request);
        $this->_orderModel = $orderModel;
    }

    /***
     * Book or update orders
     *
     * @param $orderId
     * @param $request
     *
     * @return mixed
     */
     
     
     
     
    /***
     * Tag Add
     */




    public function GetTags(Request $request)
 {


    try {
        
       $tagtype=Tagtype::with('tags')->get();
       
       


    }



    catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);

    }


    return API::response()->array(['success' => true,
        'message' => 'Tag ' . $request->get('name').' Added' ,
        'data'    =>$tagtype ], 200);


}

    public function AddTags(Request $request)
{
    $flag=0;
   
    try {
        $check=Tag::where('name',$request->name)->first();

        if(!empty($check))
        {
            $flag=1;
        }

        else{
            $tag=new Tag();


            $tag->name=$request->name;
            $tag->type = $request->id;
            $tag->save();
            $flag=2;
        }




    } catch(Exception $e) {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    if($flag==1)
    {
        return API::response()->array(['success' => true,
            'message' => 'Tag ' . $request->name.' Already Exist' ,
            'data'    => 0], 200);
    }

    if($flag==2)
    {
        return API::response()->array(['success' => true,
            'message' => 'Tag ' . $request->name.' Added' ,
            'data'    =>1 ], 200);
    }

}
     
     
    public function bookOrUpdateOrder(Request $request, $orderId = 0)
    {
        try {
            $validator = \Validator::make($request->all(), $this->_orderModel->validationRules());

            if ($validator->fails()) {
                return API::response()->array(['success' => false,
                    'error'   => 'Required parameters are missing or incorrect!',
                    'message' => $validator->errors()], 400);
            } else {
                $order = $request->all();
                $user = $this->getUserIdFromToken($request, true);
                $order['user_id'] = $user->id;
                $order['agency_id'] = $user->agency_id;
                $orders = $this->_orderModel->addOrUpdateOrder($order, $orderId);

//                $order = $this->_orderModel->addOrUpdateOrder($order, $orderId);

                $obj1 = new \stdClass;
                $obj2=[];
                foreach ($orders->products as $item){
                    $order_product_category='';
                    if(isset($item->pivot->id))
                    $order_product_category=OrderProductCategory::where('order_product_id',$item->pivot->id)->get();
                    $item->product_category=$order_product_category;
                    $obj2[]=$item;

                }
                $obj1=$orders;
                $obj1->products=$obj2;
                $order=$obj1;
//                return $order;
//                $order->remaining_amount = $this->getRemainingAmount($orderId, $order->price);
                if (is_null($order)) {
                    return API::response()->array(['success' => false,
                        'error' => 'Order Not Found'], 400);
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Order ' . (($orderId > 0) ? 'Updated' : 'Created'),
                'data'    => $order], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * Book or update expenses
     *
     * @param $expenseId
     * @param $request
     *
     * @return mixed
     */
    public function bookOrUpdateExpense(Request $request, $expenseId = 0)
    {
        $expensee='';
        try {
                $expenses = $request->all();
                $user = $this->getUserIdFromToken($request, true);

            foreach ($expenses as $expense){
                $expense['user_id'] = $user->id;

                $expensee = $this->_orderModel->addOrUpdateExpense($expense, $expenseId);

            }
//                $order = $this->_orderModel->addOrUpdateOrder($order, $orderId);

                if ( is_null($expensee)) {
                    return API::response()->array(['success' => false,
                        'error' => 'Expense Not Found'], 400);
                }

            return API::response()->array(['success' => true,
                'message' => 'Expense ' . (($expenseId > 0) ? 'Updated' : 'Created'),
                'data'    => $expensee], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
    }
    
      public function expensetags(Request $request)
    {
        
        try {
            $expenses = $request->all();
                 $getoldtags = ExpenseTag::where('expense_id',$request['id'])->get();
            
            if($getoldtags){
            foreach ($getoldtags as $key => $getoldtag) {
                $getoldtag->delete();

            }
        }
            
            foreach ($expenses['tags'] as $tag){
               
                
               

              $obj = new ExpenseTag();

               $obj->expense_id = $expenses['id'];
               $obj->tag_id = $tag['id'];
               $obj->save();
               
            }
//                $order = $this->_orderModel->addOrUpdateOrder($order, $orderId);

            if ( is_null($expenses)) {
                return API::response()->array(['success' => false,
                    'error' => 'tags Not Found'], 400);
            }

            return API::response()->array(['success' => true,
                'message' => 'Expense tags updated'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
             'message' => $e->getTraceAsString()], 400);
        }
    }
  public function addAdvInvoice(Request $request)
    {
        try {
            $obj = new UserExpense();
            $obj->user_id = $request->get('user_id');
            $obj->expense_id = 80;
            $obj->amount = $request->get('amount');
            $obj->date = date("Y-m-d");
            $obj->remarks = $request->get('remarks');
            $obj->invoice_no = $request->get('invoice_no');
            $obj->save();
            // ledger

            $user=User::where('id',$request->get('user_id'))->first();
            if(!empty($user)){
                $user->balance=$user->balance+$request->get('amount');
                $user->save();

                $led=new UserExpenseDetail();
                $led->user_id=$user->id;
                $led->detail_id=$obj->id;
                $led->vendor_id=$request->get('user_id');
                $led->type='Sale';
                $led->is_open=1;
                $led->amount=$request->get('amount');
                $led->vendor_price=$request->amount;
                $led->balance=$user->balance;
                $led->date=date("Y-m-d");
                $led->save();
            }
//    Image upload
            if(!empty($request->get('uploadimages'))) {
                $images = [];
                foreach($request->get('uploadimages') as $image) {
                    $image = upload_base64_image($image, 'uploads/userExpense/',
                        'image-');
                    $customerImage = new ExpenseImage();
                    $customerImage->image =  'http://'.$image;
                    $images[] = $customerImage;
                }
                if(count($images) > 0) {
                    $obj->images()->saveMany($images);
                }
            }

            return API::response()->array(['success' => true,
                'message' => 'added',
            ], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * Book or update return orders
     *
     * @param $orderId
     * @param $request
     *
     * @return mixed
     */
    public function bookOrUpdateReturnOrder(Request $request, $orderId = 0)
    {
        try {
//            $validator = \Validator::make($request->all(), $this->_orderModel->validationRules());
//
//            if ($validator->fails()) {
//                return API::response()->array(['success' => false,
//                    'error'   => 'Required parameters are missing or incorrect!',
//                    'message' => $validator->errors()], 400);
//            } else {
                $order = $request->all();
                $user = $this->getUserIdFromToken($request, true);
                $order['user_id'] = $user->id;
                $order['agency_id'] = $user->agency_id;
                $orders = $this->_orderModel->addOrUpdateReturnOrder($order, $orderId);
//                $order = $this->_orderModel->addOrUpdateOrder($order, $orderId);

                $obj1 = new \stdClass;
                $obj2=[];
                foreach ($orders->products as $item){
                    $order_product_category='';
                    if(isset($item->pivot->id))
                    $order_product_category=OrderProductCategory::where('order_product_id',$item->pivot->id)->get();
                    $item->product_category=$order_product_category;
                    $obj2[]=$item;

                }
                $obj1=$orders;
                $obj1->products=$obj2;
                $order=$obj1;
//                return $order;
//                $order->remaining_amount = $this->getRemainingAmount($orderId, $order->price);
                if (is_null($order)) {
                    return API::response()->array(['success' => false,
                        'error' => 'Order Not Found'], 400);
                }
//            }
            return API::response()->array(['success' => true,
                'message' => 'Return Order ' . (($orderId > 0) ? 'Updated' : 'Created'),
                'data'    => $order], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     *  update bilty
     *
     * @param $biltyId
     * @param $request
     *
     * @return mixed
     */
    public function updateBilty(Request $request, $biltyId = 0)
    {
        try {
                $bilty = $request->all();
            $user = $this->getUserIdFromToken($request, true);
            $bilty['user_id'] = $user->id;
                $bilty = $this->_orderModel->updateBilty($bilty, $biltyId);
                if (($bilty == 0)) {
                    return API::response()->array(['success' => false,
                        'error' => 'Bilty Not Updated'], 400);
                }
            return API::response()->array(['success' => true,
                'message' => 'Bilty Updated'], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
    }

    /***
     * Get Order Details
     *
     * @param $orderId
     * @return mixed
     */
    public function getOrderDetails($orderId)
    {
        try {
            $order = $this->_orderModel->getOrderDetails($orderId,0);
//            $order->remaining_amount = $this->getRemainingAmount($order->customer_id, $order->price);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => is_null($order) ? 'Order not found' : 'Order found',
                                       'data' => $order], 200);
    }
    /***
     * Get SO Orders
     *
     * @param $orderId
     * @return mixed
     */
    public function getSoOrders($orderId)
    {
        try {
            $orders = $this->_orderModel->getSoOrders($orderId);
            $count = count($orders);
//            $order->remaining_amount = $this->getRemainingAmount($order->customer_id, $order->price);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => ($count == 0) ? 'Order not found' : 'Order found',
                                       'data' => $orders], 200);
    }
    /***
     * Get Countries
     *
     * @return mixed
     */
    public function getCountries()
    {
        try {
            $orders = $this->_orderModel->getCountries();
            $count = count($orders);
//            $order->remaining_amount = $this->getRemainingAmount($order->customer_id, $order->price);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                                           'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true,
                                       'message' => ($count == 0) ? 'Order not found' : 'Order found',
                                       'data' => $orders], 200);
    }

    /***
     * List orders
     *
     * @param Request $request
     * @return mixed
     */
    public function listOrders(Request $request)
    {
        try {
            $orderRemainingAmounts = [];
            $userId = $request->get('user_id');
            $page = $request->get('page', 1);
            $avoidPagination = $request->get('avoid_pagination', false);
            if(IsNullOrEmptyString($userId)) {
                $userId = $this->getUserIdFromToken($request);
            }
            $orders = $this->_orderModel->getOrders($userId, $avoidPagination, $page);
            //Calculating remaining amounts
//            foreach($orders as $key => $order) {
//                if(!array_key_exists($order->id, $orderRemainingAmounts)) {
//                    $orderRemainingAmounts[$order->id] = $this->getRemainingAmount($order->id, $order->price);
//                }
//                $order->remaining_amount = $orderRemainingAmounts[$order->id];
//            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Orders found',
            'data' => $orders], 200);
    }
    
     /***
     * List orders without PO
     *
    
     */
    
          public function getordercount()
    {
        try {

       $data=array();

             $regular = StockBooking::where('id','>',150)->where('status','!=','Cancelled')->where('status','!=','Completed')->where('party_check','=', null)->where('booked_to','!=',99)->where('type',NULL)->doesnthave('po_numbers')->count();
            $raw = StockBooking::where('status','!=','Cancelled')->where('type','Raw')->doesnthave('po_numbers')->count();
            $adv = StockBooking::where('status','!=','Cancelled')->where('booked_to',99)->doesnthave('po_numbers')->count();

            $data['regular']=$regular;
            $data['raw']=$raw;
            $data['adv']=$adv;



            return API::response()->array(['success' => true,
                'message' => 'Orders without PO',
                'data'    => $data], 200);

        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }

    /***
     * Add or update Payment Received
     *
     * @param Request $request
     */
    public function addOrUpdatePaymentReceived(Request $request)
    {
        try {
            $newOrUpdatePayments = [];
            $payments = $request->all();
            $user = $this->getUserIdFromToken($request, true);
            foreach ($payments as $payment) {
                $paymentReceivedModel = new PaymentReceived();
                $validator = \Validator::make($payment, $paymentReceivedModel->validationRules());

                if ($validator->fails()) {
                    return API::response()->array(['success' => false,
                        'error' => 'Required parameters are missing or incorrect!',
                        'message' => $validator->errors()], 400);
                } else {
                    $payment['user_id'] = $user->id;
                    $payment['agency_id'] = $user->agency_id;
                    $payment = $paymentReceivedModel->addOrUpdatePaymentReceived($payment);
                    if (is_null($payment)) {
                        return API::response()->array(['success' => false,
                            'error' => 'Payment Not Found'], 400);
                    }
                    $newOrUpdatePayments[] = $payment;
                }
            }
        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payment Received Updated/Created',
            'data' => $newOrUpdatePayments], 200);
    }
    /***
     * Add or update Feedback
     *
     * @param Request $request
     */
    public function addOrUpdateFeedback(Request $request)
    {
        try {
            $feedback = $request->all();
                $feedbackModel = new Feedback();
                    $feedbackk = $feedbackModel->addOrUpdateFeedback($feedback);
                    if (is_null($feedback)) {
                        return API::response()->array(['success' => false,
                            'error' => 'Feedback Not Found'], 400);
                    }

        } catch (Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Feedback Updated/Created',
            'data' => $feedbackk], 200);
    }

    /***
     * Get remaining amount
     *
     * @param $orderId
     * @param $orderAmount
     *
     * @return int|mixed
     */
    public function getRemainingAmount($orderId, $orderAmount)
    {
        $paymentReceivedModel = new PaymentReceived();
        $totalPaymentAgainstOrder = $paymentReceivedModel->getTotalPaymentAgainstOrder($orderId);
        return (($orderAmount - $totalPaymentAgainstOrder) < 0) ? 0 : ($orderAmount - $totalPaymentAgainstOrder);
    }

    /***
     * List payment received API
     *
     * @param Request $request
     * @return mixed
     */
    public function listPaymentReceived(Request $request)
    {
        try {
            $paymentReceivedModel = new PaymentReceived();
            $userId = $request->get('user_id');
            $customerId = $request->get('customer_id', 0);
            $page = $request->get('page', 1);
            $avoidPagination = $request->get('avoid_pagination', false);
            if(IsNullOrEmptyString($userId)) {
                $userId = $this->getUserIdFromToken($request);
            }
            $payments = $paymentReceivedModel->getPaymentReceived($userId, $customerId,
                                                                  $page, $avoidPagination);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payments found',
            'data' => $payments], 200);
    }

    /***
     * Update order Status method
     *
     * @param Request $request
     * @return mixed
     */
    public function updateOrderStatus(Request $request)
    {

        try {
            $orderId = $request->get('order_id');
            $userId  = $request->get('user_id');
            $status  = $request->get('status');
            $remarks = $request->get('remarks');
            if(IsNullOrEmptyString($userId)) {
                $userId = $this->getUserIdFromToken($request);
            }
            $order = $this->_orderModel->updateOrderStatus($orderId, $userId, $status, $remarks);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Order Status Updated',
                                       'data' => $order], 200);
    }
    public function updateOrderStatusSync(Request $request)
    {

        try {
            $ordersResponse = [];
            $paymentResponses = [];
            $orders    = $request->get('delivered_orders');
            $payments    = $request->get('payments');
            $user = $this->getUserIdFromToken($request, true);
            $orderModel = new Order();
            if(!is_null($orders) && count($orders) > 0) {
                foreach($orders as $order) {

                    $ordersResponse[] = $orderModel->statusOrder($order['id'], $order['status']);
                }
            }
            //Insert Payments
            if(!is_null($payments) && count($payments) > 0) {
                $customerModel = new Customer();
                $paymentModel = new PaymentReceived();
                foreach($payments as $payment) {
                    $payment['user_id']   = $user->id;
                    if(array_key_exists('order_uuid', $payment)) {
                        $payment['order_id'] = $orderModel->getOrderId($payment['customer_uuid']);
                    }
                    if(array_key_exists('customer_uuid', $payment)) {
                        $customerArr['uuid'] = $payment['customer_uuid'];
                        $payment['shop_id'] = $customerModel->getCustomerId($customerArr);
                        $payment['agency_id']   = $user->agency_id;

                    }
                    $paymentResponses[] = $paymentModel->addOrUpdatePaymentReceived($payment);
                }
            }

            $data = new \stdClass();
            $data->delivered_orders   = $ordersResponse;
            $data->payments = $paymentResponses;
            return API::response()->array(['success' => true,
                'message' => 'Orders Status Updated',
                'data' => $data], 200);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function statusOrder(Request $request)
    {

        try {
            $user = $this->getUserIdFromToken($request, true);
            $orderId = $request->get('order_id');
            $status= $request->get('status');
            $invoice_no= $request->get('invoice_no');
            $order = $this->_orderModel->statusOrder($orderId,$status,$invoice_no,$user->id);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Order Status Changed',
                                       'data' => $order], 200);
    }
    public function testingRoute(Request $request)
    {

        try {
            $old_balance = 1000;
            $new_balance = 567;
            $total_balance = $old_balance - $new_balance;
//            $sent = Mail::send('email.deliver_order', compact('upper_text', 'query'), function ($message) use ($user_email) {
//                $message->from('biocospk@gmail.com', 'Biocos')->subject('Order Delivered!');
//                $message->to($user_email);
//            });
            $data=[];
            $data[]='a';
            $date = date('Y-m-d');
            $customer_name = 'Abdur Rahim Albalochi Trading ';
            $sent = Mail::send('email.deliver_order', compact('old_balance', 'new_balance','total_balance','date','customer_name'), function($message){
                $message->from('admin@biocospk.com', 'Biocos International Pvt Ltd');
                $message->to('muddassir.engineer@gmail.com')->subject('Test!');
//                $message->to('atiqarasheedahmad00@gmail.com')->subject('Test!');
            });
            if( count(Mail::failures()) > 0 ) {

                echo "There was one or more failures. They were: <br />";

                foreach(Mail::failures as $email_address) {
                    echo " - $email_address <br />";
                }

            } else {
                echo "No errors, all sent successfully!";
            }

           return $sent;
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Order Status Changed',
                                       'data' => $order], 200);
    }
    public function salepermonth(Request $request)
    {
        $product_id=$request->get('product_id');
        $user_id=$request->get('user_id');
        $area_id=$request->get('area_id');
        $originalDate = $request->get('date');
        if(empty($area_id)){
            $orders=DB::table('orders')
                ->where('orders.booked_by',$user_id)
                ->where('orders.created_at', 'like', date('Y-m',strtotime($originalDate)).'%')
                ->where('order_products.product_id',$product_id)
                ->orderBy('orders.created_at', 'ASC')
                ->Join('shops', 'orders.shop_id', '=', 'shops.id')
                ->Join('order_products', 'orders.id', '=', 'order_products.order_id')
                ->select('orders.created_at','order_products.quantity')
                ->get();
            $target =  DB::table('area_product_targets')
                ->where('product_id',$product_id)
                ->Join('target_grades', 'area_product_targets.grade_id', '=', 'target_grades.id')
                ->select('area_product_targets.threshold','target_grades.value')
                ->sum('target_grades.value');
            $threshold =  DB::table('area_product_targets')
                ->where('product_id',$product_id)
                ->Join('target_grades', 'area_product_targets.grade_id', '=', 'target_grades.id')
                ->select('area_product_targets.threshold','target_grades.value')
                            ->sum('area_product_targets.threshold');
        }else{

            $orders=DB::table('orders')
                ->where('orders.booked_by',$user_id)
                ->where('orders.created_at', 'like', date('Y-m',strtotime($originalDate)).'%')
//                ->where('shops.area_id',$area_id)
//                ->where('order_products.product_id',$product_id)
                ->orderBy('orders.created_at', 'ASC')
                ->Join('shops', 'orders.shop_id', '=', 'shops.id')
                                ->where('shops.area_id',$area_id)
                ->Join('order_products', 'orders.id', '=', 'order_products.order_id')
                                ->where('order_products.product_id',$product_id)
                ->select('orders.created_at','order_products.quantity')
                ->get();

            $target =  DB::table('area_product_targets')
                ->where('area_id',$area_id)
                ->where('product_id',$product_id)
                ->Join('target_grades', 'area_product_targets.grade_id', '=', 'target_grades.id')
                ->select('target_grades.value')
                ->first();

            $threshold =  DB::table('area_product_targets')
                ->where('area_id',$area_id)
                ->where('product_id',$product_id)
                ->Join('target_grades', 'area_product_targets.grade_id', '=', 'target_grades.id')
                ->select('area_product_targets.threshold')
                ->first();
        }

        $salepermonth =[];
        $date = new \DateTime($originalDate);
        $start=1;
        $end= date(' t ', strtotime($originalDate) );
        for($start;$start<=$end;$start++) {
            $quantity = 0;
            foreach ($orders as $order) {
                if (isset($order->created_at) && $order->created_at != '') {
                    if (date('Y-m-d', strtotime($order->created_at)) == $date->format('Y-m-d')) {
                        $quantity += $order->quantity;
                    }
                }
            }
            $value = new \stdClass();
            $value->created_at = $date->format('Y-m-d');
            $value->quantity = $quantity;
            if (!empty($target) && !empty($threshold)){
                if (empty($area_id)) {
                    $value->target = $target;
                    $value->threshold = $threshold;
                } else {
                    $value->target = $target->value;
                    $value->threshold = $threshold->threshold;
                }
        }else{
                $value->target = 0;
                $value->threshold = 0;
            }

            $salepermonth[]=$value;
            $date->modify('+1 day');
        }
        return API::response()->array(['success' => true, 'message' => 'Sale Per Month',
            'data' => $salepermonth], 200);
    }
    /***
     * Get Supplier SO
     *
     * @param Request $request
     * @return mixed
     */
    public function supplierSo(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
            $date = $request->get('date_to_deliver');
            $supplierSoModel = new SupplierSo();
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)
                {$query->select(['id','firstname','lastname','image'])->with(['areas']);},
                ])->get();

            foreach ($sale_officers as $sale_officer){
                $sale_officer->sale_officer->so_orders_count=0;
                $so_Id = $sale_officer->sale_officer->id;
                foreach ($sale_officer->sale_officer->areas as $so_area){
                    $areaId=  $so_area->id;
                    $shop_ids = Customer::select('id')->where('area_id',$areaId)->where('sale_officer_id',$so_Id)->get();

                    $c= Order::wherein('shop_id',$shop_ids)
//                    $sale_officer->sale_officer->so_orders_count= Order::wherein('shop_id',$shop_ids)
                        ->where('date_to_deliver',$date)
                        ->where('status','!=','Delivered')
                        ->where('status','!=','Cleared')
                        ->where('status','!=','Rejected')
                        ->where('status','!=','Cancelled')
                        ->count();
                    $sale_officer->sale_officer->so_orders_count=$sale_officer->sale_officer->so_orders_count+ $c;
//                    return($sale_officer);

                }
            }
//            $avoidPagination = $request->get('avoid_pagination', false);
//            $page      = $request->get('page', 1);

//            if(IsNullOrEmptyString($userId)) {
//                $userId = $this->getUserIdFromToken($request);
//            }
//            $userLocations = $userLocationModel->getUserLocations($userId, $avoidPagination, $page);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier SO found',
            'data' => $sale_officers], 200);
    }
    public function supplierSoCustomers(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
            $date = $request->get('date_to_deliver');
            $supplierSoModel = new SupplierSo();
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)
                {$query->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)
                {$query->with('images');}]);},
                ])->get();

//            foreach ($sale_officers as $sale_officer){
//                $sale_officer->sale_officer->so_orders_count=0;
//                $so_Id = $sale_officer->sale_officer->id;
//                foreach ($sale_officer->sale_officer->areas as $so_area){
//                    $areaId=  $so_area->id;
//                    $customers = Customer::select('id')->where('area_id',$areaId)->where('sale_officer_id',$so_Id)->get();
//                    $sale_officer->sale_officer->customers = $customers;
//
//                    return($sale_officer);
//
//                }
//            }                    return($sale_officers);

//            $avoidPagination = $request->get('avoid_pagination', false);
//            $page      = $request->get('page', 1);

//            if(IsNullOrEmptyString($userId)) {
//                $userId = $this->getUserIdFromToken($request);
//            }
//            $userLocations = $userLocationModel->getUserLocations($userId, $avoidPagination, $page);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier SO found',
            'data' => $sale_officers], 200);
    }
    public function supplierPayments(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
            $date = $request->get('date_to_deliver');
//            $end_date = $request->get('date_to_deliver_end');
//            $start_date = date_create($start_date);
//            $end_date = date_create($end_date);
//            $difference = date_diff($start_date,$end_date);
//            $days = $difference->format('%a');
//            $data_sale_officers = array();

//            for ($x=0;$x<=$days;$x++){
//                $sale_officers = SupplierSo::where('supplier_id', $supplierId)
//                    ->with(['sale_officer' => function ($query) use ($start_date, $end_date, $supplierId) {
//                        $query->select(['id', 'firstname', 'lastname', 'image'])
//                            ->with(['so_customers' => function ($query) use ($start_date, $end_date, $supplierId) {
//                                $query->with(['images', 'payments' => function ($query) use ($start_date, $end_date, $supplierId) {
//                                    $query->whereDate('created_at', '=', $start_date)
//                                        ->where('user_id', $supplierId)->where('payment_type', '!=', 'Promise')->get();
//                                }]);
//                            }]);
//                    },
//                    ])->get();
//                foreach ($sale_officers as $index=>$sale_officer){
//                    $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
//
//                    $sale_officers_data[$x]['sale_officer'][] = $sale_officer->sale_officer;
//                }
//                $start_date = $start_date->modify('+1 day');
//            }

//            return $sale_officers_data;
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)use($date,$supplierId)
                {$query->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($date,$supplierId)
                {$query->with(['images','payments'=>function($query)use($date,$supplierId)
                {$query->whereDate('created_at','=',$date)->where('user_id',$supplierId)->where('payment_type','!=','Promise')->get();}]);}]);},
                ])->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier Payments',
            'data' => $sale_officers], 200);
    }
    public function supplierSoPromises(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
//            $date = $request->get('date_to_deliver');
//            $date=date_create($date);
//            $date = date_format($date,"Y-m-d");
//            return $date;

            $supplierSoModel = new SupplierSo();
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)
                {$query->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)
                {$query->with(['images','payments'=>function($query)
                {$query
//                    ->where('promise_cheque_date','=',$date)
                    ->where('payment_type','=','Promise')
                    ->get();}]);}]);},
                ])->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier SO found',
            'data' => $sale_officers], 200);
    }
    public function supplierSoAllOrder(Request $request)
    {
        try {
            $shop_ids=[];
            $sale_officers = SupplierSo::select('id','so_id','supplier_id')->where('supplier_id',$request->get('supplier_id'))
                ->with(['sale_officer'=>function($query){
                    $query->with(['so_customers']);
                }])
                ->get();
            foreach ($sale_officers as $so){
                if(count($so->sale_officer->so_customers)>0){
                    foreach ($so->sale_officer->so_customers as $so_cus){
                        $shop_ids[]=$so_cus['id'];
                    }
                }
            }
             $orders= Order::wherein('shop_id',$shop_ids)
                ->whereBetween('date_to_deliver', [$request->get('start_date'),$request->get('end_date')])
                ->where('type','!=','Sample')
               ->with(['customer'=>function($query){$query->with('images');},'order_products'=> function ($query) {
                   $query->with(['product'=>function($query){$query->with('images');},'order_product_category'=>function($query){$query->with('product_category_info');}]);
               }])
                ->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier SO Orders',
            'data' => $orders], 200);
    }
    /***
     * Get Supplier SO Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function supplierSoOrders(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
            $date = $request->get('date_to_deliver');
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)
                {$query->select(['id','firstname','lastname','image'])->with(['areas']);},
                ])->get();
            foreach ($sale_officers as $sale_officer){
                $so_Id = $sale_officer->sale_officer->id;
                foreach ($sale_officer->sale_officer->areas as $so_area){
                    $areaId=  $so_area->id;
                    $shop_ids = Customer::select('id')->where('area_id',$areaId)->where('sale_officer_id',$so_Id)->get();
                    $so_area['area_orders']= Order::wherein('shop_id',$shop_ids)
                        ->where('date_to_deliver',$date)
                        ->with('images','products')->get();
                    $obj1 = new \stdClass;
                    $obj2=[];

                    foreach ($so_area['area_orders'] as $value) {
                        foreach ($value->products as $item){
                            $order_product_category = '';
                            if (isset($item->pivot->id))
                                $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
                                    ->with('product_category_info')->get();
                            if(count($order_product_category)>0){
                                foreach ($order_product_category as $info){
                                    foreach ($info->product_category_info as $data)
                                        $info->name =  $data->name;
                                    unset($info->product_category_info);
                                }
                            }
                            $item->product_category = $order_product_category;
                            $obj2[] = $item;
                        }
                        $obj1 = $value;
                        $obj1->products = $obj2;
                        $value = $obj1;
                    }
                    foreach ($so_area['area_orders'] as $key =>$area_order){
                        $so_area['area_orders'][$key]['customer'] = Customer::where('id',$area_order['shop_id'])->with('images')->first();
                    }
                }

            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Supplier SO found',
            'data' => $sale_officers], 200);
    }
    /***
     * Get SO Orders Products
     *
     * @param Request $request
     * @return mixed
     */
//    public function soOrdersProducts(Request $request)
//    {
//        try {
//            $so_id = $request->get('so_id');
//            $date = $request->get('date_to_deliver');
////            $sale_officers = User::where('id',$so_id)
////                ->with(['areas'])->get();
//            $products_total= [];
//
////            foreach ($sale_officers as $sale_officer){
////                $so_Id = $sale_officer->id;
////                foreach ($sale_officer->areas as $so_area){
////                    $areaId=  $so_area->id;
//
////                    $shop_ids = Customer::select('id')->where('area_id',$areaId)
////                        ->where('sale_officer_id',$so_Id)
////                        ->get();
//
//                    $so_orders= Order::where('booked_by',$so_id)->where('status','Delivered')->where('type','!=','Sample')
//                        ->whereDate('date_to_deliver',$date)
//                        ->with(['products'=>function($query)
//                        {$query->select(['product_id','name']);}])->get();
//                    foreach ($so_orders as $index =>$value) {
//                            foreach ($value->products as $key => $item){
//                            $order_product_category = '';
//                            $ff=[];
//                            $products_total[$index][$key] = $item;
//                            $products_total[$index][$key]->quantity = $item->pivot->quantity;
//                            if (isset($item->pivot->id))
//                                $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
//                                    ->with('product_category_info')->get();
//                            $products_total[$index][$key]['product_category'] = [];
//                            if(count($order_product_category)>0){
//
//                                foreach ($order_product_category as $val =>$info) {
//
//                                    foreach ($info->product_category_info as $data) {
//                                        $data->quantity = $info->quantity;
//                                        $info->name = $data->name;
//                                        unset($info->product_category_info);
//                                    }
//                                    $ff[]=$info;
//                                }
//
//                            }
//                            $products_total[$index][$key]['product_category']=$ff;
//                            unset($item->pivot);
//
//                        }
//
//                    }
////                }
////            }
////                                    return count($products_total);
////                                    return $products_total;
//
//
//            $array=[];
//            $array1=[];
//            $array2=[];
//            $array3=[];
//            $array4=[];
//            $array5=[];
//            if(count(count($products_total))>0){
//                for ($a=0;$a<=count($products_total);$a++) {
//                    if (isset($products_total[$a]))
//                    {
//                        $quantity = 0;
//                    foreach ($products_total[$a] as $index => $product_total) {
//                        if (array_key_exists($product_total['product_id'], $array)) {
//                            $array[$product_total['product_id']] = $array[$product_total['product_id']] + $product_total['quantity'];
//                            if ($product_total['product_id'] == 12)
//                                $array2[] = $product_total['product_category'];
//                        } else {
//                            $array[$product_total['product_id']] = $quantity + $product_total['quantity'];
//                            $array1[$product_total['product_id']] = $product_total['name'];
//                            if ($product_total['product_id'] == 12)
//                                $array2[] = $product_total['product_category'];
//                        }
//
//                    }
//                }
//                }
//            }
//            if(count($array2)>0){
//                for ($b=0;$b<count($array2);$b++){
//                    $quantity=0;
//                    foreach ($array2[$b] as $index2=>$product_total2){
//                        if (array_key_exists($product_total2['product_category_id'], $array3)) {
//                            $array3[$product_total2['product_category_id']]=$array3[$product_total2['product_category_id']]+$product_total2['quantity'];
//
//                        }else{
//                            $array3[$product_total2['product_category_id']]=$quantity+$product_total2['quantity'];
//                            $array4[$product_total2['product_category_id']]=$product_total2['name'];
//                        }
//
//                    }
//                }
//            }
//            $main_array=[];
//            $y=0;
//            $z=0;
//            foreach ($array as $k=>$arr){
//                $main_array[$z]['name']=$array1[$k];
//                $main_array[$z]['product_id']=$k;
//                $main_array[$z]['quantity']=$arr;
//                if($k==12){
//
//
//                    foreach ($array3 as $index3=>$product_total3){
//                        $array5[$y]['product_category_id']=$index3;
//                        $array5[$y]['quantity']=$product_total3;
//                        $array5[$y]['name']=$array4[$index3];
//                        $y=$y+1;
//                    }
//                    $main_array[$z]['product_category']=$array5;
//                }
//
//                $z= $z+1;
//            }
//        }
//        catch(Exception $e)
//        {
//            return API::response()->array(['success' => false,
//                'message' => $e->getTraceAsString()], 400);
//        }
//        return API::response()->array(['success' => true, 'message' => 'SO Products Total',
//            'data' => $main_array], 200);
//    }
    public function soOrdersProducts(Request $request)
    {
        try {
            $main_array=[];
            $main=[];
            $so_id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $pre_start_date=date("Y-m-d",strtotime("-1 month",strtotime($start_date )));
            $pre_end_date=date("Y-m-d",strtotime("-1 month",strtotime($end_date )));
            $orders=Order::select('id')
                ->where('booked_by',$so_id)
//                ->where('status','Delivered')
//                ->where('type','!=','Sample')
                ->whereBetween('date_to_deliver', [$start_date,$end_date])
                ->get();


            $pre_orders=Order::select('id')
                ->where('booked_by',$so_id)
//                ->where('status','Delivered')
//                ->where('type','!=','Sample')
                ->whereBetween('date_to_deliver', [$pre_start_date,$pre_end_date])
                ->get();
            $products=Product::select('id','name')->where('category_id',1)->get();
//            $products=Product::select('id','name')->get();
//            dd($products);
            foreach ($products as $key=>$product){
                $main_array[$key]['id']=$product['id'];
                $main_array[$key]['name']=$product['name'];
                $quantity=0;
                $pre_quantity=0;
                if(!empty($orders) && count($orders)>0){
                    foreach ($orders as $order){
                        $orderProd=OrderProduct::select('id','quantity')->where('order_id',$order['id'])
                            ->where('product_id',$product['id'])
                            ->first();
                        if(!empty($orderProd) ) {
                            $quantity = $quantity + $orderProd['quantity'];
                        }
                        $main[]=$orderProd;
                    }
                }
                if(!empty($pre_orders) && count($pre_orders)>0){
                    foreach ($pre_orders as $pre_order){
                        $orderProd=OrderProduct::select('id','quantity')->where('order_id',$pre_order['id'])
                            ->where('product_id',$product['id'])
                            ->first();
                        if(!empty($orderProd) ) {
                            $pre_quantity = $pre_quantity + $orderProd['quantity'];
                        }
                        $main[]=$orderProd;
                    }
                }

                $so_stock=SoStock::where('product_id',$product['id'])
                    ->where('so_id',$so_id)
                    ->first();
                if(!empty($so_stock['qty'])){
                    $main_array[$key]['stock']=$so_stock['qty'];
                }else{
                    $main_array[$key]['stock']=0;
                }
                $main_array[$key]['quantity']=$quantity;
                $main_array[$key]['pre_quantity']=$pre_quantity;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Products Total',
            'data' => $main_array], 200);
    }
    public function soOrdersProducts_old(Request $request)
    {
        try {
            $so_id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $total_products = array();
            for ($x = 0; $x <= $days; $x++) {
                $products_total = [];
//                $total_products[$x]['date'] = $start_date->format('Y-m-d');
                $so_orders = Order::where('booked_by', $so_id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                    ->whereDate('date_to_deliver', $start_date)
                    ->with(['products' => function ($query) {
                        $query->select(['product_id', 'name']);
                    }])->get();

                foreach ($so_orders as $index => $value) {
                    foreach ($value->products as $key => $item) {
                        $order_product_category = '';
                        $ff = [];
                        $products_total[$index][$key] = $item;
                        $products_total[$index][$key]->quantity = $item->pivot->quantity;
                        if (isset($item->pivot->id))
                            $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
                                ->with('product_category_info')->get();
                        $products_total[$index][$key]['product_category'] = [];
                        if (!empty($order_product_category) && count($order_product_category) > 0) {
                            foreach ($order_product_category as $val => $info) {

                                foreach ($info->product_category_info as $data) {
                                    $data->quantity = $info->quantity;
                                    $info->name = $data->name;
                                    unset($info->product_category_info);
                                }
                                $ff[] = $info;
                            }
                        }
                        $products_total[$index][$key]['product_category'] = $ff;
                        unset($item->pivot);
                    }
                }
//                }
//            }
//                                    return count($products_total);
//                                    return $products_total;
                $array = [];
                $array1 = [];
                $array2 = [];
                $array3 = [];
                $array4 = [];
                $array5 = [];
                if (count(count($products_total)) > 0) {
                    for ($a = 0; $a <= count($products_total); $a++) {
                        if (isset($products_total[$a])) {
                            $quantity = 0;
                            foreach ($products_total[$a] as $index => $product_total) {
                                if (array_key_exists($product_total['product_id'], $array)) {
                                    $array[$product_total['product_id']] = $array[$product_total['product_id']] + $product_total['quantity'];
                                    if ($product_total['product_id'] == 12)
                                        $array2[] = $product_total['product_category'];
                                } else {
                                    $array[$product_total['product_id']] = $quantity + $product_total['quantity'];
                                    $array1[$product_total['product_id']] = $product_total['name'];
                                    if ($product_total['product_id'] == 12)
                                        $array2[] = $product_total['product_category'];
                                }

                            }
                        }
                    }
                }
                if (count($array2) > 0) {
                    for ($b = 0; $b < count($array2); $b++) {
                        $quantity = 0;
                        foreach ($array2[$b] as $index2 => $product_total2) {
                            if (array_key_exists($product_total2['product_category_id'], $array3)) {
                                $array3[$product_total2['product_category_id']] = $array3[$product_total2['product_category_id']] + $product_total2['quantity'];

                            } else {
                                $array3[$product_total2['product_category_id']] = $quantity + $product_total2['quantity'];
                                $array4[$product_total2['product_category_id']] = $product_total2['name'];
                            }

                        }
                    }
                }
                $main_array = [];
                $y = 0;
                $z = 0;
                foreach ($array as $k => $arr) {
                    $main_array[$z]['name'] = $array1[$k];
                    $main_array[$z]['product_id'] = $k;
                    $main_array[$z]['quantity'] = $arr;
                    if ($k == 12) {
                        foreach ($array3 as $index3 => $product_total3) {
                            $array5[$y]['product_category_id'] = $index3;
                            $array5[$y]['quantity'] = $product_total3;
                            $array5[$y]['name'] = $array4[$index3];
                            $y = $y + 1;
                        }
                        $main_array[$z]['product_category'] = $array5;
                    }
                    $z = $z + 1;
                }
                $total_products[$x]['total_products'] = $main_array;
                $start_date = $start_date->modify('+1 day');
            }
            $array_a = [];
            $array1_a = [];
            $array2_a = [];
            $array3_a = [];
            $array4_a = [];
            $array5_a = [];
            if (count(count($total_products)) > 0) {
                for ($a = 0; $a <= count($total_products); $a++) {
                    if (isset($total_products[$a])) {
                        $quantity = 0;
                        foreach ($total_products[$a]['total_products']as $index => $product_total) {

                            if (array_key_exists($product_total['product_id'], $array_a)) {
                                $array_a[$product_total['product_id']] = $array_a[$product_total['product_id']] + $product_total['quantity'];
                                if ($product_total['product_id'] == 12)
                                    $array2_a[] = $product_total['product_category'];
                            } else {
                                $array_a[$product_total['product_id']] = $quantity + $product_total['quantity'];
                                $array1_a[$product_total['product_id']] = $product_total['name'];
                                if ($product_total['product_id'] == 12)
                                    $array2_a[] = $product_total['product_category'];
                            }

                        }
                    }
                }
            }
            if (count($array2_a) > 0) {
                for ($b = 0; $b < count($array2_a); $b++) {
                    $quantity = 0;
                    foreach ($array2_a[$b] as $index2 => $product_total2) {
                        if (array_key_exists($product_total2['product_category_id'], $array3_a)) {
                            $array3_a[$product_total2['product_category_id']] = $array3_a[$product_total2['product_category_id']] + $product_total2['quantity'];

                        } else {
                            $array3_a[$product_total2['product_category_id']] = $quantity + $product_total2['quantity'];
                            $array4_a[$product_total2['product_category_id']] = $product_total2['name'];
                        }

                    }
                }
            }
            $main_array = [];
            $y = 0;
            $z = 0;
            foreach ($array_a as $k => $arr) {
                $main_array[$z]['name'] = $array1_a[$k];
                $main_array[$z]['product_id'] = $k;
                $main_array[$z]['quantity'] = $arr;
                $so_stock = SoStock::where('so_id',$so_id)->where('product_id',$k)
                    ->with(['stock_product'=>function($query)
                    {$query->select(['id','name']);},
                    ])->first();
                $main_array[$z]['stock_quantity'] = $so_stock->qty;

                if ($k == 12) {
                    foreach ($array3_a as $index3 => $product_total3) {
                        $array5_a[$y]['product_category_id'] = $index3;
                        $array5_a[$y]['quantity'] = $product_total3;
                        $array5_a[$y]['name'] = $array4_a[$index3];
                        $y = $y + 1;
                    }
                    $main_array[$z]['product_category'] = $array5_a;
                }

                $z = $z + 1;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Products Total',
            'data' => $main_array], 200);
    }
    /***
     * Get SO Stock Products
     *
     * @param Request $request
     * @return mixed
     */
    public function BookingDetail(Request $request){
        try {
 $dis_stoc=StockBooking::where('id',$request->id)->with(['stock_details','Book_By','stockImages','stock_bilty','stock_adda','po_numbers'=>function($query){return $query->with('po_remarks');},'party_info'=>function($query){return $query->with('soul_distributer');}])->first();
//            $dis_stoc=StockBookingDetail::where('stock_booking_id',$request->get('id'))->with(['product_category','product'])->get();
            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Bilty Details',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    public function BookingDetailRaw(Request $request){
        try {
            $dis_stoc=StockBooking::where('id',$request->get('id'))->with(['stock_details_raw','Book_By','BookTo','stock_bilty_raw','po_numbers','party_info'])->first();

            return API::response()->array(['success' => true,
                'message' => 'Stock Booking Bilty Details',
                'data'    => $dis_stoc], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
    public function soStockProducts(Request $request)
    {
        try {
            $soId = $request->get('so_id');
            $so_stocks = SoStock::where('so_id',$soId)
                ->with(['stock_product'=>function($query)
                {$query->select(['id','name']);},
                ])->get();
            $stock_quantity = [];
            foreach ($so_stocks as $key=>$so_stock){
                $stock_quantity[$key]['product_id'] =  $so_stock->product_id;
                $stock_quantity[$key]['name'] =  $so_stock->stock_product->name;
                $stock_quantity[$key]['quantity'] =  $so_stock->qty;
            }
//            return $stock_quantity;
            $products_total= [];
            $array=[];
            $array1=[];
            $array2=[];
            $array3=[];
            $array4=[];
            $array5=[];
            if(count(count($products_total))>0){
                for ($a=0;$a<count($products_total);$a++){
                    $quantity=0;
                    foreach ($products_total[$a] as $index=>$product_total){
                        if (array_key_exists($product_total['product_id'], $array)) {
                            $array[$product_total['product_id']]=$array[$product_total['product_id']]+$product_total['quantity'];
                            if($product_total['product_id']==12)
                                $array2[]=$product_total['product_category'];
                        }else{
                            $array[$product_total['product_id']]=$quantity+$product_total['quantity'];
                            $array1[$product_total['product_id']]=$product_total['name'];
                            if($product_total['product_id']==12)
                                $array2[]=$product_total['product_category'];
                        }

                    }
                }
            }
            if(count($array2)>0){
                for ($b=0;$b<count($array2);$b++){
                    $quantity=0;
                    foreach ($array2[$b] as $index2=>$product_total2){
                        if (array_key_exists($product_total2['product_category_id'], $array3)) {
                            $array3[$product_total2['product_category_id']]=$array3[$product_total2['product_category_id']]+$product_total2['quantity'];

                        }else{
                            $array3[$product_total2['product_category_id']]=$quantity+$product_total2['quantity'];
                            $array4[$product_total2['product_category_id']]=$product_total2['name'];
                        }

                    }
                }
            }
            $main_array=[];
            $y=0;
            $z=0;
            foreach ($array as $k=>$arr){
                $main_array[$z]['name']=$array1[$k];
                $main_array[$z]['product_id']=$k;
                $main_array[$z]['quantity']=$arr;
                if($k==12){


                    foreach ($array3 as $index3=>$product_total3){
                        $array5[$y]['product_category_id']=$index3;
                        $array5[$y]['quantity']=$product_total3;
                        $array5[$y]['name']=$array4[$index3];
                        $y=$y+1;
                    }
                    $main_array[$z]['product_category']=$array5;
                }

                $z= $z+1;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Stock Products Total',
            'data' => $stock_quantity], 200);
    }
    public function soProduct(Request $request)
    {
        try {
            $so_stocks = SoStock::where('so_id',$request->get('so_id'))->where('product_id',$request->get('product_id'))
                ->with(['stock_product'=>function($query)
                {$query->select(['id','name']);},
                ])->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Product',
            'data' => $so_stocks], 200);
    }
    /***
     * Get Supplier SO Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function soDeliverProducts(Request $request)
    {
        try {
            $supplierId = $request->get('supplier_id');
            $date = $request->get('date_to_deliver');
            $sale_officers = SupplierSo::where('supplier_id',$supplierId)
                ->with(['sale_officer'=>function($query)
                {$query->select(['id','firstname','lastname','image'])->with(['areas']);},
                ])->get();
            $products_total= [];

            foreach ($sale_officers as $sale_officer){
                $so_Id = $sale_officer->sale_officer->id;
                foreach ($sale_officer->sale_officer->areas as $so_area){
                    $areaId=  $so_area->id;

                    $shop_ids = Customer::select('id')->where('area_id',$areaId)
                        ->where('sale_officer_id',$so_Id)
                        ->get();

                    $so_area['area_orders']= Order::wherein('shop_id',$shop_ids)
                        ->where('date_to_deliver',$date)
                        ->with(['products'=>function($query)
                    {$query->select(['product_id','name']);}])->get();
                    foreach ($so_area['area_orders'] as $index =>$value) {
                        foreach ($value->products as $key => $item){
                            $order_product_category = '';
                            $ff=[];
                            $products_total[$index][$key] = $item;
                            $products_total[$index][$key]->quantity = $item->pivot->quantity;
                            if (isset($item->pivot->id))
                                $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
                                    ->with('product_category_info')->get();
                            $products_total[$index][$key]['product_category'] = [];
                            if(count($order_product_category)>0){

                                foreach ($order_product_category as $val =>$info) {

                                    foreach ($info->product_category_info as $data) {
                                    $data->quantity = $info->quantity;
                                    $info->name = $data->name;
                                    unset($info->product_category_info);
                                }
                                    $ff[]=$info;
                                }

                            }
                            $products_total[$index][$key]['product_category']=$ff;
                            unset($item->pivot);
                        }
//                        return $products_total;

                    }
                }
            }
            $array=[];
            $array1=[];
            $array2=[];
            $array3=[];
            $array4=[];
            $array5=[];
            if(count(count($products_total))>0){
                for ($a=0;$a<count($products_total);$a++){
                    $quantity=0;
                    foreach ($products_total[$a] as $index=>$product_total){
                        if (array_key_exists($product_total['product_id'], $array)) {
                            $array[$product_total['product_id']]=$array[$product_total['product_id']]+$product_total['quantity'];
                            if($product_total['product_id']==12)
                                $array2[]=$product_total['product_category'];
                        }else{
                            $array[$product_total['product_id']]=$quantity+$product_total['quantity'];
                            $array1[$product_total['product_id']]=$product_total['name'];
                            if($product_total['product_id']==12)
                                $array2[]=$product_total['product_category'];
                        }

                    }
                }
            }
            if(count($array2)>0){
                for ($b=0;$b<count($array2);$b++){
                    $quantity=0;
                    foreach ($array2[$b] as $index2=>$product_total2){
                        if (array_key_exists($product_total2['product_category_id'], $array3)) {
                            $array3[$product_total2['product_category_id']]=$array3[$product_total2['product_category_id']]+$product_total2['quantity'];

                        }else{
                            $array3[$product_total2['product_category_id']]=$quantity+$product_total2['quantity'];
                            $array4[$product_total2['product_category_id']]=$product_total2['name'];
                        }

                    }
                }
            }
            $main_array=[];
            $y=0;
            $z=0;
            foreach ($array as $k=>$arr){
                $main_array[$z]['name']=$array1[$k];
                $main_array[$z]['product_id']=$k;
                $main_array[$z]['quantity']=$arr;
               if($k==12){


                   foreach ($array3 as $index3=>$product_total3){
                       $array5[$y]['product_category_id']=$index3;
                       $array5[$y]['quantity']=$product_total3;
                       $array5[$y]['name']=$array4[$index3];
                       $y=$y+1;
                   }
                   $main_array[$z]['product_category']=$array5;
               }

                $z= $z+1;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Products Total',
            'data' => $main_array], 200);
    }
    /***
     * Get Supplier SO Sample
     *
     * @param Request $request
     * @return mixed
     */
    public function soDeliverSample(Request $request)
    {
        try {
            $so_id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $total_products = array();
            for ($x = 0; $x <= $days; $x++) {
                $products_total = [];
                $so_orders = Order::where('booked_by', $so_id)->where('status', 'Delivered')->where('type','Sample')
                    ->whereDate('date_to_deliver', $start_date)
                    ->with(['products' => function ($query) {
                        $query->select(['product_id', 'name']);
                    }])->get();
                foreach ($so_orders as $index => $value) {
                    foreach ($value->products as $key => $item) {
                        $order_product_category = '';
                        $ff = [];
                        $products_total[$index][$key] = $item;
                        $products_total[$index][$key]->quantity = $item->pivot->quantity;
                        if (isset($item->pivot->id))
                            $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
                                ->with('product_category_info')->get();
                        $products_total[$index][$key]['product_category'] = [];
                        if (count($order_product_category) > 0) {

                            foreach ($order_product_category as $val => $info) {

                                foreach ($info->product_category_info as $data) {
                                    $data->quantity = $info->quantity;
                                    $info->name = $data->name;
                                    unset($info->product_category_info);
                                }
                                $ff[] = $info;
                            }

                        }
                        $products_total[$index][$key]['product_category'] = $ff;
                        unset($item->pivot);

                    }
                }
                $array = [];
                $array1 = [];
                $array2 = [];
                $array3 = [];
                $array4 = [];
                $array5 = [];
                if (count(count($products_total)) > 0) {
                    for ($a = 0; $a <= count($products_total); $a++) {
                        if (isset($products_total[$a])) {
                            $quantity = 0;
                            foreach ($products_total[$a] as $index => $product_total) {
                                if (array_key_exists($product_total['product_id'], $array)) {
                                    $array[$product_total['product_id']] = $array[$product_total['product_id']] + $product_total['quantity'];
                                    if ($product_total['product_id'] == 12)
                                        $array2[] = $product_total['product_category'];
                                } else {
                                    $array[$product_total['product_id']] = $quantity + $product_total['quantity'];
                                    $array1[$product_total['product_id']] = $product_total['name'];
                                    if ($product_total['product_id'] == 12)
                                        $array2[] = $product_total['product_category'];
                                }

                            }
                        }
                    }
                }
                if (count($array2) > 0) {
                    for ($b = 0; $b < count($array2); $b++) {
                        $quantity = 0;
                        foreach ($array2[$b] as $index2 => $product_total2) {
                            if (array_key_exists($product_total2['product_category_id'], $array3)) {
                                $array3[$product_total2['product_category_id']] = $array3[$product_total2['product_category_id']] + $product_total2['quantity'];

                            } else {
                                $array3[$product_total2['product_category_id']] = $quantity + $product_total2['quantity'];
                                $array4[$product_total2['product_category_id']] = $product_total2['name'];
                            }

                        }
                    }
                }
                $main_array = [];
                $y = 0;
                $z = 0;
                foreach ($array as $k => $arr) {
                    $main_array[$z]['name'] = $array1[$k];
                    $main_array[$z]['product_id'] = $k;
                    $main_array[$z]['quantity'] = $arr;
                    if ($k == 12) {


                        foreach ($array3 as $index3 => $product_total3) {
                            $array5[$y]['product_category_id'] = $index3;
                            $array5[$y]['quantity'] = $product_total3;
                            $array5[$y]['name'] = $array4[$index3];
                            $y = $y + 1;
                        }
                        $main_array[$z]['product_category'] = $array5;
                    }

                    $z = $z + 1;
                }

                $total_products[$x]['total_products'] = $main_array;
                $start_date = $start_date->modify('+1 day');
            }
            $array_a = [];
            $array1_a = [];
            $array2_a = [];
            $array3_a = [];
            $array4_a = [];
            $array5_a = [];
            if (count(count($total_products)) > 0) {
                for ($a = 0; $a <= count($total_products); $a++) {
                    if (isset($total_products[$a])) {
                        $quantity = 0;
                        foreach ($total_products[$a]['total_products']as $index => $product_total) {

                            if (array_key_exists($product_total['product_id'], $array_a)) {
                                $array_a[$product_total['product_id']] = $array_a[$product_total['product_id']] + $product_total['quantity'];
                                if ($product_total['product_id'] == 12)
                                    $array2_a[] = $product_total['product_category'];
                            } else {
                                $array_a[$product_total['product_id']] = $quantity + $product_total['quantity'];
                                $array1_a[$product_total['product_id']] = $product_total['name'];
                                if ($product_total['product_id'] == 12)
                                    $array2_a[] = $product_total['product_category'];
                            }

                        }
                    }
                }
            }
            if (count($array2_a) > 0) {
                for ($b = 0; $b < count($array2_a); $b++) {
                    $quantity = 0;
                    foreach ($array2_a[$b] as $index2 => $product_total2) {
                        if (array_key_exists($product_total2['product_category_id'], $array3_a)) {
                            $array3_a[$product_total2['product_category_id']] = $array3_a[$product_total2['product_category_id']] + $product_total2['quantity'];

                        } else {
                            $array3_a[$product_total2['product_category_id']] = $quantity + $product_total2['quantity'];
                            $array4_a[$product_total2['product_category_id']] = $product_total2['name'];
                        }

                    }
                }
            }
            $main_array = [];
            $y = 0;
            $z = 0;
            foreach ($array_a as $k => $arr) {
                $main_array[$z]['name'] = $array1_a[$k];
                $main_array[$z]['product_id'] = $k;
                $main_array[$z]['quantity'] = $arr;
                if ($k == 12) {


                    foreach ($array3_a as $index3 => $product_total3) {
                        $array5_a[$y]['product_category_id'] = $index3;
                        $array5_a[$y]['quantity'] = $product_total3;
                        $array5_a[$y]['name'] = $array4_a[$index3];
                        $y = $y + 1;
                    }
                    $main_array[$z]['product_category'] = $array5_a;
                }

                $z = $z + 1;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Products Total',
            'data' => $main_array], 200);
    }
    /***
     * Get Supplier SO
     *
     * @param Request $request
     * @return mixed
     */
    public function areaOrders(Request $request)
    {
        try {
            $areaId = $request->get('area_id');
            $so_Id = $request->get('so_id');
            $date = $request->get('date_to_deliver');
            $shop_ids = Customer::select('id')->where('area_id',$areaId)->where('sale_officer_id',$so_Id)->get();
            $area_orders= Order::wherein('shop_id',$shop_ids)
                ->where('date_to_deliver',$date)
                ->with('images','products')->get();
            $obj1 = new \stdClass;
            $obj2=[];

                foreach ($area_orders as $value) {
                    foreach ($value->products as $item){
                        $order_product_category = '';
                        if (isset($item->pivot->id))
                            $order_product_category = OrderProductCategory::where('order_product_id', $item->pivot->id)
                                ->with('product_category_info')->get();
                        if(count($order_product_category)>0){
                            foreach ($order_product_category as $info){
                                foreach ($info->product_category_info as $data)
                                    $info->name =  $data->name;
                                unset($info->product_category_info);
                            }
                        }
                        $item->product_category = $order_product_category;
                        $obj2[] = $item;
                    }
                    $obj1 = $value;
                    $obj1->products = $obj2;
                    $value = $obj1;
                }
            foreach ($area_orders as $key =>$area_order){
                $area_orders[$key]['customer'] = Customer::where('id',$area_order['shop_id'])->with('images')->first();
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Area Orders found',
            'data' => $area_orders], 200);
    }
    /***
     * Get SO Areas
     *
     * @param Request $request
     * @return mixed
     */
    public function soAreas(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $date = $request->get('date_to_deliver');

//            $so_areas = User::select('id','firstname','image')->where('id',$so_Id)->with('areas')->get();
            $so = User::select('id','firstname','image')->where('id',$so_Id)->get();

            $area_ids = UserArea::select('area_id')->where('user_id',$so_Id)->get();
            $areas = Area::wherein('id',$area_ids)->get();
            foreach ($areas  as $key => $area){
                $shop_id = Customer::select('id')->where('area_id',$area['id'])->where('sale_officer_id',$so_Id)->get();
//                return $shop_id;

                $area_orders_count= Order::wherein('shop_id',$shop_id)
                    ->where('date_to_deliver',$date)
                    ->where('status','!=','Delivered')
                    ->where('status','!=','Cleared')
                    ->where('status','!=','Rejected')
                    ->where('status','!=','Cancelled')
                    ->count();
                $areas[$key]['orders_count'] = $area_orders_count;
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Areas found',
            'data' => $areas], 200);
    }
    /***
     * Get SO Payments
     *
     * @param Request $request
     * @return mixed
     */
    public function soPaymentsDetail(Request $request){
        try {
            $obj=PaymentReceived::where('id',$request->get('detail_id'))->with(['images','customer','bank_info'])->first();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'payment detail',
            'data' => $obj], 200);
    }
    public function soPayments(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
//                        $date = $request->get('created_at');

            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x=0;$x<=$days;$x++){
                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('promise_cheque_date','=',$start_date)->where('user_id',$so_Id)
                        ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->get();}]);},
                    ])->get();
                foreach ($payments as $payment){
                    $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$x]['so_payment'][] = $payment;
                }


                $start_date = $start_date->modify('+1 day');
            }

//            return $sale_officers_data;



        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payments found',
            'data' => $sale_officers_data], 200);
    }
    public function soPaymentsPk(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $sale_officers_data = array();
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$so_Id)->get();
                $user_ids=[];
                $user_ids[]=$so_Id;
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }
                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id,$user_ids,$end_date)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id,$user_ids,$end_date)
                    {$query->whereBetween('promise_cheque_date', [$start_date, $end_date])->wherein('user_id',$user_ids)
                        ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->with(['user'=>function($query){$query->select('id','firstname','lastname');}])->get();}]);},
                    ])->get();
                foreach ($payments as $ke=>$payment){
                    $sale_officers_data[$ke]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$ke]['so_payment'][] = $payment;
                }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payments found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Bilties
     *
     * @param Request $request
     * @return mixed
     */
    public function soBilties(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
                $bilties= User::select(['id','firstname','lastname','image']);
            if(!empty($so_Id)){
                $bilties=$bilties->  where('id',$so_Id);
            }
            $bilties=$bilties->with(['so_bilties'=>function($query){
                        $query->where('status','!=','Received')->get();
                    }])->get();
            foreach ($bilties as $bilty){
                $bilties =  $bilty->so_bilties;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Bilties found',
            'data' => $bilties], 200);
    }
    public function BiltyStatus(Request $request)
    {
        try {
            Bilti::where('id', $request->get('id'))
                ->update(array('status' => 'Received'));
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Bilty Received',
        ], 200);
    }
    /***
     * Get SO Bilty Detail
     *
     * @param Request $request
     * @return mixed
     */
    public function soBiltyDetail(Request $request)
    {
        try {
            $bilty_Id = $request->id;

            $bilty_detail= Bilti::where('id',$bilty_Id)
            ->with(['biltyImages','dsf_recovery','logs_remarks' =>function($query)
                { $query->where('type','edit_bilty_log');},
                'bilty_supplier','party_info',
                'Inventory_report'=>function($query)
                {$query->with(['bilty','product','RawMaterial'])->get();},
                'bilty_detail'=>function($query)
                {$query->with(['bilty_product',
                    'bilty_detail_type'=>function($query)
                    {$query->with(['productCategory'])->get();}])->get();},])->get();

            $detail = [];
            foreach ($bilty_detail as $bilty){

                $detail['id'] =  $bilty->id;
                $detail['stock_booking_id'] =  $bilty->stock_booking_id;
                $detail['supplier_name'] =  $bilty->bilty_supplier->firstname;
                $detail['biltyImages'] =  $bilty->biltyImages;
                $detail['bilti_date'] =  $bilty->bilti_date;
                $detail['dsf_recovery'] =  $bilty->dsf_recovery;
                $detail['bilti_no'] =  $bilty->bilti_no;
                $detail['price'] =  $bilty->price;
                $detail['total_points'] =  $bilty->total_points;
                $detail['delivered_date'] =  $bilty->delivered_date;
                $detail['discount'] =  $bilty->discount;
                $detail['payment'] =  $bilty->payment;
                $detail['vendor_price'] =  $bilty->vendor_price;
                $detail['invoice_no'] =  $bilty->invoice_no;
                $detail['remarks'] =  $bilty->remarks;
                $detail['accountant_price'] =  $bilty->accountant_price;
                $detail['party_id'] =  $bilty->party_id;
                $detail['party_info'] =  $bilty->party_info;
                $detail['logs_remarks'] =  $bilty->logs_remarks;
                $detail['book_by'] =  $bilty->bookBy;
                $detail['admin_remarks'] =  $bilty->admin_remarks;
                $detail['admin_status'] =  $bilty->admin_status;
                $detail['accountant_vendor_status'] =  $bilty->accountant_vendor_status;
                $detail['po_no'] =  $bilty->po_no;
                $detail['status'] =  $bilty->status;

                foreach ($bilty->bilty_detail as $key =>$bilty_detail){

                    
                    $detail['products'][$key]['quantity'] = $bilty_detail->quantity;
                    $detail['products'][$key]['cotton'] = $bilty_detail->bilty_product->cotton;
                    $detail['products'][$key]['price'] = $bilty_detail->price;
                     $detail['accountant_vendor_price'] =  $bilty->accountant_vendor_price;
                    $detail['products'][$key]['discount'] = $bilty_detail->discount;
                    $detail['products'][$key]['payment'] = $bilty_detail->payment;
                    $detail['products'][$key]['vendor_price'] = $bilty_detail->vendor_price;
                    $detail['products'][$key]['name'] = $bilty_detail->bilty_product->name;
                    $detail['products'][$key]['id'] = $bilty_detail->bilty_product->id;
                    $detail['products'][$key]['product_code'] = $bilty_detail->bilty_product->product_code;

                     $detail['products'][$key]['raw_detail'] = [];
                     foreach ( $bilty_detail->bilty_product->raw_product as $x=>$raw_products){
                       
                        $detail['raw_products'][$key]['id'] = $raw_products->RawMaterial->id;
                       
                          $sum = 0;
                        $total_price = 0;
                        $quantity_used     = InventoryReport::where('bilty_id',$detail['id'])->where('product_id',$detail['products'][$key]['id'])->where('raw_materiel_id',$detail['raw_products'][$key]['id'] )->get();

                       

                        foreach ($quantity_used as $value) {
                              $sum=  $sum + $value->total_qty;
                                $total_price=  $total_price + $value->price;
                       }

                         $detail['products'][$key]['raw_detail'][$x] = $raw_products->RawMaterial;
                         
                        $detail['products'][$key]['raw_detail'][$x]['quantity_used'] =$sum;
                    
       
                        $detail['products'][$key]['raw_detail'][$x]['total_price'] = $total_price;
                     }

                    // $bilty_detail->bilty_product->raw_product->RawMaterial;
                    $detail['products'][$key]['product_detail_type'] = [];
                    foreach ($bilty_detail->bilty_detail_type as $x=>$bilty_detail_type){
//                        return $bilty_detail_type;
                        $detail['products'][$key]['product_detail_type'][$x] = $bilty_detail_type;
                    }
                }
               // foreach ($bilty->Inventory_report as $key => $inv){
                 //    $detail['inventory_report'][$key] = $inv;
            
               //};

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Bilty Detail',
            'data' => $detail], 200);
    }
     public function soBiltyDetailRaw(Request $request)
    {
        try {
            $bilty_Id = $request->get('id');

            $bilty_detail= Bilti::where('id',$bilty_Id)
                ->with(['biltyImages','bilty_supplier','bilty_detail'=>function($query)
                {$query->with(['bilty_product_raw'])->get();},])->get();
//            return $bilty_detail;
            $detail = [];
            foreach ($bilty_detail as $bilty){
//                return $bilty->bilty_detail;
                $detail['id'] =  $bilty->id;
                $detail['stock_booking_id'] =  $bilty->stock_booking_id;
                $detail['supplier_name'] =  $bilty->bilty_supplier->firstname;
                $detail['biltyImages'] =  $bilty->biltyImages;
                $detail['bilti_date'] =  $bilty->bilti_date;
                $detail['bilti_no'] =  $bilty->bilti_no;
                $detail['price'] =  $bilty->price;
                $detail['discount'] =  $bilty->discount;
                $detail['payment'] =  $bilty->payment;
                $detail['vendor_price'] =  $bilty->vendor_price;
                $detail['invoice_no'] =  $bilty->invoice_no;
                $detail['vendor_invoice_id'] =  $bilty->vendor_invoice_no;
                $detail['remarks'] =  $bilty->remarks;
                $detail['accountant_price'] =  $bilty->accountant_price;
                $detail['book_by'] =  $bilty->bookBy;
                $detail['admin_remarks'] =  $bilty->admin_remarks;
                $detail['admin_status'] =  $bilty->admin_status;
                $detail['accountant_vendor_status'] =  $bilty->accountant_vendor_status;
                $detail['po_no'] =  $bilty->po_no_raw;
                $detail['status'] =  $bilty->status;
                foreach ($bilty->bilty_detail as $key =>$bilty_detail){
//                    return $bilty_detail->bilty_product->name;
                    $detail['products'][$key]['quantity'] = $bilty_detail->quantity;

                    $detail['products'][$key]['price'] = $bilty_detail->price;
                    $detail['accountant_vendor_price'] =  $bilty->accountant_vendor_price;
                    $detail['products'][$key]['payment'] = $bilty_detail->payment;
                    $detail['products'][$key]['vendor_price'] = $bilty_detail->vendor_price;
                    $detail['products'][$key]['name'] = $bilty_detail->bilty_product_raw->name;
                    $detail['products'][$key]['id'] = $bilty_detail->bilty_product_raw->id;
                    $detail['products'][$key]['product_detail_type'] = [];
                    
                }

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Bilty Detail',
            'data' => $detail], 200);
    }
    
    
    public function modifyBilty(Request $request){

        try {
            $bilty=Bilti::where('id',$request->get('id'))->first();
            if(!empty($bilty)){
                $bilty->remarks=$request->get('remarks');
                $bilty->save();
                //Image upload
                if(!empty($request->get('uploadimages'))) {
                    $images = [];
                    foreach($request->get('uploadimages') as $image) {
                        $image = upload_base64_image($image, 'uploads/bilty/',
                            'image-');
                        $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                        $customerImage->image =  'http://'.$image;
                        $images[] = $customerImage;
                    }
                    if(count($images) > 0) {
                        $bilty->biltyImages()->saveMany($images);
                    }
                }
            }
            return API::response()->array(['success' => true,
                'message' => 'Bilty Images added ',
               ], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }

    }
     public function AddBilty(Request $request)
{
    try {

        $bilty= new Bilti();
        $bilty->stock_booking_id=$request->stock_booking_id;
        $bilty->supplier_id=$request->supplier_id;
        $bilty->delivered_to_id=$request->booked_by;

        $bilty->party_id=$request->party_id;

        $bilty->bilti_no=$request->biltyNo;
        $bilty->bilti_date=date("Y-m-d");
        $bilty->delivered_date = date("Y-m-d");

        $bilty->gatepass=$request->gate_pass;
        $bilty->po_no=$request->po_no;


        $bilty->uuid=$request->uuid;

        $bilty->remarks=$request->remarks;

        $bilty->status='On The Way';

        $total_price=0;
        $totalvendor_price = 0;
        $vendor_price=0;

        

        if(count($request->stock_details)>0) {
            
            //// 19 id cod and 20 id head office ///
            if($request->party_id == 19 || $request->party_id  == 20){

             foreach ($request->stock_details as $stock) {

                if($stock['quantity'] > 0 ){
                    $product_prices = Product::where('id', $stock['product_id'])->first();

                    if (count($product_prices->productCategory) > 0 ){                        

                        foreach ($stock['product_category'] as $key => $subproduct) {

                           $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$subproduct['id'])->first();
                           if($warehousestockvariant){
                               $warehousestockvariant->quantity  =  $warehousestockvariant->quantity + $subproduct['quantity']; 

                               $warehousestockvariant->save();
                           }

                       }



                   }

                   $warehouse  = WareHouse::where('active',1)->first();
                   if($warehouse){

                      $warehousestocks =  $warehouse->WarehouseStocks;
                      if($warehousestocks){
                        foreach ($warehousestocks as $key => $warehousestock) {

                            $warehouse = WarehouseStocks::where('product_id',$stock['product_id'])->where('warehouse_id',$warehousestock->id)->first();
                            if($warehouse){
                             $warehouse->quantity   =  $warehouse->quantity + $stock['quantity'];
                             $warehouse->save();
                         }
                     }

                 }
             }


         }

     }


 }

            foreach ($request->stock_details as $stock) {
                if($stock['quantity'] > 0 ){

                $product_prices = Product::where('id', $stock['product_id'])->first();

                if (count($product_prices->productCategory) > 0 ){
                        //// new work 12/18/2019 ////

                     
                    foreach ($stock['product_category'] as $key => $subproduct) {

                           //$per_cotton_price    = $product_prices->cotton;
                           // return $subproduct['quantity'];
                           //$total_cotton = $subproduct['quantity'] / $per_cotton_price;


                       $product_sub_raws=ProductRaw::where('sub_product_id',$subproduct['product']['id'])->get();

                      
                       if(!empty($product_sub_raws)){

                            //get raw of products
                        foreach ($product_sub_raws as $key => $product_sub_raw) {
                                # code...


                         $raw_meterial = $product_sub_raw->RawMaterial;
                         if($raw_meterial){
                            $per_cotton_price    = $product_prices->cotton;

                            $total_cotton = $subproduct['quantity'] / $per_cotton_price;
                            $total_pieces  = $total_cotton * $product_sub_raw->bundle; 

                            $raw_meterial->quantity =$raw_meterial->quantity - $total_pieces;
                            $raw_meterial->save();

                            ///new code 08082020///
                              $raw_material_desktop  =  $product_sub_raw->RawMaterialdesktop;
 
                              if($raw_material_desktop){
                                  $raw_material_desktop->quantity =$raw_material_desktop->quantity - $total_pieces;
                                    $raw_material_desktop->save();

                                          $latest = Factoryinventory::where('raw_id',$raw_meterial->id)->orderBy('id', 'DESC')->first();
                      
                      if($latest){

                        $tota_avaliable = $latest->available - $total_pieces;
                       
                        $factoryinventory= new Factoryinventory();
                        $factoryinventory->raw_id = $raw_material_desktop->raw_id;
                        $factoryinventory->bilti_id = 0;
                        $factoryinventory->product_id = $stock['product_id'];
                         $factoryinventory->sub_product = $subproduct['product']['id'];
                        $factoryinventory->Date =date("Y-m-d");
                        $factoryinventory->stock_out = $total_pieces;
                        $factoryinventory->available = $tota_avaliable;


                        $factoryinventory->save();
                       


                    }

                                      }




                            $raw_sub_product_vendors = $product_sub_raw->RawMaterial->raw_product_vendors;



                            $total_raw_vendor = $raw_sub_product_vendors->count();


                    /////raw bracket start ////
                            if($raw_sub_product_vendors){
                                $temp = 0;
                                $i = 1;
                                foreach ($raw_sub_product_vendors as $key => $raw_sub_product_vendor) {


                                    if($temp == 0){

                                        $flag  =  $raw_sub_product_vendor->quantity - $total_pieces;



                                        $minus = Str::contains($flag, '-');

                                        if($minus == true){


                                         if($total_raw_vendor == $i){



                                            $prices =  $total_pieces * $raw_sub_product_vendor->price;


                                            $inv_qty = $total_pieces;
                                            $raw_sub_product_vendor->quantity = $flag;
                                          
                                            $raw_sub_product_vendor->save();

                                        }else{

                                            $prices =  $raw_sub_product_vendor->quantity * $raw_sub_product_vendor->price;
                                            $inv_qty = $raw_sub_product_vendor->quantity;
                                            $raw_sub_product_vendor->quantity = 0;
                                            $raw_sub_product_vendor->save();
                                            $temp =  -($flag);
                                        }
                                    }else{

                            //if parent products have too much quantity then stop loop//
                                        $qty =$raw_sub_product_vendor->quantity-$total_pieces;

                                        $inv_qty = $total_pieces;
                                        $prices =  $total_pieces * $raw_sub_product_vendor->price;

                                        $raw_sub_product_vendor->quantity = $qty;

                                        $raw_sub_product_vendor->save();
                                        $InventoryReport= new InventoryReport();
                                        $InventoryReport->raw_materiel_id = $raw_sub_product_vendor->raw_id;
                                        $InventoryReport->product_id = $stock['product_id'];
                                        $InventoryReport->vendor_id = $raw_sub_product_vendor->vendor_id;
                                        $InventoryReport->sub_product_id = $subproduct['product']['id'];
                                        $InventoryReport->total_qty = $inv_qty;
                                        $InventoryReport->price = $prices;
                                        $InventoryReport->save();
                                        break;


                                    }   



                                }else{

                                 $flag  =  $raw_sub_product_vendor->quantity - $temp;

                                 $minus = Str::contains($flag, '-');

                                 if($minus == true){

                                    if($total_raw_vendor == $i){


                                    //after last iteration save  value in last vandor///
                                        $prices =  $temp * $raw_sub_product_vendor->price;
                                        $inv_qty = $temp;
                                        $raw_sub_product_vendor->quantity = $flag;
                                        $raw_sub_product_vendor->save();


                                    }
                                    else{

                                     $prices =  $raw_sub_product_vendor->quantity * $raw_sub_product_vendor->price;
                                     $inv_qty = $raw_sub_product_vendor->quantity;
                                     $raw_sub_product_vendor->quantity = 0;
                                     $raw_sub_product_vendor->save();
                                     $temp =  -($flag);
                                 }
                             }
                             else{


                                $qty =$raw_sub_product_vendor->quantity-$temp;
                                $inv_qty= $temp;
                                $prices =  $temp * $raw_sub_product_vendor->price;
                                $raw_sub_product_vendor->quantity = $qty;
                                $raw_sub_product_vendor->save();



                            }


                        }
                        $i++;
                        $InventoryReport= new InventoryReport();
                        $InventoryReport->raw_materiel_id = $raw_sub_product_vendor->raw_id;
                        $InventoryReport->product_id = $stock['product_id'];
                        $InventoryReport->vendor_id = $raw_sub_product_vendor->vendor_id;
                        $InventoryReport->sub_product_id = $subproduct['product']['id'];
                        $InventoryReport->total_qty = $inv_qty;
                        $InventoryReport->price = $prices;
                        $InventoryReport->save();
                    }
                    
                } //raw baraket end

            }
        }


    } 

}


}

else{

    
                    //code for parent products////
   $per_cotton_price    = $product_prices->cotton;

   $total_cotton = $stock['quantity'] / $per_cotton_price;

   $product_raws = $product_prices->raw_product;
   

   foreach ($product_raws as $product_raw) {

                    //get raw of products
    $raw_meterial = $product_raw->RawMaterial;


                    $total_pieces  = $total_cotton * $product_raw->bundle; //2400

                    if($raw_meterial){
                        $raw_meterial->quantity =$raw_meterial->quantity - $total_pieces;

                        $raw_meterial->save();

                    }
                      ///new code 08082020///
      $raw_material_desktop  =  $product_raw->RawMaterialdesktop;
 
      if($raw_material_desktop){
        $raw_material_desktop->quantity =$raw_material_desktop->quantity - $total_pieces;
                        $raw_material_desktop->save();

                               $latest = Factoryinventory::where('raw_id',$raw_material_desktop->raw_id)->orderBy('id', 'DESC')->first();

                     if($latest){

                        $tota_avaliable = $latest->available - $total_pieces;


                        $factoryinventory= new Factoryinventory();
                        $factoryinventory->raw_id = $raw_material_desktop->raw_id;
                        $factoryinventory->bilti_id = 0;
                         $factoryinventory->product_id = $stock['product_id'];
                         $factoryinventory->sub_product = $subproduct['id'];
                        $factoryinventory->Date =date("Y-m-d");
                        $factoryinventory->stock_out = $total_pieces;
                        $factoryinventory->available = $tota_avaliable;
                        $factoryinventory->save();



                    }



      }
                    $raw_product_vendors = $product_raw->RawMaterial->raw_product_vendors;
                    

                   
                    if($raw_product_vendors){
                        $total_raw_vendor = $raw_product_vendors->count();
                        $temp = 0;
                        $i = 1;
                        foreach ($raw_product_vendors as $key => $raw_product_vendor) {

                            if($temp == 0){

                                $flag  =  $raw_product_vendor->quantity - $total_pieces;

                                $minus = Str::contains($flag, '-');

                                if($minus == true){
                                 if($total_raw_vendor == $i){

                                    $prices =  $total_pieces * $raw_product_vendor->price;

                                    $inv_qty = $total_pieces;
                                    $raw_product_vendor->quantity = $flag;
                                    $raw_product_vendor->save();

                                }else{
                                    $prices =  $raw_product_vendor->quantity * $raw_product_vendor->price;
                                    $inv_qty = $raw_product_vendor->quantity;
                                    $raw_product_vendor->quantity = 0;
                                    $raw_product_vendor->save();
                                    $temp =  -($flag);

                                }

                            }else{

                            //if parent products have too much quantity then stop loop//
                                $qty =$raw_product_vendor->quantity-$total_pieces;
                                $inv_qty = $total_pieces;
                                $prices =  $total_pieces * $raw_product_vendor->price;

                                $raw_product_vendor->quantity = $qty;
                                $raw_product_vendor->save();

                                $InventoryReport= new InventoryReport();
                                $InventoryReport->raw_materiel_id = $raw_product_vendor->raw_id;
                                $InventoryReport->product_id = $stock['product_id'];
                                $InventoryReport->vendor_id = $raw_product_vendor->vendor_id;
                                $InventoryReport->total_qty = $inv_qty;
                                $InventoryReport->price = $prices;
                                $InventoryReport->save();
                                break;


                            }   



                        }else{

                         $flag  =  $raw_product_vendor->quantity - $temp;

                         $minus = Str::contains($flag, '-');

                         if($minus == true){

                            if($total_raw_vendor == $i){


                                    //after last iteration save  value in last vandor///
                                $prices =  $temp * $raw_product_vendor->price;
                                $inv_qty = $temp;

                                $raw_product_vendor->quantity = $flag;
                                $raw_product_vendor->save();


                            }
                            else{

                             $prices =  $raw_product_vendor->quantity * $raw_product_vendor->price;
                             $inv_qty = $raw_product_vendor->quantity;
                             $raw_product_vendor->quantity = 0;
                             $raw_product_vendor->save();
                             $temp =  -($flag);
                         }
                     }
                     else{


                        $qty =$raw_product_vendor->quantity-$temp;
                        $inv_qty= $temp;
                        $prices =  $temp * $raw_product_vendor->price;
                        $raw_product_vendor->quantity = $qty;
                        $raw_product_vendor->save();



                    }


                }

                $i++;

                $InventoryReport= new InventoryReport();
                $InventoryReport->raw_materiel_id = $raw_product_vendor->raw_id;
                $InventoryReport->product_id = $stock['product_id'];
                $InventoryReport->vendor_id = $raw_product_vendor->vendor_id;
                $InventoryReport->total_qty = $inv_qty;
                $InventoryReport->price = $prices;
                $InventoryReport->save();
            }

        }



    }
}
$vendor_price = ($product_prices->vendor_price)* $stock['quantity'];

$totalvendor_price = $totalvendor_price + $vendor_price;

}

}
}

$bilty->vendor_price=$totalvendor_price;

$bilty->save();
$inventories =  InventoryReport::where('bilty_id', 0)->get();
if($inventories){
    foreach ($inventories as $inventory) {
        $inventory->bilty_id = $bilty->id;
        $inventory->save();
    }

}

$Factoryinventories =  Factoryinventory::where('bilti_id', 0)->get();
if($Factoryinventories){
    foreach ($Factoryinventories as $Factoryinventory) {
        $Factoryinventory->bilti_id = $bilty->id;
        $Factoryinventory->save();
    }

}

$price=0;
$vendor_price=0;
$is_mehandi=false;
PoNumber::where('po_number',$request->po_no)->update(array('status' => 'Delivered'));
  // PoNumber::where('po_number',$request->get('po_no'))->update(array('status' => 'Delivered'));;
$party=PartyName::where('id',$request->party_id)->first();

$distributer_id  = $party->user_id;



if(count($request->stock_details)>0){

    foreach ($request->stock_details as $stock){
        if($stock['quantity'] > 0 ){
        if(!empty($distributer_id)){
           $stock_product  = SoStock::where('so_id',$distributer_id)->where('product_id',$stock['product_id'])->where('product_category_id', 0)->first();
           if($stock_product){
                $stock_product->qty  = $stock_product->qty + $stock['quantity'];
                $stock_product->save();

                    //// how much stock in at soul distributers parent products ///
                $so_stock_detail  = new SoStockDetail();
                $so_stock_detail->so_id = $distributer_id;
                 $so_stock_detail->ref_id = $bilty->id;
                $so_stock_detail->product_id = $stock['product_id'];
                $so_stock_detail->stock_in = $stock['quantity'];
                $so_stock_detail->total_stock = $stock_product->qty;
                $so_stock_detail->date = date("Y-m-d");
                $so_stock_detail->save();
                
            }else{

             $stock_product  = new SoStock();
             $stock_product->so_id = $distributer_id;
             $stock_product->product_id = $stock['product_id'];
             $stock_product->opening_qty = $stock['quantity'];
             $stock_product->qty = $stock['quantity'];
             $stock_product->save();

             $so_stock_detail  = new SoStockDetail();
             $so_stock_detail->so_id = $distributer_id;
             $so_stock_detail->ref_id = $bilty->id;
             $so_stock_detail->product_id = $stock['product_id'];
             $so_stock_detail->stock_in = $stock['quantity'];
             $so_stock_detail->total_stock = $stock['quantity'];
             $so_stock_detail->date = date("Y-m-d");
             $so_stock_detail->save();
         }
                ///



 }
 $detail=new BiltiDetail();
 $detail->bilti_id=$bilty->id;
 $detail->product_id=$stock['product_id'];
 $detail->quantity=$stock['quantity'];
 $detail->delivered_date = date("Y-m-d");

 $product_prices = Product::where('id', $stock['product_id'])->get();


 $detail->vendor_price=($product_prices[0]->vendor_price)*$stock['quantity'];


 if(!empty($party)&& !empty($party->region_id) && $party->region->custom_prices == 1){
    $cost=$this->CalculateExportInvoice($stock['product_id'],$detail->quantity,$party->id);
    if($cost == 0){

        $cost=$this->CalculateInvoice($stock['product_id'],$detail->quantity,'Distributor');

    }
//                        dd($cost);
}else{

    $cost=$this->CalculateInvoice($stock['product_id'],$detail->quantity,'Distributor');

}

$price=$price+$cost;
$detail->price=$cost;
 //// 19 id cod and 20 id head office  for our warehouse thats why bilty amount is 0 ///
            if($party->id == 19 || $party->id  == 20){ 


        $detail->discount=0;
        $detail->payment=0;
        $detail->price=0;
        $total_price=0;
        $price = 0;


            }else{

    if($party->region_id !=2 ){

        $p= ProductPrice::where('product_id',$stock['product_id'])->first();

        if($p->discount > 0){
        $detail->discount=$p->discount;
        $detail->payment=$cost-(($cost*$p->discount)/100);
        $total_price=$total_price+($cost-(($cost*$p->discount)/100));
    }else{


        if(!empty($party) && !empty($party->discount) &&  $party->discount!=0 && $stock['product_id']!=29){

            $detail->discount=$party->discount;
            $detail->payment=$cost-(($cost*$party->discount)/100);
            $total_price=$total_price+($cost-(($cost*$party->discount)/100));
        }
         else{
            $detail->discount=0;
            $detail->payment=$cost;
            $total_price=$total_price+$cost;
            $is_mehandi=true;
        }
    }

    } else{

            $detail->discount=0;
            $detail->payment=$cost;
            $total_price=$total_price+$cost;
            $is_mehandi=true;
        

    }
}
$detail->save();
$s_detail=StockBookingDetail::where('id',$stock['id'])->first();
if(!empty($s_detail)){
    $s_detail->delivered=$s_detail->delivered+$stock['quantity'];
    $s_detail->save();
}
                    ///  12/23/2019 /////

if(count($stock['product_category'])>0){
    foreach($stock['product_category'] as $product_category){

        if(!empty($distributer_id)){

            $stock_product  = SoStock::where('so_id',$distributer_id)->where('product_id',$stock['product_id'])->where('product_category_id',$product_category['product_category_id'])->first();

              if(!empty($stock_product)){
                    $stock_product->qty  = $stock_product->qty + $product_category['quantity'];

                    $stock_product->save();

                    $so_stock_detail  = new SoStockDetail();
                    $so_stock_detail->so_id = $distributer_id;
                    $so_stock_detail->ref_id = $bilty->id;
                    $so_stock_detail->product_id = $stock['product_id'];
                    $so_stock_detail->product_category_id = $product_category['product_category_id'];
                    $so_stock_detail->stock_in = $product_category['quantity'];
                    $so_stock_detail->total_stock = $stock_product->qty;
                    $so_stock_detail->date = date("Y-m-d");
                    $so_stock_detail->save();

                }else{

             $so_stock_product  = new SoStock();
             $so_stock_product->so_id = $distributer_id;
             $so_stock_product->product_id = $stock['product_id'];
             $so_stock_product->product_category_id = $product_category['product_category_id'];
             $so_stock_product->qty = $product_category['quantity'];
             $so_stock_product->save();

             $so_stock_details  = new SoStockDetail();
             $so_stock_details->so_id = $distributer_id;
             $so_stock_detail->ref_id = $bilty->id;
             $so_stock_details->product_id = $stock['product_id'];
             $so_stock_details->product_category_id = $product_category['product_category_id'];
             $so_stock_details->stock_in = $product_category['quantity'];
             $so_stock_details->total_stock = $product_category['quantity'];
             $so_stock_details->date = date("Y-m-d");
             $so_stock_details->save();
                }
        }


        $s_detail=StockBookingDetailCategory::where('stock_booking_detail_id',$stock['id'])->where('product_category_id',$product_category['product_category_id'])->first();

        if(!empty($s_detail)){
            $s_detail->delivered=$s_detail->delivered+$product_category['quantity'];
            $s_detail->save();
        }
    }
}



                    ///
                    // add stock product category

if(count($stock['product_category'])>0){
    foreach($stock['product_category'] as $product_category){
        if(!empty($product_category['quantity'])){
            $product_cat=new BiltiDetialType();
            $product_cat->bilti_detial_id=$detail->id;
            $product_cat->product_category_id=$product_category['product_category_id'];
            $product_cat->quantity=$product_category['quantity'];
//                                    $facial=$facial+($product_category['quantity']*$cot->cotton);
            $product_cat->save();
        }
    }
}
                    // auto complete stock order
$com= StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
->where('stock_booking_id',$request->stock_booking_id)->first();
if(!empty($com) && ($com['dispatch_quantity']<=$com['delivered'])){
    StockBooking::where('id',$request->stock_booking_id)->update(array('status'=>'Completed'));
}
$p_com=StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
->where('stock_booking_id',$request->stock_booking_id)
->wherein('product_id',vendorProduct($request->supplier_id))
->first();
if(!empty($p_com) && ($p_com['dispatch_quantity']<=$p_com['delivered'])){
    PoNumber::where('stock_booking_id',$request->stock_booking_id)
    ->where('user_id',$request->supplier_id)
    ->where('po_number',$request->po_no)
    ->update(array('status'=>'Completed'));
}

} ///quantity condition exit

} //loop exit stock check

} ///condition exit


$bilty->price=$price;

if(!empty($party)){
//                $amount=$price;
    if($party->discount==0){
        $bilty->discount=0;
        $bilty->payment=$price;
        $party->balance=($party->balance)+($price);
        $party->save();
    }else{
        if($is_mehandi){
            $bilty->discount=0;
        }else{
            $bilty->discount=$party->discount;
        }

        $dis=($price*$party->discount)/100;
//                    $bilty->payment=$price-$dis;
        $bilty->payment=$total_price;
//                    $amount=$price-$dis;
        $party->balance=($party->balance)+($total_price);
//                    $party->balance=($party->balance)+($price-$dis);
        $party->save();
    }
                // ledger add
    $e= new UserExpenseDetail();
    $e->user_id=$request->booked_by;
               // $e->party_id=$request->get('party_id');
    $e->detail_id=$bilty->id;
        $e->vendor_id=$request->supplier_id; //distributer id 
        $e->amount=$total_price;
        $e->vendor_price=$totalvendor_price;
        if($request->supplier_id==43 || $request->supplier_id== 100)
        {
            $user_vendor=User::where('id',$request->supplier_id)->first();

            $e->balance=$user_vendor->balance+$totalvendor_price;


            $xx="";

            {
               $opening=0;

               $obj = User::where('id', $request->supplier_id)->with(['ledger_vendor' => function ($query) {
                   $query->whereDate('date','>=','2019-07-5')->orderBy('date', 'ASC');
               }])->first();
               if (!empty($obj) && !empty($obj->ledger_vendor)) {
                   $xx=   $opening = $obj->opening_balance;
                   foreach ($obj->ledger_vendor as  $item) {
                    $update = UserExpenseDetail::where('id', $item->id)->first();
                    if (!empty($update)) {
                        switch ($update['type']) {
                            case 'Sale':
                            $opening = $opening + $update['vendor_price'];

                            UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);


                            break;
                            case 'Recovery':
                            $opening = $opening - $update['amount'];
                            UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                            break;

                        }
                    }
                       // $update->save();
                }
                $obj->balance = $opening;
                $obj->save();
            }
        }

            //     if (!empty($obj) && !empty($obj->ledger_vendor)) {
            //      $xx=   $opening = $obj->opening_balance;
            //         foreach ($obj->ledger_vendor as $key => $item) {
            //             $update = UserExpenseDetail::where('id', $item['id'])->first();
            //             if (!empty($update)) {
            //                 switch ($update['type']) {
            //                     case 'Sale':
            //                         $opening = $opening + $update['vendor_price'];
            //                         $update->balance = $opening;
            //                         $update->save();
            //                         break;
            //                     case 'Recovery':
            //                         $opening = $opening - $update['amount'];
            //                         $update->balance = $opening;
            //                         $update->save();
            //                         break;

            //                 }
            //             }
            //             $update->save();
            //         }
            //         $obj->balance = $opening;
            //         $obj->save();
            //   }


    }

    else{
        $e->balance=$party->balance;


    }

    $e->type='Sale';
    $e->date=date("Y-m-d");
    $e->save();

                    //// bilal code ////
    $e= new UserExpenseDetail();
    $e->user_id=$request->booked_by;
    $e->party_id=$request->party_id;
    $e->detail_id=$bilty->id;
                //$e->vendor_id=$request->get('supplier_id');
    $e->amount=$total_price;
    $e->vendor_price=$totalvendor_price;
    $e->balance = $party->balance + $total_price;
    $e->type='Sale';
    $e->date=date("Y-m-d");
    $e->save();


    if(!empty($party))
    {
       LedgerAdjust($party->id);
   }
}else{
    $bilty->discount=0;
    $bilty->payment=$price;
}
$bilty->save();


            //Image upload
if(!empty($request->uploadimages)) {
    $images = [];
    foreach($request->uploadimages as $image) {
        $image = upload_base64_image($image, 'uploads/bilty/',
            'image-');
        $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
        $customerImage->image =  'http://'.$image;
        $images[] = $customerImage;
    }
    if(count($images) > 0) {
        $bilty->biltyImages()->saveMany($images);
    }
}
}



catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}

//Products Detail
$BiltyInfo = BiltiDetail::where('bilti_id',$bilty->id)->get();
// return $BiltyInfo;
foreach ($BiltyInfo as $product){
        $dis_stoc=Product::where('id',$product['product_id'])->first();
        $name[] = $dis_stoc->name." (QTY: ".$product['quantity']/$dis_stoc->cotton.")";
}
$productname = implode("\n", $name);
//Party Details
$PartyDetails = PartyName::where('id', $request->party_id)->first();
$PartyName = $PartyDetails->name;
$PartyOutstanding = round($PartyDetails->balance,2);
$PartyPhone = $PartyDetails->phone_1;
$PartyInvoice = $bilty->payment;

//Vendor Details
$date = $request->date;
$VendorDetails = User::where('id', $request->supplier_id)->first();
$VendorPhone = $VendorDetails->phone_1;
$VendorName = $VendorDetails->firstname." ".$VendorDetails->lastname;
$VendorOutstanding = round($VendorDetails->balance,2);


//RSM Details
$RegionDetails = Region::where('id', $PartyDetails->region_id)->first();
$RSMDetails = User::where('id', $RegionDetails->rsm_id)->first();
$RSMPhone = $RSMDetails->phone_1;


if($VendorPhone != NULL){
$obj=array();
$obj['number']="923236600464";
$obj['text']="Dear Vendor,\nYou Have Added Bilty For $PartyName\n*Products:*\n$productname\n\n*Your Outstanding:* $VendorOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
$obj['instance']="biocos";
$obj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
header('Content-Type: application/json'); // Specify the type of data
                
$ch = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
$post = json_encode($obj); // Encode the data array into a JSON string
                
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, 1); // Specify the request method as POST
curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Set the posted fields
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
$whatsapp = curl_exec($ch); // Execute the cURL statement
curl_close($ch); // Close the cURL connection
}

if($PartyPhone != NULL){
/*Customer Messages*/
$Partyobj=array();
$Partyobj['number']="923236600464";
$Partyobj['text']="Dear Customer,\nA new bilty has been dispatched against your order from Biocos.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*Your Outstanding:* $PartyOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
$Partyobj['instance']="biocos";
$Partyobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
header('Content-Type: application/json'); // Specify the type of data
                
$Partych = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
$Partypost = json_encode($Partyobj); // Encode the data array into a JSON string
                
curl_setopt($Partych, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
curl_setopt($Partych, CURLOPT_RETURNTRANSFER, true);
curl_setopt($Partych, CURLOPT_POST, 1); // Specify the request method as POST
curl_setopt($Partych, CURLOPT_POSTFIELDS, $Partypost); // Set the posted fields
curl_setopt($Partych, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
$whatsapp = curl_exec($Partych); // Execute the cURL statement
curl_close($Partych); // Close the cURL connection
}

if($RSMPhone != NULL){
/*Customer RSM Messages*/
$RSMobj=array();
$RSMobj['number']="923236600464";
$RSMobj['text']="Dear Customer RSM,\nA new bilty has been dispatched against $PartyName.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*Your Outstanding:* $PartyOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
$RSMobj['instance']="biocos";
$RSMobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
header('Content-Type: application/json'); // Specify the type of data
                
$RSMch = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
$RSMpost = json_encode($RSMobj); // Encode the data array into a JSON string
                
curl_setopt($RSMch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
curl_setopt($RSMch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($RSMch, CURLOPT_POST, 1); // Specify the request method as POST
curl_setopt($RSMch, CURLOPT_POSTFIELDS, $RSMpost); // Set the posted fields
curl_setopt($RSMch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
$whatsapp = curl_exec($RSMch); // Execute the cURL statement
curl_close($RSMch); // Close the cURL connection
}

        //GM Message Start
        if($PartyDetails->show_gm == 1){
            $rsmobj=array();
            $rsmobj['number']="923236600464";
            $rsmobj['text']="Dear Local GM,\nA new bilty has been dispatched against $PartyName.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*Your Outstanding:* $PartyOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
            $rsmobj['instance']="biocos";
            $rsmobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
    
            $postRSM = json_encode($rsmobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postRSM); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }elseif($PartyDetails->region_id == 2){
            $rsmobj=array();
            $rsmobj['number']="923236600464";
            $rsmobj['text']="Dear Export GM,\nA new bilty has been dispatched against $PartyName.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*Your Outstanding:* $PartyOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
            $rsmobj['instance']="biocos";
            $rsmobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
    
            header('Content-Type: application/json'); // Specify the type of data
    
            $chrsm = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
    
            $postRSM = json_encode($rsmobj); // Encode the data array into a JSON string
    
            curl_setopt($chrsm, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
            curl_setopt($chrsm, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chrsm, CURLOPT_POST, 1); // Specify the request method as POST
            curl_setopt($chrsm, CURLOPT_POSTFIELDS, $postRSM); // Set the posted fields
            curl_setopt($chrsm, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
            $resultRSM = curl_exec($chrsm); // Execute the cURL statement
            curl_close($chrsm); // Close the cURL connection
        }

        //GM Message END

/*Boss Messages*/
$Bossobj=array();
$Bossobj['number']="923236600464";
$Bossobj['text']="Dear Boss,\n$VendorName Has added bilty against order of $PartyName.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*$PartyName Outstanding:* $PartyOutstanding\n*$VendorName Outstanding:* $VendorOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";
$Bossobj['instance']="biocos";
$Bossobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
header('Content-Type: application/json'); // Specify the type of data
                
$Bossch = curl_init('http://whatsapi.co.uk/api/wpcus_sendmessage'); // Initialise cURL   
                
$Bosspost = json_encode($Bossobj); // Encode the data array into a JSON string
                
curl_setopt($Bossch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
curl_setopt($Bossch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($Bossch, CURLOPT_POST, 1); // Specify the request method as POST
curl_setopt($Bossch, CURLOPT_POSTFIELDS, $Bosspost); // Set the posted fields
curl_setopt($Bossch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
$whatsapps = curl_exec($Bossch); // Execute the cURL statement
curl_close($Bossch); // Close the cURL connection

// Group Messages
$GRPobj=array();
$GRPobj['token']="b8965dcf2cdbbdf0f0a1a663b2e79523";
$GRPobj['instance']="biocos";
$GRPobj['groupId']= "923165566633-1618382479";
$GRPobj['text']="Dear Sir,\n\nA New Bilty Has Been Dispatched Against $PartyName.\n*Products:*\n$productname\n\n*Invoice Amount:* $PartyInvoice\n*Your Outstanding:* $PartyOutstanding\n*Date:* $date.\n*Thank You*\n*Biocos Int (PVT) LTD.*";

header('Content-Type: application/json'); // Specify the type of data
                
$GRPch = curl_init('http://whatsapi.co.uk/api/sendMessageGroup'); // Initialise cURL   
                
$GRPpost = json_encode($GRPobj); // Encode the data array into a JSON string
                
curl_setopt($GRPch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'  )); // Inject the token into the header
curl_setopt($GRPch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($GRPch, CURLOPT_POST, 1); // Specify the request method as POST
curl_setopt($GRPch, CURLOPT_POSTFIELDS, $GRPpost); // Set the posted fields
curl_setopt($GRPch, CURLOPT_FOLLOWLOCATION, 1); // This will follow any redirects
$whatsapps = curl_exec($GRPch); // Execute the cURL statement
curl_close($GRPch); // Close the cURL connection

return API::response()->array(['success' => true, 'message' => 'Bilty Added',
    'data' => $bilty], 200);
}
    public function AddBiltyAdv(Request $request)
    {
        try {
            $bilty= new Bilti();
            $bilty->stock_booking_id=$request->get('stock_booking_id');
            $bilty->supplier_id=$request->get('supplier_id');
            $bilty->delivered_to_id=$request->get('booked_by');
            $bilty->party_id=$request->get('party_id');
               $bilty->remarks=$request->get('remarks');
            $bilty->bilti_no=$request->get('biltyNo');
            $bilty->bilti_date=$request->get('date');
              $bilty->delivered_date=date("Y-m-d");
            $bilty->gatepass=$request->get('gatepass');
            $bilty->po_no_adv=$request->get('po_no');
            $bilty->uuid=$request->get('uuid');
            $bilty->status='On The Way';
            $bilty->save();
            PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))->where('po_number_adv',$request->get('po_no'))->update(array('status' => 'Delivered'));;
            $party=PartyName::where('id',$request->get('party_id'))->first();
            // add stock product
            if(count($request->get('stock_details'))>0){
                foreach ($request->get('stock_details') as $stock){
                    $detail=new BiltiDetail();
                    $detail->bilti_id=$bilty->id;
                    $detail->product_id=$stock['product_id'];
                    $detail->quantity=$stock['quantity'];
                    $detail->delivered_date = date("Y-m-d");
                    $detail->price=0;
                    $detail->save();
                    $s_detail=StockBookingDetail::where('id',$stock['id'])->first();
                    if(!empty($s_detail)){
                        $s_detail->delivered=$s_detail->delivered+$stock['quantity'];
                        $s_detail->save();
                    }

                    // auto complete stock order
                    $com= StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                        ->where('stock_booking_id',$request->get('stock_booking_id'))->first();
                    if(!empty($com) && ($com['dispatch_quantity']<=$com['delivered'])){
                        StockBooking::where('id',$request->get('stock_booking_id'))->update(array('status'=>'Completed'));
                    }
                    $p_com=StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                        ->where('stock_booking_id',$request->get('stock_booking_id'))
                        ->wherein('product_id',vendorProduct($request->get('supplier_id')))
                        ->first();
                    if(!empty($p_com) && ($p_com['dispatch_quantity']<=$p_com['delivered'])){
                        PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))
                            ->where('user_id',$request->get('supplier_id'))
                            ->where('po_number_adv',$request->get('po_no'))
                            ->update(array('status'=>'Completed'));
                    }
                }
            }
            $bilty->price=0;
            $bilty->discount=0;
            $bilty->payment=0;
            $bilty->save();


            //Image upload
            if(!empty($request->get('uploadimages'))) {
                $images = [];
                foreach($request->get('uploadimages') as $image) {
                    $image = upload_base64_image($image, 'uploads/bilty/',
                        'image-');
                    $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                    $customerImage->image =  'http://'.$image;
                    $images[] = $customerImage;
                }
                if(count($images) > 0) {
                    $bilty->biltyImages()->saveMany($images);
                }
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Bilty Added',
            'data' => $bilty,'vendor' => $whatsapp], 200);
    }
    
    public function AddBiltyRaw(Request $request)
{
    try {
        
        $price=0;
        $bilty= new Bilti();
        $bilty->stock_booking_id=$request->stock_booking_id;
        $bilty->supplier_id=$request->supplier_id;
        $bilty->delivered_to_id=$request->booked_by;
        $bilty->remarks=$request->remarks;
        $bilty->bilti_no=$request->biltyNo;
        $bilty->bilti_date=$request->date;
          $bilty->delivered_date=date("Y-m-d");
      $bilty->gatepass=$request->gate_pass;
        $bilty->po_no_raw=$request->po_no;
        $bilty->uuid=$request->uuid;
        $bilty->status='On The Way';
       $bilty->save();
        PoNumber::where('stock_booking_id',$request->stock_booking_id)->
        where('po_number_raw',$request->po_no)->update(array('status' => 'Delivered'));
            // add stock product
        if(count($request->stock_details)>0){

            foreach ($request->stock_details as $stock){
            
                $detail=new BiltiDetail();
                $detail->bilti_id=$bilty->id;
                $detail->product_id=$stock['product_id'];
                $detail->quantity=$stock['quantity'];
                $detail->delivered_date = date("Y-m-d");
                $product_prices = RawProductVendor::where('raw_id', $stock['product_id'])->where('vendor_id',$request->supplier_id)->first();
 
                 $quantityy = $product_prices->quantity +  $detail->quantity; 
                   
                $product_prices->update(['quantity' => $quantityy]);
                
                $product_pri = RawMaterial::where('id', $stock['product_id'])->first();
                
                
                $product_pri->quantity = $product_pri->quantity +  $detail->quantity; 

                $product_pri->save();

                $detail->price=$product_prices->price*$stock['quantity'];
                
                $detail->payment = $product_prices->price*$stock['quantity'];
                
                $price=$price+$detail->price;

                $detail->save();
                $s_detail=StockBookingDetail::where('id',$stock['id'])->first();
                if(!empty($s_detail)){
                    $s_detail->delivered=$s_detail->delivered+$stock['quantity'];
                    $s_detail->save();
                }

                    // auto complete stock order
                $com= StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                ->where('stock_booking_id',$request->get('stock_booking_id'))->first();
                if(!empty($com) && ($com['dispatch_quantity']<=$com['delivered'])){
                    StockBooking::where('id',$request->get('stock_booking_id'))->update(array('status'=>'Completed'));
                }
                $p_com=StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                ->where('stock_booking_id',$request->get('stock_booking_id'))
                ->first();
                

                if(!empty($p_com) )
                {
                    if ($p_com['dispatch_quantity']<=$p_com['delivered']){

                    PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))
                    ->where('user_id',$request->get('supplier_id'))
                    ->where('po_number_raw',$request->get('po_no'))
                    ->update(array('status'=>'Completed'));
                }

                if ($p_com['delivered'] > 0 && $p_com['delivered'] < $p_com['dispatch_quantity']   ){
                    PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))
                    ->where('user_id',$request->get('supplier_id'))
                    ->where('po_number_raw',$request->get('po_no'))
                    ->update(array('status'=>'Delivered'));
                }
                }
            }
        }
        $bilty->price=$price;
        $bilty->discount=0;
        $bilty->payment=$price;
        $bilty->vendor_price=$price;
        $bilty->save();

        $e= new UserExpenseDetail();
        $e->user_id=$request->booked_by;
        $e->party_id=$request->party_id;
        $e->detail_id=$bilty->id;
        $e->is_raw=1;
        $e->vendor_id=$request->supplier_id;
        $e->amount=$price;
        $e->vendor_price=$price;

          
            $user_vendor=User::where('id',$request->supplier_id)->first();
            if(!empty($user_vendor)){
            $e->balance=$user_vendor->balance+$price;

            $user_vendor->balance=$e->balance;
            $user_vendor->save();
        }
        else{
            $e->balance=$price;
        }

        $e->type='Sale';
        $e->date=date("Y-m-d");
        $e->save();
            //Image upload
        if(!empty($request->uploadimages)) {
            $images = [];
            foreach($request->uploadimages as $image) {
                $image = upload_base64_image($image, 'uploads/bilty/',
                    'image-');
                $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                $customerImage->image =  'http://'.$image;
                $images[] = $customerImage;
            }
            if(count($images) > 0) {
                $bilty->biltyImages()->saveMany($images);
            }
        }

    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'Bilty Added',
        'data' => $bilty], 200);
}
    
     public function AddBiltyRawBiotech(Request $request)
    {
        try {
            $price=0;
            $bilty= new Bilti();
            $bilty->stock_booking_id=$request->get('stock_booking_id');
            $bilty->supplier_id=$request->get('supplier_id');
            $bilty->delivered_to_id=$request->get('booked_by');
            $bilty->vendor_invoice_no=$request->get('vendor_invoice_id');
            $bilty->bilti_no=$request->get('biltyNo');
            $bilty->bilti_date=$request->get('date');
              $bilty->delivered_date=date("Y-m-d");
            $bilty->gatepass=$request->get('gatepass');
            $bilty->po_no_raw=$request->get('po_no');
            $bilty->uuid=$request->get('uuid');
            $bilty->status='On The Way';
            $bilty->save();
            PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))->
            where('po_number_raw',$request->get('po_no'))->update(array('status' => 'Delivered'));

            // add stock product
            if(count($request->get('stock_details'))>0){
                foreach ($request->get('stock_details') as $stock){
                    $detail=new BiltiDetail();
                    $detail->bilti_id=$bilty->id;
                    $detail->product_id=$stock['product_id'];
                    $detail->quantity=$stock['quantity'];
                     $detail->delivered_date = date("Y-m-d");
                    $product_prices = RawProductVendor::where('raw_id', $stock['product_id'])->where('vendor_id',$request->supplier_id)->first();
 
                 $quantityy = $product_prices->quantity +  $detail->quantity; 
                   
                $product_prices->update(['quantity' => $quantityy]);
                
                $product_pri = RawMaterial::where('id', $stock['product_id'])->first();
                
                
                $product_pri->quantity = $product_pri->quantity +  $detail->quantity; 

                $product_pri->save();

                $detail->price=$product_prices->price*$stock['quantity'];

                $price=$price+$detail->price;

                $detail->save();
                    $s_detail=StockBookingDetail::where('id',$stock['id'])->first();
                    if(!empty($s_detail)){
                        $s_detail->delivered=$s_detail->delivered+$stock['quantity'];
                        $s_detail->save();
                    }

                    // auto complete stock order
                    $com= StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                        ->where('stock_booking_id',$request->get('stock_booking_id'))->first();
                    if(!empty($com) && ($com['dispatch_quantity']<=$com['delivered'])){
                        StockBooking::where('id',$request->get('stock_booking_id'))->update(array('status'=>'Completed'));
                    }
                    $p_com=StockBookingDetail::select(DB::raw('sum(dispatch_quantity) as dispatch_quantity,sum(delivered) as delivered'))
                        ->where('stock_booking_id',$request->get('stock_booking_id'))
                        ->wherein('product_id',vendorProduct($request->get('supplier_id')))
                        ->first();
                    if(!empty($p_com) && ($p_com['dispatch_quantity']<=$p_com['delivered'])){
                        PoNumber::where('stock_booking_id',$request->get('stock_booking_id'))
                            ->where('user_id',$request->get('supplier_id'))
                            ->where('po_number_raw',$request->get('po_no'))
                            ->update(array('status'=>'Completed'));
                    }
                }
            }
            $bilty->price=$price;
            $bilty->discount=0;
            $bilty->payment=$price;
             $bilty->vendor_price=$price;
            $bilty->save();
            
            
         $check= VendorInvoice::where('id',$request->vendor_invoice_id)->first();
            
           $difference = $check->total_amount - $price;
          
        
          if(($difference >= 0 &&  $difference < 10)  || ($difference <= 0 && $difference > -10 ))
            {
             
                 $check=VendorInvoice::where('id',$request->vendor_invoice_id)
          ->update(['accountant_status'=>1,'accountant_amount'=>$price,'po_number'=>$request->po_no]);
            
            }
            else{
                 $check=VendorInvoice::where('id',$request->vendor_invoice_id)
          ->update(['accountant_status'=>2,'accountant_amount'=>$price,'po_number'=>$request->po_no]);
            }
            
            
            

//            $e= new UserExpenseDetail();
//            $e->user_id=$request->get('booked_by');
//            $e->party_id=$request->get('party_id');
//            $e->detail_id=$bilty->id;
//              $e->is_raw=1;
//            $e->vendor_id=$request->get('supplier_id');
//            $e->amount=$price;
//            $e->vendor_price=$price;
//
//           if($request->get('supplier_id')==43 || $request->get('supplier_id')==42)  //if there is no party and supplier is a vendor
//            {
//                $user_vendor=User::where('id',$request->get('supplier_id'))->first();
//
//                $e->balance=$user_vendor->balance+$price;
//
//                 $user_vendor->balance=$e->balance;
//                 $user_vendor->save();
//            }
//            else{
//                $e->balance=$price;
//            }
//
//            $e->type='Sale';
//            $e->date=date("Y-m-d");
//            $e->save();


            //Image upload
            if(!empty($request->get('uploadimages'))) {
                $images = [];
                foreach($request->get('uploadimages') as $image) {
                    $image = upload_base64_image($image, 'uploads/bilty/',
                        'image-');
                    $customerImage = new BiltyImage();
//                $customerImage->image_url =  str_replace("api.biocospk.com","",$image);
                    $customerImage->image =  'http://'.$image;
                    $images[] = $customerImage;
                }
                if(count($images) > 0) {
                    $bilty->biltyImages()->saveMany($images);
                }
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Bilty Added',
            'data' => $bilty], 200);
    }
    
  public function deletebility(Request $request){

    try{

        $bilty = Bilti::where('id',$request->bilty_id)->where('po_no','!=',0)->first();


        
        if($bilty){

            $party = PartyName::where('id',$bilty->party_id)->first();
            $soul_distributer  = $party->user_id;


                 $SoStockReports = SoStockDetail::where('ref_id', $request->bilty_id)->get();

                 if($SoStockReports)
                    foreach ($SoStockReports as $key => $SoStockReport) {
                        $SoStockReport->delete();
                    }
            foreach ($bilty->bilty_detail as $key => $biltydetail) {

              $StockBookingDetail   = StockBookingDetail::where('stock_booking_id',$bilty->stock_booking_id)->where('product_id', $biltydetail['product_id'])->first();


                $biltycatagorys = $biltydetail->bilty_detail_type;

            if($StockBookingDetail){
                  

                if($StockBookingDetail->product_category)
                    
                    foreach ($StockBookingDetail->product_category as $key => $value) {

                        foreach ($biltycatagorys as $key => $biltycatagory) {
                          
                        
                   if($value->product_category_id == $biltycatagory->product_category_id){
                       
                        $value->dispatch_quantity   = $value->dispatch_quantity - $biltycatagory->quantity;

                       $value->save();
                       
                    }
                }
                }
               $StockBookingDetail->delivered  = $StockBookingDetail->delivered -$biltydetail['quantity'];

              
              $StockBookingDetail->save();
          }
         
         
              $stock_product  = SoStock::where('so_id',$soul_distributer)->where('product_id', $biltydetail['product_id'])->where('product_category_id', 0)->first();
              if($stock_product){
                 $stock_qty   =  $stock_product->qty - $biltydetail['quantity'];

                 $stock_product->qty = $stock_qty;

                 $stock_product->save();





             }

             $warehouse  = WareHouse::where('active',1)->first();

             if($warehouse){

                $WarehouseStocks = WarehouseStocks::where('product_id',$biltydetail['product_id'])->where('warehouse_id',$warehouse->id)->first();
                
                if($WarehouseStocks){
                   $WarehouseStocks->quantity   =  $WarehouseStocks->quantity + $biltydetail['quantity'];

                   $WarehouseStocks->save();
               }

             

               if($biltycatagorys){

                foreach ($biltycatagorys as $key => $biltycatagory) {

                    $warehousestockvariant = WarehouseStockVariant::where('sub_product_id',$biltycatagory['product_category_id'])->first();
                    if($warehousestockvariant){
                     $warehousestockvariant->quantity  =  $warehousestockvariant->quantity + $biltycatagory['quantity'];


                     $warehousestockvariant->save();
                 }


                 $biltycatagory->delete();

             }
         }


     }
     $biltydetail->delete();


 }

 $inventories  = InventoryReport::where('bilty_id',$bilty->id)->get();
 if($inventories)
 {
     foreach ($inventories as $key => $inventory) {

        $RawProductVendor = RawProductVendor::where('raw_id',$inventory['raw_materiel_id'])->where('vendor_id',$inventory['vendor_id'])->first();


 ///add quantity in raw material tabel and vendorproduct and rawproduct desktop table 
        $qty   =  $RawProductVendor->quantity + $inventory['total_qty'];

        $RawProductVendor->quantity = $qty;

        $RawProductVendor->save();
        $raw_material = RawMaterial::where('id',$inventory['raw_materiel_id'])->first();


        $qty_raw   =   $raw_material->quantity  + $inventory['total_qty'];

        $raw_material->quantity = $qty_raw;

        $raw_material->save();

        $rawproductvendordesktop = RawProductVendorDesktop::where('raw_id',$inventory['raw_materiel_id'])->first();

        if($rawproductvendordesktop){
            $rawproductvendordk   =   $rawproductvendordesktop->quantity  + $inventory['total_qty'];
            
            $rawproductvendordesktop->quantity = $rawproductvendordk;

            $rawproductvendordesktop->save();
        }
        $inventory->delete();


    }
}
$factoryinventories = Factoryinventory::where('bilti_id',$bilty->id)->where('stock_in',0)->get();

if($factoryinventories){
 foreach ($factoryinventories as $key => $value) {
     $value->delete();

 }
}

UserExpenseDetail::where('detail_id', $request->bilty_id)->where('type','Sale')->delete();
$bilty->delete();
}else{

   return API::response()->array(['success' => false, 'message' => 'bilty not found'], 400);


}


return API::response()->array(['success' => true, 'message' => 'deleted successfully',
    'data' => $sub], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}

public function deletebilityraw(Request $request){

    try{

        $bilty = Bilti::where('id',$request->bilty_id)->where('po_no_raw','!=',0)->first();


        
        if($bilty){
   
            foreach ($bilty->bilty_detail as $key => $biltydetail) {

                

              $StockBookingDetail   = StockBookingDetail::where('stock_booking_id',$bilty->stock_booking_id)->where('product_id', $biltydetail['product_id'])->first();


                $biltycatagorys = $biltydetail->bilty_detail_type;

            if($StockBookingDetail){
                  

                if(count($StockBookingDetail->product_category) > 0)
                        
                    foreach ($StockBookingDetail->product_category as $key => $value) {

                        foreach ($biltycatagorys as $key => $biltycatagory) {
                          
                        
                   if($value->product_category_id == $biltycatagory->product_category_id){
                       
                        $value->dispatch_quantity   = $value->dispatch_quantity - $biltycatagory->quantity;

                       $value->save();
                       
                    }
                }
                }
               
               $StockBookingDetail->delivered  = $StockBookingDetail->delivered -$biltydetail['quantity'];

              
              $StockBookingDetail->save();
          }
         

           


              $RawProductVendor = RawProductVendor::where('raw_id',$biltydetail['product_id'])->where('vendor_id',$bilty->supplier_id)->first();



 ///add quantity in raw material tabel and vendorproduct and rawproduct desktop table 
        $qty   =  $RawProductVendor->quantity - $biltydetail['quantity'];

        $RawProductVendor->quantity = $qty;

       $RawProductVendor->save();

        $raw_material = RawMaterial::where('id',$biltydetail['product_id'])->first();


        $qty_raw   =   $raw_material->quantity  - $biltydetail['quantity'];

        $raw_material->quantity = $qty_raw;

        $raw_material->save();

             
        $biltydetail->delete();

          }

         $stock_booking  = StockBooking::where('id',$bilty->stock_booking_id)->first();
         if($stock_booking){
         $stock_booking->status = "Booked";

         $stock_booking->save();
     }

         $ponumber = PoNumber::where('po_number_raw',$bilty->po_no_raw)->first();
         if($ponumber){
         $ponumber->status = "Booked";

         $ponumber->save();
         } 

          UserExpenseDetail::where('detail_id', $request->bilty_id)->where('type','Sale')->delete();
         $bilty->delete();


 }




else{

   return API::response()->array(['success' => false, 'message' => 'bilty not found'], 400);


}


return API::response()->array(['success' => true, 'message' => 'deleted raw bilty successfully',
    'data' => $sub], 200);

}catch (Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}


     public function CalculateInvoice($product_id,$quantity,$type){
        switch ($type){
            case 'Distributor':
               $p= ProductPrice::where('product_id',$product_id)->first();
               if(!empty($p) && !empty($p->distributor_price)){
                   return $p->distributor_price * $quantity;
               }
                break;
            default:
                return 0;
        }
    }
    
    public function CalculateExportInvoice($product_id,$quantity,$party_id){
        $p= PartyRates::where('product_id',$product_id)
            ->where('party_id',$party_id)->first();
        if(!empty($p)){
            return $p->price * $quantity;
        }else{
            return 0;
        }
    }
    public function AddBiltyInvoice(Request $request)
    {
        try {
            $validator = \Validator::make($request->all(), ['invoice_no' => 'required|unique:biltis']);
            if ($validator->fails()) {
                return API::response()->array(['success' => false, 'error' => 'Required parameters are missing or incorrect!',
                    'message' => 'This Invoice no already exist!'], 400);
            } else {
                $bilty=  Bilti:: where('id',$request->get('id'))
                    ->update(array('invoice_no' => $request->get('invoice_no'),'admin_remarks' => $request->get('admin_remarks')));
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => ' Invoice number added ',
            'data' => $bilty], 200);
    }
    
      public function FilterRsmPayment(Request $request){
        try {
            $obj="";
            if($request->get('type')=="admin_pending")

            {
                $obj= RsmPayment::where('vendor_refno','!=',NULL)->
                where('accountant_refno','!=',NULL)->Where('status','Closed')->whereDate('date','>=','2019-06-1')

                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
            }

            if($request->get('type')=="accountant_approved"){
                $obj= RsmPayment::where('accountant_refno','!=',NULL)->whereDate('date','>=','2019-06-1')->where('vendor_refno','!=',NULL)->
                Where('status','Closed')
                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
            }


           if($request->get('type')=="vendor_pending"){
                $obj= RsmPayment::where('vendor_refno','=',NULL)->where('vendor_approval','=',0)->WhereNotIn('payment_to', [98,100,44])->whereDate('date','>=','2019-06-1')
                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
                    ->get();
            }


            if($request->get('type')=="accountant_pending"){
                $obj= RsmPayment::
                WhereIn('status',['Approved','Completed','Pending'])->Where(function ($query) {
                $query->
                
                
                
                where('accountant_refno','=','')->where(function($query) {
               
                return $query->where('payment_to',45)->whereNotIn('vendor_approval',[2,0])->where('vendor_refno','!=',NULL);
            })->orwhere('vendor_refno','!=',NULL)->orwhere('payment_to', 98)
                      ->orwhere('payment_to', '100')->orwhere('payment_to', '44');
            })
                
                
                
                ->where('date','>=','2019-06-01')  ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])->get();
            }



//            if($request->get('type')=="accountant_approved"){
//                $obj= RsmPayment::where('accountant_refno','!=',NULL)->whereDate('date','>=','2019-06-1')->where('vendor_refno','!=',NULL)->
//                where('admin_refno','!=',NULL)->Where('status','Closed')
//                    ->with(['payment_by_info','payment_to_info','completed_by_info','account_info','payment_images','party_info'])
//                    ->get();
//            }

            return API::response()->array(['success' => true,
                'message' => 'Filter Applied ',
                'data' => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
   public function AllBilty(Request $request)
{
    try {

        $bilty= Bilti::query();

        if (!empty($request->party_id)) {
            switch ($request->party_id){
                case 5000:
                $party=PartyName::select('id')->where('region_id','!=',2)->whereNotIn('id', [19,20,33])->get()->toArray();
                        //5000 shah filter
                $bilty = $bilty->wherein('party_id',$party)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0);
                break;
                case 5001:
                        //export 5001 filter

                $party=PartyName::select('id')->whereNotIn('id', [19,20,33])->get()->toArray();
                $bilty = $bilty->whereNotIn('party_id',$party)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0);
                break;
                case 5002:
                        //export 5002 User filter
                $party_id=showPartyToExport();
                $bilty = $bilty->whereIn('party_id',$party_id)->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0);
                break;
                case 0:
                break;
                default:
                        //party filter
                $bilty = $bilty->where('party_id',$request->party_id)->whereNotIn('id', [19,20,33])->where('po_no_warehouse','=',0)->where('po_no_rsm','=', 0)->where('po_no_raw',0)->where('po_no_adv',0);
                break;
            }
        }

        if (!empty($request->start_date) && !empty($request->end_date)) {

            $bilty = $bilty->whereNotIn('party_id', [19,20,33])->whereBetween('delivered_date', [$request->start_date, $request->end_date])->where('po_no_warehouse','=',0)->where('po_no_rsm',0)->where('po_no_raw',0)->where('po_no_adv',0);

        }
        if (!empty($request->user_id) && ($request->user_id!=9 ) && ($request->user_id!=91 )&& ($request->user_id !=103 ) && ($request->user_id !=104 ) ) {
            $bilty = $bilty->where('supplier_id', $request->user_id)->where('po_no_warehouse','=',0)->where('po_no_rsm',0)->where('po_no_raw',0)->where('po_no_adv',0);

        }

        $bilty = $bilty ->where('supplier_id', '<>',99)->where('po_no_raw', '=',0)->where('po_no_warehouse','=',0)->where('po_no_rsm',0)->with(['bilty_stock_order','biltyImages','bilty_supplier'=>function($query){ return $query->select('id','firstname','lastname','image');},'bookBy'=>function($query){ return $query->select('id','firstname','lastname','image');},'bilty_detail'=>function($query)
            {$query->with(['bilty_product','bilty_detail_type'=>function($query)
                {$query->with(['productCategory'])->get();}])->get();},])
        ->get();
//            if (!empty($request->get('party_id')) && $request->get('party_id')!=0 ) {
//                $bilty = $bilty->where('party_id', $request->get('party_id'))
//                    ->with(['bilty_stock_order','biltyImages','bilty_supplier'=>function($query){ return $query->select('id','firstname','lastname','image');},'bookBy'=>function($query){ return $query->select('id','firstname','lastname','image');},'bilty_detail'=>function($query)
//                    {$query->with(['bilty_product','bilty_detail_type'=>function($query)
//                    {$query->with(['productCategory'])->get();}])->get();},])
//                    ->get();
//            } else {
//
//            }

    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Bilty ',
        'data' => $bilty], 200);
}

     public function  Edit_Bilty(Request $request)
    {

        
        try{ 
            if($request->type == "Sale"){
            UserExpenseDetail::where('detail_id', $request->id)->where('type','Sale')->update(array('amount' => $request->payment));
            
        $update_bilty = Bilti::where('id', $request->id)
            ->update(array('price' => $request->price,'payment'=>$request->payment));

        foreach ($request['products'] as $product){

            $update_bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])
                ->update(array('price' => $product['price'],'payment'=>$product['payment'],'quantity' => $product['quantity']));
            }
        }
        else
            {
                UserExpenseDetail::where('detail_id', $request->id)->where('type','Sale')->update(array('vendor_price' => $request->price));
            
        $update_bilty = Bilti::where('id', $request->id)
            ->update(array('vendor_price' => $request->price));

        foreach ($request['products'] as $product){

            $update_bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])
                ->update(array('vendor_price' => $product['price'],'quantity' => $product['quantity']));
            }

        }
        }
         catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Bilty Updated '], 200);




    }
    
public function  Edit_Bilty_Product(Request $request)
{

    try{

         $bilty = Bilti::where('id', $request->id)->first();
         
         if($bilty->po_no_rsm == 0) {
        if($request->type == "Sale"){


           
            $total_price = 0;

            $total_payment = 0;

            $remark = " ";
           
           // return $request['products'];
            foreach ($request['products'] as $product){

                $bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])->first();

                 $pro = Product::where('id',$product['id'])->first();

                 $price = ($product['quantity']) * ($product['unit_price']);

                 $payment=$price-(($price*$product['discount'])/100);

                if($bilty_detail->price != $price && $bilty_detail->discount != $product['discount']  ){

                $remark = $remark ."Prodcut Name: ". $pro->name . "<br> Old discount: " . $bilty_detail->discount."% <br> New discount: " .  $product['discount']."% <br> Old price: " .  $bilty_detail->price. "<br> New Price: " .  $price."<br> Old payment: " .  $bilty_detail->payment. "<br> New Payment: " .  $payment."<br>";

                }
                else{

                     if($bilty_detail->price != $price){
                   
                      $remark = $remark ."Prodcut Name: ". $pro->name . "<br> Old price: " .  $bilty_detail->price. "<br> New Price: " .  $price."<br> Old payment: " .  $bilty_detail->payment. "<br> New Payment: " .  $payment."<br>";


                     }

                     if ($bilty_detail->discount != $product['discount'])
                     {
 
                   $remark =$remark ."Prodcut Name: ". $pro->name . "<br> Old discount: " . $bilty_detail->discount."% <br> New discount: " .  $product['discount']."%<br>";

                     }


                }


              
                $total_price = $total_price + $price;
                $total_payment = $total_payment + $payment;
              $update_bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])
            ->update(array('price' => $price,'payment'=>$payment,'quantity' => $product['quantity'],'discount' => $product['discount']));
            }
       
                $bilty_log  =   new  PaymentRemark();
                $bilty_log->rsm_id = $request->id;
                $bilty_log->party_id = $request->party_id;
                $bilty_log->user_id = $request->user_id;
                $bilty_log->type = "edit_bilty_log";
                $bilty_log->remarks = $remark;

                $bilty_log->user_remarks = $request->remarks;
                 if($request->image){

         $image = upload_base64_image($request->image, 'uploads/image_log/',
                    'image-');
        }
               $bilty_log->image_url = $image;
               $bilty_log->save();
            

             $update_bilty = Bilti::where('id', $request->id)
            ->update(array('price' => $total_price,'payment'=>$total_payment));


             UserExpenseDetail::where('detail_id', $request->id)->where('type','Sale')->update(array('amount' => $total_payment));
        }
        else
        {
        

           $total_price = 0;

            $remark = " ";
          

            foreach ($request['products'] as $product){

                 $bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])->first();

                 $pro = Product::where('id',$product['id'])->first();

                 $price = ($product['quantity']) * ($product['unit_price']);


                if($bilty_detail->vendor_price != $price){

                $remark = $remark ."Prodcut Name: ". $pro->name . "<br> Old vendor_price: " .  $bilty_detail->vendor_price. "<br> New Vendor_Price: " .  $price ."<br>";

                }
              

                $total_price = $total_price + $price;

                $update_bilty_detail = BiltiDetail::where('bilti_id',$request->id)->where('product_id',$product['id'])
                ->update(array('vendor_price' => $product['price'],'quantity' => $product['quantity']));


            }


                $bilty_log  =   new  PaymentRemark();
                $bilty_log->rsm_id = $request->id;
                $bilty_log->party_id = $request->party_id;
                $bilty_log->user_id = $request->user_id;
                $bilty_log->type = "edit_purchase_invoice";
                $bilty_log->remarks = $remark;
                $bilty_log->user_remarks = $request->remarks;
                 if($request->image){

         $image = upload_base64_image($request->image, 'uploads/image_log/',
                    'image-');
        }
               $bilty_log->image_url = $image;
               $bilty_log->save();
            

            
             $update_bilty = Bilti::where('id', $request->id) ->update(array('vendor_price' => $total_price));


              UserExpenseDetail::where('detail_id', $request->id)->where('type','Sale')->update(array('vendor_price' => $total_price));
        

        }
    }else{

       return API::response()->array(['success' => false, 'message' => 'its asm bility',], 400);
    }
    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'Bilty Updated '], 200);


}
  public function PaymentStatusUpdateAccountant(Request $request)
    {

      
        try {


                $obj=RsmPayment::where('id',$request->get('id'))->update(['status'=>'Closed','accountant_refno'=>$request->get('accountant_refno'),
                    'accountant_remarks'=>$request->get('remarks')]);
          

           



        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Amount Updated ',
            'data' => $obj], 200);

    } 
    
    
    public function ExpenseIssueAccountant()
    {


        try {


            $obj=UserExpenseDetail::where('status_check',4)->with('user_expense')-> 
                with('user_expense.expense')->get();

            

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payment Status Updated ',
            'data' => $obj], 200);

    }
  public function VendorInvoicesAccountant()
    {


        try {

            $invoices=array();



            $obj=VendorInvoice::where('accountant_status',0)->get();
            $obj2=Bilti::where('supplier_id','!=',45)->where('supplier_id','!=',99)->where('accountant_vendor_price',0)->whereDate('bilti_date','>=','2019-6-30')->with('bilty_supplier')->get();
$invoices['biotech']=$obj;
$invoices['other']=$obj2;
          



        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Vendor Invoices Pending from Accountant',
            'data' => $invoices], 200);

    }
    
    public function VendorInvoicesAccountantTotal(Request $request)
    {

        $obj="";
        try {
            if($request->get('type')=='biotech'){

                $obj= VendorInvoice::find($request->get('id'));

                if(round($obj->total_amount)==round($request->get('amount')))
                {

                    $obj=$obj->update(['accountant_amount'=>$request->get('amount'),'accountant_status'=>1]);
                }
                else{
                    $obj=$obj->update(['accountant_amount'=>$request->get('amount'),'accountant_status'=>2]);

                }
            }

            if($request->get('type')=='Other'){


                $obj= bilti::find($request->get('id'));


                if(round($obj->vendor_price)==round($request->get('amount')))
                {

                    $obj=$obj->update(['accountant_vendor_price'=>$request->get('amount'),'accountant_vendor_status'=>1]);
                }
                else{
                    $obj=$obj->update(['accountant_vendor_price'=>$request->get('amount'),'accountant_vendor_status'=>2]);

                }

            }





        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Invoice Status Changed ',
            'data' => $obj], 200);

    }

public function ExpenseAmountUpdateAccountant(Request $request)
{

    $obj="";
        try {

            $obj= UserExpense::find($request->get('id'));

             if(abs($obj->amount - $request->get('amount'))>=10)
            {
                 $check = $obj->amount - $request->get('amount');
                $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $obj->id;
                $paymentRemark->type = "expense_issue";
               $remark = "Expense Amount:" . $obj->amount."<br> Accountant Amount:" .  $request->get('amount')."<br> Difference:".$check;


                $paymentRemark->remarks = $remark;
                $paymentRemark->save();


                UserExpenseDetail::where('type',"Expense")->where('detail_id',$obj->id)->update(['status_check'=>4]);
            }

            $obj=$obj->where('id',$request->get('id'))->update(['accountant_amount'=>$request->get('amount')]);




        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Amount Updated ',
            'data' => $obj], 200);

}


  public function CreditAmountUpdateAccountant(Request $request)
    {

        $obj="";
        try {


           $obj2= $obj= UserExpense::where('id',$request->get('id'))->first();


            $obj=$obj->where('id',$request->get('id'))->update(['accountant_check_credit'=>$request->get('refno')]);

LedgerAdjust($obj2->party_id);


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Amount Updated ',
            'data' => $obj], 200);

    }
    
    public function SaleReturnAmountUpdateAccountant(Request $request)
    {

        $obj="";
        try {


            $obj2=$obj= Stockbooking::where('id',$request->get('id'))->first();
            $obj=$obj->where('id',$request->get('id'))->update(['accountant_check_return'=>$request->get('refno')]);
                $party=partyname::where('id',$obj2->party_id)->first();
                $e= new UserExpenseDetail();
                $e->user_id=$obj2->booked_by;
                $e->party_id=$obj2->party_id;
                $e->detail_id=$obj2->id;
                $e->vendor_id=0;
                $e->amount=$obj2->payment;
                $e->vendor_price=0;
                $e->balance=$party->balance-$obj2->payment;
                $party->balance= $e->balance;
                $party->save();
                $e->type='Sale Return';
                $e->date=date("Y-m-d");
                $e->save();



        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expense Amount Updated ',
            'data' => $obj], 200);

    }
    
    
      public function FilterBilty(Request $request)
{
    try {

        $bilty= Bilti::query();
        $obj="";
        if($request->get('type')=='qb')
        {
            $obj=$bilty->where('invoice_no','=',NULL)->where('po_no_warehouse','=',0)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->whereDate('bilti_date','>=','2019-6-1')->where('accountant_price','!=',0)->with('party_info')->where('supplier_id','!=',99)->get();
        }

        if($request->get('type')=='amount')
        {
            $obj=$bilty->where('accountant_price','=',0)->where('po_no_warehouse','=',0)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->whereDate('bilti_date','>=','2019-6-1')->where('invoice_no','!=',NULL)->with('party_info')->where('supplier_id','!=',99)->get();
        }
        if($request->get('type')=='pending')
        {
            $obj=$bilty->where('accountant_price','=',0)->where('po_no_warehouse','=',0)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->whereDate('bilti_date','>=','2019-6-1')->where('invoice_no','=',NULL)->with('party_info')->where('supplier_id','!=',99)->get();
        }

        if($request->get('type')=='complete')
        {
            $obj=$bilty->where('accountant_price','!=',0)->where('po_no_warehouse','=',0)->where('po_no_raw','=',0)->where('po_no_rsm','=',0)->whereDate('bilti_date','>=','2019-6-1')->where('invoice_no','!=',NULL)->with('party_info')->where('supplier_id','!=',99)->get();

        }
         if($request->get('type')=='Price_Issue')
        {
            $obj= $obj= Bilti::where('accountant_status',1)->with('party_info')->get();

        }



    }
    catch(Exception $e)
    {
        return API::response()->array(['success' => false,
            'message' => $e->getTraceAsString()], 400);
    }
    return API::response()->array(['success' => true, 'message' => 'All Bilty ',
        'data' => $obj], 200);
}
    public function FilterBiltyUpdateAccountant(Request $request)
{
    try {



        $bilty= Bilti::query();
        $obj="";
        $flag=1;
        if($request->get('type')=='qb')
        {
            $obj=$bilty->where('id','=',$request->get('id'))->update(['invoice_no'=>$request->get('value')]);
        }

        else if($request->get('type')=='amount')
        {
         $flag=0;

         
         $obj=$bilty->where('id','=',$request->get('id'))->first();

         $payment = $obj->payment;
         $check = $payment - $request->get('value');
         //return $check;
         if($check < -10 || $check > 10){
             $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $obj->id;
                $paymentRemark->type = "sale_price_issue";
               $remark = "Payment Price:" . $payment."<br> Accountant_Price:" .  $request->get('value')."<br> Price_Difference:".$check;

                $paymentRemark->remarks = $remark;
                $paymentRemark->save();
            $obj->update(['accountant_price'=>$request->get('value'),'accountant_status'=> 1]);
         }
         else{
         $obj->update(['accountant_price'=>$request->get('value'),'accountant_status'=> 0]);

     }
}


 }
 catch(Exception $e)
 {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'Bilty Updated','data'=>$flag], 200);
}
    
    public function AllBiltyAdv(Request $request)
    {
        try {
            $bilty= Bilti::query();
            if (!empty($request->get('start_date')) && !empty($request->get('end_date'))) {
                $bilty = $bilty->whereBetween('bilti_date', [$request->get('start_date'), $request->get('end_date')]);
            }
            if (!empty($request->get('user_id')) && ($request->get('user_id')!=9 ) && ($request->get('user_id')!=91 )) {
                $bilty = $bilty->where('supplier_id', $request->get('user_id'));
            }
            if (!empty($request->get('party_id')) && $request->get('party_id')!=0 ) {
                $bilty = $bilty->where('party_id', $request->get('party_id'))
                    ->with(['bilty_stock_order','biltyImages','bilty_supplier'=>function($query){ return $query->select('id','firstname','lastname','image');},'bookBy'=>function($query){ return $query->select('id','firstname','lastname','image');},'bilty_detail'=>function($query)
                    {$query->wherein('product_id',vendorProduct(99))->with(['bilty_product','bilty_detail_type'=>function($query)
                    {$query->with(['productCategory'])->get();}])->get();},])
                    ->get();
            } else {
                $bilty = $bilty ->with(['bilty_stock_order','biltyImages','bilty_supplier'=>function($query){ return $query->select('id','firstname','lastname','image');},'bookBy'=>function($query){ return $query->select('id','firstname','lastname','image');},'bilty_detail'=>function($query)
                {$query->wherein('product_id',vendorProduct(99))->with(['bilty_product','bilty_detail_type'=>function($query)
                {$query->with(['productCategory'])->get();}])->get();},])
                    ->get();
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'All Bilty ',
            'data' => $bilty], 200);
    }
    /***
     * Get SO Product Bilty
     *
     * @param Request $request
     * @return mixed
     */
    public function soProductBilty(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $product_Id = $request->get('product_id');

                $bilty_detail= Bilti::where('delivered_to_id',$so_Id)
                    ->with(['bilty_supplier','bilty_detail'=>function($query)use($product_Id)
                    {$query->where('product_id',$product_Id)->with(['bilty_product','bilty_detail_type'=>function($query)
                    {$query->with(['productCategory'])->get();}])->get();},])->get();
//            return $bilty_detail;
            $detail = [];
            foreach ($bilty_detail as $a=>$bilty){
//                return $bilty->bilty_detail;
                $detail[$a]['id'] =  $bilty->id;
                $detail[$a]['supplier_name'] =  $bilty->bilty_supplier->firstname;
                $detail[$a]['bilti_date'] =  $bilty->bilti_date;
                $detail[$a]['bilti_no'] =  $bilty->bilti_no;
                $detail[$a]['status'] =  $bilty->status;
                foreach ($bilty->bilty_detail as $key =>$bilty_detail){
//                    return $bilty_detail->bilty_product->name;
                    $detail[$a]['products'][$key]['quantity'] = $bilty_detail->quantity;
                    $detail[$a]['products'][$key]['quantity_received'] = $bilty_detail->quantity_received;
                    $detail[$a]['products'][$key]['name'] = $bilty_detail->bilty_product->name;
                    $detail[$a]['products'][$key]['id'] = $bilty_detail->bilty_product->id;
                    $detail[$a]['products'][$key]['date_receiving'] = date('Y-m-d',strtotime($bilty_detail->updated_at));
                    $detail[$a]['products'][$key]['product_detail_type'] = [];
                    foreach ($bilty_detail->bilty_detail_type as $x=>$bilty_detail_type){
//                        return $bilty_detail_type;
                        $detail[$a]['products'][$key]['product_detail_type'][$x] = $bilty_detail_type;
                    }
                }

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'SO Bilty Detail',
            'data' => $detail], 200);
    }
    /***
     * Get SO Targets
     *
     * @param Request $request
     * @return mixed
     */
   public function addRsmTarget(Request $request){

        try {
            $obj= RsmTarget::where('rsm_id',$request->get('rsm_id'))
                ->where('status','Processed')->first();
            if(!empty($obj)){
                return API::response()->array(['success' => false, 'message' => 'RSM Targets Already Assign Please mark previous target completed'], 200);
            }
            
            $rsm=PartyName::where('id',$request->party_id)->with('region')->first();
           
            $obj=new RsmTarget();
            $obj->start_date=$request->get('start_date');
            $obj->end_date=$request->get('end_date');
            $obj->rsm_id=$rsm->region->rsm_id;
            $obj->party_id=$request->get('party_id');
             $obj->coupan_scheme_id=$request->get('coupan_scheme_id');
            $obj->added_by=$request->get('added_by');
            $obj->sales_target=$request->get('sales_target');
            $obj->recovery_target=$request->get('recovery_target');
            $obj->status='Processed';
            $obj->save();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets Assign Sucessfully',
            'data' => $rsm], 200);
    }
    public function getRsmTarget(Request $request){
        try {
           if($request->get('party_id')!=0)
           {
                 $obj= RsmTarget::where('party_id',$request->get('party_id'))->with(['added_by','rsm_info'])->get();
           }
           if($request->get('rsm_id')!=0)
           {
               $obj= RsmTarget::where('party_id',$request->get('party_id'))->with(['added_by','rsm_info'])->get();
           }
           
          
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets',
            'data' => $obj], 200);
    }
    public function getRsmTargetachieved(Request $request){
        try {
            $target= RsmTarget::where('id',$request->get('id'))->with(['added_by','rsm_info'])->first();
            $obj=null;
            if(!empty($target)){
               $sales= Bilti::where('delivered_to_id',$target->rsm_id)
                   ->whereBetween('bilti_date', [$target->start_date,$target->end_date])
                   ->sum('payment');
               $recovery= RsmPayment::where('payment_by',$target->rsm_id)
                   ->whereBetween('date', [$target->start_date,$target->end_date])
                   ->sum('amount');
                $obj= new \stdClass();
                $obj->target=$target;
                $obj->sales_achieved=$sales;
                $obj->recovery_achieved=$recovery;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets',
            'data' => $obj], 200);
    }
    public function modifyRsmTargetStatus(Request $request){
        try {
            $obj= array();
            $obj['RSM']= RsmTarget::where('id',$request->get('id'))->update(['status'=>$request->get('status')]);
            $obj['ASM']= AsmTarget::where('rsm_target_id',$request->get('id'))->update(['status'=>$request->get('status')]);
            $obj['Distributor']= DistributorTarget::where('rsm_target_id',$request->get('id'))->update(['status'=>$request->get('status')]);
            $obj['DSF']= DsfTarget::where('rsm_target_id',$request->get('id'))->update(['status'=>$request->get('status')]);

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets',
            'data' => $obj], 200);
    }
    public function modifyRsmTargetenddate(Request $request){
        try {
            $obj= array();
            // $obj= RsmTarget::where('id',$request->id)->update(['end_date'=>$request->end_date,'start_date'=>$request->start_date,'sales_target'=>$request->sales_target,'recovery_target' => $request->recovery_target]);
            $obj['RSM']= RsmTarget::where('id',$request->id)->update(['end_date'=>$request->end_date,'start_date'=>$request->start_date]);
            $obj['ASM']= AsmTarget::where('rsm_target_id',$request->id)->update(['end_date'=>$request->end_date,'start_date'=>$request->start_date]);
            $obj['Distributor']= DistributorTarget::where('rsm_target_id',$request->id)->update(['end_date'=>$request->end_date,'start_date'=>$request->start_date]);
            $obj['DSF']= DsfTarget::where('rsm_target_id',$request->id)->update(['end_date'=>$request->end_date,'start_date'=>$request->start_date]);
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'RSM Targets end date modify',
            'data' => $obj], 200);
    }
    public function soTargets(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $originalDate = $request->get('date');
                $targets = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_targets'=>function($query)use($originalDate,$so_Id)
                    {$query->where('date',$originalDate)->where('user_id',$so_Id)->first();},
                    ])->first();
//            return $targets;
            $targets= $targets->so_targets;


            $sale_officers_data = array();

            $start_date = new \DateTime($originalDate);
            $start=1;
            $end= date(' t ', strtotime($originalDate) );
            for($start;$start<=$end;$start++) {
                $sale = 0;
                $recovery = 0;
                $pending = 0;

                $orders = User::where('id',$so_Id)->select(['id','firstname','lastname'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->select(['id','sale_officer_id'])
                        ->with(['orders'=>function($query)use($start_date,$so_Id)
                        {$query->whereDate('date_to_deliver','=',$start_date)->where('booked_by',$so_Id)
                            ->where('status','=','Delivered')->where('type','!=','Sample')->get();}]);},
                    ])->get();
                $user_ids=[];
                $user_ids[]=$so_Id;
                // So supplier addition
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$so_Id)->get();
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }

                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id,$user_ids)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id,$user_ids)
                    {$query->whereDate('promise_cheque_date','=',$start_date)->wherein('user_id',$user_ids)
                        ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->get();}]);},
                    ])->get();
                $checks = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id,$user_ids)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id,$user_ids)
                    {$query->whereDate('promise_cheque_date','=',$start_date)->wherein('user_id',$user_ids)
                        ->where('payment_type','!=','Promise')->where('payment_type','Cheque')->get();}]);},
                    ])->get();

                $sale_officers_data[$start]['date'] = $start_date->format('Y-m-d');

                foreach ($orders as $order){
                    foreach ($order->so_customers as $customer){
                        foreach ($customer->orders as $customer_order){
                            $sale +=  $customer_order['payment'];
                        }
                    }
                }
                foreach ($payments as $payment){
                    foreach ($payment->so_customers as $customer){
                        foreach ($customer->payments as $customer_payment){
                            $recovery +=  $customer_payment['amount'];
                        }
                    }
                }
                foreach ($checks as $check){
                    foreach ($check->so_customers as $customer){
                        foreach ($customer->payments as $customer_payment){
                            $pending +=  $customer_payment['amount'];
                        }
                    }
                }

                $sale_officers_data[$start]['sale'] = $sale;
                $sale_officers_data[$start]['recovery'] = $recovery;
                $sale_officers_data[$start]['pending_checks'] = $pending;


                $start_date = $start_date->modify('+1 day');
            }
            $so_sale = 0;
            $so_recovery = 0;
            $so_pending_checks = 0;
            foreach ($sale_officers_data as $so_data){
                 $so_sale += $so_data['sale'];
                 $so_recovery += $so_data['recovery'];
                 $so_pending_checks += $so_data['pending_checks'];
            }
            foreach ($targets as $target){
                $target->sale =  $so_sale;
                $target->recovery =  $so_recovery;
                $target->pending_checks =  $so_pending_checks;
            }
            $month = date("m",strtotime($originalDate));
            $customer_targets = SoTarget::where('so_id',$so_Id)->where('date',$originalDate)->where('customer_add',1)->select('id','date','customer_add_target')
                ->first();
            $check = 0;
            if($customer_targets == ''){
                $check = 0;
            }else {
                $check = 1;
                $customer_target = $customer_targets->customer_add_target;

                $user_customers = User::where('id', $so_Id)->select(['id', 'firstname', 'lastname', 'image'])
                    ->with(['so_customers' => function ($query) use ($month) {
                        $query->whereMonth('created_at', $month)->get();
                    },])->first();
                $customer_targets['customer_added'] = count($user_customers->so_customers);
                $total_customers = 0;
                foreach ($user_customers->so_customers as $customer) {
                    $so_orders = Order::where('shop_id', $customer->id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                        ->whereMonth('date_to_deliver', $month)->first();
                    if ($so_orders == '') {

                    } else {
                        $total_customers++;
                    }
                }
            }
            $month = date("m",strtotime($originalDate));
            $customer_visit_order_targets = SoTarget::where('so_id',$so_Id)->where('date',$originalDate)->where('customer_visit',1)->select('id','date','customer_visit_target')
                ->first();
            $check1 = 0;
            if($customer_visit_order_targets == ''){
                $check1 = 0;
            }else {
                $check1 = 1;
                $customer_order_target = $customer_visit_order_targets->customer_visit_target;

                $user_customers = User::where('id', $so_Id)->select(['id', 'firstname', 'lastname', 'image'])
                    ->with(['so_customers'])->first();
                $total_customers_orders = 0;
                foreach ($user_customers->so_customers as $customer) {
                    $so_orders = Order::where('shop_id', $customer->id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                        ->whereMonth('date_to_deliver', $month)->first();
                    if ($so_orders == '') {

                    } else {
                        $total_customers_orders++;
                    }
                }
            }

            if(count($targets) == 0){
                $so_targets = [];
                $so_targets['sales_target'] = 0;
                $so_targets['recovery_target'] = 0;
                $so_targets['sale'] = $so_sale;
                $so_targets['recovery'] = $so_recovery;
                $so_targets['pending_checks'] = $so_pending_checks;
            }else{
                foreach ($targets as $target) {
                    $so_targets = [];
                    $so_targets['sales_target'] = $target->sales_target;
                    $so_targets['recovery_target'] = $target->recovery_target;
                    $so_targets['sale'] = $so_sale;
                    $so_targets['recovery'] = $so_recovery;
                    $so_targets['pending_checks'] = $so_pending_checks;
                }
            }
            if($check == 0){
                $so_targets['customer_target'] = 0;
                $so_targets['customer_added'] = 0;
            }else{
                $so_targets['customer_target']= $customer_target;
                $so_targets['customer_added']= $total_customers;

            }
            if($check1 == 0){
                $so_targets['customer_visit_order_target'] = 0;
                $so_targets['customer_visit_order_taken'] = 0;
            }else{
                $so_targets['customer_visit_order_target']= $customer_order_target;
                $so_targets['customer_visit_order_taken']= $total_customers_orders;

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Targets',
            'data' => $so_targets], 200);
    }
    /***
     * Get SO Ordered Customers
     *
     * @param Request $request
     * @return mixed
     */
    public function soOrderedCustomers(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $originalDate = $request->get('date');
            $month = date("m",strtotime($originalDate));

                $user_customers = User::where('id', $so_Id)->select(['id', 'firstname', 'lastname', 'image'])
                    ->with(['so_customers'=>function($query){$query->with(['images']);}])->first();

                foreach ($user_customers->so_customers as $key=>$customer) {
                    $so_orders = Order::where('shop_id', $customer->id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                        ->whereMonth('date_to_deliver', $month)->first();
                    if ($so_orders == '') {
                        unset( $user_customers->so_customers[$key]);
                    } else {

                    }
                }
                $customers = [];
                foreach ($user_customers->so_customers as $customer){
                    $customers[] =  $customer;
                }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Ordered Customers',
            'data' => $customers], 200);
    }
    /***
     * Get SO Targets Product Wise
     *
     * @param Request $request
     * @return mixed
     */
    public function soTargetsProducts(Request $request)
    {
        try {
            $main_array=[];
            $main=[];
            $so_id = $request->get('so_id');
            $start_date = $request->get('date_start');
            $date=date_create($start_date);
            $originalDate =  date_format($date,"Y-m");
            $end_date = $request->get('date_end');
            $pre_start_date=date("Y-m-d",strtotime("-1 month",strtotime($start_date )));
            $date=date_create($pre_start_date);
            $preOriginalDate =  date_format($date,"Y-m");
            $pre_end_date=date("Y-m-d",strtotime("-1 month",strtotime($end_date )));
            $target=SoTarget::where('so_id',$so_id)
                ->where('productwise',1)
                ->where('date',$originalDate)
                ->get();
            $pre_target=SoTarget::where('so_id',$so_id)
                ->where('productwise',1)
                ->where('date',$preOriginalDate)
                ->get();
            $orders=Order::select('id')
                ->where('booked_by',$so_id)
                ->where('status','Delivered')
                ->where('type','!=','Sample')
//                ->whereBetween('date_to_deliver', ['2018-06-01','2018-06-30'])
                ->whereBetween('date_to_deliver', [$start_date,$end_date])
                ->get();
            $pre_orders=Order::select('id')
                ->where('booked_by',$so_id)
                ->where('status','Delivered')
                ->where('type','!=','Sample')
                ->whereBetween('date_to_deliver', [$pre_start_date,$pre_end_date])
                ->get();
            $products=Product::select('id','name')->get();
            foreach ($products as $key=>$product) {
                $quantity = 0;
                $pre_quantity = 0;
                if (count($target )> 0){
                    foreach ($target as $data) {
                        $orderProd = SoTargetDetail::select('target')->where('so_target_id', $data->id)
                            ->where('product_id', $product['id'])
                            ->first();
                        if (!empty($orderProd)) {
                            $main_array[$key]['id'] = $product['id'];
                            $main_array[$key]['name'] = $product['name'];
                            $main_array[$key]['target'] = $orderProd->target;
                        } else {
                            $main_array[$key]['id'] = $product['id'];
                            $main_array[$key]['name'] = $product['name'];
                            $main_array[$key]['target'] = 0;
                        }
                    }
            }else{
                    $main_array[$key]['id'] = $product['id'];
                    $main_array[$key]['name'] = $product['name'];
                    $main_array[$key]['target'] = 0;
                }
                if (count($pre_target) > 0) {
                    foreach ($pre_target as $data) {
                        $orderProd = SoTargetDetail::where('so_target_id', $data->id)
                            ->where('product_id', $product['id'])
                            ->first();
                        if (!empty($orderProd)) {
                            $main_array[$key]['pre_target'] = $orderProd->target;
                        } else {
                            $main_array[$key]['pre_target'] = 0;
                        }
                    }
                }else{
                    $main_array[$key]['pre_target'] = 0;
                }
                foreach ($orders as $order){
                    $orderProd=OrderProduct::select('id','quantity')->where('order_id',$order['id'])
                        ->where('product_id',$product['id'])
                        ->first();
                    if(!empty($orderProd) ) {
                        $quantity = $quantity + $orderProd['quantity'];
                    }
                    $main[]=$orderProd;
                }
                foreach ($pre_orders as $pre_order){
                    $orderProd=OrderProduct::select('id','quantity')->where('order_id',$pre_order['id'])
                        ->where('product_id',$product['id'])
                        ->first();
                    if(!empty($orderProd) ) {
                        $pre_quantity = $pre_quantity + $orderProd['quantity'];
                    }
                    $main[]=$orderProd;
                }
                $main_array[$key]['quantity']=$quantity;
                $main_array[$key]['pre_quantity']=$pre_quantity;
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Targets Product Wise',
            'data' => $main_array], 200);
    }
    public function soTargetsProductsOld(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $startDate = $request->get('date_start');
            $endDate = $request->get('date_end');
            $month = date("m",strtotime($startDate));
            $date=date_create($startDate);
            $originalDate =  date_format($date,"Y-m");
            $last_date = $date->modify('-1 month');
            $last_original_date =  date_format($last_date,"Y-m");
            $product_targets = SoTarget::where('so_id',$so_Id)->where('date',$originalDate)->where('type','Productwise')->select('id','date')
                    ->with(['target_details'=>function($query)
                    {$query->with(['product'])->get();},
                    ])->first();
            $last_product_targets = SoTarget::where('so_id',$so_Id)->where('date',$last_original_date)->where('type','Productwise')->select('id','date')
                    ->with(['target_details'=>function($query)
                    {$query->with(['product'])->get();},
                    ])->first();
//            return $last_product_targets;
            if($product_targets == ''){
                return API::response()->array(['success' => false, 'message' => 'No Target Set'], 200);
            }

            foreach ($product_targets->target_details as $detail){
                $detail['product_name'] = $detail->product->name;
                $product_id = $detail->product->id;
                $so_orders = Order::where('booked_by', $so_Id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                    ->whereMonth('date_to_deliver', $month)
                    ->with(['products' => function ($query)use($product_id) {
                        $query->where('product_id',$product_id)->select(['product_id', 'name']);
                    }])->get();
                $sale_quantity = 0;
                foreach ($so_orders as $order){
                    foreach ($order->products as $product){
                        $sale_quantity += $product->pivot->quantity;
                    }

                }
                $detail['achieve_target'] = $sale_quantity;
                unset($detail->product);
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Targets Product Wise',
            'data' => $product_targets], 200);
    }
    /***
     * Get SO Targets Customers
     *
     * @param Request $request
     * @return mixed
     */
    public function soTargetsCustomers(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $originalDate = $request->get('date');
            $month = date("m",strtotime($originalDate));
                $customer_targets = SoTarget::where('so_id',$so_Id)->where('date',$originalDate)->where('type','Customer Add')->select('id','date')
                    ->with(['target_details'])->first();
            if($customer_targets == ''){
                return API::response()->array(['success' => false, 'message' => 'No Target Set'], 200);
            }
            foreach ($customer_targets->target_details as $targets){
                $customer_targets['target']= $targets->target;
                unset($customer_targets->target_details);
            }
            $user_customers = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                ->with(['so_customers'=>function($query)use($month)
                {$query->whereMonth('created_at',$month)->get();},])->first();
            $customer_targets['customer_added'] = count($user_customers->so_customers);
            $total_customers = 0;
            foreach ($user_customers->so_customers as $customer){
                $so_orders = Order::where('shop_id', $customer->id)->where('status', 'Delivered')->where('type', '!=', 'Sample')
                    ->whereMonth('date_to_deliver', $month)->first();
                if($so_orders == ''){

                }else{
                    $total_customers++;
                }
            }
            $customer_targets['customer_order_added']= $total_customers;

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Targets Product Wise',
            'data' => $customer_targets], 200);
    }
    /***
     * Get SO Customers Added
     *
     * @param Request $request
     * @return mixed
     */
    public function soCustomersAdded(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $originalDate = $request->get('date');
            $month = date("m",strtotime($originalDate));
            $user_customers = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                ->with(['so_customers'=>function($query)use($month)
                {$query->whereMonth('created_at',$month)->with(['images'])->get();},])->first();
             $user_customers['date']= $originalDate;
            $customers = [];
            foreach ($user_customers->so_customers as $customer){
                $customers[] =  $customer;
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'So Customers Newly Added',
            'data' => $customers], 200);
    }
    /***
     * Get SO Payments Cheque
     *
     * @param Request $request
     * @return mixed
     */
    public function soPaymentsCheque(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $sale_officers_data = array();
                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($so_Id)
                    {$query->with(['images','payments'=>function($query)use($so_Id)
                    {$query->where('user_id',$so_Id)->where('payment_type','Cheque')->get();}]);},
                    ])->get();
                foreach ($payments as $payment){
                    $sale_officers_data = $payment->so_customers;
                }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payments found',
            'data' => $sale_officers_data], 200);
    }
    public function soPaymentsChequePK(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $sale_officers_data = array();
            $supplier=SupplierSo::select('supplier_id')->where('so_id',$so_Id)->get();
            $user_ids=[];
            $user_ids[]=$so_Id;
            foreach ($supplier as $su){
                $user_ids[]=$su['supplier_id'];
            }
                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($so_Id,$user_ids)
                    {$query->with(['images','payments'=>function($query)use($so_Id,$user_ids)
                    {$query->wherein('user_id',$user_ids)->where('payment_type','Cheque')->with(['user'=>function($query){$query->select('id','firstname','lastname');}])->get();}]);},
//
                    ])->get();
                foreach ($payments as $payment){
                    $sale_officers_data = $payment->so_customers;
                }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Payments found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureOrders(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x=0;$x<=$days;$x++){
                $orders = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->select(['id','sale_officer_id','name','location','shop_type'])
                        ->with(['images','orders'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('date_to_deliver','=',$start_date)->where('booked_by',$so_Id)
                        ->where('status','=','Delivered')->where('type','!=','Sample')->get();}]);},
                    ])->get();
                foreach ($orders as $order){
                    $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$x]['so_order'][] = $order;
                }


                $start_date = $start_date->modify('+1 day');
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Orders found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Return Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureReturnOrders(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x = 0; $x <= $days; $x++) {
                $orders = User::where('id', $so_Id)->select(['id', 'firstname', 'lastname', 'image'])
                    ->with(['so_customers' => function ($query) use ($start_date, $so_Id) {
                        $query->select(['id', 'sale_officer_id', 'name', 'location', 'shop_type'])
                            ->with(['images', 'orders' => function ($query) use ($start_date, $so_Id) {
                                $query->whereDate('date_to_deliver', '=', $start_date)->where('booked_by', $so_Id)
                                    ->where('status', '=', 'Returned')->where('type', '!=', 'Sample')->get();
                            }]);
                    },
                    ])->get();
                foreach ($orders as $order) {
                    $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$x]['so_order'][] = $order;
                }
                $start_date = $start_date->modify('+1 day');
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Orders found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Expenses
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureExpenses(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_start');
            $end_date = $request->get('date_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x = 0; $x <= $days; $x++) {
                $userExpense = UserExpense::where('user_id', $so_Id)->whereDate('date',$start_date)->
                whereHas(
                    'expense', function ($q) {
                    $q->where('name', '!=', "Credit Note");
                })->

                with('Images')->get();
                foreach ($userExpense as $userExpens){
                    $userExpens['name'] =  $userExpens->expense->name;
                    unset($userExpens->expense);

                }

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$x]['user_expenses'] = $userExpense;
                $start_date = $start_date->modify('+1 day');
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expenses found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Expense Detail
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureExpenseDetail(Request $request)
    {
        try {
            $expenseId = $request->get('id');
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_start');
            $end_date = $request->get('date_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x = 0; $x <= $days; $x++) {
                  if($so_Id == 9 || $so_Id == 149){
                $userExpense = UserExpense::where('expense_id',$expenseId)->whereIn('user_id', [9,149])->whereDate('date',$start_date)->with(['expense','Images'])->get();
            }else{
                $userExpense = UserExpense::where('expense_id',$expenseId)->where('user_id', $so_Id)->whereDate('date',$start_date)->with(['expense','Images'])->get();
            }
               
                foreach ($userExpense as $userExpens){
                    $userExpens['name'] =  $userExpens->expense->name;
                    unset($userExpens->expense);

                }

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                    $sale_officers_data[$x]['user_expenses'] = $userExpense;
                $start_date = $start_date->modify('+1 day');
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expenses found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Expense Wise Detail
     *
     * @param Request $request
     * @return mixed
     */
  public function soTenureExpenseWiseDetail(Request $request)
    {
        try {

            $so_Id = $request->so_id;

            $sale_officers_data = array();
            if($so_Id == 9 || $so_Id == 149){
               $expenses = Expense::wherein('user_id',[9,149])->where('name', '!=', "Credit Note")->get();

           }else{
            $expenses = Expense::where('name', '!=', "Credit Note")->get();
        }
        foreach ($expenses as $key =>$expense)
        {
            $start_date = $request->date_start;
            $end_date = $request->date_end;
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $total_expense = 0;
            if($so_Id == 9 || $so_Id == 149){
                for ($x = 0; $x <= $days; $x++) {
                    $userExpense = UserExpense::where('expense_id',$expense['id'])->wherein('user_id', [9,149])->whereDate('date', $start_date)->get();
                    foreach ($userExpense as $userExpens) {
                        $total_expense +=  $userExpens['amount'];
                    }
                    $start_date = $start_date->modify('+1 day');
                }
                $sale_officers_data[$key]['user_expenses'] = $total_expense;
                $sale_officers_data[$key]['expense_name'] = $expense['name'];
                $sale_officers_data[$key]['id'] = $expense['id'];
            }else{
               for ($x = 0; $x <= $days; $x++) {
                $userExpense = UserExpense::where('expense_id',$expense['id'])->where('user_id', $so_Id)->whereDate('date', $start_date)->get();
                foreach ($userExpense as $userExpens) {
                    $total_expense +=  $userExpens['amount'];
                }
                $start_date = $start_date->modify('+1 day');
            }
            $sale_officers_data[$key]['user_expenses'] = $total_expense;
            $sale_officers_data[$key]['expense_name'] = $expense['name'];
            $sale_officers_data[$key]['id'] = $expense['id'];

        }
    }

}
catch(Exception $e)
{
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
return API::response()->array(['success' => true, 'message' => 'Expenses found',
    'data' => $sale_officers_data], 200);
}
    /***
     * Get SO Tenure Sale Recovery
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureSaleRecovery(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x=0;$x<=$days;$x++){
                $sale = 0;
                $recovery = 0;

                $orders = User::where('id',$so_Id)->select(['id','firstname','lastname'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->select(['id','sale_officer_id'])
                        ->with(['orders'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('date_to_deliver','=',$start_date)->where('booked_by',$so_Id)
                        ->where('status','=','Delivered')->where('type','!=','Sample')->get();}]);},
                    ])->get();

                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('promise_cheque_date','=',$start_date)->where('user_id',$so_Id)
                        ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->get();}]);},
                    ])->get();

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');

                foreach ($orders as $order){
                    foreach ($order->so_customers as $customer){
                    foreach ($customer->orders as $customer_order){
                        $sale +=  $customer_order['payment'];
                    }
                    }
                }
                foreach ($payments as $payment){
                    foreach ($payment->so_customers as $customer){
                    foreach ($customer->payments as $customer_payment){
                        $recovery +=  $customer_payment['amount'];
                    }
                    }
                }

                $sale_officers_data[$x]['sale'] = $sale;
                $sale_officers_data[$x]['recovery'] = $recovery;


                $start_date = $start_date->modify('+1 day');
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Orders found',
            'data' => $sale_officers_data], 200);
    }  /***
     * Get SO Tenure Sale Recovery
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureSaleRecoverypk(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x=0;$x<=$days;$x++){
                $sale = 0;
                $recovery = 0;
                $orders = Order::where('booked_by',$so_Id)
                    ->whereDate('date_to_deliver','=',$start_date)
                    ->where('status','=','Delivered')->where('type','!=','Sample')
                    ->get();
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$so_Id)->get();
                $user_ids=[];
                $user_ids[]=$so_Id;
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }
                $payments =PaymentReceived:: wherein('user_id', $user_ids)
                    ->whereDate('promise_cheque_date','=',$start_date)
                    ->where('payment_type','=','Cash')
                    ->where('shop_id','!=',0)
                    ->get();
                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                if(count($orders)>0){
                    foreach ($orders as $order){
                        $sale +=  $order['payment'];
                    }
                }
                if(count($payments)>0){
                    foreach ($payments as $payment){
                        $recovery +=  $payment['amount'];
                    }
                }

                $sale_officers_data[$x]['sale'] = $sale;
                $sale_officers_data[$x]['recovery'] = $recovery;
                $start_date = $start_date->modify('+1 day');
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Orders found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get SO Tenure Sale Recovery Expenses Checks
     *
     * @param Request $request
     * @return mixed
     */
    public function soTenureSaleRecoveryExpensesChecks(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
            $start_date = $request->get('date_start');
            $end_date = $request->get('date_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            $expense_today = 0;
            for ($x=0;$x<=$days;$x++){
                $sale = 0;
                $recovery = 0;
                $pending_checks = 0;
                $expense = 0;
                $outstanding_balance = 0;
                $today_sale = 0;
                $today_recovery = 0;
                $transfer = 0;

                $orders = User::where('id',$so_Id)->select(['id','firstname','lastname'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->select(['id','sale_officer_id'])
                        ->with(['orders'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('date_to_deliver','=',$start_date)->where('booked_by',$so_Id)
                        ->where('status','=','Delivered')->where('type','!=','Sample')->get();}]);},
                    ])->get();

                $payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                    ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                    {$query->with(['images','payments'=>function($query)use($start_date,$so_Id)
                    {$query->whereDate('promise_cheque_date','=',$start_date)->where('user_id',$so_Id)
                        ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->get();}]);},
                    ])->get();

                $userExpenseDetail = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->where('type','Expense')->get();
                $userTransferDetail = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->where('type','Transfer')->get();

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');

                foreach ($orders as $order){
                    foreach ($order->so_customers as $customer){
                    foreach ($customer->orders as $customer_order){
                        $sale +=  $customer_order['payment'];
                    }
                    }
                }
                foreach ($payments as $payment){
                    foreach ($payment->so_customers as $customer){
                    foreach ($customer->payments as $customer_payment){
                        $recovery +=  $customer_payment['amount'];
                    }
                    }
                }
                foreach ($userExpenseDetail as $userExpense){
                    $expense +=  $userExpense['amount'];
                }
                foreach ($userTransferDetail as $userTransfer){
                    $transfer +=  $userTransfer['amount'];
                }
                $sale_officers_data[$x]['sale'] = $sale;
                $sale_officers_data[$x]['recovery'] = $recovery;
                $sale_officers_data[$x]['pending_checks'] = $pending_checks;
                $sale_officers_data[$x]['expense'] = $expense;
                $sale_officers_data[$x]['transfer'] = $transfer;

                $start_date = $start_date->modify('+1 day');
            }
            $so_customers = User::where('id',$so_Id)->select(['id','firstname','lastname','image','balance'])
                ->with(['so_customers'=>function($query)use($so_Id)
                {$query->select('id','balance','sale_officer_id','name');},
                ])->get();

            foreach ($so_customers as $so_customer) {
                $cash_in_hand =  $so_customer->balance;

                foreach ($so_customer->so_customers as $customer) {
                    $customer->balance =  $customer->balance*(-1);
                    $outstanding_balance += $customer->balance;
                }
            }
            $today_date = date("Y-m-d");
            $today_orders = User::where('id',$so_Id)->select(['id','firstname','lastname'])
                ->with(['so_customers'=>function($query)use($today_date,$so_Id)
                {$query->select(['id','sale_officer_id'])
                    ->with(['orders'=>function($query)use($today_date,$so_Id)
                    {$query->whereDate('date_to_deliver','=',$today_date)->where('booked_by',$so_Id)
                        ->where('status','=','Delivered')->where('type','!=','Sample')->get();}]);},
                ])->get();
            $today_payments = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                ->with(['so_customers'=>function($query)use($today_date,$so_Id)
                {$query->with(['images','payments'=>function($query)use($today_date,$so_Id)
                {$query->whereDate('promise_cheque_date','=',$today_date)->where('user_id',$so_Id)
                    ->where('payment_type','!=','Promise')->where('payment_type','!=','Cheque')->get();}]);},
                ])->get();
            $userExpenseDetailToday = UserExpenseDetail::where('user_id',$so_Id)
                ->whereDate('date','=',$today_date)->where('type','Expense')->get();
            $checks = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                ->with(['so_customers'=>function($query)use($start_date,$so_Id)
                {$query->with(['images','payments'=>function($query)use($start_date,$so_Id)
                {$query->where('user_id',$so_Id)
                    ->where('payment_type','Cheque')->get();}]);},
                ])->get();
            foreach ($today_orders as $order){
                foreach ($order->so_customers as $customer){
                    foreach ($customer->orders as $customer_order){
                        $today_sale +=  $customer_order['payment'];
                    }
                }
            }
            foreach ($today_payments as $payment){
                foreach ($payment->so_customers as $customer){
                    foreach ($customer->payments as $customer_payment){
                        $today_recovery +=  $customer_payment['amount'];
                    }
                }
            }
            foreach ($userExpenseDetailToday as $userExpense){
                $expense_today +=  $userExpense['amount'];
            }
            foreach ($checks as $check){
                foreach ($check->so_customers as $customer){
                    foreach ($customer->payments as $customer_payment){
                        $pending_checks +=  $customer_payment['amount'];
                    }
                }
            }
            $total_sale = 0;
            $total_recovery = 0;
            $total_pending_checks = 0;
            $total_expense = 0;
            $total_transfer = 0;
            foreach ($sale_officers_data as $data){
                $total_sale += $data['sale'];
                $total_recovery += $data['recovery'];
                $total_expense += $data['expense'];
                $total_transfer += $data['transfer'];
            }
            $total_amount = [];
            $total_amount['total_sale'] = $total_sale;
            $total_amount['total_recovery'] = $total_recovery;
            $total_amount['total_pending_checks'] = $pending_checks;
            $total_amount['total_expense'] = $total_expense;
            $total_amount['expense_today'] = $expense_today;
            $total_amount['total_transfer'] = $total_transfer;
            $total_amount['outstanding_balances'] = $outstanding_balance;
            $total_amount['cash_in_hand'] = $cash_in_hand;
            $total_amount['today_sale'] = $today_sale;
            $total_amount['today_recovery'] = $today_recovery;
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Sale/Recovery/Checks Found',
            'data' => $total_amount], 200);
    }
    /***
     * Get SO Tenure Expense Recovery
     *
     * @param Request $request
     * @return mixed
     */
   
   public function getExpensePending(Request $request)
    {
            $start_date = $request->start_date;
            $end_date   = $request->end_date;
           
        $obj="";
        try {
            $obj = UserExpenseDetail::where('user_id',91)->where('type','Expense')->where('status_check',0)->wherebetween('date',[$start_date,$end_date])->
            whereHas(
                'user_expense', function ($q)use($start_date,$end_date) {

                $q->wherebetween('date',[$start_date,$end_date]);
            }
            )->with('user_expense.expense')->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    
     public function getExpenseIssues(Request $request)
    {
        $obj="";
        try {


            $obj = UserExpenseDetail::where('user_id',91)->where('type','Expense')->where('status_check',$request->get('status'))->whereDate('date','>','2019-05-01')->
            with('user_expense.expense')->get();


        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Deatils','data'=>$obj,
        ], 200);
    }
    public function checkexpense(Request $request, $userexpenseID = 0){
        $expenses="";
        try {
            $expenses = $request->all();
            $user = $this->getUserIdFromToken($request, true);
            
            $status=$request->get('status_check');
             if($status==1)
            {
                UserExpenseDetail::where('id',$userexpenseID)->update(['ceo_check'=>1]);
            }
           
            $update_userexpense = UserExpenseDetail::where('id', $userexpenseID)
                ->update(array('status_check'=>$status));

            if ( is_null($expenses)) {
                return API::response()->array(['success' => false,
                    'error' => 'Expense Not Found'], 400);
            }

            return API::response()->array(['success' => true,
                'message' => 'Expense ' . (($userexpenseID > 0) ? 'Updated' : 'Created'),
                'data'    => $expenses], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
   public function getLedger(Request $request){
        try {
            $start=$request->date_start;
            $end=$request->date_end;
            $user_id=$request->so_id;


                $obj2 = User::where('id', $user_id)->with(['ledger' => function ($query) use($user,$start,$end) {
        $query->where('party_id','=',null)->whereDate('date','>=',$start)->orderBy('id', 'ASC');
    }])->first();

     if (!empty($obj2) && !empty($obj2->ledger)) {
        $opening = $balance_now;
        $flag = 0;
        foreach ($obj2->ledger as $key => $item) {
            $update = UserExpenseDetail::where('id', $item['id'])->first();
    
            if (!empty($update)) {

                switch ($update['type']) {
                    case 'Expense':
                    if($flag == 0){
                          $opening = $update->balance;
                        $update->balance = $opening;
                        $update->save();
                        $flag = 1;
                        break;
                    }else{
                     $opening = $opening - $update['amount'];
                     $update->balance = $opening;
                     $update->save();
                     break;

                 }
                 case 'Recovery':
                  if($flag == 0){
                       $opening = $update->balance;
                        $update->balance = $opening;
                        $update->save();
                        $flag = 1;
                        break;
                    }else{
                 $opening = $opening + $update['amount'];
                 $update->balance = $opening;
                 $update->save();
                 break;
             }
                 case 'Cash_Received':
                  if($flag == 0){
                      $opening = $update->balance;
                        $update->balance = $opening;
                        $update->save();
                        $flag = 1;
                        break;
                    }else{
                 $opening = $opening + $update['amount'];
                 $update->balance = $opening;
                 $update->save();
                 break;
             }
              

                 case 'Cash_Transfer':
                 if($flag == 0){
                      $opening = $update->balance;
                        $update->balance = $opening;
                        $update->save();
                        $flag = 1;
                        break;
                    }else{
                 $opening = $opening - $update['amount'];
                 $update->balance = $opening;
                 $update->save();
                 break;
             }

          case 'co_cash_transfer':
                 if($flag == 0){
                      $opening = $update->balance;
                        $update->balance = $opening;
                        $update->save();
                        $flag = 1;
                        break;
                    }else{
                 $opening = $opening + $update['amount'];
                 $update->balance = $opening;
                 $update->save();
                 break;
             }


             }
         }
         $update->save();
     }
     $obj2->balance = $opening;
     $obj2->save();
 }


            $obj=User::select(['id','firstname','lastname','balance'])->where('id',$user_id)
            ->with(['ledger'=>function($query) use($start,$end,$user_id){ $query ->where('user_id',$user_id)->wherein('type',['Expense','Recovery','Transfer','Cash_Received','Cash_Transfer','co_cash_transfer'])->where('party_id',null)->wherebetween('date',[$start,$end])->get();}])->first();
            return API::response()->array(['success' => true,
                'message' => 'Ledger',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
   
   public function   getLedgeradv(Request $request){


    try {$xx="";
    $obj='';

    if($request->id==45)



    {


        $obj = User::where('id', $request->id)->with(['vendor_ledger' => function ($query) {
            $query->whereDate('date','>=','2019-06-30')->orderBy('id', 'asc');
        }])->first();
        if (!empty($obj) && !empty($obj->ledger_vendor)) {
         $xx=   $opening = $obj->opening_balance;
         foreach ($obj->ledger_vendor as $key => $item) {
            $update = UserExpenseDetail::where('id', $item['id'])->first();
            if (!empty($update)) {
                switch ($update['type']) {
                    case 'Sale':
                    $opening = $opening + $update['vendor_price'];
                    $update->balance = $opening;
                    $update->save();
                    break;
                    case 'Recovery':
                    $opening = $opening - $update['amount'];
                    $update->balance = $opening;
                    $update->save();
                    break;
                    case 'cash_adjustment_add':
                    $opening = $opening + $update['amount'];
                    $update->balance = $opening;
                    $update->save();
                    break;
                    case 'cash_adjustment_minus':
                    $opening = $opening - $update['amount'];
                    $update->balance = $opening;
                    $update->save();
                    break;

                }
            }
            $update->save();
        }
        $obj->balance = $opening;
        $obj->save();
    }
}

else  if($request->vendor_id==43 || $request->vendor_id==42 || $request->vendor_id==106 || $request->vendor_id == 108 || $request->vendor_id == 126 || $request->vendor_id == 167){$opening=0;



    $obj = User::where('id', $request->vendor_id)->with(['vendor_ledger' => function ($query) {
     $query->whereDate('date','>=','2019-07-5')->orderBy('id', 'ASC');
 }])->first();

    if (!empty($obj) && !empty($obj->ledger_vendor)) {
     $xx=   $opening = $obj->opening_balance;
     foreach ($obj->ledger_vendor as  $item) {
        $update = UserExpenseDetail::where('id', $item->id)->first();
        if (!empty($update)) {
            switch ($update['type']) {
                case 'Sale':
                if($item->is_open==1)
                {
                    $opening = $opening + $update['amount'];
                }
                else
                {
                    $opening = $opening + $update['vendor_price'];
                }


                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);

                break;
                case 'Recovery':


                $opening = $opening - $update['amount'];


                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;
                case 'cash_adjustment_add':

                $opening = $opening + $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_minus':
                $opening = $opening - $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;



            }
        }
                       // $update->save();
    }
    $obj->balance = $opening;
    $obj->save();
}

}
else  if($request->vendor_id==100|| $request->vendor_id==105){$opening=0;

    $obj = User::where('id', $request->vendor_id)->with(['vendor_ledger' => function ($query) {
     $query->whereDate('date','>=','2019-06-16')->orderBy('id', 'ASC');
 }])->first();
    
    if (!empty($obj) && !empty($obj->ledger_vendor)) {
     $xx=   $opening = $obj->opening_balance;
     foreach ($obj->ledger_vendor as  $item) {
        $update = UserExpenseDetail::where('id', $item->id)->first();
        if (!empty($update)) {
            switch ($update['type']) {
                case 'Sale':
                if($item->is_open==1)
                {
                    $opening = $opening + $update['amount'];
                }
                else
                {
                    $opening = $opening + $update['vendor_price'];
                }


                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);

                break;
                case 'Recovery':

                $opening = $opening - $update['amount'];

                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_add':
                $opening = $opening + $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_minus':
                $opening = $opening - $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

            }
        }
                       // $update->save();
    }
    $obj->balance = $opening;

    $obj->save();
}
}


else if($request->user_id==99)
{

 $obj = User::where('id', $request->user_id)->with(['vendor_ledger' => function ($query) {
     $query->orderBy('id', 'ASC');
 }])->first();

 if (!empty($obj) && !empty($obj->ledger)) {
     $xx=   $opening = $obj->opening_balance;
     foreach ($obj->ledger as  $item) {
        $update = UserExpenseDetail::where('id', $item->id)->first();
        if (!empty($update)) {
            switch ($update['type']) {
                case 'Sale':

                $opening = $opening - $update['amount'];

                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);

                break;
                case 'Recovery':

                $opening = $opening + $update['amount'];


                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_add':
                $opening = $opening + $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_minus':
                $opening = $opening - $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

            }
        }
                       // $update->save();
    }
    $obj->balance = $opening;

    $obj->save();
}
}


else
{
 $obj = User::where('id', $request->user_id)->with(['vendor_ledger' => function ($query) {
       $query->orderBy('id', 'ASC');
   }])->first();

   if (!empty($obj) && !empty($obj->ledger)) {
       $xx=   $opening = $obj->opening_balance;
       foreach ($obj->ledger as  $item) {
        $update = UserExpenseDetail::where('id', $item->id)->first();
        if (!empty($update)) {
            switch ($update['type']) {
                case 'Sale':

                $opening = $opening - $update['amount'];

                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);

                break;
                case 'Recovery':

                $opening = $opening + $update['amount'];


                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_add':
                $opening = $opening + $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

                case 'cash_adjustment_minus':
                $opening = $opening - $update['amount'];
                UserExpenseDetail::where('id',$update->id)->update(['balance'=>$opening]);
                break;

            }
        }
                       // $update->save();
    }
    $obj->balance = $opening;

    $obj->save();
}
}


$start=$request->date_start;
$end=$request->date_end;
if($request->vendor_id==45 )
{


 $user_id=$request->vendor_id;
 $obj=User::select(['id','firstname','lastname','balance','opening_balance'])->where('id',$user_id)
 ->with(['vendor_ledger'=>function($query) use($start,$end,$user_id)
    {  $query->whereDate('date','>=','2019-06-30')->where('vendor_id',$user_id)->wherein('type',['Sale','Recovery','cash_adjustment_add','cash_adjustment_minus'])->whereDate('date','<=',$end)->orderBy('id', 'asc')->get();}]
)->first();

}

else if($request->vendor_id==43  || $request->vendor_id==42 )
{

 $user_id=$request->vendor_id;
 $obj=User::select(['id','firstname','lastname','balance','opening_balance'])->where('id',$user_id)
 ->with(['vendor_ledger'=>function($query) use($start,$end,$user_id)
        {  $query->wherein('type',['Sale','Recovery','cash_adjustment_add','cash_adjustment_minus'])->where('vendor_id',$user_id)->whereBetween('date', [$start,$end])->orderBy('id', 'asc');}]
    )->first();

}

else if($request->vendor_id==100 || $request->vendor_id==105 )
{
 $user_id=$request->get('vendor_id');
 $obj=User::select(['id','firstname','lastname','balance','opening_balance'])->where('id',$user_id)
 ->with(['vendor_ledger'=>function($query) use($start,$end,$user_id)
        {  $query->wherein('type',['Sale','Recovery','cash_adjustment_add','cash_adjustment_minus'])->where('vendor_id',$user_id)->whereBetween('date', [$start,$end])->orderBy('id', 'asc');}]
    )->first();


}



else
{

    $user_id=$request->vendor_id;
    $obj=User::select(['id','firstname','lastname','balance','opening_balance'])->where('id',$user_id)
    ->with(['vendor_ledger'=>function($query) use($start,$end,$user_id)
        {  $query->wherein('type',['Sale','Recovery','cash_adjustment_add','cash_adjustment_minus'])->where('vendor_id',$user_id)->whereBetween('date', [$start,$end])->orderBy('id', 'asc');}]
    )->first();


}


return API::response()->array(['success' => true,
    'message' => 'Ledger',
    'data'    => $obj], 200);
} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}
    public function getPettyCash(Request $request){
        try {
            $start=$request->get('date_start');
            $end=$request->get('date_end');
            $user_id=$request->get('so_id');
            $obj=User::select(['id','firstname','lastname','balance'])->where('id',$user_id)
                ->with(['ledger'=>function($query) use($start,$end,$user_id){ $query ->where('user_id',$user_id)->where('type','Recovery')->where('party_id',null)->wherebetween('date',[$start,$end])->get();}])->first();
            return API::response()->array(['success' => true,
                'message' => 'Ledger',
                'data'    => $obj], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    public function soTenureExpenseRecovery(Request $request)
    {
        try {
            $so_Id = $request->get('so_id');
           $c_balance= User::where('id',$so_Id)->first();
            $start_date = $request->get('date_start');
            $end_date = $request->get('date_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date,$end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            $op_balance  =0;
            if(!empty($c_balance) && $c_balance['balance']){
                $op_balance = $c_balance['balance'];
            }else{
                $op_balance = 0;
            }
            $y = 0;
            for ($x=0;$x<=$days;$x++){
                $expense = 0;
                $recovery = 0;

                $balance = 0;

                $userExpenseDetail = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->where('type','!=','Recovery')->get();
                $userRecoveryDetail = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->where('type','Recovery')->get();
                $userBalance = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->orderBy('id','desc')->first();
                $userOP = UserExpenseDetail::where('user_id',$so_Id)
                    ->whereDate('date','=',$start_date)->orderBy('id','asc')->first();

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');

                foreach ($userExpenseDetail as $userExpense){
                        $expense +=  $userExpense['amount'];
                }
                foreach ($userRecoveryDetail as $userRecovery){
                        $recovery += $userRecovery['amount'];
                }

                $sale_officers_data[$x]['expense'] = $expense;
                $sale_officers_data[$x]['recovery'] = $recovery;
                if($userBalance['balance'] != null){
                    $sale_officers_data[$x]['balance'] = $userBalance['balance'];
                    $op_balance = $userBalance['balance'];
                }else{
                    $sale_officers_data[$x]['balance'] = $op_balance;
                }
                    if ($userOP['type'] == 'Expense' || $userOP['type'] == 'Transfer') {
                        $op = $userOP['amount'] + $userOP['balance'];
                        $sale_officers_data[$x]['op'] = $op;
                    }
                    if ($userOP['type'] == 'Recovery') {
                        $op =  $userOP['balance']- $userOP['amount'];
                        $sale_officers_data[$x]['op'] = $op;
                    }
                    if ($expense == 0 && $recovery == 0) {
                        $sale_officers_data[$x]['op'] = $op_balance;
                }
                $start_date = $start_date->modify('+1 day');
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Expenses/Recovery Found',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get Customer Tenure Ledger
     *
     * @param Request $request
     * @return mixed
     */
    public function customerTenureLedger(Request $request)
    {
//        try {
//            $shop_id=$request->get('shop_id');
//            $customer=Customer::where('id',$shop_id)->first();
//            $start_date = $request->get('date_to_deliver_start');
//            $end_date = $request->get('date_to_deliver_end');
//            $orders=null;
//            $payments=null;
//            if(!empty($customer)){
//                $orders = Order::where('shop_id',$shop_id)->where('status','Delivered')
//                    ->whereBetween('date_to_deliver',[$start_date,$end_date])
//                    ->whereNotIn('type', ['Sample'])->orderBy('date_to_deliver', 'Desc')->get()->toarray();
//                $payments = PaymentReceived::where('shop_id',$shop_id)->where('payment_type','Cash')
//                    ->whereBetween('promise_cheque_date',[$start_date,$end_date])
//                    ->orderBy('promise_cheque_date', 'Desc')->get()->toarray();
//
//
//
//
//
//            }
//            $ledger=[];
//            $size=0;
//
//            if(count($orders)>0){
//                foreach ($orders as $key=>$order){
//                    $ledger[$key]['payment']=$order['payment'];
//                    $ledger[$key]['balance']=(-1) * $order['balance'];
//                    $ledger[$key]['date']=$order['date_to_deliver'];
//                    $ledger[$key]['ledger_type']='order';
//
//                }
//                $size=count($orders);
//            }
//
//            if(count($payments)>0){
//                foreach ($payments as $index=>$payment){
//                    $ledger[$size]['amount']=$payment['amount'];
//                    $ledger[$size]['balance']=(-1)* $payment['balance'];
//                    $ledger[$size]['date']=$payment['promise_cheque_date'];
//                    $ledger[$size]['ledger_type']='payment';
//                    $size++;
//                }
//            }
//
//            usort($ledger, function($a, $b) {
//                return strtotime($a['date']) - strtotime($b['date']);
//            });
//
////        $ledger=array_reverse($ledger);
//            $data['ledgers'] = $ledger;
//            $obj=[];
//            $size=-1;
//            $date=null;
//            $sal=0;
//            $rec=0;
//            $pre=0;
//            foreach ($ledger as $led){
//                if($date==$led['date']){
//                    $pre=1;
//                    switch($led['ledger_type']){
//                        case 'order':
//                            $sal=$sal+$led['payment'];
//                            break;
//                        case 'payment':
//                            $rec=$rec+$led['amount'];
//                            break;
//                    }
//                }else{
//                    $sal=0;
//                    $rec=0;
//                    $pre=0;
//                    switch($led['ledger_type']){
//                        case 'order':
//                            $sal=$sal+$led['payment'];
//                            break;
//                        case 'payment':
//                            $rec=$rec+$led['amount'];
//                            break;
//                    }
//                    $size=$size+1;
//                    $obj[$size]['balance']=$led['balance'];
//                }
//                if($pre==1){
//                    if(isset($obj[$size-1]['balance'])){
//                        $pre_bal=$obj[$size-1]['balance'];
//                    }else{
//                        $pre_bal=0;
//                    }
//
//                    $obj[$size]['balance']=$pre_bal+$sal;
//                    $obj[$size]['balance']=$obj[$size]['balance']-$rec;
//                }
//                $obj[$size]['date']=$led['date'];
//                $obj[$size]['sale']=$sal;
//                $obj[$size]['recovery']=$rec;
//                $obj[$size]['customer_balance']=(-1)* $customer['balance'];
//                $obj[$size]['customer_opening_balance']=(-1)* $customer['opening_balance'];
//                $obj[$size]['customer_opening_balance_created_at']= $customer['created_at'];
//                $date=$led['date'];
//            }
//
//        }
        try {
            $shop_id=$request->get('shop_id');
            $customer=Customer::where('id',$shop_id)->first();
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $orders=null;
            $payments=null;
            $balance=0;

            if(!empty($customer)){
                $orders = Order::where('shop_id',$shop_id)
                    ->whereBetween('date_to_deliver',[$start_date,$end_date])
                    ->whereNotIn('type', ['Sample'])->orderBy('date_to_deliver', 'Desc')->get()->toarray();

                $payments = PaymentReceived::where('shop_id',$shop_id)->where('payment_type','Cash')
                    ->whereBetween('promise_cheque_date',[$start_date,$end_date])
                    ->orderBy('promise_cheque_date', 'Desc')->get()->toarray();


                $sales=Order::where('shop_id',$shop_id)
                    ->whereBetween('date_to_deliver', ['2018-01-01',date('Y-m-d', strtotime('-1 day', strtotime($start_date)))])
                    ->where('type', '!=', 'Sample')
                    ->where(function ($query) {
                        $query->where('status', 'Delivered');

                    })
                    ->sum('payment');

                $return=Order::where('shop_id',$shop_id)
                    ->whereBetween('date_to_deliver', ['2018-01-01',date('Y-m-d', strtotime('-1 day', strtotime($start_date)))])
                    ->where('type', '!=', 'Sample')
                    ->where(function ($query) {
                        $query->where('status', 'Returned');

                    })
                    ->sum('payment');

                $recovery=PaymentReceived::where('shop_id',$shop_id)
                    ->whereBetween('promise_cheque_date', ['2018-01-01',date('Y-m-d', strtotime('-1 day', strtotime($start_date)))])
                    ->where('payment_type', '!=', 'Promise')->where('payment_type', '!=', 'Cheque')
                    ->sum('amount');

                $balance=(($sales)*(-1));

                $balance=((-1)* $customer['opening_balance'])-($balance-(($recovery)*(-1)));
                $balance=$balance+$return;

            }
            $ledger=[];
            $size=0;
 
            if(count($orders)>0){
                foreach ($orders as $key=>$order){
                 
                    if($order['status']=="Returned")

                    {
                        $ledger[$key]['return']=$order['payment'];
                        
                        $ledger[$key]['ledger_type']='return';
                        
                    }
                    else{
                        $ledger[$key]['payment']=$order['payment'];
                        $ledger[$key]['ledger_type']='order';
                       
                    }

//                    $ledger[$key]['balance']=(-1) * $order['balance'];
                    $ledger[$key]['date']=$order['date_to_deliver'];


                }
                $size=count($orders);
            }




            if(count($payments)>0){
                foreach ($payments as $index=>$payment){
                    $ledger[$size]['amount']=$payment['amount'];
//                    $ledger[$size]['balance']=(-1)* $payment['balance'];
                    $ledger[$size]['date']=$payment['promise_cheque_date'];
                    $ledger[$size]['ledger_type']='payment';
                    $size++;
                }
            }

            usort($ledger, function($a, $b) {
                return strtotime($a['date']) - strtotime($b['date']);
            });

 $data['ledgers'] = $ledger;
            $obj=[];
            $size=-1;
            $date=null;
            $sal=0;
            $rec=0;
            $pre=0;
            $return3=0;
            foreach ($ledger as $led){
                $return3=0;
                if($date==$led['date']){
                    $pre=1;
                    switch($led['ledger_type']){
                        case 'order':
                            $sal=$sal+$led['payment'];
                            $balance= $balance+$led['payment'];
                            break;
                        case 'payment':
                            $rec=$rec+$led['amount'];
                            $balance= $balance-$led['amount'];
                            break;
                        case 'return':
                            $return3=$return3+$led['return'];
                            $balance= $balance+$led['return'];
                            break;
                    }
                }else{
                    $sal=0;
                    $rec=0;
                    $pre=0;
                    switch($led['ledger_type']){
                        case 'order':
                            $sal=$sal+$led['payment'];
                            $balance= $balance+$led['payment'];
                            break;
                        case 'payment':
                            $rec=$rec+$led['amount'];
                            $balance= $balance-$led['amount'];
                            break;
                        case 'return':
                            $return3=$return3+$led['return'];
                            $balance= $balance+$led['return'];
                            break;
                    }
                    $size=$size+1;
                    $obj[$size]['balance']=($balance+($sal))-$rec+$return3;
                }
//                if($pre==1){
//                    if(isset($obj[$size-1]['balance'])){
//                        $obj[$size]['balance']=$balance;
//                    }else{
//                        $obj[$size]['balance']=$balance;
//                    }
//
//
////                    $obj[$size]['balance']=$obj[$size]['balance']-$rec;
//                }
                $obj[$size]['balance']=$balance;
                $obj[$size]['date']=$led['date'];
                $obj[$size]['sale']=$sal;
                $obj[$size]['recovery']=$rec;
                $obj[$size]['return']=$return3;
                $obj[$size]['customer_balance']=(-1)* $customer['balance'];
                $obj[$size]['customer_opening_balance']=(-1)* $customer['opening_balance'];
                $obj[$size]['customer_opening_balance_created_at']= $customer['created_at'];
                $date=$led['date'];
            }

        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Ledger',
            'data' => $obj], 200);
    }
    /***
     * Get Customer Tenure Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function customerTenureOrders(Request $request)
    {
        try {

            $shop_Id = $request->get('shop_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            $customer_balance = 0;
            for ($x = 0; $x <= $days; $x++) {
                $sale = 0;
                $recovery = 0;
                $balance = 0;

                $orders = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['images','orders' => function ($query) use ($start_date) {
                    $query->whereDate('date_to_deliver', '=', $start_date)
                        ->where('status', 'Delivered')->where('type', '!=', 'Sample')->get();
                }])->get();
//                $payments = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['payments' => function ($query) use ($start_date) {
//                    $query->whereDate('promise_cheque_date', '=', $start_date)
//                        ->where('payment_type', '!=', 'Promise')->where('payment_type', '!=', 'Cheque')->get();
//                },
//                ])->get();

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');

//                foreach ($payments as $payment) {
//                    foreach ($payment->payments as $customer_payment) {
//                        $recovery += $customer_payment['amount'];
//                        $balance = $customer_payment['balance']*(-1);
//                    }
//                }
                foreach ($orders as $order) {
                    $orderr =  $order;
                }
                $sale_officers_data[$x]['customer'] = $orderr;
//                $sale_officers_data[$x]['recovery'] = $recovery;
//                $sale_officers_data[$x]['balance'] = $balance;
//                $sale_officers_data[$x]['customer_balance'] = $customer_balance*(-1);


                $start_date = $start_date->modify('+1 day');

            }

//            return $sale_officers_data;
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Tenure Sale',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get Customer Tenure Return Orders
     *
     * @param Request $request
     * @return mixed
     */
    public function customerTenureReturnOrders(Request $request)
    {
        try {

            $shop_Id = $request->get('shop_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            $customer_balance = 0;
            for ($x = 0; $x <= $days; $x++) {
                $sale = 0;
                $recovery = 0;
                $balance = 0;

                $orders = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['images','orders' => function ($query) use ($start_date) {
                    $query->whereDate('date_to_deliver', '=', $start_date)
                        ->where('status', 'Returned')->where('type', '!=', 'Sample')->get();
                }])->get();
//                $payments = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['payments' => function ($query) use ($start_date) {
//                    $query->whereDate('promise_cheque_date', '=', $start_date)
//                        ->where('payment_type', '!=', 'Promise')->where('payment_type', '!=', 'Cheque')->get();
//                },
//                ])->get();

                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');

//                foreach ($payments as $payment) {
//                    foreach ($payment->payments as $customer_payment) {
//                        $recovery += $customer_payment['amount'];
//                        $balance = $customer_payment['balance']*(-1);
//                    }
//                }
                foreach ($orders as $order) {
                    $orderr =  $order;
                }
                $sale_officers_data[$x]['customer'] = $orderr;
//                $sale_officers_data[$x]['recovery'] = $recovery;
//                $sale_officers_data[$x]['balance'] = $balance;
//                $sale_officers_data[$x]['customer_balance'] = $customer_balance*(-1);


                $start_date = $start_date->modify('+1 day');

            }

//            return $sale_officers_data;
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Tenure Return Sale',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Get Customer Orders Id
     *
     * @param Request $request
     * @return mixed
     */
    public function customerOrdersId(Request $request)
    {
        try {

            $shop_Id = $request->get('shop_id');
            $start_date = $request->get('date_to_deliver');
            $sale_officers_data = array();
            $orderr = '';
                $order = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['orders' => function ($query) use ($start_date) {
                    $query->select('id','shop_id')
                        ->whereDate('created_at', $start_date)->where('type', '!=', 'Sample')->first();
                }])->first();
            foreach ($order->orders as $order){
                $orderr = $order;

            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Orders',
            'data' => $orderr], 200);
    }
    /***
     * Get Customer Outstanding Balance
     *
     * @param Request $request
     * @return mixed
     */
    public function customerOutstandingBalance(Request $request)
    {
        try {

            $so_Id = $request->get('so_id');
            $so_customers = User::where('id',$so_Id)->select(['id','firstname','lastname','image'])
                ->with(['so_customers'=>function($query)use($so_Id)
                {$query->select('id','balance','sale_officer_id','name')->with(['images']);},
                ])->get();

            $start_date=date("Y-m-d");
            $pre_date=date("Y-m-d",strtotime("-1 month",strtotime($start_date )));
            foreach ($so_customers as $so_customer) {
                foreach ($so_customer->so_customers as $customer) {
                    $payments = PaymentReceived::where('shop_id',$customer->id)
                        ->whereBetween('promise_cheque_date', [$pre_date,$start_date])
                        ->get();
                    $count =count($payments);
                    if($count == 0){
                        $customer->is_recover =  0;
                        $one_month_sales=Order::where('shop_id',$customer->id)
                            ->whereBetween('date_to_deliver', [$pre_date,$start_date])
                            ->sum('payment');
                        if($one_month_sales>=$customer->balance*(-1)){
                            $customer->is_recover =  1;
                        }
                    }else{
                        $customer->is_recover =  1;
                    }

                    $customer->balance =  $customer->balance*(-1);
                    $customer->image =  $customer->images;
                }
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Balances',
            'data' => $so_customers], 200);
    }
    /***
     * Get Customer Pending Checks
     *
     * @param Request $request
     * @return mixed
     */
    public function customerPendingChecks(Request $request)
    {
        try {

            $shop_Id = $request->get('shop_id');
            $payments = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['payments' => function ($query) {
                $query->where('payment_type','Cheque')->get();
            },
            ])->get();
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Pending Checks',
            'data' => $payments], 200);
    }
    /***
     * Get Customer Tenure Recovery
     *
     * @param Request $request
     * @return mixed
     */
    public function customerTenureRecovery(Request $request)
    {
        try {

            $shop_Id = $request->get('shop_id');
            $start_date = $request->get('date_to_deliver_start');
            $end_date = $request->get('date_to_deliver_end');
            $start_date = date_create($start_date);
            $end_date = date_create($end_date);
            $difference = date_diff($start_date, $end_date);
            $days = $difference->format('%a');
            $sale_officers_data = array();
            for ($x = 0; $x <= $days; $x++) {
                $payments = Customer::where('id', $shop_Id)->select('id','sale_officer_id','name')->with(['images','payments' => function ($query) use ($start_date) {
                    $query->whereDate('promise_cheque_date', '=', $start_date)
                        ->where('payment_type', '!=', 'Promise')->where('payment_type', '!=', 'Cheque')->get();
                },
                ])->get();
                $sale_officers_data[$x]['date'] = $start_date->format('Y-m-d');
                foreach ($payments as $payment) {
                    $paymentt =  $payment;
                }
                $sale_officers_data[$x]['customer'] = $paymentt;
                $start_date = $start_date->modify('+1 day');
            }
        }
        catch(Exception $e)
        {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
        return API::response()->array(['success' => true, 'message' => 'Customer Tenure Recovery',
            'data' => $sale_officers_data], 200);
    }
    /***
     * Book orders invoices
     *
     * @param $request
     *
     * @return mixed
     */
    public function bookOrderInvoices(Request $request)
    {
        try {
                $order_ids = $request->all();
            $data = [];
            foreach ($order_ids as $key =>$order_id){
                $invoice_no = $this->_orderModel->addOrderInvoice($order_id);
                if($invoice_no == 'No Order'){
                }else{
                    $data[$key]['order_id'] = $order_id;
                    $data[$key]['invoice_no'] = $invoice_no;
                }

            }
                if (is_null($data)) {
                    return API::response()->array(['success' => false,
                        'error' => 'Order Not Found'], 400);
                }
            return API::response()->array(['success' => true,
                'message' => 'Order Invoice Number Added',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * AsmSaleRecoveryPk
     *
     * @param $request
     *
     * @return mixed
     */
    public function AsmSaleRecoveryPk(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->get();
            $data=[];
            foreach ($asm as $key=>$as){
                $data[$key]['id']=$as['id'];
                $data[$key]['fullname']=$as['firstname'].' '.$as['lastname'];
                $data[$key]['image']=$as['image'];
                $data[$key]['sales']=Order::where('booked_by',$as['id'])
                     ->whereBetween('date_to_deliver',[$request->get('start_date'),$request->get('end_date')])
                     ->where('status','=','Delivered')->where('type','!=','Sample')
                     ->with('customer','book_by')->sum('payment');
                $customer=Customer::select('id')->where('sale_officer_id',$as['id'])->get();
                $user_ids=[];
                $user_ids[]=$as['id'];

                foreach ($customer as $cu){
                    $user_ids[]=$cu['id'];
                }
                // So supplier addition
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$as['id'])->get();
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }

                $data[$key]['recovery']=PaymentReceived:: wherein('user_id', $user_ids)
                    ->whereBetween('promise_cheque_date',[$request->get('start_date'),$request->get('end_date')])
                    ->where('payment_type','=','Cash')
                    ->where('shop_id','!=',0)
                    ->sum('amount');
            }
            return API::response()->array(['success' => true,
                'message' => 'Asm Sale Recovery Pk',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * asmSoPendingCheque
     *
     * @param $request
     *
     * @return mixed
     */
    public function asmSoPendingCheque(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->get();
            $data=[];
            foreach ($asm as $key=>$as){
                $data[$key]['id']=$as['id'];
                $data[$key]['fullname']=$as['firstname'].' '.$as['lastname'];
                $data[$key]['image']=$as['image'];
                $customer=Customer::select('id')->where('sale_officer_id',$as['id'])->get();
                $user_ids=[];
                $cus_ids=[];
                $user_ids[]=$as['id'];

                foreach ($customer as $cu){
                    $user_ids[]=$cu['id'];
                    $cus_ids[]=$cu['id'];
                }
                // So supplier addition
                $supplier=SupplierSo::select('supplier_id')->where('so_id',$as['id'])->get();
                foreach ($supplier as $su){
                    $user_ids[]=$su['supplier_id'];
                }

                $data[$key]['recovery']=PaymentReceived:: wherein('user_id', $user_ids)
                    ->where('payment_type','=','Cheque')
                    ->where('shop_id','!=',0)
                    ->wherein('shop_id',$cus_ids)
                    ->sum('amount');
            }
            return API::response()->array(['success' => true,
                'message' => 'Asm so pending cheque',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * AsmSo_Oustanding_balance
     *
     * @param $request
     *
     * @return mixed
     */
    public function AsmSo_Oustanding_balance(Request $request)
    {
        try {
            $asm=User::select('id','firstname','lastname','image')
                ->where('parent_id',$request->get('asm_id'))
                ->orwhere('parent_id_2',$request->get('asm_id'))
                ->get();
            $data=[];
            foreach ($asm as $key=>$as){
                $data[$key]['id']=$as['id'];
                $data[$key]['fullname']=$as['firstname'].' '.$as['lastname'];
                $data[$key]['image']=$as['image'];
                $ob=Customer::select('id')->where('sale_officer_id',$as['id']) ->sum('balance');
                $data[$key]['outstanding_balance']=(-1)*$ob;
            }
            return API::response()->array(['success' => true,
                'message' => 'Asm Sale Recovery Pk',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    /***
     * Rsm_ASM_Oustanding_balance
     *
     * @param $request
     *
     * @return mixed
     */
    public function Rsm_ASM_Oustanding_balance(Request $request)
    {
        try {
            $rsm=User::select('id','firstname','lastname','image')
                ->where('rsm_id',$request->get('rsm_id'))
                ->get();
            $data=[];
            $r_asm=[];
            foreach ($rsm as $key=>$rs){
                if($rs['role_user']=="Area Sale Manager"){
                    $r_asm[]=$rs;
                }
            }
            foreach ($r_asm as $key2=>$sm){
                $asm=User::select('id','firstname','lastname','image')
                    ->where('parent_id',$sm['id'])
                    ->orwhere('parent_id_2',$sm['id'])
                    ->get();
                $data[$key2]['id']=$sm['id'];
                $data[$key2]['fullname']=$sm['firstname'].' '.$sm['lastname'];
                $data[$key2]['image']=$sm['image'];
                $data[$key2]['outstanding_balance']=0;
                foreach ($asm as $key=>$as){
                    $ob=Customer::select('id')->where('sale_officer_id',$as['id']) ->sum('balance');
                    $data[$key2]['outstanding_balance']=$data[$key2]['outstanding_balance']+((-1)*$ob);
                }
            }



            return API::response()->array(['success' => true,
                'message' => 'RSM Asm Outstanding balance',
                'data'    => $data], 200);
        } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
    
     public function Party_Rates(Request $request)
    {
//        dd($request->all());
         try {
           
        foreach ($request->get('products') as $product){

            $rate= PartyRates::where('party_id',$request->get('party_id'))
                ->where('product_id',$product['product_id'])->first();
            if(empty($rate)){
                $rate=new PartyRates();
            }

            $rate->party_id=$request->get('party_id');
            $rate->product_id=$product['product_id'];
            $rate->price=$product['price']/12;
            $rate->save();
        }
         return API::response()->array(['success' => true,
                'message' => 'data has been saved'], 200);
          } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
     public function Single_Party_Rates(Request $request)
    {
//        dd($request->all());
         try {

            $rate= PartyRates::where('party_id',$request->get('party_id'))
                ->where('product_id',$request->get('product_id'))->first();
            if(empty($rate)){
                $rate=new PartyRates();
            }

            $rate->party_id=$request->get('party_id');
            $rate->product_id=$request->get('product_id');
            $rate->price=$request->get('price')/12;
            $rate->save();
        
         return API::response()->array(['success' => true,
                'message' => 'data has been saved'], 200);
          } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
   public function accountantentryrevers(Request $request)
    {
//        dd($request->all());
         try {

            $bility= Bilti::where('id',$request->get('id'))->first();
            if(!empty($bility)){

                $paymentRemark  =   new  PaymentRemark();
                $paymentRemark->rsm_id = $bility->id;
                $paymentRemark->type =  "Accountant_revers";
                $paymentRemark->remarks = $request->get('remarks');
                $paymentRemark->save();

            $bility->invoice_no=null;
            $bility->accountant_price=0;
            $bility->save();
            return API::response()->array(['success' => true,
                'message' => 'entry has been revers'], 200);
        }else{
         return API::response()->array(['success' => true,
                'message' => 'not found'], 200);
          }
          } catch(Exception $e) {
            return API::response()->array(['success' => false,
                'message' => $e->getTraceAsString()], 400);
        }
    }
    
   public function getproductwisebilties(Request $request)
{

   try {

    $id = $request->product_id;
    $start_date = $request->start_date;
    $end_date = $request->end_date;

    $userId = $this->getUserIdFromToken($request);
    $userrole = $this->getUserRole($userId);

    $data = [];

    if($userrole == 'gm'){
        $party=PartyName::select('id')->where('show_gm','=',1)->get()->toArray();

      $obj= Bilti::where('po_no_rsm',0)->where('po_no_warehouse','=',0)->where('po_no_raw',0)->where('po_no_adv',0)->wherein('party_id',$party)->whereBetween('delivered_date', [$start_date,$end_date])->with(['bilty_detail'=>function($query) use ($id)
      {
          $query->where('product_id',$id)->where('quantity','>',0)->with('bilty_product');
      }])->with('party_info')->get();
      
  }

  elseif ($userrole == 'rsm') {
    $use=User::where('id',$userId)->first();
    $party= PartyName::select('id')->where('region_id',$use['region_id'])->get()->toArray();

    $obj= Bilti::where('po_no_rsm',0)->where('po_no_warehouse','=',0)->where('po_no_raw',0)->where('po_no_adv',0)->wherein('party_id',$party)->whereBetween('delivered_date', [$start_date,$end_date])->with(['bilty_detail'=>function($query) use ($id)
    {
      $query->where('product_id',$id)->where('quantity','>',0)->with('bilty_product');
  }])->with('party_info')->get();

}



else{

    if($request->party_id == 0){
 $obj= Bilti::where('po_no_rsm',0)->where('po_no_warehouse','=',0)->where('po_no_raw',0)->where('po_no_adv',0)->whereBetween('delivered_date', [$start_date,$end_date])->with(['bilty_detail'=>function($query) use ($id)
 {
  $query->where('product_id',$id)->where('quantity','>',0)->with('bilty_product');
}])->with('party_info')->get();
}
else {

     $obj= Bilti::where('po_no_rsm',0)->where('po_no_warehouse','=',0)->where('po_no_raw',0)->where('po_no_adv',0)->where('party_id',$request->party_id)->whereBetween('delivered_date', [$start_date,$end_date])->with(['bilty_detail'=>function($query) use ($id)
 {
  $query->where('product_id',$id)->where('quantity','>',0)->with('bilty_product');
}])->with('party_info')->get();


}
}


foreach ($obj as $key => $ob) {
 $check = $ob->bilty_detail->count();
 if ($check != 0){

    $data[] =  $ob;


}

}
if(!empty($data)){


    return API::response()->array((['success' => true, 'message' => 'All Bilty ',
       'data' => $data]), 200);
}else{
  return API::response()->array(['success' => true,
    'message' => 'not found'], 200);
}

} catch(Exception $e) {
    return API::response()->array(['success' => false,
        'message' => $e->getTraceAsString()], 400);
}
}




}